/* nibbles-game.c generated by valac 0.56.13, the Vala compiler
 * generated from nibbles-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Coding style.
 *
 * To help you comply with the coding style in this project use the
 * following greps. Any lines returned should be adjusted so they
 * don't match. The convoluted regular expressions are so they don't 
 * match them self.
 *
 * grep -ne '[^][)(_!$ "](' *.vala
 * grep -ne '[(] ' *.vala
 * grep -ne '[ ])' *.vala
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <gio/gio.h>

#define NIBBLES_GAME_MAX_WORMS 6
#define NIBBLES_GAME_MAX_SPEED 4
#define NIBBLES_GAME_EMPTYCHAR 'a'
#define NIBBLES_GAME_WORMCHAR 'w'
#define NIBBLES_GAME_WARPCHAR 'W'
#define NIBBLES_GAME_MAX_LEVEL 26
#define WORM_GROW_FACTOR 4
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef gboolean (*KeypressHandlerFunction) (guint a, guint b, gboolean* remove_handler, gpointer user_data);
typedef enum  {
	GAME_STATUS_GAMEOVER,
	GAME_STATUS_VICTORY,
	GAME_STATUS_NEWROUND
} GameStatus;

#define TYPE_GAME_STATUS (game_status_get_type ())

#define TYPE_NIBBLES_GAME (nibbles_game_get_type ())
#define NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIBBLES_GAME, NibblesGame))
#define NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIBBLES_GAME, NibblesGameClass))
#define IS_NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIBBLES_GAME))
#define IS_NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIBBLES_GAME))
#define NIBBLES_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIBBLES_GAME, NibblesGameClass))

typedef struct _NibblesGame NibblesGame;
typedef struct _NibblesGameClass NibblesGameClass;
typedef struct _NibblesGamePrivate NibblesGamePrivate;

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;

#define TYPE_WORM_PROPERTIES (worm_properties_get_type ())
#define WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_PROPERTIES, WormProperties))
#define WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_PROPERTIES, WormPropertiesClass))
#define IS_WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_PROPERTIES))
#define IS_WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_PROPERTIES))
#define WORM_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_PROPERTIES, WormPropertiesClass))

typedef struct _WormProperties WormProperties;
typedef struct _WormPropertiesClass WormPropertiesClass;

#define TYPE_BONI (boni_get_type ())
#define BONI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONI, Boni))
#define BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONI, BoniClass))
#define IS_BONI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONI))
#define IS_BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONI))
#define BONI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONI, BoniClass))

typedef struct _Boni Boni;
typedef struct _BoniClass BoniClass;

#define TYPE_WARP_MANAGER (warp_manager_get_type ())
#define WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WARP_MANAGER, WarpManager))
#define WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WARP_MANAGER, WarpManagerClass))
#define IS_WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WARP_MANAGER))
#define IS_WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WARP_MANAGER))
#define WARP_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WARP_MANAGER, WarpManagerClass))

typedef struct _WarpManager WarpManager;
typedef struct _WarpManagerClass WarpManagerClass;
enum  {
	NIBBLES_GAME_0_PROPERTY,
	NIBBLES_GAME_SKIP_SCORE_PROPERTY,
	NIBBLES_GAME_CURRENT_LEVEL_PROPERTY,
	NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY,
	NIBBLES_GAME_SPEED_PROPERTY,
	NIBBLES_GAME_GAMEDELAY_PROPERTY,
	NIBBLES_GAME_WIDTH_PROPERTY,
	NIBBLES_GAME_HEIGHT_PROPERTY,
	NIBBLES_GAME_NUMHUMANS_PROPERTY,
	NIBBLES_GAME_NUMAI_PROPERTY,
	NIBBLES_GAME_NUMWORMS_PROPERTY,
	NIBBLES_GAME_WORMS_PROPERTY,
	NIBBLES_GAME_WORM_PROPS_PROPERTY,
	NIBBLES_GAME_IS_RUNNING_PROPERTY,
	NIBBLES_GAME_PAUSED_PROPERTY,
	NIBBLES_GAME_FAKES_PROPERTY,
	NIBBLES_GAME_NUM_PROPERTIES
};
static GParamSpec* nibbles_game_properties[NIBBLES_GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef enum  {
	WORM_DIRECTION_NONE,
	WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_EAST = WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_DOWN,
	WORM_DIRECTION_SOUTH = WORM_DIRECTION_DOWN,
	WORM_DIRECTION_LEFT,
	WORM_DIRECTION_WEST = WORM_DIRECTION_LEFT,
	WORM_DIRECTION_UP,
	WORM_DIRECTION_NORTH = WORM_DIRECTION_UP
} WormDirection;

#define TYPE_WORM_DIRECTION (worm_direction_get_type ())
typedef GeeList* (*WormGetOtherWormsType) (Worm* _self_, gpointer user_data);

#define TYPE_BONUS (bonus_get_type ())
#define BONUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONUS, Bonus))
#define BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONUS, BonusClass))
#define IS_BONUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONUS))
#define IS_BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONUS))
#define BONUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONUS, BonusClass))

typedef struct _Bonus Bonus;
typedef struct _BonusClass BonusClass;
typedef GeeList* (*WormGetBonusesType) (gpointer user_data);
typedef struct _WormPrivate WormPrivate;

#define TYPE_WORM_POSITIONS (worm_positions_get_type ())
#define WORM_POSITIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_POSITIONS, WormPositions))
#define WORM_POSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_POSITIONS, WormPositionsClass))
#define IS_WORM_POSITIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_POSITIONS))
#define IS_WORM_POSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_POSITIONS))
#define WORM_POSITIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_POSITIONS, WormPositionsClass))

typedef struct _WormPositions WormPositions;
typedef struct _WormPositionsClass WormPositionsClass;

#define TYPE_POSITION (position_get_type ())
typedef struct _Position Position;
typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

#define TYPE_BONUS_TYPE (bonus_type_get_type ())
enum  {
	NIBBLES_GAME_BONUS_APPLIED_SIGNAL,
	NIBBLES_GAME_LOG_SCORE_SIGNAL,
	NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL,
	NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL,
	NIBBLES_GAME_WARP_ADDED_SIGNAL,
	NIBBLES_GAME_BONUS_ADDED_SIGNAL,
	NIBBLES_GAME_BONUS_REMOVED_SIGNAL,
	NIBBLES_GAME_GET_PKGDATADIR_SIGNAL,
	NIBBLES_GAME_ADD_KEYPRESS_HANDLER_SIGNAL,
	NIBBLES_GAME_REDRAW_SIGNAL,
	NIBBLES_GAME_PLAY_SOUND_SIGNAL,
	NIBBLES_GAME_NUM_SIGNALS
};
static guint nibbles_game_signals[NIBBLES_GAME_NUM_SIGNALS] = {0};

struct _NibblesGame {
	GObject parent_instance;
	NibblesGamePrivate * priv;
	gint* board;
	gint board_length1;
	gint board_length2;
	gboolean added_keypress_handler;
};

struct _NibblesGameClass {
	GObjectClass parent_class;
};

struct _NibblesGamePrivate {
	gboolean _skip_score;
	gint _current_level;
	gboolean _three_dimensional_view;
	gint _speed;
	gint _gamedelay;
	guint8 _width;
	guint8 _height;
	gint _numhumans;
	gint _numai;
	gint _numworms;
	GeeLinkedList* _worms;
	GeeHashMap* _worm_props;
	Boni* boni;
	WarpManager* warp_manager;
	gboolean _is_running;
	gboolean _is_paused;
	guint main_id;
	gboolean _fakes;
	guint8 bonus_cycle;
};

struct _Worm {
	GObject parent_instance;
	WormPrivate * priv;
	gboolean is_human;
	gboolean keypress;
	gint rounds_to_stay_still;
	gboolean is_stopped;
	WormPositions* list;
};

struct _WormClass {
	GObjectClass parent_class;
};

struct _Position {
	guint8 x;
	guint8 y;
};

static gint NibblesGame_private_offset;
static gpointer nibbles_game_parent_class = NULL;

VALA_EXTERN GType game_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType nibbles_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesGame, g_object_unref)
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN GType worm_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormProperties, g_object_unref)
VALA_EXTERN GType boni_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Boni, g_object_unref)
VALA_EXTERN GType warp_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarpManager, g_object_unref)
VALA_EXTERN Boni* boni_new (void);
VALA_EXTERN Boni* boni_construct (GType object_type);
VALA_EXTERN WarpManager* warp_manager_new (void);
VALA_EXTERN WarpManager* warp_manager_construct (GType object_type);
VALA_EXTERN NibblesGame* nibbles_game_new (gint start_level,
                               gint speed,
                               gint gamedelay,
                               gboolean fakes,
                               gboolean three_dimensional_view,
                               guint8 width,
                               guint8 height,
                               gboolean no_random);
VALA_EXTERN NibblesGame* nibbles_game_construct (GType object_type,
                                     gint start_level,
                                     gint speed,
                                     gint gamedelay,
                                     gboolean fakes,
                                     gboolean three_dimensional_view,
                                     guint8 width,
                                     guint8 height,
                                     gboolean no_random);
VALA_EXTERN void nibbles_game_new_level (NibblesGame* self,
                             gint level_id);
VALA_EXTERN gboolean nibbles_game_keypress (NibblesGame* self,
                                guint keyval,
                                guint keycode,
                                gboolean* remove_handler);
static gboolean _nibbles_game_keypress_keypress_handler_function (guint a,
                                                           guint b,
                                                           gboolean* remove_handler,
                                                           gpointer self);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gboolean nibbles_game_load_board (NibblesGame* self,
                                  gchar** future_board,
                                  gint future_board_length1,
                                  guint8 regular_bonus);
VALA_EXTERN gint nibbles_game_get_numworms (NibblesGame* self);
VALA_EXTERN guint8 nibbles_game_get_height (NibblesGame* self);
VALA_EXTERN void boni_reset (Boni* self,
                 guint8 regular_bonus);
VALA_EXTERN void warp_manager_clear_warps (WarpManager* self);
VALA_EXTERN guint8 nibbles_game_get_width (NibblesGame* self);
VALA_EXTERN GeeLinkedList* nibbles_game_get_worms (NibblesGame* self);
VALA_EXTERN GType worm_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void worm_set_start (Worm* self,
                     guint8 x,
                     guint8 y,
                     WormDirection direction);
VALA_EXTERN void warp_manager_add_warp_source (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y);
VALA_EXTERN void warp_manager_add_warp_target (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y);
VALA_EXTERN void nibbles_game_start (NibblesGame* self,
                         gboolean add_initial_bonus);
static void nibbles_game_add_bonus (NibblesGame* self,
                             gboolean regular);
static void nibbles_game_set_is_running (NibblesGame* self,
                                  gboolean value);
VALA_EXTERN gint nibbles_game_get_gamedelay (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_speed (NibblesGame* self);
static gboolean __lambda11_ (NibblesGame* self);
static gboolean nibbles_game_main_loop_cb (NibblesGame* self);
static gboolean ___lambda11__gsource_func (gpointer self);
VALA_EXTERN void nibbles_game_stop (NibblesGame* self);
VALA_EXTERN void nibbles_game_reset (NibblesGame* self,
                         gint start_level);
VALA_EXTERN void nibbles_game_set_skip_score (NibblesGame* self,
                                  gboolean value);
VALA_EXTERN void nibbles_game_set_current_level (NibblesGame* self,
                                     gint value);
static void nibbles_game_set_is_paused (NibblesGame* self,
                                 gboolean value);
static void nibbles_game_end (NibblesGame* self);
VALA_EXTERN GameStatus* nibbles_game_get_game_status (NibblesGame* self);
static gboolean _game_status_equal (const GameStatus * s1,
                             const GameStatus * s2);
VALA_EXTERN gint worm_get_score (Worm* self);
VALA_EXTERN gint nibbles_game_get_current_level (NibblesGame* self);
VALA_EXTERN Worm* nibbles_game_get_winner (NibblesGame* self);
static void nibbles_game_move_worms (NibblesGame* self);
VALA_EXTERN void nibbles_game_create_worms (NibblesGame* self,
                                GeeArrayList* worm_settings);
VALA_EXTERN gint nibbles_game_get_numai (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_numhumans (NibblesGame* self);
static void nibbles_game_set_numworms (NibblesGame* self,
                                gint value);
static GeeList* nibbles_game_get_other_worms (NibblesGame* self,
                                       Worm* _self_);
static GeeList* _nibbles_game_get_other_worms_worm_get_other_worms_type (Worm* _self_,
                                                                  gpointer self);
VALA_EXTERN GType bonus_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bonus, g_object_unref)
VALA_EXTERN GeeList* nibbles_game_get_bonuses (NibblesGame* self);
static GeeList* _nibbles_game_get_bonuses_worm_get_bonuses_type (gpointer self);
VALA_EXTERN Worm* worm_new (gint id,
                guint8 width,
                guint8 height,
                WormGetOtherWormsType cb0,
                gpointer cb0_target,
                WormGetBonusesType cb1,
                gpointer cb1_target);
VALA_EXTERN Worm* worm_construct (GType object_type,
                      gint id,
                      guint8 width,
                      guint8 height,
                      WormGetOtherWormsType cb0,
                      gpointer cb0_target,
                      WormGetBonusesType cb1,
                      gpointer cb1_target);
static void nibbles_game_bonus_found_cb (NibblesGame* self,
                                  Worm* worm);
static void _nibbles_game_bonus_found_cb_worm_bonus_found (Worm* _sender,
                                                    gpointer self);
VALA_EXTERN GType worm_positions_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormPositions, g_object_unref)
VALA_EXTERN void nibbles_game_load_worm_properties (NibblesGame* self,
                                        GeeArrayList* worm_settings);
VALA_EXTERN void nibbles_game_add_worms (NibblesGame* self);
VALA_EXTERN void worm_spawn (Worm* self);
VALA_EXTERN gboolean boni_too_many_missed (Boni* self);
VALA_EXTERN void worm_set_score (Worm* self,
                     gint value);
VALA_EXTERN void boni_on_worms_move (Boni* self,
                         guint8* missed_bonuses_to_replace);
VALA_EXTERN void worm_ai_move (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2,
                   GeeLinkedList* worms);
VALA_EXTERN GType position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Position* position_dup (const Position* self);
VALA_EXTERN void position_free (Position* self);
VALA_EXTERN void worm_position_move (Worm* self,
                         Position* result);
VALA_EXTERN WormDirection worm_get_direction (Worm* self);
VALA_EXTERN gboolean warp_manager_get_warp_target (WarpManager* self,
                                       guint8 x,
                                       guint8 y,
                                       gboolean horizontal,
                                       guint8* target_x,
                                       guint8* target_y);
VALA_EXTERN gboolean worm_can_move_to (Worm* self,
                           gint* board,
                           gint board_length1,
                           gint board_length2,
                           GeeLinkedList* worms,
                           Position* position);
VALA_EXTERN void worm_move_part_1 (Worm* self);
VALA_EXTERN void worm_get_head (Worm* self,
                    Position * result);
VALA_EXTERN void worm_move_part_2 (Worm* self,
                       Position* head_position);
VALA_EXTERN guint8 worm_get_lives (Worm* self);
VALA_EXTERN void worm_reset (Worm* self);
static void nibbles_game_reverse_worms (NibblesGame* self,
                                 Worm* worm);
VALA_EXTERN void worm_reverse (Worm* self);
static gboolean nibbles_game_is_space_empty (NibblesGame* self,
                                      guint8 x,
                                      guint8 y,
                                      gboolean* worms_at,
                                      gint worms_at_length1,
                                      gint worms_at_length2);
VALA_EXTERN Bonus* boni_get_bonus (Boni* self,
                       guint8 x,
                       guint8 y);
VALA_EXTERN gboolean nibbles_game_get_fakes (NibblesGame* self);
VALA_EXTERN GType bonus_type_get_type (void) G_GNUC_CONST ;
static inline void _nibbles_game_add_bonus (NibblesGame* self,
                              guint8 x,
                              guint8 y,
                              BonusType bonus_type,
                              gboolean fake,
                              guint16 countdown);
VALA_EXTERN Bonus* bonus_new (guint8 x,
                  guint8 y,
                  BonusType bonus_type,
                  gboolean fake,
                  guint16 countdown);
VALA_EXTERN Bonus* bonus_construct (GType object_type,
                        guint8 x,
                        guint8 y,
                        BonusType bonus_type,
                        gboolean fake,
                        guint16 countdown);
VALA_EXTERN gboolean boni_add_bonus (Boni* self,
                         Bonus* bonus);
VALA_EXTERN BonusType bonus_get_bonus_type (Bonus* self);
static void nibbles_game_apply_bonus (NibblesGame* self,
                               Bonus* bonus,
                               Worm* worm);
VALA_EXTERN gboolean bonus_get_fake (Bonus* self);
VALA_EXTERN guint8 boni_new_regular_bonus_eaten (Boni* self);
VALA_EXTERN gint worm_get_change (Worm* self);
VALA_EXTERN void worm_set_change (Worm* self,
                      gint value);
VALA_EXTERN gint worm_get_length (Worm* self);
VALA_EXTERN void worm_reduce_tail (Worm* self,
                       gint erase_size);
VALA_EXTERN void worm_add_life (Worm* self);
VALA_EXTERN void worm_add_bonus_eaten_position (Worm* self,
                                    guint8 x,
                                    guint8 y);
VALA_EXTERN void boni_remove_bonus (Boni* self,
                        Bonus* bonus);
VALA_EXTERN gboolean boni_last_regular_bonus (Boni* self);
static GameStatus* _game_status_dup (GameStatus* self);
VALA_EXTERN GeeHashMap* nibbles_game_get_worm_props (NibblesGame* self);
VALA_EXTERN WormProperties* worm_properties_new (void);
VALA_EXTERN WormProperties* worm_properties_construct (GType object_type);
VALA_EXTERN gint worm_get_id (Worm* self);
static gboolean ____lambda12_ (GValue* prop_value,
                        GVariant* variant);
static inline gint nibbles_game_get_color_num (const gchar* color);
static gboolean _____lambda12__gsettings_bind_get_mapping (GValue* value,
                                                    GVariant* variant,
                                                    void* user_data);
static GVariant* ____lambda13_ (GValue* prop_value,
                         const GVariantType* variant_type);
static inline gchar* nibbles_game_get_color_string (gint color);
static GVariant* _____lambda13__gsettings_bind_set_mapping (GValue* value,
                                                     const GVariantType* expected_type,
                                                     void* user_data);
VALA_EXTERN gboolean nibbles_game_handle_keypress (NibblesGame* self,
                                       guint keyval,
                                       guint keycode);
VALA_EXTERN gboolean nibbles_game_get_is_running (NibblesGame* self);
VALA_EXTERN gboolean worm_handle_keypress (Worm* self,
                               guint keycode,
                               GeeHashMap* worm_props,
                               gint* board,
                               gint board_length1,
                               gint board_length2,
                               GeeLinkedList* worms);
VALA_EXTERN GeeList* boni_get_bonuses (Boni* self);
VALA_EXTERN gboolean nibbles_game_get_skip_score (NibblesGame* self);
VALA_EXTERN gboolean nibbles_game_get_three_dimensional_view (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_three_dimensional_view (NibblesGame* self,
                                              gboolean value);
VALA_EXTERN void nibbles_game_set_speed (NibblesGame* self,
                             gint value);
static void nibbles_game_set_gamedelay (NibblesGame* self,
                                 gint value);
static void nibbles_game_set_width (NibblesGame* self,
                             guint8 value);
static void nibbles_game_set_height (NibblesGame* self,
                              guint8 value);
VALA_EXTERN void nibbles_game_set_numhumans (NibblesGame* self,
                                 gint value);
VALA_EXTERN void nibbles_game_set_numai (NibblesGame* self,
                             gint value);
static gboolean nibbles_game_get_is_paused (NibblesGame* self);
VALA_EXTERN gboolean nibbles_game_get_paused (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_paused (NibblesGame* self,
                              gboolean value);
VALA_EXTERN void nibbles_game_set_fakes (NibblesGame* self,
                             gboolean value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void g_cclosure_user_marshal_STRING__VOID (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data);
static void g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data);
static GObject * nibbles_game_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void _nibbles_game___lambda14_ (NibblesGame* self,
                                Bonus* bonus);
static void __nibbles_game___lambda14__boni_bonus_removed (Boni* _sender,
                                                    Bonus* bonus,
                                                    gpointer self);
static void nibbles_game_finalize (GObject * obj);
static GType nibbles_game_get_type_once (void);
static void _vala_nibbles_game_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_nibbles_game_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

 G_GNUC_NO_INLINE static GType
game_status_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_STATUS_GAMEOVER, "GAME_STATUS_GAMEOVER", "gameover"}, {GAME_STATUS_VICTORY, "GAME_STATUS_VICTORY", "victory"}, {GAME_STATUS_NEWROUND, "GAME_STATUS_NEWROUND", "newround"}, {0, NULL, NULL}};
	GType game_status_type_id;
	game_status_type_id = g_enum_register_static ("GameStatus", values);
	return game_status_type_id;
}

GType
game_status_get_type (void)
{
	static gsize game_status_type_id__once = 0;
	if (g_once_init_enter (&game_status_type_id__once)) {
		GType game_status_type_id;
		game_status_type_id = game_status_get_type_once ();
		g_once_init_leave (&game_status_type_id__once, game_status_type_id);
	}
	return game_status_type_id__once;
}

static inline gpointer
nibbles_game_get_instance_private (NibblesGame* self)
{
	return G_STRUCT_MEMBER_P (self, NibblesGame_private_offset);
}

NibblesGame*
nibbles_game_construct (GType object_type,
                        gint start_level,
                        gint speed,
                        gint gamedelay,
                        gboolean fakes,
                        gboolean three_dimensional_view,
                        guint8 width,
                        guint8 height,
                        gboolean no_random)
{
	NibblesGame * self = NULL;
	guint32 _tmp0_ = 0U;
#line 128 "../src/nibbles-game.vala"
	self = (NibblesGame*) g_object_new (object_type, "skip-score", start_level != 1, "current-level", start_level, "speed", speed, "gamedelay", gamedelay, "fakes", fakes, "three-dimensional-view", three_dimensional_view, "width", width, "height", height, NULL);
#line 130 "../src/nibbles-game.vala"
	if (no_random) {
#line 130 "../src/nibbles-game.vala"
		_tmp0_ = (guint32) 42;
#line 644 "nibbles-game.c"
	} else {
		time_t _tmp1_;
#line 130 "../src/nibbles-game.vala"
		_tmp1_ = time (NULL);
#line 130 "../src/nibbles-game.vala"
		_tmp0_ = (guint32) _tmp1_;
#line 651 "nibbles-game.c"
	}
#line 130 "../src/nibbles-game.vala"
	g_random_set_seed (_tmp0_);
#line 126 "../src/nibbles-game.vala"
	return self;
#line 657 "nibbles-game.c"
}

NibblesGame*
nibbles_game_new (gint start_level,
                  gint speed,
                  gint gamedelay,
                  gboolean fakes,
                  gboolean three_dimensional_view,
                  guint8 width,
                  guint8 height,
                  gboolean no_random)
{
#line 126 "../src/nibbles-game.vala"
	return nibbles_game_construct (TYPE_NIBBLES_GAME, start_level, speed, gamedelay, fakes, three_dimensional_view, width, height, no_random);
#line 672 "nibbles-game.c"
}

static gboolean
_nibbles_game_keypress_keypress_handler_function (guint a,
                                                  guint b,
                                                  gboolean* remove_handler,
                                                  gpointer self)
{
	gboolean result;
	result = nibbles_game_keypress ((NibblesGame*) self, a, b, remove_handler);
#line 142 "../src/nibbles-game.vala"
	return result;
#line 685 "nibbles-game.c"
}

static gchar*
g_file_stream_read_line (FILE* self)
{
	gint c = 0;
	GString* ret = NULL;
	GString* _tmp3_;
	gchar* result;
#line 4059 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 4061 "glib-2.0.vapi"
	ret = NULL;
#line 4062 "glib-2.0.vapi"
	while (TRUE) {
#line 701 "nibbles-game.c"
		GString* _tmp0_;
		GString* _tmp2_;
#line 4062 "glib-2.0.vapi"
		c = fgetc (self);
#line 4062 "glib-2.0.vapi"
		if (!(c != EOF)) {
#line 4062 "glib-2.0.vapi"
			break;
#line 710 "nibbles-game.c"
		}
#line 4063 "glib-2.0.vapi"
		_tmp0_ = ret;
#line 4063 "glib-2.0.vapi"
		if (_tmp0_ == NULL) {
#line 716 "nibbles-game.c"
			GString* _tmp1_;
#line 4064 "glib-2.0.vapi"
			_tmp1_ = g_string_new ("");
#line 4064 "glib-2.0.vapi"
			_g_string_free0 (ret);
#line 4064 "glib-2.0.vapi"
			ret = _tmp1_;
#line 724 "nibbles-game.c"
		}
#line 4066 "glib-2.0.vapi"
		if (c == ((gint) '\n')) {
#line 4067 "glib-2.0.vapi"
			break;
#line 730 "nibbles-game.c"
		}
#line 4069 "glib-2.0.vapi"
		_tmp2_ = ret;
#line 4069 "glib-2.0.vapi"
		g_string_append_c ((GString*) _tmp2_, (gchar) c);
#line 736 "nibbles-game.c"
	}
#line 4071 "glib-2.0.vapi"
	_tmp3_ = ret;
#line 4071 "glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 4072 "glib-2.0.vapi"
		result = NULL;
#line 4072 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4072 "glib-2.0.vapi"
		return result;
#line 748 "nibbles-game.c"
	} else {
		GString* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 4074 "glib-2.0.vapi"
		_tmp4_ = ret;
#line 4074 "glib-2.0.vapi"
		_tmp5_ = ((GString*) _tmp4_)->str;
#line 4074 "glib-2.0.vapi"
		_tmp6_ = g_strdup (_tmp5_);
#line 4074 "glib-2.0.vapi"
		result = _tmp6_;
#line 4074 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4074 "glib-2.0.vapi"
		return result;
#line 765 "nibbles-game.c"
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 154 "../src/nibbles-game.vala"
	if ((*length) == (*size)) {
#line 154 "../src/nibbles-game.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 154 "../src/nibbles-game.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 781 "nibbles-game.c"
	}
#line 154 "../src/nibbles-game.vala"
	(*array)[(*length)++] = value;
#line 154 "../src/nibbles-game.vala"
	(*array)[*length] = NULL;
#line 787 "nibbles-game.c"
}

void
nibbles_game_new_level (NibblesGame* self,
                        gint level_id)
{
	gchar* level_name = NULL;
	gchar* _tmp1_;
	gchar* filename = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	FILE* file = NULL;
	FILE* _tmp6_;
	gchar* line = NULL;
	gchar** board = NULL;
	gchar** _tmp7_;
	gint board_length1;
	gint _board_size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gint _tmp13_;
#line 138 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/nibbles-game.vala"
	if (!self->added_keypress_handler) {
#line 815 "nibbles-game.c"
		gboolean _tmp0_ = FALSE;
#line 142 "../src/nibbles-game.vala"
		g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ADD_KEYPRESS_HANDLER_SIGNAL], 0, _nibbles_game_keypress_keypress_handler_function, self, &_tmp0_);
#line 142 "../src/nibbles-game.vala"
		self->added_keypress_handler = _tmp0_;
#line 821 "nibbles-game.c"
	}
#line 144 "../src/nibbles-game.vala"
	_tmp1_ = g_strdup_printf ("level%03d.gnl", level_id);
#line 144 "../src/nibbles-game.vala"
	level_name = _tmp1_;
#line 145 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_GET_PKGDATADIR_SIGNAL], 0, &_tmp2_);
#line 145 "../src/nibbles-game.vala"
	_tmp3_ = _tmp2_;
#line 145 "../src/nibbles-game.vala"
	_tmp4_ = g_build_filename (_tmp3_, "levels", level_name, NULL, NULL);
#line 145 "../src/nibbles-game.vala"
	_tmp5_ = _tmp4_;
#line 145 "../src/nibbles-game.vala"
	_g_free0 (_tmp3_);
#line 145 "../src/nibbles-game.vala"
	filename = _tmp5_;
#line 148 "../src/nibbles-game.vala"
	_tmp6_ = g_fopen (filename, "r");
#line 148 "../src/nibbles-game.vala"
	_fclose0 (file);
#line 148 "../src/nibbles-game.vala"
	file = _tmp6_;
#line 148 "../src/nibbles-game.vala"
	if (file == NULL) {
#line 149 "../src/nibbles-game.vala"
		g_error ("nibbles-game.vala:149: Nibbles couldn't find pixmap file: %s", filename);
#line 849 "nibbles-game.c"
	}
#line 152 "../src/nibbles-game.vala"
	_tmp7_ = g_new0 (gchar*, 0 + 1);
#line 152 "../src/nibbles-game.vala"
	board = _tmp7_;
#line 152 "../src/nibbles-game.vala"
	board_length1 = 0;
#line 152 "../src/nibbles-game.vala"
	_board_size_ = board_length1;
#line 153 "../src/nibbles-game.vala"
	while (TRUE) {
#line 861 "nibbles-game.c"
		gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 153 "../src/nibbles-game.vala"
		_tmp8_ = g_file_stream_read_line (file);
#line 153 "../src/nibbles-game.vala"
		_g_free0 (line);
#line 153 "../src/nibbles-game.vala"
		line = _tmp8_;
#line 153 "../src/nibbles-game.vala"
		_tmp9_ = line;
#line 153 "../src/nibbles-game.vala"
		if (!(_tmp9_ != NULL)) {
#line 153 "../src/nibbles-game.vala"
			break;
#line 878 "nibbles-game.c"
		}
#line 154 "../src/nibbles-game.vala"
		_tmp10_ = line;
#line 154 "../src/nibbles-game.vala"
		_tmp11_ = g_strdup ((const gchar*) _tmp10_);
#line 154 "../src/nibbles-game.vala"
		_vala_array_add1 (&board, &board_length1, &_board_size_, _tmp11_);
#line 886 "nibbles-game.c"
	}
#line 155 "../src/nibbles-game.vala"
	_tmp12_ = board;
#line 155 "../src/nibbles-game.vala"
	_tmp12__length1 = board_length1;
#line 155 "../src/nibbles-game.vala"
	_tmp13_ = self->priv->_numworms;
#line 155 "../src/nibbles-game.vala"
	if (!nibbles_game_load_board (self, _tmp12_, (gint) _tmp12__length1, (guint8) (8 + _tmp13_))) {
#line 156 "../src/nibbles-game.vala"
		g_error ("nibbles-game.vala:156: Level file appears to be damaged: %s", filename);
#line 898 "nibbles-game.c"
	}
#line 138 "../src/nibbles-game.vala"
	board = (_vala_array_free (board, board_length1, (GDestroyNotify) g_free), NULL);
#line 138 "../src/nibbles-game.vala"
	_g_free0 (line);
#line 138 "../src/nibbles-game.vala"
	_fclose0 (file);
#line 138 "../src/nibbles-game.vala"
	_g_free0 (filename);
#line 138 "../src/nibbles-game.vala"
	_g_free0 (level_name);
#line 910 "nibbles-game.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1270 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1271 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1271 "glib-2.0.vapi"
	return result;
#line 924 "nibbles-game.c"
}

static gint
string_index_of_nth_char (const gchar* self,
                          glong c)
{
	gchar* _tmp0_;
	gint result;
#line 1290 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1291 "glib-2.0.vapi"
	_tmp0_ = g_utf8_offset_to_pointer (self, c);
#line 1291 "glib-2.0.vapi"
	result = (gint) (_tmp0_ - ((gchar*) self));
#line 1291 "glib-2.0.vapi"
	return result;
#line 941 "nibbles-game.c"
}

gboolean
nibbles_game_load_board (NibblesGame* self,
                         gchar** future_board,
                         gint future_board_length1,
                         guint8 regular_bonus)
{
	guint8 _tmp0_;
	Boni* _tmp1_;
	WarpManager* _tmp2_;
	gchar* tmpboard = NULL;
	gint count = 0;
	gboolean result;
#line 159 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 161 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_height;
#line 161 "../src/nibbles-game.vala"
	if (future_board_length1 != ((gint) _tmp0_)) {
#line 162 "../src/nibbles-game.vala"
		result = FALSE;
#line 162 "../src/nibbles-game.vala"
		return result;
#line 966 "nibbles-game.c"
	}
#line 164 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->boni;
#line 164 "../src/nibbles-game.vala"
	boni_reset (_tmp1_, regular_bonus);
#line 165 "../src/nibbles-game.vala"
	_tmp2_ = self->priv->warp_manager;
#line 165 "../src/nibbles-game.vala"
	warp_manager_clear_warps (_tmp2_);
#line 168 "../src/nibbles-game.vala"
	count = 0;
#line 978 "nibbles-game.c"
	{
		guint8 i = 0U;
#line 169 "../src/nibbles-game.vala"
		i = (guint8) 0;
#line 983 "nibbles-game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 169 "../src/nibbles-game.vala"
			_tmp3_ = TRUE;
#line 169 "../src/nibbles-game.vala"
			while (TRUE) {
#line 990 "nibbles-game.c"
				guint8 _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				guint8 _tmp9_;
#line 169 "../src/nibbles-game.vala"
				if (!_tmp3_) {
#line 998 "nibbles-game.c"
					guint8 _tmp4_;
#line 169 "../src/nibbles-game.vala"
					_tmp4_ = i;
#line 169 "../src/nibbles-game.vala"
					i = _tmp4_ + 1;
#line 1004 "nibbles-game.c"
				}
#line 169 "../src/nibbles-game.vala"
				_tmp3_ = FALSE;
#line 169 "../src/nibbles-game.vala"
				_tmp5_ = self->priv->_height;
#line 169 "../src/nibbles-game.vala"
				if (!(i < _tmp5_)) {
#line 169 "../src/nibbles-game.vala"
					break;
#line 1014 "nibbles-game.c"
				}
#line 171 "../src/nibbles-game.vala"
				_tmp6_ = future_board[i];
#line 171 "../src/nibbles-game.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 171 "../src/nibbles-game.vala"
				_g_free0 (tmpboard);
#line 171 "../src/nibbles-game.vala"
				tmpboard = _tmp7_;
#line 172 "../src/nibbles-game.vala"
				_tmp8_ = tmpboard;
#line 172 "../src/nibbles-game.vala"
				_tmp9_ = self->priv->_width;
#line 172 "../src/nibbles-game.vala"
				if (g_utf8_strlen (_tmp8_, (gssize) -1) != ((gint) _tmp9_)) {
#line 173 "../src/nibbles-game.vala"
					result = FALSE;
#line 173 "../src/nibbles-game.vala"
					_g_free0 (tmpboard);
#line 173 "../src/nibbles-game.vala"
					return result;
#line 1036 "nibbles-game.c"
				}
				{
					guint8 j = 0U;
#line 174 "../src/nibbles-game.vala"
					j = (guint8) 0;
#line 1042 "nibbles-game.c"
					{
						gboolean _tmp10_ = FALSE;
#line 174 "../src/nibbles-game.vala"
						_tmp10_ = TRUE;
#line 174 "../src/nibbles-game.vala"
						while (TRUE) {
#line 1049 "nibbles-game.c"
							guint8 _tmp12_;
							gunichar char_value = 0U;
							const gchar* _tmp13_;
							const gchar* _tmp14_;
#line 174 "../src/nibbles-game.vala"
							if (!_tmp10_) {
#line 1056 "nibbles-game.c"
								guint8 _tmp11_;
#line 174 "../src/nibbles-game.vala"
								_tmp11_ = j;
#line 174 "../src/nibbles-game.vala"
								j = _tmp11_ + 1;
#line 1062 "nibbles-game.c"
							}
#line 174 "../src/nibbles-game.vala"
							_tmp10_ = FALSE;
#line 174 "../src/nibbles-game.vala"
							_tmp12_ = self->priv->_width;
#line 174 "../src/nibbles-game.vala"
							if (!(j < _tmp12_)) {
#line 174 "../src/nibbles-game.vala"
								break;
#line 1072 "nibbles-game.c"
							}
#line 176 "../src/nibbles-game.vala"
							_tmp13_ = tmpboard;
#line 176 "../src/nibbles-game.vala"
							_tmp14_ = tmpboard;
#line 176 "../src/nibbles-game.vala"
							char_value = string_get_char (_tmp13_, (glong) string_index_of_nth_char (_tmp14_, (glong) j));
#line 177 "../src/nibbles-game.vala"
							switch (char_value) {
#line 177 "../src/nibbles-game.vala"
								case '.':
#line 177 "../src/nibbles-game.vala"
								case '+':
#line 1086 "nibbles-game.c"
								{
									gint* _tmp15_;
									gint _tmp15__length1;
									gint _tmp15__length2;
#line 182 "../src/nibbles-game.vala"
									_tmp15_ = self->board;
#line 182 "../src/nibbles-game.vala"
									_tmp15__length1 = self->board_length1;
#line 182 "../src/nibbles-game.vala"
									_tmp15__length2 = self->board_length2;
#line 182 "../src/nibbles-game.vala"
									_tmp15_[(j * _tmp15__length2) + i] = (gint) 'a';
#line 183 "../src/nibbles-game.vala"
									break;
#line 1101 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9475U:
#line 1105 "nibbles-game.c"
								{
									gint* _tmp16_;
									gint _tmp16__length1;
									gint _tmp16__length2;
#line 187 "../src/nibbles-game.vala"
									_tmp16_ = self->board;
#line 187 "../src/nibbles-game.vala"
									_tmp16__length1 = self->board_length1;
#line 187 "../src/nibbles-game.vala"
									_tmp16__length2 = self->board_length2;
#line 187 "../src/nibbles-game.vala"
									_tmp16_[(j * _tmp16__length2) + i] = (gint) 'b';
#line 188 "../src/nibbles-game.vala"
									break;
#line 1120 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9473U:
#line 1124 "nibbles-game.c"
								{
									gint* _tmp17_;
									gint _tmp17__length1;
									gint _tmp17__length2;
#line 190 "../src/nibbles-game.vala"
									_tmp17_ = self->board;
#line 190 "../src/nibbles-game.vala"
									_tmp17__length1 = self->board_length1;
#line 190 "../src/nibbles-game.vala"
									_tmp17__length2 = self->board_length2;
#line 190 "../src/nibbles-game.vala"
									_tmp17_[(j * _tmp17__length2) + i] = (gint) 'c';
#line 191 "../src/nibbles-game.vala"
									break;
#line 1139 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9495U:
#line 1143 "nibbles-game.c"
								{
									gint* _tmp18_;
									gint _tmp18__length1;
									gint _tmp18__length2;
#line 193 "../src/nibbles-game.vala"
									_tmp18_ = self->board;
#line 193 "../src/nibbles-game.vala"
									_tmp18__length1 = self->board_length1;
#line 193 "../src/nibbles-game.vala"
									_tmp18__length2 = self->board_length2;
#line 193 "../src/nibbles-game.vala"
									_tmp18_[(j * _tmp18__length2) + i] = (gint) 'd';
#line 194 "../src/nibbles-game.vala"
									break;
#line 1158 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9499U:
#line 1162 "nibbles-game.c"
								{
									gint* _tmp19_;
									gint _tmp19__length1;
									gint _tmp19__length2;
#line 196 "../src/nibbles-game.vala"
									_tmp19_ = self->board;
#line 196 "../src/nibbles-game.vala"
									_tmp19__length1 = self->board_length1;
#line 196 "../src/nibbles-game.vala"
									_tmp19__length2 = self->board_length2;
#line 196 "../src/nibbles-game.vala"
									_tmp19_[(j * _tmp19__length2) + i] = (gint) 'e';
#line 197 "../src/nibbles-game.vala"
									break;
#line 1177 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9487U:
#line 1181 "nibbles-game.c"
								{
									gint* _tmp20_;
									gint _tmp20__length1;
									gint _tmp20__length2;
#line 199 "../src/nibbles-game.vala"
									_tmp20_ = self->board;
#line 199 "../src/nibbles-game.vala"
									_tmp20__length1 = self->board_length1;
#line 199 "../src/nibbles-game.vala"
									_tmp20__length2 = self->board_length2;
#line 199 "../src/nibbles-game.vala"
									_tmp20_[(j * _tmp20__length2) + i] = (gint) 'f';
#line 200 "../src/nibbles-game.vala"
									break;
#line 1196 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9491U:
#line 1200 "nibbles-game.c"
								{
									gint* _tmp21_;
									gint _tmp21__length1;
									gint _tmp21__length2;
#line 202 "../src/nibbles-game.vala"
									_tmp21_ = self->board;
#line 202 "../src/nibbles-game.vala"
									_tmp21__length1 = self->board_length1;
#line 202 "../src/nibbles-game.vala"
									_tmp21__length2 = self->board_length2;
#line 202 "../src/nibbles-game.vala"
									_tmp21_[(j * _tmp21__length2) + i] = (gint) 'g';
#line 203 "../src/nibbles-game.vala"
									break;
#line 1215 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9531U:
#line 1219 "nibbles-game.c"
								{
									gint* _tmp22_;
									gint _tmp22__length1;
									gint _tmp22__length2;
#line 205 "../src/nibbles-game.vala"
									_tmp22_ = self->board;
#line 205 "../src/nibbles-game.vala"
									_tmp22__length1 = self->board_length1;
#line 205 "../src/nibbles-game.vala"
									_tmp22__length2 = self->board_length2;
#line 205 "../src/nibbles-game.vala"
									_tmp22_[(j * _tmp22__length2) + i] = (gint) 'h';
#line 206 "../src/nibbles-game.vala"
									break;
#line 1234 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9507U:
#line 1238 "nibbles-game.c"
								{
									gint* _tmp23_;
									gint _tmp23__length1;
									gint _tmp23__length2;
#line 208 "../src/nibbles-game.vala"
									_tmp23_ = self->board;
#line 208 "../src/nibbles-game.vala"
									_tmp23__length1 = self->board_length1;
#line 208 "../src/nibbles-game.vala"
									_tmp23__length2 = self->board_length2;
#line 208 "../src/nibbles-game.vala"
									_tmp23_[(j * _tmp23__length2) + i] = (gint) 'i';
#line 209 "../src/nibbles-game.vala"
									break;
#line 1253 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9515U:
#line 1257 "nibbles-game.c"
								{
									gint* _tmp24_;
									gint _tmp24__length1;
									gint _tmp24__length2;
#line 211 "../src/nibbles-game.vala"
									_tmp24_ = self->board;
#line 211 "../src/nibbles-game.vala"
									_tmp24__length1 = self->board_length1;
#line 211 "../src/nibbles-game.vala"
									_tmp24__length2 = self->board_length2;
#line 211 "../src/nibbles-game.vala"
									_tmp24_[(j * _tmp24__length2) + i] = (gint) 'j';
#line 212 "../src/nibbles-game.vala"
									break;
#line 1272 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9523U:
#line 1276 "nibbles-game.c"
								{
									gint* _tmp25_;
									gint _tmp25__length1;
									gint _tmp25__length2;
#line 214 "../src/nibbles-game.vala"
									_tmp25_ = self->board;
#line 214 "../src/nibbles-game.vala"
									_tmp25__length1 = self->board_length1;
#line 214 "../src/nibbles-game.vala"
									_tmp25__length2 = self->board_length2;
#line 214 "../src/nibbles-game.vala"
									_tmp25_[(j * _tmp25__length2) + i] = (gint) 'k';
#line 215 "../src/nibbles-game.vala"
									break;
#line 1291 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9547U:
#line 1295 "nibbles-game.c"
								{
									gint* _tmp26_;
									gint _tmp26__length1;
									gint _tmp26__length2;
#line 217 "../src/nibbles-game.vala"
									_tmp26_ = self->board;
#line 217 "../src/nibbles-game.vala"
									_tmp26__length1 = self->board_length1;
#line 217 "../src/nibbles-game.vala"
									_tmp26__length2 = self->board_length2;
#line 217 "../src/nibbles-game.vala"
									_tmp26_[(j * _tmp26__length2) + i] = (gint) 'l';
#line 218 "../src/nibbles-game.vala"
									break;
#line 1310 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9650U:
#line 177 "../src/nibbles-game.vala"
								case 'm':
#line 1316 "nibbles-game.c"
								{
									gint* _tmp27_;
									gint _tmp27__length1;
									gint _tmp27__length2;
									gint _tmp28_;
#line 223 "../src/nibbles-game.vala"
									_tmp27_ = self->board;
#line 223 "../src/nibbles-game.vala"
									_tmp27__length1 = self->board_length1;
#line 223 "../src/nibbles-game.vala"
									_tmp27__length2 = self->board_length2;
#line 223 "../src/nibbles-game.vala"
									_tmp27_[(j * _tmp27__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 224 "../src/nibbles-game.vala"
									_tmp28_ = self->priv->_numworms;
#line 224 "../src/nibbles-game.vala"
									if (count < _tmp28_) {
#line 1334 "nibbles-game.c"
										GeeLinkedList* _tmp29_;
										gpointer _tmp30_;
										Worm* _tmp31_;
										gint _tmp32_;
#line 226 "../src/nibbles-game.vala"
										_tmp29_ = self->priv->_worms;
#line 226 "../src/nibbles-game.vala"
										_tmp30_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, count);
#line 226 "../src/nibbles-game.vala"
										_tmp31_ = (Worm*) _tmp30_;
#line 226 "../src/nibbles-game.vala"
										worm_set_start (_tmp31_, j, i, WORM_DIRECTION_UP);
#line 226 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp31_);
#line 227 "../src/nibbles-game.vala"
										_tmp32_ = count;
#line 227 "../src/nibbles-game.vala"
										count = _tmp32_ + 1;
#line 1353 "nibbles-game.c"
									}
#line 229 "../src/nibbles-game.vala"
									break;
#line 1357 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9664U:
#line 177 "../src/nibbles-game.vala"
								case 'n':
#line 1363 "nibbles-game.c"
								{
									gint* _tmp33_;
									gint _tmp33__length1;
									gint _tmp33__length2;
									gint _tmp34_;
#line 232 "../src/nibbles-game.vala"
									_tmp33_ = self->board;
#line 232 "../src/nibbles-game.vala"
									_tmp33__length1 = self->board_length1;
#line 232 "../src/nibbles-game.vala"
									_tmp33__length2 = self->board_length2;
#line 232 "../src/nibbles-game.vala"
									_tmp33_[(j * _tmp33__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 233 "../src/nibbles-game.vala"
									_tmp34_ = self->priv->_numworms;
#line 233 "../src/nibbles-game.vala"
									if (count < _tmp34_) {
#line 1381 "nibbles-game.c"
										GeeLinkedList* _tmp35_;
										gpointer _tmp36_;
										Worm* _tmp37_;
										gint _tmp38_;
#line 235 "../src/nibbles-game.vala"
										_tmp35_ = self->priv->_worms;
#line 235 "../src/nibbles-game.vala"
										_tmp36_ = gee_abstract_list_get ((GeeAbstractList*) _tmp35_, count);
#line 235 "../src/nibbles-game.vala"
										_tmp37_ = (Worm*) _tmp36_;
#line 235 "../src/nibbles-game.vala"
										worm_set_start (_tmp37_, j, i, WORM_DIRECTION_LEFT);
#line 235 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp37_);
#line 236 "../src/nibbles-game.vala"
										_tmp38_ = count;
#line 236 "../src/nibbles-game.vala"
										count = _tmp38_ + 1;
#line 1400 "nibbles-game.c"
									}
#line 238 "../src/nibbles-game.vala"
									break;
#line 1404 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9660U:
#line 177 "../src/nibbles-game.vala"
								case 'o':
#line 1410 "nibbles-game.c"
								{
									gint* _tmp39_;
									gint _tmp39__length1;
									gint _tmp39__length2;
									gint _tmp40_;
#line 241 "../src/nibbles-game.vala"
									_tmp39_ = self->board;
#line 241 "../src/nibbles-game.vala"
									_tmp39__length1 = self->board_length1;
#line 241 "../src/nibbles-game.vala"
									_tmp39__length2 = self->board_length2;
#line 241 "../src/nibbles-game.vala"
									_tmp39_[(j * _tmp39__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 242 "../src/nibbles-game.vala"
									_tmp40_ = self->priv->_numworms;
#line 242 "../src/nibbles-game.vala"
									if (count < _tmp40_) {
#line 1428 "nibbles-game.c"
										GeeLinkedList* _tmp41_;
										gpointer _tmp42_;
										Worm* _tmp43_;
										gint _tmp44_;
#line 244 "../src/nibbles-game.vala"
										_tmp41_ = self->priv->_worms;
#line 244 "../src/nibbles-game.vala"
										_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, count);
#line 244 "../src/nibbles-game.vala"
										_tmp43_ = (Worm*) _tmp42_;
#line 244 "../src/nibbles-game.vala"
										worm_set_start (_tmp43_, j, i, WORM_DIRECTION_DOWN);
#line 244 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp43_);
#line 245 "../src/nibbles-game.vala"
										_tmp44_ = count;
#line 245 "../src/nibbles-game.vala"
										count = _tmp44_ + 1;
#line 1447 "nibbles-game.c"
									}
#line 247 "../src/nibbles-game.vala"
									break;
#line 1451 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 9654U:
#line 177 "../src/nibbles-game.vala"
								case 'p':
#line 1457 "nibbles-game.c"
								{
									gint* _tmp45_;
									gint _tmp45__length1;
									gint _tmp45__length2;
									gint _tmp46_;
#line 250 "../src/nibbles-game.vala"
									_tmp45_ = self->board;
#line 250 "../src/nibbles-game.vala"
									_tmp45__length1 = self->board_length1;
#line 250 "../src/nibbles-game.vala"
									_tmp45__length2 = self->board_length2;
#line 250 "../src/nibbles-game.vala"
									_tmp45_[(j * _tmp45__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 251 "../src/nibbles-game.vala"
									_tmp46_ = self->priv->_numworms;
#line 251 "../src/nibbles-game.vala"
									if (count < _tmp46_) {
#line 1475 "nibbles-game.c"
										GeeLinkedList* _tmp47_;
										gpointer _tmp48_;
										Worm* _tmp49_;
										gint _tmp50_;
#line 253 "../src/nibbles-game.vala"
										_tmp47_ = self->priv->_worms;
#line 253 "../src/nibbles-game.vala"
										_tmp48_ = gee_abstract_list_get ((GeeAbstractList*) _tmp47_, count);
#line 253 "../src/nibbles-game.vala"
										_tmp49_ = (Worm*) _tmp48_;
#line 253 "../src/nibbles-game.vala"
										worm_set_start (_tmp49_, j, i, WORM_DIRECTION_RIGHT);
#line 253 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp49_);
#line 254 "../src/nibbles-game.vala"
										_tmp50_ = count;
#line 254 "../src/nibbles-game.vala"
										count = _tmp50_ + 1;
#line 1494 "nibbles-game.c"
									}
#line 256 "../src/nibbles-game.vala"
									break;
#line 1498 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 'Q':
#line 177 "../src/nibbles-game.vala"
								case 'R':
#line 177 "../src/nibbles-game.vala"
								case 'S':
#line 177 "../src/nibbles-game.vala"
								case 'T':
#line 177 "../src/nibbles-game.vala"
								case 'U':
#line 177 "../src/nibbles-game.vala"
								case 'V':
#line 177 "../src/nibbles-game.vala"
								case 'W':
#line 177 "../src/nibbles-game.vala"
								case 'X':
#line 177 "../src/nibbles-game.vala"
								case 'Y':
#line 177 "../src/nibbles-game.vala"
								case 'Z':
#line 1520 "nibbles-game.c"
								{
									gboolean _tmp51_ = FALSE;
									gint* _tmp52_;
									gint _tmp52__length1;
									gint _tmp52__length2;
									WarpManager* _tmp53_;
									gint* _tmp54_;
									gint _tmp54__length1;
									gint _tmp54__length2;
									gint _tmp55_;
									gint* _tmp56_;
									gint _tmp56__length1;
									gint _tmp56__length2;
									gint* _tmp57_;
									gint _tmp57__length1;
									gint _tmp57__length2;
									gint* _tmp58_;
									gint _tmp58__length1;
									gint _tmp58__length2;
									gint* _tmp59_;
									gint _tmp59__length1;
									gint _tmp59__length2;
#line 269 "../src/nibbles-game.vala"
									if (((gint) j) == 0) {
#line 269 "../src/nibbles-game.vala"
										_tmp51_ = TRUE;
#line 1547 "nibbles-game.c"
									} else {
#line 269 "../src/nibbles-game.vala"
										_tmp51_ = ((gint) i) == 0;
#line 1551 "nibbles-game.c"
									}
#line 269 "../src/nibbles-game.vala"
									if (_tmp51_) {
#line 270 "../src/nibbles-game.vala"
										result = FALSE;
#line 270 "../src/nibbles-game.vala"
										_g_free0 (tmpboard);
#line 270 "../src/nibbles-game.vala"
										return result;
#line 1561 "nibbles-game.c"
									}
#line 272 "../src/nibbles-game.vala"
									_tmp52_ = self->board;
#line 272 "../src/nibbles-game.vala"
									_tmp52__length1 = self->board_length1;
#line 272 "../src/nibbles-game.vala"
									_tmp52__length2 = self->board_length2;
#line 272 "../src/nibbles-game.vala"
									_tmp52_[(j * _tmp52__length2) + i] = (gint) char_value;
#line 273 "../src/nibbles-game.vala"
									_tmp53_ = self->priv->warp_manager;
#line 273 "../src/nibbles-game.vala"
									_tmp54_ = self->board;
#line 273 "../src/nibbles-game.vala"
									_tmp54__length1 = self->board_length1;
#line 273 "../src/nibbles-game.vala"
									_tmp54__length2 = self->board_length2;
#line 273 "../src/nibbles-game.vala"
									_tmp55_ = _tmp54_[(j * _tmp54__length2) + i];
#line 273 "../src/nibbles-game.vala"
									warp_manager_add_warp_source (_tmp53_, _tmp55_, (guint8) (j - 1), (guint8) (i - 1));
#line 275 "../src/nibbles-game.vala"
									_tmp56_ = self->board;
#line 275 "../src/nibbles-game.vala"
									_tmp56__length1 = self->board_length1;
#line 275 "../src/nibbles-game.vala"
									_tmp56__length2 = self->board_length2;
#line 275 "../src/nibbles-game.vala"
									_tmp56_[((j - 1) * _tmp56__length2) + (i - 1)] = (gint) NIBBLES_GAME_WARPCHAR;
#line 276 "../src/nibbles-game.vala"
									_tmp57_ = self->board;
#line 276 "../src/nibbles-game.vala"
									_tmp57__length1 = self->board_length1;
#line 276 "../src/nibbles-game.vala"
									_tmp57__length2 = self->board_length2;
#line 276 "../src/nibbles-game.vala"
									_tmp57_[(j * _tmp57__length2) + (i - 1)] = (gint) NIBBLES_GAME_WARPCHAR;
#line 277 "../src/nibbles-game.vala"
									_tmp58_ = self->board;
#line 277 "../src/nibbles-game.vala"
									_tmp58__length1 = self->board_length1;
#line 277 "../src/nibbles-game.vala"
									_tmp58__length2 = self->board_length2;
#line 277 "../src/nibbles-game.vala"
									_tmp58_[((j - 1) * _tmp58__length2) + i] = (gint) NIBBLES_GAME_WARPCHAR;
#line 278 "../src/nibbles-game.vala"
									_tmp59_ = self->board;
#line 278 "../src/nibbles-game.vala"
									_tmp59__length1 = self->board_length1;
#line 278 "../src/nibbles-game.vala"
									_tmp59__length2 = self->board_length2;
#line 278 "../src/nibbles-game.vala"
									_tmp59_[(j * _tmp59__length2) + i] = (gint) NIBBLES_GAME_WARPCHAR;
#line 280 "../src/nibbles-game.vala"
									g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_WARP_ADDED_SIGNAL], 0, (guint8) (j - 1), (guint8) (i - 1));
#line 281 "../src/nibbles-game.vala"
									break;
#line 1619 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 'r':
#line 177 "../src/nibbles-game.vala"
								case 's':
#line 177 "../src/nibbles-game.vala"
								case 't':
#line 177 "../src/nibbles-game.vala"
								case 'u':
#line 177 "../src/nibbles-game.vala"
								case 'v':
#line 177 "../src/nibbles-game.vala"
								case 'w':
#line 177 "../src/nibbles-game.vala"
								case 'x':
#line 177 "../src/nibbles-game.vala"
								case 'y':
#line 177 "../src/nibbles-game.vala"
								case 'z':
#line 1639 "nibbles-game.c"
								{
									WarpManager* _tmp60_;
									gint* _tmp61_;
									gint _tmp61__length1;
									gint _tmp61__length2;
#line 293 "../src/nibbles-game.vala"
									_tmp60_ = self->priv->warp_manager;
#line 293 "../src/nibbles-game.vala"
									warp_manager_add_warp_target (_tmp60_, (((gint) char_value) - ((gint) 'a')) + ((gint) 'A'), j, i);
#line 294 "../src/nibbles-game.vala"
									_tmp61_ = self->board;
#line 294 "../src/nibbles-game.vala"
									_tmp61__length1 = self->board_length1;
#line 294 "../src/nibbles-game.vala"
									_tmp61__length2 = self->board_length2;
#line 294 "../src/nibbles-game.vala"
									_tmp61_[(j * _tmp61__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 295 "../src/nibbles-game.vala"
									break;
#line 1659 "nibbles-game.c"
								}
#line 177 "../src/nibbles-game.vala"
								case 'a':
#line 177 "../src/nibbles-game.vala"
								case 'b':
#line 177 "../src/nibbles-game.vala"
								case 'c':
#line 177 "../src/nibbles-game.vala"
								case 'd':
#line 177 "../src/nibbles-game.vala"
								case 'e':
#line 177 "../src/nibbles-game.vala"
								case 'f':
#line 177 "../src/nibbles-game.vala"
								case 'g':
#line 177 "../src/nibbles-game.vala"
								case 'h':
#line 177 "../src/nibbles-game.vala"
								case 'i':
#line 177 "../src/nibbles-game.vala"
								case 'j':
#line 177 "../src/nibbles-game.vala"
								case 'k':
#line 177 "../src/nibbles-game.vala"
								case 'l':
#line 1685 "nibbles-game.c"
								{
									gint* _tmp62_;
									gint _tmp62__length1;
									gint _tmp62__length2;
#line 310 "../src/nibbles-game.vala"
									_tmp62_ = self->board;
#line 310 "../src/nibbles-game.vala"
									_tmp62__length1 = self->board_length1;
#line 310 "../src/nibbles-game.vala"
									_tmp62__length2 = self->board_length2;
#line 310 "../src/nibbles-game.vala"
									_tmp62_[(j * _tmp62__length2) + i] = (gint) char_value;
#line 311 "../src/nibbles-game.vala"
									break;
#line 1700 "nibbles-game.c"
								}
								default:
								{
#line 314 "../src/nibbles-game.vala"
									result = FALSE;
#line 314 "../src/nibbles-game.vala"
									_g_free0 (tmpboard);
#line 314 "../src/nibbles-game.vala"
									return result;
#line 1710 "nibbles-game.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 318 "../src/nibbles-game.vala"
	result = TRUE;
#line 318 "../src/nibbles-game.vala"
	_g_free0 (tmpboard);
#line 318 "../src/nibbles-game.vala"
	return result;
#line 1725 "nibbles-game.c"
}

static gboolean
__lambda11_ (NibblesGame* self)
{
	gboolean result;
#line 334 "../src/nibbles-game.vala"
	self->priv->bonus_cycle = (guint8) ((self->priv->bonus_cycle + 1) % 3);
#line 335 "../src/nibbles-game.vala"
	if (((gint) self->priv->bonus_cycle) == 0) {
#line 336 "../src/nibbles-game.vala"
		nibbles_game_add_bonus (self, FALSE);
#line 1738 "nibbles-game.c"
	}
#line 337 "../src/nibbles-game.vala"
	result = nibbles_game_main_loop_cb (self);
#line 337 "../src/nibbles-game.vala"
	return result;
#line 1744 "nibbles-game.c"
}

static gboolean
___lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda11_ ((NibblesGame*) self);
#line 333 "../src/nibbles-game.vala"
	return result;
#line 1754 "nibbles-game.c"
}

void
nibbles_game_start (NibblesGame* self,
                    gboolean add_initial_bonus)
{
	gint _tmp0_;
	gint _tmp1_;
#line 326 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 328 "../src/nibbles-game.vala"
	if (add_initial_bonus) {
#line 329 "../src/nibbles-game.vala"
		nibbles_game_add_bonus (self, TRUE);
#line 1769 "nibbles-game.c"
	}
#line 331 "../src/nibbles-game.vala"
	nibbles_game_set_is_running (self, TRUE);
#line 333 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_gamedelay;
#line 333 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_speed;
#line 333 "../src/nibbles-game.vala"
	self->priv->main_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (_tmp0_ * _tmp1_), ___lambda11__gsource_func, g_object_ref (self), g_object_unref);
#line 339 "../src/nibbles-game.vala"
	g_source_set_name_by_id (self->priv->main_id, "[Nibbles] main_loop_cb");
#line 1781 "nibbles-game.c"
}

void
nibbles_game_stop (NibblesGame* self)
{
#line 342 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 344 "../src/nibbles-game.vala"
	nibbles_game_set_is_running (self, FALSE);
#line 346 "../src/nibbles-game.vala"
	if (self->priv->main_id == ((guint) 0)) {
#line 347 "../src/nibbles-game.vala"
		return;
#line 1795 "nibbles-game.c"
	}
#line 348 "../src/nibbles-game.vala"
	g_source_remove (self->priv->main_id);
#line 349 "../src/nibbles-game.vala"
	self->priv->main_id = (guint) 0;
#line 1801 "nibbles-game.c"
}

inline void
nibbles_game_reset (NibblesGame* self,
                    gint start_level)
{
#line 352 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 354 "../src/nibbles-game.vala"
	nibbles_game_set_skip_score (self, start_level != 1);
#line 355 "../src/nibbles-game.vala"
	nibbles_game_set_current_level (self, start_level);
#line 356 "../src/nibbles-game.vala"
	nibbles_game_set_is_paused (self, FALSE);
#line 1816 "nibbles-game.c"
}

static void
nibbles_game_end (NibblesGame* self)
{
#line 359 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 361 "../src/nibbles-game.vala"
	nibbles_game_stop (self);
#line 362 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL], 0);
#line 1828 "nibbles-game.c"
}

static gboolean
_game_status_equal (const GameStatus * s1,
                    const GameStatus * s2)
{
#line 369 "../src/nibbles-game.vala"
	if (s1 == s2) {
#line 369 "../src/nibbles-game.vala"
		return TRUE;
#line 1839 "nibbles-game.c"
	}
#line 369 "../src/nibbles-game.vala"
	if (s1 == NULL) {
#line 369 "../src/nibbles-game.vala"
		return FALSE;
#line 1845 "nibbles-game.c"
	}
#line 369 "../src/nibbles-game.vala"
	if (s2 == NULL) {
#line 369 "../src/nibbles-game.vala"
		return FALSE;
#line 1851 "nibbles-game.c"
	}
#line 369 "../src/nibbles-game.vala"
	return (*s1) == (*s2);
#line 1855 "nibbles-game.c"
}

static gboolean
nibbles_game_main_loop_cb (NibblesGame* self)
{
	GameStatus* status = NULL;
	GameStatus* _tmp0_;
	GameStatus* _tmp1_;
	GameStatus _tmp2_;
	gboolean result;
#line 365 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 367 "../src/nibbles-game.vala"
	_tmp0_ = nibbles_game_get_game_status (self);
#line 367 "../src/nibbles-game.vala"
	status = _tmp0_;
#line 369 "../src/nibbles-game.vala"
	_tmp1_ = status;
#line 369 "../src/nibbles-game.vala"
	_tmp2_ = GAME_STATUS_GAMEOVER;
#line 369 "../src/nibbles-game.vala"
	if (_game_status_equal (_tmp1_, &_tmp2_) == TRUE) {
#line 1878 "nibbles-game.c"
		GeeLinkedList* _tmp3_;
		gpointer _tmp4_;
		Worm* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 371 "../src/nibbles-game.vala"
		nibbles_game_end (self);
#line 373 "../src/nibbles-game.vala"
		_tmp3_ = self->priv->_worms;
#line 373 "../src/nibbles-game.vala"
		_tmp4_ = gee_linked_list_first (_tmp3_);
#line 373 "../src/nibbles-game.vala"
		_tmp5_ = (Worm*) _tmp4_;
#line 373 "../src/nibbles-game.vala"
		_tmp6_ = worm_get_score (_tmp5_);
#line 373 "../src/nibbles-game.vala"
		_tmp7_ = _tmp6_;
#line 373 "../src/nibbles-game.vala"
		_tmp8_ = self->priv->_current_level;
#line 373 "../src/nibbles-game.vala"
		g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp7_, _tmp8_);
#line 373 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp5_);
#line 375 "../src/nibbles-game.vala"
		result = G_SOURCE_REMOVE;
#line 375 "../src/nibbles-game.vala"
		_g_free0 (status);
#line 375 "../src/nibbles-game.vala"
		return result;
#line 1909 "nibbles-game.c"
	} else {
		GameStatus* _tmp9_;
		GameStatus _tmp10_;
#line 377 "../src/nibbles-game.vala"
		_tmp9_ = status;
#line 377 "../src/nibbles-game.vala"
		_tmp10_ = GAME_STATUS_VICTORY;
#line 377 "../src/nibbles-game.vala"
		if (_game_status_equal (_tmp9_, &_tmp10_) == TRUE) {
#line 1919 "nibbles-game.c"
			Worm* winner = NULL;
			Worm* _tmp11_;
			Worm* _tmp12_;
			Worm* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
#line 379 "../src/nibbles-game.vala"
			nibbles_game_end (self);
#line 381 "../src/nibbles-game.vala"
			_tmp11_ = nibbles_game_get_winner (self);
#line 381 "../src/nibbles-game.vala"
			winner = _tmp11_;
#line 382 "../src/nibbles-game.vala"
			_tmp12_ = winner;
#line 382 "../src/nibbles-game.vala"
			if (_tmp12_ == NULL) {
#line 383 "../src/nibbles-game.vala"
				result = G_SOURCE_REMOVE;
#line 383 "../src/nibbles-game.vala"
				_g_object_unref0 (winner);
#line 383 "../src/nibbles-game.vala"
				_g_free0 (status);
#line 383 "../src/nibbles-game.vala"
				return result;
#line 1945 "nibbles-game.c"
			}
#line 385 "../src/nibbles-game.vala"
			_tmp13_ = winner;
#line 385 "../src/nibbles-game.vala"
			_tmp14_ = worm_get_score (_tmp13_);
#line 385 "../src/nibbles-game.vala"
			_tmp15_ = _tmp14_;
#line 385 "../src/nibbles-game.vala"
			_tmp16_ = self->priv->_current_level;
#line 385 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp15_, _tmp16_);
#line 387 "../src/nibbles-game.vala"
			result = G_SOURCE_REMOVE;
#line 387 "../src/nibbles-game.vala"
			_g_object_unref0 (winner);
#line 387 "../src/nibbles-game.vala"
			_g_free0 (status);
#line 387 "../src/nibbles-game.vala"
			return result;
#line 1965 "nibbles-game.c"
		} else {
			GameStatus* _tmp17_;
			GameStatus _tmp18_;
#line 389 "../src/nibbles-game.vala"
			_tmp17_ = status;
#line 389 "../src/nibbles-game.vala"
			_tmp18_ = GAME_STATUS_NEWROUND;
#line 389 "../src/nibbles-game.vala"
			if (_game_status_equal (_tmp17_, &_tmp18_) == TRUE) {
#line 1975 "nibbles-game.c"
				gint _tmp19_;
				gint _tmp20_;
#line 391 "../src/nibbles-game.vala"
				nibbles_game_stop (self);
#line 393 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL], 0);
#line 394 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL], 0);
#line 396 "../src/nibbles-game.vala"
				_tmp19_ = self->priv->_current_level;
#line 396 "../src/nibbles-game.vala"
				nibbles_game_set_current_level (self, _tmp19_ + 1);
#line 398 "../src/nibbles-game.vala"
				_tmp20_ = self->priv->_current_level;
#line 398 "../src/nibbles-game.vala"
				if (_tmp20_ == (NIBBLES_GAME_MAX_LEVEL + 1)) {
#line 1992 "nibbles-game.c"
					GeeLinkedList* _tmp21_;
					gpointer _tmp22_;
					Worm* _tmp23_;
					gint _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
#line 399 "../src/nibbles-game.vala"
					_tmp21_ = self->priv->_worms;
#line 399 "../src/nibbles-game.vala"
					_tmp22_ = gee_linked_list_first (_tmp21_);
#line 399 "../src/nibbles-game.vala"
					_tmp23_ = (Worm*) _tmp22_;
#line 399 "../src/nibbles-game.vala"
					_tmp24_ = worm_get_score (_tmp23_);
#line 399 "../src/nibbles-game.vala"
					_tmp25_ = _tmp24_;
#line 399 "../src/nibbles-game.vala"
					_tmp26_ = self->priv->_current_level;
#line 399 "../src/nibbles-game.vala"
					g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp25_, _tmp26_);
#line 399 "../src/nibbles-game.vala"
					_g_object_unref0 (_tmp23_);
#line 2015 "nibbles-game.c"
				}
#line 401 "../src/nibbles-game.vala"
				result = G_SOURCE_REMOVE;
#line 401 "../src/nibbles-game.vala"
				_g_free0 (status);
#line 401 "../src/nibbles-game.vala"
				return result;
#line 2023 "nibbles-game.c"
			}
		}
	}
#line 403 "../src/nibbles-game.vala"
	nibbles_game_move_worms (self);
#line 405 "../src/nibbles-game.vala"
	result = G_SOURCE_CONTINUE;
#line 405 "../src/nibbles-game.vala"
	_g_free0 (status);
#line 405 "../src/nibbles-game.vala"
	return result;
#line 2035 "nibbles-game.c"
}

static GeeList*
_nibbles_game_get_other_worms_worm_get_other_worms_type (Worm* _self_,
                                                         gpointer self)
{
	GeeList* result;
	result = nibbles_game_get_other_worms ((NibblesGame*) self, _self_);
#line 419 "../src/nibbles-game.vala"
	return result;
#line 2046 "nibbles-game.c"
}

static GeeList*
_nibbles_game_get_bonuses_worm_get_bonuses_type (gpointer self)
{
	GeeList* result;
	result = nibbles_game_get_bonuses ((NibblesGame*) self);
#line 419 "../src/nibbles-game.vala"
	return result;
#line 2056 "nibbles-game.c"
}

static void
_nibbles_game_bonus_found_cb_worm_bonus_found (Worm* _sender,
                                               gpointer self)
{
#line 420 "../src/nibbles-game.vala"
	nibbles_game_bonus_found_cb ((NibblesGame*) self, _sender);
#line 2065 "nibbles-game.c"
}

void
nibbles_game_create_worms (NibblesGame* self,
                           GeeArrayList* worm_settings)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 412 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 414 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worms;
#line 414 "../src/nibbles-game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 416 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_numai;
#line 416 "../src/nibbles-game.vala"
	_tmp2_ = self->priv->_numhumans;
#line 416 "../src/nibbles-game.vala"
	nibbles_game_set_numworms (self, _tmp1_ + _tmp2_);
#line 2087 "nibbles-game.c"
	{
		gint i = 0;
#line 417 "../src/nibbles-game.vala"
		i = 0;
#line 2092 "nibbles-game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 417 "../src/nibbles-game.vala"
			_tmp3_ = TRUE;
#line 417 "../src/nibbles-game.vala"
			while (TRUE) {
#line 2099 "nibbles-game.c"
				gint _tmp5_;
				Worm* worm = NULL;
				guint8 _tmp6_;
				guint8 _tmp7_;
				Worm* _tmp8_;
				Worm* _tmp9_;
				Worm* _tmp10_;
				gint _tmp11_;
				GeeLinkedList* _tmp12_;
				Worm* _tmp13_;
#line 417 "../src/nibbles-game.vala"
				if (!_tmp3_) {
#line 2112 "nibbles-game.c"
					gint _tmp4_;
#line 417 "../src/nibbles-game.vala"
					_tmp4_ = i;
#line 417 "../src/nibbles-game.vala"
					i = _tmp4_ + 1;
#line 2118 "nibbles-game.c"
				}
#line 417 "../src/nibbles-game.vala"
				_tmp3_ = FALSE;
#line 417 "../src/nibbles-game.vala"
				_tmp5_ = self->priv->_numworms;
#line 417 "../src/nibbles-game.vala"
				if (!(i < _tmp5_)) {
#line 417 "../src/nibbles-game.vala"
					break;
#line 2128 "nibbles-game.c"
				}
#line 419 "../src/nibbles-game.vala"
				_tmp6_ = self->priv->_width;
#line 419 "../src/nibbles-game.vala"
				_tmp7_ = self->priv->_height;
#line 419 "../src/nibbles-game.vala"
				_tmp8_ = worm_new (i, _tmp6_, _tmp7_, _nibbles_game_get_other_worms_worm_get_other_worms_type, self, _nibbles_game_get_bonuses_worm_get_bonuses_type, self);
#line 419 "../src/nibbles-game.vala"
				worm = _tmp8_;
#line 420 "../src/nibbles-game.vala"
				_tmp9_ = worm;
#line 420 "../src/nibbles-game.vala"
				g_signal_connect_object (_tmp9_, "bonus-found", (GCallback) _nibbles_game_bonus_found_cb_worm_bonus_found, self, 0);
#line 421 "../src/nibbles-game.vala"
				_tmp10_ = worm;
#line 421 "../src/nibbles-game.vala"
				_tmp11_ = self->priv->_numhumans;
#line 421 "../src/nibbles-game.vala"
				_tmp10_->is_human = i < _tmp11_;
#line 422 "../src/nibbles-game.vala"
				_tmp12_ = self->priv->_worms;
#line 422 "../src/nibbles-game.vala"
				_tmp13_ = worm;
#line 422 "../src/nibbles-game.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 417 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 2156 "nibbles-game.c"
			}
		}
	}
#line 424 "../src/nibbles-game.vala"
	if (worm_settings != NULL) {
#line 425 "../src/nibbles-game.vala"
		nibbles_game_load_worm_properties (self, worm_settings);
#line 2164 "nibbles-game.c"
	}
}

void
nibbles_game_add_worms (NibblesGame* self)
{
#line 429 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 2173 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 431 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 431 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 431 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 431 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 431 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 431 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 431 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 431 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2198 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
#line 431 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 431 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 431 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 431 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 431 "../src/nibbles-game.vala"
				break;
#line 2215 "nibbles-game.c"
			}
#line 431 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 431 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 431 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 432 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 432 "../src/nibbles-game.vala"
			worm_spawn (_tmp8_);
#line 431 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2229 "nibbles-game.c"
		}
	}
}

static void
nibbles_game_move_worms (NibblesGame* self)
{
	Boni* _tmp13_;
	guint8 missed_bonuses_to_replace = 0U;
	Boni* _tmp28_;
	guint8 _tmp29_ = 0U;
	GeeLinkedList* dead_worms = NULL;
	GeeLinkedList* _tmp32_;
#line 435 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 2245 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 437 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 437 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 437 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 437 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 437 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 437 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 437 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 437 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2270 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			Worm* _tmp10_;
#line 437 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 437 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 437 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 437 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 437 "../src/nibbles-game.vala"
				break;
#line 2288 "nibbles-game.c"
			}
#line 437 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 437 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 437 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 439 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 439 "../src/nibbles-game.vala"
			if (_tmp8_->rounds_to_stay_still == 1) {
#line 2300 "nibbles-game.c"
				Worm* _tmp9_;
#line 440 "../src/nibbles-game.vala"
				_tmp9_ = worm;
#line 440 "../src/nibbles-game.vala"
				_tmp9_->is_stopped = FALSE;
#line 2306 "nibbles-game.c"
			}
#line 441 "../src/nibbles-game.vala"
			_tmp10_ = worm;
#line 441 "../src/nibbles-game.vala"
			if (_tmp10_->rounds_to_stay_still > 0) {
#line 2312 "nibbles-game.c"
				Worm* _tmp11_;
				gint _tmp12_;
#line 442 "../src/nibbles-game.vala"
				_tmp11_ = worm;
#line 442 "../src/nibbles-game.vala"
				_tmp11_->rounds_to_stay_still = _tmp11_->rounds_to_stay_still - 1;
#line 442 "../src/nibbles-game.vala"
				_tmp12_ = _tmp11_->rounds_to_stay_still;
#line 2321 "nibbles-game.c"
			}
#line 437 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2325 "nibbles-game.c"
		}
	}
#line 445 "../src/nibbles-game.vala"
	_tmp13_ = self->priv->boni;
#line 445 "../src/nibbles-game.vala"
	if (boni_too_many_missed (_tmp13_)) {
#line 2332 "nibbles-game.c"
		{
			GeeLinkedList* _worm_list = NULL;
			GeeLinkedList* _tmp14_;
			gint _worm_size = 0;
			GeeLinkedList* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			gint _worm_index = 0;
#line 447 "../src/nibbles-game.vala"
			_tmp14_ = self->priv->_worms;
#line 447 "../src/nibbles-game.vala"
			_worm_list = _tmp14_;
#line 447 "../src/nibbles-game.vala"
			_tmp15_ = _worm_list;
#line 447 "../src/nibbles-game.vala"
			_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 447 "../src/nibbles-game.vala"
			_tmp17_ = _tmp16_;
#line 447 "../src/nibbles-game.vala"
			_worm_size = _tmp17_;
#line 447 "../src/nibbles-game.vala"
			_worm_index = -1;
#line 447 "../src/nibbles-game.vala"
			while (TRUE) {
#line 2357 "nibbles-game.c"
				gint _tmp18_;
				gint _tmp19_;
				Worm* worm = NULL;
				GeeLinkedList* _tmp20_;
				gpointer _tmp21_;
				Worm* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
#line 447 "../src/nibbles-game.vala"
				_worm_index = _worm_index + 1;
#line 447 "../src/nibbles-game.vala"
				_tmp18_ = _worm_index;
#line 447 "../src/nibbles-game.vala"
				_tmp19_ = _worm_size;
#line 447 "../src/nibbles-game.vala"
				if (!(_tmp18_ < _tmp19_)) {
#line 447 "../src/nibbles-game.vala"
					break;
#line 2376 "nibbles-game.c"
				}
#line 447 "../src/nibbles-game.vala"
				_tmp20_ = _worm_list;
#line 447 "../src/nibbles-game.vala"
				_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _worm_index);
#line 447 "../src/nibbles-game.vala"
				worm = (Worm*) _tmp21_;
#line 449 "../src/nibbles-game.vala"
				_tmp22_ = worm;
#line 449 "../src/nibbles-game.vala"
				_tmp23_ = worm_get_score (_tmp22_);
#line 449 "../src/nibbles-game.vala"
				_tmp24_ = _tmp23_;
#line 449 "../src/nibbles-game.vala"
				if (_tmp24_ > 0) {
#line 2392 "nibbles-game.c"
					Worm* _tmp25_;
					gint _tmp26_;
					gint _tmp27_;
#line 450 "../src/nibbles-game.vala"
					_tmp25_ = worm;
#line 450 "../src/nibbles-game.vala"
					_tmp26_ = worm_get_score (_tmp25_);
#line 450 "../src/nibbles-game.vala"
					_tmp27_ = _tmp26_;
#line 450 "../src/nibbles-game.vala"
					worm_set_score (_tmp25_, _tmp27_ - 1);
#line 2404 "nibbles-game.c"
				}
#line 447 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 2408 "nibbles-game.c"
			}
		}
	}
#line 455 "../src/nibbles-game.vala"
	_tmp28_ = self->priv->boni;
#line 455 "../src/nibbles-game.vala"
	boni_on_worms_move (_tmp28_, &_tmp29_);
#line 455 "../src/nibbles-game.vala"
	missed_bonuses_to_replace = _tmp29_;
#line 2418 "nibbles-game.c"
	{
		guint8 i = 0U;
#line 456 "../src/nibbles-game.vala"
		i = (guint8) 0;
#line 2423 "nibbles-game.c"
		{
			gboolean _tmp30_ = FALSE;
#line 456 "../src/nibbles-game.vala"
			_tmp30_ = TRUE;
#line 456 "../src/nibbles-game.vala"
			while (TRUE) {
#line 456 "../src/nibbles-game.vala"
				if (!_tmp30_) {
#line 2432 "nibbles-game.c"
					guint8 _tmp31_;
#line 456 "../src/nibbles-game.vala"
					_tmp31_ = i;
#line 456 "../src/nibbles-game.vala"
					i = _tmp31_ + 1;
#line 2438 "nibbles-game.c"
				}
#line 456 "../src/nibbles-game.vala"
				_tmp30_ = FALSE;
#line 456 "../src/nibbles-game.vala"
				if (!(i < missed_bonuses_to_replace)) {
#line 456 "../src/nibbles-game.vala"
					break;
#line 2446 "nibbles-game.c"
				}
#line 457 "../src/nibbles-game.vala"
				nibbles_game_add_bonus (self, TRUE);
#line 2450 "nibbles-game.c"
			}
		}
	}
#line 459 "../src/nibbles-game.vala"
	_tmp32_ = gee_linked_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 459 "../src/nibbles-game.vala"
	dead_worms = _tmp32_;
#line 2458 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp33_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp34_;
		gint _tmp35_;
		gint _tmp36_;
		gint _worm_index = 0;
#line 462 "../src/nibbles-game.vala"
		_tmp33_ = self->priv->_worms;
#line 462 "../src/nibbles-game.vala"
		_worm_list = _tmp33_;
#line 462 "../src/nibbles-game.vala"
		_tmp34_ = _worm_list;
#line 462 "../src/nibbles-game.vala"
		_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
#line 462 "../src/nibbles-game.vala"
		_tmp36_ = _tmp35_;
#line 462 "../src/nibbles-game.vala"
		_worm_size = _tmp36_;
#line 462 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 462 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2483 "nibbles-game.c"
			gint _tmp37_;
			gint _tmp38_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp39_;
			gpointer _tmp40_;
			gboolean _tmp41_ = FALSE;
			Worm* _tmp42_;
			Worm* _tmp47_;
#line 462 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 462 "../src/nibbles-game.vala"
			_tmp37_ = _worm_index;
#line 462 "../src/nibbles-game.vala"
			_tmp38_ = _worm_size;
#line 462 "../src/nibbles-game.vala"
			if (!(_tmp37_ < _tmp38_)) {
#line 462 "../src/nibbles-game.vala"
				break;
#line 2502 "nibbles-game.c"
			}
#line 462 "../src/nibbles-game.vala"
			_tmp39_ = _worm_list;
#line 462 "../src/nibbles-game.vala"
			_tmp40_ = gee_abstract_list_get ((GeeAbstractList*) _tmp39_, _worm_index);
#line 462 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp40_;
#line 464 "../src/nibbles-game.vala"
			_tmp42_ = worm;
#line 464 "../src/nibbles-game.vala"
			if (_tmp42_->is_stopped) {
#line 464 "../src/nibbles-game.vala"
				_tmp41_ = TRUE;
#line 2516 "nibbles-game.c"
			} else {
				Worm* _tmp43_;
				WormPositions* _tmp44_;
				gboolean _tmp45_;
				gboolean _tmp46_;
#line 465 "../src/nibbles-game.vala"
				_tmp43_ = worm;
#line 465 "../src/nibbles-game.vala"
				_tmp44_ = _tmp43_->list;
#line 465 "../src/nibbles-game.vala"
				_tmp45_ = gee_collection_get_is_empty ((GeeCollection*) _tmp44_);
#line 465 "../src/nibbles-game.vala"
				_tmp46_ = _tmp45_;
#line 465 "../src/nibbles-game.vala"
				_tmp41_ = _tmp46_;
#line 2532 "nibbles-game.c"
			}
#line 464 "../src/nibbles-game.vala"
			if (_tmp41_) {
#line 466 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 466 "../src/nibbles-game.vala"
				continue;
#line 2540 "nibbles-game.c"
			}
#line 468 "../src/nibbles-game.vala"
			_tmp47_ = worm;
#line 468 "../src/nibbles-game.vala"
			if (!_tmp47_->is_human) {
#line 2546 "nibbles-game.c"
				Worm* _tmp48_;
				gint* _tmp49_;
				gint _tmp49__length1;
				gint _tmp49__length2;
				GeeLinkedList* _tmp50_;
#line 469 "../src/nibbles-game.vala"
				_tmp48_ = worm;
#line 469 "../src/nibbles-game.vala"
				_tmp49_ = self->board;
#line 469 "../src/nibbles-game.vala"
				_tmp49__length1 = self->board_length1;
#line 469 "../src/nibbles-game.vala"
				_tmp49__length2 = self->board_length2;
#line 469 "../src/nibbles-game.vala"
				_tmp50_ = self->priv->_worms;
#line 469 "../src/nibbles-game.vala"
				worm_ai_move (_tmp48_, _tmp49_, (gint) _tmp49__length1, (gint) _tmp49__length2, _tmp50_);
#line 2564 "nibbles-game.c"
			}
#line 462 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2568 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp51_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		gint _worm_index = 0;
#line 473 "../src/nibbles-game.vala"
		_tmp51_ = self->priv->_worms;
#line 473 "../src/nibbles-game.vala"
		_worm_list = _tmp51_;
#line 473 "../src/nibbles-game.vala"
		_tmp52_ = _worm_list;
#line 473 "../src/nibbles-game.vala"
		_tmp53_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp52_);
#line 473 "../src/nibbles-game.vala"
		_tmp54_ = _tmp53_;
#line 473 "../src/nibbles-game.vala"
		_worm_size = _tmp54_;
#line 473 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 473 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2595 "nibbles-game.c"
			gint _tmp55_;
			gint _tmp56_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp57_;
			gpointer _tmp58_;
			gboolean _tmp59_ = FALSE;
			Worm* _tmp60_;
			Position position = {0};
			Worm* _tmp65_;
			Position _tmp66_ = {0};
			guint8 target_x = 0U;
			guint8 target_y = 0U;
			gboolean _tmp67_ = FALSE;
			Worm* _tmp68_;
			WormDirection _tmp69_;
			WormDirection _tmp70_;
			WarpManager* _tmp74_;
			Position _tmp75_;
			Position _tmp76_;
			guint8 _tmp77_ = 0U;
			guint8 _tmp78_ = 0U;
			gboolean _tmp79_;
			Worm* _tmp81_;
			gint* _tmp82_;
			gint _tmp82__length1;
			gint _tmp82__length2;
			GeeLinkedList* _tmp83_;
			Position _tmp84_;
#line 473 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 473 "../src/nibbles-game.vala"
			_tmp55_ = _worm_index;
#line 473 "../src/nibbles-game.vala"
			_tmp56_ = _worm_size;
#line 473 "../src/nibbles-game.vala"
			if (!(_tmp55_ < _tmp56_)) {
#line 473 "../src/nibbles-game.vala"
				break;
#line 2634 "nibbles-game.c"
			}
#line 473 "../src/nibbles-game.vala"
			_tmp57_ = _worm_list;
#line 473 "../src/nibbles-game.vala"
			_tmp58_ = gee_abstract_list_get ((GeeAbstractList*) _tmp57_, _worm_index);
#line 473 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp58_;
#line 475 "../src/nibbles-game.vala"
			_tmp60_ = worm;
#line 475 "../src/nibbles-game.vala"
			if (_tmp60_->is_stopped) {
#line 475 "../src/nibbles-game.vala"
				_tmp59_ = TRUE;
#line 2648 "nibbles-game.c"
			} else {
				Worm* _tmp61_;
				WormPositions* _tmp62_;
				gboolean _tmp63_;
				gboolean _tmp64_;
#line 476 "../src/nibbles-game.vala"
				_tmp61_ = worm;
#line 476 "../src/nibbles-game.vala"
				_tmp62_ = _tmp61_->list;
#line 476 "../src/nibbles-game.vala"
				_tmp63_ = gee_collection_get_is_empty ((GeeCollection*) _tmp62_);
#line 476 "../src/nibbles-game.vala"
				_tmp64_ = _tmp63_;
#line 476 "../src/nibbles-game.vala"
				_tmp59_ = _tmp64_;
#line 2664 "nibbles-game.c"
			}
#line 475 "../src/nibbles-game.vala"
			if (_tmp59_) {
#line 477 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 477 "../src/nibbles-game.vala"
				continue;
#line 2672 "nibbles-game.c"
			}
#line 479 "../src/nibbles-game.vala"
			_tmp65_ = worm;
#line 479 "../src/nibbles-game.vala"
			worm_position_move (_tmp65_, &_tmp66_);
#line 479 "../src/nibbles-game.vala"
			position = _tmp66_;
#line 483 "../src/nibbles-game.vala"
			_tmp68_ = worm;
#line 483 "../src/nibbles-game.vala"
			_tmp69_ = worm_get_direction (_tmp68_);
#line 483 "../src/nibbles-game.vala"
			_tmp70_ = _tmp69_;
#line 483 "../src/nibbles-game.vala"
			if (_tmp70_ == WORM_DIRECTION_LEFT) {
#line 483 "../src/nibbles-game.vala"
				_tmp67_ = TRUE;
#line 2690 "nibbles-game.c"
			} else {
				Worm* _tmp71_;
				WormDirection _tmp72_;
				WormDirection _tmp73_;
#line 483 "../src/nibbles-game.vala"
				_tmp71_ = worm;
#line 483 "../src/nibbles-game.vala"
				_tmp72_ = worm_get_direction (_tmp71_);
#line 483 "../src/nibbles-game.vala"
				_tmp73_ = _tmp72_;
#line 483 "../src/nibbles-game.vala"
				_tmp67_ = _tmp73_ == WORM_DIRECTION_RIGHT;
#line 2703 "nibbles-game.c"
			}
#line 482 "../src/nibbles-game.vala"
			_tmp74_ = self->priv->warp_manager;
#line 482 "../src/nibbles-game.vala"
			_tmp75_ = position;
#line 482 "../src/nibbles-game.vala"
			_tmp76_ = position;
#line 482 "../src/nibbles-game.vala"
			_tmp79_ = warp_manager_get_warp_target (_tmp74_, _tmp75_.x, _tmp76_.y, _tmp67_, &_tmp77_, &_tmp78_);
#line 482 "../src/nibbles-game.vala"
			target_x = _tmp77_;
#line 482 "../src/nibbles-game.vala"
			target_y = _tmp78_;
#line 482 "../src/nibbles-game.vala"
			if (_tmp79_) {
#line 2719 "nibbles-game.c"
				Position _tmp80_ = {0};
#line 485 "../src/nibbles-game.vala"
				memset (&_tmp80_, 0, sizeof (Position));
#line 485 "../src/nibbles-game.vala"
				_tmp80_.x = target_x;
#line 485 "../src/nibbles-game.vala"
				_tmp80_.y = target_y;
#line 485 "../src/nibbles-game.vala"
				position = _tmp80_;
#line 2729 "nibbles-game.c"
			}
#line 487 "../src/nibbles-game.vala"
			_tmp81_ = worm;
#line 487 "../src/nibbles-game.vala"
			_tmp82_ = self->board;
#line 487 "../src/nibbles-game.vala"
			_tmp82__length1 = self->board_length1;
#line 487 "../src/nibbles-game.vala"
			_tmp82__length2 = self->board_length2;
#line 487 "../src/nibbles-game.vala"
			_tmp83_ = self->priv->_worms;
#line 487 "../src/nibbles-game.vala"
			_tmp84_ = position;
#line 487 "../src/nibbles-game.vala"
			if (!worm_can_move_to (_tmp81_, _tmp82_, (gint) _tmp82__length1, (gint) _tmp82__length2, _tmp83_, &_tmp84_)) {
#line 2745 "nibbles-game.c"
				GeeLinkedList* _tmp85_;
				Worm* _tmp86_;
#line 489 "../src/nibbles-game.vala"
				_tmp85_ = dead_worms;
#line 489 "../src/nibbles-game.vala"
				_tmp86_ = worm;
#line 489 "../src/nibbles-game.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp85_, _tmp86_);
#line 490 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "crash");
#line 2756 "nibbles-game.c"
			}
#line 473 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2760 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp87_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp88_;
		gint _tmp89_;
		gint _tmp90_;
		gint _worm_index = 0;
#line 495 "../src/nibbles-game.vala"
		_tmp87_ = self->priv->_worms;
#line 495 "../src/nibbles-game.vala"
		_worm_list = _tmp87_;
#line 495 "../src/nibbles-game.vala"
		_tmp88_ = _worm_list;
#line 495 "../src/nibbles-game.vala"
		_tmp89_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp88_);
#line 495 "../src/nibbles-game.vala"
		_tmp90_ = _tmp89_;
#line 495 "../src/nibbles-game.vala"
		_worm_size = _tmp90_;
#line 495 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 495 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2787 "nibbles-game.c"
			gint _tmp91_;
			gint _tmp92_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp93_;
			gpointer _tmp94_;
			gboolean _tmp95_ = FALSE;
			gboolean _tmp96_ = FALSE;
			Worm* _tmp97_;
			Worm* _tmp104_;
			gint* _tmp105_;
			gint _tmp105__length1;
			gint _tmp105__length2;
			Worm* _tmp106_;
			Position _tmp107_ = {0};
			Position _tmp108_;
			Worm* _tmp109_;
			Position _tmp110_ = {0};
			Position _tmp111_;
			gint _tmp112_;
#line 495 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 495 "../src/nibbles-game.vala"
			_tmp91_ = _worm_index;
#line 495 "../src/nibbles-game.vala"
			_tmp92_ = _worm_size;
#line 495 "../src/nibbles-game.vala"
			if (!(_tmp91_ < _tmp92_)) {
#line 495 "../src/nibbles-game.vala"
				break;
#line 2817 "nibbles-game.c"
			}
#line 495 "../src/nibbles-game.vala"
			_tmp93_ = _worm_list;
#line 495 "../src/nibbles-game.vala"
			_tmp94_ = gee_abstract_list_get ((GeeAbstractList*) _tmp93_, _worm_index);
#line 495 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp94_;
#line 497 "../src/nibbles-game.vala"
			_tmp97_ = worm;
#line 497 "../src/nibbles-game.vala"
			if (_tmp97_->is_stopped) {
#line 497 "../src/nibbles-game.vala"
				_tmp96_ = TRUE;
#line 2831 "nibbles-game.c"
			} else {
				Worm* _tmp98_;
				WormPositions* _tmp99_;
				gboolean _tmp100_;
				gboolean _tmp101_;
#line 498 "../src/nibbles-game.vala"
				_tmp98_ = worm;
#line 498 "../src/nibbles-game.vala"
				_tmp99_ = _tmp98_->list;
#line 498 "../src/nibbles-game.vala"
				_tmp100_ = gee_collection_get_is_empty ((GeeCollection*) _tmp99_);
#line 498 "../src/nibbles-game.vala"
				_tmp101_ = _tmp100_;
#line 498 "../src/nibbles-game.vala"
				_tmp96_ = _tmp101_;
#line 2847 "nibbles-game.c"
			}
#line 497 "../src/nibbles-game.vala"
			if (_tmp96_) {
#line 497 "../src/nibbles-game.vala"
				_tmp95_ = TRUE;
#line 2853 "nibbles-game.c"
			} else {
				GeeLinkedList* _tmp102_;
				Worm* _tmp103_;
#line 499 "../src/nibbles-game.vala"
				_tmp102_ = dead_worms;
#line 499 "../src/nibbles-game.vala"
				_tmp103_ = worm;
#line 499 "../src/nibbles-game.vala"
				_tmp95_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp102_, _tmp103_);
#line 2863 "nibbles-game.c"
			}
#line 497 "../src/nibbles-game.vala"
			if (_tmp95_) {
#line 500 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 500 "../src/nibbles-game.vala"
				continue;
#line 2871 "nibbles-game.c"
			}
#line 502 "../src/nibbles-game.vala"
			_tmp104_ = worm;
#line 502 "../src/nibbles-game.vala"
			worm_move_part_1 (_tmp104_);
#line 503 "../src/nibbles-game.vala"
			_tmp105_ = self->board;
#line 503 "../src/nibbles-game.vala"
			_tmp105__length1 = self->board_length1;
#line 503 "../src/nibbles-game.vala"
			_tmp105__length2 = self->board_length2;
#line 503 "../src/nibbles-game.vala"
			_tmp106_ = worm;
#line 503 "../src/nibbles-game.vala"
			worm_get_head (_tmp106_, &_tmp107_);
#line 503 "../src/nibbles-game.vala"
			_tmp108_ = _tmp107_;
#line 503 "../src/nibbles-game.vala"
			_tmp109_ = worm;
#line 503 "../src/nibbles-game.vala"
			worm_get_head (_tmp109_, &_tmp110_);
#line 503 "../src/nibbles-game.vala"
			_tmp111_ = _tmp110_;
#line 503 "../src/nibbles-game.vala"
			_tmp112_ = _tmp105_[(_tmp108_.x * _tmp105__length2) + _tmp111_.y];
#line 503 "../src/nibbles-game.vala"
			if (_tmp112_ == ((gint) NIBBLES_GAME_WARPCHAR)) {
#line 2899 "nibbles-game.c"
				guint8 target_x = 0U;
				guint8 target_y = 0U;
				gboolean _tmp113_ = FALSE;
				Worm* _tmp114_;
				WormDirection _tmp115_;
				WormDirection _tmp116_;
				WarpManager* _tmp120_;
				Worm* _tmp121_;
				Position _tmp122_ = {0};
				Position _tmp123_;
				Worm* _tmp124_;
				Position _tmp125_ = {0};
				Position _tmp126_;
				guint8 _tmp127_ = 0U;
				guint8 _tmp128_ = 0U;
				gboolean _tmp129_;
				Worm* _tmp130_;
				Position _tmp131_ = {0};
#line 508 "../src/nibbles-game.vala"
				_tmp114_ = worm;
#line 508 "../src/nibbles-game.vala"
				_tmp115_ = worm_get_direction (_tmp114_);
#line 508 "../src/nibbles-game.vala"
				_tmp116_ = _tmp115_;
#line 508 "../src/nibbles-game.vala"
				if (_tmp116_ == WORM_DIRECTION_LEFT) {
#line 508 "../src/nibbles-game.vala"
					_tmp113_ = TRUE;
#line 2928 "nibbles-game.c"
				} else {
					Worm* _tmp117_;
					WormDirection _tmp118_;
					WormDirection _tmp119_;
#line 508 "../src/nibbles-game.vala"
					_tmp117_ = worm;
#line 508 "../src/nibbles-game.vala"
					_tmp118_ = worm_get_direction (_tmp117_);
#line 508 "../src/nibbles-game.vala"
					_tmp119_ = _tmp118_;
#line 508 "../src/nibbles-game.vala"
					_tmp113_ = _tmp119_ == WORM_DIRECTION_RIGHT;
#line 2941 "nibbles-game.c"
				}
#line 507 "../src/nibbles-game.vala"
				_tmp120_ = self->priv->warp_manager;
#line 507 "../src/nibbles-game.vala"
				_tmp121_ = worm;
#line 507 "../src/nibbles-game.vala"
				worm_get_head (_tmp121_, &_tmp122_);
#line 507 "../src/nibbles-game.vala"
				_tmp123_ = _tmp122_;
#line 507 "../src/nibbles-game.vala"
				_tmp124_ = worm;
#line 507 "../src/nibbles-game.vala"
				worm_get_head (_tmp124_, &_tmp125_);
#line 507 "../src/nibbles-game.vala"
				_tmp126_ = _tmp125_;
#line 507 "../src/nibbles-game.vala"
				_tmp129_ = warp_manager_get_warp_target (_tmp120_, _tmp123_.x, _tmp126_.y, _tmp113_, &_tmp127_, &_tmp128_);
#line 507 "../src/nibbles-game.vala"
				target_x = _tmp127_;
#line 507 "../src/nibbles-game.vala"
				target_y = _tmp128_;
#line 507 "../src/nibbles-game.vala"
				if (!_tmp129_) {
#line 510 "../src/nibbles-game.vala"
					g_assert_not_reached ();
#line 2967 "nibbles-game.c"
				}
#line 512 "../src/nibbles-game.vala"
				_tmp130_ = worm;
#line 512 "../src/nibbles-game.vala"
				memset (&_tmp131_, 0, sizeof (Position));
#line 512 "../src/nibbles-game.vala"
				_tmp131_.x = target_x;
#line 512 "../src/nibbles-game.vala"
				_tmp131_.y = target_y;
#line 512 "../src/nibbles-game.vala"
				worm_move_part_2 (_tmp130_, &_tmp131_);
#line 2979 "nibbles-game.c"
			} else {
				Worm* _tmp132_;
#line 515 "../src/nibbles-game.vala"
				_tmp132_ = worm;
#line 515 "../src/nibbles-game.vala"
				worm_move_part_2 (_tmp132_, NULL);
#line 2986 "nibbles-game.c"
			}
			{
				GeeLinkedList* _other_worm_list = NULL;
				GeeLinkedList* _tmp133_;
				gint _other_worm_size = 0;
				GeeLinkedList* _tmp134_;
				gint _tmp135_;
				gint _tmp136_;
				gint _other_worm_index = 0;
#line 518 "../src/nibbles-game.vala"
				_tmp133_ = self->priv->_worms;
#line 518 "../src/nibbles-game.vala"
				_other_worm_list = _tmp133_;
#line 518 "../src/nibbles-game.vala"
				_tmp134_ = _other_worm_list;
#line 518 "../src/nibbles-game.vala"
				_tmp135_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp134_);
#line 518 "../src/nibbles-game.vala"
				_tmp136_ = _tmp135_;
#line 518 "../src/nibbles-game.vala"
				_other_worm_size = _tmp136_;
#line 518 "../src/nibbles-game.vala"
				_other_worm_index = -1;
#line 518 "../src/nibbles-game.vala"
				while (TRUE) {
#line 3012 "nibbles-game.c"
					gint _tmp137_;
					gint _tmp138_;
					Worm* other_worm = NULL;
					GeeLinkedList* _tmp139_;
					gpointer _tmp140_;
					gboolean _tmp141_ = FALSE;
					gboolean _tmp142_ = FALSE;
					gboolean _tmp143_ = FALSE;
					gboolean _tmp144_ = FALSE;
					Worm* _tmp145_;
					Worm* _tmp146_;
#line 518 "../src/nibbles-game.vala"
					_other_worm_index = _other_worm_index + 1;
#line 518 "../src/nibbles-game.vala"
					_tmp137_ = _other_worm_index;
#line 518 "../src/nibbles-game.vala"
					_tmp138_ = _other_worm_size;
#line 518 "../src/nibbles-game.vala"
					if (!(_tmp137_ < _tmp138_)) {
#line 518 "../src/nibbles-game.vala"
						break;
#line 3034 "nibbles-game.c"
					}
#line 518 "../src/nibbles-game.vala"
					_tmp139_ = _other_worm_list;
#line 518 "../src/nibbles-game.vala"
					_tmp140_ = gee_abstract_list_get ((GeeAbstractList*) _tmp139_, _other_worm_index);
#line 518 "../src/nibbles-game.vala"
					other_worm = (Worm*) _tmp140_;
#line 520 "../src/nibbles-game.vala"
					_tmp145_ = worm;
#line 520 "../src/nibbles-game.vala"
					_tmp146_ = other_worm;
#line 520 "../src/nibbles-game.vala"
					if (_tmp145_ != _tmp146_) {
#line 3048 "nibbles-game.c"
						Worm* _tmp147_;
#line 521 "../src/nibbles-game.vala"
						_tmp147_ = other_worm;
#line 521 "../src/nibbles-game.vala"
						_tmp144_ = !_tmp147_->is_stopped;
#line 3054 "nibbles-game.c"
					} else {
#line 520 "../src/nibbles-game.vala"
						_tmp144_ = FALSE;
#line 3058 "nibbles-game.c"
					}
#line 520 "../src/nibbles-game.vala"
					if (_tmp144_) {
#line 3062 "nibbles-game.c"
						Worm* _tmp148_;
						WormPositions* _tmp149_;
						gboolean _tmp150_;
						gboolean _tmp151_;
#line 522 "../src/nibbles-game.vala"
						_tmp148_ = other_worm;
#line 522 "../src/nibbles-game.vala"
						_tmp149_ = _tmp148_->list;
#line 522 "../src/nibbles-game.vala"
						_tmp150_ = gee_collection_get_is_empty ((GeeCollection*) _tmp149_);
#line 522 "../src/nibbles-game.vala"
						_tmp151_ = _tmp150_;
#line 522 "../src/nibbles-game.vala"
						_tmp143_ = !_tmp151_;
#line 3077 "nibbles-game.c"
					} else {
#line 520 "../src/nibbles-game.vala"
						_tmp143_ = FALSE;
#line 3081 "nibbles-game.c"
					}
#line 520 "../src/nibbles-game.vala"
					if (_tmp143_) {
#line 3085 "nibbles-game.c"
						Worm* _tmp152_;
						Position _tmp153_ = {0};
						Position _tmp154_;
						Worm* _tmp155_;
						Position _tmp156_ = {0};
						Position _tmp157_;
#line 523 "../src/nibbles-game.vala"
						_tmp152_ = worm;
#line 523 "../src/nibbles-game.vala"
						worm_get_head (_tmp152_, &_tmp153_);
#line 523 "../src/nibbles-game.vala"
						_tmp154_ = _tmp153_;
#line 523 "../src/nibbles-game.vala"
						_tmp155_ = other_worm;
#line 523 "../src/nibbles-game.vala"
						worm_get_head (_tmp155_, &_tmp156_);
#line 523 "../src/nibbles-game.vala"
						_tmp157_ = _tmp156_;
#line 523 "../src/nibbles-game.vala"
						_tmp142_ = _tmp154_.x == _tmp157_.x;
#line 3106 "nibbles-game.c"
					} else {
#line 520 "../src/nibbles-game.vala"
						_tmp142_ = FALSE;
#line 3110 "nibbles-game.c"
					}
#line 520 "../src/nibbles-game.vala"
					if (_tmp142_) {
#line 3114 "nibbles-game.c"
						Worm* _tmp158_;
						Position _tmp159_ = {0};
						Position _tmp160_;
						Worm* _tmp161_;
						Position _tmp162_ = {0};
						Position _tmp163_;
#line 524 "../src/nibbles-game.vala"
						_tmp158_ = worm;
#line 524 "../src/nibbles-game.vala"
						worm_get_head (_tmp158_, &_tmp159_);
#line 524 "../src/nibbles-game.vala"
						_tmp160_ = _tmp159_;
#line 524 "../src/nibbles-game.vala"
						_tmp161_ = other_worm;
#line 524 "../src/nibbles-game.vala"
						worm_get_head (_tmp161_, &_tmp162_);
#line 524 "../src/nibbles-game.vala"
						_tmp163_ = _tmp162_;
#line 524 "../src/nibbles-game.vala"
						_tmp141_ = _tmp160_.y == _tmp163_.y;
#line 3135 "nibbles-game.c"
					} else {
#line 520 "../src/nibbles-game.vala"
						_tmp141_ = FALSE;
#line 3139 "nibbles-game.c"
					}
#line 520 "../src/nibbles-game.vala"
					if (_tmp141_) {
#line 3143 "nibbles-game.c"
						GeeLinkedList* _tmp164_;
						Worm* _tmp165_;
						GeeLinkedList* _tmp168_;
						Worm* _tmp169_;
#line 526 "../src/nibbles-game.vala"
						_tmp164_ = dead_worms;
#line 526 "../src/nibbles-game.vala"
						_tmp165_ = worm;
#line 526 "../src/nibbles-game.vala"
						if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp164_, _tmp165_)) {
#line 3154 "nibbles-game.c"
							GeeLinkedList* _tmp166_;
							Worm* _tmp167_;
#line 527 "../src/nibbles-game.vala"
							_tmp166_ = dead_worms;
#line 527 "../src/nibbles-game.vala"
							_tmp167_ = worm;
#line 527 "../src/nibbles-game.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp166_, _tmp167_);
#line 3163 "nibbles-game.c"
						}
#line 528 "../src/nibbles-game.vala"
						_tmp168_ = dead_worms;
#line 528 "../src/nibbles-game.vala"
						_tmp169_ = other_worm;
#line 528 "../src/nibbles-game.vala"
						if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp168_, _tmp169_)) {
#line 3171 "nibbles-game.c"
							GeeLinkedList* _tmp170_;
							Worm* _tmp171_;
#line 529 "../src/nibbles-game.vala"
							_tmp170_ = dead_worms;
#line 529 "../src/nibbles-game.vala"
							_tmp171_ = other_worm;
#line 529 "../src/nibbles-game.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp170_, _tmp171_);
#line 3180 "nibbles-game.c"
						}
					}
#line 518 "../src/nibbles-game.vala"
					_g_object_unref0 (other_worm);
#line 3185 "nibbles-game.c"
				}
			}
#line 495 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 3190 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp172_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp173_;
		gint _tmp174_;
		gint _tmp175_;
		gint _worm_index = 0;
#line 535 "../src/nibbles-game.vala"
		_tmp172_ = dead_worms;
#line 535 "../src/nibbles-game.vala"
		_worm_list = _tmp172_;
#line 535 "../src/nibbles-game.vala"
		_tmp173_ = _worm_list;
#line 535 "../src/nibbles-game.vala"
		_tmp174_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp173_);
#line 535 "../src/nibbles-game.vala"
		_tmp175_ = _tmp174_;
#line 535 "../src/nibbles-game.vala"
		_worm_size = _tmp175_;
#line 535 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 535 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3217 "nibbles-game.c"
			gint _tmp176_;
			gint _tmp177_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp178_;
			gpointer _tmp179_;
			gint _tmp180_;
			Worm* _tmp185_;
			guint8 _tmp186_;
			guint8 _tmp187_;
#line 535 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 535 "../src/nibbles-game.vala"
			_tmp176_ = _worm_index;
#line 535 "../src/nibbles-game.vala"
			_tmp177_ = _worm_size;
#line 535 "../src/nibbles-game.vala"
			if (!(_tmp176_ < _tmp177_)) {
#line 535 "../src/nibbles-game.vala"
				break;
#line 3237 "nibbles-game.c"
			}
#line 535 "../src/nibbles-game.vala"
			_tmp178_ = _worm_list;
#line 535 "../src/nibbles-game.vala"
			_tmp179_ = gee_abstract_list_get ((GeeAbstractList*) _tmp178_, _worm_index);
#line 535 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp179_;
#line 537 "../src/nibbles-game.vala"
			_tmp180_ = self->priv->_numworms;
#line 537 "../src/nibbles-game.vala"
			if (_tmp180_ > 1) {
#line 3249 "nibbles-game.c"
				Worm* _tmp181_;
				Worm* _tmp182_;
				gint _tmp183_;
				gint _tmp184_;
#line 538 "../src/nibbles-game.vala"
				_tmp181_ = worm;
#line 538 "../src/nibbles-game.vala"
				_tmp182_ = worm;
#line 538 "../src/nibbles-game.vala"
				_tmp183_ = worm_get_score (_tmp182_);
#line 538 "../src/nibbles-game.vala"
				_tmp184_ = _tmp183_;
#line 538 "../src/nibbles-game.vala"
				worm_set_score (_tmp181_, (_tmp184_ * 7) / 10);
#line 3264 "nibbles-game.c"
			}
#line 540 "../src/nibbles-game.vala"
			_tmp185_ = worm;
#line 540 "../src/nibbles-game.vala"
			_tmp186_ = worm_get_lives (_tmp185_);
#line 540 "../src/nibbles-game.vala"
			_tmp187_ = _tmp186_;
#line 540 "../src/nibbles-game.vala"
			if (((gint) _tmp187_) > 0) {
#line 3274 "nibbles-game.c"
				Worm* _tmp188_;
#line 541 "../src/nibbles-game.vala"
				_tmp188_ = worm;
#line 541 "../src/nibbles-game.vala"
				worm_reset (_tmp188_);
#line 3280 "nibbles-game.c"
			}
#line 535 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 3284 "nibbles-game.c"
		}
	}
#line 545 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_REDRAW_SIGNAL], 0, TRUE);
#line 435 "../src/nibbles-game.vala"
	_g_object_unref0 (dead_worms);
#line 3291 "nibbles-game.c"
}

static void
nibbles_game_reverse_worms (NibblesGame* self,
                            Worm* worm)
{
#line 548 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 548 "../src/nibbles-game.vala"
	g_return_if_fail (worm != NULL);
#line 3302 "nibbles-game.c"
	{
		GeeLinkedList* _other_worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _other_worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _other_worm_index = 0;
#line 550 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 550 "../src/nibbles-game.vala"
		_other_worm_list = _tmp0_;
#line 550 "../src/nibbles-game.vala"
		_tmp1_ = _other_worm_list;
#line 550 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 550 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 550 "../src/nibbles-game.vala"
		_other_worm_size = _tmp3_;
#line 550 "../src/nibbles-game.vala"
		_other_worm_index = -1;
#line 550 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3327 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* other_worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
#line 550 "../src/nibbles-game.vala"
			_other_worm_index = _other_worm_index + 1;
#line 550 "../src/nibbles-game.vala"
			_tmp4_ = _other_worm_index;
#line 550 "../src/nibbles-game.vala"
			_tmp5_ = _other_worm_size;
#line 550 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 550 "../src/nibbles-game.vala"
				break;
#line 3344 "nibbles-game.c"
			}
#line 550 "../src/nibbles-game.vala"
			_tmp6_ = _other_worm_list;
#line 550 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _other_worm_index);
#line 550 "../src/nibbles-game.vala"
			other_worm = (Worm*) _tmp7_;
#line 551 "../src/nibbles-game.vala"
			_tmp8_ = other_worm;
#line 551 "../src/nibbles-game.vala"
			if (worm != _tmp8_) {
#line 3356 "nibbles-game.c"
				Worm* _tmp9_;
#line 552 "../src/nibbles-game.vala"
				_tmp9_ = other_worm;
#line 552 "../src/nibbles-game.vala"
				worm_reverse (_tmp9_);
#line 3362 "nibbles-game.c"
			}
#line 550 "../src/nibbles-game.vala"
			_g_object_unref0 (other_worm);
#line 3366 "nibbles-game.c"
		}
	}
}

static gboolean
nibbles_game_is_space_empty (NibblesGame* self,
                             guint8 x,
                             guint8 y,
                             gboolean* worms_at,
                             gint worms_at_length1,
                             gint worms_at_length2)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gint* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	gint _tmp12_;
	gboolean result;
#line 559 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 561 "../src/nibbles-game.vala"
	_tmp11_ = self->board;
#line 561 "../src/nibbles-game.vala"
	_tmp11__length1 = self->board_length1;
#line 561 "../src/nibbles-game.vala"
	_tmp11__length2 = self->board_length2;
#line 561 "../src/nibbles-game.vala"
	_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
#line 561 "../src/nibbles-game.vala"
	if (((gint) NIBBLES_GAME_EMPTYCHAR) == _tmp12_) {
#line 3407 "nibbles-game.c"
		gint* _tmp13_;
		gint _tmp13__length1;
		gint _tmp13__length2;
		gint _tmp14_;
#line 561 "../src/nibbles-game.vala"
		_tmp13_ = self->board;
#line 561 "../src/nibbles-game.vala"
		_tmp13__length1 = self->board_length1;
#line 561 "../src/nibbles-game.vala"
		_tmp13__length2 = self->board_length2;
#line 561 "../src/nibbles-game.vala"
		_tmp14_ = _tmp13_[((x + 1) * _tmp13__length2) + (y + 1)];
#line 561 "../src/nibbles-game.vala"
		_tmp10_ = ((gint) NIBBLES_GAME_EMPTYCHAR) == _tmp14_;
#line 3422 "nibbles-game.c"
	} else {
#line 561 "../src/nibbles-game.vala"
		_tmp10_ = FALSE;
#line 3426 "nibbles-game.c"
	}
#line 561 "../src/nibbles-game.vala"
	if (_tmp10_) {
#line 3430 "nibbles-game.c"
		gint* _tmp15_;
		gint _tmp15__length1;
		gint _tmp15__length2;
		gint _tmp16_;
#line 562 "../src/nibbles-game.vala"
		_tmp15_ = self->board;
#line 562 "../src/nibbles-game.vala"
		_tmp15__length1 = self->board_length1;
#line 562 "../src/nibbles-game.vala"
		_tmp15__length2 = self->board_length2;
#line 562 "../src/nibbles-game.vala"
		_tmp16_ = _tmp15_[((x + 1) * _tmp15__length2) + y];
#line 562 "../src/nibbles-game.vala"
		_tmp9_ = ((gint) NIBBLES_GAME_EMPTYCHAR) == _tmp16_;
#line 3445 "nibbles-game.c"
	} else {
#line 561 "../src/nibbles-game.vala"
		_tmp9_ = FALSE;
#line 3449 "nibbles-game.c"
	}
#line 561 "../src/nibbles-game.vala"
	if (_tmp9_) {
#line 3453 "nibbles-game.c"
		gint* _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		gint _tmp18_;
#line 562 "../src/nibbles-game.vala"
		_tmp17_ = self->board;
#line 562 "../src/nibbles-game.vala"
		_tmp17__length1 = self->board_length1;
#line 562 "../src/nibbles-game.vala"
		_tmp17__length2 = self->board_length2;
#line 562 "../src/nibbles-game.vala"
		_tmp18_ = _tmp17_[(x * _tmp17__length2) + (y + 1)];
#line 562 "../src/nibbles-game.vala"
		_tmp8_ = ((gint) NIBBLES_GAME_EMPTYCHAR) == _tmp18_;
#line 3468 "nibbles-game.c"
	} else {
#line 561 "../src/nibbles-game.vala"
		_tmp8_ = FALSE;
#line 3472 "nibbles-game.c"
	}
#line 561 "../src/nibbles-game.vala"
	if (_tmp8_) {
#line 3476 "nibbles-game.c"
		Boni* _tmp19_;
		Bonus* _tmp20_;
		Bonus* _tmp21_;
#line 563 "../src/nibbles-game.vala"
		_tmp19_ = self->priv->boni;
#line 563 "../src/nibbles-game.vala"
		_tmp20_ = boni_get_bonus (_tmp19_, x, y);
#line 563 "../src/nibbles-game.vala"
		_tmp21_ = _tmp20_;
#line 563 "../src/nibbles-game.vala"
		_tmp7_ = _tmp21_ == NULL;
#line 563 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp21_);
#line 3490 "nibbles-game.c"
	} else {
#line 561 "../src/nibbles-game.vala"
		_tmp7_ = FALSE;
#line 3494 "nibbles-game.c"
	}
#line 561 "../src/nibbles-game.vala"
	if (_tmp7_) {
#line 3498 "nibbles-game.c"
		Boni* _tmp22_;
		Bonus* _tmp23_;
		Bonus* _tmp24_;
#line 563 "../src/nibbles-game.vala"
		_tmp22_ = self->priv->boni;
#line 563 "../src/nibbles-game.vala"
		_tmp23_ = boni_get_bonus (_tmp22_, (guint8) (x + 1), (guint8) (y + 1));
#line 563 "../src/nibbles-game.vala"
		_tmp24_ = _tmp23_;
#line 563 "../src/nibbles-game.vala"
		_tmp6_ = _tmp24_ == NULL;
#line 563 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp24_);
#line 3512 "nibbles-game.c"
	} else {
#line 561 "../src/nibbles-game.vala"
		_tmp6_ = FALSE;
#line 3516 "nibbles-game.c"
	}
#line 561 "../src/nibbles-game.vala"
	if (_tmp6_) {
#line 3520 "nibbles-game.c"
		Boni* _tmp25_;
		Bonus* _tmp26_;
		Bonus* _tmp27_;
#line 564 "../src/nibbles-game.vala"
		_tmp25_ = self->priv->boni;
#line 564 "../src/nibbles-game.vala"
		_tmp26_ = boni_get_bonus (_tmp25_, (guint8) (x + 1), y);
#line 564 "../src/nibbles-game.vala"
		_tmp27_ = _tmp26_;
#line 564 "../src/nibbles-game.vala"
		_tmp5_ = _tmp27_ == NULL;
#line 564 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp27_);
#line 3534 "nibbles-game.c"
	} else {
#line 561 "../src/nibbles-game.vala"
		_tmp5_ = FALSE;
#line 3538 "nibbles-game.c"
	}
#line 561 "../src/nibbles-game.vala"
	if (_tmp5_) {
#line 3542 "nibbles-game.c"
		Boni* _tmp28_;
		Bonus* _tmp29_;
		Bonus* _tmp30_;
#line 564 "../src/nibbles-game.vala"
		_tmp28_ = self->priv->boni;
#line 564 "../src/nibbles-game.vala"
		_tmp29_ = boni_get_bonus (_tmp28_, x, (guint8) (y + 1));
#line 564 "../src/nibbles-game.vala"
		_tmp30_ = _tmp29_;
#line 564 "../src/nibbles-game.vala"
		_tmp4_ = _tmp30_ == NULL;
#line 564 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp30_);
#line 3556 "nibbles-game.c"
	} else {
#line 561 "../src/nibbles-game.vala"
		_tmp4_ = FALSE;
#line 3560 "nibbles-game.c"
	}
#line 561 "../src/nibbles-game.vala"
	if (_tmp4_) {
#line 3564 "nibbles-game.c"
		gboolean _tmp31_;
#line 565 "../src/nibbles-game.vala"
		_tmp31_ = worms_at[(x * worms_at_length2) + y];
#line 565 "../src/nibbles-game.vala"
		_tmp3_ = !_tmp31_;
#line 3570 "nibbles-game.c"
	} else {
#line 561 "../src/nibbles-game.vala"
		_tmp3_ = FALSE;
#line 3574 "nibbles-game.c"
	}
#line 561 "../src/nibbles-game.vala"
	if (_tmp3_) {
#line 3578 "nibbles-game.c"
		gboolean _tmp32_;
#line 565 "../src/nibbles-game.vala"
		_tmp32_ = worms_at[((x + 1) * worms_at_length2) + (y + 1)];
#line 565 "../src/nibbles-game.vala"
		_tmp2_ = !_tmp32_;
#line 3584 "nibbles-game.c"
	} else {
#line 561 "../src/nibbles-game.vala"
		_tmp2_ = FALSE;
#line 3588 "nibbles-game.c"
	}
#line 561 "../src/nibbles-game.vala"
	if (_tmp2_) {
#line 3592 "nibbles-game.c"
		gboolean _tmp33_;
#line 566 "../src/nibbles-game.vala"
		_tmp33_ = worms_at[((x + 1) * worms_at_length2) + y];
#line 566 "../src/nibbles-game.vala"
		_tmp1_ = !_tmp33_;
#line 3598 "nibbles-game.c"
	} else {
#line 561 "../src/nibbles-game.vala"
		_tmp1_ = FALSE;
#line 3602 "nibbles-game.c"
	}
#line 561 "../src/nibbles-game.vala"
	if (_tmp1_) {
#line 3606 "nibbles-game.c"
		gboolean _tmp34_;
#line 566 "../src/nibbles-game.vala"
		_tmp34_ = worms_at[(x * worms_at_length2) + (y + 1)];
#line 566 "../src/nibbles-game.vala"
		_tmp0_ = !_tmp34_;
#line 3612 "nibbles-game.c"
	} else {
#line 561 "../src/nibbles-game.vala"
		_tmp0_ = FALSE;
#line 3616 "nibbles-game.c"
	}
#line 561 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 561 "../src/nibbles-game.vala"
	return result;
#line 3622 "nibbles-game.c"
}

static void
nibbles_game_add_bonus (NibblesGame* self,
                        gboolean regular)
{
	gboolean good = FALSE;
	guint8 x = 0U;
	guint8 y = 0U;
	gboolean* worms_at = NULL;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gboolean* _tmp2_;
	gint worms_at_length1;
	gint worms_at_length2;
#line 569 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 571 "../src/nibbles-game.vala"
	good = FALSE;
#line 572 "../src/nibbles-game.vala"
	x = (guint8) 0;
#line 573 "../src/nibbles-game.vala"
	y = (guint8) 0;
#line 574 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_width;
#line 574 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_height;
#line 574 "../src/nibbles-game.vala"
	_tmp2_ = g_new0 (gboolean, _tmp0_ * _tmp1_);
#line 574 "../src/nibbles-game.vala"
	worms_at = _tmp2_;
#line 574 "../src/nibbles-game.vala"
	worms_at_length1 = _tmp0_;
#line 574 "../src/nibbles-game.vala"
	worms_at_length2 = _tmp1_;
#line 576 "../src/nibbles-game.vala"
	if (!regular) {
#line 578 "../src/nibbles-game.vala"
		if (g_random_int_range ((gint32) 0, (gint32) 50) != ((gint32) 0)) {
#line 579 "../src/nibbles-game.vala"
			worms_at = (g_free (worms_at), NULL);
#line 579 "../src/nibbles-game.vala"
			return;
#line 3666 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp3_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _worm_index = 0;
#line 582 "../src/nibbles-game.vala"
		_tmp3_ = self->priv->_worms;
#line 582 "../src/nibbles-game.vala"
		_worm_list = _tmp3_;
#line 582 "../src/nibbles-game.vala"
		_tmp4_ = _worm_list;
#line 582 "../src/nibbles-game.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 582 "../src/nibbles-game.vala"
		_tmp6_ = _tmp5_;
#line 582 "../src/nibbles-game.vala"
		_worm_size = _tmp6_;
#line 582 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 582 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3693 "nibbles-game.c"
			gint _tmp7_;
			gint _tmp8_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp9_;
			gpointer _tmp10_;
			Worm* _tmp11_;
#line 582 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 582 "../src/nibbles-game.vala"
			_tmp7_ = _worm_index;
#line 582 "../src/nibbles-game.vala"
			_tmp8_ = _worm_size;
#line 582 "../src/nibbles-game.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 582 "../src/nibbles-game.vala"
				break;
#line 3710 "nibbles-game.c"
			}
#line 582 "../src/nibbles-game.vala"
			_tmp9_ = _worm_list;
#line 582 "../src/nibbles-game.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _worm_index);
#line 582 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp10_;
#line 583 "../src/nibbles-game.vala"
			_tmp11_ = worm;
#line 583 "../src/nibbles-game.vala"
			if (!_tmp11_->is_stopped) {
#line 3722 "nibbles-game.c"
				{
					WormPositions* _p_list = NULL;
					Worm* _tmp12_;
					WormPositions* _tmp13_;
					gint _p_size = 0;
					WormPositions* _tmp14_;
					gint _tmp15_;
					gint _tmp16_;
					gint _p_index = 0;
#line 584 "../src/nibbles-game.vala"
					_tmp12_ = worm;
#line 584 "../src/nibbles-game.vala"
					_tmp13_ = _tmp12_->list;
#line 584 "../src/nibbles-game.vala"
					_p_list = _tmp13_;
#line 584 "../src/nibbles-game.vala"
					_tmp14_ = _p_list;
#line 584 "../src/nibbles-game.vala"
					_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 584 "../src/nibbles-game.vala"
					_tmp16_ = _tmp15_;
#line 584 "../src/nibbles-game.vala"
					_p_size = _tmp16_;
#line 584 "../src/nibbles-game.vala"
					_p_index = -1;
#line 584 "../src/nibbles-game.vala"
					while (TRUE) {
#line 3750 "nibbles-game.c"
						gint _tmp17_;
						gint _tmp18_;
						guint16 p = 0U;
						WormPositions* _tmp19_;
						gpointer _tmp20_;
						gboolean* _tmp21_;
						gint _tmp21__length1;
						gint _tmp21__length2;
#line 584 "../src/nibbles-game.vala"
						_p_index = _p_index + 1;
#line 584 "../src/nibbles-game.vala"
						_tmp17_ = _p_index;
#line 584 "../src/nibbles-game.vala"
						_tmp18_ = _p_size;
#line 584 "../src/nibbles-game.vala"
						if (!(_tmp17_ < _tmp18_)) {
#line 584 "../src/nibbles-game.vala"
							break;
#line 3769 "nibbles-game.c"
						}
#line 584 "../src/nibbles-game.vala"
						_tmp19_ = _p_list;
#line 584 "../src/nibbles-game.vala"
						_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _p_index);
#line 584 "../src/nibbles-game.vala"
						p = (guint16) ((guintptr) _tmp20_);
#line 585 "../src/nibbles-game.vala"
						_tmp21_ = worms_at;
#line 585 "../src/nibbles-game.vala"
						_tmp21__length1 = worms_at_length1;
#line 585 "../src/nibbles-game.vala"
						_tmp21__length2 = worms_at_length2;
#line 585 "../src/nibbles-game.vala"
						_tmp21_[((p >> 8) * _tmp21__length2) + ((guint8) p)] = TRUE;
#line 3785 "nibbles-game.c"
					}
				}
			}
#line 582 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 3791 "nibbles-game.c"
		}
	}
	{
		gboolean _tmp22_ = FALSE;
#line 587 "../src/nibbles-game.vala"
		_tmp22_ = TRUE;
#line 587 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3800 "nibbles-game.c"
			guint8 _tmp24_;
			guint8 _tmp25_;
#line 587 "../src/nibbles-game.vala"
			if (!_tmp22_) {
#line 3805 "nibbles-game.c"
				gboolean* _tmp23_;
				gint _tmp23__length1;
				gint _tmp23__length2;
#line 591 "../src/nibbles-game.vala"
				_tmp23_ = worms_at;
#line 591 "../src/nibbles-game.vala"
				_tmp23__length1 = worms_at_length1;
#line 591 "../src/nibbles-game.vala"
				_tmp23__length2 = worms_at_length2;
#line 591 "../src/nibbles-game.vala"
				if (!(!nibbles_game_is_space_empty (self, x, y, _tmp23_, (gint) _tmp23__length1, (gint) _tmp23__length2))) {
#line 591 "../src/nibbles-game.vala"
					break;
#line 3819 "nibbles-game.c"
				}
			}
#line 587 "../src/nibbles-game.vala"
			_tmp22_ = FALSE;
#line 589 "../src/nibbles-game.vala"
			_tmp24_ = self->priv->_width;
#line 589 "../src/nibbles-game.vala"
			x = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp24_ - 1));
#line 590 "../src/nibbles-game.vala"
			_tmp25_ = self->priv->_height;
#line 590 "../src/nibbles-game.vala"
			y = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp25_ - 1));
#line 3832 "nibbles-game.c"
		}
	}
#line 593 "../src/nibbles-game.vala"
	if (regular) {
#line 3837 "nibbles-game.c"
		gboolean _tmp26_ = FALSE;
#line 595 "../src/nibbles-game.vala"
		if (g_random_int_range ((gint32) 0, (gint32) 7) == ((gint32) 0)) {
#line 3841 "nibbles-game.c"
			gboolean _tmp27_;
#line 595 "../src/nibbles-game.vala"
			_tmp27_ = self->priv->_fakes;
#line 595 "../src/nibbles-game.vala"
			_tmp26_ = _tmp27_;
#line 3847 "nibbles-game.c"
		} else {
#line 595 "../src/nibbles-game.vala"
			_tmp26_ = FALSE;
#line 3851 "nibbles-game.c"
		}
#line 595 "../src/nibbles-game.vala"
		if (_tmp26_) {
#line 596 "../src/nibbles-game.vala"
			_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_REGULAR, TRUE, (guint16) 300);
#line 3857 "nibbles-game.c"
		}
		{
			gboolean _tmp28_ = FALSE;
#line 598 "../src/nibbles-game.vala"
			_tmp28_ = TRUE;
#line 598 "../src/nibbles-game.vala"
			while (TRUE) {
#line 3865 "nibbles-game.c"
				guint8 _tmp30_;
				guint8 _tmp31_;
#line 598 "../src/nibbles-game.vala"
				if (!_tmp28_) {
#line 3870 "nibbles-game.c"
					gboolean* _tmp29_;
					gint _tmp29__length1;
					gint _tmp29__length2;
#line 602 "../src/nibbles-game.vala"
					_tmp29_ = worms_at;
#line 602 "../src/nibbles-game.vala"
					_tmp29__length1 = worms_at_length1;
#line 602 "../src/nibbles-game.vala"
					_tmp29__length2 = worms_at_length2;
#line 602 "../src/nibbles-game.vala"
					if (!(!nibbles_game_is_space_empty (self, x, y, _tmp29_, (gint) _tmp29__length1, (gint) _tmp29__length2))) {
#line 602 "../src/nibbles-game.vala"
						break;
#line 3884 "nibbles-game.c"
					}
				}
#line 598 "../src/nibbles-game.vala"
				_tmp28_ = FALSE;
#line 600 "../src/nibbles-game.vala"
				_tmp30_ = self->priv->_width;
#line 600 "../src/nibbles-game.vala"
				x = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp30_ - 1));
#line 601 "../src/nibbles-game.vala"
				_tmp31_ = self->priv->_height;
#line 601 "../src/nibbles-game.vala"
				y = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp31_ - 1));
#line 3897 "nibbles-game.c"
			}
		}
#line 603 "../src/nibbles-game.vala"
		_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_REGULAR, FALSE, (guint16) 300);
#line 3902 "nibbles-game.c"
	} else {
		Boni* _tmp32_;
#line 605 "../src/nibbles-game.vala"
		_tmp32_ = self->priv->boni;
#line 605 "../src/nibbles-game.vala"
		if (!boni_too_many_missed (_tmp32_)) {
#line 3909 "nibbles-game.c"
			gboolean _tmp33_ = FALSE;
#line 607 "../src/nibbles-game.vala"
			if (g_random_int_range ((gint32) 0, (gint32) 7) != ((gint32) 0)) {
#line 608 "../src/nibbles-game.vala"
				good = FALSE;
#line 3915 "nibbles-game.c"
			} else {
#line 610 "../src/nibbles-game.vala"
				good = TRUE;
#line 3919 "nibbles-game.c"
			}
#line 612 "../src/nibbles-game.vala"
			if (good) {
#line 3923 "nibbles-game.c"
				gboolean _tmp34_;
#line 612 "../src/nibbles-game.vala"
				_tmp34_ = self->priv->_fakes;
#line 612 "../src/nibbles-game.vala"
				_tmp33_ = !_tmp34_;
#line 3929 "nibbles-game.c"
			} else {
#line 612 "../src/nibbles-game.vala"
				_tmp33_ = FALSE;
#line 3933 "nibbles-game.c"
			}
#line 612 "../src/nibbles-game.vala"
			if (_tmp33_) {
#line 613 "../src/nibbles-game.vala"
				worms_at = (g_free (worms_at), NULL);
#line 613 "../src/nibbles-game.vala"
				return;
#line 3941 "nibbles-game.c"
			}
#line 615 "../src/nibbles-game.vala"
			switch (g_random_int_range ((gint32) 0, (gint32) 21)) {
#line 615 "../src/nibbles-game.vala"
				case 0:
#line 615 "../src/nibbles-game.vala"
				case 1:
#line 615 "../src/nibbles-game.vala"
				case 2:
#line 615 "../src/nibbles-game.vala"
				case 3:
#line 615 "../src/nibbles-game.vala"
				case 4:
#line 615 "../src/nibbles-game.vala"
				case 5:
#line 615 "../src/nibbles-game.vala"
				case 6:
#line 615 "../src/nibbles-game.vala"
				case 7:
#line 615 "../src/nibbles-game.vala"
				case 8:
#line 615 "../src/nibbles-game.vala"
				case 9:
#line 3965 "nibbles-game.c"
				{
#line 627 "../src/nibbles-game.vala"
					_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_HALF, good, (guint16) 200);
#line 628 "../src/nibbles-game.vala"
					break;
#line 3971 "nibbles-game.c"
				}
#line 615 "../src/nibbles-game.vala"
				case 10:
#line 615 "../src/nibbles-game.vala"
				case 11:
#line 615 "../src/nibbles-game.vala"
				case 12:
#line 615 "../src/nibbles-game.vala"
				case 13:
#line 615 "../src/nibbles-game.vala"
				case 14:
#line 3983 "nibbles-game.c"
				{
#line 634 "../src/nibbles-game.vala"
					_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_DOUBLE, good, (guint16) 150);
#line 635 "../src/nibbles-game.vala"
					break;
#line 3989 "nibbles-game.c"
				}
#line 615 "../src/nibbles-game.vala"
				case 15:
#line 3993 "nibbles-game.c"
				{
#line 637 "../src/nibbles-game.vala"
					_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_LIFE, good, (guint16) 100);
#line 638 "../src/nibbles-game.vala"
					break;
#line 3999 "nibbles-game.c"
				}
#line 615 "../src/nibbles-game.vala"
				case 16:
#line 615 "../src/nibbles-game.vala"
				case 17:
#line 615 "../src/nibbles-game.vala"
				case 18:
#line 615 "../src/nibbles-game.vala"
				case 19:
#line 615 "../src/nibbles-game.vala"
				case 20:
#line 4011 "nibbles-game.c"
				{
					gint _tmp35_;
#line 644 "../src/nibbles-game.vala"
					_tmp35_ = self->priv->_numworms;
#line 644 "../src/nibbles-game.vala"
					if (_tmp35_ > 1) {
#line 645 "../src/nibbles-game.vala"
						_nibbles_game_add_bonus (self, x, y, BONUS_TYPE_REVERSE, good, (guint16) 150);
#line 4020 "nibbles-game.c"
					}
#line 646 "../src/nibbles-game.vala"
					break;
#line 4024 "nibbles-game.c"
				}
				default:
#line 615 "../src/nibbles-game.vala"
				break;
#line 4029 "nibbles-game.c"
			}
		}
	}
#line 569 "../src/nibbles-game.vala"
	worms_at = (g_free (worms_at), NULL);
#line 4035 "nibbles-game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 653 "../src/nibbles-game.vala"
	return self ? g_object_ref (self) : NULL;
#line 4043 "nibbles-game.c"
}

static inline void
_nibbles_game_add_bonus (NibblesGame* self,
                         guint8 x,
                         guint8 y,
                         BonusType bonus_type,
                         gboolean fake,
                         guint16 countdown)
{
	Bonus* bonus = NULL;
	Bonus* _tmp0_;
	Boni* _tmp1_;
	Bonus* _tmp2_;
	Bonus* _tmp3_;
#line 650 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 652 "../src/nibbles-game.vala"
	_tmp0_ = bonus_new (x, y, bonus_type, fake, countdown);
#line 652 "../src/nibbles-game.vala"
	bonus = _tmp0_;
#line 653 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->boni;
#line 653 "../src/nibbles-game.vala"
	_tmp2_ = bonus;
#line 653 "../src/nibbles-game.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 653 "../src/nibbles-game.vala"
	if (boni_add_bonus (_tmp1_, _tmp3_)) {
#line 4073 "nibbles-game.c"
		Bonus* _tmp4_;
		BonusType _tmp5_;
		BonusType _tmp6_;
#line 654 "../src/nibbles-game.vala"
		_tmp4_ = bonus;
#line 654 "../src/nibbles-game.vala"
		_tmp5_ = bonus_get_bonus_type (_tmp4_);
#line 654 "../src/nibbles-game.vala"
		_tmp6_ = _tmp5_;
#line 654 "../src/nibbles-game.vala"
		if (_tmp6_ != BONUS_TYPE_REGULAR) {
#line 655 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "appear");
#line 4087 "nibbles-game.c"
		}
	}
#line 650 "../src/nibbles-game.vala"
	_g_object_unref0 (bonus);
#line 4092 "nibbles-game.c"
}

static void
nibbles_game_apply_bonus (NibblesGame* self,
                          Bonus* bonus,
                          Worm* worm)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	BonusType _tmp2_;
	BonusType _tmp3_;
#line 658 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 658 "../src/nibbles-game.vala"
	g_return_if_fail (bonus != NULL);
#line 658 "../src/nibbles-game.vala"
	g_return_if_fail (worm != NULL);
#line 660 "../src/nibbles-game.vala"
	_tmp0_ = bonus_get_fake (bonus);
#line 660 "../src/nibbles-game.vala"
	_tmp1_ = _tmp0_;
#line 660 "../src/nibbles-game.vala"
	if (_tmp1_) {
#line 662 "../src/nibbles-game.vala"
		worm_reverse (worm);
#line 664 "../src/nibbles-game.vala"
		return;
#line 4120 "nibbles-game.c"
	}
#line 667 "../src/nibbles-game.vala"
	_tmp2_ = bonus_get_bonus_type (bonus);
#line 667 "../src/nibbles-game.vala"
	_tmp3_ = _tmp2_;
#line 667 "../src/nibbles-game.vala"
	switch (_tmp3_) {
#line 667 "../src/nibbles-game.vala"
		case BONUS_TYPE_REGULAR:
#line 4130 "nibbles-game.c"
		{
			guint8 nth_bonus = 0U;
			Boni* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 670 "../src/nibbles-game.vala"
			_tmp4_ = self->priv->boni;
#line 670 "../src/nibbles-game.vala"
			nth_bonus = boni_new_regular_bonus_eaten (_tmp4_);
#line 671 "../src/nibbles-game.vala"
			_tmp5_ = worm_get_change (worm);
#line 671 "../src/nibbles-game.vala"
			_tmp6_ = _tmp5_;
#line 671 "../src/nibbles-game.vala"
			worm_set_change (worm, _tmp6_ + (((gint) nth_bonus) * WORM_GROW_FACTOR));
#line 672 "../src/nibbles-game.vala"
			_tmp7_ = worm_get_score (worm);
#line 672 "../src/nibbles-game.vala"
			_tmp8_ = _tmp7_;
#line 672 "../src/nibbles-game.vala"
			_tmp9_ = self->priv->_current_level;
#line 672 "../src/nibbles-game.vala"
			worm_set_score (worm, _tmp8_ + (((gint) nth_bonus) * _tmp9_));
#line 673 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "gobble");
#line 674 "../src/nibbles-game.vala"
			break;
#line 4161 "nibbles-game.c"
		}
#line 667 "../src/nibbles-game.vala"
		case BONUS_TYPE_DOUBLE:
#line 4165 "nibbles-game.c"
		{
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
#line 676 "../src/nibbles-game.vala"
			_tmp10_ = worm_get_score (worm);
#line 676 "../src/nibbles-game.vala"
			_tmp11_ = _tmp10_;
#line 676 "../src/nibbles-game.vala"
			_tmp12_ = worm_get_length (worm);
#line 676 "../src/nibbles-game.vala"
			_tmp13_ = _tmp12_;
#line 676 "../src/nibbles-game.vala"
			_tmp14_ = worm_get_change (worm);
#line 676 "../src/nibbles-game.vala"
			_tmp15_ = _tmp14_;
#line 676 "../src/nibbles-game.vala"
			_tmp16_ = self->priv->_current_level;
#line 676 "../src/nibbles-game.vala"
			worm_set_score (worm, _tmp11_ + ((_tmp13_ + _tmp15_) * _tmp16_));
#line 677 "../src/nibbles-game.vala"
			_tmp17_ = worm_get_change (worm);
#line 677 "../src/nibbles-game.vala"
			_tmp18_ = _tmp17_;
#line 677 "../src/nibbles-game.vala"
			_tmp19_ = worm_get_length (worm);
#line 677 "../src/nibbles-game.vala"
			_tmp20_ = _tmp19_;
#line 677 "../src/nibbles-game.vala"
			_tmp21_ = worm_get_change (worm);
#line 677 "../src/nibbles-game.vala"
			_tmp22_ = _tmp21_;
#line 677 "../src/nibbles-game.vala"
			worm_set_change (worm, _tmp18_ + (_tmp20_ + _tmp22_));
#line 678 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "bonus");
#line 679 "../src/nibbles-game.vala"
			break;
#line 4214 "nibbles-game.c"
		}
#line 667 "../src/nibbles-game.vala"
		case BONUS_TYPE_HALF:
#line 4218 "nibbles-game.c"
		{
			gint _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
#line 681 "../src/nibbles-game.vala"
			_tmp23_ = worm_get_length (worm);
#line 681 "../src/nibbles-game.vala"
			_tmp24_ = _tmp23_;
#line 681 "../src/nibbles-game.vala"
			_tmp25_ = worm_get_change (worm);
#line 681 "../src/nibbles-game.vala"
			_tmp26_ = _tmp25_;
#line 681 "../src/nibbles-game.vala"
			if ((_tmp24_ + _tmp26_) > 2) {
#line 4234 "nibbles-game.c"
				gint _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				gint _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
#line 683 "../src/nibbles-game.vala"
				_tmp27_ = worm_get_score (worm);
#line 683 "../src/nibbles-game.vala"
				_tmp28_ = _tmp27_;
#line 683 "../src/nibbles-game.vala"
				_tmp29_ = worm_get_length (worm);
#line 683 "../src/nibbles-game.vala"
				_tmp30_ = _tmp29_;
#line 683 "../src/nibbles-game.vala"
				_tmp31_ = worm_get_change (worm);
#line 683 "../src/nibbles-game.vala"
				_tmp32_ = _tmp31_;
#line 683 "../src/nibbles-game.vala"
				_tmp33_ = self->priv->_current_level;
#line 683 "../src/nibbles-game.vala"
				worm_set_score (worm, _tmp28_ + ((_tmp30_ + (_tmp32_ / 2)) * _tmp33_));
#line 684 "../src/nibbles-game.vala"
				_tmp34_ = worm_get_length (worm);
#line 684 "../src/nibbles-game.vala"
				_tmp35_ = _tmp34_;
#line 684 "../src/nibbles-game.vala"
				worm_reduce_tail (worm, _tmp35_ / 2);
#line 685 "../src/nibbles-game.vala"
				_tmp36_ = worm_get_change (worm);
#line 685 "../src/nibbles-game.vala"
				_tmp37_ = _tmp36_;
#line 685 "../src/nibbles-game.vala"
				_tmp38_ = worm_get_length (worm);
#line 685 "../src/nibbles-game.vala"
				_tmp39_ = _tmp38_;
#line 685 "../src/nibbles-game.vala"
				_tmp40_ = worm_get_change (worm);
#line 685 "../src/nibbles-game.vala"
				_tmp41_ = _tmp40_;
#line 685 "../src/nibbles-game.vala"
				worm_set_change (worm, _tmp37_ - ((_tmp39_ + _tmp41_) / 2));
#line 4286 "nibbles-game.c"
			}
#line 687 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "bonus");
#line 688 "../src/nibbles-game.vala"
			break;
#line 4292 "nibbles-game.c"
		}
#line 667 "../src/nibbles-game.vala"
		case BONUS_TYPE_LIFE:
#line 4296 "nibbles-game.c"
		{
#line 690 "../src/nibbles-game.vala"
			worm_add_life (worm);
#line 691 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "life");
#line 692 "../src/nibbles-game.vala"
			break;
#line 4304 "nibbles-game.c"
		}
#line 667 "../src/nibbles-game.vala"
		case BONUS_TYPE_REVERSE:
#line 4308 "nibbles-game.c"
		{
#line 694 "../src/nibbles-game.vala"
			nibbles_game_reverse_worms (self, worm);
#line 695 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "reverse");
#line 696 "../src/nibbles-game.vala"
			break;
#line 4316 "nibbles-game.c"
		}
#line 667 "../src/nibbles-game.vala"
		case BONUS_TYPE_WARP:
#line 4320 "nibbles-game.c"
		{
#line 698 "../src/nibbles-game.vala"
			break;
#line 4324 "nibbles-game.c"
		}
		default:
#line 667 "../src/nibbles-game.vala"
		break;
#line 4329 "nibbles-game.c"
	}
}

static void
nibbles_game_bonus_found_cb (NibblesGame* self,
                             Worm* worm)
{
	Bonus* bonus = NULL;
	Boni* _tmp0_;
	Position _tmp1_ = {0};
	Position _tmp2_;
	Position _tmp3_ = {0};
	Position _tmp4_;
	Bonus* _tmp5_;
	Bonus* _tmp6_;
	Position _tmp7_ = {0};
	Position _tmp8_;
	Position _tmp9_ = {0};
	Position _tmp10_;
	Bonus* _tmp11_;
	Bonus* _tmp12_;
	gboolean _tmp13_ = FALSE;
	Bonus* _tmp14_;
	BonusType _tmp15_;
	BonusType _tmp16_;
	gboolean real_bonus = FALSE;
	Boni* _tmp20_;
	Bonus* _tmp21_;
	gboolean _tmp22_ = FALSE;
#line 702 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 702 "../src/nibbles-game.vala"
	g_return_if_fail (worm != NULL);
#line 704 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->boni;
#line 704 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp1_);
#line 704 "../src/nibbles-game.vala"
	_tmp2_ = _tmp1_;
#line 704 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp3_);
#line 704 "../src/nibbles-game.vala"
	_tmp4_ = _tmp3_;
#line 704 "../src/nibbles-game.vala"
	_tmp5_ = boni_get_bonus (_tmp0_, _tmp2_.x, _tmp4_.y);
#line 704 "../src/nibbles-game.vala"
	bonus = _tmp5_;
#line 705 "../src/nibbles-game.vala"
	_tmp6_ = bonus;
#line 705 "../src/nibbles-game.vala"
	if (_tmp6_ == NULL) {
#line 706 "../src/nibbles-game.vala"
		_g_object_unref0 (bonus);
#line 706 "../src/nibbles-game.vala"
		return;
#line 4385 "nibbles-game.c"
	}
#line 707 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp7_);
#line 707 "../src/nibbles-game.vala"
	_tmp8_ = _tmp7_;
#line 707 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp9_);
#line 707 "../src/nibbles-game.vala"
	_tmp10_ = _tmp9_;
#line 707 "../src/nibbles-game.vala"
	worm_add_bonus_eaten_position (worm, _tmp8_.x, _tmp10_.y);
#line 708 "../src/nibbles-game.vala"
	_tmp11_ = bonus;
#line 708 "../src/nibbles-game.vala"
	nibbles_game_apply_bonus (self, _tmp11_, worm);
#line 709 "../src/nibbles-game.vala"
	_tmp12_ = bonus;
#line 709 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_BONUS_APPLIED_SIGNAL], 0, _tmp12_, worm);
#line 711 "../src/nibbles-game.vala"
	_tmp14_ = bonus;
#line 711 "../src/nibbles-game.vala"
	_tmp15_ = bonus_get_bonus_type (_tmp14_);
#line 711 "../src/nibbles-game.vala"
	_tmp16_ = _tmp15_;
#line 711 "../src/nibbles-game.vala"
	if (_tmp16_ == BONUS_TYPE_REGULAR) {
#line 4413 "nibbles-game.c"
		Bonus* _tmp17_;
		gboolean _tmp18_;
		gboolean _tmp19_;
#line 711 "../src/nibbles-game.vala"
		_tmp17_ = bonus;
#line 711 "../src/nibbles-game.vala"
		_tmp18_ = bonus_get_fake (_tmp17_);
#line 711 "../src/nibbles-game.vala"
		_tmp19_ = _tmp18_;
#line 711 "../src/nibbles-game.vala"
		_tmp13_ = !_tmp19_;
#line 4425 "nibbles-game.c"
	} else {
#line 711 "../src/nibbles-game.vala"
		_tmp13_ = FALSE;
#line 4429 "nibbles-game.c"
	}
#line 711 "../src/nibbles-game.vala"
	real_bonus = _tmp13_;
#line 713 "../src/nibbles-game.vala"
	_tmp20_ = self->priv->boni;
#line 713 "../src/nibbles-game.vala"
	_tmp21_ = bonus;
#line 713 "../src/nibbles-game.vala"
	boni_remove_bonus (_tmp20_, _tmp21_);
#line 715 "../src/nibbles-game.vala"
	if (real_bonus) {
#line 4441 "nibbles-game.c"
		Boni* _tmp23_;
#line 715 "../src/nibbles-game.vala"
		_tmp23_ = self->priv->boni;
#line 715 "../src/nibbles-game.vala"
		_tmp22_ = !boni_last_regular_bonus (_tmp23_);
#line 4447 "nibbles-game.c"
	} else {
#line 715 "../src/nibbles-game.vala"
		_tmp22_ = FALSE;
#line 4451 "nibbles-game.c"
	}
#line 715 "../src/nibbles-game.vala"
	if (_tmp22_) {
#line 716 "../src/nibbles-game.vala"
		nibbles_game_add_bonus (self, TRUE);
#line 4457 "nibbles-game.c"
	}
#line 702 "../src/nibbles-game.vala"
	_g_object_unref0 (bonus);
#line 4461 "nibbles-game.c"
}

static GameStatus*
_game_status_dup (GameStatus* self)
{
	GameStatus* dup;
#line 727 "../src/nibbles-game.vala"
	dup = g_new0 (GameStatus, 1);
#line 727 "../src/nibbles-game.vala"
	memcpy (dup, self, sizeof (GameStatus));
#line 727 "../src/nibbles-game.vala"
	return dup;
#line 4474 "nibbles-game.c"
}

static gpointer
__game_status_dup0 (gpointer self)
{
#line 727 "../src/nibbles-game.vala"
	return self ? _game_status_dup (self) : NULL;
#line 4482 "nibbles-game.c"
}

GameStatus*
nibbles_game_get_game_status (NibblesGame* self)
{
	gint worms_left = 0;
	gboolean _tmp25_ = FALSE;
	Boni* _tmp31_;
	GameStatus* result;
#line 719 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 721 "../src/nibbles-game.vala"
	worms_left = 0;
#line 4496 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 722 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 722 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 722 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 722 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 722 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 722 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 722 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 722 "../src/nibbles-game.vala"
		while (TRUE) {
#line 4521 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			guint8 _tmp9_;
			guint8 _tmp10_;
#line 722 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 722 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 722 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 722 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 722 "../src/nibbles-game.vala"
				break;
#line 4540 "nibbles-game.c"
			}
#line 722 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 722 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 722 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 724 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 724 "../src/nibbles-game.vala"
			_tmp9_ = worm_get_lives (_tmp8_);
#line 724 "../src/nibbles-game.vala"
			_tmp10_ = _tmp9_;
#line 724 "../src/nibbles-game.vala"
			if (((gint) _tmp10_) > 0) {
#line 725 "../src/nibbles-game.vala"
				worms_left += 1;
#line 4558 "nibbles-game.c"
			} else {
				gboolean _tmp11_ = FALSE;
				Worm* _tmp12_;
#line 726 "../src/nibbles-game.vala"
				_tmp12_ = worm;
#line 726 "../src/nibbles-game.vala"
				if (_tmp12_->is_human) {
#line 4566 "nibbles-game.c"
					Worm* _tmp13_;
					guint8 _tmp14_;
					guint8 _tmp15_;
#line 726 "../src/nibbles-game.vala"
					_tmp13_ = worm;
#line 726 "../src/nibbles-game.vala"
					_tmp14_ = worm_get_lives (_tmp13_);
#line 726 "../src/nibbles-game.vala"
					_tmp15_ = _tmp14_;
#line 726 "../src/nibbles-game.vala"
					_tmp11_ = ((gint) _tmp15_) == 0;
#line 4578 "nibbles-game.c"
				} else {
#line 726 "../src/nibbles-game.vala"
					_tmp11_ = FALSE;
#line 4582 "nibbles-game.c"
				}
#line 726 "../src/nibbles-game.vala"
				if (_tmp11_) {
#line 4586 "nibbles-game.c"
					GameStatus _tmp16_;
					GameStatus* _tmp17_;
#line 727 "../src/nibbles-game.vala"
					_tmp16_ = GAME_STATUS_GAMEOVER;
#line 727 "../src/nibbles-game.vala"
					_tmp17_ = __game_status_dup0 (&_tmp16_);
#line 727 "../src/nibbles-game.vala"
					result = _tmp17_;
#line 727 "../src/nibbles-game.vala"
					_g_object_unref0 (worm);
#line 727 "../src/nibbles-game.vala"
					return result;
#line 4599 "nibbles-game.c"
				} else {
					gboolean _tmp18_ = FALSE;
					gint _tmp19_;
#line 728 "../src/nibbles-game.vala"
					_tmp19_ = self->priv->_numhumans;
#line 728 "../src/nibbles-game.vala"
					if (_tmp19_ == 0) {
#line 4607 "nibbles-game.c"
						Worm* _tmp20_;
						guint8 _tmp21_;
						guint8 _tmp22_;
#line 728 "../src/nibbles-game.vala"
						_tmp20_ = worm;
#line 728 "../src/nibbles-game.vala"
						_tmp21_ = worm_get_lives (_tmp20_);
#line 728 "../src/nibbles-game.vala"
						_tmp22_ = _tmp21_;
#line 728 "../src/nibbles-game.vala"
						_tmp18_ = ((gint) _tmp22_) == 0;
#line 4619 "nibbles-game.c"
					} else {
#line 728 "../src/nibbles-game.vala"
						_tmp18_ = FALSE;
#line 4623 "nibbles-game.c"
					}
#line 728 "../src/nibbles-game.vala"
					if (_tmp18_) {
#line 4627 "nibbles-game.c"
						GameStatus _tmp23_;
						GameStatus* _tmp24_;
#line 729 "../src/nibbles-game.vala"
						_tmp23_ = GAME_STATUS_GAMEOVER;
#line 729 "../src/nibbles-game.vala"
						_tmp24_ = __game_status_dup0 (&_tmp23_);
#line 729 "../src/nibbles-game.vala"
						result = _tmp24_;
#line 729 "../src/nibbles-game.vala"
						_g_object_unref0 (worm);
#line 729 "../src/nibbles-game.vala"
						return result;
#line 4640 "nibbles-game.c"
					}
				}
			}
#line 722 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 4646 "nibbles-game.c"
		}
	}
#line 732 "../src/nibbles-game.vala"
	if (worms_left == 1) {
#line 4651 "nibbles-game.c"
		gint _tmp26_;
#line 732 "../src/nibbles-game.vala"
		_tmp26_ = self->priv->_numworms;
#line 732 "../src/nibbles-game.vala"
		_tmp25_ = _tmp26_ > 1;
#line 4657 "nibbles-game.c"
	} else {
#line 732 "../src/nibbles-game.vala"
		_tmp25_ = FALSE;
#line 4661 "nibbles-game.c"
	}
#line 732 "../src/nibbles-game.vala"
	if (_tmp25_) {
#line 4665 "nibbles-game.c"
		GameStatus _tmp27_;
		GameStatus* _tmp28_;
#line 735 "../src/nibbles-game.vala"
		_tmp27_ = GAME_STATUS_VICTORY;
#line 735 "../src/nibbles-game.vala"
		_tmp28_ = __game_status_dup0 (&_tmp27_);
#line 735 "../src/nibbles-game.vala"
		result = _tmp28_;
#line 735 "../src/nibbles-game.vala"
		return result;
#line 4676 "nibbles-game.c"
	} else {
#line 737 "../src/nibbles-game.vala"
		if (worms_left == 0) {
#line 4680 "nibbles-game.c"
			GameStatus _tmp29_;
			GameStatus* _tmp30_;
#line 740 "../src/nibbles-game.vala"
			_tmp29_ = GAME_STATUS_GAMEOVER;
#line 740 "../src/nibbles-game.vala"
			_tmp30_ = __game_status_dup0 (&_tmp29_);
#line 740 "../src/nibbles-game.vala"
			result = _tmp30_;
#line 740 "../src/nibbles-game.vala"
			return result;
#line 4691 "nibbles-game.c"
		}
	}
#line 743 "../src/nibbles-game.vala"
	_tmp31_ = self->priv->boni;
#line 743 "../src/nibbles-game.vala"
	if (boni_last_regular_bonus (_tmp31_)) {
#line 4698 "nibbles-game.c"
		GameStatus _tmp32_;
		GameStatus* _tmp33_;
#line 744 "../src/nibbles-game.vala"
		_tmp32_ = GAME_STATUS_NEWROUND;
#line 744 "../src/nibbles-game.vala"
		_tmp33_ = __game_status_dup0 (&_tmp32_);
#line 744 "../src/nibbles-game.vala"
		result = _tmp33_;
#line 744 "../src/nibbles-game.vala"
		return result;
#line 4709 "nibbles-game.c"
	}
#line 746 "../src/nibbles-game.vala"
	result = NULL;
#line 746 "../src/nibbles-game.vala"
	return result;
#line 4715 "nibbles-game.c"
}

Worm*
nibbles_game_get_winner (NibblesGame* self)
{
	Worm* result;
#line 749 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4724 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 751 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 751 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 751 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 751 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 751 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 751 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 751 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 751 "../src/nibbles-game.vala"
		while (TRUE) {
#line 4749 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			guint8 _tmp9_;
			guint8 _tmp10_;
#line 751 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 751 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 751 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 751 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 751 "../src/nibbles-game.vala"
				break;
#line 4768 "nibbles-game.c"
			}
#line 751 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 751 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 751 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 753 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 753 "../src/nibbles-game.vala"
			_tmp9_ = worm_get_lives (_tmp8_);
#line 753 "../src/nibbles-game.vala"
			_tmp10_ = _tmp9_;
#line 753 "../src/nibbles-game.vala"
			if (((gint) _tmp10_) > 0) {
#line 754 "../src/nibbles-game.vala"
				result = worm;
#line 754 "../src/nibbles-game.vala"
				return result;
#line 4788 "nibbles-game.c"
			}
#line 751 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 4792 "nibbles-game.c"
		}
	}
#line 757 "../src/nibbles-game.vala"
	result = NULL;
#line 757 "../src/nibbles-game.vala"
	return result;
#line 4799 "nibbles-game.c"
}

static gboolean
____lambda12_ (GValue* prop_value,
               GVariant* variant)
{
	const gchar* _tmp0_;
	gboolean result;
#line 772 "../src/nibbles-game.vala"
	g_return_val_if_fail (prop_value != NULL, FALSE);
#line 772 "../src/nibbles-game.vala"
	g_return_val_if_fail (variant != NULL, FALSE);
#line 772 "../src/nibbles-game.vala"
	_tmp0_ = g_variant_get_string (variant, NULL);
#line 772 "../src/nibbles-game.vala"
	g_value_set_int (prop_value, nibbles_game_get_color_num (_tmp0_));
#line 773 "../src/nibbles-game.vala"
	result = TRUE;
#line 773 "../src/nibbles-game.vala"
	return result;
#line 4820 "nibbles-game.c"
}

static gboolean
_____lambda12__gsettings_bind_get_mapping (GValue* value,
                                           GVariant* variant,
                                           void* user_data)
{
	gboolean result;
	result = ____lambda12_ (value, variant);
#line 771 "../src/nibbles-game.vala"
	return result;
#line 4832 "nibbles-game.c"
}

static GVariant*
____lambda13_ (GValue* prop_value,
               const GVariantType* variant_type)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* result;
#line 774 "../src/nibbles-game.vala"
	g_return_val_if_fail (prop_value != NULL, NULL);
#line 774 "../src/nibbles-game.vala"
	g_return_val_if_fail (variant_type != NULL, NULL);
#line 774 "../src/nibbles-game.vala"
	_tmp0_ = nibbles_game_get_color_string (g_value_get_int (prop_value));
#line 774 "../src/nibbles-game.vala"
	_tmp1_ = _tmp0_;
#line 774 "../src/nibbles-game.vala"
	_tmp2_ = g_variant_new_string (_tmp1_);
#line 774 "../src/nibbles-game.vala"
	g_variant_ref_sink (_tmp2_);
#line 774 "../src/nibbles-game.vala"
	_tmp3_ = _tmp2_;
#line 774 "../src/nibbles-game.vala"
	_g_free0 (_tmp1_);
#line 774 "../src/nibbles-game.vala"
	result = _tmp3_;
#line 774 "../src/nibbles-game.vala"
	return result;
#line 4864 "nibbles-game.c"
}

static GVariant*
_____lambda13__gsettings_bind_set_mapping (GValue* value,
                                           const GVariantType* expected_type,
                                           void* user_data)
{
	GVariant* result;
	result = ____lambda13_ (value, expected_type);
#line 771 "../src/nibbles-game.vala"
	return result;
#line 4876 "nibbles-game.c"
}

void
nibbles_game_load_worm_properties (NibblesGame* self,
                                   GeeArrayList* worm_settings)
{
	GeeHashMap* _tmp0_;
#line 764 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 764 "../src/nibbles-game.vala"
	g_return_if_fail (worm_settings != NULL);
#line 766 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worm_props;
#line 766 "../src/nibbles-game.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 4892 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
#line 767 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->_worms;
#line 767 "../src/nibbles-game.vala"
		_worm_list = _tmp1_;
#line 767 "../src/nibbles-game.vala"
		_tmp2_ = _worm_list;
#line 767 "../src/nibbles-game.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 767 "../src/nibbles-game.vala"
		_tmp4_ = _tmp3_;
#line 767 "../src/nibbles-game.vala"
		_worm_size = _tmp4_;
#line 767 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 767 "../src/nibbles-game.vala"
		while (TRUE) {
#line 4917 "nibbles-game.c"
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			WormProperties* properties = NULL;
			WormProperties* _tmp9_;
			Worm* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gpointer _tmp13_;
			GSettings* _tmp14_;
			WormProperties* _tmp15_;
			Worm* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gpointer _tmp19_;
			GSettings* _tmp20_;
			WormProperties* _tmp21_;
			Worm* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			gpointer _tmp25_;
			GSettings* _tmp26_;
			WormProperties* _tmp27_;
			Worm* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gpointer _tmp31_;
			GSettings* _tmp32_;
			WormProperties* _tmp33_;
			Worm* _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
			gpointer _tmp37_;
			GSettings* _tmp38_;
			WormProperties* _tmp39_;
			Worm* _tmp40_;
			gint _tmp41_;
			gint _tmp42_;
			gpointer _tmp43_;
			GSettings* _tmp44_;
			WormProperties* _tmp45_;
			Worm* _tmp46_;
			gint _tmp47_;
			gint _tmp48_;
			gpointer _tmp49_;
			GSettings* _tmp50_;
			WormProperties* _tmp51_;
			Worm* _tmp52_;
			gint _tmp53_;
			gint _tmp54_;
			gpointer _tmp55_;
			GSettings* _tmp56_;
			WormProperties* _tmp57_;
			Worm* _tmp58_;
			gint _tmp59_;
			gint _tmp60_;
			gpointer _tmp61_;
			GSettings* _tmp62_;
			WormProperties* _tmp63_;
			GeeHashMap* _tmp64_;
			Worm* _tmp65_;
			WormProperties* _tmp66_;
#line 767 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 767 "../src/nibbles-game.vala"
			_tmp5_ = _worm_index;
#line 767 "../src/nibbles-game.vala"
			_tmp6_ = _worm_size;
#line 767 "../src/nibbles-game.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 767 "../src/nibbles-game.vala"
				break;
#line 4992 "nibbles-game.c"
			}
#line 767 "../src/nibbles-game.vala"
			_tmp7_ = _worm_list;
#line 767 "../src/nibbles-game.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
#line 767 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp8_;
#line 769 "../src/nibbles-game.vala"
			_tmp9_ = worm_properties_new ();
#line 769 "../src/nibbles-game.vala"
			properties = _tmp9_;
#line 771 "../src/nibbles-game.vala"
			_tmp10_ = worm;
#line 771 "../src/nibbles-game.vala"
			_tmp11_ = worm_get_id (_tmp10_);
#line 771 "../src/nibbles-game.vala"
			_tmp12_ = _tmp11_;
#line 771 "../src/nibbles-game.vala"
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp12_);
#line 771 "../src/nibbles-game.vala"
			_tmp14_ = (GSettings*) _tmp13_;
#line 771 "../src/nibbles-game.vala"
			_tmp15_ = properties;
#line 771 "../src/nibbles-game.vala"
			g_settings_bind_with_mapping (_tmp14_, "color", (GObject*) _tmp15_, "color", G_SETTINGS_BIND_DEFAULT, _____lambda12__gsettings_bind_get_mapping, _____lambda13__gsettings_bind_set_mapping, NULL, NULL);
#line 771 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp14_);
#line 777 "../src/nibbles-game.vala"
			_tmp16_ = worm;
#line 777 "../src/nibbles-game.vala"
			_tmp17_ = worm_get_id (_tmp16_);
#line 777 "../src/nibbles-game.vala"
			_tmp18_ = _tmp17_;
#line 777 "../src/nibbles-game.vala"
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp18_);
#line 777 "../src/nibbles-game.vala"
			_tmp20_ = (GSettings*) _tmp19_;
#line 777 "../src/nibbles-game.vala"
			_tmp21_ = properties;
#line 777 "../src/nibbles-game.vala"
			g_settings_bind (_tmp20_, "key-up", (GObject*) _tmp21_, "up", G_SETTINGS_BIND_DEFAULT);
#line 777 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp20_);
#line 778 "../src/nibbles-game.vala"
			_tmp22_ = worm;
#line 778 "../src/nibbles-game.vala"
			_tmp23_ = worm_get_id (_tmp22_);
#line 778 "../src/nibbles-game.vala"
			_tmp24_ = _tmp23_;
#line 778 "../src/nibbles-game.vala"
			_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp24_);
#line 778 "../src/nibbles-game.vala"
			_tmp26_ = (GSettings*) _tmp25_;
#line 778 "../src/nibbles-game.vala"
			_tmp27_ = properties;
#line 778 "../src/nibbles-game.vala"
			g_settings_bind (_tmp26_, "key-down", (GObject*) _tmp27_, "down", G_SETTINGS_BIND_DEFAULT);
#line 778 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp26_);
#line 779 "../src/nibbles-game.vala"
			_tmp28_ = worm;
#line 779 "../src/nibbles-game.vala"
			_tmp29_ = worm_get_id (_tmp28_);
#line 779 "../src/nibbles-game.vala"
			_tmp30_ = _tmp29_;
#line 779 "../src/nibbles-game.vala"
			_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp30_);
#line 779 "../src/nibbles-game.vala"
			_tmp32_ = (GSettings*) _tmp31_;
#line 779 "../src/nibbles-game.vala"
			_tmp33_ = properties;
#line 779 "../src/nibbles-game.vala"
			g_settings_bind (_tmp32_, "key-left", (GObject*) _tmp33_, "left", G_SETTINGS_BIND_DEFAULT);
#line 779 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp32_);
#line 780 "../src/nibbles-game.vala"
			_tmp34_ = worm;
#line 780 "../src/nibbles-game.vala"
			_tmp35_ = worm_get_id (_tmp34_);
#line 780 "../src/nibbles-game.vala"
			_tmp36_ = _tmp35_;
#line 780 "../src/nibbles-game.vala"
			_tmp37_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp36_);
#line 780 "../src/nibbles-game.vala"
			_tmp38_ = (GSettings*) _tmp37_;
#line 780 "../src/nibbles-game.vala"
			_tmp39_ = properties;
#line 780 "../src/nibbles-game.vala"
			g_settings_bind (_tmp38_, "key-right", (GObject*) _tmp39_, "right", G_SETTINGS_BIND_DEFAULT);
#line 780 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp38_);
#line 781 "../src/nibbles-game.vala"
			_tmp40_ = worm;
#line 781 "../src/nibbles-game.vala"
			_tmp41_ = worm_get_id (_tmp40_);
#line 781 "../src/nibbles-game.vala"
			_tmp42_ = _tmp41_;
#line 781 "../src/nibbles-game.vala"
			_tmp43_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp42_);
#line 781 "../src/nibbles-game.vala"
			_tmp44_ = (GSettings*) _tmp43_;
#line 781 "../src/nibbles-game.vala"
			_tmp45_ = properties;
#line 781 "../src/nibbles-game.vala"
			g_settings_bind (_tmp44_, "key-up-raw", (GObject*) _tmp45_, "raw-up", G_SETTINGS_BIND_DEFAULT);
#line 781 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp44_);
#line 782 "../src/nibbles-game.vala"
			_tmp46_ = worm;
#line 782 "../src/nibbles-game.vala"
			_tmp47_ = worm_get_id (_tmp46_);
#line 782 "../src/nibbles-game.vala"
			_tmp48_ = _tmp47_;
#line 782 "../src/nibbles-game.vala"
			_tmp49_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp48_);
#line 782 "../src/nibbles-game.vala"
			_tmp50_ = (GSettings*) _tmp49_;
#line 782 "../src/nibbles-game.vala"
			_tmp51_ = properties;
#line 782 "../src/nibbles-game.vala"
			g_settings_bind (_tmp50_, "key-down-raw", (GObject*) _tmp51_, "raw-down", G_SETTINGS_BIND_DEFAULT);
#line 782 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp50_);
#line 783 "../src/nibbles-game.vala"
			_tmp52_ = worm;
#line 783 "../src/nibbles-game.vala"
			_tmp53_ = worm_get_id (_tmp52_);
#line 783 "../src/nibbles-game.vala"
			_tmp54_ = _tmp53_;
#line 783 "../src/nibbles-game.vala"
			_tmp55_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp54_);
#line 783 "../src/nibbles-game.vala"
			_tmp56_ = (GSettings*) _tmp55_;
#line 783 "../src/nibbles-game.vala"
			_tmp57_ = properties;
#line 783 "../src/nibbles-game.vala"
			g_settings_bind (_tmp56_, "key-left-raw", (GObject*) _tmp57_, "raw-left", G_SETTINGS_BIND_DEFAULT);
#line 783 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp56_);
#line 784 "../src/nibbles-game.vala"
			_tmp58_ = worm;
#line 784 "../src/nibbles-game.vala"
			_tmp59_ = worm_get_id (_tmp58_);
#line 784 "../src/nibbles-game.vala"
			_tmp60_ = _tmp59_;
#line 784 "../src/nibbles-game.vala"
			_tmp61_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp60_);
#line 784 "../src/nibbles-game.vala"
			_tmp62_ = (GSettings*) _tmp61_;
#line 784 "../src/nibbles-game.vala"
			_tmp63_ = properties;
#line 784 "../src/nibbles-game.vala"
			g_settings_bind (_tmp62_, "key-right-raw", (GObject*) _tmp63_, "raw-right", G_SETTINGS_BIND_DEFAULT);
#line 784 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp62_);
#line 785 "../src/nibbles-game.vala"
			_tmp64_ = self->priv->_worm_props;
#line 785 "../src/nibbles-game.vala"
			_tmp65_ = worm;
#line 785 "../src/nibbles-game.vala"
			_tmp66_ = properties;
#line 785 "../src/nibbles-game.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp64_, _tmp65_, _tmp66_);
#line 767 "../src/nibbles-game.vala"
			_g_object_unref0 (properties);
#line 767 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 5160 "nibbles-game.c"
		}
	}
}

static inline gchar*
nibbles_game_get_color_string (gint color)
{
	gchar* result;
#line 790 "../src/nibbles-game.vala"
	switch (color) {
#line 790 "../src/nibbles-game.vala"
		case 0:
#line 5173 "nibbles-game.c"
		{
			gchar* _tmp0_;
#line 792 "../src/nibbles-game.vala"
			_tmp0_ = g_strdup ("red");
#line 792 "../src/nibbles-game.vala"
			result = _tmp0_;
#line 792 "../src/nibbles-game.vala"
			return result;
#line 5182 "nibbles-game.c"
		}
#line 790 "../src/nibbles-game.vala"
		case 1:
#line 5186 "nibbles-game.c"
		{
			gchar* _tmp1_;
#line 793 "../src/nibbles-game.vala"
			_tmp1_ = g_strdup ("green");
#line 793 "../src/nibbles-game.vala"
			result = _tmp1_;
#line 793 "../src/nibbles-game.vala"
			return result;
#line 5195 "nibbles-game.c"
		}
#line 790 "../src/nibbles-game.vala"
		case 2:
#line 5199 "nibbles-game.c"
		{
			gchar* _tmp2_;
#line 794 "../src/nibbles-game.vala"
			_tmp2_ = g_strdup ("blue");
#line 794 "../src/nibbles-game.vala"
			result = _tmp2_;
#line 794 "../src/nibbles-game.vala"
			return result;
#line 5208 "nibbles-game.c"
		}
#line 790 "../src/nibbles-game.vala"
		case 3:
#line 5212 "nibbles-game.c"
		{
			gchar* _tmp3_;
#line 795 "../src/nibbles-game.vala"
			_tmp3_ = g_strdup ("yellow");
#line 795 "../src/nibbles-game.vala"
			result = _tmp3_;
#line 795 "../src/nibbles-game.vala"
			return result;
#line 5221 "nibbles-game.c"
		}
#line 790 "../src/nibbles-game.vala"
		case 4:
#line 5225 "nibbles-game.c"
		{
			gchar* _tmp4_;
#line 796 "../src/nibbles-game.vala"
			_tmp4_ = g_strdup ("cyan");
#line 796 "../src/nibbles-game.vala"
			result = _tmp4_;
#line 796 "../src/nibbles-game.vala"
			return result;
#line 5234 "nibbles-game.c"
		}
#line 790 "../src/nibbles-game.vala"
		case 5:
#line 5238 "nibbles-game.c"
		{
			gchar* _tmp5_;
#line 797 "../src/nibbles-game.vala"
			_tmp5_ = g_strdup ("purple");
#line 797 "../src/nibbles-game.vala"
			result = _tmp5_;
#line 797 "../src/nibbles-game.vala"
			return result;
#line 5247 "nibbles-game.c"
		}
		default:
		{
#line 798 "../src/nibbles-game.vala"
			g_assert_not_reached ();
#line 5253 "nibbles-game.c"
		}
	}
}

static inline gint
nibbles_game_get_color_num (const gchar* color)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 803 "../src/nibbles-game.vala"
	static GQuark _tmp1_label0 = 0;
#line 803 "../src/nibbles-game.vala"
	static GQuark _tmp1_label1 = 0;
#line 803 "../src/nibbles-game.vala"
	static GQuark _tmp1_label2 = 0;
#line 803 "../src/nibbles-game.vala"
	static GQuark _tmp1_label3 = 0;
#line 803 "../src/nibbles-game.vala"
	static GQuark _tmp1_label4 = 0;
#line 803 "../src/nibbles-game.vala"
	static GQuark _tmp1_label5 = 0;
#line 5275 "nibbles-game.c"
	gint result;
#line 801 "../src/nibbles-game.vala"
	g_return_val_if_fail (color != NULL, 0);
#line 803 "../src/nibbles-game.vala"
	_tmp0_ = color;
#line 803 "../src/nibbles-game.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 803 "../src/nibbles-game.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("red")))) {
#line 803 "../src/nibbles-game.vala"
		switch (0) {
#line 5287 "nibbles-game.c"
			default:
			{
#line 805 "../src/nibbles-game.vala"
				result = 0;
#line 805 "../src/nibbles-game.vala"
				return result;
#line 5294 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("green")))) {
#line 803 "../src/nibbles-game.vala"
		switch (0) {
#line 5300 "nibbles-game.c"
			default:
			{
#line 806 "../src/nibbles-game.vala"
				result = 1;
#line 806 "../src/nibbles-game.vala"
				return result;
#line 5307 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("blue")))) {
#line 803 "../src/nibbles-game.vala"
		switch (0) {
#line 5313 "nibbles-game.c"
			default:
			{
#line 807 "../src/nibbles-game.vala"
				result = 2;
#line 807 "../src/nibbles-game.vala"
				return result;
#line 5320 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("yellow")))) {
#line 803 "../src/nibbles-game.vala"
		switch (0) {
#line 5326 "nibbles-game.c"
			default:
			{
#line 808 "../src/nibbles-game.vala"
				result = 3;
#line 808 "../src/nibbles-game.vala"
				return result;
#line 5333 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("cyan")))) {
#line 803 "../src/nibbles-game.vala"
		switch (0) {
#line 5339 "nibbles-game.c"
			default:
			{
#line 809 "../src/nibbles-game.vala"
				result = 4;
#line 809 "../src/nibbles-game.vala"
				return result;
#line 5346 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("purple")))) {
#line 803 "../src/nibbles-game.vala"
		switch (0) {
#line 5352 "nibbles-game.c"
			default:
			{
#line 810 "../src/nibbles-game.vala"
				result = 5;
#line 810 "../src/nibbles-game.vala"
				return result;
#line 5359 "nibbles-game.c"
			}
		}
	} else {
#line 803 "../src/nibbles-game.vala"
		switch (0) {
#line 5365 "nibbles-game.c"
			default:
			{
#line 811 "../src/nibbles-game.vala"
				g_assert_not_reached ();
#line 5370 "nibbles-game.c"
			}
		}
	}
}

gboolean
nibbles_game_keypress (NibblesGame* self,
                       guint keyval,
                       guint keycode,
                       gboolean* remove_handler)
{
	gboolean _vala_remove_handler = FALSE;
	gboolean result;
#line 815 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 817 "../src/nibbles-game.vala"
	_vala_remove_handler = FALSE;
#line 818 "../src/nibbles-game.vala"
	result = nibbles_game_handle_keypress (self, keyval, keycode);
#line 818 "../src/nibbles-game.vala"
	if (remove_handler) {
#line 818 "../src/nibbles-game.vala"
		*remove_handler = _vala_remove_handler;
#line 5394 "nibbles-game.c"
	}
#line 818 "../src/nibbles-game.vala"
	return result;
#line 5398 "nibbles-game.c"
}

gboolean
nibbles_game_handle_keypress (NibblesGame* self,
                              guint keyval,
                              guint keycode)
{
	gboolean _tmp0_;
	gboolean result;
#line 821 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 823 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_is_running;
#line 823 "../src/nibbles-game.vala"
	if (!_tmp0_) {
#line 824 "../src/nibbles-game.vala"
		result = FALSE;
#line 824 "../src/nibbles-game.vala"
		return result;
#line 5418 "nibbles-game.c"
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
#line 826 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->_worms;
#line 826 "../src/nibbles-game.vala"
		_worm_list = _tmp1_;
#line 826 "../src/nibbles-game.vala"
		_tmp2_ = _worm_list;
#line 826 "../src/nibbles-game.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 826 "../src/nibbles-game.vala"
		_tmp4_ = _tmp3_;
#line 826 "../src/nibbles-game.vala"
		_worm_size = _tmp4_;
#line 826 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 826 "../src/nibbles-game.vala"
		while (TRUE) {
#line 5444 "nibbles-game.c"
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			Worm* _tmp9_;
#line 826 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 826 "../src/nibbles-game.vala"
			_tmp5_ = _worm_index;
#line 826 "../src/nibbles-game.vala"
			_tmp6_ = _worm_size;
#line 826 "../src/nibbles-game.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 826 "../src/nibbles-game.vala"
				break;
#line 5461 "nibbles-game.c"
			}
#line 826 "../src/nibbles-game.vala"
			_tmp7_ = _worm_list;
#line 826 "../src/nibbles-game.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
#line 826 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp8_;
#line 828 "../src/nibbles-game.vala"
			_tmp9_ = worm;
#line 828 "../src/nibbles-game.vala"
			if (_tmp9_->is_human) {
#line 5473 "nibbles-game.c"
				Worm* _tmp10_;
				GeeHashMap* _tmp11_;
				gint* _tmp12_;
				gint _tmp12__length1;
				gint _tmp12__length2;
				GeeLinkedList* _tmp13_;
#line 829 "../src/nibbles-game.vala"
				_tmp10_ = worm;
#line 829 "../src/nibbles-game.vala"
				_tmp11_ = self->priv->_worm_props;
#line 829 "../src/nibbles-game.vala"
				_tmp12_ = self->board;
#line 829 "../src/nibbles-game.vala"
				_tmp12__length1 = self->board_length1;
#line 829 "../src/nibbles-game.vala"
				_tmp12__length2 = self->board_length2;
#line 829 "../src/nibbles-game.vala"
				_tmp13_ = self->priv->_worms;
#line 829 "../src/nibbles-game.vala"
				if (worm_handle_keypress (_tmp10_, keycode, _tmp11_, _tmp12_, (gint) _tmp12__length1, (gint) _tmp12__length2, _tmp13_)) {
#line 830 "../src/nibbles-game.vala"
					result = TRUE;
#line 830 "../src/nibbles-game.vala"
					_g_object_unref0 (worm);
#line 830 "../src/nibbles-game.vala"
					return result;
#line 5500 "nibbles-game.c"
				}
			}
#line 826 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 5505 "nibbles-game.c"
		}
	}
#line 833 "../src/nibbles-game.vala"
	result = FALSE;
#line 833 "../src/nibbles-game.vala"
	return result;
#line 5512 "nibbles-game.c"
}

static GeeList*
nibbles_game_get_other_worms (NibblesGame* self,
                              Worm* _self_)
{
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp0_;
	GeeList* result;
#line 840 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 840 "../src/nibbles-game.vala"
	g_return_val_if_fail (_self_ != NULL, NULL);
#line 842 "../src/nibbles-game.vala"
	_tmp0_ = gee_array_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 842 "../src/nibbles-game.vala"
	_result_ = _tmp0_;
#line 5530 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
#line 843 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->_worms;
#line 843 "../src/nibbles-game.vala"
		_worm_list = _tmp1_;
#line 843 "../src/nibbles-game.vala"
		_tmp2_ = _worm_list;
#line 843 "../src/nibbles-game.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 843 "../src/nibbles-game.vala"
		_tmp4_ = _tmp3_;
#line 843 "../src/nibbles-game.vala"
		_worm_size = _tmp4_;
#line 843 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 843 "../src/nibbles-game.vala"
		while (TRUE) {
#line 5555 "nibbles-game.c"
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			Worm* _tmp9_;
#line 843 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 843 "../src/nibbles-game.vala"
			_tmp5_ = _worm_index;
#line 843 "../src/nibbles-game.vala"
			_tmp6_ = _worm_size;
#line 843 "../src/nibbles-game.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 843 "../src/nibbles-game.vala"
				break;
#line 5572 "nibbles-game.c"
			}
#line 843 "../src/nibbles-game.vala"
			_tmp7_ = _worm_list;
#line 843 "../src/nibbles-game.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
#line 843 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp8_;
#line 845 "../src/nibbles-game.vala"
			_tmp9_ = worm;
#line 845 "../src/nibbles-game.vala"
			if (_tmp9_ != _self_) {
#line 5584 "nibbles-game.c"
				GeeArrayList* _tmp10_;
				Worm* _tmp11_;
#line 846 "../src/nibbles-game.vala"
				_tmp10_ = _result_;
#line 846 "../src/nibbles-game.vala"
				_tmp11_ = worm;
#line 846 "../src/nibbles-game.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 5593 "nibbles-game.c"
			}
#line 843 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 5597 "nibbles-game.c"
		}
	}
#line 848 "../src/nibbles-game.vala"
	result = (GeeList*) _result_;
#line 848 "../src/nibbles-game.vala"
	return result;
#line 5604 "nibbles-game.c"
}

GeeList*
nibbles_game_get_bonuses (NibblesGame* self)
{
	Boni* _tmp0_;
	GeeList* _tmp1_;
	GeeList* result;
#line 851 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 853 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->boni;
#line 853 "../src/nibbles-game.vala"
	_tmp1_ = boni_get_bonuses (_tmp0_);
#line 853 "../src/nibbles-game.vala"
	result = _tmp1_;
#line 853 "../src/nibbles-game.vala"
	return result;
#line 5623 "nibbles-game.c"
}

gboolean
nibbles_game_get_skip_score (NibblesGame* self)
{
	gboolean result;
#line 55 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../src/nibbles-game.vala"
	result = self->priv->_skip_score;
#line 55 "../src/nibbles-game.vala"
	return result;
#line 5636 "nibbles-game.c"
}

void
nibbles_game_set_skip_score (NibblesGame* self,
                             gboolean value)
{
	gboolean old_value;
#line 55 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_skip_score (self);
#line 55 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 55 "../src/nibbles-game.vala"
		self->priv->_skip_score = value;
#line 55 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_SKIP_SCORE_PROPERTY]);
#line 5654 "nibbles-game.c"
	}
}

gint
nibbles_game_get_current_level (NibblesGame* self)
{
	gint result;
#line 56 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 56 "../src/nibbles-game.vala"
	result = self->priv->_current_level;
#line 56 "../src/nibbles-game.vala"
	return result;
#line 5668 "nibbles-game.c"
}

void
nibbles_game_set_current_level (NibblesGame* self,
                                gint value)
{
	gint old_value;
#line 56 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_current_level (self);
#line 56 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 56 "../src/nibbles-game.vala"
		self->priv->_current_level = value;
#line 56 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_CURRENT_LEVEL_PROPERTY]);
#line 5686 "nibbles-game.c"
	}
}

gboolean
nibbles_game_get_three_dimensional_view (NibblesGame* self)
{
	gboolean result;
#line 57 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../src/nibbles-game.vala"
	result = self->priv->_three_dimensional_view;
#line 57 "../src/nibbles-game.vala"
	return result;
#line 5700 "nibbles-game.c"
}

void
nibbles_game_set_three_dimensional_view (NibblesGame* self,
                                         gboolean value)
{
	gboolean old_value;
#line 57 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_three_dimensional_view (self);
#line 57 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 57 "../src/nibbles-game.vala"
		self->priv->_three_dimensional_view = value;
#line 57 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY]);
#line 5718 "nibbles-game.c"
	}
}

gint
nibbles_game_get_speed (NibblesGame* self)
{
	gint result;
#line 58 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 58 "../src/nibbles-game.vala"
	result = self->priv->_speed;
#line 58 "../src/nibbles-game.vala"
	return result;
#line 5732 "nibbles-game.c"
}

void
nibbles_game_set_speed (NibblesGame* self,
                        gint value)
{
	gint old_value;
#line 58 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_speed (self);
#line 58 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 58 "../src/nibbles-game.vala"
		self->priv->_speed = value;
#line 58 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_SPEED_PROPERTY]);
#line 5750 "nibbles-game.c"
	}
}

gint
nibbles_game_get_gamedelay (NibblesGame* self)
{
	gint result;
#line 59 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 59 "../src/nibbles-game.vala"
	result = self->priv->_gamedelay;
#line 59 "../src/nibbles-game.vala"
	return result;
#line 5764 "nibbles-game.c"
}

static void
nibbles_game_set_gamedelay (NibblesGame* self,
                            gint value)
{
	gint old_value;
#line 59 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_gamedelay (self);
#line 59 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 59 "../src/nibbles-game.vala"
		self->priv->_gamedelay = value;
#line 59 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_GAMEDELAY_PROPERTY]);
#line 5782 "nibbles-game.c"
	}
}

guint8
nibbles_game_get_width (NibblesGame* self)
{
	guint8 result;
#line 64 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 64 "../src/nibbles-game.vala"
	result = self->priv->_width;
#line 64 "../src/nibbles-game.vala"
	return result;
#line 5796 "nibbles-game.c"
}

static void
nibbles_game_set_width (NibblesGame* self,
                        guint8 value)
{
	guint8 old_value;
#line 64 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_width (self);
#line 64 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 64 "../src/nibbles-game.vala"
		self->priv->_width = value;
#line 64 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_WIDTH_PROPERTY]);
#line 5814 "nibbles-game.c"
	}
}

guint8
nibbles_game_get_height (NibblesGame* self)
{
	guint8 result;
#line 65 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 65 "../src/nibbles-game.vala"
	result = self->priv->_height;
#line 65 "../src/nibbles-game.vala"
	return result;
#line 5828 "nibbles-game.c"
}

static void
nibbles_game_set_height (NibblesGame* self,
                         guint8 value)
{
	guint8 old_value;
#line 65 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_height (self);
#line 65 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 65 "../src/nibbles-game.vala"
		self->priv->_height = value;
#line 65 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_HEIGHT_PROPERTY]);
#line 5846 "nibbles-game.c"
	}
}

gint
nibbles_game_get_numhumans (NibblesGame* self)
{
	gint result;
#line 68 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 68 "../src/nibbles-game.vala"
	result = self->priv->_numhumans;
#line 68 "../src/nibbles-game.vala"
	return result;
#line 5860 "nibbles-game.c"
}

void
nibbles_game_set_numhumans (NibblesGame* self,
                            gint value)
{
	gint old_value;
#line 68 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_numhumans (self);
#line 68 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 68 "../src/nibbles-game.vala"
		self->priv->_numhumans = value;
#line 68 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMHUMANS_PROPERTY]);
#line 5878 "nibbles-game.c"
	}
}

gint
nibbles_game_get_numai (NibblesGame* self)
{
	gint result;
#line 69 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 69 "../src/nibbles-game.vala"
	result = self->priv->_numai;
#line 69 "../src/nibbles-game.vala"
	return result;
#line 5892 "nibbles-game.c"
}

void
nibbles_game_set_numai (NibblesGame* self,
                        gint value)
{
	gint old_value;
#line 69 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_numai (self);
#line 69 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 69 "../src/nibbles-game.vala"
		self->priv->_numai = value;
#line 69 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMAI_PROPERTY]);
#line 5910 "nibbles-game.c"
	}
}

gint
nibbles_game_get_numworms (NibblesGame* self)
{
	gint result;
#line 70 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 70 "../src/nibbles-game.vala"
	result = self->priv->_numworms;
#line 70 "../src/nibbles-game.vala"
	return result;
#line 5924 "nibbles-game.c"
}

static void
nibbles_game_set_numworms (NibblesGame* self,
                           gint value)
{
	gint old_value;
#line 70 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_numworms (self);
#line 70 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 70 "../src/nibbles-game.vala"
		self->priv->_numworms = value;
#line 70 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMWORMS_PROPERTY]);
#line 5942 "nibbles-game.c"
	}
}

GeeLinkedList*
nibbles_game_get_worms (NibblesGame* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
#line 73 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worms;
#line 73 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 73 "../src/nibbles-game.vala"
	return result;
#line 5959 "nibbles-game.c"
}

GeeHashMap*
nibbles_game_get_worm_props (NibblesGame* self)
{
	GeeHashMap* result;
	GeeHashMap* _tmp0_;
#line 74 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worm_props;
#line 74 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 74 "../src/nibbles-game.vala"
	return result;
#line 5975 "nibbles-game.c"
}

gboolean
nibbles_game_get_is_running (NibblesGame* self)
{
	gboolean result;
#line 80 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 80 "../src/nibbles-game.vala"
	result = self->priv->_is_running;
#line 80 "../src/nibbles-game.vala"
	return result;
#line 5988 "nibbles-game.c"
}

static void
nibbles_game_set_is_running (NibblesGame* self,
                             gboolean value)
{
	gboolean old_value;
#line 80 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_is_running (self);
#line 80 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 80 "../src/nibbles-game.vala"
		self->priv->_is_running = value;
#line 80 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_IS_RUNNING_PROPERTY]);
#line 6006 "nibbles-game.c"
	}
}

static gboolean
nibbles_game_get_is_paused (NibblesGame* self)
{
	gboolean result;
#line 81 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 81 "../src/nibbles-game.vala"
	result = self->priv->_is_paused;
#line 81 "../src/nibbles-game.vala"
	return result;
#line 6020 "nibbles-game.c"
}

static void
nibbles_game_set_is_paused (NibblesGame* self,
                            gboolean value)
{
#line 81 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/nibbles-game.vala"
	self->priv->_is_paused = value;
#line 6031 "nibbles-game.c"
}

gboolean
nibbles_game_get_paused (NibblesGame* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 84 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 84 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_is_paused;
#line 84 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 84 "../src/nibbles-game.vala"
	return result;
#line 6047 "nibbles-game.c"
}

void
nibbles_game_set_paused (NibblesGame* self,
                         gboolean value)
{
#line 85 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/nibbles-game.vala"
	nibbles_game_set_is_paused (self, value);
#line 88 "../src/nibbles-game.vala"
	if (value) {
#line 89 "../src/nibbles-game.vala"
		nibbles_game_stop (self);
#line 6062 "nibbles-game.c"
	} else {
#line 91 "../src/nibbles-game.vala"
		nibbles_game_start (self, FALSE);
#line 6066 "nibbles-game.c"
	}
#line 85 "../src/nibbles-game.vala"
	g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_PAUSED_PROPERTY]);
#line 6070 "nibbles-game.c"
}

gboolean
nibbles_game_get_fakes (NibblesGame* self)
{
	gboolean result;
#line 97 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 97 "../src/nibbles-game.vala"
	result = self->priv->_fakes;
#line 97 "../src/nibbles-game.vala"
	return result;
#line 6083 "nibbles-game.c"
}

void
nibbles_game_set_fakes (NibblesGame* self,
                        gboolean value)
{
	gboolean old_value;
#line 97 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_fakes (self);
#line 97 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 97 "../src/nibbles-game.vala"
		self->priv->_fakes = value;
#line 97 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_FAKES_PROPERTY]);
#line 6101 "nibbles-game.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 42 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 42 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 42 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 42 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 6127 "nibbles-game.c"
	} else {
#line 42 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 42 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 6133 "nibbles-game.c"
	}
#line 42 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 42 "../src/nibbles-game.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 6139 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 42 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 42 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 42 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 42 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 6164 "nibbles-game.c"
	} else {
#line 42 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 42 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 6170 "nibbles-game.c"
	}
#line 42 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 42 "../src/nibbles-game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 6176 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR) (gpointer data1, guint8 arg_1, guint8 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 42 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 42 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 42 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 42 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 6201 "nibbles-game.c"
	} else {
#line 42 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 42 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 6207 "nibbles-game.c"
	}
#line 42 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR) (marshal_data ? marshal_data : cc->callback);
#line 42 "../src/nibbles-game.vala"
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), data2);
#line 6213 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_STRING__VOID (GClosure * closure,
                                      GValue * return_value,
                                      guint n_param_values,
                                      const GValue * param_values,
                                      gpointer invocation_hint,
                                      gpointer marshal_data)
{
	typedef const char* (*GMarshalFunc_STRING__VOID) (gpointer data1, gpointer data2);
	register GMarshalFunc_STRING__VOID callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	const char* v_return;
	cc = (GCClosure *) closure;
#line 42 "../src/nibbles-game.vala"
	g_return_if_fail (return_value != NULL);
#line 42 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 1);
#line 42 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 42 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 42 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 6241 "nibbles-game.c"
	} else {
#line 42 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 42 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 6247 "nibbles-game.c"
	}
#line 42 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_STRING__VOID) (marshal_data ? marshal_data : cc->callback);
#line 42 "../src/nibbles-game.vala"
	v_return = callback (data1, data2);
#line 42 "../src/nibbles-game.vala"
	g_value_take_string (return_value, v_return);
#line 6255 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__POINTER_POINTER) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_BOOLEAN__POINTER_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 42 "../src/nibbles-game.vala"
	g_return_if_fail (return_value != NULL);
#line 42 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 42 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 42 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 42 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 6283 "nibbles-game.c"
	} else {
#line 42 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 42 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 6289 "nibbles-game.c"
	}
#line 42 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_BOOLEAN__POINTER_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 42 "../src/nibbles-game.vala"
	v_return = callback (data1, g_value_get_pointer (param_values + 1), g_value_get_pointer (param_values + 2), data2);
#line 42 "../src/nibbles-game.vala"
	g_value_set_boolean (return_value, v_return);
#line 6297 "nibbles-game.c"
}

static void
_nibbles_game___lambda14_ (NibblesGame* self,
                           Bonus* bonus)
{
#line 123 "../src/nibbles-game.vala"
	g_return_if_fail (bonus != NULL);
#line 123 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_BONUS_REMOVED_SIGNAL], 0, bonus);
#line 6308 "nibbles-game.c"
}

static void
__nibbles_game___lambda14__boni_bonus_removed (Boni* _sender,
                                               Bonus* bonus,
                                               gpointer self)
{
#line 123 "../src/nibbles-game.vala"
	_nibbles_game___lambda14_ ((NibblesGame*) self, bonus);
#line 6318 "nibbles-game.c"
}

static GObject *
nibbles_game_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NibblesGame * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gint* _tmp2_;
	Boni* _tmp3_;
#line 120 "../src/nibbles-game.vala"
	parent_class = G_OBJECT_CLASS (nibbles_game_parent_class);
#line 120 "../src/nibbles-game.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 120 "../src/nibbles-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_GAME, NibblesGame);
#line 122 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_width;
#line 122 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_height;
#line 122 "../src/nibbles-game.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 122 "../src/nibbles-game.vala"
	self->board = (g_free (self->board), NULL);
#line 122 "../src/nibbles-game.vala"
	self->board = _tmp2_;
#line 122 "../src/nibbles-game.vala"
	self->board_length1 = _tmp0_;
#line 122 "../src/nibbles-game.vala"
	self->board_length2 = _tmp1_;
#line 123 "../src/nibbles-game.vala"
	_tmp3_ = self->priv->boni;
#line 123 "../src/nibbles-game.vala"
	g_signal_connect_object (_tmp3_, "bonus-removed", (GCallback) __nibbles_game___lambda14__boni_bonus_removed, self, 0);
#line 120 "../src/nibbles-game.vala"
	return obj;
#line 6359 "nibbles-game.c"
}

static void
nibbles_game_class_init (NibblesGameClass * klass,
                         gpointer klass_data)
{
#line 42 "../src/nibbles-game.vala"
	nibbles_game_parent_class = g_type_class_peek_parent (klass);
#line 42 "../src/nibbles-game.vala"
	g_type_class_adjust_private_offset (klass, &NibblesGame_private_offset);
#line 42 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_nibbles_game_get_property;
#line 42 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_nibbles_game_set_property;
#line 42 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->constructor = nibbles_game_constructor;
#line 42 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->finalize = nibbles_game_finalize;
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_SKIP_SCORE_PROPERTY, nibbles_game_properties[NIBBLES_GAME_SKIP_SCORE_PROPERTY] = g_param_spec_boolean ("skip-score", "skip-score", "skip-score", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_CURRENT_LEVEL_PROPERTY, nibbles_game_properties[NIBBLES_GAME_CURRENT_LEVEL_PROPERTY] = g_param_spec_int ("current-level", "current-level", "current-level", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY, nibbles_game_properties[NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY] = g_param_spec_boolean ("three-dimensional-view", "three-dimensional-view", "three-dimensional-view", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_SPEED_PROPERTY, nibbles_game_properties[NIBBLES_GAME_SPEED_PROPERTY] = g_param_spec_int ("speed", "speed", "speed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_GAMEDELAY_PROPERTY, nibbles_game_properties[NIBBLES_GAME_GAMEDELAY_PROPERTY] = g_param_spec_int ("gamedelay", "gamedelay", "gamedelay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WIDTH_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WIDTH_PROPERTY] = g_param_spec_uchar ("width", "width", "width", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_HEIGHT_PROPERTY, nibbles_game_properties[NIBBLES_GAME_HEIGHT_PROPERTY] = g_param_spec_uchar ("height", "height", "height", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMHUMANS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMHUMANS_PROPERTY] = g_param_spec_int ("numhumans", "numhumans", "numhumans", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMAI_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMAI_PROPERTY] = g_param_spec_int ("numai", "numai", "numai", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMWORMS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMWORMS_PROPERTY] = g_param_spec_int ("numworms", "numworms", "numworms", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WORMS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WORMS_PROPERTY] = g_param_spec_object ("worms", "worms", "worms", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WORM_PROPS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WORM_PROPS_PROPERTY] = g_param_spec_object ("worm-props", "worm-props", "worm-props", GEE_TYPE_HASH_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_IS_RUNNING_PROPERTY, nibbles_game_properties[NIBBLES_GAME_IS_RUNNING_PROPERTY] = g_param_spec_boolean ("is-running", "is-running", "is-running", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_PAUSED_PROPERTY, nibbles_game_properties[NIBBLES_GAME_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 42 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_FAKES_PROPERTY, nibbles_game_properties[NIBBLES_GAME_FAKES_PROPERTY] = g_param_spec_boolean ("fakes", "fakes", "fakes", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 42 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_BONUS_APPLIED_SIGNAL] = g_signal_new ("bonus-applied", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_BONUS, TYPE_WORM);
#line 42 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL] = g_signal_new ("log-score", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 42 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL] = g_signal_new ("animate-end-game", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 42 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL] = g_signal_new ("level-completed", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 42 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_WARP_ADDED_SIGNAL] = g_signal_new ("warp-added", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR, G_TYPE_NONE, 2, G_TYPE_UCHAR, G_TYPE_UCHAR);
#line 42 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_BONUS_ADDED_SIGNAL] = g_signal_new ("bonus-added", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
#line 42 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_BONUS_REMOVED_SIGNAL] = g_signal_new ("bonus-removed", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
#line 42 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_GET_PKGDATADIR_SIGNAL] = g_signal_new ("get-pkgdatadir", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_STRING__VOID, G_TYPE_STRING, 0);
#line 42 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_ADD_KEYPRESS_HANDLER_SIGNAL] = g_signal_new ("add-keypress-handler", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER, G_TYPE_BOOLEAN, 2, G_TYPE_POINTER, G_TYPE_POINTER);
#line 42 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_REDRAW_SIGNAL] = g_signal_new ("redraw", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 42 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL] = g_signal_new ("play-sound", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 6430 "nibbles-game.c"
}

static void
nibbles_game_instance_init (NibblesGame * self,
                            gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GeeHashMap* _tmp1_;
	Boni* _tmp2_;
	WarpManager* _tmp3_;
#line 42 "../src/nibbles-game.vala"
	self->priv = nibbles_game_get_instance_private (self);
#line 73 "../src/nibbles-game.vala"
	_tmp0_ = gee_linked_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 73 "../src/nibbles-game.vala"
	self->priv->_worms = _tmp0_;
#line 74 "../src/nibbles-game.vala"
	_tmp1_ = gee_hash_map_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_WORM_PROPERTIES, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 74 "../src/nibbles-game.vala"
	self->priv->_worm_props = _tmp1_;
#line 76 "../src/nibbles-game.vala"
	_tmp2_ = boni_new ();
#line 76 "../src/nibbles-game.vala"
	self->priv->boni = _tmp2_;
#line 77 "../src/nibbles-game.vala"
	_tmp3_ = warp_manager_new ();
#line 77 "../src/nibbles-game.vala"
	self->priv->warp_manager = _tmp3_;
#line 80 "../src/nibbles-game.vala"
	self->priv->_is_running = FALSE;
#line 81 "../src/nibbles-game.vala"
	self->priv->_is_paused = FALSE;
#line 95 "../src/nibbles-game.vala"
	self->priv->main_id = (guint) 0;
#line 111 "../src/nibbles-game.vala"
	self->added_keypress_handler = FALSE;
#line 325 "../src/nibbles-game.vala"
	self->priv->bonus_cycle = (guint8) 0;
#line 6469 "nibbles-game.c"
}

static void
nibbles_game_finalize (GObject * obj)
{
	NibblesGame * self;
#line 42 "../src/nibbles-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_GAME, NibblesGame);
#line 62 "../src/nibbles-game.vala"
	self->board = (g_free (self->board), NULL);
#line 73 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->_worms);
#line 74 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->_worm_props);
#line 76 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->boni);
#line 77 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->warp_manager);
#line 42 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (nibbles_game_parent_class)->finalize (obj);
#line 6490 "nibbles-game.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NibblesGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NibblesGame), 0, (GInstanceInitFunc) nibbles_game_instance_init, NULL };
	GType nibbles_game_type_id;
	nibbles_game_type_id = g_type_register_static (G_TYPE_OBJECT, "NibblesGame", &g_define_type_info, 0);
	NibblesGame_private_offset = g_type_add_instance_private (nibbles_game_type_id, sizeof (NibblesGamePrivate));
	return nibbles_game_type_id;
}

GType
nibbles_game_get_type (void)
{
	static gsize nibbles_game_type_id__once = 0;
	if (g_once_init_enter (&nibbles_game_type_id__once)) {
		GType nibbles_game_type_id;
		nibbles_game_type_id = nibbles_game_get_type_once ();
		g_once_init_leave (&nibbles_game_type_id__once, nibbles_game_type_id);
	}
	return nibbles_game_type_id__once;
}

static void
_vala_nibbles_game_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	NibblesGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIBBLES_GAME, NibblesGame);
#line 42 "../src/nibbles-game.vala"
	switch (property_id) {
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SKIP_SCORE_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_skip_score (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_CURRENT_LEVEL_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_current_level (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_three_dimensional_view (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SPEED_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_speed (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_GAMEDELAY_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_gamedelay (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WIDTH_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_uchar (value, nibbles_game_get_width (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_HEIGHT_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_uchar (value, nibbles_game_get_height (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMHUMANS_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_numhumans (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMAI_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_numai (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMWORMS_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_numworms (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WORMS_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_object (value, nibbles_game_get_worms (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WORM_PROPS_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_object (value, nibbles_game_get_worm_props (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_IS_RUNNING_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_is_running (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_PAUSED_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_paused (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_FAKES_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_fakes (self));
#line 42 "../src/nibbles-game.vala"
		break;
#line 6615 "nibbles-game.c"
		default:
#line 42 "../src/nibbles-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "../src/nibbles-game.vala"
		break;
#line 6621 "nibbles-game.c"
	}
}

static void
_vala_nibbles_game_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	NibblesGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIBBLES_GAME, NibblesGame);
#line 42 "../src/nibbles-game.vala"
	switch (property_id) {
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SKIP_SCORE_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_skip_score (self, g_value_get_boolean (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_CURRENT_LEVEL_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_current_level (self, g_value_get_int (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_three_dimensional_view (self, g_value_get_boolean (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SPEED_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_speed (self, g_value_get_int (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_GAMEDELAY_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_gamedelay (self, g_value_get_int (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WIDTH_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_width (self, g_value_get_uchar (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_HEIGHT_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_height (self, g_value_get_uchar (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMHUMANS_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_numhumans (self, g_value_get_int (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMAI_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_numai (self, g_value_get_int (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMWORMS_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_numworms (self, g_value_get_int (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_IS_RUNNING_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_is_running (self, g_value_get_boolean (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_PAUSED_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_paused (self, g_value_get_boolean (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 42 "../src/nibbles-game.vala"
		case NIBBLES_GAME_FAKES_PROPERTY:
#line 42 "../src/nibbles-game.vala"
		nibbles_game_set_fakes (self, g_value_get_boolean (value));
#line 42 "../src/nibbles-game.vala"
		break;
#line 6713 "nibbles-game.c"
		default:
#line 42 "../src/nibbles-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "../src/nibbles-game.vala"
		break;
#line 6719 "nibbles-game.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

