/* nibbles-view.c generated by valac 0.56.13, the Vala compiler
 * generated from nibbles-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 * Copyright (C) 2023 Ben Corby <bcorby@new-ms.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Coding style.
 *
 * To help you comply with the coding style in this project use the
 * following greps. Any lines returned should be adjusted so they
 * don't match. The convoluted regular expressions are so they don't 
 * match them self.
 *
 * grep -ne '[^][)(_!$ "](' *.vala
 * grep -ne '[(] ' *.vala
 * grep -ne '[ ])' *.vala
 *
 */
/* designed for Gtk 4, link with libgtk-4-dev or gtk4-devel */

#include <glib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <cairo-gobject.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <pango/pangocairo.h>
#include <gobject/gvaluecollector.h>

#define NIBBLES_VIEW_WIDTH ((guint8) 92)
#define NIBBLES_VIEW_HEIGHT ((guint8) 66)
#define NIBBLES_VIEW_NUM_COLORS 6
#define NIBBLES_GAME_WARPCHAR 'W'
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef void (*YesNoResultFunction) (guint yes_no, gpointer user_data);
typedef gboolean (*NewGameDialogueActiveFunction) (YesNoResultFunction* function, gpointer* function_target, GDestroyNotify* function_target_destroy_notify, gpointer user_data);

#define TYPE_NIBBLES_VIEW (nibbles_view_get_type ())
#define NIBBLES_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIBBLES_VIEW, NibblesView))
#define NIBBLES_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIBBLES_VIEW, NibblesViewClass))
#define IS_NIBBLES_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIBBLES_VIEW))
#define IS_NIBBLES_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIBBLES_VIEW))
#define NIBBLES_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIBBLES_VIEW, NibblesViewClass))

typedef struct _NibblesView NibblesView;
typedef struct _NibblesViewClass NibblesViewClass;
typedef struct _NibblesViewPrivate NibblesViewPrivate;

#define TYPE_NIBBLES_GAME (nibbles_game_get_type ())
#define NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIBBLES_GAME, NibblesGame))
#define NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIBBLES_GAME, NibblesGameClass))
#define IS_NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIBBLES_GAME))
#define IS_NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIBBLES_GAME))
#define NIBBLES_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIBBLES_GAME, NibblesGameClass))

typedef struct _NibblesGame NibblesGame;
typedef struct _NibblesGameClass NibblesGameClass;
typedef gint (*NibblesViewCountdownActiveFunction) (gpointer user_data);
enum  {
	NIBBLES_VIEW_0_PROPERTY,
	NIBBLES_VIEW_NUM_PROPERTIES
};
static GParamSpec* nibbles_view_properties[NIBBLES_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block6Data Block6Data;

#define NIBBLES_VIEW_TYPE_VIEW3_D (nibbles_view_view3_d_get_type ())
#define NIBBLES_VIEW_VIEW3_D(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NIBBLES_VIEW_TYPE_VIEW3_D, NibblesViewView3D))
#define NIBBLES_VIEW_VIEW3_D_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NIBBLES_VIEW_TYPE_VIEW3_D, NibblesViewView3DClass))
#define NIBBLES_VIEW_IS_VIEW3_D(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NIBBLES_VIEW_TYPE_VIEW3_D))
#define NIBBLES_VIEW_IS_VIEW3_D_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NIBBLES_VIEW_TYPE_VIEW3_D))
#define NIBBLES_VIEW_VIEW3_D_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NIBBLES_VIEW_TYPE_VIEW3_D, NibblesViewView3DClass))

typedef struct _NibblesViewView3D NibblesViewView3D;
typedef struct _NibblesViewView3DClass NibblesViewView3DClass;

#define NIBBLES_VIEW_TYPE_POINT3_D (nibbles_view_point3_d_get_type ())
typedef struct _NibblesViewPoint3D NibblesViewPoint3D;

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;
typedef struct _WormPrivate WormPrivate;

#define TYPE_WORM_POSITIONS (worm_positions_get_type ())
#define WORM_POSITIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_POSITIONS, WormPositions))
#define WORM_POSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_POSITIONS, WormPositionsClass))
#define IS_WORM_POSITIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_POSITIONS))
#define IS_WORM_POSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_POSITIONS))
#define WORM_POSITIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_POSITIONS, WormPositionsClass))

typedef struct _WormPositions WormPositions;
typedef struct _WormPositionsClass WormPositionsClass;

#define TYPE_BONUS (bonus_get_type ())
#define BONUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONUS, Bonus))
#define BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONUS, BonusClass))
#define IS_BONUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONUS))
#define IS_BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONUS))
#define BONUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONUS, BonusClass))

typedef struct _Bonus Bonus;
typedef struct _BonusClass BonusClass;

#define TYPE_WORM_PROPERTIES (worm_properties_get_type ())
#define WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_PROPERTIES, WormProperties))
#define WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_PROPERTIES, WormPropertiesClass))
#define IS_WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_PROPERTIES))
#define IS_WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_PROPERTIES))
#define WORM_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_PROPERTIES, WormPropertiesClass))

typedef struct _WormProperties WormProperties;
typedef struct _WormPropertiesClass WormPropertiesClass;

#define TYPE_POSITION (position_get_type ())
typedef struct _Position Position;
typedef enum  {
	WORM_DIRECTION_NONE,
	WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_EAST = WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_DOWN,
	WORM_DIRECTION_SOUTH = WORM_DIRECTION_DOWN,
	WORM_DIRECTION_LEFT,
	WORM_DIRECTION_WEST = WORM_DIRECTION_LEFT,
	WORM_DIRECTION_UP,
	WORM_DIRECTION_NORTH = WORM_DIRECTION_UP
} WormDirection;

#define TYPE_WORM_DIRECTION (worm_direction_get_type ())
typedef struct _NibblesGamePrivate NibblesGamePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _nibbles_view_view3_d_unref0(var) ((var == NULL) ? NULL : (var = (nibbles_view_view3_d_unref (var), NULL)))
typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

#define TYPE_BONUS_TYPE (bonus_type_get_type ())
typedef struct _Block7Data Block7Data;
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _NibblesViewView3DPrivate NibblesViewView3DPrivate;
typedef struct _NibblesViewParamSpecView3D NibblesViewParamSpecView3D;

struct _NibblesView {
	GtkDrawingArea parent_instance;
	NibblesViewPrivate * priv;
};

struct _NibblesViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _NibblesViewPrivate {
	NibblesGame* game;
	NibblesViewCountdownActiveFunction countdown_active;
	gpointer countdown_active_target;
	GDestroyNotify countdown_active_target_destroy_notify;
	NewGameDialogueActiveFunction new_game_dialogue_active;
	gpointer new_game_dialogue_active_target;
	GDestroyNotify new_game_dialogue_active_target_destroy_notify;
	YesNoResultFunction result_function;
	gpointer result_function_target;
	GDestroyNotify result_function_target_destroy_notify;
	gdouble b0_x;
	gdouble b0_y;
	gdouble b0_width;
	gdouble b0_height;
	gdouble b1_x;
	gdouble b1_y;
	gdouble b1_width;
	gdouble b1_height;
	gboolean mouse_pressed;
	guint mouse_button;
	guint64 animate;
};

struct _Block6Data {
	int _ref_count_;
	NibblesView* self;
	NibblesGame* game;
	NibblesViewCountdownActiveFunction countdown_active;
	gpointer countdown_active_target;
	NewGameDialogueActiveFunction new_game_dialogue_active;
	gpointer new_game_dialogue_active_target;
};

struct _NibblesViewPoint3D {
	gdouble x;
	gdouble y;
	gdouble z;
};

struct _Worm {
	GObject parent_instance;
	WormPrivate * priv;
	gboolean is_human;
	gboolean keypress;
	gint rounds_to_stay_still;
	gboolean is_stopped;
	WormPositions* list;
};

struct _WormClass {
	GObjectClass parent_class;
};

struct _Position {
	guint8 x;
	guint8 y;
};

struct _NibblesGame {
	GObject parent_instance;
	NibblesGamePrivate * priv;
	gint* board;
	gint board_length1;
	gint board_length2;
	gboolean added_keypress_handler;
};

struct _NibblesGameClass {
	GObjectClass parent_class;
};

struct _Block7Data {
	int _ref_count_;
	NibblesView* self;
	YesNoResultFunction result_function;
	gpointer result_function_target;
};

struct _NibblesViewView3D {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NibblesViewView3DPrivate * priv;
};

struct _NibblesViewView3DClass {
	GTypeClass parent_class;
	void (*finalize) (NibblesViewView3D *self);
};

struct _NibblesViewView3DPrivate {
	gdouble view_plain_y;
	gboolean has_view_plain_been_set;
	gdouble view_plain_z_height;
	gboolean has_view_plain_z_height_been_set;
	NibblesViewPoint3D view_point;
	gdouble x_scale;
	gdouble y_scale;
};

struct _NibblesViewParamSpecView3D {
	GParamSpec parent_instance;
};

static gint NibblesView_private_offset;
static gpointer nibbles_view_parent_class = NULL;
static gchar** nibbles_view_color_lookup;
static gint nibbles_view_color_lookup_length1;
static gint nibbles_view_color_lookup_length2;
static gchar** nibbles_view_color_lookup = NULL;
static gint nibbles_view_color_lookup_length1 = 0;
static gint nibbles_view_color_lookup_length2 = 0;
static gint NibblesViewView3D_private_offset;
static gpointer nibbles_view_view3_d_parent_class = NULL;

VALA_EXTERN void get_worm_rgb (gint color,
                   gboolean bright,
                   gdouble* r,
                   gdouble* g,
                   gdouble* b);
VALA_EXTERN void get_worm_pango_color (gint color,
                           gboolean bright,
                           PangoColor* c);
VALA_EXTERN GType nibbles_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesView, g_object_unref)
VALA_EXTERN GType nibbles_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesGame, g_object_unref)
VALA_EXTERN NibblesView* nibbles_view_new (NibblesGame* game,
                               NibblesViewCountdownActiveFunction countdown_active,
                               gpointer countdown_active_target,
                               NewGameDialogueActiveFunction new_game_dialogue_active,
                               gpointer new_game_dialogue_active_target);
VALA_EXTERN NibblesView* nibbles_view_construct (GType object_type,
                                     NibblesGame* game,
                                     NibblesViewCountdownActiveFunction countdown_active,
                                     gpointer countdown_active_target,
                                     NewGameDialogueActiveFunction new_game_dialogue_active,
                                     gpointer new_game_dialogue_active_target);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda16_ (NibblesView* self);
static void ___lambda16__gtk_widget_realize (GtkWidget* _sender,
                                      gpointer self);
static void __lambda17_ (NibblesView* self,
                  gint width,
                  gint height);
static void ___lambda17__gtk_drawing_area_resize (GtkDrawingArea* _sender,
                                           gint width,
                                           gint height,
                                           gpointer self);
static void __lambda18_ (Block6Data* _data6_,
                  GtkDrawingArea* area,
                  cairo_t* c,
                  gint width,
                  gint height);
VALA_EXTERN gboolean nibbles_game_get_three_dimensional_view (NibblesGame* self);
static gpointer nibbles_view_view3_d_ref (gpointer instance);
static void nibbles_view_view3_d_unref (gpointer instance);
static GParamSpec* nibbles_view_param_spec_view3_d (const gchar* name,
                                             const gchar* nick,
                                             const gchar* blurb,
                                             GType object_type,
                                             GParamFlags flags) G_GNUC_UNUSED ;
static void nibbles_view_value_set_view3_d (GValue* value,
                                     gpointer v_object) G_GNUC_UNUSED ;
static void nibbles_view_value_take_view3_d (GValue* value,
                                      gpointer v_object) G_GNUC_UNUSED ;
static gpointer nibbles_view_value_get_view3_d (const GValue* value) G_GNUC_UNUSED ;
static GType nibbles_view_view3_d_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesViewView3D, nibbles_view_view3_d_unref)
static NibblesViewView3D* nibbles_view_view3_d_new (void);
static NibblesViewView3D* nibbles_view_view3_d_construct (GType object_type);
static void nibbles_view_view3_d_set_view_plain (NibblesViewView3D* self,
                                          gdouble y);
static GType nibbles_view_point3_d_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static NibblesViewPoint3D* nibbles_view_point3_d_dup (const NibblesViewPoint3D* self);
static void nibbles_view_point3_d_free (NibblesViewPoint3D* self);
static void nibbles_view_view3_d_set_view_point (NibblesViewView3D* self,
                                          NibblesViewPoint3D* point,
                                          gdouble max_object_height);
static void nibbles_view_view3_d_set_scale_x (NibblesViewView3D* self,
                                       gdouble scale);
static void nibbles_view_view3_d_set_scale_y (NibblesViewView3D* self,
                                       gdouble scale);
static void nibbles_view_view3_d_to_view_plain (NibblesViewView3D* self,
                                         NibblesViewPoint3D* point,
                                         gdouble* x_at_plain,
                                         gdouble* z_at_plain);
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN GeeLinkedList* nibbles_game_get_worms (NibblesGame* self);
VALA_EXTERN GType worm_positions_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormPositions, g_object_unref)
VALA_EXTERN gboolean worm_get_is_materialized (Worm* self);
static void _vala_array_add2 (Worm** * array,
                       gint* length,
                       gint* size,
                       Worm* value);
VALA_EXTERN GType bonus_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bonus, g_object_unref)
VALA_EXTERN GeeList* nibbles_game_get_bonuses (NibblesGame* self);
VALA_EXTERN guint8 bonus_get_x (Bonus* self);
VALA_EXTERN guint8 bonus_get_y (Bonus* self);
VALA_EXTERN GType worm_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormProperties, g_object_unref)
VALA_EXTERN GeeHashMap* nibbles_game_get_worm_props (NibblesGame* self);
VALA_EXTERN gint worm_properties_get_color (WormProperties* self);
VALA_EXTERN gboolean worm_was_bonus_eaten_at_this_position (Worm* self,
                                                guint16 position);
static void nibbles_view_draw_sphere (NibblesView* self,
                               cairo_t* c,
                               NibblesViewView3D* v,
                               gint x,
                               gint y,
                               gdouble r,
                               gdouble g,
                               gdouble b,
                               gdouble size);
VALA_EXTERN GType position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Position* position_dup (const Position* self);
VALA_EXTERN void position_free (Position* self);
VALA_EXTERN void worm_get_head (Worm* self,
                    Position * result);
VALA_EXTERN GType worm_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN WormDirection worm_get_direction (Worm* self);
static void nibbles_view_draw_eyes_front (NibblesView* self,
                                   cairo_t* c,
                                   NibblesViewView3D* v,
                                   gint x,
                                   gint y,
                                   gboolean blink);
VALA_EXTERN gint worm_get_id (Worm* self);
static void nibbles_view_draw_eyes_right (NibblesView* self,
                                   cairo_t* c,
                                   NibblesViewView3D* v,
                                   gint x,
                                   gint y,
                                   gboolean blink);
static void nibbles_view_draw_eyes_left (NibblesView* self,
                                  cairo_t* c,
                                  NibblesViewView3D* v,
                                  gint x,
                                  gint y,
                                  gboolean blink);
static gdouble nibbles_view_view3_d_view_point_x (NibblesViewView3D* self);
static void nibbles_view_draw_oval (NibblesView* self,
                             cairo_t* C,
                             NibblesViewView3D* v,
                             NibblesViewPoint3D* a,
                             NibblesViewPoint3D* b,
                             NibblesViewPoint3D* c,
                             NibblesViewPoint3D* d);
static void nibbles_view_draw_3D_bonus (NibblesView* self,
                                 cairo_t* c,
                                 NibblesViewView3D* v,
                                 gint x,
                                 gint y,
                                 Bonus* bonus);
static gchar* nibbles_view_seconds_string (NibblesView* self,
                                    gint s);
static gdouble nibbles_view_view3_d_2D_diff (NibblesViewView3D* self,
                                      NibblesViewPoint3D* a,
                                      NibblesViewPoint3D* b);
static gint nibbles_view_calculate_font_size (NibblesView* self,
                                       cairo_t* C,
                                       const gchar* text,
                                       gint target_width,
                                       gdouble* width,
                                       gdouble* height);
static void nibbles_view_draw_text_font_size (NibblesView* self,
                                       cairo_t* C,
                                       gint x,
                                       gint y,
                                       const gchar* text,
                                       gint font_size);
VALA_EXTERN gint worm_get_length (Worm* self);
static void nibbles_view_draw_text_target_width (NibblesView* self,
                                          cairo_t* C,
                                          gint x,
                                          gint y,
                                          const gchar* text,
                                          gint target_width,
                                          gint color);
static gchar* nibbles_view_worm_name (NibblesView* self,
                               gint id);
static void nibbles_view_new_game_dialogue_draw (NibblesView* self,
                                          cairo_t* c,
                                          gdouble width,
                                          gdouble height,
                                          YesNoResultFunction result_function,
                                          gpointer result_function_target);
static void nibbles_view_draw_wall_segment (NibblesView* self,
                                     gint i,
                                     cairo_t* C,
                                     gint x,
                                     gint y,
                                     gint x_size,
                                     gint y_size);
VALA_EXTERN GType bonus_type_get_type (void) G_GNUC_CONST ;
static void nibbles_view_draw_bonus (NibblesView* self,
                              cairo_t* C,
                              gint x,
                              gint y,
                              gint x_size,
                              gint y_size,
                              BonusType type);
static void nibbles_view_draw_worm_segment (NibblesView* self,
                                     cairo_t* C,
                                     gint x,
                                     gint y,
                                     gint x_size,
                                     gint y_size,
                                     gint color,
                                     gboolean is_materialized,
                                     gboolean eaten_bonus);
static void _vala_array_add3 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
VALA_EXTERN BonusType bonus_get_bonus_type (Bonus* self);
static void ___lambda18__gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                              cairo_t* cr,
                                              gint width,
                                              gint height,
                                              gpointer self);
VALA_EXTERN void nibbles_view_connect_game_signals (NibblesView* self,
                                        NibblesGame* game);
VALA_EXTERN void nibbles_view_redraw (NibblesView* self,
                          gboolean AnimateStep);
static void _nibbles_view_redraw_nibbles_game_redraw (NibblesGame* _sender,
                                               gboolean animate,
                                               gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void nibbles_view_draw_dialogue (NibblesView* self,
                                 cairo_t* C,
                                 gdouble width,
                                 gdouble height,
                                 const gchar* text,
                                 gdouble* b0_x,
                                 gdouble* b0_y,
                                 gdouble* b0_width,
                                 gdouble* b0_height,
                                 gdouble* b1_x,
                                 gdouble* b1_y,
                                 gdouble* b1_width,
                                 gdouble* b1_height,
                                 gboolean draw_buttons);
static void __lambda19_ (NibblesView* self,
                  gdouble x,
                  gdouble y);
static void nibbles_view_yesno_position (NibblesView* self,
                                  gdouble x,
                                  gdouble y);
static void ___lambda19__gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                      gdouble x,
                                                      gdouble y,
                                                      gpointer self);
static void __lambda20_ (NibblesView* self,
                  gdouble x,
                  gdouble y);
static void ___lambda20__gtk_event_controller_motion_enter (GtkEventControllerMotion* _sender,
                                                     gdouble x,
                                                     gdouble y,
                                                     gpointer self);
static gboolean __lambda21_ (Block7Data* _data7_,
                      GdkEvent* event);
static gboolean ___lambda21__gtk_event_controller_legacy_event (GtkEventControllerLegacy* _sender,
                                                         GdkEvent* event,
                                                         gpointer self);
static void nibbles_view_mid_point (NibblesView* self,
                             NibblesViewPoint3D* a,
                             NibblesViewPoint3D* b,
                             NibblesViewPoint3D* result);
static void nibbles_view_draw_apple (NibblesView* self,
                              cairo_t* c,
                              NibblesViewView3D* v,
                              gdouble x,
                              gdouble y);
static void nibbles_view_draw_cherry (NibblesView* self,
                               cairo_t* c,
                               NibblesViewView3D* v,
                               gdouble x,
                               gdouble y);
static void nibbles_view_draw_banana (NibblesView* self,
                               cairo_t* c,
                               NibblesViewView3D* v,
                               gdouble x,
                               gdouble y);
static void nibbles_view_draw_heart (NibblesView* self,
                              cairo_t* c,
                              NibblesViewView3D* v,
                              gdouble x,
                              gdouble y);
static void nibbles_view_draw_diamond (NibblesView* self,
                                cairo_t* c,
                                NibblesViewView3D* v,
                                gdouble x,
                                gdouble y);
static void nibbles_view_set_color (NibblesView* self,
                             cairo_t* C,
                             gint color,
                             gboolean bright);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static void nibbles_view_get_text_offsets (NibblesView* self,
                                    cairo_t* C,
                                    const gchar* text,
                                    gint font_size,
                                    gint* x_offset,
                                    gint* y_offset);
static void _vala_array_add4 (gdouble* * array,
                       gint* length,
                       gint* size,
                       gdouble value);
static void _vala_array_add5 (gdouble* * array,
                       gint* length,
                       gint* size,
                       gdouble value);
static void nibbles_view_draw_dialogue_text (NibblesView* self,
                                      cairo_t* C,
                                      gdouble x,
                                      gdouble y,
                                      const gchar* text,
                                      gint font_size);
static gint nibbles_view_calculate_font_size_from_max (NibblesView* self,
                                                cairo_t* C,
                                                const gchar* text,
                                                gint max_width,
                                                gint max_height,
                                                gdouble* width,
                                                gdouble* height);
VALA_EXTERN gchar* nibbles_view_colorval_name_untranslated (gint colorval);
VALA_EXTERN GtkImage* nibbles_view_load_image_file (const gchar* pixmap,
                                        gint xsize,
                                        gint ysize);
static void nibbles_view_view3_d_finalize (NibblesViewView3D * obj);
static GType nibbles_view_view3_d_get_type_once (void);
static void nibbles_view_finalize (GObject * obj);
static GType nibbles_view_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

void
get_worm_rgb (gint color,
              gboolean bright,
              gdouble* r,
              gdouble* g,
              gdouble* b)
{
	gdouble _vala_r = 0.0;
	gdouble _vala_g = 0.0;
	gdouble _vala_b = 0.0;
#line 44 "../src/nibbles-view.vala"
	switch (color) {
#line 44 "../src/nibbles-view.vala"
		case 0:
#line 657 "nibbles-view.c"
		{
			gdouble _tmp0_ = 0.0;
#line 47 "../src/nibbles-view.vala"
			if (bright) {
#line 47 "../src/nibbles-view.vala"
				_tmp0_ = (gdouble) 1;
#line 664 "nibbles-view.c"
			} else {
#line 47 "../src/nibbles-view.vala"
				_tmp0_ = 0.75;
#line 668 "nibbles-view.c"
			}
#line 47 "../src/nibbles-view.vala"
			_vala_r = _tmp0_;
#line 48 "../src/nibbles-view.vala"
			_vala_g = (gdouble) 0;
#line 49 "../src/nibbles-view.vala"
			_vala_b = (gdouble) 0;
#line 50 "../src/nibbles-view.vala"
			break;
#line 678 "nibbles-view.c"
		}
#line 44 "../src/nibbles-view.vala"
		case 1:
#line 682 "nibbles-view.c"
		{
			gdouble _tmp1_ = 0.0;
#line 52 "../src/nibbles-view.vala"
			_vala_r = (gdouble) 0;
#line 53 "../src/nibbles-view.vala"
			if (bright) {
#line 53 "../src/nibbles-view.vala"
				_tmp1_ = 0.75;
#line 691 "nibbles-view.c"
			} else {
#line 53 "../src/nibbles-view.vala"
				_tmp1_ = 0.5;
#line 695 "nibbles-view.c"
			}
#line 53 "../src/nibbles-view.vala"
			_vala_g = _tmp1_;
#line 54 "../src/nibbles-view.vala"
			_vala_b = (gdouble) 0;
#line 55 "../src/nibbles-view.vala"
			break;
#line 703 "nibbles-view.c"
		}
#line 44 "../src/nibbles-view.vala"
		case 2:
#line 707 "nibbles-view.c"
		{
			gdouble _tmp2_ = 0.0;
			gdouble _tmp3_ = 0.0;
#line 57 "../src/nibbles-view.vala"
			_vala_r = (gdouble) 0;
#line 58 "../src/nibbles-view.vala"
			if (bright) {
#line 58 "../src/nibbles-view.vala"
				_tmp2_ = 0.5;
#line 717 "nibbles-view.c"
			} else {
#line 58 "../src/nibbles-view.vala"
				_tmp2_ = 0.25;
#line 721 "nibbles-view.c"
			}
#line 58 "../src/nibbles-view.vala"
			_vala_g = _tmp2_;
#line 59 "../src/nibbles-view.vala"
			if (bright) {
#line 59 "../src/nibbles-view.vala"
				_tmp3_ = (gdouble) 1;
#line 729 "nibbles-view.c"
			} else {
#line 59 "../src/nibbles-view.vala"
				_tmp3_ = 0.75;
#line 733 "nibbles-view.c"
			}
#line 59 "../src/nibbles-view.vala"
			_vala_b = _tmp3_;
#line 60 "../src/nibbles-view.vala"
			break;
#line 739 "nibbles-view.c"
		}
#line 44 "../src/nibbles-view.vala"
		case 3:
#line 743 "nibbles-view.c"
		{
			gdouble _tmp4_ = 0.0;
			gdouble _tmp5_ = 0.0;
#line 62 "../src/nibbles-view.vala"
			if (bright) {
#line 62 "../src/nibbles-view.vala"
				_tmp4_ = 0.9;
#line 751 "nibbles-view.c"
			} else {
#line 62 "../src/nibbles-view.vala"
				_tmp4_ = 0.75;
#line 755 "nibbles-view.c"
			}
#line 62 "../src/nibbles-view.vala"
			_vala_r = _tmp4_;
#line 63 "../src/nibbles-view.vala"
			if (bright) {
#line 63 "../src/nibbles-view.vala"
				_tmp5_ = 0.9;
#line 763 "nibbles-view.c"
			} else {
#line 63 "../src/nibbles-view.vala"
				_tmp5_ = 0.75;
#line 767 "nibbles-view.c"
			}
#line 63 "../src/nibbles-view.vala"
			_vala_g = _tmp5_;
#line 64 "../src/nibbles-view.vala"
			_vala_b = (gdouble) 0;
#line 65 "../src/nibbles-view.vala"
			break;
#line 775 "nibbles-view.c"
		}
#line 44 "../src/nibbles-view.vala"
		case 4:
#line 779 "nibbles-view.c"
		{
			gdouble _tmp6_ = 0.0;
			gdouble _tmp7_ = 0.0;
#line 67 "../src/nibbles-view.vala"
			_vala_r = (gdouble) 0;
#line 68 "../src/nibbles-view.vala"
			if (bright) {
#line 68 "../src/nibbles-view.vala"
				_tmp6_ = (gdouble) 1;
#line 789 "nibbles-view.c"
			} else {
#line 68 "../src/nibbles-view.vala"
				_tmp6_ = 0.75;
#line 793 "nibbles-view.c"
			}
#line 68 "../src/nibbles-view.vala"
			_vala_g = _tmp6_;
#line 69 "../src/nibbles-view.vala"
			if (bright) {
#line 69 "../src/nibbles-view.vala"
				_tmp7_ = (gdouble) 1;
#line 801 "nibbles-view.c"
			} else {
#line 69 "../src/nibbles-view.vala"
				_tmp7_ = 0.75;
#line 805 "nibbles-view.c"
			}
#line 69 "../src/nibbles-view.vala"
			_vala_b = _tmp7_;
#line 70 "../src/nibbles-view.vala"
			break;
#line 811 "nibbles-view.c"
		}
#line 44 "../src/nibbles-view.vala"
		case 5:
#line 815 "nibbles-view.c"
		{
			gdouble _tmp8_ = 0.0;
			gdouble _tmp9_ = 0.0;
#line 72 "../src/nibbles-view.vala"
			if (bright) {
#line 72 "../src/nibbles-view.vala"
				_tmp8_ = 0.75;
#line 823 "nibbles-view.c"
			} else {
#line 72 "../src/nibbles-view.vala"
				_tmp8_ = 0.5;
#line 827 "nibbles-view.c"
			}
#line 72 "../src/nibbles-view.vala"
			_vala_r = _tmp8_;
#line 73 "../src/nibbles-view.vala"
			_vala_g = (gdouble) 0;
#line 74 "../src/nibbles-view.vala"
			if (bright) {
#line 74 "../src/nibbles-view.vala"
				_tmp9_ = 0.75;
#line 837 "nibbles-view.c"
			} else {
#line 74 "../src/nibbles-view.vala"
				_tmp9_ = 0.5;
#line 841 "nibbles-view.c"
			}
#line 74 "../src/nibbles-view.vala"
			_vala_b = _tmp9_;
#line 75 "../src/nibbles-view.vala"
			break;
#line 847 "nibbles-view.c"
		}
		default:
		{
			gdouble _tmp10_ = 0.0;
			gdouble _tmp11_ = 0.0;
			gdouble _tmp12_ = 0.0;
#line 77 "../src/nibbles-view.vala"
			if (bright) {
#line 77 "../src/nibbles-view.vala"
				_tmp10_ = (gdouble) 1;
#line 858 "nibbles-view.c"
			} else {
#line 77 "../src/nibbles-view.vala"
				_tmp10_ = 0.75;
#line 862 "nibbles-view.c"
			}
#line 77 "../src/nibbles-view.vala"
			_vala_r = _tmp10_;
#line 78 "../src/nibbles-view.vala"
			if (bright) {
#line 78 "../src/nibbles-view.vala"
				_tmp11_ = (gdouble) 1;
#line 870 "nibbles-view.c"
			} else {
#line 78 "../src/nibbles-view.vala"
				_tmp11_ = 0.75;
#line 874 "nibbles-view.c"
			}
#line 78 "../src/nibbles-view.vala"
			_vala_g = _tmp11_;
#line 79 "../src/nibbles-view.vala"
			if (bright) {
#line 79 "../src/nibbles-view.vala"
				_tmp12_ = (gdouble) 1;
#line 882 "nibbles-view.c"
			} else {
#line 79 "../src/nibbles-view.vala"
				_tmp12_ = 0.75;
#line 886 "nibbles-view.c"
			}
#line 79 "../src/nibbles-view.vala"
			_vala_b = _tmp12_;
#line 80 "../src/nibbles-view.vala"
			break;
#line 892 "nibbles-view.c"
		}
	}
#line 42 "../src/nibbles-view.vala"
	if (r) {
#line 42 "../src/nibbles-view.vala"
		*r = _vala_r;
#line 899 "nibbles-view.c"
	}
#line 42 "../src/nibbles-view.vala"
	if (g) {
#line 42 "../src/nibbles-view.vala"
		*g = _vala_g;
#line 905 "nibbles-view.c"
	}
#line 42 "../src/nibbles-view.vala"
	if (b) {
#line 42 "../src/nibbles-view.vala"
		*b = _vala_b;
#line 911 "nibbles-view.c"
	}
}

void
get_worm_pango_color (gint color,
                      gboolean bright,
                      PangoColor* c)
{
	gdouble r = 0.0;
	gdouble g = 0.0;
	gdouble b = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 84 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 87 "../src/nibbles-view.vala"
	get_worm_rgb (color, bright, &_tmp0_, &_tmp1_, &_tmp2_);
#line 87 "../src/nibbles-view.vala"
	r = _tmp0_;
#line 87 "../src/nibbles-view.vala"
	g = _tmp1_;
#line 87 "../src/nibbles-view.vala"
	b = _tmp2_;
#line 88 "../src/nibbles-view.vala"
	(*c).red = (guint16) (r * 0xffff);
#line 89 "../src/nibbles-view.vala"
	(*c).green = (guint16) (g * 0xffff);
#line 90 "../src/nibbles-view.vala"
	(*c).blue = (guint16) (b * 0xffff);
#line 942 "nibbles-view.c"
}

static inline gpointer
nibbles_view_get_instance_private (NibblesView* self)
{
	return G_STRUCT_MEMBER_P (self, NibblesView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 243 "../src/nibbles-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 956 "nibbles-view.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 243 "../src/nibbles-view.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 243 "../src/nibbles-view.vala"
	return _data6_;
#line 966 "nibbles-view.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 243 "../src/nibbles-view.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 976 "nibbles-view.c"
		NibblesView* self;
#line 243 "../src/nibbles-view.vala"
		self = _data6_->self;
#line 243 "../src/nibbles-view.vala"
		_g_object_unref0 (_data6_->game);
#line 243 "../src/nibbles-view.vala"
		_g_object_unref0 (self);
#line 243 "../src/nibbles-view.vala"
		g_slice_free (Block6Data, _data6_);
#line 986 "nibbles-view.c"
	}
}

static void
__lambda16_ (NibblesView* self)
{
}

static void
___lambda16__gtk_widget_realize (GtkWidget* _sender,
                                 gpointer self)
{
#line 251 "../src/nibbles-view.vala"
	__lambda16_ ((NibblesView*) self);
#line 1001 "nibbles-view.c"
}

static void
__lambda17_ (NibblesView* self,
             gint width,
             gint height)
{
}

static void
___lambda17__gtk_drawing_area_resize (GtkDrawingArea* _sender,
                                      gint width,
                                      gint height,
                                      gpointer self)
{
#line 254 "../src/nibbles-view.vala"
	__lambda17_ ((NibblesView*) self, width, height);
#line 1019 "nibbles-view.c"
}

static void
_vala_array_add2 (Worm** * array,
                  gint* length,
                  gint* size,
                  Worm* value)
{
#line 295 "../src/nibbles-view.vala"
	if ((*length) == (*size)) {
#line 295 "../src/nibbles-view.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 295 "../src/nibbles-view.vala"
		*array = g_renew (Worm*, *array, (*size) + 1);
#line 1034 "nibbles-view.c"
	}
#line 295 "../src/nibbles-view.vala"
	(*array)[(*length)++] = value;
#line 295 "../src/nibbles-view.vala"
	(*array)[*length] = NULL;
#line 1040 "nibbles-view.c"
}

static void
_vala_array_add3 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 531 "../src/nibbles-view.vala"
	if ((*length) == (*size)) {
#line 531 "../src/nibbles-view.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 531 "../src/nibbles-view.vala"
		*array = g_renew (gint, *array, *size);
#line 1055 "nibbles-view.c"
	}
#line 531 "../src/nibbles-view.vala"
	(*array)[(*length)++] = value;
#line 1059 "nibbles-view.c"
}

static void
__lambda18_ (Block6Data* _data6_,
             GtkDrawingArea* area,
             cairo_t* c,
             gint width,
             gint height)
{
	NibblesView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 261 "../src/nibbles-view.vala"
	self = _data6_->self;
#line 261 "../src/nibbles-view.vala"
	g_return_if_fail (area != NULL);
#line 261 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 263 "../src/nibbles-view.vala"
	_tmp0_ = nibbles_game_get_three_dimensional_view (_data6_->game);
#line 263 "../src/nibbles-view.vala"
	_tmp1_ = _tmp0_;
#line 263 "../src/nibbles-view.vala"
	if (_tmp1_) {
#line 1084 "nibbles-view.c"
		gdouble x2d = 0.0;
		gdouble y2d = 0.0;
		gdouble r = 0.0;
		gdouble g = 0.0;
		gdouble b = 0.0;
		NibblesViewView3D* v = NULL;
		NibblesViewView3D* _tmp2_;
		NibblesViewView3D* _tmp3_;
		NibblesViewView3D* _tmp4_;
		NibblesViewPoint3D _tmp5_ = {0};
		NibblesViewView3D* _tmp6_;
		NibblesViewView3D* _tmp7_;
		NibblesViewView3D* _tmp8_;
		NibblesViewPoint3D _tmp9_ = {0};
		gdouble _tmp10_ = 0.0;
		gdouble _tmp11_ = 0.0;
		NibblesViewView3D* _tmp12_;
		NibblesViewPoint3D _tmp13_ = {0};
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_ = 0.0;
		NibblesViewView3D* _tmp16_;
		NibblesViewPoint3D _tmp17_ = {0};
		gdouble _tmp18_ = 0.0;
		gdouble _tmp19_ = 0.0;
		NibblesViewView3D* _tmp20_;
		NibblesViewPoint3D _tmp21_ = {0};
		gdouble _tmp22_ = 0.0;
		gdouble _tmp23_ = 0.0;
		Worm** dematerialized_worms = NULL;
		Worm** _tmp24_;
		gint dematerialized_worms_length1;
		gint _dematerialized_worms_size_;
		Worm** worm_at = NULL;
		Worm** _tmp25_;
		gint worm_at_length1;
		gint worm_at_length2;
		Worm** _tmp53_;
		gint _tmp53__length1;
		Bonus** bonus_at = NULL;
		Bonus** _tmp69_;
		gint bonus_at_length1;
		gint bonus_at_length2;
		YesNoResultFunction _tmp377_ = NULL;
		gpointer _tmp378_ = NULL;
		GDestroyNotify _tmp379_ = NULL;
		gboolean _tmp380_;
#line 268 "../src/nibbles-view.vala"
		_tmp2_ = nibbles_view_view3_d_new ();
#line 268 "../src/nibbles-view.vala"
		v = _tmp2_;
#line 269 "../src/nibbles-view.vala"
		_tmp3_ = v;
#line 269 "../src/nibbles-view.vala"
		nibbles_view_view3_d_set_view_plain (_tmp3_, (gdouble) NIBBLES_VIEW_HEIGHT);
#line 270 "../src/nibbles-view.vala"
		_tmp4_ = v;
#line 270 "../src/nibbles-view.vala"
		_tmp5_.x = ((gdouble) NIBBLES_VIEW_WIDTH) / 2.0;
#line 270 "../src/nibbles-view.vala"
		_tmp5_.y = 2.0 * ((gdouble) NIBBLES_VIEW_HEIGHT);
#line 270 "../src/nibbles-view.vala"
		_tmp5_.z = 2.0 * ((gdouble) NIBBLES_VIEW_HEIGHT);
#line 270 "../src/nibbles-view.vala"
		nibbles_view_view3_d_set_view_point (_tmp4_, &_tmp5_, (gdouble) 1);
#line 271 "../src/nibbles-view.vala"
		_tmp6_ = v;
#line 271 "../src/nibbles-view.vala"
		nibbles_view_view3_d_set_scale_x (_tmp6_, (gdouble) (width / NIBBLES_VIEW_WIDTH));
#line 272 "../src/nibbles-view.vala"
		_tmp7_ = v;
#line 272 "../src/nibbles-view.vala"
		nibbles_view_view3_d_set_scale_y (_tmp7_, (gdouble) (height / NIBBLES_VIEW_HEIGHT));
#line 275 "../src/nibbles-view.vala"
		_tmp8_ = v;
#line 275 "../src/nibbles-view.vala"
		_tmp9_.x = (gdouble) 0;
#line 275 "../src/nibbles-view.vala"
		_tmp9_.y = (gdouble) 0;
#line 275 "../src/nibbles-view.vala"
		_tmp9_.z = (gdouble) 0;
#line 275 "../src/nibbles-view.vala"
		nibbles_view_view3_d_to_view_plain (_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 275 "../src/nibbles-view.vala"
		x2d = _tmp10_;
#line 275 "../src/nibbles-view.vala"
		y2d = _tmp11_;
#line 276 "../src/nibbles-view.vala"
		cairo_move_to (c, x2d, y2d);
#line 277 "../src/nibbles-view.vala"
		_tmp12_ = v;
#line 277 "../src/nibbles-view.vala"
		_tmp13_.x = (gdouble) NIBBLES_VIEW_WIDTH;
#line 277 "../src/nibbles-view.vala"
		_tmp13_.y = (gdouble) 0;
#line 277 "../src/nibbles-view.vala"
		_tmp13_.z = (gdouble) 0;
#line 277 "../src/nibbles-view.vala"
		nibbles_view_view3_d_to_view_plain (_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 277 "../src/nibbles-view.vala"
		x2d = _tmp14_;
#line 277 "../src/nibbles-view.vala"
		y2d = _tmp15_;
#line 278 "../src/nibbles-view.vala"
		cairo_line_to (c, x2d, y2d);
#line 279 "../src/nibbles-view.vala"
		_tmp16_ = v;
#line 279 "../src/nibbles-view.vala"
		_tmp17_.x = (gdouble) NIBBLES_VIEW_WIDTH;
#line 279 "../src/nibbles-view.vala"
		_tmp17_.y = (gdouble) NIBBLES_VIEW_HEIGHT;
#line 279 "../src/nibbles-view.vala"
		_tmp17_.z = (gdouble) 0;
#line 279 "../src/nibbles-view.vala"
		nibbles_view_view3_d_to_view_plain (_tmp16_, &_tmp17_, &_tmp18_, &_tmp19_);
#line 279 "../src/nibbles-view.vala"
		x2d = _tmp18_;
#line 279 "../src/nibbles-view.vala"
		y2d = _tmp19_;
#line 280 "../src/nibbles-view.vala"
		cairo_line_to (c, x2d, y2d);
#line 281 "../src/nibbles-view.vala"
		_tmp20_ = v;
#line 281 "../src/nibbles-view.vala"
		_tmp21_.x = (gdouble) 0;
#line 281 "../src/nibbles-view.vala"
		_tmp21_.y = (gdouble) NIBBLES_VIEW_HEIGHT;
#line 281 "../src/nibbles-view.vala"
		_tmp21_.z = (gdouble) 0;
#line 281 "../src/nibbles-view.vala"
		nibbles_view_view3_d_to_view_plain (_tmp20_, &_tmp21_, &_tmp22_, &_tmp23_);
#line 281 "../src/nibbles-view.vala"
		x2d = _tmp22_;
#line 281 "../src/nibbles-view.vala"
		y2d = _tmp23_;
#line 282 "../src/nibbles-view.vala"
		cairo_line_to (c, x2d, y2d);
#line 283 "../src/nibbles-view.vala"
		cairo_set_source_rgb (c, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 284 "../src/nibbles-view.vala"
		cairo_fill (c);
#line 287 "../src/nibbles-view.vala"
		_tmp24_ = g_new0 (Worm*, 0 + 1);
#line 287 "../src/nibbles-view.vala"
		dematerialized_worms = _tmp24_;
#line 287 "../src/nibbles-view.vala"
		dematerialized_worms_length1 = 0;
#line 287 "../src/nibbles-view.vala"
		_dematerialized_worms_size_ = dematerialized_worms_length1;
#line 288 "../src/nibbles-view.vala"
		_tmp25_ = g_new0 (Worm*, (NIBBLES_VIEW_WIDTH * NIBBLES_VIEW_HEIGHT) + 1);
#line 288 "../src/nibbles-view.vala"
		worm_at = _tmp25_;
#line 288 "../src/nibbles-view.vala"
		worm_at_length1 = NIBBLES_VIEW_WIDTH;
#line 288 "../src/nibbles-view.vala"
		worm_at_length2 = NIBBLES_VIEW_HEIGHT;
#line 1241 "nibbles-view.c"
		{
			GeeLinkedList* _worm_list = NULL;
			GeeLinkedList* _tmp26_;
			GeeLinkedList* _tmp27_;
			gint _worm_size = 0;
			GeeLinkedList* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gint _worm_index = 0;
#line 289 "../src/nibbles-view.vala"
			_tmp26_ = nibbles_game_get_worms (_data6_->game);
#line 289 "../src/nibbles-view.vala"
			_tmp27_ = _tmp26_;
#line 289 "../src/nibbles-view.vala"
			_worm_list = _tmp27_;
#line 289 "../src/nibbles-view.vala"
			_tmp28_ = _worm_list;
#line 289 "../src/nibbles-view.vala"
			_tmp29_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp28_);
#line 289 "../src/nibbles-view.vala"
			_tmp30_ = _tmp29_;
#line 289 "../src/nibbles-view.vala"
			_worm_size = _tmp30_;
#line 289 "../src/nibbles-view.vala"
			_worm_index = -1;
#line 289 "../src/nibbles-view.vala"
			while (TRUE) {
#line 1269 "nibbles-view.c"
				gint _tmp31_;
				gint _tmp32_;
				Worm* worm = NULL;
				GeeLinkedList* _tmp33_;
				gpointer _tmp34_;
				Worm* _tmp35_;
#line 289 "../src/nibbles-view.vala"
				_worm_index = _worm_index + 1;
#line 289 "../src/nibbles-view.vala"
				_tmp31_ = _worm_index;
#line 289 "../src/nibbles-view.vala"
				_tmp32_ = _worm_size;
#line 289 "../src/nibbles-view.vala"
				if (!(_tmp31_ < _tmp32_)) {
#line 289 "../src/nibbles-view.vala"
					break;
#line 1286 "nibbles-view.c"
				}
#line 289 "../src/nibbles-view.vala"
				_tmp33_ = _worm_list;
#line 289 "../src/nibbles-view.vala"
				_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) _tmp33_, _worm_index);
#line 289 "../src/nibbles-view.vala"
				worm = (Worm*) _tmp34_;
#line 290 "../src/nibbles-view.vala"
				_tmp35_ = worm;
#line 290 "../src/nibbles-view.vala"
				if (!_tmp35_->is_stopped) {
#line 1298 "nibbles-view.c"
					Worm* _tmp36_;
					gboolean _tmp37_;
					gboolean _tmp38_;
#line 291 "../src/nibbles-view.vala"
					_tmp36_ = worm;
#line 291 "../src/nibbles-view.vala"
					_tmp37_ = worm_get_is_materialized (_tmp36_);
#line 291 "../src/nibbles-view.vala"
					_tmp38_ = _tmp37_;
#line 291 "../src/nibbles-view.vala"
					if (_tmp38_) {
#line 1310 "nibbles-view.c"
						{
							WormPositions* _p_list = NULL;
							Worm* _tmp39_;
							WormPositions* _tmp40_;
							gint _p_size = 0;
							WormPositions* _tmp41_;
							gint _tmp42_;
							gint _tmp43_;
							gint _p_index = 0;
#line 292 "../src/nibbles-view.vala"
							_tmp39_ = worm;
#line 292 "../src/nibbles-view.vala"
							_tmp40_ = _tmp39_->list;
#line 292 "../src/nibbles-view.vala"
							_p_list = _tmp40_;
#line 292 "../src/nibbles-view.vala"
							_tmp41_ = _p_list;
#line 292 "../src/nibbles-view.vala"
							_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
#line 292 "../src/nibbles-view.vala"
							_tmp43_ = _tmp42_;
#line 292 "../src/nibbles-view.vala"
							_p_size = _tmp43_;
#line 292 "../src/nibbles-view.vala"
							_p_index = -1;
#line 292 "../src/nibbles-view.vala"
							while (TRUE) {
#line 1338 "nibbles-view.c"
								gint _tmp44_;
								gint _tmp45_;
								guint16 p = 0U;
								WormPositions* _tmp46_;
								gpointer _tmp47_;
								Worm** _tmp48_;
								gint _tmp48__length1;
								gint _tmp48__length2;
								Worm* _tmp49_;
								Worm* _tmp50_;
#line 292 "../src/nibbles-view.vala"
								_p_index = _p_index + 1;
#line 292 "../src/nibbles-view.vala"
								_tmp44_ = _p_index;
#line 292 "../src/nibbles-view.vala"
								_tmp45_ = _p_size;
#line 292 "../src/nibbles-view.vala"
								if (!(_tmp44_ < _tmp45_)) {
#line 292 "../src/nibbles-view.vala"
									break;
#line 1359 "nibbles-view.c"
								}
#line 292 "../src/nibbles-view.vala"
								_tmp46_ = _p_list;
#line 292 "../src/nibbles-view.vala"
								_tmp47_ = gee_abstract_list_get ((GeeAbstractList*) _tmp46_, _p_index);
#line 292 "../src/nibbles-view.vala"
								p = (guint16) ((guintptr) _tmp47_);
#line 293 "../src/nibbles-view.vala"
								_tmp48_ = worm_at;
#line 293 "../src/nibbles-view.vala"
								_tmp48__length1 = worm_at_length1;
#line 293 "../src/nibbles-view.vala"
								_tmp48__length2 = worm_at_length2;
#line 293 "../src/nibbles-view.vala"
								_tmp49_ = worm;
#line 293 "../src/nibbles-view.vala"
								_tmp50_ = _g_object_ref0 (_tmp49_);
#line 293 "../src/nibbles-view.vala"
								_g_object_unref0 (_tmp48_[((p >> 8) * _tmp48__length2) + ((guint8) p)]);
#line 293 "../src/nibbles-view.vala"
								_tmp48_[((p >> 8) * _tmp48__length2) + ((guint8) p)] = _tmp50_;
#line 1381 "nibbles-view.c"
							}
						}
					} else {
						Worm* _tmp51_;
						Worm* _tmp52_;
#line 295 "../src/nibbles-view.vala"
						_tmp51_ = worm;
#line 295 "../src/nibbles-view.vala"
						_tmp52_ = _g_object_ref0 (_tmp51_);
#line 295 "../src/nibbles-view.vala"
						_vala_array_add2 (&dematerialized_worms, &dematerialized_worms_length1, &_dematerialized_worms_size_, _tmp52_);
#line 1393 "nibbles-view.c"
					}
				}
#line 289 "../src/nibbles-view.vala"
				_g_object_unref0 (worm);
#line 1398 "nibbles-view.c"
			}
		}
#line 296 "../src/nibbles-view.vala"
		_tmp53_ = dematerialized_worms;
#line 296 "../src/nibbles-view.vala"
		_tmp53__length1 = dematerialized_worms_length1;
#line 1405 "nibbles-view.c"
		{
			Worm** worm_collection = NULL;
			gint worm_collection_length1 = 0;
			gint _worm_collection_size_ = 0;
			gint worm_it = 0;
#line 296 "../src/nibbles-view.vala"
			worm_collection = _tmp53_;
#line 296 "../src/nibbles-view.vala"
			worm_collection_length1 = _tmp53__length1;
#line 296 "../src/nibbles-view.vala"
			for (worm_it = 0; worm_it < worm_collection_length1; worm_it = worm_it + 1) {
#line 1417 "nibbles-view.c"
				Worm* _tmp54_;
				Worm* worm = NULL;
#line 296 "../src/nibbles-view.vala"
				_tmp54_ = _g_object_ref0 (worm_collection[worm_it]);
#line 296 "../src/nibbles-view.vala"
				worm = _tmp54_;
#line 1424 "nibbles-view.c"
				{
					{
						WormPositions* _p_list = NULL;
						Worm* _tmp55_;
						WormPositions* _tmp56_;
						gint _p_size = 0;
						WormPositions* _tmp57_;
						gint _tmp58_;
						gint _tmp59_;
						gint _p_index = 0;
#line 297 "../src/nibbles-view.vala"
						_tmp55_ = worm;
#line 297 "../src/nibbles-view.vala"
						_tmp56_ = _tmp55_->list;
#line 297 "../src/nibbles-view.vala"
						_p_list = _tmp56_;
#line 297 "../src/nibbles-view.vala"
						_tmp57_ = _p_list;
#line 297 "../src/nibbles-view.vala"
						_tmp58_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp57_);
#line 297 "../src/nibbles-view.vala"
						_tmp59_ = _tmp58_;
#line 297 "../src/nibbles-view.vala"
						_p_size = _tmp59_;
#line 297 "../src/nibbles-view.vala"
						_p_index = -1;
#line 297 "../src/nibbles-view.vala"
						while (TRUE) {
#line 1453 "nibbles-view.c"
							gint _tmp60_;
							gint _tmp61_;
							guint16 p = 0U;
							WormPositions* _tmp62_;
							gpointer _tmp63_;
							Worm** _tmp64_;
							gint _tmp64__length1;
							gint _tmp64__length2;
							Worm* _tmp65_;
#line 297 "../src/nibbles-view.vala"
							_p_index = _p_index + 1;
#line 297 "../src/nibbles-view.vala"
							_tmp60_ = _p_index;
#line 297 "../src/nibbles-view.vala"
							_tmp61_ = _p_size;
#line 297 "../src/nibbles-view.vala"
							if (!(_tmp60_ < _tmp61_)) {
#line 297 "../src/nibbles-view.vala"
								break;
#line 1473 "nibbles-view.c"
							}
#line 297 "../src/nibbles-view.vala"
							_tmp62_ = _p_list;
#line 297 "../src/nibbles-view.vala"
							_tmp63_ = gee_abstract_list_get ((GeeAbstractList*) _tmp62_, _p_index);
#line 297 "../src/nibbles-view.vala"
							p = (guint16) ((guintptr) _tmp63_);
#line 298 "../src/nibbles-view.vala"
							_tmp64_ = worm_at;
#line 298 "../src/nibbles-view.vala"
							_tmp64__length1 = worm_at_length1;
#line 298 "../src/nibbles-view.vala"
							_tmp64__length2 = worm_at_length2;
#line 298 "../src/nibbles-view.vala"
							_tmp65_ = _tmp64_[((p >> 8) * _tmp64__length2) + ((guint8) p)];
#line 298 "../src/nibbles-view.vala"
							if (_tmp65_ == NULL) {
#line 1491 "nibbles-view.c"
								Worm** _tmp66_;
								gint _tmp66__length1;
								gint _tmp66__length2;
								Worm* _tmp67_;
								Worm* _tmp68_;
#line 299 "../src/nibbles-view.vala"
								_tmp66_ = worm_at;
#line 299 "../src/nibbles-view.vala"
								_tmp66__length1 = worm_at_length1;
#line 299 "../src/nibbles-view.vala"
								_tmp66__length2 = worm_at_length2;
#line 299 "../src/nibbles-view.vala"
								_tmp67_ = worm;
#line 299 "../src/nibbles-view.vala"
								_tmp68_ = _g_object_ref0 (_tmp67_);
#line 299 "../src/nibbles-view.vala"
								_g_object_unref0 (_tmp66_[((p >> 8) * _tmp66__length2) + ((guint8) p)]);
#line 299 "../src/nibbles-view.vala"
								_tmp66_[((p >> 8) * _tmp66__length2) + ((guint8) p)] = _tmp68_;
#line 1511 "nibbles-view.c"
							}
						}
					}
#line 296 "../src/nibbles-view.vala"
					_g_object_unref0 (worm);
#line 1517 "nibbles-view.c"
				}
			}
		}
#line 302 "../src/nibbles-view.vala"
		_tmp69_ = g_new0 (Bonus*, (NIBBLES_VIEW_WIDTH * NIBBLES_VIEW_HEIGHT) + 1);
#line 302 "../src/nibbles-view.vala"
		bonus_at = _tmp69_;
#line 302 "../src/nibbles-view.vala"
		bonus_at_length1 = NIBBLES_VIEW_WIDTH;
#line 302 "../src/nibbles-view.vala"
		bonus_at_length2 = NIBBLES_VIEW_HEIGHT;
#line 1529 "nibbles-view.c"
		{
			GeeList* _bonus_list = NULL;
			GeeList* _tmp70_;
			gint _bonus_size = 0;
			GeeList* _tmp71_;
			gint _tmp72_;
			gint _tmp73_;
			gint _bonus_index = 0;
#line 303 "../src/nibbles-view.vala"
			_tmp70_ = nibbles_game_get_bonuses (_data6_->game);
#line 303 "../src/nibbles-view.vala"
			_bonus_list = _tmp70_;
#line 303 "../src/nibbles-view.vala"
			_tmp71_ = _bonus_list;
#line 303 "../src/nibbles-view.vala"
			_tmp72_ = gee_collection_get_size ((GeeCollection*) _tmp71_);
#line 303 "../src/nibbles-view.vala"
			_tmp73_ = _tmp72_;
#line 303 "../src/nibbles-view.vala"
			_bonus_size = _tmp73_;
#line 303 "../src/nibbles-view.vala"
			_bonus_index = -1;
#line 303 "../src/nibbles-view.vala"
			while (TRUE) {
#line 1554 "nibbles-view.c"
				gint _tmp74_;
				gint _tmp75_;
				Bonus* bonus = NULL;
				GeeList* _tmp76_;
				gpointer _tmp77_;
				Bonus** _tmp78_;
				gint _tmp78__length1;
				gint _tmp78__length2;
				Bonus* _tmp79_;
				guint8 _tmp80_;
				guint8 _tmp81_;
				Bonus* _tmp82_;
				guint8 _tmp83_;
				guint8 _tmp84_;
				Bonus* _tmp85_;
				Bonus* _tmp86_;
#line 303 "../src/nibbles-view.vala"
				_bonus_index = _bonus_index + 1;
#line 303 "../src/nibbles-view.vala"
				_tmp74_ = _bonus_index;
#line 303 "../src/nibbles-view.vala"
				_tmp75_ = _bonus_size;
#line 303 "../src/nibbles-view.vala"
				if (!(_tmp74_ < _tmp75_)) {
#line 303 "../src/nibbles-view.vala"
					break;
#line 1581 "nibbles-view.c"
				}
#line 303 "../src/nibbles-view.vala"
				_tmp76_ = _bonus_list;
#line 303 "../src/nibbles-view.vala"
				_tmp77_ = gee_list_get (_tmp76_, _bonus_index);
#line 303 "../src/nibbles-view.vala"
				bonus = (Bonus*) _tmp77_;
#line 304 "../src/nibbles-view.vala"
				_tmp78_ = bonus_at;
#line 304 "../src/nibbles-view.vala"
				_tmp78__length1 = bonus_at_length1;
#line 304 "../src/nibbles-view.vala"
				_tmp78__length2 = bonus_at_length2;
#line 304 "../src/nibbles-view.vala"
				_tmp79_ = bonus;
#line 304 "../src/nibbles-view.vala"
				_tmp80_ = bonus_get_x (_tmp79_);
#line 304 "../src/nibbles-view.vala"
				_tmp81_ = _tmp80_;
#line 304 "../src/nibbles-view.vala"
				_tmp82_ = bonus;
#line 304 "../src/nibbles-view.vala"
				_tmp83_ = bonus_get_y (_tmp82_);
#line 304 "../src/nibbles-view.vala"
				_tmp84_ = _tmp83_;
#line 304 "../src/nibbles-view.vala"
				_tmp85_ = bonus;
#line 304 "../src/nibbles-view.vala"
				_tmp86_ = _g_object_ref0 (_tmp85_);
#line 304 "../src/nibbles-view.vala"
				_g_object_unref0 (_tmp78_[(_tmp81_ * _tmp78__length2) + _tmp84_]);
#line 304 "../src/nibbles-view.vala"
				_tmp78_[(_tmp81_ * _tmp78__length2) + _tmp84_] = _tmp86_;
#line 303 "../src/nibbles-view.vala"
				_g_object_unref0 (bonus);
#line 1617 "nibbles-view.c"
			}
#line 303 "../src/nibbles-view.vala"
			_g_object_unref0 (_bonus_list);
#line 1621 "nibbles-view.c"
		}
		{
			gint y = 0;
#line 307 "../src/nibbles-view.vala"
			y = 0;
#line 1627 "nibbles-view.c"
			{
				gboolean _tmp87_ = FALSE;
#line 307 "../src/nibbles-view.vala"
				_tmp87_ = TRUE;
#line 307 "../src/nibbles-view.vala"
				while (TRUE) {
#line 307 "../src/nibbles-view.vala"
					if (!_tmp87_) {
#line 1636 "nibbles-view.c"
						gint _tmp88_;
#line 307 "../src/nibbles-view.vala"
						_tmp88_ = y;
#line 307 "../src/nibbles-view.vala"
						y = _tmp88_ + 1;
#line 1642 "nibbles-view.c"
					}
#line 307 "../src/nibbles-view.vala"
					_tmp87_ = FALSE;
#line 307 "../src/nibbles-view.vala"
					if (!(y < ((gint) NIBBLES_VIEW_HEIGHT))) {
#line 307 "../src/nibbles-view.vala"
						break;
#line 1650 "nibbles-view.c"
					}
					{
						gint x = 0;
#line 309 "../src/nibbles-view.vala"
						x = 0;
#line 1656 "nibbles-view.c"
						{
							gboolean _tmp89_ = FALSE;
#line 309 "../src/nibbles-view.vala"
							_tmp89_ = TRUE;
#line 309 "../src/nibbles-view.vala"
							while (TRUE) {
#line 1663 "nibbles-view.c"
								Worm** _tmp91_;
								gint _tmp91__length1;
								gint _tmp91__length2;
								Worm* _tmp92_;
								gboolean _tmp136_ = FALSE;
								gint* _tmp137_;
								gint _tmp137__length1;
								gint _tmp137__length2;
								gint _tmp138_;
								gboolean _tmp219_ = FALSE;
								gboolean _tmp220_ = FALSE;
								gboolean _tmp221_ = FALSE;
								gint* _tmp222_;
								gint _tmp222__length1;
								gint _tmp222__length2;
								gint _tmp223_;
								Bonus** _tmp253_;
								gint _tmp253__length1;
								gint _tmp253__length2;
								Bonus* _tmp254_;
#line 309 "../src/nibbles-view.vala"
								if (!_tmp89_) {
#line 1686 "nibbles-view.c"
									gint _tmp90_ = 0;
#line 309 "../src/nibbles-view.vala"
									if (x < (NIBBLES_VIEW_WIDTH / 2)) {
#line 309 "../src/nibbles-view.vala"
										_tmp90_ = (NIBBLES_VIEW_WIDTH - 1) - x;
#line 1692 "nibbles-view.c"
									} else {
#line 309 "../src/nibbles-view.vala"
										_tmp90_ = NIBBLES_VIEW_WIDTH - x;
#line 1696 "nibbles-view.c"
									}
#line 309 "../src/nibbles-view.vala"
									x = _tmp90_;
#line 1700 "nibbles-view.c"
								}
#line 309 "../src/nibbles-view.vala"
								_tmp89_ = FALSE;
#line 311 "../src/nibbles-view.vala"
								_tmp91_ = worm_at;
#line 311 "../src/nibbles-view.vala"
								_tmp91__length1 = worm_at_length1;
#line 311 "../src/nibbles-view.vala"
								_tmp91__length2 = worm_at_length2;
#line 311 "../src/nibbles-view.vala"
								_tmp92_ = _tmp91_[(x * _tmp91__length2) + y];
#line 311 "../src/nibbles-view.vala"
								if (_tmp92_ != NULL) {
#line 1714 "nibbles-view.c"
									GeeHashMap* _tmp93_;
									GeeHashMap* _tmp94_;
									Worm** _tmp95_;
									gint _tmp95__length1;
									gint _tmp95__length2;
									Worm* _tmp96_;
									gpointer _tmp97_;
									WormProperties* _tmp98_;
									gint _tmp99_;
									gint _tmp100_;
									gdouble _tmp101_ = 0.0;
									gdouble _tmp102_ = 0.0;
									gdouble _tmp103_ = 0.0;
									Worm** _tmp104_;
									gint _tmp104__length1;
									gint _tmp104__length2;
									Worm* _tmp105_;
									gdouble _tmp106_ = 0.0;
									Worm** _tmp107_;
									gint _tmp107__length1;
									gint _tmp107__length2;
									Worm* _tmp108_;
									NibblesViewView3D* _tmp109_;
									Position head = {0};
									Worm** _tmp110_;
									gint _tmp110__length1;
									gint _tmp110__length2;
									Worm* _tmp111_;
									Position _tmp112_ = {0};
									Position _tmp113_;
									gboolean _tmp114_ = FALSE;
									Position _tmp115_;
#line 313 "../src/nibbles-view.vala"
									_tmp93_ = nibbles_game_get_worm_props (_data6_->game);
#line 313 "../src/nibbles-view.vala"
									_tmp94_ = _tmp93_;
#line 313 "../src/nibbles-view.vala"
									_tmp95_ = worm_at;
#line 313 "../src/nibbles-view.vala"
									_tmp95__length1 = worm_at_length1;
#line 313 "../src/nibbles-view.vala"
									_tmp95__length2 = worm_at_length2;
#line 313 "../src/nibbles-view.vala"
									_tmp96_ = _tmp95_[(x * _tmp95__length2) + y];
#line 313 "../src/nibbles-view.vala"
									_tmp97_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp94_, _tmp96_);
#line 313 "../src/nibbles-view.vala"
									_tmp98_ = (WormProperties*) _tmp97_;
#line 313 "../src/nibbles-view.vala"
									_tmp99_ = worm_properties_get_color (_tmp98_);
#line 313 "../src/nibbles-view.vala"
									_tmp100_ = _tmp99_;
#line 313 "../src/nibbles-view.vala"
									get_worm_rgb (_tmp100_, TRUE, &_tmp101_, &_tmp102_, &_tmp103_);
#line 313 "../src/nibbles-view.vala"
									r = _tmp101_;
#line 313 "../src/nibbles-view.vala"
									g = _tmp102_;
#line 313 "../src/nibbles-view.vala"
									b = _tmp103_;
#line 313 "../src/nibbles-view.vala"
									_g_object_unref0 (_tmp98_);
#line 314 "../src/nibbles-view.vala"
									_tmp104_ = worm_at;
#line 314 "../src/nibbles-view.vala"
									_tmp104__length1 = worm_at_length1;
#line 314 "../src/nibbles-view.vala"
									_tmp104__length2 = worm_at_length2;
#line 314 "../src/nibbles-view.vala"
									_tmp105_ = _tmp104_[(x * _tmp104__length2) + y];
#line 314 "../src/nibbles-view.vala"
									worm_was_bonus_eaten_at_this_position (_tmp105_, (guint16) ((x << 8) | y));
#line 315 "../src/nibbles-view.vala"
									_tmp107_ = worm_at;
#line 315 "../src/nibbles-view.vala"
									_tmp107__length1 = worm_at_length1;
#line 315 "../src/nibbles-view.vala"
									_tmp107__length2 = worm_at_length2;
#line 315 "../src/nibbles-view.vala"
									_tmp108_ = _tmp107_[(x * _tmp107__length2) + y];
#line 315 "../src/nibbles-view.vala"
									if (worm_was_bonus_eaten_at_this_position (_tmp108_, (guint16) ((x << 8) | y))) {
#line 315 "../src/nibbles-view.vala"
										_tmp106_ = 1.25;
#line 1799 "nibbles-view.c"
									} else {
#line 315 "../src/nibbles-view.vala"
										_tmp106_ = (gdouble) 1;
#line 1803 "nibbles-view.c"
									}
#line 315 "../src/nibbles-view.vala"
									_tmp109_ = v;
#line 315 "../src/nibbles-view.vala"
									nibbles_view_draw_sphere (self, c, _tmp109_, x, y, r, g, b, _tmp106_);
#line 316 "../src/nibbles-view.vala"
									_tmp110_ = worm_at;
#line 316 "../src/nibbles-view.vala"
									_tmp110__length1 = worm_at_length1;
#line 316 "../src/nibbles-view.vala"
									_tmp110__length2 = worm_at_length2;
#line 316 "../src/nibbles-view.vala"
									_tmp111_ = _tmp110_[(x * _tmp110__length2) + y];
#line 316 "../src/nibbles-view.vala"
									worm_get_head (_tmp111_, &_tmp112_);
#line 316 "../src/nibbles-view.vala"
									_tmp113_ = _tmp112_;
#line 316 "../src/nibbles-view.vala"
									head = _tmp113_;
#line 317 "../src/nibbles-view.vala"
									_tmp115_ = head;
#line 317 "../src/nibbles-view.vala"
									if (((gint) _tmp115_.x) == x) {
#line 1827 "nibbles-view.c"
										Position _tmp116_;
#line 317 "../src/nibbles-view.vala"
										_tmp116_ = head;
#line 317 "../src/nibbles-view.vala"
										_tmp114_ = ((gint) _tmp116_.y) == y;
#line 1833 "nibbles-view.c"
									} else {
#line 317 "../src/nibbles-view.vala"
										_tmp114_ = FALSE;
#line 1837 "nibbles-view.c"
									}
#line 317 "../src/nibbles-view.vala"
									if (_tmp114_) {
#line 1841 "nibbles-view.c"
										Worm** _tmp117_;
										gint _tmp117__length1;
										gint _tmp117__length2;
										Worm* _tmp118_;
										WormDirection _tmp119_;
										WormDirection _tmp120_;
#line 319 "../src/nibbles-view.vala"
										_tmp117_ = worm_at;
#line 319 "../src/nibbles-view.vala"
										_tmp117__length1 = worm_at_length1;
#line 319 "../src/nibbles-view.vala"
										_tmp117__length2 = worm_at_length2;
#line 319 "../src/nibbles-view.vala"
										_tmp118_ = _tmp117_[(x * _tmp117__length2) + y];
#line 319 "../src/nibbles-view.vala"
										_tmp119_ = worm_get_direction (_tmp118_);
#line 319 "../src/nibbles-view.vala"
										_tmp120_ = _tmp119_;
#line 319 "../src/nibbles-view.vala"
										switch (_tmp120_) {
#line 319 "../src/nibbles-view.vala"
											case WORM_DIRECTION_SOUTH:
#line 1864 "nibbles-view.c"
											{
												NibblesViewView3D* _tmp121_;
												Worm** _tmp122_;
												gint _tmp122__length1;
												gint _tmp122__length2;
												Worm* _tmp123_;
												gint _tmp124_;
												gint _tmp125_;
#line 322 "../src/nibbles-view.vala"
												_tmp121_ = v;
#line 322 "../src/nibbles-view.vala"
												_tmp122_ = worm_at;
#line 322 "../src/nibbles-view.vala"
												_tmp122__length1 = worm_at_length1;
#line 322 "../src/nibbles-view.vala"
												_tmp122__length2 = worm_at_length2;
#line 322 "../src/nibbles-view.vala"
												_tmp123_ = _tmp122_[(x * _tmp122__length2) + y];
#line 322 "../src/nibbles-view.vala"
												_tmp124_ = worm_get_id (_tmp123_);
#line 322 "../src/nibbles-view.vala"
												_tmp125_ = _tmp124_;
#line 322 "../src/nibbles-view.vala"
												nibbles_view_draw_eyes_front (self, c, _tmp121_, x, y, ((self->priv->animate % 30) / 5) == ((guint64) _tmp125_));
#line 323 "../src/nibbles-view.vala"
												break;
#line 1891 "nibbles-view.c"
											}
#line 319 "../src/nibbles-view.vala"
											case WORM_DIRECTION_EAST:
#line 1895 "nibbles-view.c"
											{
												NibblesViewView3D* _tmp126_;
												Worm** _tmp127_;
												gint _tmp127__length1;
												gint _tmp127__length2;
												Worm* _tmp128_;
												gint _tmp129_;
												gint _tmp130_;
#line 325 "../src/nibbles-view.vala"
												_tmp126_ = v;
#line 325 "../src/nibbles-view.vala"
												_tmp127_ = worm_at;
#line 325 "../src/nibbles-view.vala"
												_tmp127__length1 = worm_at_length1;
#line 325 "../src/nibbles-view.vala"
												_tmp127__length2 = worm_at_length2;
#line 325 "../src/nibbles-view.vala"
												_tmp128_ = _tmp127_[(x * _tmp127__length2) + y];
#line 325 "../src/nibbles-view.vala"
												_tmp129_ = worm_get_id (_tmp128_);
#line 325 "../src/nibbles-view.vala"
												_tmp130_ = _tmp129_;
#line 325 "../src/nibbles-view.vala"
												nibbles_view_draw_eyes_right (self, c, _tmp126_, x, y, ((self->priv->animate % 30) / 5) == ((guint64) _tmp130_));
#line 326 "../src/nibbles-view.vala"
												break;
#line 1922 "nibbles-view.c"
											}
#line 319 "../src/nibbles-view.vala"
											case WORM_DIRECTION_WEST:
#line 1926 "nibbles-view.c"
											{
												NibblesViewView3D* _tmp131_;
												Worm** _tmp132_;
												gint _tmp132__length1;
												gint _tmp132__length2;
												Worm* _tmp133_;
												gint _tmp134_;
												gint _tmp135_;
#line 328 "../src/nibbles-view.vala"
												_tmp131_ = v;
#line 328 "../src/nibbles-view.vala"
												_tmp132_ = worm_at;
#line 328 "../src/nibbles-view.vala"
												_tmp132__length1 = worm_at_length1;
#line 328 "../src/nibbles-view.vala"
												_tmp132__length2 = worm_at_length2;
#line 328 "../src/nibbles-view.vala"
												_tmp133_ = _tmp132_[(x * _tmp132__length2) + y];
#line 328 "../src/nibbles-view.vala"
												_tmp134_ = worm_get_id (_tmp133_);
#line 328 "../src/nibbles-view.vala"
												_tmp135_ = _tmp134_;
#line 328 "../src/nibbles-view.vala"
												nibbles_view_draw_eyes_left (self, c, _tmp131_, x, y, ((self->priv->animate % 30) / 5) == ((guint64) _tmp135_));
#line 329 "../src/nibbles-view.vala"
												break;
#line 1953 "nibbles-view.c"
											}
											default:
											{
#line 331 "../src/nibbles-view.vala"
												break;
#line 1959 "nibbles-view.c"
											}
										}
									}
								}
#line 335 "../src/nibbles-view.vala"
								_tmp137_ = _data6_->game->board;
#line 335 "../src/nibbles-view.vala"
								_tmp137__length1 = _data6_->game->board_length1;
#line 335 "../src/nibbles-view.vala"
								_tmp137__length2 = _data6_->game->board_length2;
#line 335 "../src/nibbles-view.vala"
								_tmp138_ = _tmp137_[(x * _tmp137__length2) + y];
#line 335 "../src/nibbles-view.vala"
								if (_tmp138_ >= ((gint) 'b')) {
#line 1974 "nibbles-view.c"
									gint* _tmp139_;
									gint _tmp139__length1;
									gint _tmp139__length2;
									gint _tmp140_;
#line 335 "../src/nibbles-view.vala"
									_tmp139_ = _data6_->game->board;
#line 335 "../src/nibbles-view.vala"
									_tmp139__length1 = _data6_->game->board_length1;
#line 335 "../src/nibbles-view.vala"
									_tmp139__length2 = _data6_->game->board_length2;
#line 335 "../src/nibbles-view.vala"
									_tmp140_ = _tmp139_[(x * _tmp139__length2) + y];
#line 335 "../src/nibbles-view.vala"
									_tmp136_ = _tmp140_ <= ((gint) 'l');
#line 1989 "nibbles-view.c"
								} else {
#line 335 "../src/nibbles-view.vala"
									_tmp136_ = FALSE;
#line 1993 "nibbles-view.c"
								}
#line 335 "../src/nibbles-view.vala"
								if (_tmp136_) {
#line 1997 "nibbles-view.c"
									NibblesViewView3D* _tmp141_;
									NibblesViewPoint3D _tmp142_ = {0};
									gdouble _tmp143_ = 0.0;
									gdouble _tmp144_ = 0.0;
									NibblesViewView3D* _tmp145_;
									NibblesViewPoint3D _tmp146_ = {0};
									gdouble _tmp147_ = 0.0;
									gdouble _tmp148_ = 0.0;
									NibblesViewView3D* _tmp149_;
									NibblesViewPoint3D _tmp150_ = {0};
									gdouble _tmp151_ = 0.0;
									gdouble _tmp152_ = 0.0;
									NibblesViewView3D* _tmp153_;
									NibblesViewPoint3D _tmp154_ = {0};
									gdouble _tmp155_ = 0.0;
									gdouble _tmp156_ = 0.0;
									gboolean _tmp157_ = FALSE;
									NibblesViewView3D* _tmp158_;
									NibblesViewView3D* _tmp203_;
									NibblesViewPoint3D _tmp204_ = {0};
									gdouble _tmp205_ = 0.0;
									gdouble _tmp206_ = 0.0;
									NibblesViewView3D* _tmp207_;
									NibblesViewPoint3D _tmp208_ = {0};
									gdouble _tmp209_ = 0.0;
									gdouble _tmp210_ = 0.0;
									NibblesViewView3D* _tmp211_;
									NibblesViewPoint3D _tmp212_ = {0};
									gdouble _tmp213_ = 0.0;
									gdouble _tmp214_ = 0.0;
									NibblesViewView3D* _tmp215_;
									NibblesViewPoint3D _tmp216_ = {0};
									gdouble _tmp217_ = 0.0;
									gdouble _tmp218_ = 0.0;
#line 338 "../src/nibbles-view.vala"
									_tmp141_ = v;
#line 338 "../src/nibbles-view.vala"
									_tmp142_.x = (gdouble) x;
#line 338 "../src/nibbles-view.vala"
									_tmp142_.y = (gdouble) y;
#line 338 "../src/nibbles-view.vala"
									_tmp142_.z = (gdouble) 1;
#line 338 "../src/nibbles-view.vala"
									nibbles_view_view3_d_to_view_plain (_tmp141_, &_tmp142_, &_tmp143_, &_tmp144_);
#line 338 "../src/nibbles-view.vala"
									x2d = _tmp143_;
#line 338 "../src/nibbles-view.vala"
									y2d = _tmp144_;
#line 339 "../src/nibbles-view.vala"
									cairo_move_to (c, x2d, y2d);
#line 340 "../src/nibbles-view.vala"
									_tmp145_ = v;
#line 340 "../src/nibbles-view.vala"
									_tmp146_.x = (gdouble) (x + 1);
#line 340 "../src/nibbles-view.vala"
									_tmp146_.y = (gdouble) y;
#line 340 "../src/nibbles-view.vala"
									_tmp146_.z = (gdouble) 1;
#line 340 "../src/nibbles-view.vala"
									nibbles_view_view3_d_to_view_plain (_tmp145_, &_tmp146_, &_tmp147_, &_tmp148_);
#line 340 "../src/nibbles-view.vala"
									x2d = _tmp147_;
#line 340 "../src/nibbles-view.vala"
									y2d = _tmp148_;
#line 341 "../src/nibbles-view.vala"
									cairo_line_to (c, x2d, y2d);
#line 342 "../src/nibbles-view.vala"
									_tmp149_ = v;
#line 342 "../src/nibbles-view.vala"
									_tmp150_.x = (gdouble) (x + 1);
#line 342 "../src/nibbles-view.vala"
									_tmp150_.y = (gdouble) (y + 1);
#line 342 "../src/nibbles-view.vala"
									_tmp150_.z = (gdouble) 1;
#line 342 "../src/nibbles-view.vala"
									nibbles_view_view3_d_to_view_plain (_tmp149_, &_tmp150_, &_tmp151_, &_tmp152_);
#line 342 "../src/nibbles-view.vala"
									x2d = _tmp151_;
#line 342 "../src/nibbles-view.vala"
									y2d = _tmp152_;
#line 343 "../src/nibbles-view.vala"
									cairo_line_to (c, x2d, y2d);
#line 344 "../src/nibbles-view.vala"
									_tmp153_ = v;
#line 344 "../src/nibbles-view.vala"
									_tmp154_.x = (gdouble) x;
#line 344 "../src/nibbles-view.vala"
									_tmp154_.y = (gdouble) (y + 1);
#line 344 "../src/nibbles-view.vala"
									_tmp154_.z = (gdouble) 1;
#line 344 "../src/nibbles-view.vala"
									nibbles_view_view3_d_to_view_plain (_tmp153_, &_tmp154_, &_tmp155_, &_tmp156_);
#line 344 "../src/nibbles-view.vala"
									x2d = _tmp155_;
#line 344 "../src/nibbles-view.vala"
									y2d = _tmp156_;
#line 345 "../src/nibbles-view.vala"
									cairo_line_to (c, x2d, y2d);
#line 346 "../src/nibbles-view.vala"
									cairo_set_source_rgb (c, 0.95, 0.95, 0.95);
#line 347 "../src/nibbles-view.vala"
									cairo_fill (c);
#line 350 "../src/nibbles-view.vala"
									_tmp158_ = v;
#line 350 "../src/nibbles-view.vala"
									if (((gdouble) x) < nibbles_view_view3_d_view_point_x (_tmp158_)) {
#line 2104 "nibbles-view.c"
										gboolean _tmp159_ = FALSE;
										gint* _tmp160_;
										gint _tmp160__length1;
										gint _tmp160__length2;
										gint _tmp161_;
#line 350 "../src/nibbles-view.vala"
										_tmp160_ = _data6_->game->board;
#line 350 "../src/nibbles-view.vala"
										_tmp160__length1 = _data6_->game->board_length1;
#line 350 "../src/nibbles-view.vala"
										_tmp160__length2 = _data6_->game->board_length2;
#line 350 "../src/nibbles-view.vala"
										_tmp161_ = _tmp160_[((x + 1) * _tmp160__length2) + y];
#line 350 "../src/nibbles-view.vala"
										if (_tmp161_ >= ((gint) 'b')) {
#line 2120 "nibbles-view.c"
											gint* _tmp162_;
											gint _tmp162__length1;
											gint _tmp162__length2;
											gint _tmp163_;
#line 350 "../src/nibbles-view.vala"
											_tmp162_ = _data6_->game->board;
#line 350 "../src/nibbles-view.vala"
											_tmp162__length1 = _data6_->game->board_length1;
#line 350 "../src/nibbles-view.vala"
											_tmp162__length2 = _data6_->game->board_length2;
#line 350 "../src/nibbles-view.vala"
											_tmp163_ = _tmp162_[((x + 1) * _tmp162__length2) + y];
#line 350 "../src/nibbles-view.vala"
											_tmp159_ = _tmp163_ <= ((gint) 'l');
#line 2135 "nibbles-view.c"
										} else {
#line 350 "../src/nibbles-view.vala"
											_tmp159_ = FALSE;
#line 2139 "nibbles-view.c"
										}
#line 350 "../src/nibbles-view.vala"
										_tmp157_ = !_tmp159_;
#line 2143 "nibbles-view.c"
									} else {
#line 350 "../src/nibbles-view.vala"
										_tmp157_ = FALSE;
#line 2147 "nibbles-view.c"
									}
#line 350 "../src/nibbles-view.vala"
									if (_tmp157_) {
#line 2151 "nibbles-view.c"
										NibblesViewView3D* _tmp164_;
										NibblesViewPoint3D _tmp165_ = {0};
										gdouble _tmp166_ = 0.0;
										gdouble _tmp167_ = 0.0;
										NibblesViewView3D* _tmp168_;
										NibblesViewPoint3D _tmp169_ = {0};
										gdouble _tmp170_ = 0.0;
										gdouble _tmp171_ = 0.0;
										NibblesViewView3D* _tmp172_;
										NibblesViewPoint3D _tmp173_ = {0};
										gdouble _tmp174_ = 0.0;
										gdouble _tmp175_ = 0.0;
										NibblesViewView3D* _tmp176_;
										NibblesViewPoint3D _tmp177_ = {0};
										gdouble _tmp178_ = 0.0;
										gdouble _tmp179_ = 0.0;
#line 352 "../src/nibbles-view.vala"
										_tmp164_ = v;
#line 352 "../src/nibbles-view.vala"
										_tmp165_.x = (gdouble) (x + 1);
#line 352 "../src/nibbles-view.vala"
										_tmp165_.y = (gdouble) y;
#line 352 "../src/nibbles-view.vala"
										_tmp165_.z = (gdouble) 0;
#line 352 "../src/nibbles-view.vala"
										nibbles_view_view3_d_to_view_plain (_tmp164_, &_tmp165_, &_tmp166_, &_tmp167_);
#line 352 "../src/nibbles-view.vala"
										x2d = _tmp166_;
#line 352 "../src/nibbles-view.vala"
										y2d = _tmp167_;
#line 353 "../src/nibbles-view.vala"
										cairo_move_to (c, x2d, y2d);
#line 354 "../src/nibbles-view.vala"
										_tmp168_ = v;
#line 354 "../src/nibbles-view.vala"
										_tmp169_.x = (gdouble) (x + 1);
#line 354 "../src/nibbles-view.vala"
										_tmp169_.y = (gdouble) (y + 1);
#line 354 "../src/nibbles-view.vala"
										_tmp169_.z = (gdouble) 0;
#line 354 "../src/nibbles-view.vala"
										nibbles_view_view3_d_to_view_plain (_tmp168_, &_tmp169_, &_tmp170_, &_tmp171_);
#line 354 "../src/nibbles-view.vala"
										x2d = _tmp170_;
#line 354 "../src/nibbles-view.vala"
										y2d = _tmp171_;
#line 355 "../src/nibbles-view.vala"
										cairo_line_to (c, x2d, y2d);
#line 356 "../src/nibbles-view.vala"
										_tmp172_ = v;
#line 356 "../src/nibbles-view.vala"
										_tmp173_.x = (gdouble) (x + 1);
#line 356 "../src/nibbles-view.vala"
										_tmp173_.y = (gdouble) (y + 1);
#line 356 "../src/nibbles-view.vala"
										_tmp173_.z = (gdouble) 1;
#line 356 "../src/nibbles-view.vala"
										nibbles_view_view3_d_to_view_plain (_tmp172_, &_tmp173_, &_tmp174_, &_tmp175_);
#line 356 "../src/nibbles-view.vala"
										x2d = _tmp174_;
#line 356 "../src/nibbles-view.vala"
										y2d = _tmp175_;
#line 357 "../src/nibbles-view.vala"
										cairo_line_to (c, x2d, y2d);
#line 358 "../src/nibbles-view.vala"
										_tmp176_ = v;
#line 358 "../src/nibbles-view.vala"
										_tmp177_.x = (gdouble) (x + 1);
#line 358 "../src/nibbles-view.vala"
										_tmp177_.y = (gdouble) y;
#line 358 "../src/nibbles-view.vala"
										_tmp177_.z = (gdouble) 1;
#line 358 "../src/nibbles-view.vala"
										nibbles_view_view3_d_to_view_plain (_tmp176_, &_tmp177_, &_tmp178_, &_tmp179_);
#line 358 "../src/nibbles-view.vala"
										x2d = _tmp178_;
#line 358 "../src/nibbles-view.vala"
										y2d = _tmp179_;
#line 359 "../src/nibbles-view.vala"
										cairo_line_to (c, x2d, y2d);
#line 360 "../src/nibbles-view.vala"
										cairo_set_source_rgb (c, 0.5, 0.5, 0.5);
#line 361 "../src/nibbles-view.vala"
										cairo_fill (c);
#line 2236 "nibbles-view.c"
									} else {
										gboolean _tmp180_ = FALSE;
										NibblesViewView3D* _tmp181_;
#line 363 "../src/nibbles-view.vala"
										_tmp181_ = v;
#line 363 "../src/nibbles-view.vala"
										if (((gdouble) x) > nibbles_view_view3_d_view_point_x (_tmp181_)) {
#line 2244 "nibbles-view.c"
											gboolean _tmp182_ = FALSE;
											gint* _tmp183_;
											gint _tmp183__length1;
											gint _tmp183__length2;
											gint _tmp184_;
#line 363 "../src/nibbles-view.vala"
											_tmp183_ = _data6_->game->board;
#line 363 "../src/nibbles-view.vala"
											_tmp183__length1 = _data6_->game->board_length1;
#line 363 "../src/nibbles-view.vala"
											_tmp183__length2 = _data6_->game->board_length2;
#line 363 "../src/nibbles-view.vala"
											_tmp184_ = _tmp183_[((x - 1) * _tmp183__length2) + y];
#line 363 "../src/nibbles-view.vala"
											if (_tmp184_ >= ((gint) 'b')) {
#line 2260 "nibbles-view.c"
												gint* _tmp185_;
												gint _tmp185__length1;
												gint _tmp185__length2;
												gint _tmp186_;
#line 363 "../src/nibbles-view.vala"
												_tmp185_ = _data6_->game->board;
#line 363 "../src/nibbles-view.vala"
												_tmp185__length1 = _data6_->game->board_length1;
#line 363 "../src/nibbles-view.vala"
												_tmp185__length2 = _data6_->game->board_length2;
#line 363 "../src/nibbles-view.vala"
												_tmp186_ = _tmp185_[((x - 1) * _tmp185__length2) + y];
#line 363 "../src/nibbles-view.vala"
												_tmp182_ = _tmp186_ <= ((gint) 'l');
#line 2275 "nibbles-view.c"
											} else {
#line 363 "../src/nibbles-view.vala"
												_tmp182_ = FALSE;
#line 2279 "nibbles-view.c"
											}
#line 363 "../src/nibbles-view.vala"
											_tmp180_ = !_tmp182_;
#line 2283 "nibbles-view.c"
										} else {
#line 363 "../src/nibbles-view.vala"
											_tmp180_ = FALSE;
#line 2287 "nibbles-view.c"
										}
#line 363 "../src/nibbles-view.vala"
										if (_tmp180_) {
#line 2291 "nibbles-view.c"
											NibblesViewView3D* _tmp187_;
											NibblesViewPoint3D _tmp188_ = {0};
											gdouble _tmp189_ = 0.0;
											gdouble _tmp190_ = 0.0;
											NibblesViewView3D* _tmp191_;
											NibblesViewPoint3D _tmp192_ = {0};
											gdouble _tmp193_ = 0.0;
											gdouble _tmp194_ = 0.0;
											NibblesViewView3D* _tmp195_;
											NibblesViewPoint3D _tmp196_ = {0};
											gdouble _tmp197_ = 0.0;
											gdouble _tmp198_ = 0.0;
											NibblesViewView3D* _tmp199_;
											NibblesViewPoint3D _tmp200_ = {0};
											gdouble _tmp201_ = 0.0;
											gdouble _tmp202_ = 0.0;
#line 365 "../src/nibbles-view.vala"
											_tmp187_ = v;
#line 365 "../src/nibbles-view.vala"
											_tmp188_.x = (gdouble) x;
#line 365 "../src/nibbles-view.vala"
											_tmp188_.y = (gdouble) y;
#line 365 "../src/nibbles-view.vala"
											_tmp188_.z = (gdouble) 0;
#line 365 "../src/nibbles-view.vala"
											nibbles_view_view3_d_to_view_plain (_tmp187_, &_tmp188_, &_tmp189_, &_tmp190_);
#line 365 "../src/nibbles-view.vala"
											x2d = _tmp189_;
#line 365 "../src/nibbles-view.vala"
											y2d = _tmp190_;
#line 366 "../src/nibbles-view.vala"
											cairo_move_to (c, x2d, y2d);
#line 367 "../src/nibbles-view.vala"
											_tmp191_ = v;
#line 367 "../src/nibbles-view.vala"
											_tmp192_.x = (gdouble) x;
#line 367 "../src/nibbles-view.vala"
											_tmp192_.y = (gdouble) (y + 1);
#line 367 "../src/nibbles-view.vala"
											_tmp192_.z = (gdouble) 0;
#line 367 "../src/nibbles-view.vala"
											nibbles_view_view3_d_to_view_plain (_tmp191_, &_tmp192_, &_tmp193_, &_tmp194_);
#line 367 "../src/nibbles-view.vala"
											x2d = _tmp193_;
#line 367 "../src/nibbles-view.vala"
											y2d = _tmp194_;
#line 368 "../src/nibbles-view.vala"
											cairo_line_to (c, x2d, y2d);
#line 369 "../src/nibbles-view.vala"
											_tmp195_ = v;
#line 369 "../src/nibbles-view.vala"
											_tmp196_.x = (gdouble) x;
#line 369 "../src/nibbles-view.vala"
											_tmp196_.y = (gdouble) (y + 1);
#line 369 "../src/nibbles-view.vala"
											_tmp196_.z = (gdouble) 1;
#line 369 "../src/nibbles-view.vala"
											nibbles_view_view3_d_to_view_plain (_tmp195_, &_tmp196_, &_tmp197_, &_tmp198_);
#line 369 "../src/nibbles-view.vala"
											x2d = _tmp197_;
#line 369 "../src/nibbles-view.vala"
											y2d = _tmp198_;
#line 370 "../src/nibbles-view.vala"
											cairo_line_to (c, x2d, y2d);
#line 371 "../src/nibbles-view.vala"
											_tmp199_ = v;
#line 371 "../src/nibbles-view.vala"
											_tmp200_.x = (gdouble) x;
#line 371 "../src/nibbles-view.vala"
											_tmp200_.y = (gdouble) y;
#line 371 "../src/nibbles-view.vala"
											_tmp200_.z = (gdouble) 1;
#line 371 "../src/nibbles-view.vala"
											nibbles_view_view3_d_to_view_plain (_tmp199_, &_tmp200_, &_tmp201_, &_tmp202_);
#line 371 "../src/nibbles-view.vala"
											x2d = _tmp201_;
#line 371 "../src/nibbles-view.vala"
											y2d = _tmp202_;
#line 372 "../src/nibbles-view.vala"
											cairo_line_to (c, x2d, y2d);
#line 373 "../src/nibbles-view.vala"
											cairo_set_source_rgb (c, 0.5, 0.5, 0.5);
#line 374 "../src/nibbles-view.vala"
											cairo_fill (c);
#line 2376 "nibbles-view.c"
										} else {
										}
									}
#line 381 "../src/nibbles-view.vala"
									_tmp203_ = v;
#line 381 "../src/nibbles-view.vala"
									_tmp204_.x = (gdouble) x;
#line 381 "../src/nibbles-view.vala"
									_tmp204_.y = (gdouble) (y + 1);
#line 381 "../src/nibbles-view.vala"
									_tmp204_.z = (gdouble) 0;
#line 381 "../src/nibbles-view.vala"
									nibbles_view_view3_d_to_view_plain (_tmp203_, &_tmp204_, &_tmp205_, &_tmp206_);
#line 381 "../src/nibbles-view.vala"
									x2d = _tmp205_;
#line 381 "../src/nibbles-view.vala"
									y2d = _tmp206_;
#line 382 "../src/nibbles-view.vala"
									cairo_move_to (c, x2d, y2d);
#line 383 "../src/nibbles-view.vala"
									_tmp207_ = v;
#line 383 "../src/nibbles-view.vala"
									_tmp208_.x = (gdouble) (x + 1);
#line 383 "../src/nibbles-view.vala"
									_tmp208_.y = (gdouble) (y + 1);
#line 383 "../src/nibbles-view.vala"
									_tmp208_.z = (gdouble) 0;
#line 383 "../src/nibbles-view.vala"
									nibbles_view_view3_d_to_view_plain (_tmp207_, &_tmp208_, &_tmp209_, &_tmp210_);
#line 383 "../src/nibbles-view.vala"
									x2d = _tmp209_;
#line 383 "../src/nibbles-view.vala"
									y2d = _tmp210_;
#line 384 "../src/nibbles-view.vala"
									cairo_line_to (c, x2d, y2d);
#line 385 "../src/nibbles-view.vala"
									_tmp211_ = v;
#line 385 "../src/nibbles-view.vala"
									_tmp212_.x = (gdouble) (x + 1);
#line 385 "../src/nibbles-view.vala"
									_tmp212_.y = (gdouble) (y + 1);
#line 385 "../src/nibbles-view.vala"
									_tmp212_.z = (gdouble) 1;
#line 385 "../src/nibbles-view.vala"
									nibbles_view_view3_d_to_view_plain (_tmp211_, &_tmp212_, &_tmp213_, &_tmp214_);
#line 385 "../src/nibbles-view.vala"
									x2d = _tmp213_;
#line 385 "../src/nibbles-view.vala"
									y2d = _tmp214_;
#line 386 "../src/nibbles-view.vala"
									cairo_line_to (c, x2d, y2d);
#line 387 "../src/nibbles-view.vala"
									_tmp215_ = v;
#line 387 "../src/nibbles-view.vala"
									_tmp216_.x = (gdouble) x;
#line 387 "../src/nibbles-view.vala"
									_tmp216_.y = (gdouble) (y + 1);
#line 387 "../src/nibbles-view.vala"
									_tmp216_.z = (gdouble) 1;
#line 387 "../src/nibbles-view.vala"
									nibbles_view_view3_d_to_view_plain (_tmp215_, &_tmp216_, &_tmp217_, &_tmp218_);
#line 387 "../src/nibbles-view.vala"
									x2d = _tmp217_;
#line 387 "../src/nibbles-view.vala"
									y2d = _tmp218_;
#line 388 "../src/nibbles-view.vala"
									cairo_line_to (c, x2d, y2d);
#line 389 "../src/nibbles-view.vala"
									cairo_set_source_rgb (c, 0.75, 0.75, 0.75);
#line 390 "../src/nibbles-view.vala"
									cairo_fill (c);
#line 2448 "nibbles-view.c"
								}
#line 393 "../src/nibbles-view.vala"
								_tmp222_ = _data6_->game->board;
#line 393 "../src/nibbles-view.vala"
								_tmp222__length1 = _data6_->game->board_length1;
#line 393 "../src/nibbles-view.vala"
								_tmp222__length2 = _data6_->game->board_length2;
#line 393 "../src/nibbles-view.vala"
								_tmp223_ = _tmp222_[((x + 0) * _tmp222__length2) + (y + 0)];
#line 393 "../src/nibbles-view.vala"
								if (_tmp223_ == ((gint) NIBBLES_GAME_WARPCHAR)) {
#line 2460 "nibbles-view.c"
									gint* _tmp224_;
									gint _tmp224__length1;
									gint _tmp224__length2;
									gint _tmp225_;
#line 394 "../src/nibbles-view.vala"
									_tmp224_ = _data6_->game->board;
#line 394 "../src/nibbles-view.vala"
									_tmp224__length1 = _data6_->game->board_length1;
#line 394 "../src/nibbles-view.vala"
									_tmp224__length2 = _data6_->game->board_length2;
#line 394 "../src/nibbles-view.vala"
									_tmp225_ = _tmp224_[((x + 1) * _tmp224__length2) + (y + 0)];
#line 394 "../src/nibbles-view.vala"
									_tmp221_ = _tmp225_ == ((gint) NIBBLES_GAME_WARPCHAR);
#line 2475 "nibbles-view.c"
								} else {
#line 393 "../src/nibbles-view.vala"
									_tmp221_ = FALSE;
#line 2479 "nibbles-view.c"
								}
#line 393 "../src/nibbles-view.vala"
								if (_tmp221_) {
#line 2483 "nibbles-view.c"
									gint* _tmp226_;
									gint _tmp226__length1;
									gint _tmp226__length2;
									gint _tmp227_;
#line 395 "../src/nibbles-view.vala"
									_tmp226_ = _data6_->game->board;
#line 395 "../src/nibbles-view.vala"
									_tmp226__length1 = _data6_->game->board_length1;
#line 395 "../src/nibbles-view.vala"
									_tmp226__length2 = _data6_->game->board_length2;
#line 395 "../src/nibbles-view.vala"
									_tmp227_ = _tmp226_[((x + 0) * _tmp226__length2) + (y + 1)];
#line 395 "../src/nibbles-view.vala"
									_tmp220_ = _tmp227_ == ((gint) NIBBLES_GAME_WARPCHAR);
#line 2498 "nibbles-view.c"
								} else {
#line 393 "../src/nibbles-view.vala"
									_tmp220_ = FALSE;
#line 2502 "nibbles-view.c"
								}
#line 393 "../src/nibbles-view.vala"
								if (_tmp220_) {
#line 2506 "nibbles-view.c"
									gint* _tmp228_;
									gint _tmp228__length1;
									gint _tmp228__length2;
									gint _tmp229_;
#line 396 "../src/nibbles-view.vala"
									_tmp228_ = _data6_->game->board;
#line 396 "../src/nibbles-view.vala"
									_tmp228__length1 = _data6_->game->board_length1;
#line 396 "../src/nibbles-view.vala"
									_tmp228__length2 = _data6_->game->board_length2;
#line 396 "../src/nibbles-view.vala"
									_tmp229_ = _tmp228_[((x + 1) * _tmp228__length2) + (y + 1)];
#line 396 "../src/nibbles-view.vala"
									_tmp219_ = _tmp229_ == ((gint) NIBBLES_GAME_WARPCHAR);
#line 2521 "nibbles-view.c"
								} else {
#line 393 "../src/nibbles-view.vala"
									_tmp219_ = FALSE;
#line 2525 "nibbles-view.c"
								}
#line 393 "../src/nibbles-view.vala"
								if (_tmp219_) {
#line 2529 "nibbles-view.c"
									{
										gint z = 0;
#line 398 "../src/nibbles-view.vala"
										z = 0;
#line 2534 "nibbles-view.c"
										{
											gboolean _tmp230_ = FALSE;
#line 398 "../src/nibbles-view.vala"
											_tmp230_ = TRUE;
#line 398 "../src/nibbles-view.vala"
											while (TRUE) {
#line 2541 "nibbles-view.c"
												guint64 a40 = 0ULL;
												guint64 a20 = 0ULL;
												guint64 a20o = 0ULL;
												gdouble a10 = 0.0;
												gdouble _tmp232_ = 0.0;
												gdouble _tmp234_ = 0.0;
												gboolean _tmp235_ = FALSE;
												gdouble _tmp237_ = 0.0;
												gboolean _tmp238_ = FALSE;
												gdouble _tmp240_ = 0.0;
												gboolean _tmp241_ = FALSE;
												gdouble angle[4] = {0};
												gdouble _tmp243_[4] = {0};
												NibblesViewView3D* _tmp244_;
												gdouble _tmp245_;
												NibblesViewPoint3D _tmp246_ = {0};
												gdouble _tmp247_;
												NibblesViewPoint3D _tmp248_ = {0};
												gdouble _tmp249_;
												NibblesViewPoint3D _tmp250_ = {0};
												gdouble _tmp251_;
												NibblesViewPoint3D _tmp252_ = {0};
#line 398 "../src/nibbles-view.vala"
												if (!_tmp230_) {
#line 2566 "nibbles-view.c"
													gint _tmp231_;
#line 398 "../src/nibbles-view.vala"
													_tmp231_ = z;
#line 398 "../src/nibbles-view.vala"
													z = _tmp231_ + 1;
#line 2572 "nibbles-view.c"
												}
#line 398 "../src/nibbles-view.vala"
												_tmp230_ = FALSE;
#line 398 "../src/nibbles-view.vala"
												if (!(z < 6)) {
#line 398 "../src/nibbles-view.vala"
													break;
#line 2580 "nibbles-view.c"
												}
#line 400 "../src/nibbles-view.vala"
												a40 = self->priv->animate % 40;
#line 401 "../src/nibbles-view.vala"
												a20 = self->priv->animate % 20;
#line 402 "../src/nibbles-view.vala"
												a20o = (self->priv->animate + 10) % 20;
#line 403 "../src/nibbles-view.vala"
												a10 = (gdouble) (self->priv->animate % 10);
#line 405 "../src/nibbles-view.vala"
												if (a40 < ((guint64) 20)) {
#line 2592 "nibbles-view.c"
													gdouble _tmp233_ = 0.0;
#line 405 "../src/nibbles-view.vala"
													if (a20 < ((guint64) 10)) {
#line 405 "../src/nibbles-view.vala"
														_tmp233_ = a10;
#line 2598 "nibbles-view.c"
													} else {
#line 405 "../src/nibbles-view.vala"
														_tmp233_ = 10.0 - a10;
#line 2602 "nibbles-view.c"
													}
#line 405 "../src/nibbles-view.vala"
													_tmp232_ = _tmp233_ / 5.0;
#line 2606 "nibbles-view.c"
												} else {
#line 405 "../src/nibbles-view.vala"
													_tmp232_ = (gdouble) 0;
#line 2610 "nibbles-view.c"
												}
#line 406 "../src/nibbles-view.vala"
												if (a40 >= ((guint64) 10)) {
#line 406 "../src/nibbles-view.vala"
													_tmp235_ = a40 < ((guint64) 30);
#line 2616 "nibbles-view.c"
												} else {
#line 406 "../src/nibbles-view.vala"
													_tmp235_ = FALSE;
#line 2620 "nibbles-view.c"
												}
#line 406 "../src/nibbles-view.vala"
												if (_tmp235_) {
#line 2624 "nibbles-view.c"
													gdouble _tmp236_ = 0.0;
#line 406 "../src/nibbles-view.vala"
													if (a20o < ((guint64) 10)) {
#line 406 "../src/nibbles-view.vala"
														_tmp236_ = a10;
#line 2630 "nibbles-view.c"
													} else {
#line 406 "../src/nibbles-view.vala"
														_tmp236_ = 10.0 - a10;
#line 2634 "nibbles-view.c"
													}
#line 406 "../src/nibbles-view.vala"
													_tmp234_ = _tmp236_ / 5.0;
#line 2638 "nibbles-view.c"
												} else {
#line 406 "../src/nibbles-view.vala"
													_tmp234_ = (gdouble) 0;
#line 2642 "nibbles-view.c"
												}
#line 407 "../src/nibbles-view.vala"
												if (a40 >= ((guint64) 20)) {
#line 407 "../src/nibbles-view.vala"
													_tmp238_ = a40 < ((guint64) 40);
#line 2648 "nibbles-view.c"
												} else {
#line 407 "../src/nibbles-view.vala"
													_tmp238_ = FALSE;
#line 2652 "nibbles-view.c"
												}
#line 407 "../src/nibbles-view.vala"
												if (_tmp238_) {
#line 2656 "nibbles-view.c"
													gdouble _tmp239_ = 0.0;
#line 407 "../src/nibbles-view.vala"
													if (a20 < ((guint64) 10)) {
#line 407 "../src/nibbles-view.vala"
														_tmp239_ = a10;
#line 2662 "nibbles-view.c"
													} else {
#line 407 "../src/nibbles-view.vala"
														_tmp239_ = 10.0 - a10;
#line 2666 "nibbles-view.c"
													}
#line 407 "../src/nibbles-view.vala"
													_tmp237_ = _tmp239_ / 5.0;
#line 2670 "nibbles-view.c"
												} else {
#line 407 "../src/nibbles-view.vala"
													_tmp237_ = (gdouble) 0;
#line 2674 "nibbles-view.c"
												}
#line 408 "../src/nibbles-view.vala"
												if (a40 >= ((guint64) 30)) {
#line 408 "../src/nibbles-view.vala"
													_tmp241_ = TRUE;
#line 2680 "nibbles-view.c"
												} else {
#line 408 "../src/nibbles-view.vala"
													_tmp241_ = a40 < ((guint64) 10);
#line 2684 "nibbles-view.c"
												}
#line 408 "../src/nibbles-view.vala"
												if (_tmp241_) {
#line 2688 "nibbles-view.c"
													gdouble _tmp242_ = 0.0;
#line 408 "../src/nibbles-view.vala"
													if (a20o < ((guint64) 10)) {
#line 408 "../src/nibbles-view.vala"
														_tmp242_ = a10;
#line 2694 "nibbles-view.c"
													} else {
#line 408 "../src/nibbles-view.vala"
														_tmp242_ = 10.0 - a10;
#line 2698 "nibbles-view.c"
													}
#line 408 "../src/nibbles-view.vala"
													_tmp240_ = _tmp242_ / 5.0;
#line 2702 "nibbles-view.c"
												} else {
#line 408 "../src/nibbles-view.vala"
													_tmp240_ = (gdouble) 0;
#line 2706 "nibbles-view.c"
												}
#line 404 "../src/nibbles-view.vala"
												_tmp243_[0] = _tmp232_;
#line 404 "../src/nibbles-view.vala"
												_tmp243_[1] = _tmp234_;
#line 404 "../src/nibbles-view.vala"
												_tmp243_[2] = _tmp237_;
#line 404 "../src/nibbles-view.vala"
												_tmp243_[3] = _tmp240_;
#line 404 "../src/nibbles-view.vala"
												memcpy (angle, _tmp243_, 4 * sizeof (gdouble));
#line 409 "../src/nibbles-view.vala"
												_tmp244_ = v;
#line 409 "../src/nibbles-view.vala"
												_tmp245_ = angle[0];
#line 409 "../src/nibbles-view.vala"
												_tmp246_.x = ((gdouble) x) + (0.1 * z);
#line 409 "../src/nibbles-view.vala"
												_tmp246_.y = ((gdouble) y) + (0.1 * z);
#line 409 "../src/nibbles-view.vala"
												_tmp246_.z = _tmp245_;
#line 409 "../src/nibbles-view.vala"
												_tmp247_ = angle[1];
#line 409 "../src/nibbles-view.vala"
												_tmp248_.x = (((gdouble) x) + 2) - (0.1 * z);
#line 409 "../src/nibbles-view.vala"
												_tmp248_.y = ((gdouble) y) + (0.1 * z);
#line 409 "../src/nibbles-view.vala"
												_tmp248_.z = _tmp247_;
#line 409 "../src/nibbles-view.vala"
												_tmp249_ = angle[2];
#line 409 "../src/nibbles-view.vala"
												_tmp250_.x = (((gdouble) x) + 2) - (0.1 * z);
#line 409 "../src/nibbles-view.vala"
												_tmp250_.y = (((gdouble) y) + 2) - (0.1 * z);
#line 409 "../src/nibbles-view.vala"
												_tmp250_.z = _tmp249_;
#line 409 "../src/nibbles-view.vala"
												_tmp251_ = angle[3];
#line 409 "../src/nibbles-view.vala"
												_tmp252_.x = ((gdouble) x) + (0.1 * z);
#line 409 "../src/nibbles-view.vala"
												_tmp252_.y = (((gdouble) y) + 2) - (0.1 * z);
#line 409 "../src/nibbles-view.vala"
												_tmp252_.z = _tmp251_;
#line 409 "../src/nibbles-view.vala"
												nibbles_view_draw_oval (self, c, _tmp244_, &_tmp246_, &_tmp248_, &_tmp250_, &_tmp252_);
#line 414 "../src/nibbles-view.vala"
												cairo_set_source_rgb (c, 0.0, 0.0, 0.6 - (0.1 * ((gdouble) z)));
#line 415 "../src/nibbles-view.vala"
												cairo_fill (c);
#line 2758 "nibbles-view.c"
											}
										}
									}
								}
#line 419 "../src/nibbles-view.vala"
								_tmp253_ = bonus_at;
#line 419 "../src/nibbles-view.vala"
								_tmp253__length1 = bonus_at_length1;
#line 419 "../src/nibbles-view.vala"
								_tmp253__length2 = bonus_at_length2;
#line 419 "../src/nibbles-view.vala"
								_tmp254_ = _tmp253_[(x * _tmp253__length2) + y];
#line 419 "../src/nibbles-view.vala"
								if (_tmp254_ != NULL) {
#line 2773 "nibbles-view.c"
									NibblesViewView3D* _tmp255_;
									Bonus** _tmp256_;
									gint _tmp256__length1;
									gint _tmp256__length2;
									Bonus* _tmp257_;
#line 420 "../src/nibbles-view.vala"
									_tmp255_ = v;
#line 420 "../src/nibbles-view.vala"
									_tmp256_ = bonus_at;
#line 420 "../src/nibbles-view.vala"
									_tmp256__length1 = bonus_at_length1;
#line 420 "../src/nibbles-view.vala"
									_tmp256__length2 = bonus_at_length2;
#line 420 "../src/nibbles-view.vala"
									_tmp257_ = _tmp256_[(x * _tmp256__length2) + y];
#line 420 "../src/nibbles-view.vala"
									nibbles_view_draw_3D_bonus (self, c, _tmp255_, x, y, _tmp257_);
#line 2791 "nibbles-view.c"
								}
#line 423 "../src/nibbles-view.vala"
								if (x == (NIBBLES_VIEW_WIDTH / 2)) {
#line 424 "../src/nibbles-view.vala"
									break;
#line 2797 "nibbles-view.c"
								}
							}
						}
					}
				}
			}
		}
#line 428 "../src/nibbles-view.vala"
		if (_data6_->countdown_active (_data6_->countdown_active_target) > 0) {
#line 2807 "nibbles-view.c"
			gchar* text = NULL;
			gchar* _tmp258_;
			gint text_width = 0;
			NibblesViewView3D* _tmp259_;
			NibblesViewPoint3D _tmp260_ = {0};
			NibblesViewPoint3D _tmp261_ = {0};
			gdouble w = 0.0;
			gdouble h = 0.0;
			gint font_size = 0;
			const gchar* _tmp262_;
			gdouble _tmp263_ = 0.0;
			gdouble _tmp264_ = 0.0;
			gint _tmp265_;
			gdouble center_x = 0.0;
			gdouble center_y = 0.0;
			NibblesViewView3D* _tmp266_;
			NibblesViewPoint3D _tmp267_ = {0};
			gdouble _tmp268_ = 0.0;
			gdouble _tmp269_ = 0.0;
			const gchar* _tmp270_;
#line 431 "../src/nibbles-view.vala"
			_tmp258_ = nibbles_view_seconds_string (self, _data6_->countdown_active (_data6_->countdown_active_target));
#line 431 "../src/nibbles-view.vala"
			text = _tmp258_;
#line 432 "../src/nibbles-view.vala"
			_tmp259_ = v;
#line 432 "../src/nibbles-view.vala"
			_tmp260_.x = (gdouble) ((NIBBLES_VIEW_WIDTH / 2) - 5);
#line 432 "../src/nibbles-view.vala"
			_tmp260_.y = (gdouble) (NIBBLES_VIEW_HEIGHT / 2);
#line 432 "../src/nibbles-view.vala"
			_tmp260_.z = (gdouble) 0;
#line 432 "../src/nibbles-view.vala"
			_tmp261_.x = (gdouble) ((NIBBLES_VIEW_WIDTH / 2) + 5);
#line 432 "../src/nibbles-view.vala"
			_tmp261_.y = (gdouble) (NIBBLES_VIEW_HEIGHT / 2);
#line 432 "../src/nibbles-view.vala"
			_tmp261_.z = (gdouble) 0;
#line 432 "../src/nibbles-view.vala"
			text_width = (gint) nibbles_view_view3_d_2D_diff (_tmp259_, &_tmp260_, &_tmp261_);
#line 434 "../src/nibbles-view.vala"
			_tmp262_ = text;
#line 434 "../src/nibbles-view.vala"
			_tmp265_ = nibbles_view_calculate_font_size (self, c, _tmp262_, text_width, &_tmp263_, &_tmp264_);
#line 434 "../src/nibbles-view.vala"
			w = _tmp263_;
#line 434 "../src/nibbles-view.vala"
			h = _tmp264_;
#line 434 "../src/nibbles-view.vala"
			font_size = _tmp265_;
#line 436 "../src/nibbles-view.vala"
			_tmp266_ = v;
#line 436 "../src/nibbles-view.vala"
			_tmp267_.x = (gdouble) (NIBBLES_VIEW_WIDTH / 2);
#line 436 "../src/nibbles-view.vala"
			_tmp267_.y = (gdouble) (NIBBLES_VIEW_HEIGHT / 2);
#line 436 "../src/nibbles-view.vala"
			_tmp267_.z = (gdouble) 0;
#line 436 "../src/nibbles-view.vala"
			nibbles_view_view3_d_to_view_plain (_tmp266_, &_tmp267_, &_tmp268_, &_tmp269_);
#line 436 "../src/nibbles-view.vala"
			center_x = _tmp268_;
#line 436 "../src/nibbles-view.vala"
			center_y = _tmp269_;
#line 437 "../src/nibbles-view.vala"
			_tmp270_ = text;
#line 437 "../src/nibbles-view.vala"
			nibbles_view_draw_text_font_size (self, c, (gint) (center_x - (w / 2)), (gint) (center_y - (h / 2)), _tmp270_, font_size);
#line 2876 "nibbles-view.c"
			{
				GeeLinkedList* _worm_list = NULL;
				GeeLinkedList* _tmp271_;
				GeeLinkedList* _tmp272_;
				gint _worm_size = 0;
				GeeLinkedList* _tmp273_;
				gint _tmp274_;
				gint _tmp275_;
				gint _worm_index = 0;
#line 440 "../src/nibbles-view.vala"
				_tmp271_ = nibbles_game_get_worms (_data6_->game);
#line 440 "../src/nibbles-view.vala"
				_tmp272_ = _tmp271_;
#line 440 "../src/nibbles-view.vala"
				_worm_list = _tmp272_;
#line 440 "../src/nibbles-view.vala"
				_tmp273_ = _worm_list;
#line 440 "../src/nibbles-view.vala"
				_tmp274_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp273_);
#line 440 "../src/nibbles-view.vala"
				_tmp275_ = _tmp274_;
#line 440 "../src/nibbles-view.vala"
				_worm_size = _tmp275_;
#line 440 "../src/nibbles-view.vala"
				_worm_index = -1;
#line 440 "../src/nibbles-view.vala"
				while (TRUE) {
#line 2904 "nibbles-view.c"
					gint _tmp276_;
					gint _tmp277_;
					Worm* worm = NULL;
					GeeLinkedList* _tmp278_;
					gpointer _tmp279_;
					Worm* _tmp280_;
					WormPositions* _tmp281_;
					gboolean _tmp282_;
					gboolean _tmp283_;
#line 440 "../src/nibbles-view.vala"
					_worm_index = _worm_index + 1;
#line 440 "../src/nibbles-view.vala"
					_tmp276_ = _worm_index;
#line 440 "../src/nibbles-view.vala"
					_tmp277_ = _worm_size;
#line 440 "../src/nibbles-view.vala"
					if (!(_tmp276_ < _tmp277_)) {
#line 440 "../src/nibbles-view.vala"
						break;
#line 2924 "nibbles-view.c"
					}
#line 440 "../src/nibbles-view.vala"
					_tmp278_ = _worm_list;
#line 440 "../src/nibbles-view.vala"
					_tmp279_ = gee_abstract_list_get ((GeeAbstractList*) _tmp278_, _worm_index);
#line 440 "../src/nibbles-view.vala"
					worm = (Worm*) _tmp279_;
#line 442 "../src/nibbles-view.vala"
					_tmp280_ = worm;
#line 442 "../src/nibbles-view.vala"
					_tmp281_ = _tmp280_->list;
#line 442 "../src/nibbles-view.vala"
					_tmp282_ = gee_collection_get_is_empty ((GeeCollection*) _tmp281_);
#line 442 "../src/nibbles-view.vala"
					_tmp283_ = _tmp282_;
#line 442 "../src/nibbles-view.vala"
					if (!_tmp283_) {
#line 2942 "nibbles-view.c"
						gint color = 0;
						GeeHashMap* _tmp284_;
						GeeHashMap* _tmp285_;
						Worm* _tmp286_;
						gpointer _tmp287_;
						WormProperties* _tmp288_;
						gint _tmp289_;
						gint _tmp290_;
						gint _tmp291_;
						gboolean _tmp292_ = FALSE;
						Worm* _tmp293_;
						WormDirection _tmp294_;
						WormDirection _tmp295_;
#line 444 "../src/nibbles-view.vala"
						_tmp284_ = nibbles_game_get_worm_props (_data6_->game);
#line 444 "../src/nibbles-view.vala"
						_tmp285_ = _tmp284_;
#line 444 "../src/nibbles-view.vala"
						_tmp286_ = worm;
#line 444 "../src/nibbles-view.vala"
						_tmp287_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp285_, _tmp286_);
#line 444 "../src/nibbles-view.vala"
						_tmp288_ = (WormProperties*) _tmp287_;
#line 444 "../src/nibbles-view.vala"
						_tmp289_ = worm_properties_get_color (_tmp288_);
#line 444 "../src/nibbles-view.vala"
						_tmp290_ = _tmp289_;
#line 444 "../src/nibbles-view.vala"
						_tmp291_ = _tmp290_;
#line 444 "../src/nibbles-view.vala"
						_g_object_unref0 (_tmp288_);
#line 444 "../src/nibbles-view.vala"
						color = _tmp291_;
#line 445 "../src/nibbles-view.vala"
						_tmp293_ = worm;
#line 445 "../src/nibbles-view.vala"
						_tmp294_ = worm_get_direction (_tmp293_);
#line 445 "../src/nibbles-view.vala"
						_tmp295_ = _tmp294_;
#line 445 "../src/nibbles-view.vala"
						if (_tmp295_ == WORM_DIRECTION_UP) {
#line 445 "../src/nibbles-view.vala"
							_tmp292_ = TRUE;
#line 2986 "nibbles-view.c"
						} else {
							Worm* _tmp296_;
							WormDirection _tmp297_;
							WormDirection _tmp298_;
#line 445 "../src/nibbles-view.vala"
							_tmp296_ = worm;
#line 445 "../src/nibbles-view.vala"
							_tmp297_ = worm_get_direction (_tmp296_);
#line 445 "../src/nibbles-view.vala"
							_tmp298_ = _tmp297_;
#line 445 "../src/nibbles-view.vala"
							_tmp292_ = _tmp298_ == WORM_DIRECTION_DOWN;
#line 2999 "nibbles-view.c"
						}
#line 445 "../src/nibbles-view.vala"
						if (_tmp292_) {
#line 3003 "nibbles-view.c"
							gint middle = 0;
							Worm* _tmp299_;
							gint _tmp300_;
							gint _tmp301_;
							NibblesViewView3D* _tmp302_;
							Worm* _tmp303_;
							WormPositions* _tmp304_;
							gpointer _tmp305_;
							Worm* _tmp306_;
							WormPositions* _tmp307_;
							gpointer _tmp308_;
							NibblesViewPoint3D _tmp309_ = {0};
							gdouble _tmp310_ = 0.0;
							gdouble _tmp311_ = 0.0;
							Worm* _tmp312_;
							gint _tmp313_;
							gint _tmp314_;
							gchar* _tmp315_;
							gchar* _tmp316_;
							NibblesViewView3D* _tmp317_;
							Worm* _tmp318_;
							WormPositions* _tmp319_;
							gpointer _tmp320_;
							Worm* _tmp321_;
							WormPositions* _tmp322_;
							gpointer _tmp323_;
							NibblesViewPoint3D _tmp324_ = {0};
							Worm* _tmp325_;
							WormPositions* _tmp326_;
							Worm* _tmp327_;
							gint _tmp328_;
							gint _tmp329_;
							gpointer _tmp330_;
							Worm* _tmp331_;
							WormPositions* _tmp332_;
							Worm* _tmp333_;
							gint _tmp334_;
							gint _tmp335_;
							gpointer _tmp336_;
							NibblesViewPoint3D _tmp337_ = {0};
#line 448 "../src/nibbles-view.vala"
							_tmp299_ = worm;
#line 448 "../src/nibbles-view.vala"
							_tmp300_ = worm_get_length (_tmp299_);
#line 448 "../src/nibbles-view.vala"
							_tmp301_ = _tmp300_;
#line 448 "../src/nibbles-view.vala"
							middle = _tmp301_ / 2;
#line 449 "../src/nibbles-view.vala"
							_tmp302_ = v;
#line 449 "../src/nibbles-view.vala"
							_tmp303_ = worm;
#line 449 "../src/nibbles-view.vala"
							_tmp304_ = _tmp303_->list;
#line 449 "../src/nibbles-view.vala"
							_tmp305_ = gee_abstract_list_get ((GeeAbstractList*) _tmp304_, middle);
#line 449 "../src/nibbles-view.vala"
							_tmp306_ = worm;
#line 449 "../src/nibbles-view.vala"
							_tmp307_ = _tmp306_->list;
#line 449 "../src/nibbles-view.vala"
							_tmp308_ = gee_abstract_list_get ((GeeAbstractList*) _tmp307_, middle);
#line 449 "../src/nibbles-view.vala"
							_tmp309_.x = (((guint16) ((guintptr) _tmp305_)) >> 8) + 1.5;
#line 449 "../src/nibbles-view.vala"
							_tmp309_.y = (gdouble) ((guint8) ((guint16) ((guintptr) _tmp308_)));
#line 449 "../src/nibbles-view.vala"
							_tmp309_.z = (gdouble) 0;
#line 449 "../src/nibbles-view.vala"
							nibbles_view_view3_d_to_view_plain (_tmp302_, &_tmp309_, &_tmp310_, &_tmp311_);
#line 449 "../src/nibbles-view.vala"
							x2d = _tmp310_;
#line 449 "../src/nibbles-view.vala"
							y2d = _tmp311_;
#line 450 "../src/nibbles-view.vala"
							_tmp312_ = worm;
#line 450 "../src/nibbles-view.vala"
							_tmp313_ = worm_get_id (_tmp312_);
#line 450 "../src/nibbles-view.vala"
							_tmp314_ = _tmp313_;
#line 450 "../src/nibbles-view.vala"
							_tmp315_ = nibbles_view_worm_name (self, _tmp314_ + 1);
#line 450 "../src/nibbles-view.vala"
							_tmp316_ = _tmp315_;
#line 450 "../src/nibbles-view.vala"
							_tmp317_ = v;
#line 450 "../src/nibbles-view.vala"
							_tmp318_ = worm;
#line 450 "../src/nibbles-view.vala"
							_tmp319_ = _tmp318_->list;
#line 450 "../src/nibbles-view.vala"
							_tmp320_ = gee_abstract_list_get ((GeeAbstractList*) _tmp319_, 0);
#line 450 "../src/nibbles-view.vala"
							_tmp321_ = worm;
#line 450 "../src/nibbles-view.vala"
							_tmp322_ = _tmp321_->list;
#line 450 "../src/nibbles-view.vala"
							_tmp323_ = gee_abstract_list_get ((GeeAbstractList*) _tmp322_, 0);
#line 450 "../src/nibbles-view.vala"
							_tmp324_.x = (gdouble) (((guint16) ((guintptr) _tmp320_)) >> 8);
#line 450 "../src/nibbles-view.vala"
							_tmp324_.y = (gdouble) ((guint8) ((guint16) ((guintptr) _tmp323_)));
#line 450 "../src/nibbles-view.vala"
							_tmp324_.z = (gdouble) 0;
#line 450 "../src/nibbles-view.vala"
							_tmp325_ = worm;
#line 450 "../src/nibbles-view.vala"
							_tmp326_ = _tmp325_->list;
#line 450 "../src/nibbles-view.vala"
							_tmp327_ = worm;
#line 450 "../src/nibbles-view.vala"
							_tmp328_ = worm_get_length (_tmp327_);
#line 450 "../src/nibbles-view.vala"
							_tmp329_ = _tmp328_;
#line 450 "../src/nibbles-view.vala"
							_tmp330_ = gee_abstract_list_get ((GeeAbstractList*) _tmp326_, _tmp329_ - 1);
#line 450 "../src/nibbles-view.vala"
							_tmp331_ = worm;
#line 450 "../src/nibbles-view.vala"
							_tmp332_ = _tmp331_->list;
#line 450 "../src/nibbles-view.vala"
							_tmp333_ = worm;
#line 450 "../src/nibbles-view.vala"
							_tmp334_ = worm_get_length (_tmp333_);
#line 450 "../src/nibbles-view.vala"
							_tmp335_ = _tmp334_;
#line 450 "../src/nibbles-view.vala"
							_tmp336_ = gee_abstract_list_get ((GeeAbstractList*) _tmp332_, _tmp335_ - 1);
#line 450 "../src/nibbles-view.vala"
							_tmp337_.x = (gdouble) (((guint16) ((guintptr) _tmp330_)) >> 8);
#line 450 "../src/nibbles-view.vala"
							_tmp337_.y = (gdouble) (((guint8) ((guint16) ((guintptr) _tmp336_))) + 1);
#line 450 "../src/nibbles-view.vala"
							_tmp337_.z = (gdouble) 0;
#line 450 "../src/nibbles-view.vala"
							nibbles_view_draw_text_target_width (self, c, (gint) x2d, (gint) y2d, _tmp316_, (gint) nibbles_view_view3_d_2D_diff (_tmp317_, &_tmp324_, &_tmp337_), color);
#line 450 "../src/nibbles-view.vala"
							_g_free0 (_tmp316_);
#line 3142 "nibbles-view.c"
						} else {
							gboolean _tmp338_ = FALSE;
							Worm* _tmp339_;
							WormDirection _tmp340_;
							WormDirection _tmp341_;
#line 455 "../src/nibbles-view.vala"
							_tmp339_ = worm;
#line 455 "../src/nibbles-view.vala"
							_tmp340_ = worm_get_direction (_tmp339_);
#line 455 "../src/nibbles-view.vala"
							_tmp341_ = _tmp340_;
#line 455 "../src/nibbles-view.vala"
							if (_tmp341_ == WORM_DIRECTION_LEFT) {
#line 455 "../src/nibbles-view.vala"
								_tmp338_ = TRUE;
#line 3158 "nibbles-view.c"
							} else {
								Worm* _tmp342_;
								WormDirection _tmp343_;
								WormDirection _tmp344_;
#line 455 "../src/nibbles-view.vala"
								_tmp342_ = worm;
#line 455 "../src/nibbles-view.vala"
								_tmp343_ = worm_get_direction (_tmp342_);
#line 455 "../src/nibbles-view.vala"
								_tmp344_ = _tmp343_;
#line 455 "../src/nibbles-view.vala"
								_tmp338_ = _tmp344_ == WORM_DIRECTION_RIGHT;
#line 3171 "nibbles-view.c"
							}
#line 455 "../src/nibbles-view.vala"
							if (_tmp338_) {
#line 3175 "nibbles-view.c"
								gdouble x_2d[2] = {0};
								gdouble y_2d[2] = {0};
								gint x = 0;
								Worm* _tmp345_;
								WormPositions* _tmp346_;
								gpointer _tmp347_;
								gint x_max = 0;
								Worm* _tmp348_;
								WormPositions* _tmp349_;
								Worm* _tmp350_;
								gint _tmp351_;
								gint _tmp352_;
								gpointer _tmp353_;
								NibblesViewView3D* _tmp354_;
								Worm* _tmp355_;
								WormPositions* _tmp356_;
								gpointer _tmp357_;
								NibblesViewPoint3D _tmp358_ = {0};
								gdouble _tmp359_ = 0.0;
								gdouble _tmp360_ = 0.0;
								NibblesViewView3D* _tmp361_;
								Worm* _tmp362_;
								WormPositions* _tmp363_;
								gpointer _tmp364_;
								NibblesViewPoint3D _tmp365_ = {0};
								gdouble _tmp366_ = 0.0;
								gdouble _tmp367_ = 0.0;
								gdouble _tmp368_;
								gdouble _tmp369_;
								Worm* _tmp370_;
								gint _tmp371_;
								gint _tmp372_;
								gchar* _tmp373_;
								gchar* _tmp374_;
								gdouble _tmp375_;
								gdouble _tmp376_;
#line 459 "../src/nibbles-view.vala"
								_tmp345_ = worm;
#line 459 "../src/nibbles-view.vala"
								_tmp346_ = _tmp345_->list;
#line 459 "../src/nibbles-view.vala"
								_tmp347_ = gee_abstract_list_get ((GeeAbstractList*) _tmp346_, 0);
#line 459 "../src/nibbles-view.vala"
								x = ((guint16) ((guintptr) _tmp347_)) >> 8;
#line 460 "../src/nibbles-view.vala"
								_tmp348_ = worm;
#line 460 "../src/nibbles-view.vala"
								_tmp349_ = _tmp348_->list;
#line 460 "../src/nibbles-view.vala"
								_tmp350_ = worm;
#line 460 "../src/nibbles-view.vala"
								_tmp351_ = worm_get_length (_tmp350_);
#line 460 "../src/nibbles-view.vala"
								_tmp352_ = _tmp351_;
#line 460 "../src/nibbles-view.vala"
								_tmp353_ = gee_abstract_list_get ((GeeAbstractList*) _tmp349_, _tmp352_ - 1);
#line 460 "../src/nibbles-view.vala"
								x_max = ((guint16) ((guintptr) _tmp353_)) >> 8;
#line 461 "../src/nibbles-view.vala"
								if (x > x_max) {
#line 3236 "nibbles-view.c"
									gint swap = 0;
#line 463 "../src/nibbles-view.vala"
									swap = x;
#line 464 "../src/nibbles-view.vala"
									x = x_max;
#line 465 "../src/nibbles-view.vala"
									x_max = swap;
#line 3244 "nibbles-view.c"
								}
#line 467 "../src/nibbles-view.vala"
								_tmp354_ = v;
#line 467 "../src/nibbles-view.vala"
								_tmp355_ = worm;
#line 467 "../src/nibbles-view.vala"
								_tmp356_ = _tmp355_->list;
#line 467 "../src/nibbles-view.vala"
								_tmp357_ = gee_abstract_list_get ((GeeAbstractList*) _tmp356_, 0);
#line 467 "../src/nibbles-view.vala"
								_tmp358_.x = (gdouble) x;
#line 467 "../src/nibbles-view.vala"
								_tmp358_.y = (gdouble) ((guint8) ((guint16) ((guintptr) _tmp357_)));
#line 467 "../src/nibbles-view.vala"
								_tmp358_.z = (gdouble) 3;
#line 467 "../src/nibbles-view.vala"
								nibbles_view_view3_d_to_view_plain (_tmp354_, &_tmp358_, &_tmp359_, &_tmp360_);
#line 467 "../src/nibbles-view.vala"
								x_2d[0] = _tmp359_;
#line 467 "../src/nibbles-view.vala"
								y_2d[0] = _tmp360_;
#line 468 "../src/nibbles-view.vala"
								_tmp361_ = v;
#line 468 "../src/nibbles-view.vala"
								_tmp362_ = worm;
#line 468 "../src/nibbles-view.vala"
								_tmp363_ = _tmp362_->list;
#line 468 "../src/nibbles-view.vala"
								_tmp364_ = gee_abstract_list_get ((GeeAbstractList*) _tmp363_, 0);
#line 468 "../src/nibbles-view.vala"
								_tmp365_.x = (gdouble) (x_max + 1);
#line 468 "../src/nibbles-view.vala"
								_tmp365_.y = (gdouble) ((guint8) ((guint16) ((guintptr) _tmp364_)));
#line 468 "../src/nibbles-view.vala"
								_tmp365_.z = (gdouble) 3;
#line 468 "../src/nibbles-view.vala"
								nibbles_view_view3_d_to_view_plain (_tmp361_, &_tmp365_, &_tmp366_, &_tmp367_);
#line 468 "../src/nibbles-view.vala"
								x_2d[1] = _tmp366_;
#line 468 "../src/nibbles-view.vala"
								y_2d[1] = _tmp367_;
#line 469 "../src/nibbles-view.vala"
								_tmp368_ = x_2d[0];
#line 469 "../src/nibbles-view.vala"
								_tmp369_ = y_2d[0];
#line 469 "../src/nibbles-view.vala"
								_tmp370_ = worm;
#line 469 "../src/nibbles-view.vala"
								_tmp371_ = worm_get_id (_tmp370_);
#line 469 "../src/nibbles-view.vala"
								_tmp372_ = _tmp371_;
#line 469 "../src/nibbles-view.vala"
								_tmp373_ = nibbles_view_worm_name (self, _tmp372_ + 1);
#line 469 "../src/nibbles-view.vala"
								_tmp374_ = _tmp373_;
#line 469 "../src/nibbles-view.vala"
								_tmp375_ = x_2d[1];
#line 469 "../src/nibbles-view.vala"
								_tmp376_ = x_2d[0];
#line 469 "../src/nibbles-view.vala"
								nibbles_view_draw_text_target_width (self, c, (gint) _tmp368_, (gint) _tmp369_, _tmp374_, (gint) (_tmp375_ - _tmp376_), color);
#line 469 "../src/nibbles-view.vala"
								_g_free0 (_tmp374_);
#line 3308 "nibbles-view.c"
							}
						}
					}
#line 440 "../src/nibbles-view.vala"
					_g_object_unref0 (worm);
#line 3314 "nibbles-view.c"
				}
			}
#line 428 "../src/nibbles-view.vala"
			_g_free0 (text);
#line 3319 "nibbles-view.c"
		}
#line 475 "../src/nibbles-view.vala"
		_tmp380_ = _data6_->new_game_dialogue_active (&_tmp377_, &_tmp378_, &_tmp379_, _data6_->new_game_dialogue_active_target);
#line 475 "../src/nibbles-view.vala"
		(self->priv->result_function_target_destroy_notify == NULL) ? NULL : (self->priv->result_function_target_destroy_notify (self->priv->result_function_target), NULL);
#line 475 "../src/nibbles-view.vala"
		self->priv->result_function = NULL;
#line 475 "../src/nibbles-view.vala"
		self->priv->result_function_target = NULL;
#line 475 "../src/nibbles-view.vala"
		self->priv->result_function_target_destroy_notify = NULL;
#line 475 "../src/nibbles-view.vala"
		self->priv->result_function = _tmp377_;
#line 475 "../src/nibbles-view.vala"
		self->priv->result_function_target = _tmp378_;
#line 475 "../src/nibbles-view.vala"
		self->priv->result_function_target_destroy_notify = _tmp379_;
#line 475 "../src/nibbles-view.vala"
		if (_tmp380_) {
#line 3339 "nibbles-view.c"
			YesNoResultFunction _tmp381_;
			gpointer _tmp381__target;
#line 477 "../src/nibbles-view.vala"
			_tmp381_ = self->priv->result_function;
#line 477 "../src/nibbles-view.vala"
			_tmp381__target = self->priv->result_function_target;
#line 477 "../src/nibbles-view.vala"
			nibbles_view_new_game_dialogue_draw (self, c, (gdouble) width, (gdouble) height, _tmp381_, _tmp381__target);
#line 3348 "nibbles-view.c"
		}
#line 263 "../src/nibbles-view.vala"
		bonus_at = (_vala_array_free (bonus_at, bonus_at_length1 * bonus_at_length2, (GDestroyNotify) g_object_unref), NULL);
#line 263 "../src/nibbles-view.vala"
		worm_at = (_vala_array_free (worm_at, worm_at_length1 * worm_at_length2, (GDestroyNotify) g_object_unref), NULL);
#line 263 "../src/nibbles-view.vala"
		dematerialized_worms = (_vala_array_free (dematerialized_worms, dematerialized_worms_length1, (GDestroyNotify) g_object_unref), NULL);
#line 263 "../src/nibbles-view.vala"
		_nibbles_view_view3_d_unref0 (v);
#line 3358 "nibbles-view.c"
	} else {
#line 482 "../src/nibbles-view.vala"
		static const gdouble max_delta_deviation = 1.15;
#line 3362 "nibbles-view.c"
		gint x_delta = 0;
		gint y_delta = 0;
		gint x_offset = 0;
		gint y_offset = 0;
		GeeArrayList* materialized_worm_positions = NULL;
		GeeArrayList* _tmp404_;
		gint* dematerialized_worms = NULL;
		gint* _tmp405_;
		gint dematerialized_worms_length1;
		gint _dematerialized_worms_size_;
		YesNoResultFunction _tmp575_ = NULL;
		gpointer _tmp576_ = NULL;
		GDestroyNotify _tmp577_ = NULL;
		gboolean _tmp578_;
#line 483 "../src/nibbles-view.vala"
		x_delta = width / NIBBLES_VIEW_WIDTH;
#line 484 "../src/nibbles-view.vala"
		y_delta = height / NIBBLES_VIEW_HEIGHT;
#line 485 "../src/nibbles-view.vala"
		if (((gdouble) x_delta) > (max_delta_deviation * y_delta)) {
#line 486 "../src/nibbles-view.vala"
			x_delta = (gint) (y_delta * max_delta_deviation);
#line 3385 "nibbles-view.c"
		} else {
#line 487 "../src/nibbles-view.vala"
			if (((gdouble) y_delta) > (max_delta_deviation * x_delta)) {
#line 488 "../src/nibbles-view.vala"
				y_delta = (gint) (x_delta * max_delta_deviation);
#line 3391 "nibbles-view.c"
			}
		}
#line 489 "../src/nibbles-view.vala"
		x_offset = (width - (x_delta * NIBBLES_VIEW_WIDTH)) / 2;
#line 490 "../src/nibbles-view.vala"
		y_offset = (height - (y_delta * NIBBLES_VIEW_HEIGHT)) / 2;
#line 493 "../src/nibbles-view.vala"
		cairo_rectangle (c, (gdouble) x_offset, (gdouble) y_offset, (gdouble) (x_delta * NIBBLES_VIEW_WIDTH), (gdouble) (y_delta * NIBBLES_VIEW_HEIGHT));
#line 494 "../src/nibbles-view.vala"
		cairo_set_source_rgb (c, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 495 "../src/nibbles-view.vala"
		cairo_fill (c);
#line 3404 "nibbles-view.c"
		{
			gint x = 0;
#line 498 "../src/nibbles-view.vala"
			x = 0;
#line 3409 "nibbles-view.c"
			{
				gboolean _tmp382_ = FALSE;
#line 498 "../src/nibbles-view.vala"
				_tmp382_ = TRUE;
#line 498 "../src/nibbles-view.vala"
				while (TRUE) {
#line 498 "../src/nibbles-view.vala"
					if (!_tmp382_) {
#line 3418 "nibbles-view.c"
						gint _tmp383_;
#line 498 "../src/nibbles-view.vala"
						_tmp383_ = x;
#line 498 "../src/nibbles-view.vala"
						x = _tmp383_ + 1;
#line 3424 "nibbles-view.c"
					}
#line 498 "../src/nibbles-view.vala"
					_tmp382_ = FALSE;
#line 498 "../src/nibbles-view.vala"
					if (!(x < ((gint) NIBBLES_VIEW_WIDTH))) {
#line 498 "../src/nibbles-view.vala"
						break;
#line 3432 "nibbles-view.c"
					}
					{
						gint y = 0;
#line 500 "../src/nibbles-view.vala"
						y = 0;
#line 3438 "nibbles-view.c"
						{
							gboolean _tmp384_ = FALSE;
#line 500 "../src/nibbles-view.vala"
							_tmp384_ = TRUE;
#line 500 "../src/nibbles-view.vala"
							while (TRUE) {
#line 3445 "nibbles-view.c"
								gboolean _tmp386_ = FALSE;
								gint* _tmp387_;
								gint _tmp387__length1;
								gint _tmp387__length2;
								gint _tmp388_;
								gboolean _tmp393_ = FALSE;
								gboolean _tmp394_ = FALSE;
								gboolean _tmp395_ = FALSE;
								gint* _tmp396_;
								gint _tmp396__length1;
								gint _tmp396__length2;
								gint _tmp397_;
#line 500 "../src/nibbles-view.vala"
								if (!_tmp384_) {
#line 3460 "nibbles-view.c"
									gint _tmp385_;
#line 500 "../src/nibbles-view.vala"
									_tmp385_ = y;
#line 500 "../src/nibbles-view.vala"
									y = _tmp385_ + 1;
#line 3466 "nibbles-view.c"
								}
#line 500 "../src/nibbles-view.vala"
								_tmp384_ = FALSE;
#line 500 "../src/nibbles-view.vala"
								if (!(y < ((gint) NIBBLES_VIEW_HEIGHT))) {
#line 500 "../src/nibbles-view.vala"
									break;
#line 3474 "nibbles-view.c"
								}
#line 503 "../src/nibbles-view.vala"
								_tmp387_ = _data6_->game->board;
#line 503 "../src/nibbles-view.vala"
								_tmp387__length1 = _data6_->game->board_length1;
#line 503 "../src/nibbles-view.vala"
								_tmp387__length2 = _data6_->game->board_length2;
#line 503 "../src/nibbles-view.vala"
								_tmp388_ = _tmp387_[(x * _tmp387__length2) + y];
#line 503 "../src/nibbles-view.vala"
								if (_tmp388_ >= ((gint) 'b')) {
#line 3486 "nibbles-view.c"
									gint* _tmp389_;
									gint _tmp389__length1;
									gint _tmp389__length2;
									gint _tmp390_;
#line 503 "../src/nibbles-view.vala"
									_tmp389_ = _data6_->game->board;
#line 503 "../src/nibbles-view.vala"
									_tmp389__length1 = _data6_->game->board_length1;
#line 503 "../src/nibbles-view.vala"
									_tmp389__length2 = _data6_->game->board_length2;
#line 503 "../src/nibbles-view.vala"
									_tmp390_ = _tmp389_[(x * _tmp389__length2) + y];
#line 503 "../src/nibbles-view.vala"
									_tmp386_ = _tmp390_ <= ((gint) 'l');
#line 3501 "nibbles-view.c"
								} else {
#line 503 "../src/nibbles-view.vala"
									_tmp386_ = FALSE;
#line 3505 "nibbles-view.c"
								}
#line 503 "../src/nibbles-view.vala"
								if (_tmp386_) {
#line 3509 "nibbles-view.c"
									gint* _tmp391_;
									gint _tmp391__length1;
									gint _tmp391__length2;
									gint _tmp392_;
#line 504 "../src/nibbles-view.vala"
									_tmp391_ = _data6_->game->board;
#line 504 "../src/nibbles-view.vala"
									_tmp391__length1 = _data6_->game->board_length1;
#line 504 "../src/nibbles-view.vala"
									_tmp391__length2 = _data6_->game->board_length2;
#line 504 "../src/nibbles-view.vala"
									_tmp392_ = _tmp391_[(x * _tmp391__length2) + y];
#line 504 "../src/nibbles-view.vala"
									nibbles_view_draw_wall_segment (self, _tmp392_, c, (x_delta * x) + x_offset, (y_delta * y) + y_offset, x_delta, y_delta);
#line 3524 "nibbles-view.c"
								}
#line 507 "../src/nibbles-view.vala"
								_tmp396_ = _data6_->game->board;
#line 507 "../src/nibbles-view.vala"
								_tmp396__length1 = _data6_->game->board_length1;
#line 507 "../src/nibbles-view.vala"
								_tmp396__length2 = _data6_->game->board_length2;
#line 507 "../src/nibbles-view.vala"
								_tmp397_ = _tmp396_[((x + 0) * _tmp396__length2) + (y + 0)];
#line 507 "../src/nibbles-view.vala"
								if (_tmp397_ == ((gint) NIBBLES_GAME_WARPCHAR)) {
#line 3536 "nibbles-view.c"
									gint* _tmp398_;
									gint _tmp398__length1;
									gint _tmp398__length2;
									gint _tmp399_;
#line 508 "../src/nibbles-view.vala"
									_tmp398_ = _data6_->game->board;
#line 508 "../src/nibbles-view.vala"
									_tmp398__length1 = _data6_->game->board_length1;
#line 508 "../src/nibbles-view.vala"
									_tmp398__length2 = _data6_->game->board_length2;
#line 508 "../src/nibbles-view.vala"
									_tmp399_ = _tmp398_[((x + 1) * _tmp398__length2) + (y + 0)];
#line 508 "../src/nibbles-view.vala"
									_tmp395_ = _tmp399_ == ((gint) NIBBLES_GAME_WARPCHAR);
#line 3551 "nibbles-view.c"
								} else {
#line 507 "../src/nibbles-view.vala"
									_tmp395_ = FALSE;
#line 3555 "nibbles-view.c"
								}
#line 507 "../src/nibbles-view.vala"
								if (_tmp395_) {
#line 3559 "nibbles-view.c"
									gint* _tmp400_;
									gint _tmp400__length1;
									gint _tmp400__length2;
									gint _tmp401_;
#line 509 "../src/nibbles-view.vala"
									_tmp400_ = _data6_->game->board;
#line 509 "../src/nibbles-view.vala"
									_tmp400__length1 = _data6_->game->board_length1;
#line 509 "../src/nibbles-view.vala"
									_tmp400__length2 = _data6_->game->board_length2;
#line 509 "../src/nibbles-view.vala"
									_tmp401_ = _tmp400_[((x + 0) * _tmp400__length2) + (y + 1)];
#line 509 "../src/nibbles-view.vala"
									_tmp394_ = _tmp401_ == ((gint) NIBBLES_GAME_WARPCHAR);
#line 3574 "nibbles-view.c"
								} else {
#line 507 "../src/nibbles-view.vala"
									_tmp394_ = FALSE;
#line 3578 "nibbles-view.c"
								}
#line 507 "../src/nibbles-view.vala"
								if (_tmp394_) {
#line 3582 "nibbles-view.c"
									gint* _tmp402_;
									gint _tmp402__length1;
									gint _tmp402__length2;
									gint _tmp403_;
#line 510 "../src/nibbles-view.vala"
									_tmp402_ = _data6_->game->board;
#line 510 "../src/nibbles-view.vala"
									_tmp402__length1 = _data6_->game->board_length1;
#line 510 "../src/nibbles-view.vala"
									_tmp402__length2 = _data6_->game->board_length2;
#line 510 "../src/nibbles-view.vala"
									_tmp403_ = _tmp402_[((x + 1) * _tmp402__length2) + (y + 1)];
#line 510 "../src/nibbles-view.vala"
									_tmp393_ = _tmp403_ == ((gint) NIBBLES_GAME_WARPCHAR);
#line 3597 "nibbles-view.c"
								} else {
#line 507 "../src/nibbles-view.vala"
									_tmp393_ = FALSE;
#line 3601 "nibbles-view.c"
								}
#line 507 "../src/nibbles-view.vala"
								if (_tmp393_) {
#line 512 "../src/nibbles-view.vala"
									nibbles_view_draw_bonus (self, c, (x_delta * x) + x_offset, (y_delta * y) + y_offset, x_delta + x_delta, y_delta + y_delta, BONUS_TYPE_WARP);
#line 3607 "nibbles-view.c"
								}
							}
						}
					}
				}
			}
		}
#line 518 "../src/nibbles-view.vala"
		_tmp404_ = gee_array_list_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
#line 518 "../src/nibbles-view.vala"
		materialized_worm_positions = _tmp404_;
#line 519 "../src/nibbles-view.vala"
		_tmp405_ = g_new0 (gint, 0);
#line 519 "../src/nibbles-view.vala"
		dematerialized_worms = _tmp405_;
#line 519 "../src/nibbles-view.vala"
		dematerialized_worms_length1 = 0;
#line 519 "../src/nibbles-view.vala"
		_dematerialized_worms_size_ = dematerialized_worms_length1;
#line 3627 "nibbles-view.c"
		{
			gint i = 0;
#line 520 "../src/nibbles-view.vala"
			i = 0;
#line 3632 "nibbles-view.c"
			{
				gboolean _tmp406_ = FALSE;
#line 520 "../src/nibbles-view.vala"
				_tmp406_ = TRUE;
#line 520 "../src/nibbles-view.vala"
				while (TRUE) {
#line 3639 "nibbles-view.c"
					GeeLinkedList* _tmp408_;
					GeeLinkedList* _tmp409_;
					gint _tmp410_;
					gint _tmp411_;
					GeeLinkedList* _tmp412_;
					GeeLinkedList* _tmp413_;
					gpointer _tmp414_;
					Worm* _tmp415_;
					gboolean _tmp416_;
					gboolean _tmp417_;
					gboolean _tmp418_;
#line 520 "../src/nibbles-view.vala"
					if (!_tmp406_) {
#line 3653 "nibbles-view.c"
						gint _tmp407_;
#line 520 "../src/nibbles-view.vala"
						_tmp407_ = i;
#line 520 "../src/nibbles-view.vala"
						i = _tmp407_ + 1;
#line 3659 "nibbles-view.c"
					}
#line 520 "../src/nibbles-view.vala"
					_tmp406_ = FALSE;
#line 520 "../src/nibbles-view.vala"
					_tmp408_ = nibbles_game_get_worms (_data6_->game);
#line 520 "../src/nibbles-view.vala"
					_tmp409_ = _tmp408_;
#line 520 "../src/nibbles-view.vala"
					_tmp410_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp409_);
#line 520 "../src/nibbles-view.vala"
					_tmp411_ = _tmp410_;
#line 520 "../src/nibbles-view.vala"
					if (!(i < _tmp411_)) {
#line 520 "../src/nibbles-view.vala"
						break;
#line 3675 "nibbles-view.c"
					}
#line 522 "../src/nibbles-view.vala"
					_tmp412_ = nibbles_game_get_worms (_data6_->game);
#line 522 "../src/nibbles-view.vala"
					_tmp413_ = _tmp412_;
#line 522 "../src/nibbles-view.vala"
					_tmp414_ = gee_abstract_list_get ((GeeAbstractList*) _tmp413_, i);
#line 522 "../src/nibbles-view.vala"
					_tmp415_ = (Worm*) _tmp414_;
#line 522 "../src/nibbles-view.vala"
					_tmp416_ = worm_get_is_materialized (_tmp415_);
#line 522 "../src/nibbles-view.vala"
					_tmp417_ = _tmp416_;
#line 522 "../src/nibbles-view.vala"
					_tmp418_ = _tmp417_;
#line 522 "../src/nibbles-view.vala"
					_g_object_unref0 (_tmp415_);
#line 522 "../src/nibbles-view.vala"
					if (_tmp418_) {
#line 3695 "nibbles-view.c"
						{
							WormPositions* _position_list = NULL;
							GeeLinkedList* _tmp419_;
							GeeLinkedList* _tmp420_;
							gpointer _tmp421_;
							Worm* _tmp422_;
							WormPositions* _tmp423_;
							WormPositions* _tmp424_;
							gint _position_size = 0;
							WormPositions* _tmp425_;
							gint _tmp426_;
							gint _tmp427_;
							gint _position_index = 0;
#line 523 "../src/nibbles-view.vala"
							_tmp419_ = nibbles_game_get_worms (_data6_->game);
#line 523 "../src/nibbles-view.vala"
							_tmp420_ = _tmp419_;
#line 523 "../src/nibbles-view.vala"
							_tmp421_ = gee_abstract_list_get ((GeeAbstractList*) _tmp420_, i);
#line 523 "../src/nibbles-view.vala"
							_tmp422_ = (Worm*) _tmp421_;
#line 523 "../src/nibbles-view.vala"
							_tmp423_ = _tmp422_->list;
#line 523 "../src/nibbles-view.vala"
							_tmp424_ = _tmp423_;
#line 523 "../src/nibbles-view.vala"
							_g_object_unref0 (_tmp422_);
#line 523 "../src/nibbles-view.vala"
							_position_list = _tmp424_;
#line 523 "../src/nibbles-view.vala"
							_tmp425_ = _position_list;
#line 523 "../src/nibbles-view.vala"
							_tmp426_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp425_);
#line 523 "../src/nibbles-view.vala"
							_tmp427_ = _tmp426_;
#line 523 "../src/nibbles-view.vala"
							_position_size = _tmp427_;
#line 523 "../src/nibbles-view.vala"
							_position_index = -1;
#line 523 "../src/nibbles-view.vala"
							while (TRUE) {
#line 3737 "nibbles-view.c"
								gint _tmp428_;
								gint _tmp429_;
								guint16 position = 0U;
								WormPositions* _tmp430_;
								gpointer _tmp431_;
								guint8 x = 0U;
								guint8 y = 0U;
								GeeHashMap* _tmp432_;
								GeeHashMap* _tmp433_;
								GeeLinkedList* _tmp434_;
								GeeLinkedList* _tmp435_;
								gpointer _tmp436_;
								Worm* _tmp437_;
								gpointer _tmp438_;
								WormProperties* _tmp439_;
								gint _tmp440_;
								gint _tmp441_;
								GeeLinkedList* _tmp442_;
								GeeLinkedList* _tmp443_;
								gpointer _tmp444_;
								Worm* _tmp445_;
								GeeArrayList* _tmp446_;
#line 523 "../src/nibbles-view.vala"
								_position_index = _position_index + 1;
#line 523 "../src/nibbles-view.vala"
								_tmp428_ = _position_index;
#line 523 "../src/nibbles-view.vala"
								_tmp429_ = _position_size;
#line 523 "../src/nibbles-view.vala"
								if (!(_tmp428_ < _tmp429_)) {
#line 523 "../src/nibbles-view.vala"
									break;
#line 3770 "nibbles-view.c"
								}
#line 523 "../src/nibbles-view.vala"
								_tmp430_ = _position_list;
#line 523 "../src/nibbles-view.vala"
								_tmp431_ = gee_abstract_list_get ((GeeAbstractList*) _tmp430_, _position_index);
#line 523 "../src/nibbles-view.vala"
								position = (guint16) ((guintptr) _tmp431_);
#line 525 "../src/nibbles-view.vala"
								x = (guint8) (position >> 8);
#line 526 "../src/nibbles-view.vala"
								y = (guint8) position;
#line 527 "../src/nibbles-view.vala"
								_tmp432_ = nibbles_game_get_worm_props (_data6_->game);
#line 527 "../src/nibbles-view.vala"
								_tmp433_ = _tmp432_;
#line 527 "../src/nibbles-view.vala"
								_tmp434_ = nibbles_game_get_worms (_data6_->game);
#line 527 "../src/nibbles-view.vala"
								_tmp435_ = _tmp434_;
#line 527 "../src/nibbles-view.vala"
								_tmp436_ = gee_abstract_list_get ((GeeAbstractList*) _tmp435_, i);
#line 527 "../src/nibbles-view.vala"
								_tmp437_ = (Worm*) _tmp436_;
#line 527 "../src/nibbles-view.vala"
								_tmp438_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp433_, _tmp437_);
#line 527 "../src/nibbles-view.vala"
								_tmp439_ = (WormProperties*) _tmp438_;
#line 527 "../src/nibbles-view.vala"
								_tmp440_ = worm_properties_get_color (_tmp439_);
#line 527 "../src/nibbles-view.vala"
								_tmp441_ = _tmp440_;
#line 527 "../src/nibbles-view.vala"
								_tmp442_ = nibbles_game_get_worms (_data6_->game);
#line 527 "../src/nibbles-view.vala"
								_tmp443_ = _tmp442_;
#line 527 "../src/nibbles-view.vala"
								_tmp444_ = gee_abstract_list_get ((GeeAbstractList*) _tmp443_, i);
#line 527 "../src/nibbles-view.vala"
								_tmp445_ = (Worm*) _tmp444_;
#line 527 "../src/nibbles-view.vala"
								nibbles_view_draw_worm_segment (self, c, (x_delta * x) + x_offset, (y_delta * y) + y_offset, x_delta, y_delta, _tmp441_, TRUE, worm_was_bonus_eaten_at_this_position (_tmp445_, position));
#line 527 "../src/nibbles-view.vala"
								_g_object_unref0 (_tmp445_);
#line 527 "../src/nibbles-view.vala"
								_g_object_unref0 (_tmp439_);
#line 527 "../src/nibbles-view.vala"
								_g_object_unref0 (_tmp437_);
#line 528 "../src/nibbles-view.vala"
								_tmp446_ = materialized_worm_positions;
#line 528 "../src/nibbles-view.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp446_, (gpointer) ((guintptr) position));
#line 3822 "nibbles-view.c"
							}
						}
					} else {
#line 531 "../src/nibbles-view.vala"
						_vala_array_add3 (&dematerialized_worms, &dematerialized_worms_length1, &_dematerialized_worms_size_, i);
#line 3828 "nibbles-view.c"
					}
				}
			}
		}
		{
			gint i = 0;
#line 534 "../src/nibbles-view.vala"
			i = 0;
#line 3837 "nibbles-view.c"
			{
				gboolean _tmp447_ = FALSE;
#line 534 "../src/nibbles-view.vala"
				_tmp447_ = TRUE;
#line 534 "../src/nibbles-view.vala"
				while (TRUE) {
#line 3844 "nibbles-view.c"
					gint* _tmp449_;
					gint _tmp449__length1;
#line 534 "../src/nibbles-view.vala"
					if (!_tmp447_) {
#line 3849 "nibbles-view.c"
						gint _tmp448_;
#line 534 "../src/nibbles-view.vala"
						_tmp448_ = i;
#line 534 "../src/nibbles-view.vala"
						i = _tmp448_ + 1;
#line 3855 "nibbles-view.c"
					}
#line 534 "../src/nibbles-view.vala"
					_tmp447_ = FALSE;
#line 534 "../src/nibbles-view.vala"
					_tmp449_ = dematerialized_worms;
#line 534 "../src/nibbles-view.vala"
					_tmp449__length1 = dematerialized_worms_length1;
#line 534 "../src/nibbles-view.vala"
					if (!(i < _tmp449__length1)) {
#line 534 "../src/nibbles-view.vala"
						break;
#line 3867 "nibbles-view.c"
					}
					{
						WormPositions* _position_list = NULL;
						GeeLinkedList* _tmp450_;
						GeeLinkedList* _tmp451_;
						gpointer _tmp452_;
						Worm* _tmp453_;
						WormPositions* _tmp454_;
						WormPositions* _tmp455_;
						gint _position_size = 0;
						WormPositions* _tmp456_;
						gint _tmp457_;
						gint _tmp458_;
						gint _position_index = 0;
#line 536 "../src/nibbles-view.vala"
						_tmp450_ = nibbles_game_get_worms (_data6_->game);
#line 536 "../src/nibbles-view.vala"
						_tmp451_ = _tmp450_;
#line 536 "../src/nibbles-view.vala"
						_tmp452_ = gee_abstract_list_get ((GeeAbstractList*) _tmp451_, i);
#line 536 "../src/nibbles-view.vala"
						_tmp453_ = (Worm*) _tmp452_;
#line 536 "../src/nibbles-view.vala"
						_tmp454_ = _tmp453_->list;
#line 536 "../src/nibbles-view.vala"
						_tmp455_ = _tmp454_;
#line 536 "../src/nibbles-view.vala"
						_g_object_unref0 (_tmp453_);
#line 536 "../src/nibbles-view.vala"
						_position_list = _tmp455_;
#line 536 "../src/nibbles-view.vala"
						_tmp456_ = _position_list;
#line 536 "../src/nibbles-view.vala"
						_tmp457_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp456_);
#line 536 "../src/nibbles-view.vala"
						_tmp458_ = _tmp457_;
#line 536 "../src/nibbles-view.vala"
						_position_size = _tmp458_;
#line 536 "../src/nibbles-view.vala"
						_position_index = -1;
#line 536 "../src/nibbles-view.vala"
						while (TRUE) {
#line 3910 "nibbles-view.c"
							gint _tmp459_;
							gint _tmp460_;
							guint16 position = 0U;
							WormPositions* _tmp461_;
							gpointer _tmp462_;
							GeeArrayList* _tmp463_;
#line 536 "../src/nibbles-view.vala"
							_position_index = _position_index + 1;
#line 536 "../src/nibbles-view.vala"
							_tmp459_ = _position_index;
#line 536 "../src/nibbles-view.vala"
							_tmp460_ = _position_size;
#line 536 "../src/nibbles-view.vala"
							if (!(_tmp459_ < _tmp460_)) {
#line 536 "../src/nibbles-view.vala"
								break;
#line 3927 "nibbles-view.c"
							}
#line 536 "../src/nibbles-view.vala"
							_tmp461_ = _position_list;
#line 536 "../src/nibbles-view.vala"
							_tmp462_ = gee_abstract_list_get ((GeeAbstractList*) _tmp461_, _position_index);
#line 536 "../src/nibbles-view.vala"
							position = (guint16) ((guintptr) _tmp462_);
#line 538 "../src/nibbles-view.vala"
							_tmp463_ = materialized_worm_positions;
#line 538 "../src/nibbles-view.vala"
							if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp463_, (gpointer) ((guintptr) position))) {
#line 3939 "nibbles-view.c"
								guint8 x = 0U;
								guint8 y = 0U;
								GeeHashMap* _tmp464_;
								GeeHashMap* _tmp465_;
								GeeLinkedList* _tmp466_;
								GeeLinkedList* _tmp467_;
								gpointer _tmp468_;
								Worm* _tmp469_;
								gpointer _tmp470_;
								WormProperties* _tmp471_;
								gint _tmp472_;
								gint _tmp473_;
#line 540 "../src/nibbles-view.vala"
								x = (guint8) (position >> 8);
#line 541 "../src/nibbles-view.vala"
								y = (guint8) position;
#line 542 "../src/nibbles-view.vala"
								_tmp464_ = nibbles_game_get_worm_props (_data6_->game);
#line 542 "../src/nibbles-view.vala"
								_tmp465_ = _tmp464_;
#line 542 "../src/nibbles-view.vala"
								_tmp466_ = nibbles_game_get_worms (_data6_->game);
#line 542 "../src/nibbles-view.vala"
								_tmp467_ = _tmp466_;
#line 542 "../src/nibbles-view.vala"
								_tmp468_ = gee_abstract_list_get ((GeeAbstractList*) _tmp467_, i);
#line 542 "../src/nibbles-view.vala"
								_tmp469_ = (Worm*) _tmp468_;
#line 542 "../src/nibbles-view.vala"
								_tmp470_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp465_, _tmp469_);
#line 542 "../src/nibbles-view.vala"
								_tmp471_ = (WormProperties*) _tmp470_;
#line 542 "../src/nibbles-view.vala"
								_tmp472_ = worm_properties_get_color (_tmp471_);
#line 542 "../src/nibbles-view.vala"
								_tmp473_ = _tmp472_;
#line 542 "../src/nibbles-view.vala"
								nibbles_view_draw_worm_segment (self, c, (x_delta * x) + x_offset, (y_delta * y) + y_offset, x_delta, y_delta, _tmp473_, FALSE, FALSE);
#line 542 "../src/nibbles-view.vala"
								_g_object_unref0 (_tmp471_);
#line 542 "../src/nibbles-view.vala"
								_g_object_unref0 (_tmp469_);
#line 3982 "nibbles-view.c"
							}
						}
					}
				}
			}
		}
		{
			GeeList* _bonus_list = NULL;
			GeeList* _tmp474_;
			gint _bonus_size = 0;
			GeeList* _tmp475_;
			gint _tmp476_;
			gint _tmp477_;
			gint _bonus_index = 0;
#line 548 "../src/nibbles-view.vala"
			_tmp474_ = nibbles_game_get_bonuses (_data6_->game);
#line 548 "../src/nibbles-view.vala"
			_bonus_list = _tmp474_;
#line 548 "../src/nibbles-view.vala"
			_tmp475_ = _bonus_list;
#line 548 "../src/nibbles-view.vala"
			_tmp476_ = gee_collection_get_size ((GeeCollection*) _tmp475_);
#line 548 "../src/nibbles-view.vala"
			_tmp477_ = _tmp476_;
#line 548 "../src/nibbles-view.vala"
			_bonus_size = _tmp477_;
#line 548 "../src/nibbles-view.vala"
			_bonus_index = -1;
#line 548 "../src/nibbles-view.vala"
			while (TRUE) {
#line 4013 "nibbles-view.c"
				gint _tmp478_;
				gint _tmp479_;
				Bonus* bonus = NULL;
				GeeList* _tmp480_;
				gpointer _tmp481_;
				Bonus* _tmp482_;
				guint8 _tmp483_;
				guint8 _tmp484_;
				Bonus* _tmp485_;
				guint8 _tmp486_;
				guint8 _tmp487_;
				Bonus* _tmp488_;
				BonusType _tmp489_;
				BonusType _tmp490_;
#line 548 "../src/nibbles-view.vala"
				_bonus_index = _bonus_index + 1;
#line 548 "../src/nibbles-view.vala"
				_tmp478_ = _bonus_index;
#line 548 "../src/nibbles-view.vala"
				_tmp479_ = _bonus_size;
#line 548 "../src/nibbles-view.vala"
				if (!(_tmp478_ < _tmp479_)) {
#line 548 "../src/nibbles-view.vala"
					break;
#line 4038 "nibbles-view.c"
				}
#line 548 "../src/nibbles-view.vala"
				_tmp480_ = _bonus_list;
#line 548 "../src/nibbles-view.vala"
				_tmp481_ = gee_list_get (_tmp480_, _bonus_index);
#line 548 "../src/nibbles-view.vala"
				bonus = (Bonus*) _tmp481_;
#line 550 "../src/nibbles-view.vala"
				_tmp482_ = bonus;
#line 550 "../src/nibbles-view.vala"
				_tmp483_ = bonus_get_x (_tmp482_);
#line 550 "../src/nibbles-view.vala"
				_tmp484_ = _tmp483_;
#line 550 "../src/nibbles-view.vala"
				_tmp485_ = bonus;
#line 550 "../src/nibbles-view.vala"
				_tmp486_ = bonus_get_y (_tmp485_);
#line 550 "../src/nibbles-view.vala"
				_tmp487_ = _tmp486_;
#line 550 "../src/nibbles-view.vala"
				_tmp488_ = bonus;
#line 550 "../src/nibbles-view.vala"
				_tmp489_ = bonus_get_bonus_type (_tmp488_);
#line 550 "../src/nibbles-view.vala"
				_tmp490_ = _tmp489_;
#line 550 "../src/nibbles-view.vala"
				nibbles_view_draw_bonus (self, c, (x_delta * _tmp484_) + x_offset, (y_delta * _tmp487_) + y_offset, x_delta + x_delta, y_delta + y_delta, _tmp490_);
#line 548 "../src/nibbles-view.vala"
				_g_object_unref0 (bonus);
#line 4068 "nibbles-view.c"
			}
#line 548 "../src/nibbles-view.vala"
			_g_object_unref0 (_bonus_list);
#line 4072 "nibbles-view.c"
		}
#line 553 "../src/nibbles-view.vala"
		if (_data6_->countdown_active (_data6_->countdown_active_target) > 0) {
#line 4076 "nibbles-view.c"
			gchar* text = NULL;
			gchar* _tmp491_;
			gint text_width = 0;
			gdouble w = 0.0;
			gdouble h = 0.0;
			gint font_size = 0;
			const gchar* _tmp492_;
			gdouble _tmp493_ = 0.0;
			gdouble _tmp494_ = 0.0;
			gint _tmp495_;
			const gchar* _tmp496_;
#line 556 "../src/nibbles-view.vala"
			_tmp491_ = nibbles_view_seconds_string (self, _data6_->countdown_active (_data6_->countdown_active_target));
#line 556 "../src/nibbles-view.vala"
			text = _tmp491_;
#line 557 "../src/nibbles-view.vala"
			text_width = x_delta * 10;
#line 559 "../src/nibbles-view.vala"
			_tmp492_ = text;
#line 559 "../src/nibbles-view.vala"
			_tmp495_ = nibbles_view_calculate_font_size (self, c, _tmp492_, text_width, &_tmp493_, &_tmp494_);
#line 559 "../src/nibbles-view.vala"
			w = _tmp493_;
#line 559 "../src/nibbles-view.vala"
			h = _tmp494_;
#line 559 "../src/nibbles-view.vala"
			font_size = _tmp495_;
#line 560 "../src/nibbles-view.vala"
			_tmp496_ = text;
#line 560 "../src/nibbles-view.vala"
			nibbles_view_draw_text_font_size (self, c, (gint) ((x_offset + (x_delta * (NIBBLES_VIEW_WIDTH / 2))) - (w / 2)), (gint) ((y_offset + (y_delta * (NIBBLES_VIEW_HEIGHT / 2))) - (h / 2)), _tmp496_, font_size);
#line 4108 "nibbles-view.c"
			{
				GeeLinkedList* _worm_list = NULL;
				GeeLinkedList* _tmp497_;
				GeeLinkedList* _tmp498_;
				gint _worm_size = 0;
				GeeLinkedList* _tmp499_;
				gint _tmp500_;
				gint _tmp501_;
				gint _worm_index = 0;
#line 564 "../src/nibbles-view.vala"
				_tmp497_ = nibbles_game_get_worms (_data6_->game);
#line 564 "../src/nibbles-view.vala"
				_tmp498_ = _tmp497_;
#line 564 "../src/nibbles-view.vala"
				_worm_list = _tmp498_;
#line 564 "../src/nibbles-view.vala"
				_tmp499_ = _worm_list;
#line 564 "../src/nibbles-view.vala"
				_tmp500_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp499_);
#line 564 "../src/nibbles-view.vala"
				_tmp501_ = _tmp500_;
#line 564 "../src/nibbles-view.vala"
				_worm_size = _tmp501_;
#line 564 "../src/nibbles-view.vala"
				_worm_index = -1;
#line 564 "../src/nibbles-view.vala"
				while (TRUE) {
#line 4136 "nibbles-view.c"
					gint _tmp502_;
					gint _tmp503_;
					Worm* worm = NULL;
					GeeLinkedList* _tmp504_;
					gpointer _tmp505_;
					Worm* _tmp506_;
					WormPositions* _tmp507_;
					gboolean _tmp508_;
					gboolean _tmp509_;
#line 564 "../src/nibbles-view.vala"
					_worm_index = _worm_index + 1;
#line 564 "../src/nibbles-view.vala"
					_tmp502_ = _worm_index;
#line 564 "../src/nibbles-view.vala"
					_tmp503_ = _worm_size;
#line 564 "../src/nibbles-view.vala"
					if (!(_tmp502_ < _tmp503_)) {
#line 564 "../src/nibbles-view.vala"
						break;
#line 4156 "nibbles-view.c"
					}
#line 564 "../src/nibbles-view.vala"
					_tmp504_ = _worm_list;
#line 564 "../src/nibbles-view.vala"
					_tmp505_ = gee_abstract_list_get ((GeeAbstractList*) _tmp504_, _worm_index);
#line 564 "../src/nibbles-view.vala"
					worm = (Worm*) _tmp505_;
#line 566 "../src/nibbles-view.vala"
					_tmp506_ = worm;
#line 566 "../src/nibbles-view.vala"
					_tmp507_ = _tmp506_->list;
#line 566 "../src/nibbles-view.vala"
					_tmp508_ = gee_collection_get_is_empty ((GeeCollection*) _tmp507_);
#line 566 "../src/nibbles-view.vala"
					_tmp509_ = _tmp508_;
#line 566 "../src/nibbles-view.vala"
					if (!_tmp509_) {
#line 4174 "nibbles-view.c"
						gint color = 0;
						GeeHashMap* _tmp510_;
						GeeHashMap* _tmp511_;
						Worm* _tmp512_;
						gpointer _tmp513_;
						WormProperties* _tmp514_;
						gint _tmp515_;
						gint _tmp516_;
						gint _tmp517_;
						gboolean _tmp518_ = FALSE;
						Worm* _tmp519_;
						WormDirection _tmp520_;
						WormDirection _tmp521_;
#line 568 "../src/nibbles-view.vala"
						_tmp510_ = nibbles_game_get_worm_props (_data6_->game);
#line 568 "../src/nibbles-view.vala"
						_tmp511_ = _tmp510_;
#line 568 "../src/nibbles-view.vala"
						_tmp512_ = worm;
#line 568 "../src/nibbles-view.vala"
						_tmp513_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp511_, _tmp512_);
#line 568 "../src/nibbles-view.vala"
						_tmp514_ = (WormProperties*) _tmp513_;
#line 568 "../src/nibbles-view.vala"
						_tmp515_ = worm_properties_get_color (_tmp514_);
#line 568 "../src/nibbles-view.vala"
						_tmp516_ = _tmp515_;
#line 568 "../src/nibbles-view.vala"
						_tmp517_ = _tmp516_;
#line 568 "../src/nibbles-view.vala"
						_g_object_unref0 (_tmp514_);
#line 568 "../src/nibbles-view.vala"
						color = _tmp517_;
#line 569 "../src/nibbles-view.vala"
						_tmp519_ = worm;
#line 569 "../src/nibbles-view.vala"
						_tmp520_ = worm_get_direction (_tmp519_);
#line 569 "../src/nibbles-view.vala"
						_tmp521_ = _tmp520_;
#line 569 "../src/nibbles-view.vala"
						if (_tmp521_ == WORM_DIRECTION_UP) {
#line 569 "../src/nibbles-view.vala"
							_tmp518_ = TRUE;
#line 4218 "nibbles-view.c"
						} else {
							Worm* _tmp522_;
							WormDirection _tmp523_;
							WormDirection _tmp524_;
#line 569 "../src/nibbles-view.vala"
							_tmp522_ = worm;
#line 569 "../src/nibbles-view.vala"
							_tmp523_ = worm_get_direction (_tmp522_);
#line 569 "../src/nibbles-view.vala"
							_tmp524_ = _tmp523_;
#line 569 "../src/nibbles-view.vala"
							_tmp518_ = _tmp524_ == WORM_DIRECTION_DOWN;
#line 4231 "nibbles-view.c"
						}
#line 569 "../src/nibbles-view.vala"
						if (_tmp518_) {
#line 4235 "nibbles-view.c"
							gint middle = 0;
							Worm* _tmp525_;
							gint _tmp526_;
							gint _tmp527_;
							Worm* _tmp528_;
							WormPositions* _tmp529_;
							gpointer _tmp530_;
							Worm* _tmp531_;
							WormPositions* _tmp532_;
							gpointer _tmp533_;
							Worm* _tmp534_;
							gint _tmp535_;
							gint _tmp536_;
							gchar* _tmp537_;
							gchar* _tmp538_;
							Worm* _tmp539_;
							gint _tmp540_;
							gint _tmp541_;
#line 572 "../src/nibbles-view.vala"
							_tmp525_ = worm;
#line 572 "../src/nibbles-view.vala"
							_tmp526_ = worm_get_length (_tmp525_);
#line 572 "../src/nibbles-view.vala"
							_tmp527_ = _tmp526_;
#line 572 "../src/nibbles-view.vala"
							middle = _tmp527_ / 2;
#line 573 "../src/nibbles-view.vala"
							_tmp528_ = worm;
#line 573 "../src/nibbles-view.vala"
							_tmp529_ = _tmp528_->list;
#line 573 "../src/nibbles-view.vala"
							_tmp530_ = gee_abstract_list_get ((GeeAbstractList*) _tmp529_, middle);
#line 573 "../src/nibbles-view.vala"
							_tmp531_ = worm;
#line 573 "../src/nibbles-view.vala"
							_tmp532_ = _tmp531_->list;
#line 573 "../src/nibbles-view.vala"
							_tmp533_ = gee_abstract_list_get ((GeeAbstractList*) _tmp532_, middle);
#line 573 "../src/nibbles-view.vala"
							_tmp534_ = worm;
#line 573 "../src/nibbles-view.vala"
							_tmp535_ = worm_get_id (_tmp534_);
#line 573 "../src/nibbles-view.vala"
							_tmp536_ = _tmp535_;
#line 573 "../src/nibbles-view.vala"
							_tmp537_ = nibbles_view_worm_name (self, _tmp536_ + 1);
#line 573 "../src/nibbles-view.vala"
							_tmp538_ = _tmp537_;
#line 573 "../src/nibbles-view.vala"
							_tmp539_ = worm;
#line 573 "../src/nibbles-view.vala"
							_tmp540_ = worm_get_length (_tmp539_);
#line 573 "../src/nibbles-view.vala"
							_tmp541_ = _tmp540_;
#line 573 "../src/nibbles-view.vala"
							nibbles_view_draw_text_target_width (self, c, (x_offset + (x_delta * ((((guint16) ((guintptr) _tmp530_)) >> 8) + 1))) + (x_delta / 2), y_offset + (y_delta * ((guint8) ((guint16) ((guintptr) _tmp533_)))), _tmp538_, x_delta * _tmp541_, color);
#line 573 "../src/nibbles-view.vala"
							_g_free0 (_tmp538_);
#line 4294 "nibbles-view.c"
						} else {
							gboolean _tmp542_ = FALSE;
							Worm* _tmp543_;
							WormDirection _tmp544_;
							WormDirection _tmp545_;
#line 577 "../src/nibbles-view.vala"
							_tmp543_ = worm;
#line 577 "../src/nibbles-view.vala"
							_tmp544_ = worm_get_direction (_tmp543_);
#line 577 "../src/nibbles-view.vala"
							_tmp545_ = _tmp544_;
#line 577 "../src/nibbles-view.vala"
							if (_tmp545_ == WORM_DIRECTION_LEFT) {
#line 577 "../src/nibbles-view.vala"
								_tmp542_ = TRUE;
#line 4310 "nibbles-view.c"
							} else {
								Worm* _tmp546_;
								WormDirection _tmp547_;
								WormDirection _tmp548_;
#line 577 "../src/nibbles-view.vala"
								_tmp546_ = worm;
#line 577 "../src/nibbles-view.vala"
								_tmp547_ = worm_get_direction (_tmp546_);
#line 577 "../src/nibbles-view.vala"
								_tmp548_ = _tmp547_;
#line 577 "../src/nibbles-view.vala"
								_tmp542_ = _tmp548_ == WORM_DIRECTION_RIGHT;
#line 4323 "nibbles-view.c"
							}
#line 577 "../src/nibbles-view.vala"
							if (_tmp542_) {
#line 4327 "nibbles-view.c"
								gint x = 0;
								Worm* _tmp549_;
								WormPositions* _tmp550_;
								gpointer _tmp551_;
								Worm* _tmp552_;
								WormPositions* _tmp553_;
								Worm* _tmp554_;
								gint _tmp555_;
								gint _tmp556_;
								gpointer _tmp557_;
								Worm* _tmp564_;
								WormPositions* _tmp565_;
								gpointer _tmp566_;
								Worm* _tmp567_;
								gint _tmp568_;
								gint _tmp569_;
								gchar* _tmp570_;
								gchar* _tmp571_;
								Worm* _tmp572_;
								gint _tmp573_;
								gint _tmp574_;
#line 580 "../src/nibbles-view.vala"
								_tmp549_ = worm;
#line 580 "../src/nibbles-view.vala"
								_tmp550_ = _tmp549_->list;
#line 580 "../src/nibbles-view.vala"
								_tmp551_ = gee_abstract_list_get ((GeeAbstractList*) _tmp550_, 0);
#line 580 "../src/nibbles-view.vala"
								x = ((guint16) ((guintptr) _tmp551_)) >> 8;
#line 581 "../src/nibbles-view.vala"
								_tmp552_ = worm;
#line 581 "../src/nibbles-view.vala"
								_tmp553_ = _tmp552_->list;
#line 581 "../src/nibbles-view.vala"
								_tmp554_ = worm;
#line 581 "../src/nibbles-view.vala"
								_tmp555_ = worm_get_length (_tmp554_);
#line 581 "../src/nibbles-view.vala"
								_tmp556_ = _tmp555_;
#line 581 "../src/nibbles-view.vala"
								_tmp557_ = gee_abstract_list_get ((GeeAbstractList*) _tmp553_, _tmp556_ - 1);
#line 581 "../src/nibbles-view.vala"
								if (x > (((guint16) ((guintptr) _tmp557_)) >> 8)) {
#line 4371 "nibbles-view.c"
									Worm* _tmp558_;
									WormPositions* _tmp559_;
									Worm* _tmp560_;
									gint _tmp561_;
									gint _tmp562_;
									gpointer _tmp563_;
#line 582 "../src/nibbles-view.vala"
									_tmp558_ = worm;
#line 582 "../src/nibbles-view.vala"
									_tmp559_ = _tmp558_->list;
#line 582 "../src/nibbles-view.vala"
									_tmp560_ = worm;
#line 582 "../src/nibbles-view.vala"
									_tmp561_ = worm_get_length (_tmp560_);
#line 582 "../src/nibbles-view.vala"
									_tmp562_ = _tmp561_;
#line 582 "../src/nibbles-view.vala"
									_tmp563_ = gee_abstract_list_get ((GeeAbstractList*) _tmp559_, _tmp562_ - 1);
#line 582 "../src/nibbles-view.vala"
									x = ((guint16) ((guintptr) _tmp563_)) >> 8;
#line 4392 "nibbles-view.c"
								}
#line 583 "../src/nibbles-view.vala"
								_tmp564_ = worm;
#line 583 "../src/nibbles-view.vala"
								_tmp565_ = _tmp564_->list;
#line 583 "../src/nibbles-view.vala"
								_tmp566_ = gee_abstract_list_get ((GeeAbstractList*) _tmp565_, 0);
#line 583 "../src/nibbles-view.vala"
								_tmp567_ = worm;
#line 583 "../src/nibbles-view.vala"
								_tmp568_ = worm_get_id (_tmp567_);
#line 583 "../src/nibbles-view.vala"
								_tmp569_ = _tmp568_;
#line 583 "../src/nibbles-view.vala"
								_tmp570_ = nibbles_view_worm_name (self, _tmp569_ + 1);
#line 583 "../src/nibbles-view.vala"
								_tmp571_ = _tmp570_;
#line 583 "../src/nibbles-view.vala"
								_tmp572_ = worm;
#line 583 "../src/nibbles-view.vala"
								_tmp573_ = worm_get_length (_tmp572_);
#line 583 "../src/nibbles-view.vala"
								_tmp574_ = _tmp573_;
#line 583 "../src/nibbles-view.vala"
								nibbles_view_draw_text_target_width (self, c, x_offset + (x_delta * x), (y_offset + (y_delta * ((guint8) ((guint16) ((guintptr) _tmp566_))))) - y_delta, _tmp571_, x_delta * _tmp574_, color);
#line 583 "../src/nibbles-view.vala"
								_g_free0 (_tmp571_);
#line 4420 "nibbles-view.c"
							}
						}
					}
#line 564 "../src/nibbles-view.vala"
					_g_object_unref0 (worm);
#line 4426 "nibbles-view.c"
				}
			}
#line 553 "../src/nibbles-view.vala"
			_g_free0 (text);
#line 4431 "nibbles-view.c"
		}
#line 591 "../src/nibbles-view.vala"
		_tmp578_ = _data6_->new_game_dialogue_active (&_tmp575_, &_tmp576_, &_tmp577_, _data6_->new_game_dialogue_active_target);
#line 591 "../src/nibbles-view.vala"
		(self->priv->result_function_target_destroy_notify == NULL) ? NULL : (self->priv->result_function_target_destroy_notify (self->priv->result_function_target), NULL);
#line 591 "../src/nibbles-view.vala"
		self->priv->result_function = NULL;
#line 591 "../src/nibbles-view.vala"
		self->priv->result_function_target = NULL;
#line 591 "../src/nibbles-view.vala"
		self->priv->result_function_target_destroy_notify = NULL;
#line 591 "../src/nibbles-view.vala"
		self->priv->result_function = _tmp575_;
#line 591 "../src/nibbles-view.vala"
		self->priv->result_function_target = _tmp576_;
#line 591 "../src/nibbles-view.vala"
		self->priv->result_function_target_destroy_notify = _tmp577_;
#line 591 "../src/nibbles-view.vala"
		if (_tmp578_) {
#line 4451 "nibbles-view.c"
			YesNoResultFunction _tmp579_;
			gpointer _tmp579__target;
#line 593 "../src/nibbles-view.vala"
			_tmp579_ = self->priv->result_function;
#line 593 "../src/nibbles-view.vala"
			_tmp579__target = self->priv->result_function_target;
#line 593 "../src/nibbles-view.vala"
			nibbles_view_new_game_dialogue_draw (self, c, (gdouble) width, (gdouble) height, _tmp579_, _tmp579__target);
#line 4460 "nibbles-view.c"
		}
#line 263 "../src/nibbles-view.vala"
		dematerialized_worms = (g_free (dematerialized_worms), NULL);
#line 263 "../src/nibbles-view.vala"
		_g_object_unref0 (materialized_worm_positions);
#line 4466 "nibbles-view.c"
	}
}

static void
___lambda18__gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                         cairo_t* cr,
                                         gint width,
                                         gint height,
                                         gpointer self)
{
#line 261 "../src/nibbles-view.vala"
	__lambda18_ (self, drawing_area, cr, width, height);
#line 4479 "nibbles-view.c"
}

NibblesView*
nibbles_view_construct (GType object_type,
                        NibblesGame* game,
                        NibblesViewCountdownActiveFunction countdown_active,
                        gpointer countdown_active_target,
                        NewGameDialogueActiveFunction new_game_dialogue_active,
                        gpointer new_game_dialogue_active_target)
{
	NibblesView * self = NULL;
	Block6Data* _data6_;
	NibblesGame* _tmp0_;
	NibblesGame* _tmp1_;
#line 243 "../src/nibbles-view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 243 "../src/nibbles-view.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 243 "../src/nibbles-view.vala"
	_data6_->_ref_count_ = 1;
#line 243 "../src/nibbles-view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 243 "../src/nibbles-view.vala"
	_g_object_unref0 (_data6_->game);
#line 243 "../src/nibbles-view.vala"
	_data6_->game = _tmp0_;
#line 243 "../src/nibbles-view.vala"
	_data6_->countdown_active = countdown_active;
#line 243 "../src/nibbles-view.vala"
	_data6_->countdown_active_target = countdown_active_target;
#line 243 "../src/nibbles-view.vala"
	_data6_->new_game_dialogue_active = new_game_dialogue_active;
#line 243 "../src/nibbles-view.vala"
	_data6_->new_game_dialogue_active_target = new_game_dialogue_active_target;
#line 243 "../src/nibbles-view.vala"
	self = (NibblesView*) g_object_new (object_type, NULL);
#line 243 "../src/nibbles-view.vala"
	_data6_->self = g_object_ref (self);
#line 246 "../src/nibbles-view.vala"
	_tmp1_ = _g_object_ref0 (_data6_->game);
#line 246 "../src/nibbles-view.vala"
	_g_object_unref0 (self->priv->game);
#line 246 "../src/nibbles-view.vala"
	self->priv->game = _tmp1_;
#line 247 "../src/nibbles-view.vala"
	(self->priv->countdown_active_target_destroy_notify == NULL) ? NULL : (self->priv->countdown_active_target_destroy_notify (self->priv->countdown_active_target), NULL);
#line 247 "../src/nibbles-view.vala"
	self->priv->countdown_active = NULL;
#line 247 "../src/nibbles-view.vala"
	self->priv->countdown_active_target = NULL;
#line 247 "../src/nibbles-view.vala"
	self->priv->countdown_active_target_destroy_notify = NULL;
#line 247 "../src/nibbles-view.vala"
	self->priv->countdown_active = (NibblesViewCountdownActiveFunction) _data6_->countdown_active;
#line 247 "../src/nibbles-view.vala"
	self->priv->countdown_active_target = _data6_->countdown_active_target;
#line 247 "../src/nibbles-view.vala"
	self->priv->countdown_active_target_destroy_notify = NULL;
#line 248 "../src/nibbles-view.vala"
	(self->priv->new_game_dialogue_active_target_destroy_notify == NULL) ? NULL : (self->priv->new_game_dialogue_active_target_destroy_notify (self->priv->new_game_dialogue_active_target), NULL);
#line 248 "../src/nibbles-view.vala"
	self->priv->new_game_dialogue_active = NULL;
#line 248 "../src/nibbles-view.vala"
	self->priv->new_game_dialogue_active_target = NULL;
#line 248 "../src/nibbles-view.vala"
	self->priv->new_game_dialogue_active_target_destroy_notify = NULL;
#line 248 "../src/nibbles-view.vala"
	self->priv->new_game_dialogue_active = (NewGameDialogueActiveFunction) _data6_->new_game_dialogue_active;
#line 248 "../src/nibbles-view.vala"
	self->priv->new_game_dialogue_active_target = _data6_->new_game_dialogue_active_target;
#line 248 "../src/nibbles-view.vala"
	self->priv->new_game_dialogue_active_target_destroy_notify = NULL;
#line 251 "../src/nibbles-view.vala"
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) ___lambda16__gtk_widget_realize, self, 0);
#line 254 "../src/nibbles-view.vala"
	g_signal_connect_object ((GtkDrawingArea*) self, "resize", (GCallback) ___lambda17__gtk_drawing_area_resize, self, 0);
#line 258 "../src/nibbles-view.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 261 "../src/nibbles-view.vala"
	gtk_drawing_area_set_draw_func ((GtkDrawingArea*) self, ___lambda18__gtk_drawing_area_draw_func, block6_data_ref (_data6_), block6_data_unref);
#line 597 "../src/nibbles-view.vala"
	nibbles_view_connect_game_signals (self, _data6_->game);
#line 243 "../src/nibbles-view.vala"
	block6_data_unref (_data6_);
#line 243 "../src/nibbles-view.vala"
	_data6_ = NULL;
#line 243 "../src/nibbles-view.vala"
	return self;
#line 4568 "nibbles-view.c"
}

NibblesView*
nibbles_view_new (NibblesGame* game,
                  NibblesViewCountdownActiveFunction countdown_active,
                  gpointer countdown_active_target,
                  NewGameDialogueActiveFunction new_game_dialogue_active,
                  gpointer new_game_dialogue_active_target)
{
#line 243 "../src/nibbles-view.vala"
	return nibbles_view_construct (TYPE_NIBBLES_VIEW, game, countdown_active, countdown_active_target, new_game_dialogue_active, new_game_dialogue_active_target);
#line 4580 "nibbles-view.c"
}

static gchar*
nibbles_view_seconds_string (NibblesView* self,
                             gint s)
{
	gchar* result;
#line 600 "../src/nibbles-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 602 "../src/nibbles-view.vala"
	switch (s) {
#line 602 "../src/nibbles-view.vala"
		case 1:
#line 4594 "nibbles-view.c"
		{
			gchar* _tmp0_;
#line 606 "../src/nibbles-view.vala"
			_tmp0_ = g_strdup (_ ("1"));
#line 606 "../src/nibbles-view.vala"
			result = _tmp0_;
#line 606 "../src/nibbles-view.vala"
			return result;
#line 4603 "nibbles-view.c"
		}
#line 602 "../src/nibbles-view.vala"
		case 2:
#line 4607 "nibbles-view.c"
		{
			gchar* _tmp1_;
#line 609 "../src/nibbles-view.vala"
			_tmp1_ = g_strdup (_ ("2"));
#line 609 "../src/nibbles-view.vala"
			result = _tmp1_;
#line 609 "../src/nibbles-view.vala"
			return result;
#line 4616 "nibbles-view.c"
		}
#line 602 "../src/nibbles-view.vala"
		case 3:
#line 4620 "nibbles-view.c"
		{
			gchar* _tmp2_;
#line 612 "../src/nibbles-view.vala"
			_tmp2_ = g_strdup (_ ("3"));
#line 612 "../src/nibbles-view.vala"
			result = _tmp2_;
#line 612 "../src/nibbles-view.vala"
			return result;
#line 4629 "nibbles-view.c"
		}
		default:
		{
			gchar* _tmp3_;
#line 614 "../src/nibbles-view.vala"
			_tmp3_ = g_strdup ("");
#line 614 "../src/nibbles-view.vala"
			result = _tmp3_;
#line 614 "../src/nibbles-view.vala"
			return result;
#line 4640 "nibbles-view.c"
		}
	}
}

static gchar*
nibbles_view_worm_name (NibblesView* self,
                        gint id)
{
	gchar* result;
#line 619 "../src/nibbles-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 621 "../src/nibbles-view.vala"
	switch (id) {
#line 621 "../src/nibbles-view.vala"
		case 1:
#line 4656 "nibbles-view.c"
		{
			gchar* _tmp0_;
#line 625 "../src/nibbles-view.vala"
			_tmp0_ = g_strdup (_ ("Worm 1"));
#line 625 "../src/nibbles-view.vala"
			result = _tmp0_;
#line 625 "../src/nibbles-view.vala"
			return result;
#line 4665 "nibbles-view.c"
		}
#line 621 "../src/nibbles-view.vala"
		case 2:
#line 4669 "nibbles-view.c"
		{
			gchar* _tmp1_;
#line 628 "../src/nibbles-view.vala"
			_tmp1_ = g_strdup (_ ("Worm 2"));
#line 628 "../src/nibbles-view.vala"
			result = _tmp1_;
#line 628 "../src/nibbles-view.vala"
			return result;
#line 4678 "nibbles-view.c"
		}
#line 621 "../src/nibbles-view.vala"
		case 3:
#line 4682 "nibbles-view.c"
		{
			gchar* _tmp2_;
#line 631 "../src/nibbles-view.vala"
			_tmp2_ = g_strdup (_ ("Worm 3"));
#line 631 "../src/nibbles-view.vala"
			result = _tmp2_;
#line 631 "../src/nibbles-view.vala"
			return result;
#line 4691 "nibbles-view.c"
		}
#line 621 "../src/nibbles-view.vala"
		case 4:
#line 4695 "nibbles-view.c"
		{
			gchar* _tmp3_;
#line 634 "../src/nibbles-view.vala"
			_tmp3_ = g_strdup (_ ("Worm 4"));
#line 634 "../src/nibbles-view.vala"
			result = _tmp3_;
#line 634 "../src/nibbles-view.vala"
			return result;
#line 4704 "nibbles-view.c"
		}
#line 621 "../src/nibbles-view.vala"
		case 5:
#line 4708 "nibbles-view.c"
		{
			gchar* _tmp4_;
#line 637 "../src/nibbles-view.vala"
			_tmp4_ = g_strdup (_ ("Worm 5"));
#line 637 "../src/nibbles-view.vala"
			result = _tmp4_;
#line 637 "../src/nibbles-view.vala"
			return result;
#line 4717 "nibbles-view.c"
		}
#line 621 "../src/nibbles-view.vala"
		case 6:
#line 4721 "nibbles-view.c"
		{
			gchar* _tmp5_;
#line 640 "../src/nibbles-view.vala"
			_tmp5_ = g_strdup (_ ("Worm 6"));
#line 640 "../src/nibbles-view.vala"
			result = _tmp5_;
#line 640 "../src/nibbles-view.vala"
			return result;
#line 4730 "nibbles-view.c"
		}
		default:
		{
			gchar* _tmp6_;
#line 642 "../src/nibbles-view.vala"
			_tmp6_ = g_strdup ("");
#line 642 "../src/nibbles-view.vala"
			result = _tmp6_;
#line 642 "../src/nibbles-view.vala"
			return result;
#line 4741 "nibbles-view.c"
		}
	}
}

void
nibbles_view_redraw (NibblesView* self,
                     gboolean AnimateStep)
{
#line 647 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 649 "../src/nibbles-view.vala"
	if (AnimateStep) {
#line 4754 "nibbles-view.c"
		guint64 _tmp0_;
#line 650 "../src/nibbles-view.vala"
		self->priv->animate = self->priv->animate + 1;
#line 650 "../src/nibbles-view.vala"
		_tmp0_ = self->priv->animate;
#line 4760 "nibbles-view.c"
	}
#line 651 "../src/nibbles-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 4764 "nibbles-view.c"
}

static void
_nibbles_view_redraw_nibbles_game_redraw (NibblesGame* _sender,
                                          gboolean animate,
                                          gpointer self)
{
#line 657 "../src/nibbles-view.vala"
	nibbles_view_redraw ((NibblesView*) self, animate);
#line 4774 "nibbles-view.c"
}

void
nibbles_view_connect_game_signals (NibblesView* self,
                                   NibblesGame* game)
{
#line 655 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 655 "../src/nibbles-view.vala"
	g_return_if_fail (game != NULL);
#line 657 "../src/nibbles-view.vala"
	g_signal_connect_object (game, "redraw", (GCallback) _nibbles_view_redraw_nibbles_game_redraw, self, 0);
#line 4787 "nibbles-view.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 662 "../src/nibbles-view.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 662 "../src/nibbles-view.vala"
	return _data7_;
#line 4797 "nibbles-view.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 662 "../src/nibbles-view.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 4807 "nibbles-view.c"
		NibblesView* self;
#line 662 "../src/nibbles-view.vala"
		self = _data7_->self;
#line 662 "../src/nibbles-view.vala"
		_g_object_unref0 (self);
#line 662 "../src/nibbles-view.vala"
		g_slice_free (Block7Data, _data7_);
#line 4815 "nibbles-view.c"
	}
}

static void
__lambda19_ (NibblesView* self,
             gdouble x,
             gdouble y)
{
#line 671 "../src/nibbles-view.vala"
	nibbles_view_yesno_position (self, x, y);
#line 4826 "nibbles-view.c"
}

static void
___lambda19__gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                 gdouble x,
                                                 gdouble y,
                                                 gpointer self)
{
#line 671 "../src/nibbles-view.vala"
	__lambda19_ ((NibblesView*) self, x, y);
#line 4837 "nibbles-view.c"
}

static void
__lambda20_ (NibblesView* self,
             gdouble x,
             gdouble y)
{
#line 672 "../src/nibbles-view.vala"
	nibbles_view_yesno_position (self, x, y);
#line 4847 "nibbles-view.c"
}

static void
___lambda20__gtk_event_controller_motion_enter (GtkEventControllerMotion* _sender,
                                                gdouble x,
                                                gdouble y,
                                                gpointer self)
{
#line 672 "../src/nibbles-view.vala"
	__lambda20_ ((NibblesView*) self, x, y);
#line 4858 "nibbles-view.c"
}

static gboolean
__lambda21_ (Block7Data* _data7_,
             GdkEvent* event)
{
	NibblesView* self;
	gboolean result;
#line 675 "../src/nibbles-view.vala"
	self = _data7_->self;
#line 675 "../src/nibbles-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 677 "../src/nibbles-view.vala"
	switch (gdk_event_get_event_type (event)) {
#line 677 "../src/nibbles-view.vala"
		case GDK_BUTTON_PRESS:
#line 4875 "nibbles-view.c"
		{
#line 680 "../src/nibbles-view.vala"
			self->priv->mouse_pressed = TRUE;
#line 681 "../src/nibbles-view.vala"
			nibbles_view_redraw (self, FALSE);
#line 682 "../src/nibbles-view.vala"
			result = TRUE;
#line 682 "../src/nibbles-view.vala"
			return result;
#line 4885 "nibbles-view.c"
		}
#line 677 "../src/nibbles-view.vala"
		case GDK_BUTTON_RELEASE:
#line 4889 "nibbles-view.c"
		{
#line 684 "../src/nibbles-view.vala"
			self->priv->mouse_pressed = FALSE;
#line 685 "../src/nibbles-view.vala"
			if (self->priv->mouse_button > ((guint) 1)) {
#line 686 "../src/nibbles-view.vala"
				nibbles_view_redraw (self, FALSE);
#line 4897 "nibbles-view.c"
			} else {
#line 688 "../src/nibbles-view.vala"
				_data7_->result_function (self->priv->mouse_button, _data7_->result_function_target);
#line 4901 "nibbles-view.c"
			}
#line 689 "../src/nibbles-view.vala"
			result = TRUE;
#line 689 "../src/nibbles-view.vala"
			return result;
#line 4907 "nibbles-view.c"
		}
		default:
		{
#line 691 "../src/nibbles-view.vala"
			result = FALSE;
#line 691 "../src/nibbles-view.vala"
			return result;
#line 4915 "nibbles-view.c"
		}
	}
}

static gboolean
___lambda21__gtk_event_controller_legacy_event (GtkEventControllerLegacy* _sender,
                                                GdkEvent* event,
                                                gpointer self)
{
	gboolean result;
	result = __lambda21_ (self, event);
#line 675 "../src/nibbles-view.vala"
	return result;
#line 4929 "nibbles-view.c"
}

static void
nibbles_view_new_game_dialogue_draw (NibblesView* self,
                                     cairo_t* c,
                                     gdouble width,
                                     gdouble height,
                                     YesNoResultFunction result_function,
                                     gpointer result_function_target)
{
	Block7Data* _data7_;
	gchar* text = NULL;
	gchar* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	GtkEventControllerMotion* mouse_position = NULL;
	GtkEventControllerMotion* _tmp9_;
	GtkEventControllerLegacy* mouse_click = NULL;
	GtkEventControllerLegacy* _tmp10_;
	GtkEventController* _tmp11_;
	GtkEventController* _tmp12_;
#line 662 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 662 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 662 "../src/nibbles-view.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 662 "../src/nibbles-view.vala"
	_data7_->_ref_count_ = 1;
#line 662 "../src/nibbles-view.vala"
	_data7_->self = g_object_ref (self);
#line 662 "../src/nibbles-view.vala"
	_data7_->result_function = result_function;
#line 662 "../src/nibbles-view.vala"
	_data7_->result_function_target = result_function_target;
#line 665 "../src/nibbles-view.vala"
	_tmp0_ = g_strdup (_ ("Are you sure you want to start a new game?\n" \
"If you start a new game, the current one will be lost."));
#line 665 "../src/nibbles-view.vala"
	text = _tmp0_;
#line 666 "../src/nibbles-view.vala"
	nibbles_view_draw_dialogue (self, c, width, height, text, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_, &_tmp8_, TRUE);
#line 666 "../src/nibbles-view.vala"
	self->priv->b0_x = _tmp1_;
#line 666 "../src/nibbles-view.vala"
	self->priv->b0_y = _tmp2_;
#line 666 "../src/nibbles-view.vala"
	self->priv->b0_width = _tmp3_;
#line 666 "../src/nibbles-view.vala"
	self->priv->b0_height = _tmp4_;
#line 666 "../src/nibbles-view.vala"
	self->priv->b1_x = _tmp5_;
#line 666 "../src/nibbles-view.vala"
	self->priv->b1_y = _tmp6_;
#line 666 "../src/nibbles-view.vala"
	self->priv->b1_width = _tmp7_;
#line 666 "../src/nibbles-view.vala"
	self->priv->b1_height = _tmp8_;
#line 670 "../src/nibbles-view.vala"
	_tmp9_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ();
#line 670 "../src/nibbles-view.vala"
	mouse_position = _tmp9_;
#line 671 "../src/nibbles-view.vala"
	g_signal_connect_object (mouse_position, "motion", (GCallback) ___lambda19__gtk_event_controller_motion_motion, self, 0);
#line 672 "../src/nibbles-view.vala"
	g_signal_connect_object (mouse_position, "enter", (GCallback) ___lambda20__gtk_event_controller_motion_enter, self, 0);
#line 674 "../src/nibbles-view.vala"
	_tmp10_ = (GtkEventControllerLegacy*) gtk_event_controller_legacy_new ();
#line 674 "../src/nibbles-view.vala"
	mouse_click = _tmp10_;
#line 675 "../src/nibbles-view.vala"
	g_signal_connect_data (mouse_click, "event", (GCallback) ___lambda21__gtk_event_controller_legacy_event, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 694 "../src/nibbles-view.vala"
	_tmp11_ = _g_object_ref0 ((GtkEventController*) mouse_click);
#line 694 "../src/nibbles-view.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp11_);
#line 695 "../src/nibbles-view.vala"
	_tmp12_ = _g_object_ref0 ((GtkEventController*) mouse_position);
#line 695 "../src/nibbles-view.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp12_);
#line 662 "../src/nibbles-view.vala"
	_g_object_unref0 (mouse_click);
#line 662 "../src/nibbles-view.vala"
	_g_object_unref0 (mouse_position);
#line 662 "../src/nibbles-view.vala"
	_g_free0 (text);
#line 662 "../src/nibbles-view.vala"
	block7_data_unref (_data7_);
#line 662 "../src/nibbles-view.vala"
	_data7_ = NULL;
#line 5025 "nibbles-view.c"
}

static void
nibbles_view_yesno_position (NibblesView* self,
                             gdouble x,
                             gdouble y)
{
	guint new_button = 0U;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 698 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 701 "../src/nibbles-view.vala"
	if (x >= self->priv->b0_x) {
#line 701 "../src/nibbles-view.vala"
		_tmp2_ = x <= (self->priv->b0_x + self->priv->b0_width);
#line 5043 "nibbles-view.c"
	} else {
#line 701 "../src/nibbles-view.vala"
		_tmp2_ = FALSE;
#line 5047 "nibbles-view.c"
	}
#line 701 "../src/nibbles-view.vala"
	if (_tmp2_) {
#line 701 "../src/nibbles-view.vala"
		_tmp1_ = y >= self->priv->b0_y;
#line 5053 "nibbles-view.c"
	} else {
#line 701 "../src/nibbles-view.vala"
		_tmp1_ = FALSE;
#line 5057 "nibbles-view.c"
	}
#line 701 "../src/nibbles-view.vala"
	if (_tmp1_) {
#line 701 "../src/nibbles-view.vala"
		_tmp0_ = y <= (self->priv->b0_y + self->priv->b0_height);
#line 5063 "nibbles-view.c"
	} else {
#line 701 "../src/nibbles-view.vala"
		_tmp0_ = FALSE;
#line 5067 "nibbles-view.c"
	}
#line 701 "../src/nibbles-view.vala"
	if (_tmp0_) {
#line 702 "../src/nibbles-view.vala"
		new_button = (guint) 0;
#line 5073 "nibbles-view.c"
	} else {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
#line 703 "../src/nibbles-view.vala"
		if (x >= self->priv->b1_x) {
#line 703 "../src/nibbles-view.vala"
			_tmp5_ = x <= (self->priv->b1_x + self->priv->b1_width);
#line 5082 "nibbles-view.c"
		} else {
#line 703 "../src/nibbles-view.vala"
			_tmp5_ = FALSE;
#line 5086 "nibbles-view.c"
		}
#line 703 "../src/nibbles-view.vala"
		if (_tmp5_) {
#line 703 "../src/nibbles-view.vala"
			_tmp4_ = y >= self->priv->b1_y;
#line 5092 "nibbles-view.c"
		} else {
#line 703 "../src/nibbles-view.vala"
			_tmp4_ = FALSE;
#line 5096 "nibbles-view.c"
		}
#line 703 "../src/nibbles-view.vala"
		if (_tmp4_) {
#line 703 "../src/nibbles-view.vala"
			_tmp3_ = y <= (self->priv->b1_y + self->priv->b1_height);
#line 5102 "nibbles-view.c"
		} else {
#line 703 "../src/nibbles-view.vala"
			_tmp3_ = FALSE;
#line 5106 "nibbles-view.c"
		}
#line 703 "../src/nibbles-view.vala"
		if (_tmp3_) {
#line 704 "../src/nibbles-view.vala"
			new_button = (guint) 1;
#line 5112 "nibbles-view.c"
		} else {
#line 706 "../src/nibbles-view.vala"
			new_button = G_MAXUINT;
#line 5116 "nibbles-view.c"
		}
	}
#line 708 "../src/nibbles-view.vala"
	if (new_button != self->priv->mouse_button) {
#line 710 "../src/nibbles-view.vala"
		self->priv->mouse_button = new_button;
#line 711 "../src/nibbles-view.vala"
		nibbles_view_redraw (self, FALSE);
#line 5125 "nibbles-view.c"
	}
}

static void
nibbles_view_draw_oval (NibblesView* self,
                        cairo_t* C,
                        NibblesViewView3D* v,
                        NibblesViewPoint3D* a,
                        NibblesViewPoint3D* b,
                        NibblesViewPoint3D* c,
                        NibblesViewPoint3D* d)
{
	gdouble x[3] = {0};
	gdouble y[3] = {0};
	NibblesViewPoint3D p[8] = {0};
	NibblesViewPoint3D _tmp0_;
	NibblesViewPoint3D _tmp1_;
	NibblesViewPoint3D _tmp2_;
	NibblesViewPoint3D _tmp3_ = {0};
	NibblesViewPoint3D _tmp4_;
	NibblesViewPoint3D _tmp5_;
	NibblesViewPoint3D _tmp6_;
	NibblesViewPoint3D _tmp7_ = {0};
	NibblesViewPoint3D _tmp8_;
	NibblesViewPoint3D _tmp9_;
	NibblesViewPoint3D _tmp10_;
	NibblesViewPoint3D _tmp11_ = {0};
	NibblesViewPoint3D _tmp12_;
	NibblesViewPoint3D _tmp13_;
	NibblesViewPoint3D _tmp14_;
	NibblesViewPoint3D _tmp15_ = {0};
	NibblesViewPoint3D _tmp16_[8] = {0};
	guint lowest_y_midpoint_index = 0U;
	guint second_lowest_y_midpoint_index = 0U;
	gint _tmp26_ = 0;
	gint direction = 0;
#line 715 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 715 "../src/nibbles-view.vala"
	g_return_if_fail (C != NULL);
#line 715 "../src/nibbles-view.vala"
	g_return_if_fail (v != NULL);
#line 715 "../src/nibbles-view.vala"
	g_return_if_fail (a != NULL);
#line 715 "../src/nibbles-view.vala"
	g_return_if_fail (b != NULL);
#line 715 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 715 "../src/nibbles-view.vala"
	g_return_if_fail (d != NULL);
#line 720 "../src/nibbles-view.vala"
	_tmp0_ = *a;
#line 720 "../src/nibbles-view.vala"
	_tmp1_ = *a;
#line 720 "../src/nibbles-view.vala"
	_tmp2_ = *b;
#line 720 "../src/nibbles-view.vala"
	nibbles_view_mid_point (self, &_tmp1_, &_tmp2_, &_tmp3_);
#line 720 "../src/nibbles-view.vala"
	_tmp4_ = *b;
#line 720 "../src/nibbles-view.vala"
	_tmp5_ = *b;
#line 720 "../src/nibbles-view.vala"
	_tmp6_ = *c;
#line 720 "../src/nibbles-view.vala"
	nibbles_view_mid_point (self, &_tmp5_, &_tmp6_, &_tmp7_);
#line 720 "../src/nibbles-view.vala"
	_tmp8_ = *c;
#line 720 "../src/nibbles-view.vala"
	_tmp9_ = *c;
#line 720 "../src/nibbles-view.vala"
	_tmp10_ = *d;
#line 720 "../src/nibbles-view.vala"
	nibbles_view_mid_point (self, &_tmp9_, &_tmp10_, &_tmp11_);
#line 720 "../src/nibbles-view.vala"
	_tmp12_ = *d;
#line 720 "../src/nibbles-view.vala"
	_tmp13_ = *d;
#line 720 "../src/nibbles-view.vala"
	_tmp14_ = *a;
#line 720 "../src/nibbles-view.vala"
	nibbles_view_mid_point (self, &_tmp13_, &_tmp14_, &_tmp15_);
#line 720 "../src/nibbles-view.vala"
	_tmp16_[0] = _tmp0_;
#line 720 "../src/nibbles-view.vala"
	_tmp16_[1] = _tmp3_;
#line 720 "../src/nibbles-view.vala"
	_tmp16_[2] = _tmp4_;
#line 720 "../src/nibbles-view.vala"
	_tmp16_[3] = _tmp7_;
#line 720 "../src/nibbles-view.vala"
	_tmp16_[4] = _tmp8_;
#line 720 "../src/nibbles-view.vala"
	_tmp16_[5] = _tmp11_;
#line 720 "../src/nibbles-view.vala"
	_tmp16_[6] = _tmp12_;
#line 720 "../src/nibbles-view.vala"
	_tmp16_[7] = _tmp15_;
#line 720 "../src/nibbles-view.vala"
	memcpy (p, _tmp16_, 8 * sizeof (NibblesViewPoint3D));
#line 721 "../src/nibbles-view.vala"
	lowest_y_midpoint_index = G_MAXUINT;
#line 5228 "nibbles-view.c"
	{
		gint i = 0;
#line 722 "../src/nibbles-view.vala"
		i = 1;
#line 5233 "nibbles-view.c"
		{
			gboolean _tmp17_ = FALSE;
#line 722 "../src/nibbles-view.vala"
			_tmp17_ = TRUE;
#line 722 "../src/nibbles-view.vala"
			while (TRUE) {
#line 5240 "nibbles-view.c"
				gboolean _tmp18_ = FALSE;
#line 722 "../src/nibbles-view.vala"
				if (!_tmp17_) {
#line 722 "../src/nibbles-view.vala"
					i += 2;
#line 5246 "nibbles-view.c"
				}
#line 722 "../src/nibbles-view.vala"
				_tmp17_ = FALSE;
#line 722 "../src/nibbles-view.vala"
				if (!(i < 8)) {
#line 722 "../src/nibbles-view.vala"
					break;
#line 5254 "nibbles-view.c"
				}
#line 724 "../src/nibbles-view.vala"
				if (lowest_y_midpoint_index == G_MAXUINT) {
#line 724 "../src/nibbles-view.vala"
					_tmp18_ = TRUE;
#line 5260 "nibbles-view.c"
				} else {
					NibblesViewPoint3D _tmp19_;
					NibblesViewPoint3D _tmp20_;
#line 724 "../src/nibbles-view.vala"
					_tmp19_ = p[lowest_y_midpoint_index];
#line 724 "../src/nibbles-view.vala"
					_tmp20_ = p[i];
#line 724 "../src/nibbles-view.vala"
					_tmp18_ = _tmp19_.y > _tmp20_.y;
#line 5270 "nibbles-view.c"
				}
#line 724 "../src/nibbles-view.vala"
				if (_tmp18_) {
#line 725 "../src/nibbles-view.vala"
					lowest_y_midpoint_index = (guint) i;
#line 5276 "nibbles-view.c"
				}
			}
		}
	}
#line 727 "../src/nibbles-view.vala"
	second_lowest_y_midpoint_index = G_MAXUINT;
#line 5283 "nibbles-view.c"
	{
		gint i = 0;
#line 728 "../src/nibbles-view.vala"
		i = 1;
#line 5288 "nibbles-view.c"
		{
			gboolean _tmp21_ = FALSE;
#line 728 "../src/nibbles-view.vala"
			_tmp21_ = TRUE;
#line 728 "../src/nibbles-view.vala"
			while (TRUE) {
#line 5295 "nibbles-view.c"
				gboolean _tmp22_ = FALSE;
#line 728 "../src/nibbles-view.vala"
				if (!_tmp21_) {
#line 728 "../src/nibbles-view.vala"
					i += 2;
#line 5301 "nibbles-view.c"
				}
#line 728 "../src/nibbles-view.vala"
				_tmp21_ = FALSE;
#line 728 "../src/nibbles-view.vala"
				if (!(i < 8)) {
#line 728 "../src/nibbles-view.vala"
					break;
#line 5309 "nibbles-view.c"
				}
#line 730 "../src/nibbles-view.vala"
				if (((guint) i) != lowest_y_midpoint_index) {
#line 5313 "nibbles-view.c"
					gboolean _tmp23_ = FALSE;
#line 730 "../src/nibbles-view.vala"
					if (second_lowest_y_midpoint_index == G_MAXUINT) {
#line 730 "../src/nibbles-view.vala"
						_tmp23_ = TRUE;
#line 5319 "nibbles-view.c"
					} else {
						NibblesViewPoint3D _tmp24_;
						NibblesViewPoint3D _tmp25_;
#line 730 "../src/nibbles-view.vala"
						_tmp24_ = p[second_lowest_y_midpoint_index];
#line 730 "../src/nibbles-view.vala"
						_tmp25_ = p[i];
#line 730 "../src/nibbles-view.vala"
						_tmp23_ = _tmp24_.y > _tmp25_.y;
#line 5329 "nibbles-view.c"
					}
#line 730 "../src/nibbles-view.vala"
					_tmp22_ = _tmp23_;
#line 5333 "nibbles-view.c"
				} else {
#line 730 "../src/nibbles-view.vala"
					_tmp22_ = FALSE;
#line 5337 "nibbles-view.c"
				}
#line 730 "../src/nibbles-view.vala"
				if (_tmp22_) {
#line 731 "../src/nibbles-view.vala"
					second_lowest_y_midpoint_index = (guint) i;
#line 5343 "nibbles-view.c"
				}
			}
		}
	}
#line 734 "../src/nibbles-view.vala"
	if (second_lowest_y_midpoint_index > lowest_y_midpoint_index) {
#line 734 "../src/nibbles-view.vala"
		_tmp26_ = -1;
#line 5352 "nibbles-view.c"
	} else {
#line 734 "../src/nibbles-view.vala"
		_tmp26_ = 1;
#line 5356 "nibbles-view.c"
	}
#line 734 "../src/nibbles-view.vala"
	direction = _tmp26_;
#line 5360 "nibbles-view.c"
	{
		guint i = 0U;
#line 735 "../src/nibbles-view.vala"
		i = second_lowest_y_midpoint_index;
#line 5365 "nibbles-view.c"
		{
			gboolean _tmp27_ = FALSE;
#line 735 "../src/nibbles-view.vala"
			_tmp27_ = TRUE;
#line 735 "../src/nibbles-view.vala"
			while (TRUE) {
#line 5372 "nibbles-view.c"
				gint between_point = 0;
				gint next_index = 0;
				NibblesViewPoint3D _tmp28_;
				gdouble _tmp29_ = 0.0;
				gdouble _tmp30_ = 0.0;
				NibblesViewPoint3D _tmp31_;
				gdouble _tmp32_ = 0.0;
				gdouble _tmp33_ = 0.0;
				NibblesViewPoint3D _tmp34_;
				gdouble _tmp35_ = 0.0;
				gdouble _tmp36_ = 0.0;
				gdouble _tmp39_;
				gdouble _tmp40_;
				gdouble _tmp41_;
				gdouble _tmp42_;
				gdouble _tmp43_;
				gdouble _tmp44_;
#line 735 "../src/nibbles-view.vala"
				if (!_tmp27_) {
#line 5392 "nibbles-view.c"
				}
#line 735 "../src/nibbles-view.vala"
				_tmp27_ = FALSE;
#line 737 "../src/nibbles-view.vala"
				between_point = ((gint) i) + direction;
#line 738 "../src/nibbles-view.vala"
				next_index = between_point + direction;
#line 739 "../src/nibbles-view.vala"
				if (between_point < 0) {
#line 740 "../src/nibbles-view.vala"
					between_point += 8;
#line 5404 "nibbles-view.c"
				} else {
#line 741 "../src/nibbles-view.vala"
					if (between_point > 7) {
#line 742 "../src/nibbles-view.vala"
						between_point -= 8;
#line 5410 "nibbles-view.c"
					}
				}
#line 743 "../src/nibbles-view.vala"
				if (next_index < 0) {
#line 744 "../src/nibbles-view.vala"
					next_index += 8;
#line 5417 "nibbles-view.c"
				} else {
#line 745 "../src/nibbles-view.vala"
					if (next_index > 7) {
#line 746 "../src/nibbles-view.vala"
						next_index -= 8;
#line 5423 "nibbles-view.c"
					}
				}
#line 747 "../src/nibbles-view.vala"
				_tmp28_ = p[i];
#line 747 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp28_, &_tmp29_, &_tmp30_);
#line 747 "../src/nibbles-view.vala"
				x[0] = _tmp29_;
#line 747 "../src/nibbles-view.vala"
				y[0] = _tmp30_;
#line 748 "../src/nibbles-view.vala"
				_tmp31_ = p[between_point];
#line 748 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp31_, &_tmp32_, &_tmp33_);
#line 748 "../src/nibbles-view.vala"
				x[1] = _tmp32_;
#line 748 "../src/nibbles-view.vala"
				y[1] = _tmp33_;
#line 749 "../src/nibbles-view.vala"
				_tmp34_ = p[next_index];
#line 749 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp34_, &_tmp35_, &_tmp36_);
#line 749 "../src/nibbles-view.vala"
				x[2] = _tmp35_;
#line 749 "../src/nibbles-view.vala"
				y[2] = _tmp36_;
#line 750 "../src/nibbles-view.vala"
				if (i == second_lowest_y_midpoint_index) {
#line 5452 "nibbles-view.c"
					gdouble _tmp37_;
					gdouble _tmp38_;
#line 751 "../src/nibbles-view.vala"
					_tmp37_ = x[0];
#line 751 "../src/nibbles-view.vala"
					_tmp38_ = y[0];
#line 751 "../src/nibbles-view.vala"
					cairo_move_to (C, _tmp37_, _tmp38_);
#line 5461 "nibbles-view.c"
				}
#line 752 "../src/nibbles-view.vala"
				_tmp39_ = x[0];
#line 752 "../src/nibbles-view.vala"
				_tmp40_ = y[0];
#line 752 "../src/nibbles-view.vala"
				_tmp41_ = x[1];
#line 752 "../src/nibbles-view.vala"
				_tmp42_ = y[1];
#line 752 "../src/nibbles-view.vala"
				_tmp43_ = x[2];
#line 752 "../src/nibbles-view.vala"
				_tmp44_ = y[2];
#line 752 "../src/nibbles-view.vala"
				cairo_curve_to (C, _tmp39_, _tmp40_, _tmp41_, _tmp42_, _tmp43_, _tmp44_);
#line 753 "../src/nibbles-view.vala"
				i = (guint) next_index;
#line 754 "../src/nibbles-view.vala"
				if (i == second_lowest_y_midpoint_index) {
#line 755 "../src/nibbles-view.vala"
					break;
#line 5483 "nibbles-view.c"
				}
			}
		}
	}
}

static void
nibbles_view_mid_point (NibblesView* self,
                        NibblesViewPoint3D* a,
                        NibblesViewPoint3D* b,
                        NibblesViewPoint3D* result)
{
	gdouble _tmp0_ = 0.0;
	NibblesViewPoint3D _tmp1_;
	NibblesViewPoint3D _tmp2_;
	gdouble _tmp9_ = 0.0;
	NibblesViewPoint3D _tmp10_;
	NibblesViewPoint3D _tmp11_;
	gdouble _tmp18_ = 0.0;
	NibblesViewPoint3D _tmp19_;
	NibblesViewPoint3D _tmp20_;
	NibblesViewPoint3D _tmp27_ = {0};
#line 759 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 759 "../src/nibbles-view.vala"
	g_return_if_fail (a != NULL);
#line 759 "../src/nibbles-view.vala"
	g_return_if_fail (b != NULL);
#line 761 "../src/nibbles-view.vala"
	_tmp1_ = *a;
#line 761 "../src/nibbles-view.vala"
	_tmp2_ = *b;
#line 761 "../src/nibbles-view.vala"
	if (_tmp1_.x > _tmp2_.x) {
#line 5518 "nibbles-view.c"
		NibblesViewPoint3D _tmp3_;
		NibblesViewPoint3D _tmp4_;
		NibblesViewPoint3D _tmp5_;
#line 761 "../src/nibbles-view.vala"
		_tmp3_ = *a;
#line 761 "../src/nibbles-view.vala"
		_tmp4_ = *b;
#line 761 "../src/nibbles-view.vala"
		_tmp5_ = *b;
#line 761 "../src/nibbles-view.vala"
		_tmp0_ = ((_tmp3_.x - _tmp4_.x) / 2) + _tmp5_.x;
#line 5530 "nibbles-view.c"
	} else {
		NibblesViewPoint3D _tmp6_;
		NibblesViewPoint3D _tmp7_;
		NibblesViewPoint3D _tmp8_;
#line 761 "../src/nibbles-view.vala"
		_tmp6_ = *b;
#line 761 "../src/nibbles-view.vala"
		_tmp7_ = *a;
#line 761 "../src/nibbles-view.vala"
		_tmp8_ = *a;
#line 761 "../src/nibbles-view.vala"
		_tmp0_ = ((_tmp6_.x - _tmp7_.x) / 2) + _tmp8_.x;
#line 5543 "nibbles-view.c"
	}
#line 762 "../src/nibbles-view.vala"
	_tmp10_ = *a;
#line 762 "../src/nibbles-view.vala"
	_tmp11_ = *b;
#line 762 "../src/nibbles-view.vala"
	if (_tmp10_.y > _tmp11_.y) {
#line 5551 "nibbles-view.c"
		NibblesViewPoint3D _tmp12_;
		NibblesViewPoint3D _tmp13_;
		NibblesViewPoint3D _tmp14_;
#line 762 "../src/nibbles-view.vala"
		_tmp12_ = *a;
#line 762 "../src/nibbles-view.vala"
		_tmp13_ = *b;
#line 762 "../src/nibbles-view.vala"
		_tmp14_ = *b;
#line 762 "../src/nibbles-view.vala"
		_tmp9_ = ((_tmp12_.y - _tmp13_.y) / 2) + _tmp14_.y;
#line 5563 "nibbles-view.c"
	} else {
		NibblesViewPoint3D _tmp15_;
		NibblesViewPoint3D _tmp16_;
		NibblesViewPoint3D _tmp17_;
#line 762 "../src/nibbles-view.vala"
		_tmp15_ = *b;
#line 762 "../src/nibbles-view.vala"
		_tmp16_ = *a;
#line 762 "../src/nibbles-view.vala"
		_tmp17_ = *a;
#line 762 "../src/nibbles-view.vala"
		_tmp9_ = ((_tmp15_.y - _tmp16_.y) / 2) + _tmp17_.y;
#line 5576 "nibbles-view.c"
	}
#line 763 "../src/nibbles-view.vala"
	_tmp19_ = *a;
#line 763 "../src/nibbles-view.vala"
	_tmp20_ = *b;
#line 763 "../src/nibbles-view.vala"
	if (_tmp19_.z > _tmp20_.z) {
#line 5584 "nibbles-view.c"
		NibblesViewPoint3D _tmp21_;
		NibblesViewPoint3D _tmp22_;
		NibblesViewPoint3D _tmp23_;
#line 763 "../src/nibbles-view.vala"
		_tmp21_ = *a;
#line 763 "../src/nibbles-view.vala"
		_tmp22_ = *b;
#line 763 "../src/nibbles-view.vala"
		_tmp23_ = *b;
#line 763 "../src/nibbles-view.vala"
		_tmp18_ = ((_tmp21_.z - _tmp22_.z) / 2) + _tmp23_.z;
#line 5596 "nibbles-view.c"
	} else {
		NibblesViewPoint3D _tmp24_;
		NibblesViewPoint3D _tmp25_;
		NibblesViewPoint3D _tmp26_;
#line 763 "../src/nibbles-view.vala"
		_tmp24_ = *b;
#line 763 "../src/nibbles-view.vala"
		_tmp25_ = *a;
#line 763 "../src/nibbles-view.vala"
		_tmp26_ = *a;
#line 763 "../src/nibbles-view.vala"
		_tmp18_ = ((_tmp24_.z - _tmp25_.z) / 2) + _tmp26_.z;
#line 5609 "nibbles-view.c"
	}
#line 761 "../src/nibbles-view.vala"
	_tmp27_.x = _tmp0_;
#line 761 "../src/nibbles-view.vala"
	_tmp27_.y = _tmp9_;
#line 761 "../src/nibbles-view.vala"
	_tmp27_.z = _tmp18_;
#line 761 "../src/nibbles-view.vala"
	*result = _tmp27_;
#line 761 "../src/nibbles-view.vala"
	return;
#line 5621 "nibbles-view.c"
}

static void
nibbles_view_draw_sphere (NibblesView* self,
                          cairo_t* c,
                          NibblesViewView3D* v,
                          gint x,
                          gint y,
                          gdouble r,
                          gdouble g,
                          gdouble b,
                          gdouble size)
{
	gdouble increase = 0.0;
	NibblesViewPoint3D _tmp0_ = {0};
	NibblesViewPoint3D _tmp1_ = {0};
	NibblesViewPoint3D _tmp2_ = {0};
	NibblesViewPoint3D _tmp3_ = {0};
	gdouble X = 0.0;
	gdouble Y = 0.0;
	gdouble radius = 0.0;
	gdouble d = 0.0;
	gdouble top_x = 0.0;
	gdouble top_y = 0.0;
	NibblesViewPoint3D _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	NibblesViewPoint3D _tmp7_ = {0};
	NibblesViewPoint3D _tmp8_ = {0};
	NibblesViewPoint3D _tmp9_ = {0};
	NibblesViewPoint3D _tmp10_ = {0};
	NibblesViewPoint3D _tmp11_ = {0};
	NibblesViewPoint3D _tmp12_ = {0};
	NibblesViewPoint3D _tmp13_ = {0};
	NibblesViewPoint3D _tmp14_ = {0};
	NibblesViewPoint3D _tmp15_ = {0};
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	cairo_pattern_t* pat2 = NULL;
	cairo_pattern_t* _tmp18_;
#line 766 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 766 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 766 "../src/nibbles-view.vala"
	g_return_if_fail (v != NULL);
#line 768 "../src/nibbles-view.vala"
	increase = (size - 1) / 2;
#line 769 "../src/nibbles-view.vala"
	_tmp0_.x = (x + 0) - increase;
#line 769 "../src/nibbles-view.vala"
	_tmp0_.y = (y + 1.0) + increase;
#line 769 "../src/nibbles-view.vala"
	_tmp0_.z = 0 - increase;
#line 769 "../src/nibbles-view.vala"
	_tmp1_.x = (x + 0) - increase;
#line 769 "../src/nibbles-view.vala"
	_tmp1_.y = (y + 0.0) - increase;
#line 769 "../src/nibbles-view.vala"
	_tmp1_.z = 1 + increase;
#line 769 "../src/nibbles-view.vala"
	_tmp2_.x = (x + 1) + increase;
#line 769 "../src/nibbles-view.vala"
	_tmp2_.y = (y + 0.0) - increase;
#line 769 "../src/nibbles-view.vala"
	_tmp2_.z = 1 + increase;
#line 769 "../src/nibbles-view.vala"
	_tmp3_.x = (x + 1) + increase;
#line 769 "../src/nibbles-view.vala"
	_tmp3_.y = (y + 1.0) + increase;
#line 769 "../src/nibbles-view.vala"
	_tmp3_.z = 0 - increase;
#line 769 "../src/nibbles-view.vala"
	nibbles_view_draw_oval (self, c, v, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 774 "../src/nibbles-view.vala"
	_tmp4_.x = x + 0.5;
#line 774 "../src/nibbles-view.vala"
	_tmp4_.y = y + 0.5;
#line 774 "../src/nibbles-view.vala"
	_tmp4_.z = 0.5;
#line 774 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp4_, &_tmp5_, &_tmp6_);
#line 774 "../src/nibbles-view.vala"
	X = _tmp5_;
#line 774 "../src/nibbles-view.vala"
	Y = _tmp6_;
#line 775 "../src/nibbles-view.vala"
	_tmp7_.x = x + 0.5;
#line 775 "../src/nibbles-view.vala"
	_tmp7_.y = y + 0.5;
#line 775 "../src/nibbles-view.vala"
	_tmp7_.z = 0.5;
#line 775 "../src/nibbles-view.vala"
	_tmp8_.x = x + 0.5;
#line 775 "../src/nibbles-view.vala"
	_tmp8_.y = (y + 0.0) - increase;
#line 775 "../src/nibbles-view.vala"
	_tmp8_.z = 1 + increase;
#line 775 "../src/nibbles-view.vala"
	radius = nibbles_view_view3_d_2D_diff (v, &_tmp7_, &_tmp8_);
#line 776 "../src/nibbles-view.vala"
	_tmp9_.x = x + 0.5;
#line 776 "../src/nibbles-view.vala"
	_tmp9_.y = y + 0.5;
#line 776 "../src/nibbles-view.vala"
	_tmp9_.z = 0.5;
#line 776 "../src/nibbles-view.vala"
	_tmp10_.x = (x + 0.0) - increase;
#line 776 "../src/nibbles-view.vala"
	_tmp10_.y = y + 0.5;
#line 776 "../src/nibbles-view.vala"
	_tmp10_.z = 0.5;
#line 776 "../src/nibbles-view.vala"
	d = nibbles_view_view3_d_2D_diff (v, &_tmp9_, &_tmp10_);
#line 777 "../src/nibbles-view.vala"
	if (d > radius) {
#line 778 "../src/nibbles-view.vala"
		radius = d;
#line 5740 "nibbles-view.c"
	}
#line 779 "../src/nibbles-view.vala"
	_tmp11_.x = x + 0.5;
#line 779 "../src/nibbles-view.vala"
	_tmp11_.y = y + 0.5;
#line 779 "../src/nibbles-view.vala"
	_tmp11_.z = 0.5;
#line 779 "../src/nibbles-view.vala"
	_tmp12_.x = (x + 1.0) + increase;
#line 779 "../src/nibbles-view.vala"
	_tmp12_.y = y + 0.5;
#line 779 "../src/nibbles-view.vala"
	_tmp12_.z = 0.5;
#line 779 "../src/nibbles-view.vala"
	d = nibbles_view_view3_d_2D_diff (v, &_tmp11_, &_tmp12_);
#line 780 "../src/nibbles-view.vala"
	if (d > radius) {
#line 781 "../src/nibbles-view.vala"
		radius = d;
#line 5760 "nibbles-view.c"
	}
#line 782 "../src/nibbles-view.vala"
	_tmp13_.x = x + 0.5;
#line 782 "../src/nibbles-view.vala"
	_tmp13_.y = y + 0.5;
#line 782 "../src/nibbles-view.vala"
	_tmp13_.z = 0.5;
#line 782 "../src/nibbles-view.vala"
	_tmp14_.x = x + 0.5;
#line 782 "../src/nibbles-view.vala"
	_tmp14_.y = (y + 1.0) + increase;
#line 782 "../src/nibbles-view.vala"
	_tmp14_.z = 0.0 - increase;
#line 782 "../src/nibbles-view.vala"
	d = nibbles_view_view3_d_2D_diff (v, &_tmp13_, &_tmp14_);
#line 783 "../src/nibbles-view.vala"
	if (d > radius) {
#line 784 "../src/nibbles-view.vala"
		radius = d;
#line 5780 "nibbles-view.c"
	}
#line 786 "../src/nibbles-view.vala"
	_tmp15_.x = x + 0.5;
#line 786 "../src/nibbles-view.vala"
	_tmp15_.y = y + 0.5;
#line 786 "../src/nibbles-view.vala"
	_tmp15_.z = (gdouble) 1;
#line 786 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp15_, &_tmp16_, &_tmp17_);
#line 786 "../src/nibbles-view.vala"
	top_x = _tmp16_;
#line 786 "../src/nibbles-view.vala"
	top_y = _tmp17_;
#line 787 "../src/nibbles-view.vala"
	_tmp18_ = cairo_pattern_create_radial (X, Y, radius, top_x, top_y, radius / 20.0);
#line 787 "../src/nibbles-view.vala"
	pat2 = _tmp18_;
#line 788 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (pat2, (gdouble) 0, r / 10, g / 10, b / 10);
#line 789 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (pat2, (gdouble) 1, r, g, b);
#line 790 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (pat2, (gdouble) 2, ((1 - r) / 2) + r, ((1 - g) / 2) + g, ((1 - b) / 2) + b);
#line 791 "../src/nibbles-view.vala"
	cairo_set_source (c, pat2);
#line 792 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 766 "../src/nibbles-view.vala"
	_cairo_pattern_destroy0 (pat2);
#line 5810 "nibbles-view.c"
}

static void
nibbles_view_draw_eyes_front (NibblesView* self,
                              cairo_t* c,
                              NibblesViewView3D* v,
                              gint x,
                              gint y,
                              gboolean blink)
{
	gdouble e = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble b = 0.0;
	NibblesViewPoint3D centre = {0};
	NibblesViewPoint3D _tmp1_ = {0};
	NibblesViewPoint3D _tmp2_;
	NibblesViewPoint3D _tmp3_;
	NibblesViewPoint3D _tmp4_;
	NibblesViewPoint3D _tmp5_ = {0};
	NibblesViewPoint3D _tmp6_;
	NibblesViewPoint3D _tmp7_;
	NibblesViewPoint3D _tmp8_;
	NibblesViewPoint3D _tmp9_ = {0};
	NibblesViewPoint3D _tmp10_;
	NibblesViewPoint3D _tmp11_;
	NibblesViewPoint3D _tmp12_;
	NibblesViewPoint3D _tmp13_ = {0};
	NibblesViewPoint3D _tmp14_;
	NibblesViewPoint3D _tmp15_;
	NibblesViewPoint3D _tmp16_;
	NibblesViewPoint3D _tmp17_ = {0};
	NibblesViewPoint3D _tmp18_ = {0};
	NibblesViewPoint3D _tmp19_;
	NibblesViewPoint3D _tmp20_;
	NibblesViewPoint3D _tmp21_;
	NibblesViewPoint3D _tmp22_ = {0};
	NibblesViewPoint3D _tmp23_;
	NibblesViewPoint3D _tmp24_;
	NibblesViewPoint3D _tmp25_;
	NibblesViewPoint3D _tmp26_ = {0};
	NibblesViewPoint3D _tmp27_;
	NibblesViewPoint3D _tmp28_;
	NibblesViewPoint3D _tmp29_;
	NibblesViewPoint3D _tmp30_ = {0};
	NibblesViewPoint3D _tmp31_;
	NibblesViewPoint3D _tmp32_;
	NibblesViewPoint3D _tmp33_;
	NibblesViewPoint3D _tmp34_ = {0};
#line 795 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 795 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 795 "../src/nibbles-view.vala"
	g_return_if_fail (v != NULL);
#line 798 "../src/nibbles-view.vala"
	e = sqrt (0.125);
#line 799 "../src/nibbles-view.vala"
	if (blink) {
#line 799 "../src/nibbles-view.vala"
		_tmp0_ = 0.025;
#line 5871 "nibbles-view.c"
	} else {
#line 799 "../src/nibbles-view.vala"
		_tmp0_ = 0.1;
#line 5875 "nibbles-view.c"
	}
#line 799 "../src/nibbles-view.vala"
	b = _tmp0_;
#line 800 "../src/nibbles-view.vala"
	_tmp1_.x = (x + 0.5) - (e / 2);
#line 800 "../src/nibbles-view.vala"
	_tmp1_.y = (y + 0.5) + e;
#line 800 "../src/nibbles-view.vala"
	_tmp1_.z = 0.5 + (e / 2);
#line 800 "../src/nibbles-view.vala"
	centre = _tmp1_;
#line 801 "../src/nibbles-view.vala"
	_tmp2_ = centre;
#line 801 "../src/nibbles-view.vala"
	_tmp3_ = centre;
#line 801 "../src/nibbles-view.vala"
	_tmp4_ = centre;
#line 801 "../src/nibbles-view.vala"
	_tmp5_.x = _tmp2_.x - 0.1;
#line 801 "../src/nibbles-view.vala"
	_tmp5_.y = _tmp3_.y + b;
#line 801 "../src/nibbles-view.vala"
	_tmp5_.z = _tmp4_.z - b;
#line 801 "../src/nibbles-view.vala"
	_tmp6_ = centre;
#line 801 "../src/nibbles-view.vala"
	_tmp7_ = centre;
#line 801 "../src/nibbles-view.vala"
	_tmp8_ = centre;
#line 801 "../src/nibbles-view.vala"
	_tmp9_.x = _tmp6_.x - 0.1;
#line 801 "../src/nibbles-view.vala"
	_tmp9_.y = _tmp7_.y - b;
#line 801 "../src/nibbles-view.vala"
	_tmp9_.z = _tmp8_.z + b;
#line 801 "../src/nibbles-view.vala"
	_tmp10_ = centre;
#line 801 "../src/nibbles-view.vala"
	_tmp11_ = centre;
#line 801 "../src/nibbles-view.vala"
	_tmp12_ = centre;
#line 801 "../src/nibbles-view.vala"
	_tmp13_.x = _tmp10_.x + 0.1;
#line 801 "../src/nibbles-view.vala"
	_tmp13_.y = _tmp11_.y - b;
#line 801 "../src/nibbles-view.vala"
	_tmp13_.z = _tmp12_.z + b;
#line 801 "../src/nibbles-view.vala"
	_tmp14_ = centre;
#line 801 "../src/nibbles-view.vala"
	_tmp15_ = centre;
#line 801 "../src/nibbles-view.vala"
	_tmp16_ = centre;
#line 801 "../src/nibbles-view.vala"
	_tmp17_.x = _tmp14_.x + 0.1;
#line 801 "../src/nibbles-view.vala"
	_tmp17_.y = _tmp15_.y + b;
#line 801 "../src/nibbles-view.vala"
	_tmp17_.z = _tmp16_.z - b;
#line 801 "../src/nibbles-view.vala"
	nibbles_view_draw_oval (self, c, v, &_tmp5_, &_tmp9_, &_tmp13_, &_tmp17_);
#line 805 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 806 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 807 "../src/nibbles-view.vala"
	_tmp18_.x = (x + 0.5) + (e / 2);
#line 807 "../src/nibbles-view.vala"
	_tmp18_.y = (y + 0.5) + e;
#line 807 "../src/nibbles-view.vala"
	_tmp18_.z = 0.5 + (e / 2);
#line 807 "../src/nibbles-view.vala"
	centre = _tmp18_;
#line 808 "../src/nibbles-view.vala"
	_tmp19_ = centre;
#line 808 "../src/nibbles-view.vala"
	_tmp20_ = centre;
#line 808 "../src/nibbles-view.vala"
	_tmp21_ = centre;
#line 808 "../src/nibbles-view.vala"
	_tmp22_.x = _tmp19_.x - 0.1;
#line 808 "../src/nibbles-view.vala"
	_tmp22_.y = _tmp20_.y + b;
#line 808 "../src/nibbles-view.vala"
	_tmp22_.z = _tmp21_.z - b;
#line 808 "../src/nibbles-view.vala"
	_tmp23_ = centre;
#line 808 "../src/nibbles-view.vala"
	_tmp24_ = centre;
#line 808 "../src/nibbles-view.vala"
	_tmp25_ = centre;
#line 808 "../src/nibbles-view.vala"
	_tmp26_.x = _tmp23_.x - 0.1;
#line 808 "../src/nibbles-view.vala"
	_tmp26_.y = _tmp24_.y - b;
#line 808 "../src/nibbles-view.vala"
	_tmp26_.z = _tmp25_.z + b;
#line 808 "../src/nibbles-view.vala"
	_tmp27_ = centre;
#line 808 "../src/nibbles-view.vala"
	_tmp28_ = centre;
#line 808 "../src/nibbles-view.vala"
	_tmp29_ = centre;
#line 808 "../src/nibbles-view.vala"
	_tmp30_.x = _tmp27_.x + 0.1;
#line 808 "../src/nibbles-view.vala"
	_tmp30_.y = _tmp28_.y - b;
#line 808 "../src/nibbles-view.vala"
	_tmp30_.z = _tmp29_.z + b;
#line 808 "../src/nibbles-view.vala"
	_tmp31_ = centre;
#line 808 "../src/nibbles-view.vala"
	_tmp32_ = centre;
#line 808 "../src/nibbles-view.vala"
	_tmp33_ = centre;
#line 808 "../src/nibbles-view.vala"
	_tmp34_.x = _tmp31_.x + 0.1;
#line 808 "../src/nibbles-view.vala"
	_tmp34_.y = _tmp32_.y + b;
#line 808 "../src/nibbles-view.vala"
	_tmp34_.z = _tmp33_.z - b;
#line 808 "../src/nibbles-view.vala"
	nibbles_view_draw_oval (self, c, v, &_tmp22_, &_tmp26_, &_tmp30_, &_tmp34_);
#line 812 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 813 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 6003 "nibbles-view.c"
}

static void
nibbles_view_draw_eyes_left (NibblesView* self,
                             cairo_t* c,
                             NibblesViewView3D* v,
                             gint x,
                             gint y,
                             gboolean blink)
{
	gdouble e = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble b = 0.0;
	NibblesViewPoint3D centre = {0};
	NibblesViewPoint3D _tmp1_ = {0};
	NibblesViewPoint3D _tmp2_;
	NibblesViewPoint3D _tmp3_;
	NibblesViewPoint3D _tmp4_;
	NibblesViewPoint3D _tmp5_ = {0};
	NibblesViewPoint3D _tmp6_;
	NibblesViewPoint3D _tmp7_;
	NibblesViewPoint3D _tmp8_;
	NibblesViewPoint3D _tmp9_ = {0};
	NibblesViewPoint3D _tmp10_;
	NibblesViewPoint3D _tmp11_;
	NibblesViewPoint3D _tmp12_;
	NibblesViewPoint3D _tmp13_ = {0};
	NibblesViewPoint3D _tmp14_;
	NibblesViewPoint3D _tmp15_;
	NibblesViewPoint3D _tmp16_;
	NibblesViewPoint3D _tmp17_ = {0};
	NibblesViewPoint3D _tmp18_ = {0};
	NibblesViewPoint3D _tmp19_;
	NibblesViewPoint3D _tmp20_;
	NibblesViewPoint3D _tmp21_;
	NibblesViewPoint3D _tmp22_ = {0};
	NibblesViewPoint3D _tmp23_;
	NibblesViewPoint3D _tmp24_;
	NibblesViewPoint3D _tmp25_;
	NibblesViewPoint3D _tmp26_ = {0};
	NibblesViewPoint3D _tmp27_;
	NibblesViewPoint3D _tmp28_;
	NibblesViewPoint3D _tmp29_;
	NibblesViewPoint3D _tmp30_ = {0};
	NibblesViewPoint3D _tmp31_;
	NibblesViewPoint3D _tmp32_;
	NibblesViewPoint3D _tmp33_;
	NibblesViewPoint3D _tmp34_ = {0};
#line 816 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 816 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 816 "../src/nibbles-view.vala"
	g_return_if_fail (v != NULL);
#line 819 "../src/nibbles-view.vala"
	e = sqrt (0.125);
#line 820 "../src/nibbles-view.vala"
	if (blink) {
#line 820 "../src/nibbles-view.vala"
		_tmp0_ = 0.025;
#line 6064 "nibbles-view.c"
	} else {
#line 820 "../src/nibbles-view.vala"
		_tmp0_ = 0.1;
#line 6068 "nibbles-view.c"
	}
#line 820 "../src/nibbles-view.vala"
	b = _tmp0_;
#line 821 "../src/nibbles-view.vala"
	_tmp1_.x = (x + 0.5) - e;
#line 821 "../src/nibbles-view.vala"
	_tmp1_.y = (y + 0.5) - (e / 2);
#line 821 "../src/nibbles-view.vala"
	_tmp1_.z = 0.5 + (e / 2);
#line 821 "../src/nibbles-view.vala"
	centre = _tmp1_;
#line 822 "../src/nibbles-view.vala"
	_tmp2_ = centre;
#line 822 "../src/nibbles-view.vala"
	_tmp3_ = centre;
#line 822 "../src/nibbles-view.vala"
	_tmp4_ = centre;
#line 822 "../src/nibbles-view.vala"
	_tmp5_.x = _tmp2_.x - b;
#line 822 "../src/nibbles-view.vala"
	_tmp5_.y = _tmp3_.y - 0.1;
#line 822 "../src/nibbles-view.vala"
	_tmp5_.z = _tmp4_.z - b;
#line 822 "../src/nibbles-view.vala"
	_tmp6_ = centre;
#line 822 "../src/nibbles-view.vala"
	_tmp7_ = centre;
#line 822 "../src/nibbles-view.vala"
	_tmp8_ = centre;
#line 822 "../src/nibbles-view.vala"
	_tmp9_.x = _tmp6_.x + b;
#line 822 "../src/nibbles-view.vala"
	_tmp9_.y = _tmp7_.y - 0.1;
#line 822 "../src/nibbles-view.vala"
	_tmp9_.z = _tmp8_.z + b;
#line 822 "../src/nibbles-view.vala"
	_tmp10_ = centre;
#line 822 "../src/nibbles-view.vala"
	_tmp11_ = centre;
#line 822 "../src/nibbles-view.vala"
	_tmp12_ = centre;
#line 822 "../src/nibbles-view.vala"
	_tmp13_.x = _tmp10_.x + b;
#line 822 "../src/nibbles-view.vala"
	_tmp13_.y = _tmp11_.y + 0.1;
#line 822 "../src/nibbles-view.vala"
	_tmp13_.z = _tmp12_.z + b;
#line 822 "../src/nibbles-view.vala"
	_tmp14_ = centre;
#line 822 "../src/nibbles-view.vala"
	_tmp15_ = centre;
#line 822 "../src/nibbles-view.vala"
	_tmp16_ = centre;
#line 822 "../src/nibbles-view.vala"
	_tmp17_.x = _tmp14_.x - b;
#line 822 "../src/nibbles-view.vala"
	_tmp17_.y = _tmp15_.y + 0.1;
#line 822 "../src/nibbles-view.vala"
	_tmp17_.z = _tmp16_.z - b;
#line 822 "../src/nibbles-view.vala"
	nibbles_view_draw_oval (self, c, v, &_tmp5_, &_tmp9_, &_tmp13_, &_tmp17_);
#line 826 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 827 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 828 "../src/nibbles-view.vala"
	_tmp18_.x = (x + 0.5) - e;
#line 828 "../src/nibbles-view.vala"
	_tmp18_.y = (y + 0.5) + (e / 2);
#line 828 "../src/nibbles-view.vala"
	_tmp18_.z = 0.5 + (e / 2);
#line 828 "../src/nibbles-view.vala"
	centre = _tmp18_;
#line 829 "../src/nibbles-view.vala"
	_tmp19_ = centre;
#line 829 "../src/nibbles-view.vala"
	_tmp20_ = centre;
#line 829 "../src/nibbles-view.vala"
	_tmp21_ = centre;
#line 829 "../src/nibbles-view.vala"
	_tmp22_.x = _tmp19_.x - b;
#line 829 "../src/nibbles-view.vala"
	_tmp22_.y = _tmp20_.y - 0.1;
#line 829 "../src/nibbles-view.vala"
	_tmp22_.z = _tmp21_.z - b;
#line 829 "../src/nibbles-view.vala"
	_tmp23_ = centre;
#line 829 "../src/nibbles-view.vala"
	_tmp24_ = centre;
#line 829 "../src/nibbles-view.vala"
	_tmp25_ = centre;
#line 829 "../src/nibbles-view.vala"
	_tmp26_.x = _tmp23_.x + b;
#line 829 "../src/nibbles-view.vala"
	_tmp26_.y = _tmp24_.y - 0.1;
#line 829 "../src/nibbles-view.vala"
	_tmp26_.z = _tmp25_.z + b;
#line 829 "../src/nibbles-view.vala"
	_tmp27_ = centre;
#line 829 "../src/nibbles-view.vala"
	_tmp28_ = centre;
#line 829 "../src/nibbles-view.vala"
	_tmp29_ = centre;
#line 829 "../src/nibbles-view.vala"
	_tmp30_.x = _tmp27_.x + b;
#line 829 "../src/nibbles-view.vala"
	_tmp30_.y = _tmp28_.y + 0.1;
#line 829 "../src/nibbles-view.vala"
	_tmp30_.z = _tmp29_.z + b;
#line 829 "../src/nibbles-view.vala"
	_tmp31_ = centre;
#line 829 "../src/nibbles-view.vala"
	_tmp32_ = centre;
#line 829 "../src/nibbles-view.vala"
	_tmp33_ = centre;
#line 829 "../src/nibbles-view.vala"
	_tmp34_.x = _tmp31_.x - b;
#line 829 "../src/nibbles-view.vala"
	_tmp34_.y = _tmp32_.y + 0.1;
#line 829 "../src/nibbles-view.vala"
	_tmp34_.z = _tmp33_.z - b;
#line 829 "../src/nibbles-view.vala"
	nibbles_view_draw_oval (self, c, v, &_tmp22_, &_tmp26_, &_tmp30_, &_tmp34_);
#line 833 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 834 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 6196 "nibbles-view.c"
}

static void
nibbles_view_draw_eyes_right (NibblesView* self,
                              cairo_t* c,
                              NibblesViewView3D* v,
                              gint x,
                              gint y,
                              gboolean blink)
{
	gdouble e = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble b = 0.0;
	NibblesViewPoint3D centre = {0};
	NibblesViewPoint3D _tmp1_ = {0};
	NibblesViewPoint3D _tmp2_;
	NibblesViewPoint3D _tmp3_;
	NibblesViewPoint3D _tmp4_;
	NibblesViewPoint3D _tmp5_ = {0};
	NibblesViewPoint3D _tmp6_;
	NibblesViewPoint3D _tmp7_;
	NibblesViewPoint3D _tmp8_;
	NibblesViewPoint3D _tmp9_ = {0};
	NibblesViewPoint3D _tmp10_;
	NibblesViewPoint3D _tmp11_;
	NibblesViewPoint3D _tmp12_;
	NibblesViewPoint3D _tmp13_ = {0};
	NibblesViewPoint3D _tmp14_;
	NibblesViewPoint3D _tmp15_;
	NibblesViewPoint3D _tmp16_;
	NibblesViewPoint3D _tmp17_ = {0};
	NibblesViewPoint3D _tmp18_ = {0};
	NibblesViewPoint3D _tmp19_;
	NibblesViewPoint3D _tmp20_;
	NibblesViewPoint3D _tmp21_;
	NibblesViewPoint3D _tmp22_ = {0};
	NibblesViewPoint3D _tmp23_;
	NibblesViewPoint3D _tmp24_;
	NibblesViewPoint3D _tmp25_;
	NibblesViewPoint3D _tmp26_ = {0};
	NibblesViewPoint3D _tmp27_;
	NibblesViewPoint3D _tmp28_;
	NibblesViewPoint3D _tmp29_;
	NibblesViewPoint3D _tmp30_ = {0};
	NibblesViewPoint3D _tmp31_;
	NibblesViewPoint3D _tmp32_;
	NibblesViewPoint3D _tmp33_;
	NibblesViewPoint3D _tmp34_ = {0};
#line 837 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 837 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 837 "../src/nibbles-view.vala"
	g_return_if_fail (v != NULL);
#line 840 "../src/nibbles-view.vala"
	e = sqrt (0.125);
#line 841 "../src/nibbles-view.vala"
	if (blink) {
#line 841 "../src/nibbles-view.vala"
		_tmp0_ = 0.025;
#line 6257 "nibbles-view.c"
	} else {
#line 841 "../src/nibbles-view.vala"
		_tmp0_ = 0.1;
#line 6261 "nibbles-view.c"
	}
#line 841 "../src/nibbles-view.vala"
	b = _tmp0_;
#line 842 "../src/nibbles-view.vala"
	_tmp1_.x = (x + 0.5) + e;
#line 842 "../src/nibbles-view.vala"
	_tmp1_.y = (y + 0.5) - (e / 2);
#line 842 "../src/nibbles-view.vala"
	_tmp1_.z = 0.5 + (e / 2);
#line 842 "../src/nibbles-view.vala"
	centre = _tmp1_;
#line 843 "../src/nibbles-view.vala"
	_tmp2_ = centre;
#line 843 "../src/nibbles-view.vala"
	_tmp3_ = centre;
#line 843 "../src/nibbles-view.vala"
	_tmp4_ = centre;
#line 843 "../src/nibbles-view.vala"
	_tmp5_.x = _tmp2_.x + b;
#line 843 "../src/nibbles-view.vala"
	_tmp5_.y = _tmp3_.y - 0.1;
#line 843 "../src/nibbles-view.vala"
	_tmp5_.z = _tmp4_.z - b;
#line 843 "../src/nibbles-view.vala"
	_tmp6_ = centre;
#line 843 "../src/nibbles-view.vala"
	_tmp7_ = centre;
#line 843 "../src/nibbles-view.vala"
	_tmp8_ = centre;
#line 843 "../src/nibbles-view.vala"
	_tmp9_.x = _tmp6_.x - b;
#line 843 "../src/nibbles-view.vala"
	_tmp9_.y = _tmp7_.y - 0.1;
#line 843 "../src/nibbles-view.vala"
	_tmp9_.z = _tmp8_.z + b;
#line 843 "../src/nibbles-view.vala"
	_tmp10_ = centre;
#line 843 "../src/nibbles-view.vala"
	_tmp11_ = centre;
#line 843 "../src/nibbles-view.vala"
	_tmp12_ = centre;
#line 843 "../src/nibbles-view.vala"
	_tmp13_.x = _tmp10_.x - b;
#line 843 "../src/nibbles-view.vala"
	_tmp13_.y = _tmp11_.y + 0.1;
#line 843 "../src/nibbles-view.vala"
	_tmp13_.z = _tmp12_.z + b;
#line 843 "../src/nibbles-view.vala"
	_tmp14_ = centre;
#line 843 "../src/nibbles-view.vala"
	_tmp15_ = centre;
#line 843 "../src/nibbles-view.vala"
	_tmp16_ = centre;
#line 843 "../src/nibbles-view.vala"
	_tmp17_.x = _tmp14_.x + b;
#line 843 "../src/nibbles-view.vala"
	_tmp17_.y = _tmp15_.y + 0.1;
#line 843 "../src/nibbles-view.vala"
	_tmp17_.z = _tmp16_.z - b;
#line 843 "../src/nibbles-view.vala"
	nibbles_view_draw_oval (self, c, v, &_tmp5_, &_tmp9_, &_tmp13_, &_tmp17_);
#line 847 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 848 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 849 "../src/nibbles-view.vala"
	_tmp18_.x = (x + 0.5) + e;
#line 849 "../src/nibbles-view.vala"
	_tmp18_.y = (y + 0.5) + (e / 2);
#line 849 "../src/nibbles-view.vala"
	_tmp18_.z = 0.5 + (e / 2);
#line 849 "../src/nibbles-view.vala"
	centre = _tmp18_;
#line 850 "../src/nibbles-view.vala"
	_tmp19_ = centre;
#line 850 "../src/nibbles-view.vala"
	_tmp20_ = centre;
#line 850 "../src/nibbles-view.vala"
	_tmp21_ = centre;
#line 850 "../src/nibbles-view.vala"
	_tmp22_.x = _tmp19_.x + b;
#line 850 "../src/nibbles-view.vala"
	_tmp22_.y = _tmp20_.y - 0.1;
#line 850 "../src/nibbles-view.vala"
	_tmp22_.z = _tmp21_.z - b;
#line 850 "../src/nibbles-view.vala"
	_tmp23_ = centre;
#line 850 "../src/nibbles-view.vala"
	_tmp24_ = centre;
#line 850 "../src/nibbles-view.vala"
	_tmp25_ = centre;
#line 850 "../src/nibbles-view.vala"
	_tmp26_.x = _tmp23_.x - b;
#line 850 "../src/nibbles-view.vala"
	_tmp26_.y = _tmp24_.y - 0.1;
#line 850 "../src/nibbles-view.vala"
	_tmp26_.z = _tmp25_.z + b;
#line 850 "../src/nibbles-view.vala"
	_tmp27_ = centre;
#line 850 "../src/nibbles-view.vala"
	_tmp28_ = centre;
#line 850 "../src/nibbles-view.vala"
	_tmp29_ = centre;
#line 850 "../src/nibbles-view.vala"
	_tmp30_.x = _tmp27_.x - b;
#line 850 "../src/nibbles-view.vala"
	_tmp30_.y = _tmp28_.y + 0.1;
#line 850 "../src/nibbles-view.vala"
	_tmp30_.z = _tmp29_.z + b;
#line 850 "../src/nibbles-view.vala"
	_tmp31_ = centre;
#line 850 "../src/nibbles-view.vala"
	_tmp32_ = centre;
#line 850 "../src/nibbles-view.vala"
	_tmp33_ = centre;
#line 850 "../src/nibbles-view.vala"
	_tmp34_.x = _tmp31_.x + b;
#line 850 "../src/nibbles-view.vala"
	_tmp34_.y = _tmp32_.y + 0.1;
#line 850 "../src/nibbles-view.vala"
	_tmp34_.z = _tmp33_.z - b;
#line 850 "../src/nibbles-view.vala"
	nibbles_view_draw_oval (self, c, v, &_tmp22_, &_tmp26_, &_tmp30_, &_tmp34_);
#line 854 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 855 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 6389 "nibbles-view.c"
}

static void
nibbles_view_draw_3D_bonus (NibblesView* self,
                            cairo_t* c,
                            NibblesViewView3D* v,
                            gint x,
                            gint y,
                            Bonus* bonus)
{
	BonusType _tmp0_;
	BonusType _tmp1_;
#line 858 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 858 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 858 "../src/nibbles-view.vala"
	g_return_if_fail (v != NULL);
#line 858 "../src/nibbles-view.vala"
	g_return_if_fail (bonus != NULL);
#line 860 "../src/nibbles-view.vala"
	_tmp0_ = bonus_get_bonus_type (bonus);
#line 860 "../src/nibbles-view.vala"
	_tmp1_ = _tmp0_;
#line 860 "../src/nibbles-view.vala"
	switch (_tmp1_) {
#line 860 "../src/nibbles-view.vala"
		case BONUS_TYPE_REGULAR:
#line 6418 "nibbles-view.c"
		{
#line 863 "../src/nibbles-view.vala"
			nibbles_view_draw_apple (self, c, v, (gdouble) x, (gdouble) y);
#line 864 "../src/nibbles-view.vala"
			break;
#line 6424 "nibbles-view.c"
		}
#line 860 "../src/nibbles-view.vala"
		case BONUS_TYPE_HALF:
#line 6428 "nibbles-view.c"
		{
#line 866 "../src/nibbles-view.vala"
			nibbles_view_draw_cherry (self, c, v, (gdouble) x, (gdouble) y);
#line 867 "../src/nibbles-view.vala"
			break;
#line 6434 "nibbles-view.c"
		}
#line 860 "../src/nibbles-view.vala"
		case BONUS_TYPE_DOUBLE:
#line 6438 "nibbles-view.c"
		{
#line 869 "../src/nibbles-view.vala"
			nibbles_view_draw_banana (self, c, v, (gdouble) x, (gdouble) y);
#line 870 "../src/nibbles-view.vala"
			break;
#line 6444 "nibbles-view.c"
		}
#line 860 "../src/nibbles-view.vala"
		case BONUS_TYPE_LIFE:
#line 6448 "nibbles-view.c"
		{
#line 872 "../src/nibbles-view.vala"
			nibbles_view_draw_heart (self, c, v, (gdouble) x, (gdouble) y);
#line 873 "../src/nibbles-view.vala"
			break;
#line 6454 "nibbles-view.c"
		}
#line 860 "../src/nibbles-view.vala"
		case BONUS_TYPE_REVERSE:
#line 6458 "nibbles-view.c"
		{
#line 875 "../src/nibbles-view.vala"
			nibbles_view_draw_diamond (self, c, v, (gdouble) x, (gdouble) y);
#line 876 "../src/nibbles-view.vala"
			break;
#line 6464 "nibbles-view.c"
		}
#line 860 "../src/nibbles-view.vala"
		case BONUS_TYPE_WARP:
#line 6468 "nibbles-view.c"
		{
#line 878 "../src/nibbles-view.vala"
			break;
#line 6472 "nibbles-view.c"
		}
#line 860 "../src/nibbles-view.vala"
		case 6:
#line 6476 "nibbles-view.c"
		{
#line 880 "../src/nibbles-view.vala"
			break;
#line 6480 "nibbles-view.c"
		}
#line 860 "../src/nibbles-view.vala"
		case 7:
#line 6484 "nibbles-view.c"
		{
#line 882 "../src/nibbles-view.vala"
			break;
#line 6488 "nibbles-view.c"
		}
		default:
		{
#line 884 "../src/nibbles-view.vala"
			break;
#line 6494 "nibbles-view.c"
		}
	}
}

static void
nibbles_view_draw_banana (NibblesView* self,
                          cairo_t* c,
                          NibblesViewView3D* v,
                          gdouble x,
                          gdouble y)
{
	gdouble cx[3] = {0};
	gdouble cy[3] = {0};
	NibblesViewPoint3D _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	NibblesViewPoint3D _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	NibblesViewPoint3D _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	NibblesViewPoint3D _tmp17_ = {0};
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	NibblesViewPoint3D _tmp20_ = {0};
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
	NibblesViewPoint3D _tmp23_ = {0};
	gdouble _tmp24_ = 0.0;
	gdouble _tmp25_ = 0.0;
	gdouble _tmp26_;
	gdouble _tmp27_;
	gdouble _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	NibblesViewPoint3D _tmp32_ = {0};
	gdouble _tmp33_ = 0.0;
	gdouble _tmp34_ = 0.0;
	gdouble _tmp35_;
	gdouble _tmp36_;
	NibblesViewPoint3D _tmp37_ = {0};
	gdouble _tmp38_ = 0.0;
	gdouble _tmp39_ = 0.0;
	gdouble _tmp40_;
	gdouble _tmp41_;
	NibblesViewPoint3D _tmp42_ = {0};
	gdouble _tmp43_ = 0.0;
	gdouble _tmp44_ = 0.0;
	NibblesViewPoint3D _tmp45_ = {0};
	gdouble _tmp46_ = 0.0;
	gdouble _tmp47_ = 0.0;
	NibblesViewPoint3D _tmp48_ = {0};
	gdouble _tmp49_ = 0.0;
	gdouble _tmp50_ = 0.0;
	gdouble _tmp51_;
	gdouble _tmp52_;
	gdouble _tmp53_;
	gdouble _tmp54_;
	gdouble _tmp55_;
	gdouble _tmp56_;
	NibblesViewPoint3D _tmp57_ = {0};
	gdouble _tmp58_ = 0.0;
	gdouble _tmp59_ = 0.0;
	NibblesViewPoint3D _tmp60_ = {0};
	gdouble _tmp61_ = 0.0;
	gdouble _tmp62_ = 0.0;
	NibblesViewPoint3D _tmp63_ = {0};
	gdouble _tmp64_ = 0.0;
	gdouble _tmp65_ = 0.0;
	gdouble _tmp66_;
	gdouble _tmp67_;
	gdouble _tmp68_;
	gdouble _tmp69_;
	gdouble _tmp70_;
	gdouble _tmp71_;
	NibblesViewPoint3D _tmp72_ = {0};
	gdouble _tmp73_ = 0.0;
	gdouble _tmp74_ = 0.0;
	gdouble _tmp75_;
	gdouble _tmp76_;
	NibblesViewPoint3D _tmp77_ = {0};
	gdouble _tmp78_ = 0.0;
	gdouble _tmp79_ = 0.0;
	gdouble _tmp80_;
	gdouble _tmp81_;
	NibblesViewPoint3D _tmp82_ = {0};
	gdouble _tmp83_ = 0.0;
	gdouble _tmp84_ = 0.0;
	NibblesViewPoint3D _tmp85_ = {0};
	gdouble _tmp86_ = 0.0;
	gdouble _tmp87_ = 0.0;
	NibblesViewPoint3D _tmp88_ = {0};
	gdouble _tmp89_ = 0.0;
	gdouble _tmp90_ = 0.0;
	gdouble _tmp91_;
	gdouble _tmp92_;
	gdouble _tmp93_;
	gdouble _tmp94_;
	gdouble _tmp95_;
	gdouble _tmp96_;
	NibblesViewPoint3D _tmp97_ = {0};
	gdouble _tmp98_ = 0.0;
	gdouble _tmp99_ = 0.0;
	NibblesViewPoint3D _tmp100_ = {0};
	gdouble _tmp101_ = 0.0;
	gdouble _tmp102_ = 0.0;
	NibblesViewPoint3D _tmp103_ = {0};
	gdouble _tmp104_ = 0.0;
	gdouble _tmp105_ = 0.0;
	gdouble _tmp106_;
	gdouble _tmp107_;
	gdouble _tmp108_;
	gdouble _tmp109_;
	gdouble _tmp110_;
	gdouble _tmp111_;
	NibblesViewPoint3D _tmp112_ = {0};
	gdouble _tmp113_ = 0.0;
	gdouble _tmp114_ = 0.0;
	gdouble _tmp115_;
	gdouble _tmp116_;
	NibblesViewPoint3D _tmp117_ = {0};
	gdouble _tmp118_ = 0.0;
	gdouble _tmp119_ = 0.0;
	gdouble _tmp120_;
	gdouble _tmp121_;
	NibblesViewPoint3D _tmp122_ = {0};
	gdouble _tmp123_ = 0.0;
	gdouble _tmp124_ = 0.0;
	gdouble _tmp125_;
	gdouble _tmp126_;
	NibblesViewPoint3D _tmp127_ = {0};
	gdouble _tmp128_ = 0.0;
	gdouble _tmp129_ = 0.0;
	gdouble _tmp130_;
	gdouble _tmp131_;
	NibblesViewPoint3D _tmp132_ = {0};
	gdouble _tmp133_ = 0.0;
	gdouble _tmp134_ = 0.0;
	NibblesViewPoint3D _tmp135_ = {0};
	gdouble _tmp136_ = 0.0;
	gdouble _tmp137_ = 0.0;
	NibblesViewPoint3D _tmp138_ = {0};
	gdouble _tmp139_ = 0.0;
	gdouble _tmp140_ = 0.0;
	gdouble _tmp141_;
	gdouble _tmp142_;
	gdouble _tmp143_;
	gdouble _tmp144_;
	gdouble _tmp145_;
	gdouble _tmp146_;
	NibblesViewPoint3D _tmp147_ = {0};
	gdouble _tmp148_ = 0.0;
	gdouble _tmp149_ = 0.0;
	NibblesViewPoint3D _tmp150_ = {0};
	gdouble _tmp151_ = 0.0;
	gdouble _tmp152_ = 0.0;
	NibblesViewPoint3D _tmp153_ = {0};
	gdouble _tmp154_ = 0.0;
	gdouble _tmp155_ = 0.0;
	gdouble _tmp156_;
	gdouble _tmp157_;
	gdouble _tmp158_;
	gdouble _tmp159_;
	gdouble _tmp160_;
	gdouble _tmp161_;
	NibblesViewPoint3D _tmp162_ = {0};
	gdouble _tmp163_ = 0.0;
	gdouble _tmp164_ = 0.0;
	gdouble _tmp165_;
	gdouble _tmp166_;
	NibblesViewPoint3D _tmp167_ = {0};
	gdouble _tmp168_ = 0.0;
	gdouble _tmp169_ = 0.0;
	gdouble _tmp170_;
	gdouble _tmp171_;
	NibblesViewPoint3D _tmp172_ = {0};
	gdouble _tmp173_ = 0.0;
	gdouble _tmp174_ = 0.0;
	gdouble _tmp175_;
	gdouble _tmp176_;
	NibblesViewPoint3D _tmp177_ = {0};
	gdouble _tmp178_ = 0.0;
	gdouble _tmp179_ = 0.0;
	gdouble _tmp180_;
	gdouble _tmp181_;
#line 888 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 888 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 888 "../src/nibbles-view.vala"
	g_return_if_fail (v != NULL);
#line 892 "../src/nibbles-view.vala"
	_tmp0_.x = x + 0;
#line 892 "../src/nibbles-view.vala"
	_tmp0_.y = (y + 1) + 0.25;
#line 892 "../src/nibbles-view.vala"
	_tmp0_.z = (gdouble) 1;
#line 892 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp0_, &_tmp1_, &_tmp2_);
#line 892 "../src/nibbles-view.vala"
	cx[0] = _tmp1_;
#line 892 "../src/nibbles-view.vala"
	cy[0] = _tmp2_;
#line 893 "../src/nibbles-view.vala"
	_tmp3_.x = x + 0;
#line 893 "../src/nibbles-view.vala"
	_tmp3_.y = (y + 1) + 0.25;
#line 893 "../src/nibbles-view.vala"
	_tmp3_.z = (gdouble) 0;
#line 893 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 893 "../src/nibbles-view.vala"
	cx[1] = _tmp4_;
#line 893 "../src/nibbles-view.vala"
	cy[1] = _tmp5_;
#line 894 "../src/nibbles-view.vala"
	_tmp6_.x = x + 1;
#line 894 "../src/nibbles-view.vala"
	_tmp6_.y = (y + 1) + 0.25;
#line 894 "../src/nibbles-view.vala"
	_tmp6_.z = (gdouble) 0;
#line 894 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp6_, &_tmp7_, &_tmp8_);
#line 894 "../src/nibbles-view.vala"
	cx[2] = _tmp7_;
#line 894 "../src/nibbles-view.vala"
	cy[2] = _tmp8_;
#line 895 "../src/nibbles-view.vala"
	_tmp9_ = cx[0];
#line 895 "../src/nibbles-view.vala"
	_tmp10_ = cy[0];
#line 895 "../src/nibbles-view.vala"
	cairo_move_to (c, _tmp9_, _tmp10_);
#line 896 "../src/nibbles-view.vala"
	_tmp11_ = cx[0];
#line 896 "../src/nibbles-view.vala"
	_tmp12_ = cy[0];
#line 896 "../src/nibbles-view.vala"
	_tmp13_ = cx[1];
#line 896 "../src/nibbles-view.vala"
	_tmp14_ = cy[1];
#line 896 "../src/nibbles-view.vala"
	_tmp15_ = cx[2];
#line 896 "../src/nibbles-view.vala"
	_tmp16_ = cy[2];
#line 896 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp11_, _tmp12_, _tmp13_, _tmp14_, _tmp15_, _tmp16_);
#line 897 "../src/nibbles-view.vala"
	_tmp17_.x = x + 1;
#line 897 "../src/nibbles-view.vala"
	_tmp17_.y = (y + 1) + 0.25;
#line 897 "../src/nibbles-view.vala"
	_tmp17_.z = (gdouble) 0;
#line 897 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp17_, &_tmp18_, &_tmp19_);
#line 897 "../src/nibbles-view.vala"
	cx[0] = _tmp18_;
#line 897 "../src/nibbles-view.vala"
	cy[0] = _tmp19_;
#line 898 "../src/nibbles-view.vala"
	_tmp20_.x = x + 2;
#line 898 "../src/nibbles-view.vala"
	_tmp20_.y = (y + 1) + 0.25;
#line 898 "../src/nibbles-view.vala"
	_tmp20_.z = (gdouble) 0;
#line 898 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp20_, &_tmp21_, &_tmp22_);
#line 898 "../src/nibbles-view.vala"
	cx[1] = _tmp21_;
#line 898 "../src/nibbles-view.vala"
	cy[1] = _tmp22_;
#line 899 "../src/nibbles-view.vala"
	_tmp23_.x = x + 2;
#line 899 "../src/nibbles-view.vala"
	_tmp23_.y = (y + 1) + 0.25;
#line 899 "../src/nibbles-view.vala"
	_tmp23_.z = (gdouble) 1;
#line 899 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp23_, &_tmp24_, &_tmp25_);
#line 899 "../src/nibbles-view.vala"
	cx[2] = _tmp24_;
#line 899 "../src/nibbles-view.vala"
	cy[2] = _tmp25_;
#line 900 "../src/nibbles-view.vala"
	_tmp26_ = cx[0];
#line 900 "../src/nibbles-view.vala"
	_tmp27_ = cy[0];
#line 900 "../src/nibbles-view.vala"
	_tmp28_ = cx[1];
#line 900 "../src/nibbles-view.vala"
	_tmp29_ = cy[1];
#line 900 "../src/nibbles-view.vala"
	_tmp30_ = cx[2];
#line 900 "../src/nibbles-view.vala"
	_tmp31_ = cy[2];
#line 900 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp26_, _tmp27_, _tmp28_, _tmp29_, _tmp30_, _tmp31_);
#line 901 "../src/nibbles-view.vala"
	_tmp32_.x = (x + 2) - 0.1;
#line 901 "../src/nibbles-view.vala"
	_tmp32_.y = (y + 1) + 0.25;
#line 901 "../src/nibbles-view.vala"
	_tmp32_.z = 1 + 0.5;
#line 901 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp32_, &_tmp33_, &_tmp34_);
#line 901 "../src/nibbles-view.vala"
	cx[0] = _tmp33_;
#line 901 "../src/nibbles-view.vala"
	cy[0] = _tmp34_;
#line 902 "../src/nibbles-view.vala"
	_tmp35_ = cx[0];
#line 902 "../src/nibbles-view.vala"
	_tmp36_ = cy[0];
#line 902 "../src/nibbles-view.vala"
	cairo_line_to (c, _tmp35_, _tmp36_);
#line 903 "../src/nibbles-view.vala"
	_tmp37_.x = (x + 2) - 0.2;
#line 903 "../src/nibbles-view.vala"
	_tmp37_.y = (y + 1) + 0.25;
#line 903 "../src/nibbles-view.vala"
	_tmp37_.z = 1 + 0.5;
#line 903 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp37_, &_tmp38_, &_tmp39_);
#line 903 "../src/nibbles-view.vala"
	cx[0] = _tmp38_;
#line 903 "../src/nibbles-view.vala"
	cy[0] = _tmp39_;
#line 904 "../src/nibbles-view.vala"
	_tmp40_ = cx[0];
#line 904 "../src/nibbles-view.vala"
	_tmp41_ = cy[0];
#line 904 "../src/nibbles-view.vala"
	cairo_line_to (c, _tmp40_, _tmp41_);
#line 906 "../src/nibbles-view.vala"
	_tmp42_.x = (x + 2) - 0.2;
#line 906 "../src/nibbles-view.vala"
	_tmp42_.y = (y + 1) + 0.25;
#line 906 "../src/nibbles-view.vala"
	_tmp42_.z = 1 + 0.5;
#line 906 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp42_, &_tmp43_, &_tmp44_);
#line 906 "../src/nibbles-view.vala"
	cx[0] = _tmp43_;
#line 906 "../src/nibbles-view.vala"
	cy[0] = _tmp44_;
#line 907 "../src/nibbles-view.vala"
	_tmp45_.x = (x + 2) - 0.2;
#line 907 "../src/nibbles-view.vala"
	_tmp45_.y = (y + 1) + 0.25;
#line 907 "../src/nibbles-view.vala"
	_tmp45_.z = 0.5;
#line 907 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp45_, &_tmp46_, &_tmp47_);
#line 907 "../src/nibbles-view.vala"
	cx[1] = _tmp46_;
#line 907 "../src/nibbles-view.vala"
	cy[1] = _tmp47_;
#line 908 "../src/nibbles-view.vala"
	_tmp48_.x = x + 1;
#line 908 "../src/nibbles-view.vala"
	_tmp48_.y = (y + 1) + 0.25;
#line 908 "../src/nibbles-view.vala"
	_tmp48_.z = 0.5;
#line 908 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp48_, &_tmp49_, &_tmp50_);
#line 908 "../src/nibbles-view.vala"
	cx[2] = _tmp49_;
#line 908 "../src/nibbles-view.vala"
	cy[2] = _tmp50_;
#line 909 "../src/nibbles-view.vala"
	_tmp51_ = cx[0];
#line 909 "../src/nibbles-view.vala"
	_tmp52_ = cy[0];
#line 909 "../src/nibbles-view.vala"
	_tmp53_ = cx[1];
#line 909 "../src/nibbles-view.vala"
	_tmp54_ = cy[1];
#line 909 "../src/nibbles-view.vala"
	_tmp55_ = cx[2];
#line 909 "../src/nibbles-view.vala"
	_tmp56_ = cy[2];
#line 909 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp51_, _tmp52_, _tmp53_, _tmp54_, _tmp55_, _tmp56_);
#line 911 "../src/nibbles-view.vala"
	_tmp57_.x = x + 1;
#line 911 "../src/nibbles-view.vala"
	_tmp57_.y = (y + 1) + 0.25;
#line 911 "../src/nibbles-view.vala"
	_tmp57_.z = 0.5;
#line 911 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp57_, &_tmp58_, &_tmp59_);
#line 911 "../src/nibbles-view.vala"
	cx[0] = _tmp58_;
#line 911 "../src/nibbles-view.vala"
	cy[0] = _tmp59_;
#line 912 "../src/nibbles-view.vala"
	_tmp60_.x = x + 0.2;
#line 912 "../src/nibbles-view.vala"
	_tmp60_.y = (y + 1) + 0.25;
#line 912 "../src/nibbles-view.vala"
	_tmp60_.z = 0.5;
#line 912 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp60_, &_tmp61_, &_tmp62_);
#line 912 "../src/nibbles-view.vala"
	cx[1] = _tmp61_;
#line 912 "../src/nibbles-view.vala"
	cy[1] = _tmp62_;
#line 913 "../src/nibbles-view.vala"
	_tmp63_.x = x + 0.1;
#line 913 "../src/nibbles-view.vala"
	_tmp63_.y = (y + 1) + 0.25;
#line 913 "../src/nibbles-view.vala"
	_tmp63_.z = 1 + 0.1;
#line 913 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp63_, &_tmp64_, &_tmp65_);
#line 913 "../src/nibbles-view.vala"
	cx[2] = _tmp64_;
#line 913 "../src/nibbles-view.vala"
	cy[2] = _tmp65_;
#line 914 "../src/nibbles-view.vala"
	_tmp66_ = cx[0];
#line 914 "../src/nibbles-view.vala"
	_tmp67_ = cy[0];
#line 914 "../src/nibbles-view.vala"
	_tmp68_ = cx[1];
#line 914 "../src/nibbles-view.vala"
	_tmp69_ = cy[1];
#line 914 "../src/nibbles-view.vala"
	_tmp70_ = cx[2];
#line 914 "../src/nibbles-view.vala"
	_tmp71_ = cy[2];
#line 914 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp66_, _tmp67_, _tmp68_, _tmp69_, _tmp70_, _tmp71_);
#line 915 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.6, 0.6, (gdouble) 0);
#line 916 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 918 "../src/nibbles-view.vala"
	_tmp72_.x = x + 0.1;
#line 918 "../src/nibbles-view.vala"
	_tmp72_.y = (y + 1) + 0.25;
#line 918 "../src/nibbles-view.vala"
	_tmp72_.z = 1 + 0.1;
#line 918 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp72_, &_tmp73_, &_tmp74_);
#line 918 "../src/nibbles-view.vala"
	cx[0] = _tmp73_;
#line 918 "../src/nibbles-view.vala"
	cy[0] = _tmp74_;
#line 919 "../src/nibbles-view.vala"
	_tmp75_ = cx[0];
#line 919 "../src/nibbles-view.vala"
	_tmp76_ = cy[0];
#line 919 "../src/nibbles-view.vala"
	cairo_move_to (c, _tmp75_, _tmp76_);
#line 920 "../src/nibbles-view.vala"
	_tmp77_.x = x + 0.1;
#line 920 "../src/nibbles-view.vala"
	_tmp77_.y = (y + 1) + 0.15;
#line 920 "../src/nibbles-view.vala"
	_tmp77_.z = 1 + 0.1;
#line 920 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp77_, &_tmp78_, &_tmp79_);
#line 920 "../src/nibbles-view.vala"
	cx[0] = _tmp78_;
#line 920 "../src/nibbles-view.vala"
	cy[0] = _tmp79_;
#line 921 "../src/nibbles-view.vala"
	_tmp80_ = cx[0];
#line 921 "../src/nibbles-view.vala"
	_tmp81_ = cy[0];
#line 921 "../src/nibbles-view.vala"
	cairo_line_to (c, _tmp80_, _tmp81_);
#line 923 "../src/nibbles-view.vala"
	_tmp82_.x = x + 0.1;
#line 923 "../src/nibbles-view.vala"
	_tmp82_.y = (y + 1) + 0.15;
#line 923 "../src/nibbles-view.vala"
	_tmp82_.z = 1 + 0.1;
#line 923 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp82_, &_tmp83_, &_tmp84_);
#line 923 "../src/nibbles-view.vala"
	cx[0] = _tmp83_;
#line 923 "../src/nibbles-view.vala"
	cy[0] = _tmp84_;
#line 924 "../src/nibbles-view.vala"
	_tmp85_.x = x + 0.2;
#line 924 "../src/nibbles-view.vala"
	_tmp85_.y = (y + 1) + 0.15;
#line 924 "../src/nibbles-view.vala"
	_tmp85_.z = 0.5;
#line 924 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp85_, &_tmp86_, &_tmp87_);
#line 924 "../src/nibbles-view.vala"
	cx[1] = _tmp86_;
#line 924 "../src/nibbles-view.vala"
	cy[1] = _tmp87_;
#line 925 "../src/nibbles-view.vala"
	_tmp88_.x = x + 1;
#line 925 "../src/nibbles-view.vala"
	_tmp88_.y = (y + 1) + 0.15;
#line 925 "../src/nibbles-view.vala"
	_tmp88_.z = 0.5;
#line 925 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp88_, &_tmp89_, &_tmp90_);
#line 925 "../src/nibbles-view.vala"
	cx[2] = _tmp89_;
#line 925 "../src/nibbles-view.vala"
	cy[2] = _tmp90_;
#line 926 "../src/nibbles-view.vala"
	_tmp91_ = cx[0];
#line 926 "../src/nibbles-view.vala"
	_tmp92_ = cy[0];
#line 926 "../src/nibbles-view.vala"
	_tmp93_ = cx[1];
#line 926 "../src/nibbles-view.vala"
	_tmp94_ = cy[1];
#line 926 "../src/nibbles-view.vala"
	_tmp95_ = cx[2];
#line 926 "../src/nibbles-view.vala"
	_tmp96_ = cy[2];
#line 926 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp91_, _tmp92_, _tmp93_, _tmp94_, _tmp95_, _tmp96_);
#line 928 "../src/nibbles-view.vala"
	_tmp97_.x = x + 1;
#line 928 "../src/nibbles-view.vala"
	_tmp97_.y = (y + 1) + 0.15;
#line 928 "../src/nibbles-view.vala"
	_tmp97_.z = 0.5;
#line 928 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp97_, &_tmp98_, &_tmp99_);
#line 928 "../src/nibbles-view.vala"
	cx[0] = _tmp98_;
#line 928 "../src/nibbles-view.vala"
	cy[0] = _tmp99_;
#line 929 "../src/nibbles-view.vala"
	_tmp100_.x = (x + 2) - 0.2;
#line 929 "../src/nibbles-view.vala"
	_tmp100_.y = (y + 1) + 0.15;
#line 929 "../src/nibbles-view.vala"
	_tmp100_.z = 0.5;
#line 929 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp100_, &_tmp101_, &_tmp102_);
#line 929 "../src/nibbles-view.vala"
	cx[1] = _tmp101_;
#line 929 "../src/nibbles-view.vala"
	cy[1] = _tmp102_;
#line 930 "../src/nibbles-view.vala"
	_tmp103_.x = (x + 2) - 0.2;
#line 930 "../src/nibbles-view.vala"
	_tmp103_.y = (y + 1) + 0.15;
#line 930 "../src/nibbles-view.vala"
	_tmp103_.z = 1 + 0.5;
#line 930 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp103_, &_tmp104_, &_tmp105_);
#line 930 "../src/nibbles-view.vala"
	cx[2] = _tmp104_;
#line 930 "../src/nibbles-view.vala"
	cy[2] = _tmp105_;
#line 931 "../src/nibbles-view.vala"
	_tmp106_ = cx[0];
#line 931 "../src/nibbles-view.vala"
	_tmp107_ = cy[0];
#line 931 "../src/nibbles-view.vala"
	_tmp108_ = cx[1];
#line 931 "../src/nibbles-view.vala"
	_tmp109_ = cy[1];
#line 931 "../src/nibbles-view.vala"
	_tmp110_ = cx[2];
#line 931 "../src/nibbles-view.vala"
	_tmp111_ = cy[2];
#line 931 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp106_, _tmp107_, _tmp108_, _tmp109_, _tmp110_, _tmp111_);
#line 933 "../src/nibbles-view.vala"
	_tmp112_.x = (x + 2) - 0.2;
#line 933 "../src/nibbles-view.vala"
	_tmp112_.y = (y + 1) + 0.15;
#line 933 "../src/nibbles-view.vala"
	_tmp112_.z = 1 + 0.5;
#line 933 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp112_, &_tmp113_, &_tmp114_);
#line 933 "../src/nibbles-view.vala"
	cx[0] = _tmp113_;
#line 933 "../src/nibbles-view.vala"
	cy[0] = _tmp114_;
#line 934 "../src/nibbles-view.vala"
	_tmp115_ = cx[0];
#line 934 "../src/nibbles-view.vala"
	_tmp116_ = cy[0];
#line 934 "../src/nibbles-view.vala"
	cairo_line_to (c, _tmp115_, _tmp116_);
#line 935 "../src/nibbles-view.vala"
	_tmp117_.x = (x + 2) - 0.1;
#line 935 "../src/nibbles-view.vala"
	_tmp117_.y = (y + 1) + 0.15;
#line 935 "../src/nibbles-view.vala"
	_tmp117_.z = 1 + 0.5;
#line 935 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp117_, &_tmp118_, &_tmp119_);
#line 935 "../src/nibbles-view.vala"
	cx[0] = _tmp118_;
#line 935 "../src/nibbles-view.vala"
	cy[0] = _tmp119_;
#line 936 "../src/nibbles-view.vala"
	_tmp120_ = cx[0];
#line 936 "../src/nibbles-view.vala"
	_tmp121_ = cy[0];
#line 936 "../src/nibbles-view.vala"
	cairo_line_to (c, _tmp120_, _tmp121_);
#line 937 "../src/nibbles-view.vala"
	_tmp122_.x = (x + 2) - 0.1;
#line 937 "../src/nibbles-view.vala"
	_tmp122_.y = (y + 1) + 0.25;
#line 937 "../src/nibbles-view.vala"
	_tmp122_.z = 1 + 0.5;
#line 937 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp122_, &_tmp123_, &_tmp124_);
#line 937 "../src/nibbles-view.vala"
	cx[0] = _tmp123_;
#line 937 "../src/nibbles-view.vala"
	cy[0] = _tmp124_;
#line 938 "../src/nibbles-view.vala"
	_tmp125_ = cx[0];
#line 938 "../src/nibbles-view.vala"
	_tmp126_ = cy[0];
#line 938 "../src/nibbles-view.vala"
	cairo_line_to (c, _tmp125_, _tmp126_);
#line 939 "../src/nibbles-view.vala"
	_tmp127_.x = (x + 2) - 0.2;
#line 939 "../src/nibbles-view.vala"
	_tmp127_.y = (y + 1) + 0.25;
#line 939 "../src/nibbles-view.vala"
	_tmp127_.z = 1 + 0.5;
#line 939 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp127_, &_tmp128_, &_tmp129_);
#line 939 "../src/nibbles-view.vala"
	cx[0] = _tmp128_;
#line 939 "../src/nibbles-view.vala"
	cy[0] = _tmp129_;
#line 940 "../src/nibbles-view.vala"
	_tmp130_ = cx[0];
#line 940 "../src/nibbles-view.vala"
	_tmp131_ = cy[0];
#line 940 "../src/nibbles-view.vala"
	cairo_line_to (c, _tmp130_, _tmp131_);
#line 942 "../src/nibbles-view.vala"
	_tmp132_.x = (x + 2) - 0.2;
#line 942 "../src/nibbles-view.vala"
	_tmp132_.y = (y + 1) + 0.25;
#line 942 "../src/nibbles-view.vala"
	_tmp132_.z = 1 + 0.5;
#line 942 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp132_, &_tmp133_, &_tmp134_);
#line 942 "../src/nibbles-view.vala"
	cx[0] = _tmp133_;
#line 942 "../src/nibbles-view.vala"
	cy[0] = _tmp134_;
#line 943 "../src/nibbles-view.vala"
	_tmp135_.x = (x + 2) - 0.2;
#line 943 "../src/nibbles-view.vala"
	_tmp135_.y = (y + 1) + 0.25;
#line 943 "../src/nibbles-view.vala"
	_tmp135_.z = 0.5;
#line 943 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp135_, &_tmp136_, &_tmp137_);
#line 943 "../src/nibbles-view.vala"
	cx[1] = _tmp136_;
#line 943 "../src/nibbles-view.vala"
	cy[1] = _tmp137_;
#line 944 "../src/nibbles-view.vala"
	_tmp138_.x = x + 1;
#line 944 "../src/nibbles-view.vala"
	_tmp138_.y = (y + 1) + 0.25;
#line 944 "../src/nibbles-view.vala"
	_tmp138_.z = 0.5;
#line 944 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp138_, &_tmp139_, &_tmp140_);
#line 944 "../src/nibbles-view.vala"
	cx[2] = _tmp139_;
#line 944 "../src/nibbles-view.vala"
	cy[2] = _tmp140_;
#line 945 "../src/nibbles-view.vala"
	_tmp141_ = cx[0];
#line 945 "../src/nibbles-view.vala"
	_tmp142_ = cy[0];
#line 945 "../src/nibbles-view.vala"
	_tmp143_ = cx[1];
#line 945 "../src/nibbles-view.vala"
	_tmp144_ = cy[1];
#line 945 "../src/nibbles-view.vala"
	_tmp145_ = cx[2];
#line 945 "../src/nibbles-view.vala"
	_tmp146_ = cy[2];
#line 945 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp141_, _tmp142_, _tmp143_, _tmp144_, _tmp145_, _tmp146_);
#line 947 "../src/nibbles-view.vala"
	_tmp147_.x = x + 1;
#line 947 "../src/nibbles-view.vala"
	_tmp147_.y = (y + 1) + 0.25;
#line 947 "../src/nibbles-view.vala"
	_tmp147_.z = 0.5;
#line 947 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp147_, &_tmp148_, &_tmp149_);
#line 947 "../src/nibbles-view.vala"
	cx[0] = _tmp148_;
#line 947 "../src/nibbles-view.vala"
	cy[0] = _tmp149_;
#line 948 "../src/nibbles-view.vala"
	_tmp150_.x = x + 0.2;
#line 948 "../src/nibbles-view.vala"
	_tmp150_.y = (y + 1) + 0.25;
#line 948 "../src/nibbles-view.vala"
	_tmp150_.z = 0.5;
#line 948 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp150_, &_tmp151_, &_tmp152_);
#line 948 "../src/nibbles-view.vala"
	cx[1] = _tmp151_;
#line 948 "../src/nibbles-view.vala"
	cy[1] = _tmp152_;
#line 949 "../src/nibbles-view.vala"
	_tmp153_.x = x + 0.1;
#line 949 "../src/nibbles-view.vala"
	_tmp153_.y = (y + 1) + 0.25;
#line 949 "../src/nibbles-view.vala"
	_tmp153_.z = 1 + 0.1;
#line 949 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp153_, &_tmp154_, &_tmp155_);
#line 949 "../src/nibbles-view.vala"
	cx[2] = _tmp154_;
#line 949 "../src/nibbles-view.vala"
	cy[2] = _tmp155_;
#line 950 "../src/nibbles-view.vala"
	_tmp156_ = cx[0];
#line 950 "../src/nibbles-view.vala"
	_tmp157_ = cy[0];
#line 950 "../src/nibbles-view.vala"
	_tmp158_ = cx[1];
#line 950 "../src/nibbles-view.vala"
	_tmp159_ = cy[1];
#line 950 "../src/nibbles-view.vala"
	_tmp160_ = cx[2];
#line 950 "../src/nibbles-view.vala"
	_tmp161_ = cy[2];
#line 950 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp156_, _tmp157_, _tmp158_, _tmp159_, _tmp160_, _tmp161_);
#line 952 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.8, 0.8, (gdouble) 0);
#line 953 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 955 "../src/nibbles-view.vala"
	_tmp162_.x = x + 0;
#line 955 "../src/nibbles-view.vala"
	_tmp162_.y = (y + 1) + 0.25;
#line 955 "../src/nibbles-view.vala"
	_tmp162_.z = (gdouble) 1;
#line 955 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp162_, &_tmp163_, &_tmp164_);
#line 955 "../src/nibbles-view.vala"
	cx[0] = _tmp163_;
#line 955 "../src/nibbles-view.vala"
	cy[0] = _tmp164_;
#line 956 "../src/nibbles-view.vala"
	_tmp165_ = cx[0];
#line 956 "../src/nibbles-view.vala"
	_tmp166_ = cy[0];
#line 956 "../src/nibbles-view.vala"
	cairo_move_to (c, _tmp165_, _tmp166_);
#line 957 "../src/nibbles-view.vala"
	_tmp167_.x = x + 0.1;
#line 957 "../src/nibbles-view.vala"
	_tmp167_.y = (y + 1) + 0.25;
#line 957 "../src/nibbles-view.vala"
	_tmp167_.z = 1 + 0.1;
#line 957 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp167_, &_tmp168_, &_tmp169_);
#line 957 "../src/nibbles-view.vala"
	cx[0] = _tmp168_;
#line 957 "../src/nibbles-view.vala"
	cy[0] = _tmp169_;
#line 958 "../src/nibbles-view.vala"
	_tmp170_ = cx[0];
#line 958 "../src/nibbles-view.vala"
	_tmp171_ = cy[0];
#line 958 "../src/nibbles-view.vala"
	cairo_line_to (c, _tmp170_, _tmp171_);
#line 959 "../src/nibbles-view.vala"
	_tmp172_.x = x + 0.1;
#line 959 "../src/nibbles-view.vala"
	_tmp172_.y = (y + 1) + 0.15;
#line 959 "../src/nibbles-view.vala"
	_tmp172_.z = 1 + 0.1;
#line 959 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp172_, &_tmp173_, &_tmp174_);
#line 959 "../src/nibbles-view.vala"
	cx[0] = _tmp173_;
#line 959 "../src/nibbles-view.vala"
	cy[0] = _tmp174_;
#line 960 "../src/nibbles-view.vala"
	_tmp175_ = cx[0];
#line 960 "../src/nibbles-view.vala"
	_tmp176_ = cy[0];
#line 960 "../src/nibbles-view.vala"
	cairo_line_to (c, _tmp175_, _tmp176_);
#line 961 "../src/nibbles-view.vala"
	_tmp177_.x = x + 0;
#line 961 "../src/nibbles-view.vala"
	_tmp177_.y = (y + 1) + 0.15;
#line 961 "../src/nibbles-view.vala"
	_tmp177_.z = (gdouble) 1;
#line 961 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp177_, &_tmp178_, &_tmp179_);
#line 961 "../src/nibbles-view.vala"
	cx[0] = _tmp178_;
#line 961 "../src/nibbles-view.vala"
	cy[0] = _tmp179_;
#line 962 "../src/nibbles-view.vala"
	_tmp180_ = cx[0];
#line 962 "../src/nibbles-view.vala"
	_tmp181_ = cy[0];
#line 962 "../src/nibbles-view.vala"
	cairo_line_to (c, _tmp180_, _tmp181_);
#line 963 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.3, 0.3, 0.4);
#line 964 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 7330 "nibbles-view.c"
}

static void
nibbles_view_draw_diamond (NibblesView* self,
                           cairo_t* c,
                           NibblesViewView3D* v,
                           gdouble x,
                           gdouble y)
{
#line 969 "../src/nibbles-view.vala"
	static const gdouble cos60 = 0.5;
#line 970 "../src/nibbles-view.vala"
	static const gdouble sin60 = 0.866025403784;
#line 7344 "nibbles-view.c"
	NibblesViewPoint3D top[6] = {0};
	NibblesViewPoint3D _tmp0_ = {0};
	NibblesViewPoint3D _tmp1_ = {0};
	NibblesViewPoint3D _tmp2_ = {0};
	NibblesViewPoint3D _tmp3_ = {0};
	NibblesViewPoint3D _tmp4_ = {0};
	NibblesViewPoint3D _tmp5_ = {0};
	NibblesViewPoint3D _tmp6_[6] = {0};
	NibblesViewPoint3D middle[6] = {0};
	NibblesViewPoint3D _tmp7_ = {0};
	NibblesViewPoint3D _tmp8_ = {0};
	NibblesViewPoint3D _tmp9_ = {0};
	NibblesViewPoint3D _tmp10_ = {0};
	NibblesViewPoint3D _tmp11_ = {0};
	NibblesViewPoint3D _tmp12_ = {0};
	NibblesViewPoint3D _tmp13_[6] = {0};
	gdouble X = 0.0;
	gdouble Y = 0.0;
	NibblesViewPoint3D _tmp14_;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	NibblesViewPoint3D _tmp17_;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	NibblesViewPoint3D _tmp20_;
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
	NibblesViewPoint3D _tmp23_;
	gdouble _tmp24_ = 0.0;
	gdouble _tmp25_ = 0.0;
	NibblesViewPoint3D _tmp26_;
	gdouble _tmp27_ = 0.0;
	gdouble _tmp28_ = 0.0;
	NibblesViewPoint3D _tmp29_;
	gdouble _tmp30_ = 0.0;
	gdouble _tmp31_ = 0.0;
	NibblesViewPoint3D _tmp32_;
	gdouble _tmp33_ = 0.0;
	gdouble _tmp34_ = 0.0;
	NibblesViewPoint3D _tmp35_;
	gdouble _tmp36_ = 0.0;
	gdouble _tmp37_ = 0.0;
	NibblesViewPoint3D _tmp38_;
	gdouble _tmp39_ = 0.0;
	gdouble _tmp40_ = 0.0;
	NibblesViewPoint3D _tmp41_;
	gdouble _tmp42_ = 0.0;
	gdouble _tmp43_ = 0.0;
	NibblesViewPoint3D _tmp44_;
	gdouble _tmp45_ = 0.0;
	gdouble _tmp46_ = 0.0;
	NibblesViewPoint3D _tmp47_;
	gdouble _tmp48_ = 0.0;
	gdouble _tmp49_ = 0.0;
	NibblesViewPoint3D _tmp50_;
	gdouble _tmp51_ = 0.0;
	gdouble _tmp52_ = 0.0;
	NibblesViewPoint3D _tmp53_;
	gdouble _tmp54_ = 0.0;
	gdouble _tmp55_ = 0.0;
	NibblesViewPoint3D _tmp56_;
	gdouble _tmp57_ = 0.0;
	gdouble _tmp58_ = 0.0;
	NibblesViewPoint3D _tmp59_;
	gdouble _tmp60_ = 0.0;
	gdouble _tmp61_ = 0.0;
	NibblesViewPoint3D _tmp62_;
	gdouble _tmp63_ = 0.0;
	gdouble _tmp64_ = 0.0;
	NibblesViewPoint3D _tmp65_;
	gdouble _tmp66_ = 0.0;
	gdouble _tmp67_ = 0.0;
	NibblesViewPoint3D _tmp68_;
	gdouble _tmp69_ = 0.0;
	gdouble _tmp70_ = 0.0;
	NibblesViewPoint3D _tmp71_;
	gdouble _tmp72_ = 0.0;
	gdouble _tmp73_ = 0.0;
	NibblesViewPoint3D _tmp74_;
	gdouble _tmp75_ = 0.0;
	gdouble _tmp76_ = 0.0;
	NibblesViewPoint3D _tmp77_;
	gdouble _tmp78_ = 0.0;
	gdouble _tmp79_ = 0.0;
	NibblesViewPoint3D _tmp80_;
	gdouble _tmp81_ = 0.0;
	gdouble _tmp82_ = 0.0;
	NibblesViewPoint3D _tmp83_;
	gdouble _tmp84_ = 0.0;
	gdouble _tmp85_ = 0.0;
	NibblesViewPoint3D _tmp86_;
	gdouble _tmp87_ = 0.0;
	gdouble _tmp88_ = 0.0;
	NibblesViewPoint3D _tmp89_;
	gdouble _tmp90_ = 0.0;
	gdouble _tmp91_ = 0.0;
	NibblesViewPoint3D _tmp92_;
	gdouble _tmp93_ = 0.0;
	gdouble _tmp94_ = 0.0;
	NibblesViewPoint3D _tmp95_;
	gdouble _tmp96_ = 0.0;
	gdouble _tmp97_ = 0.0;
	NibblesViewPoint3D _tmp98_;
	gdouble _tmp99_ = 0.0;
	gdouble _tmp100_ = 0.0;
	NibblesViewPoint3D _tmp101_;
	gdouble _tmp102_ = 0.0;
	gdouble _tmp103_ = 0.0;
#line 967 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 967 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 967 "../src/nibbles-view.vala"
	g_return_if_fail (v != NULL);
#line 971 "../src/nibbles-view.vala"
	memset (&_tmp0_, 0, sizeof (NibblesViewPoint3D));
#line 971 "../src/nibbles-view.vala"
	_tmp0_.x = x + 0;
#line 971 "../src/nibbles-view.vala"
	_tmp0_.y = y + 1;
#line 971 "../src/nibbles-view.vala"
	_tmp0_.z = 1.5;
#line 971 "../src/nibbles-view.vala"
	memset (&_tmp1_, 0, sizeof (NibblesViewPoint3D));
#line 971 "../src/nibbles-view.vala"
	_tmp1_.x = x + cos60;
#line 971 "../src/nibbles-view.vala"
	_tmp1_.y = (y + 1.0) - sin60;
#line 971 "../src/nibbles-view.vala"
	_tmp1_.z = 1.5;
#line 971 "../src/nibbles-view.vala"
	memset (&_tmp2_, 0, sizeof (NibblesViewPoint3D));
#line 971 "../src/nibbles-view.vala"
	_tmp2_.x = (x + cos60) + 1;
#line 971 "../src/nibbles-view.vala"
	_tmp2_.y = (y + 1.0) - sin60;
#line 971 "../src/nibbles-view.vala"
	_tmp2_.z = 1.5;
#line 971 "../src/nibbles-view.vala"
	memset (&_tmp3_, 0, sizeof (NibblesViewPoint3D));
#line 971 "../src/nibbles-view.vala"
	_tmp3_.x = x + 2;
#line 971 "../src/nibbles-view.vala"
	_tmp3_.y = y + 1;
#line 971 "../src/nibbles-view.vala"
	_tmp3_.z = 1.5;
#line 971 "../src/nibbles-view.vala"
	memset (&_tmp4_, 0, sizeof (NibblesViewPoint3D));
#line 971 "../src/nibbles-view.vala"
	_tmp4_.x = (x + cos60) + 1;
#line 971 "../src/nibbles-view.vala"
	_tmp4_.y = (y + 1.0) + sin60;
#line 971 "../src/nibbles-view.vala"
	_tmp4_.z = 1.5;
#line 971 "../src/nibbles-view.vala"
	memset (&_tmp5_, 0, sizeof (NibblesViewPoint3D));
#line 971 "../src/nibbles-view.vala"
	_tmp5_.x = x + cos60;
#line 971 "../src/nibbles-view.vala"
	_tmp5_.y = (y + 1.0) + sin60;
#line 971 "../src/nibbles-view.vala"
	_tmp5_.z = 1.5;
#line 971 "../src/nibbles-view.vala"
	_tmp6_[0] = _tmp0_;
#line 971 "../src/nibbles-view.vala"
	_tmp6_[1] = _tmp1_;
#line 971 "../src/nibbles-view.vala"
	_tmp6_[2] = _tmp2_;
#line 971 "../src/nibbles-view.vala"
	_tmp6_[3] = _tmp3_;
#line 971 "../src/nibbles-view.vala"
	_tmp6_[4] = _tmp4_;
#line 971 "../src/nibbles-view.vala"
	_tmp6_[5] = _tmp5_;
#line 971 "../src/nibbles-view.vala"
	memcpy (top, _tmp6_, 6 * sizeof (NibblesViewPoint3D));
#line 973 "../src/nibbles-view.vala"
	memset (&_tmp7_, 0, sizeof (NibblesViewPoint3D));
#line 973 "../src/nibbles-view.vala"
	_tmp7_.x = x + 0.5;
#line 973 "../src/nibbles-view.vala"
	_tmp7_.y = y + 1;
#line 973 "../src/nibbles-view.vala"
	_tmp7_.z = (gdouble) 2;
#line 973 "../src/nibbles-view.vala"
	memset (&_tmp8_, 0, sizeof (NibblesViewPoint3D));
#line 973 "../src/nibbles-view.vala"
	_tmp8_.x = x + (1.0 - (0.5 * cos60));
#line 973 "../src/nibbles-view.vala"
	_tmp8_.y = (y + 1.0) - (0.5 * sin60);
#line 973 "../src/nibbles-view.vala"
	_tmp8_.z = (gdouble) 2;
#line 973 "../src/nibbles-view.vala"
	memset (&_tmp9_, 0, sizeof (NibblesViewPoint3D));
#line 973 "../src/nibbles-view.vala"
	_tmp9_.x = (x + (0.5 * cos60)) + 1;
#line 973 "../src/nibbles-view.vala"
	_tmp9_.y = (y + 1.0) - (0.5 * sin60);
#line 973 "../src/nibbles-view.vala"
	_tmp9_.z = (gdouble) 2;
#line 973 "../src/nibbles-view.vala"
	memset (&_tmp10_, 0, sizeof (NibblesViewPoint3D));
#line 973 "../src/nibbles-view.vala"
	_tmp10_.x = x + 1.5;
#line 973 "../src/nibbles-view.vala"
	_tmp10_.y = y + 1;
#line 973 "../src/nibbles-view.vala"
	_tmp10_.z = (gdouble) 2;
#line 973 "../src/nibbles-view.vala"
	memset (&_tmp11_, 0, sizeof (NibblesViewPoint3D));
#line 973 "../src/nibbles-view.vala"
	_tmp11_.x = (x + (0.5 * cos60)) + 1;
#line 973 "../src/nibbles-view.vala"
	_tmp11_.y = (y + 1.0) + (0.5 * sin60);
#line 973 "../src/nibbles-view.vala"
	_tmp11_.z = (gdouble) 2;
#line 973 "../src/nibbles-view.vala"
	memset (&_tmp12_, 0, sizeof (NibblesViewPoint3D));
#line 973 "../src/nibbles-view.vala"
	_tmp12_.x = x + (1.0 - (0.5 * cos60));
#line 973 "../src/nibbles-view.vala"
	_tmp12_.y = (y + 1.0) + (0.5 * sin60);
#line 973 "../src/nibbles-view.vala"
	_tmp12_.z = (gdouble) 2;
#line 973 "../src/nibbles-view.vala"
	_tmp13_[0] = _tmp7_;
#line 973 "../src/nibbles-view.vala"
	_tmp13_[1] = _tmp8_;
#line 973 "../src/nibbles-view.vala"
	_tmp13_[2] = _tmp9_;
#line 973 "../src/nibbles-view.vala"
	_tmp13_[3] = _tmp10_;
#line 973 "../src/nibbles-view.vala"
	_tmp13_[4] = _tmp11_;
#line 973 "../src/nibbles-view.vala"
	_tmp13_[5] = _tmp12_;
#line 973 "../src/nibbles-view.vala"
	memcpy (middle, _tmp13_, 6 * sizeof (NibblesViewPoint3D));
#line 976 "../src/nibbles-view.vala"
	_tmp14_ = top[0];
#line 976 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp14_, &_tmp15_, &_tmp16_);
#line 976 "../src/nibbles-view.vala"
	X = _tmp15_;
#line 976 "../src/nibbles-view.vala"
	Y = _tmp16_;
#line 977 "../src/nibbles-view.vala"
	cairo_move_to (c, X, Y);
#line 978 "../src/nibbles-view.vala"
	_tmp17_ = top[1];
#line 978 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp17_, &_tmp18_, &_tmp19_);
#line 978 "../src/nibbles-view.vala"
	X = _tmp18_;
#line 978 "../src/nibbles-view.vala"
	Y = _tmp19_;
#line 979 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 980 "../src/nibbles-view.vala"
	_tmp20_ = top[2];
#line 980 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp20_, &_tmp21_, &_tmp22_);
#line 980 "../src/nibbles-view.vala"
	X = _tmp21_;
#line 980 "../src/nibbles-view.vala"
	Y = _tmp22_;
#line 981 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 982 "../src/nibbles-view.vala"
	_tmp23_ = top[3];
#line 982 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp23_, &_tmp24_, &_tmp25_);
#line 982 "../src/nibbles-view.vala"
	X = _tmp24_;
#line 982 "../src/nibbles-view.vala"
	Y = _tmp25_;
#line 983 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 984 "../src/nibbles-view.vala"
	_tmp26_ = top[4];
#line 984 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp26_, &_tmp27_, &_tmp28_);
#line 984 "../src/nibbles-view.vala"
	X = _tmp27_;
#line 984 "../src/nibbles-view.vala"
	Y = _tmp28_;
#line 985 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 986 "../src/nibbles-view.vala"
	_tmp29_ = top[5];
#line 986 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp29_, &_tmp30_, &_tmp31_);
#line 986 "../src/nibbles-view.vala"
	X = _tmp30_;
#line 986 "../src/nibbles-view.vala"
	Y = _tmp31_;
#line 987 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 988 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.8, 0.9, (gdouble) 1);
#line 989 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 991 "../src/nibbles-view.vala"
	_tmp32_ = middle[1];
#line 991 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp32_, &_tmp33_, &_tmp34_);
#line 991 "../src/nibbles-view.vala"
	X = _tmp33_;
#line 991 "../src/nibbles-view.vala"
	Y = _tmp34_;
#line 992 "../src/nibbles-view.vala"
	cairo_move_to (c, X, Y);
#line 993 "../src/nibbles-view.vala"
	_tmp35_ = middle[2];
#line 993 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp35_, &_tmp36_, &_tmp37_);
#line 993 "../src/nibbles-view.vala"
	X = _tmp36_;
#line 993 "../src/nibbles-view.vala"
	Y = _tmp37_;
#line 994 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 995 "../src/nibbles-view.vala"
	_tmp38_ = top[2];
#line 995 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp38_, &_tmp39_, &_tmp40_);
#line 995 "../src/nibbles-view.vala"
	X = _tmp39_;
#line 995 "../src/nibbles-view.vala"
	Y = _tmp40_;
#line 996 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 997 "../src/nibbles-view.vala"
	_tmp41_ = top[1];
#line 997 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp41_, &_tmp42_, &_tmp43_);
#line 997 "../src/nibbles-view.vala"
	X = _tmp42_;
#line 997 "../src/nibbles-view.vala"
	Y = _tmp43_;
#line 998 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 999 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.618, 0.708, 0.802);
#line 1000 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1002 "../src/nibbles-view.vala"
	_tmp44_ = middle[1];
#line 1002 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp44_, &_tmp45_, &_tmp46_);
#line 1002 "../src/nibbles-view.vala"
	X = _tmp45_;
#line 1002 "../src/nibbles-view.vala"
	Y = _tmp46_;
#line 1003 "../src/nibbles-view.vala"
	cairo_move_to (c, X, Y);
#line 1004 "../src/nibbles-view.vala"
	_tmp47_ = middle[0];
#line 1004 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp47_, &_tmp48_, &_tmp49_);
#line 1004 "../src/nibbles-view.vala"
	X = _tmp48_;
#line 1004 "../src/nibbles-view.vala"
	Y = _tmp49_;
#line 1005 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1006 "../src/nibbles-view.vala"
	_tmp50_ = top[0];
#line 1006 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp50_, &_tmp51_, &_tmp52_);
#line 1006 "../src/nibbles-view.vala"
	X = _tmp51_;
#line 1006 "../src/nibbles-view.vala"
	Y = _tmp52_;
#line 1007 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1008 "../src/nibbles-view.vala"
	_tmp53_ = top[1];
#line 1008 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp53_, &_tmp54_, &_tmp55_);
#line 1008 "../src/nibbles-view.vala"
	X = _tmp54_;
#line 1008 "../src/nibbles-view.vala"
	Y = _tmp55_;
#line 1009 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1010 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.347, 0.524, 0.712);
#line 1011 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1013 "../src/nibbles-view.vala"
	_tmp56_ = middle[2];
#line 1013 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp56_, &_tmp57_, &_tmp58_);
#line 1013 "../src/nibbles-view.vala"
	X = _tmp57_;
#line 1013 "../src/nibbles-view.vala"
	Y = _tmp58_;
#line 1014 "../src/nibbles-view.vala"
	cairo_move_to (c, X, Y);
#line 1015 "../src/nibbles-view.vala"
	_tmp59_ = middle[3];
#line 1015 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp59_, &_tmp60_, &_tmp61_);
#line 1015 "../src/nibbles-view.vala"
	X = _tmp60_;
#line 1015 "../src/nibbles-view.vala"
	Y = _tmp61_;
#line 1016 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1017 "../src/nibbles-view.vala"
	_tmp62_ = top[3];
#line 1017 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp62_, &_tmp63_, &_tmp64_);
#line 1017 "../src/nibbles-view.vala"
	X = _tmp63_;
#line 1017 "../src/nibbles-view.vala"
	Y = _tmp64_;
#line 1018 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1019 "../src/nibbles-view.vala"
	_tmp65_ = top[2];
#line 1019 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp65_, &_tmp66_, &_tmp67_);
#line 1019 "../src/nibbles-view.vala"
	X = _tmp66_;
#line 1019 "../src/nibbles-view.vala"
	Y = _tmp67_;
#line 1020 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1021 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.347, 0.524, 0.712);
#line 1022 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1024 "../src/nibbles-view.vala"
	_tmp68_ = middle[3];
#line 1024 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp68_, &_tmp69_, &_tmp70_);
#line 1024 "../src/nibbles-view.vala"
	X = _tmp69_;
#line 1024 "../src/nibbles-view.vala"
	Y = _tmp70_;
#line 1025 "../src/nibbles-view.vala"
	cairo_move_to (c, X, Y);
#line 1026 "../src/nibbles-view.vala"
	_tmp71_ = middle[4];
#line 1026 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp71_, &_tmp72_, &_tmp73_);
#line 1026 "../src/nibbles-view.vala"
	X = _tmp72_;
#line 1026 "../src/nibbles-view.vala"
	Y = _tmp73_;
#line 1027 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1028 "../src/nibbles-view.vala"
	_tmp74_ = top[4];
#line 1028 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp74_, &_tmp75_, &_tmp76_);
#line 1028 "../src/nibbles-view.vala"
	X = _tmp75_;
#line 1028 "../src/nibbles-view.vala"
	Y = _tmp76_;
#line 1029 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1030 "../src/nibbles-view.vala"
	_tmp77_ = top[3];
#line 1030 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp77_, &_tmp78_, &_tmp79_);
#line 1030 "../src/nibbles-view.vala"
	X = _tmp78_;
#line 1030 "../src/nibbles-view.vala"
	Y = _tmp79_;
#line 1031 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1032 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.447, 0.624, 0.812);
#line 1033 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1035 "../src/nibbles-view.vala"
	_tmp80_ = middle[5];
#line 1035 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp80_, &_tmp81_, &_tmp82_);
#line 1035 "../src/nibbles-view.vala"
	X = _tmp81_;
#line 1035 "../src/nibbles-view.vala"
	Y = _tmp82_;
#line 1036 "../src/nibbles-view.vala"
	cairo_move_to (c, X, Y);
#line 1037 "../src/nibbles-view.vala"
	_tmp83_ = middle[0];
#line 1037 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp83_, &_tmp84_, &_tmp85_);
#line 1037 "../src/nibbles-view.vala"
	X = _tmp84_;
#line 1037 "../src/nibbles-view.vala"
	Y = _tmp85_;
#line 1038 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1039 "../src/nibbles-view.vala"
	_tmp86_ = top[0];
#line 1039 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp86_, &_tmp87_, &_tmp88_);
#line 1039 "../src/nibbles-view.vala"
	X = _tmp87_;
#line 1039 "../src/nibbles-view.vala"
	Y = _tmp88_;
#line 1040 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1041 "../src/nibbles-view.vala"
	_tmp89_ = top[5];
#line 1041 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp89_, &_tmp90_, &_tmp91_);
#line 1041 "../src/nibbles-view.vala"
	X = _tmp90_;
#line 1041 "../src/nibbles-view.vala"
	Y = _tmp91_;
#line 1042 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1043 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.447, 0.624, 0.812);
#line 1044 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1046 "../src/nibbles-view.vala"
	_tmp92_ = middle[4];
#line 1046 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp92_, &_tmp93_, &_tmp94_);
#line 1046 "../src/nibbles-view.vala"
	X = _tmp93_;
#line 1046 "../src/nibbles-view.vala"
	Y = _tmp94_;
#line 1047 "../src/nibbles-view.vala"
	cairo_move_to (c, X, Y);
#line 1048 "../src/nibbles-view.vala"
	_tmp95_ = middle[5];
#line 1048 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp95_, &_tmp96_, &_tmp97_);
#line 1048 "../src/nibbles-view.vala"
	X = _tmp96_;
#line 1048 "../src/nibbles-view.vala"
	Y = _tmp97_;
#line 1049 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1050 "../src/nibbles-view.vala"
	_tmp98_ = top[5];
#line 1050 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp98_, &_tmp99_, &_tmp100_);
#line 1050 "../src/nibbles-view.vala"
	X = _tmp99_;
#line 1050 "../src/nibbles-view.vala"
	Y = _tmp100_;
#line 1051 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1052 "../src/nibbles-view.vala"
	_tmp101_ = top[4];
#line 1052 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp101_, &_tmp102_, &_tmp103_);
#line 1052 "../src/nibbles-view.vala"
	X = _tmp102_;
#line 1052 "../src/nibbles-view.vala"
	Y = _tmp103_;
#line 1053 "../src/nibbles-view.vala"
	cairo_line_to (c, X, Y);
#line 1054 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.718, 0.808, 0.902);
#line 1055 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 7911 "nibbles-view.c"
}

static void
nibbles_view_draw_heart (NibblesView* self,
                         cairo_t* c,
                         NibblesViewView3D* v,
                         gdouble x,
                         gdouble y)
{
	gdouble H = 0.0;
	gdouble h = 0.0;
	gdouble cx[3] = {0};
	gdouble cy[3] = {0};
	NibblesViewPoint3D _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	NibblesViewPoint3D _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	NibblesViewPoint3D _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	NibblesViewPoint3D _tmp17_ = {0};
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	NibblesViewPoint3D _tmp20_ = {0};
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
	NibblesViewPoint3D _tmp23_ = {0};
	gdouble _tmp24_ = 0.0;
	gdouble _tmp25_ = 0.0;
	gdouble _tmp26_;
	gdouble _tmp27_;
	gdouble _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	NibblesViewPoint3D _tmp32_ = {0};
	gdouble _tmp33_ = 0.0;
	gdouble _tmp34_ = 0.0;
	NibblesViewPoint3D _tmp35_ = {0};
	gdouble _tmp36_ = 0.0;
	gdouble _tmp37_ = 0.0;
	NibblesViewPoint3D _tmp38_ = {0};
	gdouble _tmp39_ = 0.0;
	gdouble _tmp40_ = 0.0;
	gdouble _tmp41_;
	gdouble _tmp42_;
	gdouble _tmp43_;
	gdouble _tmp44_;
	gdouble _tmp45_;
	gdouble _tmp46_;
	NibblesViewPoint3D _tmp47_ = {0};
	gdouble _tmp48_ = 0.0;
	gdouble _tmp49_ = 0.0;
	NibblesViewPoint3D _tmp50_ = {0};
	gdouble _tmp51_ = 0.0;
	gdouble _tmp52_ = 0.0;
	NibblesViewPoint3D _tmp53_ = {0};
	gdouble _tmp54_ = 0.0;
	gdouble _tmp55_ = 0.0;
	gdouble _tmp56_;
	gdouble _tmp57_;
	gdouble _tmp58_;
	gdouble _tmp59_;
	gdouble _tmp60_;
	gdouble _tmp61_;
	NibblesViewPoint3D _tmp62_ = {0};
	gdouble _tmp63_ = 0.0;
	gdouble _tmp64_ = 0.0;
	NibblesViewPoint3D _tmp65_ = {0};
	gdouble _tmp66_ = 0.0;
	gdouble _tmp67_ = 0.0;
	NibblesViewPoint3D _tmp68_ = {0};
	gdouble _tmp69_ = 0.0;
	gdouble _tmp70_ = 0.0;
	gdouble _tmp71_;
	gdouble _tmp72_;
	gdouble _tmp73_;
	gdouble _tmp74_;
	gdouble _tmp75_;
	gdouble _tmp76_;
	NibblesViewPoint3D _tmp77_ = {0};
	gdouble _tmp78_ = 0.0;
	gdouble _tmp79_ = 0.0;
	NibblesViewPoint3D _tmp80_ = {0};
	gdouble _tmp81_ = 0.0;
	gdouble _tmp82_ = 0.0;
	NibblesViewPoint3D _tmp83_ = {0};
	gdouble _tmp84_ = 0.0;
	gdouble _tmp85_ = 0.0;
	gdouble _tmp86_;
	gdouble _tmp87_;
	gdouble _tmp88_;
	gdouble _tmp89_;
	gdouble _tmp90_;
	gdouble _tmp91_;
	NibblesViewPoint3D _tmp92_ = {0};
	gdouble _tmp93_ = 0.0;
	gdouble _tmp94_ = 0.0;
	gdouble _tmp95_;
	gdouble _tmp96_;
	NibblesViewPoint3D _tmp97_ = {0};
	gdouble _tmp98_ = 0.0;
	gdouble _tmp99_ = 0.0;
	gdouble _tmp100_;
	gdouble _tmp101_;
	NibblesViewPoint3D _tmp102_ = {0};
	gdouble _tmp103_ = 0.0;
	gdouble _tmp104_ = 0.0;
	NibblesViewPoint3D _tmp105_ = {0};
	gdouble _tmp106_ = 0.0;
	gdouble _tmp107_ = 0.0;
	gdouble radius = 0.0;
	NibblesViewPoint3D _tmp108_ = {0};
	NibblesViewPoint3D _tmp109_ = {0};
	cairo_pattern_t* pat2 = NULL;
	gdouble _tmp110_;
	gdouble _tmp111_;
	gdouble _tmp112_;
	gdouble _tmp113_;
	cairo_pattern_t* _tmp114_;
#line 1058 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 1058 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 1058 "../src/nibbles-view.vala"
	g_return_if_fail (v != NULL);
#line 1060 "../src/nibbles-view.vala"
	H = sqrt (0.125);
#line 1061 "../src/nibbles-view.vala"
	h = 0.5 - H;
#line 1066 "../src/nibbles-view.vala"
	_tmp0_.x = x + h;
#line 1066 "../src/nibbles-view.vala"
	_tmp0_.y = y + 1;
#line 1066 "../src/nibbles-view.vala"
	_tmp0_.z = 1 + h;
#line 1066 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp0_, &_tmp1_, &_tmp2_);
#line 1066 "../src/nibbles-view.vala"
	cx[0] = _tmp1_;
#line 1066 "../src/nibbles-view.vala"
	cy[0] = _tmp2_;
#line 1067 "../src/nibbles-view.vala"
	_tmp3_.x = x - 0.207106781187;
#line 1067 "../src/nibbles-view.vala"
	_tmp3_.y = y + 1;
#line 1067 "../src/nibbles-view.vala"
	_tmp3_.z = 1.5;
#line 1067 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 1067 "../src/nibbles-view.vala"
	cx[1] = _tmp4_;
#line 1067 "../src/nibbles-view.vala"
	cy[1] = _tmp5_;
#line 1068 "../src/nibbles-view.vala"
	_tmp6_.x = x + h;
#line 1068 "../src/nibbles-view.vala"
	_tmp6_.y = y + 1;
#line 1068 "../src/nibbles-view.vala"
	_tmp6_.z = 2.0 - h;
#line 1068 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp6_, &_tmp7_, &_tmp8_);
#line 1068 "../src/nibbles-view.vala"
	cx[2] = _tmp7_;
#line 1068 "../src/nibbles-view.vala"
	cy[2] = _tmp8_;
#line 1069 "../src/nibbles-view.vala"
	_tmp9_ = cx[0];
#line 1069 "../src/nibbles-view.vala"
	_tmp10_ = cy[0];
#line 1069 "../src/nibbles-view.vala"
	cairo_move_to (c, _tmp9_, _tmp10_);
#line 1070 "../src/nibbles-view.vala"
	_tmp11_ = cx[0];
#line 1070 "../src/nibbles-view.vala"
	_tmp12_ = cy[0];
#line 1070 "../src/nibbles-view.vala"
	_tmp13_ = cx[1];
#line 1070 "../src/nibbles-view.vala"
	_tmp14_ = cy[1];
#line 1070 "../src/nibbles-view.vala"
	_tmp15_ = cx[2];
#line 1070 "../src/nibbles-view.vala"
	_tmp16_ = cy[2];
#line 1070 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp11_, _tmp12_, _tmp13_, _tmp14_, _tmp15_, _tmp16_);
#line 1074 "../src/nibbles-view.vala"
	_tmp17_.x = x + h;
#line 1074 "../src/nibbles-view.vala"
	_tmp17_.y = y + 1;
#line 1074 "../src/nibbles-view.vala"
	_tmp17_.z = 2.0 - h;
#line 1074 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp17_, &_tmp18_, &_tmp19_);
#line 1074 "../src/nibbles-view.vala"
	cx[0] = _tmp18_;
#line 1074 "../src/nibbles-view.vala"
	cy[0] = _tmp19_;
#line 1075 "../src/nibbles-view.vala"
	_tmp20_.x = x + 0.5;
#line 1075 "../src/nibbles-view.vala"
	_tmp20_.y = y + 1;
#line 1075 "../src/nibbles-view.vala"
	_tmp20_.z = 2.0 + 0.207106781187;
#line 1075 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp20_, &_tmp21_, &_tmp22_);
#line 1075 "../src/nibbles-view.vala"
	cx[1] = _tmp21_;
#line 1075 "../src/nibbles-view.vala"
	cy[1] = _tmp22_;
#line 1076 "../src/nibbles-view.vala"
	_tmp23_.x = (x + 1) - h;
#line 1076 "../src/nibbles-view.vala"
	_tmp23_.y = y + 1;
#line 1076 "../src/nibbles-view.vala"
	_tmp23_.z = 2.0 - h;
#line 1076 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp23_, &_tmp24_, &_tmp25_);
#line 1076 "../src/nibbles-view.vala"
	cx[2] = _tmp24_;
#line 1076 "../src/nibbles-view.vala"
	cy[2] = _tmp25_;
#line 1077 "../src/nibbles-view.vala"
	_tmp26_ = cx[0];
#line 1077 "../src/nibbles-view.vala"
	_tmp27_ = cy[0];
#line 1077 "../src/nibbles-view.vala"
	_tmp28_ = cx[1];
#line 1077 "../src/nibbles-view.vala"
	_tmp29_ = cy[1];
#line 1077 "../src/nibbles-view.vala"
	_tmp30_ = cx[2];
#line 1077 "../src/nibbles-view.vala"
	_tmp31_ = cy[2];
#line 1077 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp26_, _tmp27_, _tmp28_, _tmp29_, _tmp30_, _tmp31_);
#line 1081 "../src/nibbles-view.vala"
	_tmp32_.x = (x + 1) - h;
#line 1081 "../src/nibbles-view.vala"
	_tmp32_.y = y + 1;
#line 1081 "../src/nibbles-view.vala"
	_tmp32_.z = 2.0 - h;
#line 1081 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp32_, &_tmp33_, &_tmp34_);
#line 1081 "../src/nibbles-view.vala"
	cx[0] = _tmp33_;
#line 1081 "../src/nibbles-view.vala"
	cy[0] = _tmp34_;
#line 1082 "../src/nibbles-view.vala"
	_tmp35_.x = x + 1;
#line 1082 "../src/nibbles-view.vala"
	_tmp35_.y = y + 1;
#line 1082 "../src/nibbles-view.vala"
	_tmp35_.z = (((2.0 - h) - 1.5) / 2) + 1.5;
#line 1082 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp35_, &_tmp36_, &_tmp37_);
#line 1082 "../src/nibbles-view.vala"
	cx[1] = _tmp36_;
#line 1082 "../src/nibbles-view.vala"
	cy[1] = _tmp37_;
#line 1083 "../src/nibbles-view.vala"
	_tmp38_.x = x + 1;
#line 1083 "../src/nibbles-view.vala"
	_tmp38_.y = y + 1;
#line 1083 "../src/nibbles-view.vala"
	_tmp38_.z = 1.5;
#line 1083 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp38_, &_tmp39_, &_tmp40_);
#line 1083 "../src/nibbles-view.vala"
	cx[2] = _tmp39_;
#line 1083 "../src/nibbles-view.vala"
	cy[2] = _tmp40_;
#line 1084 "../src/nibbles-view.vala"
	_tmp41_ = cx[0];
#line 1084 "../src/nibbles-view.vala"
	_tmp42_ = cy[0];
#line 1084 "../src/nibbles-view.vala"
	_tmp43_ = cx[1];
#line 1084 "../src/nibbles-view.vala"
	_tmp44_ = cy[1];
#line 1084 "../src/nibbles-view.vala"
	_tmp45_ = cx[2];
#line 1084 "../src/nibbles-view.vala"
	_tmp46_ = cy[2];
#line 1084 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp41_, _tmp42_, _tmp43_, _tmp44_, _tmp45_, _tmp46_);
#line 1088 "../src/nibbles-view.vala"
	_tmp47_.x = x + 1;
#line 1088 "../src/nibbles-view.vala"
	_tmp47_.y = y + 1;
#line 1088 "../src/nibbles-view.vala"
	_tmp47_.z = 1.5;
#line 1088 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp47_, &_tmp48_, &_tmp49_);
#line 1088 "../src/nibbles-view.vala"
	cx[0] = _tmp48_;
#line 1088 "../src/nibbles-view.vala"
	cy[0] = _tmp49_;
#line 1089 "../src/nibbles-view.vala"
	_tmp50_.x = x + 1;
#line 1089 "../src/nibbles-view.vala"
	_tmp50_.y = y + 1;
#line 1089 "../src/nibbles-view.vala"
	_tmp50_.z = (((2.0 - h) - 1.5) / 2) + 1.5;
#line 1089 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp50_, &_tmp51_, &_tmp52_);
#line 1089 "../src/nibbles-view.vala"
	cx[1] = _tmp51_;
#line 1089 "../src/nibbles-view.vala"
	cy[1] = _tmp52_;
#line 1090 "../src/nibbles-view.vala"
	_tmp53_.x = (x + 1) + h;
#line 1090 "../src/nibbles-view.vala"
	_tmp53_.y = y + 1;
#line 1090 "../src/nibbles-view.vala"
	_tmp53_.z = 2.0 - h;
#line 1090 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp53_, &_tmp54_, &_tmp55_);
#line 1090 "../src/nibbles-view.vala"
	cx[2] = _tmp54_;
#line 1090 "../src/nibbles-view.vala"
	cy[2] = _tmp55_;
#line 1091 "../src/nibbles-view.vala"
	_tmp56_ = cx[0];
#line 1091 "../src/nibbles-view.vala"
	_tmp57_ = cy[0];
#line 1091 "../src/nibbles-view.vala"
	_tmp58_ = cx[1];
#line 1091 "../src/nibbles-view.vala"
	_tmp59_ = cy[1];
#line 1091 "../src/nibbles-view.vala"
	_tmp60_ = cx[2];
#line 1091 "../src/nibbles-view.vala"
	_tmp61_ = cy[2];
#line 1091 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp56_, _tmp57_, _tmp58_, _tmp59_, _tmp60_, _tmp61_);
#line 1095 "../src/nibbles-view.vala"
	_tmp62_.x = (x + 1) + h;
#line 1095 "../src/nibbles-view.vala"
	_tmp62_.y = y + 1;
#line 1095 "../src/nibbles-view.vala"
	_tmp62_.z = 2.0 - h;
#line 1095 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp62_, &_tmp63_, &_tmp64_);
#line 1095 "../src/nibbles-view.vala"
	cx[0] = _tmp63_;
#line 1095 "../src/nibbles-view.vala"
	cy[0] = _tmp64_;
#line 1096 "../src/nibbles-view.vala"
	_tmp65_.x = x + 1.5;
#line 1096 "../src/nibbles-view.vala"
	_tmp65_.y = y + 1;
#line 1096 "../src/nibbles-view.vala"
	_tmp65_.z = 2.0 + 0.207106781187;
#line 1096 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp65_, &_tmp66_, &_tmp67_);
#line 1096 "../src/nibbles-view.vala"
	cx[1] = _tmp66_;
#line 1096 "../src/nibbles-view.vala"
	cy[1] = _tmp67_;
#line 1097 "../src/nibbles-view.vala"
	_tmp68_.x = (x + 2) - h;
#line 1097 "../src/nibbles-view.vala"
	_tmp68_.y = y + 1;
#line 1097 "../src/nibbles-view.vala"
	_tmp68_.z = 2.0 - h;
#line 1097 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp68_, &_tmp69_, &_tmp70_);
#line 1097 "../src/nibbles-view.vala"
	cx[2] = _tmp69_;
#line 1097 "../src/nibbles-view.vala"
	cy[2] = _tmp70_;
#line 1098 "../src/nibbles-view.vala"
	_tmp71_ = cx[0];
#line 1098 "../src/nibbles-view.vala"
	_tmp72_ = cy[0];
#line 1098 "../src/nibbles-view.vala"
	_tmp73_ = cx[1];
#line 1098 "../src/nibbles-view.vala"
	_tmp74_ = cy[1];
#line 1098 "../src/nibbles-view.vala"
	_tmp75_ = cx[2];
#line 1098 "../src/nibbles-view.vala"
	_tmp76_ = cy[2];
#line 1098 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp71_, _tmp72_, _tmp73_, _tmp74_, _tmp75_, _tmp76_);
#line 1102 "../src/nibbles-view.vala"
	_tmp77_.x = (x + 2) - h;
#line 1102 "../src/nibbles-view.vala"
	_tmp77_.y = y + 1;
#line 1102 "../src/nibbles-view.vala"
	_tmp77_.z = 2.0 - h;
#line 1102 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp77_, &_tmp78_, &_tmp79_);
#line 1102 "../src/nibbles-view.vala"
	cx[0] = _tmp78_;
#line 1102 "../src/nibbles-view.vala"
	cy[0] = _tmp79_;
#line 1103 "../src/nibbles-view.vala"
	_tmp80_.x = (x + 2) + 0.207106781187;
#line 1103 "../src/nibbles-view.vala"
	_tmp80_.y = y + 1;
#line 1103 "../src/nibbles-view.vala"
	_tmp80_.z = 1.5;
#line 1103 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp80_, &_tmp81_, &_tmp82_);
#line 1103 "../src/nibbles-view.vala"
	cx[1] = _tmp81_;
#line 1103 "../src/nibbles-view.vala"
	cy[1] = _tmp82_;
#line 1104 "../src/nibbles-view.vala"
	_tmp83_.x = (x + 2) - h;
#line 1104 "../src/nibbles-view.vala"
	_tmp83_.y = y + 1;
#line 1104 "../src/nibbles-view.vala"
	_tmp83_.z = 1 + h;
#line 1104 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp83_, &_tmp84_, &_tmp85_);
#line 1104 "../src/nibbles-view.vala"
	cx[2] = _tmp84_;
#line 1104 "../src/nibbles-view.vala"
	cy[2] = _tmp85_;
#line 1105 "../src/nibbles-view.vala"
	_tmp86_ = cx[0];
#line 1105 "../src/nibbles-view.vala"
	_tmp87_ = cy[0];
#line 1105 "../src/nibbles-view.vala"
	_tmp88_ = cx[1];
#line 1105 "../src/nibbles-view.vala"
	_tmp89_ = cy[1];
#line 1105 "../src/nibbles-view.vala"
	_tmp90_ = cx[2];
#line 1105 "../src/nibbles-view.vala"
	_tmp91_ = cy[2];
#line 1105 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp86_, _tmp87_, _tmp88_, _tmp89_, _tmp90_, _tmp91_);
#line 1107 "../src/nibbles-view.vala"
	_tmp92_.x = x + 1;
#line 1107 "../src/nibbles-view.vala"
	_tmp92_.y = y + 1;
#line 1107 "../src/nibbles-view.vala"
	_tmp92_.z = (gdouble) 0;
#line 1107 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp92_, &_tmp93_, &_tmp94_);
#line 1107 "../src/nibbles-view.vala"
	cx[0] = _tmp93_;
#line 1107 "../src/nibbles-view.vala"
	cy[0] = _tmp94_;
#line 1108 "../src/nibbles-view.vala"
	_tmp95_ = cx[0];
#line 1108 "../src/nibbles-view.vala"
	_tmp96_ = cy[0];
#line 1108 "../src/nibbles-view.vala"
	cairo_line_to (c, _tmp95_, _tmp96_);
#line 1110 "../src/nibbles-view.vala"
	_tmp97_.x = x + h;
#line 1110 "../src/nibbles-view.vala"
	_tmp97_.y = y + 1;
#line 1110 "../src/nibbles-view.vala"
	_tmp97_.z = 1 + h;
#line 1110 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp97_, &_tmp98_, &_tmp99_);
#line 1110 "../src/nibbles-view.vala"
	cx[0] = _tmp98_;
#line 1110 "../src/nibbles-view.vala"
	cy[0] = _tmp99_;
#line 1111 "../src/nibbles-view.vala"
	_tmp100_ = cx[0];
#line 1111 "../src/nibbles-view.vala"
	_tmp101_ = cy[0];
#line 1111 "../src/nibbles-view.vala"
	cairo_line_to (c, _tmp100_, _tmp101_);
#line 1114 "../src/nibbles-view.vala"
	_tmp102_.x = x + 1;
#line 1114 "../src/nibbles-view.vala"
	_tmp102_.y = y + 1;
#line 1114 "../src/nibbles-view.vala"
	_tmp102_.z = 1 + h;
#line 1114 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp102_, &_tmp103_, &_tmp104_);
#line 1114 "../src/nibbles-view.vala"
	cx[0] = _tmp103_;
#line 1114 "../src/nibbles-view.vala"
	cy[0] = _tmp104_;
#line 1115 "../src/nibbles-view.vala"
	_tmp105_.x = x + 0.875;
#line 1115 "../src/nibbles-view.vala"
	_tmp105_.y = y + 1;
#line 1115 "../src/nibbles-view.vala"
	_tmp105_.z = 1.5;
#line 1115 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp105_, &_tmp106_, &_tmp107_);
#line 1115 "../src/nibbles-view.vala"
	cx[1] = _tmp106_;
#line 1115 "../src/nibbles-view.vala"
	cy[1] = _tmp107_;
#line 1117 "../src/nibbles-view.vala"
	_tmp108_.x = x + 1;
#line 1117 "../src/nibbles-view.vala"
	_tmp108_.y = y + 1;
#line 1117 "../src/nibbles-view.vala"
	_tmp108_.z = 1 + h;
#line 1117 "../src/nibbles-view.vala"
	_tmp109_.x = x + 1;
#line 1117 "../src/nibbles-view.vala"
	_tmp109_.y = y + 1;
#line 1117 "../src/nibbles-view.vala"
	_tmp109_.z = 0.0;
#line 1117 "../src/nibbles-view.vala"
	radius = nibbles_view_view3_d_2D_diff (v, &_tmp108_, &_tmp109_);
#line 1118 "../src/nibbles-view.vala"
	_tmp110_ = cx[0];
#line 1118 "../src/nibbles-view.vala"
	_tmp111_ = cy[0];
#line 1118 "../src/nibbles-view.vala"
	_tmp112_ = cx[1];
#line 1118 "../src/nibbles-view.vala"
	_tmp113_ = cy[1];
#line 1118 "../src/nibbles-view.vala"
	_tmp114_ = cairo_pattern_create_radial (_tmp110_, _tmp111_, radius, _tmp112_, _tmp113_, radius / 40.0);
#line 1118 "../src/nibbles-view.vala"
	pat2 = _tmp114_;
#line 1119 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (pat2, (gdouble) 0, (gdouble) (1 / 10), (gdouble) 0, (gdouble) 0);
#line 1120 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (pat2, (gdouble) 1, (gdouble) 1, (gdouble) 0, (gdouble) 0);
#line 1121 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (pat2, (gdouble) 2, (gdouble) 1, 0.5, 0.5);
#line 1122 "../src/nibbles-view.vala"
	cairo_set_source (c, pat2);
#line 1123 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1058 "../src/nibbles-view.vala"
	_cairo_pattern_destroy0 (pat2);
#line 8456 "nibbles-view.c"
}

static void
nibbles_view_draw_cherry (NibblesView* self,
                          cairo_t* c,
                          NibblesViewView3D* v,
                          gdouble x,
                          gdouble y)
{
	NibblesViewPoint3D _tmp0_ = {0};
	NibblesViewPoint3D _tmp1_ = {0};
	NibblesViewPoint3D _tmp2_ = {0};
	NibblesViewPoint3D _tmp3_ = {0};
	gdouble X = 0.0;
	gdouble Y = 0.0;
	gdouble radius = 0.0;
	gdouble d = 0.0;
	gdouble top_x = 0.0;
	gdouble top_y = 0.0;
	NibblesViewPoint3D _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	NibblesViewPoint3D _tmp7_ = {0};
	NibblesViewPoint3D _tmp8_ = {0};
	NibblesViewPoint3D _tmp9_ = {0};
	NibblesViewPoint3D _tmp10_ = {0};
	NibblesViewPoint3D _tmp11_ = {0};
	NibblesViewPoint3D _tmp12_ = {0};
	NibblesViewPoint3D _tmp13_ = {0};
	NibblesViewPoint3D _tmp14_ = {0};
	NibblesViewPoint3D _tmp15_ = {0};
	gdouble _tmp16_ = 0.0;
	gdouble _tmp17_ = 0.0;
	cairo_pattern_t* pat2 = NULL;
	cairo_pattern_t* _tmp18_;
	cairo_pattern_t* _tmp19_;
	cairo_pattern_t* _tmp20_;
	cairo_pattern_t* _tmp21_;
	cairo_pattern_t* _tmp22_;
	gdouble cx[3] = {0};
	gdouble cy[3] = {0};
	NibblesViewPoint3D _tmp23_ = {0};
	gdouble _tmp24_ = 0.0;
	gdouble _tmp25_ = 0.0;
	NibblesViewPoint3D _tmp26_ = {0};
	gdouble _tmp27_ = 0.0;
	gdouble _tmp28_ = 0.0;
	NibblesViewPoint3D _tmp29_ = {0};
	gdouble _tmp30_ = 0.0;
	gdouble _tmp31_ = 0.0;
	gdouble _tmp32_;
	gdouble _tmp33_;
	gdouble _tmp34_;
	gdouble _tmp35_;
	gdouble _tmp36_;
	gdouble _tmp37_;
	gdouble _tmp38_;
	gdouble _tmp39_;
	NibblesViewPoint3D _tmp40_ = {0};
	gdouble _tmp41_ = 0.0;
	gdouble _tmp42_ = 0.0;
	NibblesViewPoint3D _tmp43_ = {0};
	gdouble _tmp44_ = 0.0;
	gdouble _tmp45_ = 0.0;
	NibblesViewPoint3D _tmp46_ = {0};
	gdouble _tmp47_ = 0.0;
	gdouble _tmp48_ = 0.0;
	gdouble _tmp49_;
	gdouble _tmp50_;
	gdouble _tmp51_;
	gdouble _tmp52_;
	gdouble _tmp53_;
	gdouble _tmp54_;
	NibblesViewPoint3D _tmp55_ = {0};
	NibblesViewPoint3D _tmp56_ = {0};
	NibblesViewPoint3D _tmp57_ = {0};
	NibblesViewPoint3D _tmp58_ = {0};
	NibblesViewPoint3D _tmp59_ = {0};
	gdouble _tmp60_ = 0.0;
	gdouble _tmp61_ = 0.0;
	NibblesViewPoint3D _tmp62_ = {0};
	NibblesViewPoint3D _tmp63_ = {0};
	NibblesViewPoint3D _tmp64_ = {0};
	NibblesViewPoint3D _tmp65_ = {0};
	NibblesViewPoint3D _tmp66_ = {0};
	NibblesViewPoint3D _tmp67_ = {0};
	NibblesViewPoint3D _tmp68_ = {0};
	NibblesViewPoint3D _tmp69_ = {0};
	NibblesViewPoint3D _tmp70_ = {0};
	gdouble _tmp71_ = 0.0;
	gdouble _tmp72_ = 0.0;
	cairo_pattern_t* _tmp73_;
	cairo_pattern_t* _tmp74_;
	cairo_pattern_t* _tmp75_;
	cairo_pattern_t* _tmp76_;
	cairo_pattern_t* _tmp77_;
	NibblesViewPoint3D _tmp78_ = {0};
	gdouble _tmp79_ = 0.0;
	gdouble _tmp80_ = 0.0;
	NibblesViewPoint3D _tmp81_ = {0};
	gdouble _tmp82_ = 0.0;
	gdouble _tmp83_ = 0.0;
	NibblesViewPoint3D _tmp84_ = {0};
	gdouble _tmp85_ = 0.0;
	gdouble _tmp86_ = 0.0;
	gdouble _tmp87_;
	gdouble _tmp88_;
	gdouble _tmp89_;
	gdouble _tmp90_;
	gdouble _tmp91_;
	gdouble _tmp92_;
	gdouble _tmp93_;
	gdouble _tmp94_;
	NibblesViewPoint3D _tmp95_ = {0};
	gdouble _tmp96_ = 0.0;
	gdouble _tmp97_ = 0.0;
	NibblesViewPoint3D _tmp98_ = {0};
	gdouble _tmp99_ = 0.0;
	gdouble _tmp100_ = 0.0;
	NibblesViewPoint3D _tmp101_ = {0};
	gdouble _tmp102_ = 0.0;
	gdouble _tmp103_ = 0.0;
	gdouble _tmp104_;
	gdouble _tmp105_;
	gdouble _tmp106_;
	gdouble _tmp107_;
	gdouble _tmp108_;
	gdouble _tmp109_;
	NibblesViewPoint3D _tmp110_ = {0};
	gdouble _tmp111_ = 0.0;
	gdouble _tmp112_ = 0.0;
	NibblesViewPoint3D _tmp113_ = {0};
	gdouble _tmp114_ = 0.0;
	gdouble _tmp115_ = 0.0;
	NibblesViewPoint3D _tmp116_ = {0};
	gdouble _tmp117_ = 0.0;
	gdouble _tmp118_ = 0.0;
	gdouble _tmp119_;
	gdouble _tmp120_;
	gdouble _tmp121_;
	gdouble _tmp122_;
	gdouble _tmp123_;
	gdouble _tmp124_;
	gdouble _tmp125_;
	gdouble _tmp126_;
	NibblesViewPoint3D _tmp127_ = {0};
	gdouble _tmp128_ = 0.0;
	gdouble _tmp129_ = 0.0;
	NibblesViewPoint3D _tmp130_ = {0};
	gdouble _tmp131_ = 0.0;
	gdouble _tmp132_ = 0.0;
	NibblesViewPoint3D _tmp133_ = {0};
	gdouble _tmp134_ = 0.0;
	gdouble _tmp135_ = 0.0;
	gdouble _tmp136_;
	gdouble _tmp137_;
	gdouble _tmp138_;
	gdouble _tmp139_;
	gdouble _tmp140_;
	gdouble _tmp141_;
#line 1126 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 1126 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 1126 "../src/nibbles-view.vala"
	g_return_if_fail (v != NULL);
#line 1129 "../src/nibbles-view.vala"
	_tmp0_.x = x;
#line 1129 "../src/nibbles-view.vala"
	_tmp0_.y = 1.5 + y;
#line 1129 "../src/nibbles-view.vala"
	_tmp0_.z = (gdouble) 0;
#line 1129 "../src/nibbles-view.vala"
	_tmp1_.x = x;
#line 1129 "../src/nibbles-view.vala"
	_tmp1_.y = 0.5 + y;
#line 1129 "../src/nibbles-view.vala"
	_tmp1_.z = (gdouble) 1;
#line 1129 "../src/nibbles-view.vala"
	_tmp2_.x = 1.0 + x;
#line 1129 "../src/nibbles-view.vala"
	_tmp2_.y = 0.5 + y;
#line 1129 "../src/nibbles-view.vala"
	_tmp2_.z = (gdouble) 1;
#line 1129 "../src/nibbles-view.vala"
	_tmp3_.x = 1.0 + x;
#line 1129 "../src/nibbles-view.vala"
	_tmp3_.y = 1.5 + y;
#line 1129 "../src/nibbles-view.vala"
	_tmp3_.z = (gdouble) 0;
#line 1129 "../src/nibbles-view.vala"
	nibbles_view_draw_oval (self, c, v, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 1134 "../src/nibbles-view.vala"
	_tmp4_.x = x + 0.5;
#line 1134 "../src/nibbles-view.vala"
	_tmp4_.y = y + 1.0;
#line 1134 "../src/nibbles-view.vala"
	_tmp4_.z = 0.5;
#line 1134 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp4_, &_tmp5_, &_tmp6_);
#line 1134 "../src/nibbles-view.vala"
	X = _tmp5_;
#line 1134 "../src/nibbles-view.vala"
	Y = _tmp6_;
#line 1135 "../src/nibbles-view.vala"
	_tmp7_.x = x + 0.5;
#line 1135 "../src/nibbles-view.vala"
	_tmp7_.y = y + 1.0;
#line 1135 "../src/nibbles-view.vala"
	_tmp7_.z = 0.5;
#line 1135 "../src/nibbles-view.vala"
	_tmp8_.x = x + 0.5;
#line 1135 "../src/nibbles-view.vala"
	_tmp8_.y = y + 0.5;
#line 1135 "../src/nibbles-view.vala"
	_tmp8_.z = 1.0;
#line 1135 "../src/nibbles-view.vala"
	radius = nibbles_view_view3_d_2D_diff (v, &_tmp7_, &_tmp8_);
#line 1136 "../src/nibbles-view.vala"
	_tmp9_.x = x + 0.5;
#line 1136 "../src/nibbles-view.vala"
	_tmp9_.y = y + 1.0;
#line 1136 "../src/nibbles-view.vala"
	_tmp9_.z = 0.5;
#line 1136 "../src/nibbles-view.vala"
	_tmp10_.x = x + 0.0;
#line 1136 "../src/nibbles-view.vala"
	_tmp10_.y = y + 1.0;
#line 1136 "../src/nibbles-view.vala"
	_tmp10_.z = 0.5;
#line 1136 "../src/nibbles-view.vala"
	d = nibbles_view_view3_d_2D_diff (v, &_tmp9_, &_tmp10_);
#line 1137 "../src/nibbles-view.vala"
	if (d > radius) {
#line 1138 "../src/nibbles-view.vala"
		radius = d;
#line 8693 "nibbles-view.c"
	}
#line 1139 "../src/nibbles-view.vala"
	_tmp11_.x = x + 0.5;
#line 1139 "../src/nibbles-view.vala"
	_tmp11_.y = y + 1.0;
#line 1139 "../src/nibbles-view.vala"
	_tmp11_.z = 0.5;
#line 1139 "../src/nibbles-view.vala"
	_tmp12_.x = x + 1.0;
#line 1139 "../src/nibbles-view.vala"
	_tmp12_.y = y + 1.0;
#line 1139 "../src/nibbles-view.vala"
	_tmp12_.z = 0.5;
#line 1139 "../src/nibbles-view.vala"
	d = nibbles_view_view3_d_2D_diff (v, &_tmp11_, &_tmp12_);
#line 1140 "../src/nibbles-view.vala"
	if (d > radius) {
#line 1141 "../src/nibbles-view.vala"
		radius = d;
#line 8713 "nibbles-view.c"
	}
#line 1142 "../src/nibbles-view.vala"
	_tmp13_.x = x + 0.5;
#line 1142 "../src/nibbles-view.vala"
	_tmp13_.y = y + 1.0;
#line 1142 "../src/nibbles-view.vala"
	_tmp13_.z = 0.5;
#line 1142 "../src/nibbles-view.vala"
	_tmp14_.x = x + 0.5;
#line 1142 "../src/nibbles-view.vala"
	_tmp14_.y = y + 1.5;
#line 1142 "../src/nibbles-view.vala"
	_tmp14_.z = 0.0;
#line 1142 "../src/nibbles-view.vala"
	d = nibbles_view_view3_d_2D_diff (v, &_tmp13_, &_tmp14_);
#line 1143 "../src/nibbles-view.vala"
	if (d > radius) {
#line 1144 "../src/nibbles-view.vala"
		radius = d;
#line 8733 "nibbles-view.c"
	}
#line 1146 "../src/nibbles-view.vala"
	_tmp15_.x = x + 0.5;
#line 1146 "../src/nibbles-view.vala"
	_tmp15_.y = y + 1.0;
#line 1146 "../src/nibbles-view.vala"
	_tmp15_.z = 1.0;
#line 1146 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp15_, &_tmp16_, &_tmp17_);
#line 1146 "../src/nibbles-view.vala"
	top_x = _tmp16_;
#line 1146 "../src/nibbles-view.vala"
	top_y = _tmp17_;
#line 1147 "../src/nibbles-view.vala"
	_tmp18_ = cairo_pattern_create_radial (X, Y, radius, top_x, top_y, radius / 20.0);
#line 1147 "../src/nibbles-view.vala"
	pat2 = _tmp18_;
#line 1148 "../src/nibbles-view.vala"
	_tmp19_ = pat2;
#line 1148 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (_tmp19_, (gdouble) 0, (gdouble) (1 / 10), (gdouble) 0, (gdouble) 0);
#line 1149 "../src/nibbles-view.vala"
	_tmp20_ = pat2;
#line 1149 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (_tmp20_, (gdouble) 1, (gdouble) 1, (gdouble) 0, (gdouble) 0);
#line 1150 "../src/nibbles-view.vala"
	_tmp21_ = pat2;
#line 1150 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (_tmp21_, (gdouble) 2, (gdouble) 1, 0.5, 0.5);
#line 1151 "../src/nibbles-view.vala"
	_tmp22_ = pat2;
#line 1151 "../src/nibbles-view.vala"
	cairo_set_source (c, _tmp22_);
#line 1152 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1156 "../src/nibbles-view.vala"
	_tmp23_.x = x + 0.45;
#line 1156 "../src/nibbles-view.vala"
	_tmp23_.y = y + 1.0;
#line 1156 "../src/nibbles-view.vala"
	_tmp23_.z = 1.0;
#line 1156 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp23_, &_tmp24_, &_tmp25_);
#line 1156 "../src/nibbles-view.vala"
	cx[0] = _tmp24_;
#line 1156 "../src/nibbles-view.vala"
	cy[0] = _tmp25_;
#line 1157 "../src/nibbles-view.vala"
	_tmp26_.x = x + 0.45;
#line 1157 "../src/nibbles-view.vala"
	_tmp26_.y = y + 1.0;
#line 1157 "../src/nibbles-view.vala"
	_tmp26_.z = 2.0;
#line 1157 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp26_, &_tmp27_, &_tmp28_);
#line 1157 "../src/nibbles-view.vala"
	cx[1] = _tmp27_;
#line 1157 "../src/nibbles-view.vala"
	cy[1] = _tmp28_;
#line 1158 "../src/nibbles-view.vala"
	_tmp29_.x = x + 1.15;
#line 1158 "../src/nibbles-view.vala"
	_tmp29_.y = y + 1.0;
#line 1158 "../src/nibbles-view.vala"
	_tmp29_.z = 2.0;
#line 1158 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp29_, &_tmp30_, &_tmp31_);
#line 1158 "../src/nibbles-view.vala"
	cx[2] = _tmp30_;
#line 1158 "../src/nibbles-view.vala"
	cy[2] = _tmp31_;
#line 1159 "../src/nibbles-view.vala"
	_tmp32_ = cx[0];
#line 1159 "../src/nibbles-view.vala"
	_tmp33_ = cy[0];
#line 1159 "../src/nibbles-view.vala"
	cairo_move_to (c, _tmp32_, _tmp33_);
#line 1160 "../src/nibbles-view.vala"
	_tmp34_ = cx[0];
#line 1160 "../src/nibbles-view.vala"
	_tmp35_ = cy[0];
#line 1160 "../src/nibbles-view.vala"
	_tmp36_ = cx[1];
#line 1160 "../src/nibbles-view.vala"
	_tmp37_ = cy[1];
#line 1160 "../src/nibbles-view.vala"
	_tmp38_ = cx[2];
#line 1160 "../src/nibbles-view.vala"
	_tmp39_ = cy[2];
#line 1160 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp34_, _tmp35_, _tmp36_, _tmp37_, _tmp38_, _tmp39_);
#line 1161 "../src/nibbles-view.vala"
	_tmp40_.x = x + 1.25;
#line 1161 "../src/nibbles-view.vala"
	_tmp40_.y = y + 1.0;
#line 1161 "../src/nibbles-view.vala"
	_tmp40_.z = 2.0;
#line 1161 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp40_, &_tmp41_, &_tmp42_);
#line 1161 "../src/nibbles-view.vala"
	cx[0] = _tmp41_;
#line 1161 "../src/nibbles-view.vala"
	cy[0] = _tmp42_;
#line 1162 "../src/nibbles-view.vala"
	_tmp43_.x = x + 0.55;
#line 1162 "../src/nibbles-view.vala"
	_tmp43_.y = y + 1.0;
#line 1162 "../src/nibbles-view.vala"
	_tmp43_.z = 2.0;
#line 1162 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp43_, &_tmp44_, &_tmp45_);
#line 1162 "../src/nibbles-view.vala"
	cx[1] = _tmp44_;
#line 1162 "../src/nibbles-view.vala"
	cy[1] = _tmp45_;
#line 1163 "../src/nibbles-view.vala"
	_tmp46_.x = x + 0.55;
#line 1163 "../src/nibbles-view.vala"
	_tmp46_.y = y + 1.0;
#line 1163 "../src/nibbles-view.vala"
	_tmp46_.z = 1.0;
#line 1163 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp46_, &_tmp47_, &_tmp48_);
#line 1163 "../src/nibbles-view.vala"
	cx[2] = _tmp47_;
#line 1163 "../src/nibbles-view.vala"
	cy[2] = _tmp48_;
#line 1164 "../src/nibbles-view.vala"
	_tmp49_ = cx[0];
#line 1164 "../src/nibbles-view.vala"
	_tmp50_ = cy[0];
#line 1164 "../src/nibbles-view.vala"
	_tmp51_ = cx[1];
#line 1164 "../src/nibbles-view.vala"
	_tmp52_ = cy[1];
#line 1164 "../src/nibbles-view.vala"
	_tmp53_ = cx[2];
#line 1164 "../src/nibbles-view.vala"
	_tmp54_ = cy[2];
#line 1164 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp49_, _tmp50_, _tmp51_, _tmp52_, _tmp53_, _tmp54_);
#line 1165 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.5, 0.5, (gdouble) 0);
#line 1166 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1168 "../src/nibbles-view.vala"
	_tmp55_.x = 1.0 + x;
#line 1168 "../src/nibbles-view.vala"
	_tmp55_.y = 1.5 + y;
#line 1168 "../src/nibbles-view.vala"
	_tmp55_.z = (gdouble) 0;
#line 1168 "../src/nibbles-view.vala"
	_tmp56_.x = 1.0 + x;
#line 1168 "../src/nibbles-view.vala"
	_tmp56_.y = 0.5 + y;
#line 1168 "../src/nibbles-view.vala"
	_tmp56_.z = (gdouble) 1;
#line 1168 "../src/nibbles-view.vala"
	_tmp57_.x = 2.0 + x;
#line 1168 "../src/nibbles-view.vala"
	_tmp57_.y = 0.5 + y;
#line 1168 "../src/nibbles-view.vala"
	_tmp57_.z = (gdouble) 1;
#line 1168 "../src/nibbles-view.vala"
	_tmp58_.x = 2.0 + x;
#line 1168 "../src/nibbles-view.vala"
	_tmp58_.y = 1.5 + y;
#line 1168 "../src/nibbles-view.vala"
	_tmp58_.z = (gdouble) 0;
#line 1168 "../src/nibbles-view.vala"
	nibbles_view_draw_oval (self, c, v, &_tmp55_, &_tmp56_, &_tmp57_, &_tmp58_);
#line 1172 "../src/nibbles-view.vala"
	_tmp59_.x = x + 1.5;
#line 1172 "../src/nibbles-view.vala"
	_tmp59_.y = y + 1.0;
#line 1172 "../src/nibbles-view.vala"
	_tmp59_.z = 0.5;
#line 1172 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp59_, &_tmp60_, &_tmp61_);
#line 1172 "../src/nibbles-view.vala"
	X = _tmp60_;
#line 1172 "../src/nibbles-view.vala"
	Y = _tmp61_;
#line 1173 "../src/nibbles-view.vala"
	_tmp62_.x = x + 1.5;
#line 1173 "../src/nibbles-view.vala"
	_tmp62_.y = y + 1.0;
#line 1173 "../src/nibbles-view.vala"
	_tmp62_.z = 0.5;
#line 1173 "../src/nibbles-view.vala"
	_tmp63_.x = x + 1.5;
#line 1173 "../src/nibbles-view.vala"
	_tmp63_.y = y + 0.5;
#line 1173 "../src/nibbles-view.vala"
	_tmp63_.z = 1.0;
#line 1173 "../src/nibbles-view.vala"
	radius = nibbles_view_view3_d_2D_diff (v, &_tmp62_, &_tmp63_);
#line 1174 "../src/nibbles-view.vala"
	_tmp64_.x = x + 1.5;
#line 1174 "../src/nibbles-view.vala"
	_tmp64_.y = y + 1.0;
#line 1174 "../src/nibbles-view.vala"
	_tmp64_.z = 0.5;
#line 1174 "../src/nibbles-view.vala"
	_tmp65_.x = x + 1.0;
#line 1174 "../src/nibbles-view.vala"
	_tmp65_.y = y + 1.0;
#line 1174 "../src/nibbles-view.vala"
	_tmp65_.z = 0.5;
#line 1174 "../src/nibbles-view.vala"
	d = nibbles_view_view3_d_2D_diff (v, &_tmp64_, &_tmp65_);
#line 1175 "../src/nibbles-view.vala"
	if (d > radius) {
#line 1176 "../src/nibbles-view.vala"
		radius = d;
#line 8949 "nibbles-view.c"
	}
#line 1177 "../src/nibbles-view.vala"
	_tmp66_.x = x + 1.5;
#line 1177 "../src/nibbles-view.vala"
	_tmp66_.y = y + 1.0;
#line 1177 "../src/nibbles-view.vala"
	_tmp66_.z = 0.5;
#line 1177 "../src/nibbles-view.vala"
	_tmp67_.x = x + 2.0;
#line 1177 "../src/nibbles-view.vala"
	_tmp67_.y = y + 1.0;
#line 1177 "../src/nibbles-view.vala"
	_tmp67_.z = 0.5;
#line 1177 "../src/nibbles-view.vala"
	d = nibbles_view_view3_d_2D_diff (v, &_tmp66_, &_tmp67_);
#line 1178 "../src/nibbles-view.vala"
	if (d > radius) {
#line 1179 "../src/nibbles-view.vala"
		radius = d;
#line 8969 "nibbles-view.c"
	}
#line 1180 "../src/nibbles-view.vala"
	_tmp68_.x = x + 1.5;
#line 1180 "../src/nibbles-view.vala"
	_tmp68_.y = y + 1.0;
#line 1180 "../src/nibbles-view.vala"
	_tmp68_.z = 0.5;
#line 1180 "../src/nibbles-view.vala"
	_tmp69_.x = x + 1.5;
#line 1180 "../src/nibbles-view.vala"
	_tmp69_.y = y + 1.5;
#line 1180 "../src/nibbles-view.vala"
	_tmp69_.z = 0.0;
#line 1180 "../src/nibbles-view.vala"
	d = nibbles_view_view3_d_2D_diff (v, &_tmp68_, &_tmp69_);
#line 1181 "../src/nibbles-view.vala"
	if (d > radius) {
#line 1182 "../src/nibbles-view.vala"
		radius = d;
#line 8989 "nibbles-view.c"
	}
#line 1184 "../src/nibbles-view.vala"
	_tmp70_.x = x + 1.5;
#line 1184 "../src/nibbles-view.vala"
	_tmp70_.y = y + 1.0;
#line 1184 "../src/nibbles-view.vala"
	_tmp70_.z = 1.0;
#line 1184 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp70_, &_tmp71_, &_tmp72_);
#line 1184 "../src/nibbles-view.vala"
	top_x = _tmp71_;
#line 1184 "../src/nibbles-view.vala"
	top_y = _tmp72_;
#line 1185 "../src/nibbles-view.vala"
	_tmp73_ = cairo_pattern_create_radial (X, Y, radius, top_x, top_y, radius / 20.0);
#line 1185 "../src/nibbles-view.vala"
	_cairo_pattern_destroy0 (pat2);
#line 1185 "../src/nibbles-view.vala"
	pat2 = _tmp73_;
#line 1186 "../src/nibbles-view.vala"
	_tmp74_ = pat2;
#line 1186 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (_tmp74_, (gdouble) 0, (gdouble) (1 / 10), (gdouble) 0, (gdouble) 0);
#line 1187 "../src/nibbles-view.vala"
	_tmp75_ = pat2;
#line 1187 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (_tmp75_, (gdouble) 1, (gdouble) 1, (gdouble) 0, (gdouble) 0);
#line 1188 "../src/nibbles-view.vala"
	_tmp76_ = pat2;
#line 1188 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (_tmp76_, (gdouble) 2, (gdouble) 1, 0.5, 0.5);
#line 1189 "../src/nibbles-view.vala"
	_tmp77_ = pat2;
#line 1189 "../src/nibbles-view.vala"
	cairo_set_source (c, _tmp77_);
#line 1190 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1192 "../src/nibbles-view.vala"
	_tmp78_.x = x + 1.45;
#line 1192 "../src/nibbles-view.vala"
	_tmp78_.y = y + 1.0;
#line 1192 "../src/nibbles-view.vala"
	_tmp78_.z = 1.0;
#line 1192 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp78_, &_tmp79_, &_tmp80_);
#line 1192 "../src/nibbles-view.vala"
	cx[0] = _tmp79_;
#line 1192 "../src/nibbles-view.vala"
	cy[0] = _tmp80_;
#line 1193 "../src/nibbles-view.vala"
	_tmp81_.x = x + 1.45;
#line 1193 "../src/nibbles-view.vala"
	_tmp81_.y = y + 1.0;
#line 1193 "../src/nibbles-view.vala"
	_tmp81_.z = 2.0;
#line 1193 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp81_, &_tmp82_, &_tmp83_);
#line 1193 "../src/nibbles-view.vala"
	cx[1] = _tmp82_;
#line 1193 "../src/nibbles-view.vala"
	cy[1] = _tmp83_;
#line 1194 "../src/nibbles-view.vala"
	_tmp84_.x = x + 1.15;
#line 1194 "../src/nibbles-view.vala"
	_tmp84_.y = y + 1.0;
#line 1194 "../src/nibbles-view.vala"
	_tmp84_.z = 2.0;
#line 1194 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp84_, &_tmp85_, &_tmp86_);
#line 1194 "../src/nibbles-view.vala"
	cx[2] = _tmp85_;
#line 1194 "../src/nibbles-view.vala"
	cy[2] = _tmp86_;
#line 1195 "../src/nibbles-view.vala"
	_tmp87_ = cx[0];
#line 1195 "../src/nibbles-view.vala"
	_tmp88_ = cy[0];
#line 1195 "../src/nibbles-view.vala"
	cairo_move_to (c, _tmp87_, _tmp88_);
#line 1196 "../src/nibbles-view.vala"
	_tmp89_ = cx[0];
#line 1196 "../src/nibbles-view.vala"
	_tmp90_ = cy[0];
#line 1196 "../src/nibbles-view.vala"
	_tmp91_ = cx[1];
#line 1196 "../src/nibbles-view.vala"
	_tmp92_ = cy[1];
#line 1196 "../src/nibbles-view.vala"
	_tmp93_ = cx[2];
#line 1196 "../src/nibbles-view.vala"
	_tmp94_ = cy[2];
#line 1196 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp89_, _tmp90_, _tmp91_, _tmp92_, _tmp93_, _tmp94_);
#line 1197 "../src/nibbles-view.vala"
	_tmp95_.x = x + 1.25;
#line 1197 "../src/nibbles-view.vala"
	_tmp95_.y = y + 1.0;
#line 1197 "../src/nibbles-view.vala"
	_tmp95_.z = 2.0;
#line 1197 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp95_, &_tmp96_, &_tmp97_);
#line 1197 "../src/nibbles-view.vala"
	cx[0] = _tmp96_;
#line 1197 "../src/nibbles-view.vala"
	cy[0] = _tmp97_;
#line 1198 "../src/nibbles-view.vala"
	_tmp98_.x = x + 1.55;
#line 1198 "../src/nibbles-view.vala"
	_tmp98_.y = y + 1.0;
#line 1198 "../src/nibbles-view.vala"
	_tmp98_.z = 2.0;
#line 1198 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp98_, &_tmp99_, &_tmp100_);
#line 1198 "../src/nibbles-view.vala"
	cx[1] = _tmp99_;
#line 1198 "../src/nibbles-view.vala"
	cy[1] = _tmp100_;
#line 1199 "../src/nibbles-view.vala"
	_tmp101_.x = x + 1.55;
#line 1199 "../src/nibbles-view.vala"
	_tmp101_.y = y + 1.0;
#line 1199 "../src/nibbles-view.vala"
	_tmp101_.z = 1.0;
#line 1199 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp101_, &_tmp102_, &_tmp103_);
#line 1199 "../src/nibbles-view.vala"
	cx[2] = _tmp102_;
#line 1199 "../src/nibbles-view.vala"
	cy[2] = _tmp103_;
#line 1200 "../src/nibbles-view.vala"
	_tmp104_ = cx[0];
#line 1200 "../src/nibbles-view.vala"
	_tmp105_ = cy[0];
#line 1200 "../src/nibbles-view.vala"
	_tmp106_ = cx[1];
#line 1200 "../src/nibbles-view.vala"
	_tmp107_ = cy[1];
#line 1200 "../src/nibbles-view.vala"
	_tmp108_ = cx[2];
#line 1200 "../src/nibbles-view.vala"
	_tmp109_ = cy[2];
#line 1200 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp104_, _tmp105_, _tmp106_, _tmp107_, _tmp108_, _tmp109_);
#line 1201 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.5, 0.5, (gdouble) 0);
#line 1202 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1204 "../src/nibbles-view.vala"
	_tmp110_.x = x + 1.20;
#line 1204 "../src/nibbles-view.vala"
	_tmp110_.y = y + 1.0;
#line 1204 "../src/nibbles-view.vala"
	_tmp110_.z = 2.0;
#line 1204 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp110_, &_tmp111_, &_tmp112_);
#line 1204 "../src/nibbles-view.vala"
	cx[0] = _tmp111_;
#line 1204 "../src/nibbles-view.vala"
	cy[0] = _tmp112_;
#line 1205 "../src/nibbles-view.vala"
	_tmp113_.x = (x + 1.20) - 0.5;
#line 1205 "../src/nibbles-view.vala"
	_tmp113_.y = y + 1.0;
#line 1205 "../src/nibbles-view.vala"
	_tmp113_.z = 2.0;
#line 1205 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp113_, &_tmp114_, &_tmp115_);
#line 1205 "../src/nibbles-view.vala"
	cx[1] = _tmp114_;
#line 1205 "../src/nibbles-view.vala"
	cy[1] = _tmp115_;
#line 1206 "../src/nibbles-view.vala"
	_tmp116_.x = (x + 1.20) - 0.5;
#line 1206 "../src/nibbles-view.vala"
	_tmp116_.y = (y + 1.0) - 0.5;
#line 1206 "../src/nibbles-view.vala"
	_tmp116_.z = 2.0;
#line 1206 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp116_, &_tmp117_, &_tmp118_);
#line 1206 "../src/nibbles-view.vala"
	cx[2] = _tmp117_;
#line 1206 "../src/nibbles-view.vala"
	cy[2] = _tmp118_;
#line 1207 "../src/nibbles-view.vala"
	_tmp119_ = cx[0];
#line 1207 "../src/nibbles-view.vala"
	_tmp120_ = cy[0];
#line 1207 "../src/nibbles-view.vala"
	cairo_move_to (c, _tmp119_, _tmp120_);
#line 1208 "../src/nibbles-view.vala"
	_tmp121_ = cx[0];
#line 1208 "../src/nibbles-view.vala"
	_tmp122_ = cy[0];
#line 1208 "../src/nibbles-view.vala"
	_tmp123_ = cx[1];
#line 1208 "../src/nibbles-view.vala"
	_tmp124_ = cy[1];
#line 1208 "../src/nibbles-view.vala"
	_tmp125_ = cx[2];
#line 1208 "../src/nibbles-view.vala"
	_tmp126_ = cy[2];
#line 1208 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp121_, _tmp122_, _tmp123_, _tmp124_, _tmp125_, _tmp126_);
#line 1209 "../src/nibbles-view.vala"
	_tmp127_.x = (x + 1.20) - 0.5;
#line 1209 "../src/nibbles-view.vala"
	_tmp127_.y = (y + 1.0) - 0.5;
#line 1209 "../src/nibbles-view.vala"
	_tmp127_.z = 2.0;
#line 1209 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp127_, &_tmp128_, &_tmp129_);
#line 1209 "../src/nibbles-view.vala"
	cx[0] = _tmp128_;
#line 1209 "../src/nibbles-view.vala"
	cy[0] = _tmp129_;
#line 1210 "../src/nibbles-view.vala"
	_tmp130_.x = x + 1.20;
#line 1210 "../src/nibbles-view.vala"
	_tmp130_.y = (y + 1.0) - 0.5;
#line 1210 "../src/nibbles-view.vala"
	_tmp130_.z = 2.0;
#line 1210 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp130_, &_tmp131_, &_tmp132_);
#line 1210 "../src/nibbles-view.vala"
	cx[1] = _tmp131_;
#line 1210 "../src/nibbles-view.vala"
	cy[1] = _tmp132_;
#line 1211 "../src/nibbles-view.vala"
	_tmp133_.x = x + 1.20;
#line 1211 "../src/nibbles-view.vala"
	_tmp133_.y = y + 1.0;
#line 1211 "../src/nibbles-view.vala"
	_tmp133_.z = 2.0;
#line 1211 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp133_, &_tmp134_, &_tmp135_);
#line 1211 "../src/nibbles-view.vala"
	cx[2] = _tmp134_;
#line 1211 "../src/nibbles-view.vala"
	cy[2] = _tmp135_;
#line 1212 "../src/nibbles-view.vala"
	_tmp136_ = cx[0];
#line 1212 "../src/nibbles-view.vala"
	_tmp137_ = cy[0];
#line 1212 "../src/nibbles-view.vala"
	_tmp138_ = cx[1];
#line 1212 "../src/nibbles-view.vala"
	_tmp139_ = cy[1];
#line 1212 "../src/nibbles-view.vala"
	_tmp140_ = cx[2];
#line 1212 "../src/nibbles-view.vala"
	_tmp141_ = cy[2];
#line 1212 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp136_, _tmp137_, _tmp138_, _tmp139_, _tmp140_, _tmp141_);
#line 1213 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, (gdouble) 0, 0.75, (gdouble) 0);
#line 1214 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1126 "../src/nibbles-view.vala"
	_cairo_pattern_destroy0 (pat2);
#line 9249 "nibbles-view.c"
}

static void
nibbles_view_draw_apple (NibblesView* self,
                         cairo_t* c,
                         NibblesViewView3D* v,
                         gdouble x,
                         gdouble y)
{
	gdouble cx[3] = {0};
	gdouble cy[3] = {0};
	gdouble top_x = 0.0;
	gdouble top_y = 0.0;
	NibblesViewPoint3D _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	NibblesViewPoint3D _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	NibblesViewPoint3D _tmp6_ = {0};
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	NibblesViewPoint3D _tmp17_ = {0};
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	NibblesViewPoint3D _tmp20_ = {0};
	gdouble _tmp21_ = 0.0;
	gdouble _tmp22_ = 0.0;
	NibblesViewPoint3D _tmp23_ = {0};
	gdouble _tmp24_ = 0.0;
	gdouble _tmp25_ = 0.0;
	gdouble _tmp26_;
	gdouble _tmp27_;
	gdouble _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	NibblesViewPoint3D _tmp32_ = {0};
	gdouble _tmp33_ = 0.0;
	gdouble _tmp34_ = 0.0;
	NibblesViewPoint3D _tmp35_ = {0};
	gdouble _tmp36_ = 0.0;
	gdouble _tmp37_ = 0.0;
	NibblesViewPoint3D _tmp38_ = {0};
	gdouble _tmp39_ = 0.0;
	gdouble _tmp40_ = 0.0;
	gdouble _tmp41_;
	gdouble _tmp42_;
	gdouble _tmp43_;
	gdouble _tmp44_;
	gdouble _tmp45_;
	gdouble _tmp46_;
	NibblesViewPoint3D _tmp47_ = {0};
	gdouble _tmp48_ = 0.0;
	gdouble _tmp49_ = 0.0;
	NibblesViewPoint3D _tmp50_ = {0};
	gdouble _tmp51_ = 0.0;
	gdouble _tmp52_ = 0.0;
	NibblesViewPoint3D _tmp53_ = {0};
	gdouble _tmp54_ = 0.0;
	gdouble _tmp55_ = 0.0;
	gdouble _tmp56_;
	gdouble _tmp57_;
	gdouble _tmp58_;
	gdouble _tmp59_;
	gdouble _tmp60_;
	gdouble _tmp61_;
	NibblesViewPoint3D _tmp62_ = {0};
	gdouble _tmp63_ = 0.0;
	gdouble _tmp64_ = 0.0;
	gdouble radius = 0.0;
	NibblesViewPoint3D _tmp65_ = {0};
	NibblesViewPoint3D _tmp66_ = {0};
	cairo_pattern_t* pat2 = NULL;
	cairo_pattern_t* _tmp67_;
	cairo_pattern_t* _tmp68_;
	cairo_pattern_t* _tmp69_;
	cairo_pattern_t* _tmp70_;
	cairo_pattern_t* _tmp71_;
	NibblesViewPoint3D _tmp135_ = {0};
	gdouble _tmp136_ = 0.0;
	gdouble _tmp137_ = 0.0;
	NibblesViewPoint3D _tmp138_ = {0};
	gdouble _tmp139_ = 0.0;
	gdouble _tmp140_ = 0.0;
	NibblesViewPoint3D _tmp141_ = {0};
	gdouble _tmp142_ = 0.0;
	gdouble _tmp143_ = 0.0;
	gdouble _tmp144_;
	gdouble _tmp145_;
	gdouble _tmp146_;
	gdouble _tmp147_;
	gdouble _tmp148_;
	gdouble _tmp149_;
	gdouble _tmp150_;
	gdouble _tmp151_;
	NibblesViewPoint3D _tmp152_ = {0};
	gdouble _tmp153_ = 0.0;
	gdouble _tmp154_ = 0.0;
	NibblesViewPoint3D _tmp155_ = {0};
	gdouble _tmp156_ = 0.0;
	gdouble _tmp157_ = 0.0;
	NibblesViewPoint3D _tmp158_ = {0};
	gdouble _tmp159_ = 0.0;
	gdouble _tmp160_ = 0.0;
	gdouble _tmp161_;
	gdouble _tmp162_;
	gdouble _tmp163_;
	gdouble _tmp164_;
	gdouble _tmp165_;
	gdouble _tmp166_;
	NibblesViewPoint3D _tmp167_ = {0};
	gdouble _tmp168_ = 0.0;
	gdouble _tmp169_ = 0.0;
	NibblesViewPoint3D _tmp170_ = {0};
	gdouble _tmp171_ = 0.0;
	gdouble _tmp172_ = 0.0;
	NibblesViewPoint3D _tmp173_ = {0};
	gdouble _tmp174_ = 0.0;
	gdouble _tmp175_ = 0.0;
	gdouble _tmp176_;
	gdouble _tmp177_;
	gdouble _tmp178_;
	gdouble _tmp179_;
	gdouble _tmp180_;
	gdouble _tmp181_;
	gdouble _tmp182_;
	gdouble _tmp183_;
	NibblesViewPoint3D _tmp184_ = {0};
	gdouble _tmp185_ = 0.0;
	gdouble _tmp186_ = 0.0;
	NibblesViewPoint3D _tmp187_ = {0};
	gdouble _tmp188_ = 0.0;
	gdouble _tmp189_ = 0.0;
	NibblesViewPoint3D _tmp190_ = {0};
	gdouble _tmp191_ = 0.0;
	gdouble _tmp192_ = 0.0;
	gdouble _tmp193_;
	gdouble _tmp194_;
	gdouble _tmp195_;
	gdouble _tmp196_;
	gdouble _tmp197_;
	gdouble _tmp198_;
#line 1217 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 1217 "../src/nibbles-view.vala"
	g_return_if_fail (c != NULL);
#line 1217 "../src/nibbles-view.vala"
	g_return_if_fail (v != NULL);
#line 1223 "../src/nibbles-view.vala"
	_tmp0_.x = x + 0;
#line 1223 "../src/nibbles-view.vala"
	_tmp0_.y = y + 1;
#line 1223 "../src/nibbles-view.vala"
	_tmp0_.z = (gdouble) 1;
#line 1223 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp0_, &_tmp1_, &_tmp2_);
#line 1223 "../src/nibbles-view.vala"
	cx[0] = _tmp1_;
#line 1223 "../src/nibbles-view.vala"
	cy[0] = _tmp2_;
#line 1224 "../src/nibbles-view.vala"
	_tmp3_.x = x + 0;
#line 1224 "../src/nibbles-view.vala"
	_tmp3_.y = y + 1;
#line 1224 "../src/nibbles-view.vala"
	_tmp3_.z = (gdouble) 0;
#line 1224 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 1224 "../src/nibbles-view.vala"
	cx[1] = _tmp4_;
#line 1224 "../src/nibbles-view.vala"
	cy[1] = _tmp5_;
#line 1225 "../src/nibbles-view.vala"
	_tmp6_.x = x + 1;
#line 1225 "../src/nibbles-view.vala"
	_tmp6_.y = y + 1;
#line 1225 "../src/nibbles-view.vala"
	_tmp6_.z = (gdouble) 0;
#line 1225 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp6_, &_tmp7_, &_tmp8_);
#line 1225 "../src/nibbles-view.vala"
	cx[2] = _tmp7_;
#line 1225 "../src/nibbles-view.vala"
	cy[2] = _tmp8_;
#line 1226 "../src/nibbles-view.vala"
	_tmp9_ = cx[0];
#line 1226 "../src/nibbles-view.vala"
	_tmp10_ = cy[0];
#line 1226 "../src/nibbles-view.vala"
	cairo_move_to (c, _tmp9_, _tmp10_);
#line 1227 "../src/nibbles-view.vala"
	_tmp11_ = cx[0];
#line 1227 "../src/nibbles-view.vala"
	_tmp12_ = cy[0];
#line 1227 "../src/nibbles-view.vala"
	_tmp13_ = cx[1];
#line 1227 "../src/nibbles-view.vala"
	_tmp14_ = cy[1];
#line 1227 "../src/nibbles-view.vala"
	_tmp15_ = cx[2];
#line 1227 "../src/nibbles-view.vala"
	_tmp16_ = cy[2];
#line 1227 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp11_, _tmp12_, _tmp13_, _tmp14_, _tmp15_, _tmp16_);
#line 1228 "../src/nibbles-view.vala"
	_tmp17_.x = x + 1;
#line 1228 "../src/nibbles-view.vala"
	_tmp17_.y = y + 1;
#line 1228 "../src/nibbles-view.vala"
	_tmp17_.z = (gdouble) 0;
#line 1228 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp17_, &_tmp18_, &_tmp19_);
#line 1228 "../src/nibbles-view.vala"
	cx[0] = _tmp18_;
#line 1228 "../src/nibbles-view.vala"
	cy[0] = _tmp19_;
#line 1229 "../src/nibbles-view.vala"
	_tmp20_.x = x + 2;
#line 1229 "../src/nibbles-view.vala"
	_tmp20_.y = y + 1;
#line 1229 "../src/nibbles-view.vala"
	_tmp20_.z = (gdouble) 0;
#line 1229 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp20_, &_tmp21_, &_tmp22_);
#line 1229 "../src/nibbles-view.vala"
	cx[1] = _tmp21_;
#line 1229 "../src/nibbles-view.vala"
	cy[1] = _tmp22_;
#line 1230 "../src/nibbles-view.vala"
	_tmp23_.x = x + 2;
#line 1230 "../src/nibbles-view.vala"
	_tmp23_.y = y + 1;
#line 1230 "../src/nibbles-view.vala"
	_tmp23_.z = (gdouble) 1;
#line 1230 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp23_, &_tmp24_, &_tmp25_);
#line 1230 "../src/nibbles-view.vala"
	cx[2] = _tmp24_;
#line 1230 "../src/nibbles-view.vala"
	cy[2] = _tmp25_;
#line 1231 "../src/nibbles-view.vala"
	_tmp26_ = cx[0];
#line 1231 "../src/nibbles-view.vala"
	_tmp27_ = cy[0];
#line 1231 "../src/nibbles-view.vala"
	_tmp28_ = cx[1];
#line 1231 "../src/nibbles-view.vala"
	_tmp29_ = cy[1];
#line 1231 "../src/nibbles-view.vala"
	_tmp30_ = cx[2];
#line 1231 "../src/nibbles-view.vala"
	_tmp31_ = cy[2];
#line 1231 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp26_, _tmp27_, _tmp28_, _tmp29_, _tmp30_, _tmp31_);
#line 1232 "../src/nibbles-view.vala"
	_tmp32_.x = x + 2;
#line 1232 "../src/nibbles-view.vala"
	_tmp32_.y = y + 1;
#line 1232 "../src/nibbles-view.vala"
	_tmp32_.z = (gdouble) 1;
#line 1232 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp32_, &_tmp33_, &_tmp34_);
#line 1232 "../src/nibbles-view.vala"
	cx[0] = _tmp33_;
#line 1232 "../src/nibbles-view.vala"
	cy[0] = _tmp34_;
#line 1233 "../src/nibbles-view.vala"
	_tmp35_.x = x + 2;
#line 1233 "../src/nibbles-view.vala"
	_tmp35_.y = y + 1.0;
#line 1233 "../src/nibbles-view.vala"
	_tmp35_.z = (gdouble) 2;
#line 1233 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp35_, &_tmp36_, &_tmp37_);
#line 1233 "../src/nibbles-view.vala"
	cx[1] = _tmp36_;
#line 1233 "../src/nibbles-view.vala"
	cy[1] = _tmp37_;
#line 1234 "../src/nibbles-view.vala"
	_tmp38_.x = x + 1.0;
#line 1234 "../src/nibbles-view.vala"
	_tmp38_.y = y + 1;
#line 1234 "../src/nibbles-view.vala"
	_tmp38_.z = (gdouble) 2;
#line 1234 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp38_, &_tmp39_, &_tmp40_);
#line 1234 "../src/nibbles-view.vala"
	cx[2] = _tmp39_;
#line 1234 "../src/nibbles-view.vala"
	cy[2] = _tmp40_;
#line 1235 "../src/nibbles-view.vala"
	_tmp41_ = cx[0];
#line 1235 "../src/nibbles-view.vala"
	_tmp42_ = cy[0];
#line 1235 "../src/nibbles-view.vala"
	_tmp43_ = cx[1];
#line 1235 "../src/nibbles-view.vala"
	_tmp44_ = cy[1];
#line 1235 "../src/nibbles-view.vala"
	_tmp45_ = cx[2];
#line 1235 "../src/nibbles-view.vala"
	_tmp46_ = cy[2];
#line 1235 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp41_, _tmp42_, _tmp43_, _tmp44_, _tmp45_, _tmp46_);
#line 1236 "../src/nibbles-view.vala"
	_tmp47_.x = x + 1.0;
#line 1236 "../src/nibbles-view.vala"
	_tmp47_.y = y + 1;
#line 1236 "../src/nibbles-view.vala"
	_tmp47_.z = (gdouble) 2;
#line 1236 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp47_, &_tmp48_, &_tmp49_);
#line 1236 "../src/nibbles-view.vala"
	cx[0] = _tmp48_;
#line 1236 "../src/nibbles-view.vala"
	cy[0] = _tmp49_;
#line 1237 "../src/nibbles-view.vala"
	_tmp50_.x = x + 0;
#line 1237 "../src/nibbles-view.vala"
	_tmp50_.y = y + 1;
#line 1237 "../src/nibbles-view.vala"
	_tmp50_.z = (gdouble) 2;
#line 1237 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp50_, &_tmp51_, &_tmp52_);
#line 1237 "../src/nibbles-view.vala"
	cx[1] = _tmp51_;
#line 1237 "../src/nibbles-view.vala"
	cy[1] = _tmp52_;
#line 1238 "../src/nibbles-view.vala"
	_tmp53_.x = x + 0;
#line 1238 "../src/nibbles-view.vala"
	_tmp53_.y = y + 1;
#line 1238 "../src/nibbles-view.vala"
	_tmp53_.z = (gdouble) 1;
#line 1238 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp53_, &_tmp54_, &_tmp55_);
#line 1238 "../src/nibbles-view.vala"
	cx[2] = _tmp54_;
#line 1238 "../src/nibbles-view.vala"
	cy[2] = _tmp55_;
#line 1239 "../src/nibbles-view.vala"
	_tmp56_ = cx[0];
#line 1239 "../src/nibbles-view.vala"
	_tmp57_ = cy[0];
#line 1239 "../src/nibbles-view.vala"
	_tmp58_ = cx[1];
#line 1239 "../src/nibbles-view.vala"
	_tmp59_ = cy[1];
#line 1239 "../src/nibbles-view.vala"
	_tmp60_ = cx[2];
#line 1239 "../src/nibbles-view.vala"
	_tmp61_ = cy[2];
#line 1239 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp56_, _tmp57_, _tmp58_, _tmp59_, _tmp60_, _tmp61_);
#line 1241 "../src/nibbles-view.vala"
	_tmp62_.x = x + 1;
#line 1241 "../src/nibbles-view.vala"
	_tmp62_.y = y + 1.0;
#line 1241 "../src/nibbles-view.vala"
	_tmp62_.z = 1.5;
#line 1241 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp62_, &_tmp63_, &_tmp64_);
#line 1241 "../src/nibbles-view.vala"
	top_x = _tmp63_;
#line 1241 "../src/nibbles-view.vala"
	top_y = _tmp64_;
#line 1242 "../src/nibbles-view.vala"
	_tmp65_.x = x + 1;
#line 1242 "../src/nibbles-view.vala"
	_tmp65_.y = y + 1.0;
#line 1242 "../src/nibbles-view.vala"
	_tmp65_.z = 1.5;
#line 1242 "../src/nibbles-view.vala"
	_tmp66_.x = x + 1;
#line 1242 "../src/nibbles-view.vala"
	_tmp66_.y = y + 1.0;
#line 1242 "../src/nibbles-view.vala"
	_tmp66_.z = (gdouble) 0;
#line 1242 "../src/nibbles-view.vala"
	radius = nibbles_view_view3_d_2D_diff (v, &_tmp65_, &_tmp66_);
#line 1243 "../src/nibbles-view.vala"
	_tmp67_ = cairo_pattern_create_radial (top_x, top_y, radius, top_x, top_y, radius / 20.0);
#line 1243 "../src/nibbles-view.vala"
	pat2 = _tmp67_;
#line 1244 "../src/nibbles-view.vala"
	_tmp68_ = pat2;
#line 1244 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (_tmp68_, (gdouble) 0, (gdouble) 0, (gdouble) (1 / 10), (gdouble) 0);
#line 1245 "../src/nibbles-view.vala"
	_tmp69_ = pat2;
#line 1245 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (_tmp69_, (gdouble) 1, (gdouble) 0, (gdouble) 1, (gdouble) 0);
#line 1246 "../src/nibbles-view.vala"
	_tmp70_ = pat2;
#line 1246 "../src/nibbles-view.vala"
	cairo_pattern_add_color_stop_rgb (_tmp70_, (gdouble) 2, 0.5, (gdouble) 1, 0.5);
#line 1247 "../src/nibbles-view.vala"
	_tmp71_ = pat2;
#line 1247 "../src/nibbles-view.vala"
	cairo_set_source (c, _tmp71_);
#line 1248 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 9661 "nibbles-view.c"
	{
		gdouble _3D_radius_ = 0.0;
#line 1251 "../src/nibbles-view.vala"
		_3D_radius_ = 0.2;
#line 9666 "nibbles-view.c"
		{
			gboolean _tmp72_ = FALSE;
#line 1251 "../src/nibbles-view.vala"
			_tmp72_ = TRUE;
#line 1251 "../src/nibbles-view.vala"
			while (TRUE) {
#line 9673 "nibbles-view.c"
				NibblesViewPoint3D _tmp73_ = {0};
				gdouble _tmp74_ = 0.0;
				gdouble _tmp75_ = 0.0;
				NibblesViewPoint3D _tmp76_ = {0};
				gdouble _tmp77_ = 0.0;
				gdouble _tmp78_ = 0.0;
				NibblesViewPoint3D _tmp79_ = {0};
				gdouble _tmp80_ = 0.0;
				gdouble _tmp81_ = 0.0;
				gdouble _tmp82_;
				gdouble _tmp83_;
				gdouble _tmp84_;
				gdouble _tmp85_;
				gdouble _tmp86_;
				gdouble _tmp87_;
				gdouble _tmp88_;
				gdouble _tmp89_;
				NibblesViewPoint3D _tmp90_ = {0};
				gdouble _tmp91_ = 0.0;
				gdouble _tmp92_ = 0.0;
				NibblesViewPoint3D _tmp93_ = {0};
				gdouble _tmp94_ = 0.0;
				gdouble _tmp95_ = 0.0;
				NibblesViewPoint3D _tmp96_ = {0};
				gdouble _tmp97_ = 0.0;
				gdouble _tmp98_ = 0.0;
				gdouble _tmp99_;
				gdouble _tmp100_;
				gdouble _tmp101_;
				gdouble _tmp102_;
				gdouble _tmp103_;
				gdouble _tmp104_;
				NibblesViewPoint3D _tmp105_ = {0};
				gdouble _tmp106_ = 0.0;
				gdouble _tmp107_ = 0.0;
				NibblesViewPoint3D _tmp108_ = {0};
				gdouble _tmp109_ = 0.0;
				gdouble _tmp110_ = 0.0;
				NibblesViewPoint3D _tmp111_ = {0};
				gdouble _tmp112_ = 0.0;
				gdouble _tmp113_ = 0.0;
				gdouble _tmp114_;
				gdouble _tmp115_;
				gdouble _tmp116_;
				gdouble _tmp117_;
				gdouble _tmp118_;
				gdouble _tmp119_;
				NibblesViewPoint3D _tmp120_ = {0};
				gdouble _tmp121_ = 0.0;
				gdouble _tmp122_ = 0.0;
				NibblesViewPoint3D _tmp123_ = {0};
				gdouble _tmp124_ = 0.0;
				gdouble _tmp125_ = 0.0;
				NibblesViewPoint3D _tmp126_ = {0};
				gdouble _tmp127_ = 0.0;
				gdouble _tmp128_ = 0.0;
				gdouble _tmp129_;
				gdouble _tmp130_;
				gdouble _tmp131_;
				gdouble _tmp132_;
				gdouble _tmp133_;
				gdouble _tmp134_;
#line 1251 "../src/nibbles-view.vala"
				if (!_tmp72_) {
#line 1251 "../src/nibbles-view.vala"
					_3D_radius_ -= 0.01;
#line 9740 "nibbles-view.c"
				}
#line 1251 "../src/nibbles-view.vala"
				_tmp72_ = FALSE;
#line 1251 "../src/nibbles-view.vala"
				if (!(_3D_radius_ > 0.01)) {
#line 1251 "../src/nibbles-view.vala"
					break;
#line 9748 "nibbles-view.c"
				}
#line 1253 "../src/nibbles-view.vala"
				_tmp73_.x = x + (1 - _3D_radius_);
#line 1253 "../src/nibbles-view.vala"
				_tmp73_.y = y + 1.0;
#line 1253 "../src/nibbles-view.vala"
				_tmp73_.z = 1.75;
#line 1253 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp73_, &_tmp74_, &_tmp75_);
#line 1253 "../src/nibbles-view.vala"
				cx[0] = _tmp74_;
#line 1253 "../src/nibbles-view.vala"
				cy[0] = _tmp75_;
#line 1254 "../src/nibbles-view.vala"
				_tmp76_.x = x + (1 - _3D_radius_);
#line 1254 "../src/nibbles-view.vala"
				_tmp76_.y = y + (1 - _3D_radius_);
#line 1254 "../src/nibbles-view.vala"
				_tmp76_.z = 1.75;
#line 1254 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp76_, &_tmp77_, &_tmp78_);
#line 1254 "../src/nibbles-view.vala"
				cx[1] = _tmp77_;
#line 1254 "../src/nibbles-view.vala"
				cy[1] = _tmp78_;
#line 1255 "../src/nibbles-view.vala"
				_tmp79_.x = x + 1.00;
#line 1255 "../src/nibbles-view.vala"
				_tmp79_.y = y + (1 - _3D_radius_);
#line 1255 "../src/nibbles-view.vala"
				_tmp79_.z = 1.75;
#line 1255 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp79_, &_tmp80_, &_tmp81_);
#line 1255 "../src/nibbles-view.vala"
				cx[2] = _tmp80_;
#line 1255 "../src/nibbles-view.vala"
				cy[2] = _tmp81_;
#line 1256 "../src/nibbles-view.vala"
				_tmp82_ = cx[0];
#line 1256 "../src/nibbles-view.vala"
				_tmp83_ = cy[0];
#line 1256 "../src/nibbles-view.vala"
				cairo_move_to (c, _tmp82_, _tmp83_);
#line 1257 "../src/nibbles-view.vala"
				_tmp84_ = cx[0];
#line 1257 "../src/nibbles-view.vala"
				_tmp85_ = cy[0];
#line 1257 "../src/nibbles-view.vala"
				_tmp86_ = cx[1];
#line 1257 "../src/nibbles-view.vala"
				_tmp87_ = cy[1];
#line 1257 "../src/nibbles-view.vala"
				_tmp88_ = cx[2];
#line 1257 "../src/nibbles-view.vala"
				_tmp89_ = cy[2];
#line 1257 "../src/nibbles-view.vala"
				cairo_curve_to (c, _tmp84_, _tmp85_, _tmp86_, _tmp87_, _tmp88_, _tmp89_);
#line 1258 "../src/nibbles-view.vala"
				_tmp90_.x = x + 1.00;
#line 1258 "../src/nibbles-view.vala"
				_tmp90_.y = y + (1 - _3D_radius_);
#line 1258 "../src/nibbles-view.vala"
				_tmp90_.z = 1.75;
#line 1258 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp90_, &_tmp91_, &_tmp92_);
#line 1258 "../src/nibbles-view.vala"
				cx[0] = _tmp91_;
#line 1258 "../src/nibbles-view.vala"
				cy[0] = _tmp92_;
#line 1259 "../src/nibbles-view.vala"
				_tmp93_.x = x + (1 + _3D_radius_);
#line 1259 "../src/nibbles-view.vala"
				_tmp93_.y = y + (1 - _3D_radius_);
#line 1259 "../src/nibbles-view.vala"
				_tmp93_.z = 1.75;
#line 1259 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp93_, &_tmp94_, &_tmp95_);
#line 1259 "../src/nibbles-view.vala"
				cx[1] = _tmp94_;
#line 1259 "../src/nibbles-view.vala"
				cy[1] = _tmp95_;
#line 1260 "../src/nibbles-view.vala"
				_tmp96_.x = x + (1 + _3D_radius_);
#line 1260 "../src/nibbles-view.vala"
				_tmp96_.y = y + 1.0;
#line 1260 "../src/nibbles-view.vala"
				_tmp96_.z = 1.75;
#line 1260 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp96_, &_tmp97_, &_tmp98_);
#line 1260 "../src/nibbles-view.vala"
				cx[2] = _tmp97_;
#line 1260 "../src/nibbles-view.vala"
				cy[2] = _tmp98_;
#line 1261 "../src/nibbles-view.vala"
				_tmp99_ = cx[0];
#line 1261 "../src/nibbles-view.vala"
				_tmp100_ = cy[0];
#line 1261 "../src/nibbles-view.vala"
				_tmp101_ = cx[1];
#line 1261 "../src/nibbles-view.vala"
				_tmp102_ = cy[1];
#line 1261 "../src/nibbles-view.vala"
				_tmp103_ = cx[2];
#line 1261 "../src/nibbles-view.vala"
				_tmp104_ = cy[2];
#line 1261 "../src/nibbles-view.vala"
				cairo_curve_to (c, _tmp99_, _tmp100_, _tmp101_, _tmp102_, _tmp103_, _tmp104_);
#line 1262 "../src/nibbles-view.vala"
				_tmp105_.x = x + (1 + _3D_radius_);
#line 1262 "../src/nibbles-view.vala"
				_tmp105_.y = y + 1.0;
#line 1262 "../src/nibbles-view.vala"
				_tmp105_.z = 1.75;
#line 1262 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp105_, &_tmp106_, &_tmp107_);
#line 1262 "../src/nibbles-view.vala"
				cx[0] = _tmp106_;
#line 1262 "../src/nibbles-view.vala"
				cy[0] = _tmp107_;
#line 1263 "../src/nibbles-view.vala"
				_tmp108_.x = x + (1 + _3D_radius_);
#line 1263 "../src/nibbles-view.vala"
				_tmp108_.y = y + (1 + _3D_radius_);
#line 1263 "../src/nibbles-view.vala"
				_tmp108_.z = 1.75;
#line 1263 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp108_, &_tmp109_, &_tmp110_);
#line 1263 "../src/nibbles-view.vala"
				cx[1] = _tmp109_;
#line 1263 "../src/nibbles-view.vala"
				cy[1] = _tmp110_;
#line 1264 "../src/nibbles-view.vala"
				_tmp111_.x = x + 1;
#line 1264 "../src/nibbles-view.vala"
				_tmp111_.y = y + (1 + _3D_radius_);
#line 1264 "../src/nibbles-view.vala"
				_tmp111_.z = 1.75;
#line 1264 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp111_, &_tmp112_, &_tmp113_);
#line 1264 "../src/nibbles-view.vala"
				cx[2] = _tmp112_;
#line 1264 "../src/nibbles-view.vala"
				cy[2] = _tmp113_;
#line 1265 "../src/nibbles-view.vala"
				_tmp114_ = cx[0];
#line 1265 "../src/nibbles-view.vala"
				_tmp115_ = cy[0];
#line 1265 "../src/nibbles-view.vala"
				_tmp116_ = cx[1];
#line 1265 "../src/nibbles-view.vala"
				_tmp117_ = cy[1];
#line 1265 "../src/nibbles-view.vala"
				_tmp118_ = cx[2];
#line 1265 "../src/nibbles-view.vala"
				_tmp119_ = cy[2];
#line 1265 "../src/nibbles-view.vala"
				cairo_curve_to (c, _tmp114_, _tmp115_, _tmp116_, _tmp117_, _tmp118_, _tmp119_);
#line 1266 "../src/nibbles-view.vala"
				_tmp120_.x = x + 1;
#line 1266 "../src/nibbles-view.vala"
				_tmp120_.y = y + (1 + _3D_radius_);
#line 1266 "../src/nibbles-view.vala"
				_tmp120_.z = 1.75;
#line 1266 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp120_, &_tmp121_, &_tmp122_);
#line 1266 "../src/nibbles-view.vala"
				cx[0] = _tmp121_;
#line 1266 "../src/nibbles-view.vala"
				cy[0] = _tmp122_;
#line 1267 "../src/nibbles-view.vala"
				_tmp123_.x = x + (1 - _3D_radius_);
#line 1267 "../src/nibbles-view.vala"
				_tmp123_.y = y + (1 + _3D_radius_);
#line 1267 "../src/nibbles-view.vala"
				_tmp123_.z = 1.75;
#line 1267 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp123_, &_tmp124_, &_tmp125_);
#line 1267 "../src/nibbles-view.vala"
				cx[1] = _tmp124_;
#line 1267 "../src/nibbles-view.vala"
				cy[1] = _tmp125_;
#line 1268 "../src/nibbles-view.vala"
				_tmp126_.x = x + (1 - _3D_radius_);
#line 1268 "../src/nibbles-view.vala"
				_tmp126_.y = y + 1.0;
#line 1268 "../src/nibbles-view.vala"
				_tmp126_.z = 1.75;
#line 1268 "../src/nibbles-view.vala"
				nibbles_view_view3_d_to_view_plain (v, &_tmp126_, &_tmp127_, &_tmp128_);
#line 1268 "../src/nibbles-view.vala"
				cx[2] = _tmp127_;
#line 1268 "../src/nibbles-view.vala"
				cy[2] = _tmp128_;
#line 1269 "../src/nibbles-view.vala"
				_tmp129_ = cx[0];
#line 1269 "../src/nibbles-view.vala"
				_tmp130_ = cy[0];
#line 1269 "../src/nibbles-view.vala"
				_tmp131_ = cx[1];
#line 1269 "../src/nibbles-view.vala"
				_tmp132_ = cy[1];
#line 1269 "../src/nibbles-view.vala"
				_tmp133_ = cx[2];
#line 1269 "../src/nibbles-view.vala"
				_tmp134_ = cy[2];
#line 1269 "../src/nibbles-view.vala"
				cairo_curve_to (c, _tmp129_, _tmp130_, _tmp131_, _tmp132_, _tmp133_, _tmp134_);
#line 1270 "../src/nibbles-view.vala"
				cairo_set_source_rgb (c, 0.4, 0.8 - ((0.2 - _3D_radius_) * 3), 0.4 - ((0.2 - _3D_radius_) * 2));
#line 1271 "../src/nibbles-view.vala"
				cairo_fill (c);
#line 9960 "nibbles-view.c"
			}
		}
	}
#line 1275 "../src/nibbles-view.vala"
	_tmp135_.x = x + 1.0;
#line 1275 "../src/nibbles-view.vala"
	_tmp135_.y = y + 1.0;
#line 1275 "../src/nibbles-view.vala"
	_tmp135_.z = 1.75;
#line 1275 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp135_, &_tmp136_, &_tmp137_);
#line 1275 "../src/nibbles-view.vala"
	cx[0] = _tmp136_;
#line 1275 "../src/nibbles-view.vala"
	cy[0] = _tmp137_;
#line 1276 "../src/nibbles-view.vala"
	_tmp138_.x = (x + 1.0) - 0.5;
#line 1276 "../src/nibbles-view.vala"
	_tmp138_.y = y + 1.0;
#line 1276 "../src/nibbles-view.vala"
	_tmp138_.z = 1.75;
#line 1276 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp138_, &_tmp139_, &_tmp140_);
#line 1276 "../src/nibbles-view.vala"
	cx[1] = _tmp139_;
#line 1276 "../src/nibbles-view.vala"
	cy[1] = _tmp140_;
#line 1277 "../src/nibbles-view.vala"
	_tmp141_.x = (x + 1.0) - 0.5;
#line 1277 "../src/nibbles-view.vala"
	_tmp141_.y = (y + 1.0) - 0.5;
#line 1277 "../src/nibbles-view.vala"
	_tmp141_.z = 1.75;
#line 1277 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp141_, &_tmp142_, &_tmp143_);
#line 1277 "../src/nibbles-view.vala"
	cx[2] = _tmp142_;
#line 1277 "../src/nibbles-view.vala"
	cy[2] = _tmp143_;
#line 1278 "../src/nibbles-view.vala"
	_tmp144_ = cx[0];
#line 1278 "../src/nibbles-view.vala"
	_tmp145_ = cy[0];
#line 1278 "../src/nibbles-view.vala"
	cairo_move_to (c, _tmp144_, _tmp145_);
#line 1279 "../src/nibbles-view.vala"
	_tmp146_ = cx[0];
#line 1279 "../src/nibbles-view.vala"
	_tmp147_ = cy[0];
#line 1279 "../src/nibbles-view.vala"
	_tmp148_ = cx[1];
#line 1279 "../src/nibbles-view.vala"
	_tmp149_ = cy[1];
#line 1279 "../src/nibbles-view.vala"
	_tmp150_ = cx[2];
#line 1279 "../src/nibbles-view.vala"
	_tmp151_ = cy[2];
#line 1279 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp146_, _tmp147_, _tmp148_, _tmp149_, _tmp150_, _tmp151_);
#line 1280 "../src/nibbles-view.vala"
	_tmp152_.x = (x + 1.0) - 0.5;
#line 1280 "../src/nibbles-view.vala"
	_tmp152_.y = (y + 1.0) - 0.5;
#line 1280 "../src/nibbles-view.vala"
	_tmp152_.z = 1.75;
#line 1280 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp152_, &_tmp153_, &_tmp154_);
#line 1280 "../src/nibbles-view.vala"
	cx[0] = _tmp153_;
#line 1280 "../src/nibbles-view.vala"
	cy[0] = _tmp154_;
#line 1281 "../src/nibbles-view.vala"
	_tmp155_.x = x + 1.0;
#line 1281 "../src/nibbles-view.vala"
	_tmp155_.y = (y + 1.0) - 0.5;
#line 1281 "../src/nibbles-view.vala"
	_tmp155_.z = 1.75;
#line 1281 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp155_, &_tmp156_, &_tmp157_);
#line 1281 "../src/nibbles-view.vala"
	cx[1] = _tmp156_;
#line 1281 "../src/nibbles-view.vala"
	cy[1] = _tmp157_;
#line 1282 "../src/nibbles-view.vala"
	_tmp158_.x = x + 1.0;
#line 1282 "../src/nibbles-view.vala"
	_tmp158_.y = y + 1.0;
#line 1282 "../src/nibbles-view.vala"
	_tmp158_.z = 1.75;
#line 1282 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp158_, &_tmp159_, &_tmp160_);
#line 1282 "../src/nibbles-view.vala"
	cx[2] = _tmp159_;
#line 1282 "../src/nibbles-view.vala"
	cy[2] = _tmp160_;
#line 1283 "../src/nibbles-view.vala"
	_tmp161_ = cx[0];
#line 1283 "../src/nibbles-view.vala"
	_tmp162_ = cy[0];
#line 1283 "../src/nibbles-view.vala"
	_tmp163_ = cx[1];
#line 1283 "../src/nibbles-view.vala"
	_tmp164_ = cy[1];
#line 1283 "../src/nibbles-view.vala"
	_tmp165_ = cx[2];
#line 1283 "../src/nibbles-view.vala"
	_tmp166_ = cy[2];
#line 1283 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp161_, _tmp162_, _tmp163_, _tmp164_, _tmp165_, _tmp166_);
#line 1284 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, 0.25, 0.5, (gdouble) 0);
#line 1285 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1287 "../src/nibbles-view.vala"
	_tmp167_.x = x + 1.0;
#line 1287 "../src/nibbles-view.vala"
	_tmp167_.y = y + 1.0;
#line 1287 "../src/nibbles-view.vala"
	_tmp167_.z = 1.75;
#line 1287 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp167_, &_tmp168_, &_tmp169_);
#line 1287 "../src/nibbles-view.vala"
	cx[0] = _tmp168_;
#line 1287 "../src/nibbles-view.vala"
	cy[0] = _tmp169_;
#line 1288 "../src/nibbles-view.vala"
	_tmp170_.x = (x + 1.0) + 0.5;
#line 1288 "../src/nibbles-view.vala"
	_tmp170_.y = y + 1.0;
#line 1288 "../src/nibbles-view.vala"
	_tmp170_.z = 1.75;
#line 1288 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp170_, &_tmp171_, &_tmp172_);
#line 1288 "../src/nibbles-view.vala"
	cx[1] = _tmp171_;
#line 1288 "../src/nibbles-view.vala"
	cy[1] = _tmp172_;
#line 1289 "../src/nibbles-view.vala"
	_tmp173_.x = (x + 1.0) + 0.5;
#line 1289 "../src/nibbles-view.vala"
	_tmp173_.y = (y + 1.0) - 0.5;
#line 1289 "../src/nibbles-view.vala"
	_tmp173_.z = 1.75;
#line 1289 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp173_, &_tmp174_, &_tmp175_);
#line 1289 "../src/nibbles-view.vala"
	cx[2] = _tmp174_;
#line 1289 "../src/nibbles-view.vala"
	cy[2] = _tmp175_;
#line 1290 "../src/nibbles-view.vala"
	_tmp176_ = cx[0];
#line 1290 "../src/nibbles-view.vala"
	_tmp177_ = cy[0];
#line 1290 "../src/nibbles-view.vala"
	cairo_move_to (c, _tmp176_, _tmp177_);
#line 1291 "../src/nibbles-view.vala"
	_tmp178_ = cx[0];
#line 1291 "../src/nibbles-view.vala"
	_tmp179_ = cy[0];
#line 1291 "../src/nibbles-view.vala"
	_tmp180_ = cx[1];
#line 1291 "../src/nibbles-view.vala"
	_tmp181_ = cy[1];
#line 1291 "../src/nibbles-view.vala"
	_tmp182_ = cx[2];
#line 1291 "../src/nibbles-view.vala"
	_tmp183_ = cy[2];
#line 1291 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp178_, _tmp179_, _tmp180_, _tmp181_, _tmp182_, _tmp183_);
#line 1292 "../src/nibbles-view.vala"
	_tmp184_.x = (x + 1.0) + 0.5;
#line 1292 "../src/nibbles-view.vala"
	_tmp184_.y = (y + 1.0) - 0.5;
#line 1292 "../src/nibbles-view.vala"
	_tmp184_.z = 1.75;
#line 1292 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp184_, &_tmp185_, &_tmp186_);
#line 1292 "../src/nibbles-view.vala"
	cx[0] = _tmp185_;
#line 1292 "../src/nibbles-view.vala"
	cy[0] = _tmp186_;
#line 1293 "../src/nibbles-view.vala"
	_tmp187_.x = x + 1.0;
#line 1293 "../src/nibbles-view.vala"
	_tmp187_.y = (y + 1.0) - 0.5;
#line 1293 "../src/nibbles-view.vala"
	_tmp187_.z = 1.75;
#line 1293 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp187_, &_tmp188_, &_tmp189_);
#line 1293 "../src/nibbles-view.vala"
	cx[1] = _tmp188_;
#line 1293 "../src/nibbles-view.vala"
	cy[1] = _tmp189_;
#line 1294 "../src/nibbles-view.vala"
	_tmp190_.x = x + 1.0;
#line 1294 "../src/nibbles-view.vala"
	_tmp190_.y = y + 1.0;
#line 1294 "../src/nibbles-view.vala"
	_tmp190_.z = 1.75;
#line 1294 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (v, &_tmp190_, &_tmp191_, &_tmp192_);
#line 1294 "../src/nibbles-view.vala"
	cx[2] = _tmp191_;
#line 1294 "../src/nibbles-view.vala"
	cy[2] = _tmp192_;
#line 1295 "../src/nibbles-view.vala"
	_tmp193_ = cx[0];
#line 1295 "../src/nibbles-view.vala"
	_tmp194_ = cy[0];
#line 1295 "../src/nibbles-view.vala"
	_tmp195_ = cx[1];
#line 1295 "../src/nibbles-view.vala"
	_tmp196_ = cy[1];
#line 1295 "../src/nibbles-view.vala"
	_tmp197_ = cx[2];
#line 1295 "../src/nibbles-view.vala"
	_tmp198_ = cy[2];
#line 1295 "../src/nibbles-view.vala"
	cairo_curve_to (c, _tmp193_, _tmp194_, _tmp195_, _tmp196_, _tmp197_, _tmp198_);
#line 1296 "../src/nibbles-view.vala"
	cairo_set_source_rgb (c, (gdouble) 0, 0.5, 0.25);
#line 1297 "../src/nibbles-view.vala"
	cairo_fill (c);
#line 1217 "../src/nibbles-view.vala"
	_cairo_pattern_destroy0 (pat2);
#line 10186 "nibbles-view.c"
}

static void
nibbles_view_draw_wall_segment (NibblesView* self,
                                gint i,
                                cairo_t* C,
                                gint x,
                                gint y,
                                gint x_size,
                                gint y_size)
{
	gint x_s13 = 0;
	gint x_remainder = 0;
	gint y_s13 = 0;
	gint y_remainder = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	gboolean _tmp36_ = FALSE;
	gboolean _tmp37_ = FALSE;
#line 1300 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 1300 "../src/nibbles-view.vala"
	g_return_if_fail (C != NULL);
#line 1303 "../src/nibbles-view.vala"
	x_s13 = x_size / 3;
#line 1304 "../src/nibbles-view.vala"
	x_remainder = x_size - (x_s13 * 3);
#line 1305 "../src/nibbles-view.vala"
	y_s13 = y_size / 3;
#line 1306 "../src/nibbles-view.vala"
	y_remainder = y_size - (y_s13 * 3);
#line 1307 "../src/nibbles-view.vala"
	if (i >= ((gint) 'b')) {
#line 1307 "../src/nibbles-view.vala"
		_tmp0_ = i <= ((gint) 'l');
#line 10243 "nibbles-view.c"
	} else {
#line 1307 "../src/nibbles-view.vala"
		_tmp0_ = FALSE;
#line 10247 "nibbles-view.c"
	}
#line 1307 "../src/nibbles-view.vala"
	if (_tmp0_) {
#line 10251 "nibbles-view.c"
		gint _tmp1_ = 0;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
#line 1310 "../src/nibbles-view.vala"
		if (x_remainder == 2) {
#line 1310 "../src/nibbles-view.vala"
			_tmp1_ = (x_s13 + x) + x_remainder;
#line 10260 "nibbles-view.c"
		} else {
#line 1310 "../src/nibbles-view.vala"
			_tmp1_ = x_s13 + x;
#line 10264 "nibbles-view.c"
		}
#line 1311 "../src/nibbles-view.vala"
		if (y_remainder == 2) {
#line 1311 "../src/nibbles-view.vala"
			_tmp2_ = (y_s13 + y) + y_remainder;
#line 10270 "nibbles-view.c"
		} else {
#line 1311 "../src/nibbles-view.vala"
			_tmp2_ = y_s13 + y;
#line 10274 "nibbles-view.c"
		}
#line 1312 "../src/nibbles-view.vala"
		if (x_remainder == 2) {
#line 1312 "../src/nibbles-view.vala"
			_tmp3_ = x_s13;
#line 10280 "nibbles-view.c"
		} else {
#line 1312 "../src/nibbles-view.vala"
			_tmp3_ = x_s13 + x_remainder;
#line 10284 "nibbles-view.c"
		}
#line 1313 "../src/nibbles-view.vala"
		if (y_remainder == 2) {
#line 1313 "../src/nibbles-view.vala"
			_tmp4_ = y_s13;
#line 10290 "nibbles-view.c"
		} else {
#line 1313 "../src/nibbles-view.vala"
			_tmp4_ = y_s13 + y_remainder;
#line 10294 "nibbles-view.c"
		}
#line 1310 "../src/nibbles-view.vala"
		cairo_rectangle (C, (gdouble) _tmp1_, (gdouble) _tmp2_, (gdouble) _tmp3_, (gdouble) _tmp4_);
#line 1314 "../src/nibbles-view.vala"
		cairo_set_source_rgb (C, 0.5, 0.5, 0.5);
#line 1315 "../src/nibbles-view.vala"
		cairo_fill (C);
#line 10302 "nibbles-view.c"
	}
#line 1317 "../src/nibbles-view.vala"
	if (i == ((gint) 'b')) {
#line 1317 "../src/nibbles-view.vala"
		_tmp10_ = TRUE;
#line 10308 "nibbles-view.c"
	} else {
#line 1317 "../src/nibbles-view.vala"
		_tmp10_ = i == ((gint) 'd');
#line 10312 "nibbles-view.c"
	}
#line 1317 "../src/nibbles-view.vala"
	if (_tmp10_) {
#line 1317 "../src/nibbles-view.vala"
		_tmp9_ = TRUE;
#line 10318 "nibbles-view.c"
	} else {
#line 1317 "../src/nibbles-view.vala"
		_tmp9_ = i == ((gint) 'e');
#line 10322 "nibbles-view.c"
	}
#line 1317 "../src/nibbles-view.vala"
	if (_tmp9_) {
#line 1317 "../src/nibbles-view.vala"
		_tmp8_ = TRUE;
#line 10328 "nibbles-view.c"
	} else {
#line 1317 "../src/nibbles-view.vala"
		_tmp8_ = i == ((gint) 'h');
#line 10332 "nibbles-view.c"
	}
#line 1317 "../src/nibbles-view.vala"
	if (_tmp8_) {
#line 1317 "../src/nibbles-view.vala"
		_tmp7_ = TRUE;
#line 10338 "nibbles-view.c"
	} else {
#line 1317 "../src/nibbles-view.vala"
		_tmp7_ = i == ((gint) 'i');
#line 10342 "nibbles-view.c"
	}
#line 1317 "../src/nibbles-view.vala"
	if (_tmp7_) {
#line 1317 "../src/nibbles-view.vala"
		_tmp6_ = TRUE;
#line 10348 "nibbles-view.c"
	} else {
#line 1317 "../src/nibbles-view.vala"
		_tmp6_ = i == ((gint) 'j');
#line 10352 "nibbles-view.c"
	}
#line 1317 "../src/nibbles-view.vala"
	if (_tmp6_) {
#line 1317 "../src/nibbles-view.vala"
		_tmp5_ = TRUE;
#line 10358 "nibbles-view.c"
	} else {
#line 1317 "../src/nibbles-view.vala"
		_tmp5_ = i == ((gint) 'l');
#line 10362 "nibbles-view.c"
	}
#line 1317 "../src/nibbles-view.vala"
	if (_tmp5_) {
#line 10366 "nibbles-view.c"
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
#line 1320 "../src/nibbles-view.vala"
		if (x_remainder == 2) {
#line 1320 "../src/nibbles-view.vala"
			_tmp11_ = (x_s13 + x) + x_remainder;
#line 10374 "nibbles-view.c"
		} else {
#line 1320 "../src/nibbles-view.vala"
			_tmp11_ = x_s13 + x;
#line 10378 "nibbles-view.c"
		}
#line 1322 "../src/nibbles-view.vala"
		if (x_remainder == 2) {
#line 1322 "../src/nibbles-view.vala"
			_tmp12_ = x_s13;
#line 10384 "nibbles-view.c"
		} else {
#line 1322 "../src/nibbles-view.vala"
			_tmp12_ = x_s13 + x_remainder;
#line 10388 "nibbles-view.c"
		}
#line 1323 "../src/nibbles-view.vala"
		if (y_remainder == 2) {
#line 1323 "../src/nibbles-view.vala"
			_tmp13_ = y_s13 + y_remainder;
#line 10394 "nibbles-view.c"
		} else {
#line 1323 "../src/nibbles-view.vala"
			_tmp13_ = y_s13;
#line 10398 "nibbles-view.c"
		}
#line 1320 "../src/nibbles-view.vala"
		cairo_rectangle (C, (gdouble) _tmp11_, (gdouble) y, (gdouble) _tmp12_, (gdouble) _tmp13_);
#line 1324 "../src/nibbles-view.vala"
		cairo_set_source_rgb (C, 0.5, 0.5, 0.5);
#line 1325 "../src/nibbles-view.vala"
		cairo_fill (C);
#line 10406 "nibbles-view.c"
	}
#line 1327 "../src/nibbles-view.vala"
	if (i == ((gint) 'c')) {
#line 1327 "../src/nibbles-view.vala"
		_tmp19_ = TRUE;
#line 10412 "nibbles-view.c"
	} else {
#line 1327 "../src/nibbles-view.vala"
		_tmp19_ = i == ((gint) 'd');
#line 10416 "nibbles-view.c"
	}
#line 1327 "../src/nibbles-view.vala"
	if (_tmp19_) {
#line 1327 "../src/nibbles-view.vala"
		_tmp18_ = TRUE;
#line 10422 "nibbles-view.c"
	} else {
#line 1327 "../src/nibbles-view.vala"
		_tmp18_ = i == ((gint) 'f');
#line 10426 "nibbles-view.c"
	}
#line 1327 "../src/nibbles-view.vala"
	if (_tmp18_) {
#line 1327 "../src/nibbles-view.vala"
		_tmp17_ = TRUE;
#line 10432 "nibbles-view.c"
	} else {
#line 1327 "../src/nibbles-view.vala"
		_tmp17_ = i == ((gint) 'h');
#line 10436 "nibbles-view.c"
	}
#line 1327 "../src/nibbles-view.vala"
	if (_tmp17_) {
#line 1327 "../src/nibbles-view.vala"
		_tmp16_ = TRUE;
#line 10442 "nibbles-view.c"
	} else {
#line 1327 "../src/nibbles-view.vala"
		_tmp16_ = i == ((gint) 'i');
#line 10446 "nibbles-view.c"
	}
#line 1327 "../src/nibbles-view.vala"
	if (_tmp16_) {
#line 1327 "../src/nibbles-view.vala"
		_tmp15_ = TRUE;
#line 10452 "nibbles-view.c"
	} else {
#line 1327 "../src/nibbles-view.vala"
		_tmp15_ = i == ((gint) 'k');
#line 10456 "nibbles-view.c"
	}
#line 1327 "../src/nibbles-view.vala"
	if (_tmp15_) {
#line 1327 "../src/nibbles-view.vala"
		_tmp14_ = TRUE;
#line 10462 "nibbles-view.c"
	} else {
#line 1327 "../src/nibbles-view.vala"
		_tmp14_ = i == ((gint) 'l');
#line 10466 "nibbles-view.c"
	}
#line 1327 "../src/nibbles-view.vala"
	if (_tmp14_) {
#line 10470 "nibbles-view.c"
		gint _tmp20_ = 0;
		gint _tmp21_ = 0;
		gint _tmp22_ = 0;
#line 1331 "../src/nibbles-view.vala"
		if (y_remainder == 2) {
#line 1331 "../src/nibbles-view.vala"
			_tmp20_ = (y_s13 + y_remainder) + y;
#line 10478 "nibbles-view.c"
		} else {
#line 1331 "../src/nibbles-view.vala"
			_tmp20_ = y_s13 + y;
#line 10482 "nibbles-view.c"
		}
#line 1332 "../src/nibbles-view.vala"
		if (x_remainder == 2) {
#line 1332 "../src/nibbles-view.vala"
			_tmp21_ = x_s13 + x_remainder;
#line 10488 "nibbles-view.c"
		} else {
#line 1332 "../src/nibbles-view.vala"
			_tmp21_ = x_s13;
#line 10492 "nibbles-view.c"
		}
#line 1333 "../src/nibbles-view.vala"
		if (y_remainder == 2) {
#line 1333 "../src/nibbles-view.vala"
			_tmp22_ = y_s13;
#line 10498 "nibbles-view.c"
		} else {
#line 1333 "../src/nibbles-view.vala"
			_tmp22_ = y_s13 + y_remainder;
#line 10502 "nibbles-view.c"
		}
#line 1330 "../src/nibbles-view.vala"
		cairo_rectangle (C, (gdouble) (((x_s13 + x_s13) + x_remainder) + x), (gdouble) _tmp20_, (gdouble) _tmp21_, (gdouble) _tmp22_);
#line 1334 "../src/nibbles-view.vala"
		cairo_set_source_rgb (C, 0.5, 0.5, 0.5);
#line 1335 "../src/nibbles-view.vala"
		cairo_fill (C);
#line 10510 "nibbles-view.c"
	}
#line 1337 "../src/nibbles-view.vala"
	if (i == ((gint) 'b')) {
#line 1337 "../src/nibbles-view.vala"
		_tmp28_ = TRUE;
#line 10516 "nibbles-view.c"
	} else {
#line 1337 "../src/nibbles-view.vala"
		_tmp28_ = i == ((gint) 'f');
#line 10520 "nibbles-view.c"
	}
#line 1337 "../src/nibbles-view.vala"
	if (_tmp28_) {
#line 1337 "../src/nibbles-view.vala"
		_tmp27_ = TRUE;
#line 10526 "nibbles-view.c"
	} else {
#line 1337 "../src/nibbles-view.vala"
		_tmp27_ = i == ((gint) 'g');
#line 10530 "nibbles-view.c"
	}
#line 1337 "../src/nibbles-view.vala"
	if (_tmp27_) {
#line 1337 "../src/nibbles-view.vala"
		_tmp26_ = TRUE;
#line 10536 "nibbles-view.c"
	} else {
#line 1337 "../src/nibbles-view.vala"
		_tmp26_ = i == ((gint) 'i');
#line 10540 "nibbles-view.c"
	}
#line 1337 "../src/nibbles-view.vala"
	if (_tmp26_) {
#line 1337 "../src/nibbles-view.vala"
		_tmp25_ = TRUE;
#line 10546 "nibbles-view.c"
	} else {
#line 1337 "../src/nibbles-view.vala"
		_tmp25_ = i == ((gint) 'j');
#line 10550 "nibbles-view.c"
	}
#line 1337 "../src/nibbles-view.vala"
	if (_tmp25_) {
#line 1337 "../src/nibbles-view.vala"
		_tmp24_ = TRUE;
#line 10556 "nibbles-view.c"
	} else {
#line 1337 "../src/nibbles-view.vala"
		_tmp24_ = i == ((gint) 'k');
#line 10560 "nibbles-view.c"
	}
#line 1337 "../src/nibbles-view.vala"
	if (_tmp24_) {
#line 1337 "../src/nibbles-view.vala"
		_tmp23_ = TRUE;
#line 10566 "nibbles-view.c"
	} else {
#line 1337 "../src/nibbles-view.vala"
		_tmp23_ = i == ((gint) 'l');
#line 10570 "nibbles-view.c"
	}
#line 1337 "../src/nibbles-view.vala"
	if (_tmp23_) {
#line 10574 "nibbles-view.c"
		gint _tmp29_ = 0;
		gint _tmp30_ = 0;
		gint _tmp31_ = 0;
#line 1340 "../src/nibbles-view.vala"
		if (x_remainder == 2) {
#line 1340 "../src/nibbles-view.vala"
			_tmp29_ = (x_s13 + x) + x_remainder;
#line 10582 "nibbles-view.c"
		} else {
#line 1340 "../src/nibbles-view.vala"
			_tmp29_ = x_s13 + x;
#line 10586 "nibbles-view.c"
		}
#line 1342 "../src/nibbles-view.vala"
		if (x_remainder == 2) {
#line 1342 "../src/nibbles-view.vala"
			_tmp30_ = x_s13;
#line 10592 "nibbles-view.c"
		} else {
#line 1342 "../src/nibbles-view.vala"
			_tmp30_ = x_s13 + x_remainder;
#line 10596 "nibbles-view.c"
		}
#line 1343 "../src/nibbles-view.vala"
		if (y_remainder == 2) {
#line 1343 "../src/nibbles-view.vala"
			_tmp31_ = y_s13 + y_remainder;
#line 10602 "nibbles-view.c"
		} else {
#line 1343 "../src/nibbles-view.vala"
			_tmp31_ = y_s13;
#line 10606 "nibbles-view.c"
		}
#line 1340 "../src/nibbles-view.vala"
		cairo_rectangle (C, (gdouble) _tmp29_, (gdouble) (((y_s13 + y_s13) + y_remainder) + y), (gdouble) _tmp30_, (gdouble) _tmp31_);
#line 1344 "../src/nibbles-view.vala"
		cairo_set_source_rgb (C, 0.5, 0.5, 0.5);
#line 1345 "../src/nibbles-view.vala"
		cairo_fill (C);
#line 10614 "nibbles-view.c"
	}
#line 1347 "../src/nibbles-view.vala"
	if (i == ((gint) 'c')) {
#line 1347 "../src/nibbles-view.vala"
		_tmp37_ = TRUE;
#line 10620 "nibbles-view.c"
	} else {
#line 1347 "../src/nibbles-view.vala"
		_tmp37_ = i == ((gint) 'e');
#line 10624 "nibbles-view.c"
	}
#line 1347 "../src/nibbles-view.vala"
	if (_tmp37_) {
#line 1347 "../src/nibbles-view.vala"
		_tmp36_ = TRUE;
#line 10630 "nibbles-view.c"
	} else {
#line 1347 "../src/nibbles-view.vala"
		_tmp36_ = i == ((gint) 'g');
#line 10634 "nibbles-view.c"
	}
#line 1347 "../src/nibbles-view.vala"
	if (_tmp36_) {
#line 1347 "../src/nibbles-view.vala"
		_tmp35_ = TRUE;
#line 10640 "nibbles-view.c"
	} else {
#line 1347 "../src/nibbles-view.vala"
		_tmp35_ = i == ((gint) 'h');
#line 10644 "nibbles-view.c"
	}
#line 1347 "../src/nibbles-view.vala"
	if (_tmp35_) {
#line 1347 "../src/nibbles-view.vala"
		_tmp34_ = TRUE;
#line 10650 "nibbles-view.c"
	} else {
#line 1347 "../src/nibbles-view.vala"
		_tmp34_ = i == ((gint) 'j');
#line 10654 "nibbles-view.c"
	}
#line 1347 "../src/nibbles-view.vala"
	if (_tmp34_) {
#line 1347 "../src/nibbles-view.vala"
		_tmp33_ = TRUE;
#line 10660 "nibbles-view.c"
	} else {
#line 1347 "../src/nibbles-view.vala"
		_tmp33_ = i == ((gint) 'k');
#line 10664 "nibbles-view.c"
	}
#line 1347 "../src/nibbles-view.vala"
	if (_tmp33_) {
#line 1347 "../src/nibbles-view.vala"
		_tmp32_ = TRUE;
#line 10670 "nibbles-view.c"
	} else {
#line 1347 "../src/nibbles-view.vala"
		_tmp32_ = i == ((gint) 'l');
#line 10674 "nibbles-view.c"
	}
#line 1347 "../src/nibbles-view.vala"
	if (_tmp32_) {
#line 10678 "nibbles-view.c"
		gint _tmp38_ = 0;
		gint _tmp39_ = 0;
		gint _tmp40_ = 0;
#line 1351 "../src/nibbles-view.vala"
		if (y_remainder == 2) {
#line 1351 "../src/nibbles-view.vala"
			_tmp38_ = (y_s13 + y) + y_remainder;
#line 10686 "nibbles-view.c"
		} else {
#line 1351 "../src/nibbles-view.vala"
			_tmp38_ = y_s13 + y;
#line 10690 "nibbles-view.c"
		}
#line 1352 "../src/nibbles-view.vala"
		if (x_remainder == 2) {
#line 1352 "../src/nibbles-view.vala"
			_tmp39_ = x_s13 + x_remainder;
#line 10696 "nibbles-view.c"
		} else {
#line 1352 "../src/nibbles-view.vala"
			_tmp39_ = x_s13;
#line 10700 "nibbles-view.c"
		}
#line 1353 "../src/nibbles-view.vala"
		if (y_remainder == 2) {
#line 1353 "../src/nibbles-view.vala"
			_tmp40_ = y_s13;
#line 10706 "nibbles-view.c"
		} else {
#line 1353 "../src/nibbles-view.vala"
			_tmp40_ = y_s13 + y_remainder;
#line 10710 "nibbles-view.c"
		}
#line 1350 "../src/nibbles-view.vala"
		cairo_rectangle (C, (gdouble) x, (gdouble) _tmp38_, (gdouble) _tmp39_, (gdouble) _tmp40_);
#line 1354 "../src/nibbles-view.vala"
		cairo_set_source_rgb (C, 0.5, 0.5, 0.5);
#line 1355 "../src/nibbles-view.vala"
		cairo_fill (C);
#line 10718 "nibbles-view.c"
	}
}

static void
nibbles_view_draw_worm_segment (NibblesView* self,
                                cairo_t* C,
                                gint x,
                                gint y,
                                gint x_size,
                                gint y_size,
                                gint color,
                                gboolean is_materialized,
                                gboolean eaten_bonus)
{
#line 1389 "../src/nibbles-view.vala"
	static const gdouble PI2 = 1.570796326794896619231321691639751442;
#line 10735 "nibbles-view.c"
	gdouble x_s13 = 0.0;
	gdouble x_s23 = 0.0;
	gdouble y_s13 = 0.0;
	gdouble y_s23 = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 1359 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 1359 "../src/nibbles-view.vala"
	g_return_if_fail (C != NULL);
#line 1361 "../src/nibbles-view.vala"
	if (eaten_bonus) {
#line 10750 "nibbles-view.c"
		gint a = 0;
#line 1363 "../src/nibbles-view.vala"
		a = x_size + (x_size / 5);
#line 1364 "../src/nibbles-view.vala"
		if (a < (x_size + 1)) {
#line 1365 "../src/nibbles-view.vala"
			x_size = x_size + 1;
#line 10758 "nibbles-view.c"
		} else {
#line 1368 "../src/nibbles-view.vala"
			x = x - ((a - x_size) / 2);
#line 1369 "../src/nibbles-view.vala"
			x_size = a;
#line 10764 "nibbles-view.c"
		}
#line 1371 "../src/nibbles-view.vala"
		a = y_size + (y_size / 5);
#line 1372 "../src/nibbles-view.vala"
		if (a < (y_size + 1)) {
#line 1373 "../src/nibbles-view.vala"
			y_size = y_size + 1;
#line 10772 "nibbles-view.c"
		} else {
#line 1376 "../src/nibbles-view.vala"
			y = y - ((a - y_size) / 2);
#line 1377 "../src/nibbles-view.vala"
			y_size = a;
#line 10778 "nibbles-view.c"
		}
	} else {
		gint _tmp0_;
		gint _tmp1_;
#line 1383 "../src/nibbles-view.vala"
		x = x + 1;
#line 1383 "../src/nibbles-view.vala"
		_tmp0_ = x;
#line 1384 "../src/nibbles-view.vala"
		y = y + 1;
#line 1384 "../src/nibbles-view.vala"
		_tmp1_ = y;
#line 1385 "../src/nibbles-view.vala"
		x_size = x_size - 1;
#line 1386 "../src/nibbles-view.vala"
		y_size = y_size - 1;
#line 10795 "nibbles-view.c"
	}
#line 1390 "../src/nibbles-view.vala"
	x_s13 = x_size / 3.0;
#line 1391 "../src/nibbles-view.vala"
	x_s23 = x_s13 + x_s13;
#line 1392 "../src/nibbles-view.vala"
	y_s13 = y_size / 3.0;
#line 1393 "../src/nibbles-view.vala"
	y_s23 = y_s13 + y_s13;
#line 1395 "../src/nibbles-view.vala"
	if (x_s13 < y_s13) {
#line 1395 "../src/nibbles-view.vala"
		_tmp2_ = x_s13;
#line 10809 "nibbles-view.c"
	} else {
#line 1395 "../src/nibbles-view.vala"
		_tmp2_ = y_s13;
#line 10813 "nibbles-view.c"
	}
#line 1395 "../src/nibbles-view.vala"
	cairo_arc (C, x + x_s23, y + y_s13, _tmp2_, -PI2, (gdouble) 0);
#line 1396 "../src/nibbles-view.vala"
	if (x_s13 < y_s13) {
#line 1396 "../src/nibbles-view.vala"
		_tmp3_ = x_s13;
#line 10821 "nibbles-view.c"
	} else {
#line 1396 "../src/nibbles-view.vala"
		_tmp3_ = y_s13;
#line 10825 "nibbles-view.c"
	}
#line 1396 "../src/nibbles-view.vala"
	cairo_arc (C, x + x_s23, y + y_s23, _tmp3_, (gdouble) 0, PI2);
#line 1397 "../src/nibbles-view.vala"
	if (x_s13 < y_s13) {
#line 1397 "../src/nibbles-view.vala"
		_tmp4_ = x_s13;
#line 10833 "nibbles-view.c"
	} else {
#line 1397 "../src/nibbles-view.vala"
		_tmp4_ = y_s13;
#line 10837 "nibbles-view.c"
	}
#line 1397 "../src/nibbles-view.vala"
	cairo_arc (C, x + x_s13, y + y_s23, _tmp4_, PI2, PI2 * 2);
#line 1398 "../src/nibbles-view.vala"
	if (x_s13 < y_s13) {
#line 1398 "../src/nibbles-view.vala"
		_tmp5_ = x_s13;
#line 10845 "nibbles-view.c"
	} else {
#line 1398 "../src/nibbles-view.vala"
		_tmp5_ = y_s13;
#line 10849 "nibbles-view.c"
	}
#line 1398 "../src/nibbles-view.vala"
	cairo_arc (C, x + x_s13, y + y_s13, _tmp5_, PI2 * 2, -PI2);
#line 1400 "../src/nibbles-view.vala"
	nibbles_view_set_color (self, C, color, is_materialized);
#line 1401 "../src/nibbles-view.vala"
	cairo_fill (C);
#line 10857 "nibbles-view.c"
}

static void
nibbles_view_draw_bonus (NibblesView* self,
                         cairo_t* C,
                         gint x,
                         gint y,
                         gint x_size,
                         gint y_size,
                         BonusType type)
{
	gdouble x_m = 0.0;
	gdouble y_m = 0.0;
#line 1404 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 1404 "../src/nibbles-view.vala"
	g_return_if_fail (C != NULL);
#line 1406 "../src/nibbles-view.vala"
	x_m = (gdouble) x_size;
#line 1407 "../src/nibbles-view.vala"
	y_m = (gdouble) y_size;
#line 1408 "../src/nibbles-view.vala"
	switch (type) {
#line 1408 "../src/nibbles-view.vala"
		case BONUS_TYPE_REGULAR:
#line 10883 "nibbles-view.c"
		{
#line 1411 "../src/nibbles-view.vala"
			x_m /= (gdouble) 18;
#line 1412 "../src/nibbles-view.vala"
			y_m /= (gdouble) 18;
#line 1413 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 15), y + (y_m * 8));
#line 1414 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 15.023438), y + (y_m * 10.035156), x + (x_m * 13.953125), y + (y_m * 17.1875), x + (x_m * 8), y + (y_m * 14.429688));
#line 1415 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 1.90625), y + (y_m * 17.109375), x + (x_m * 1.03125), y + (y_m * 9.921875), x + (x_m * 1), y + (y_m * 8));
#line 1416 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 1.007813), y + (y_m * 5.109375), x + (x_m * 3.300781), y + (y_m * 1.355469), x + (x_m * 8), y + (y_m * 4.3125));
#line 1417 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 12.933594), y + (y_m * 1.394531), x + (x_m * 15.0625), y + (y_m * 5), x + (x_m * 15), y + (y_m * 8));
#line 1418 "../src/nibbles-view.vala"
			cairo_close_path (C);
#line 1419 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, (gdouble) 0, (gdouble) 1, (gdouble) 0, (gdouble) 1);
#line 1420 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1421 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 9.65625), y + (y_m * 1.34375));
#line 1422 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 8), y + (y_m * 2), x + (x_m * 8), y + (y_m * 3.667969), x + (x_m * 8), y + (y_m * 5));
#line 1423 "../src/nibbles-view.vala"
			cairo_close_path (C);
#line 1424 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, (gdouble) 0, (gdouble) 1, (gdouble) 0, (gdouble) 1);
#line 1425 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1426 "../src/nibbles-view.vala"
			break;
#line 10917 "nibbles-view.c"
		}
#line 1408 "../src/nibbles-view.vala"
		case BONUS_TYPE_HALF:
#line 10921 "nibbles-view.c"
		{
#line 1428 "../src/nibbles-view.vala"
			x_m /= (gdouble) 16;
#line 1429 "../src/nibbles-view.vala"
			y_m /= (gdouble) 16;
#line 1430 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 10.253906), y + (y_m * 1.3125));
#line 1431 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 9.472656), y + (y_m * 4.730469), x + (x_m * 9.445313), y + (y_m * 8.015625), x + (x_m * 11.625), y + (y_m * 10.683594));
#line 1432 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.305882, 0.603922, 0.0235294, (gdouble) 1);
#line 1433 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1434 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 10.296875), y + (y_m * 1.152344));
#line 1435 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 9.046875), y + (y_m * 7.132813), x + (x_m * 6.023438), y + (y_m * 7.765625), x + (x_m * 3.84375), y + (y_m * 10.429688));
#line 1436 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.305882, 0.603922, 0.0235294, (gdouble) 1);
#line 1437 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1438 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 7), y + (y_m * 10));
#line 1439 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 7), y + (y_m * 11.65625), x + (x_m * 5.65625), y + (y_m * 13), x + (x_m * 4), y + (y_m * 13));
#line 1440 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 2.34375), y + (y_m * 13), x + (x_m * 1), y + (y_m * 11.65625), x + (x_m * 1), y + (y_m * 10));
#line 1441 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 1), y + (y_m * 8.34375), x + (x_m * 2.34375), y + (y_m * 7), x + (x_m * 4), y + (y_m * 7));
#line 1442 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 5.65625), y + (y_m * 7), x + (x_m * 7), y + (y_m * 8.34375), x + (x_m * 7), y + (y_m * 10));
#line 1443 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.8, (gdouble) 0, (gdouble) 0, (gdouble) 1);
#line 1444 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1445 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 15), y + (y_m * 12));
#line 1446 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 15), y + (y_m * 13.65625), x + (x_m * 13.65625), y + (y_m * 15), x + (x_m * 12), y + (y_m * 15));
#line 1447 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 10.34375), y + (y_m * 15), x + (x_m * 9), y + (y_m * 13.65625), x + (x_m * 9), y + (y_m * 12));
#line 1448 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 9), y + (y_m * 10.34375), x + (x_m * 10.34375), y + (y_m * 9), x + (x_m * 12), y + (y_m * 9));
#line 1449 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 13.65625), y + (y_m * 9), x + (x_m * 15), y + (y_m * 10.34375), x + (x_m * 15), y + (y_m * 12));
#line 1450 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.8, (gdouble) 0, (gdouble) 0, (gdouble) 1);
#line 1451 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1452 "../src/nibbles-view.vala"
			break;
#line 10973 "nibbles-view.c"
		}
#line 1408 "../src/nibbles-view.vala"
		case BONUS_TYPE_DOUBLE:
#line 10977 "nibbles-view.c"
		{
#line 1454 "../src/nibbles-view.vala"
			x_m /= (gdouble) 18;
#line 1455 "../src/nibbles-view.vala"
			y_m /= (gdouble) 18;
#line 1456 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 0.695313), y + (y_m * 8.425781));
#line 1457 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 8.914063), y + (y_m * 11.246094), x + (x_m * 13.257813), y + (y_m * 5.894531), x + (x_m * 13.847656), y + (y_m * 4.394531));
#line 1458 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 14.285156), y + (y_m * 3.351563), x + (x_m * 14.308594), y + (y_m * 3.082031), x + (x_m * 14.402344), y + (y_m * 2.535156));
#line 1459 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 14.941406), y + (y_m * 2.433594), x + (x_m * 15.613281), y + (y_m * 2.71875), x + (x_m * 16), y + (y_m * 3.0625));
#line 1460 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 15.566406), y + (y_m * 3.535156), x + (x_m * 15.261719), y + (y_m * 4.246094), x + (x_m * 15.167969), y + (y_m * 4.984375));
#line 1461 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 15.675781), y + (y_m * 11.316406), x + (x_m * 7.71875), y + (y_m * 17.683594), x + (x_m * 0), y + (y_m * 9.972656));
#line 1462 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 0.03125), y + (y_m * 9.433594), x + (x_m * 0.210938), y + (y_m * 8.84375), x + (x_m * 0.695313), y + (y_m * 8.425781));
#line 1463 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.988235, 0.913725, 0.309804, (gdouble) 1);
#line 1464 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1465 "../src/nibbles-view.vala"
			break;
#line 11003 "nibbles-view.c"
		}
#line 1408 "../src/nibbles-view.vala"
		case BONUS_TYPE_LIFE:
#line 11007 "nibbles-view.c"
		{
#line 1467 "../src/nibbles-view.vala"
			x_m /= (gdouble) 16;
#line 1468 "../src/nibbles-view.vala"
			y_m /= (gdouble) 16;
#line 1469 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 4.753906), y + (y_m * 1.828125));
#line 1470 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 2.652344), y + (y_m * 1.851563), x + (x_m * 1.019531), y + (y_m * 3.648438), x + (x_m * 1), y + (y_m * 5.8125));
#line 1471 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 0.972656), y + (y_m * 8.890625), x + (x_m * 2.808594), y + (y_m * 9.882813), x + (x_m * 8.015625), y + (y_m * 14.171875));
#line 1472 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 12.992188), y + (y_m * 9.558594), x + (x_m * 14.976563), y + (y_m * 8.316406), x + (x_m * 15), y + (y_m * 5.722656));
#line 1473 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 15.027344), y + (y_m * 2.886719), x + (x_m * 10.90625), y + (y_m * 0.128906), x + (x_m * 7.910156), y + (y_m * 3.121094));
#line 1474 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 6.835938), y + (y_m * 2.199219), x + (x_m * 5.742188), y + (y_m * 1.816406), x + (x_m * 4.753906), y + (y_m * 1.828125));
#line 1475 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, (gdouble) 1, (gdouble) 0, (gdouble) 0, (gdouble) 1);
#line 1476 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1477 "../src/nibbles-view.vala"
			break;
#line 11031 "nibbles-view.c"
		}
#line 1408 "../src/nibbles-view.vala"
		case BONUS_TYPE_REVERSE:
#line 11035 "nibbles-view.c"
		{
#line 1479 "../src/nibbles-view.vala"
			x_m /= (gdouble) 16;
#line 1480 "../src/nibbles-view.vala"
			y_m /= (gdouble) 16;
#line 1481 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 4), y + (y_m * 2));
#line 1482 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 12), y + (y_m * 2));
#line 1483 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 15), y + (y_m * 6));
#line 1484 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 8), y + (y_m * 15));
#line 1485 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 1), y + (y_m * 6));
#line 1486 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.717647, 0.807843, 0.901961, (gdouble) 1);
#line 1487 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1488 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 11), y + (y_m * 6));
#line 1489 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 8), y + (y_m * 15));
#line 1490 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 5), y + (y_m * 6));
#line 1491 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.447059, 0.623529, 0.811765, (gdouble) 1);
#line 1492 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1493 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 4), y + (y_m * 2));
#line 1494 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 8), y + (y_m * 2));
#line 1495 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 5), y + (y_m * 6));
#line 1496 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 1), y + (y_m * 6));
#line 1497 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.447059, 0.623529, 0.811765, (gdouble) 1);
#line 1498 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1499 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 12), y + (y_m * 2));
#line 1500 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 8), y + (y_m * 2));
#line 1501 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 11), y + (y_m * 6));
#line 1502 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 15), y + (y_m * 6));
#line 1503 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.447059, 0.623529, 0.811765, (gdouble) 1);
#line 1504 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1505 "../src/nibbles-view.vala"
			break;
#line 11091 "nibbles-view.c"
		}
#line 1408 "../src/nibbles-view.vala"
		case BONUS_TYPE_WARP:
#line 11095 "nibbles-view.c"
		{
			gdouble _tmp0_ = 0.0;
			gdouble _tmp2_ = 0.0;
			gdouble _tmp4_ = 0.0;
#line 1507 "../src/nibbles-view.vala"
			x_m /= (gdouble) 16;
#line 1508 "../src/nibbles-view.vala"
			y_m /= (gdouble) 16;
#line 1509 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 8.664063), y + (y_m * 0.621094));
#line 1510 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 6.179688), y + (y_m * 0.761719), x + (x_m * 4.265625), y + (y_m * 2.679688), x + (x_m * 4.40625), y + (y_m * 5.164063));
#line 1511 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 7.433594), y + (y_m * 5.164063));
#line 1512 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 7.386719), y + (y_m * 4.3125), x + (x_m * 8.003906), y + (y_m * 3.699219), x + (x_m * 8.855469), y + (y_m * 3.652344));
#line 1513 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 9.707031), y + (y_m * 3.601563), x + (x_m * 10.417969), y + (y_m * 4.21875), x + (x_m * 10.464844), y + (y_m * 5.070313));
#line 1514 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 10.464844), y + (y_m * 5.117188));
#line 1515 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 10.46875), y + (y_m * 5.316406), x + (x_m * 10.417969), y + (y_m * 5.609375), x + (x_m * 10.273438), y + (y_m * 5.78125));
#line 1516 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 9.929688), y + (y_m * 6.191406), x + (x_m * 9.542969), y + (y_m * 6.53125), x + (x_m * 9.234375), y + (y_m * 6.773438));
#line 1517 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 8.890625), y + (y_m * 7.035156), x + (x_m * 8.515625), y + (y_m * 7.351563), x + (x_m * 8.144531), y + (y_m * 7.816406));
#line 1518 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 7.773438), y + (y_m * 8.28125), x + (x_m * 7.433594), y + (y_m * 8.949219), x + (x_m * 7.433594), y + (y_m * 9.710938));
#line 1519 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 7.425781), y + (y_m * 10.507813), x + (x_m * 8.148438), y + (y_m * 11.222656), x + (x_m * 8.949219), y + (y_m * 11.222656));
#line 1520 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 9.75), y + (y_m * 11.222656), x + (x_m * 10.476563), y + (y_m * 10.507813), x + (x_m * 10.464844), y + (y_m * 9.710938));
#line 1521 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 10.464844), y + (y_m * 9.710938), x + (x_m * 10.4375), y + (y_m * 9.753906), x + (x_m * 10.511719), y + (y_m * 9.664063));
#line 1522 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 10.585938), y + (y_m * 9.566406), x + (x_m * 10.789063), y + (y_m * 9.40625), x + (x_m * 11.078125), y + (y_m * 9.1875));
#line 1523 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 12.921875), y + (y_m * 7.792969), x + (x_m * 13.492188), y + (y_m * 7.003906), x + (x_m * 13.492188), y + (y_m * 4.882813));
#line 1524 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 13.355469), y + (y_m * 2.394531), x + (x_m * 11.152344), y + (y_m * 0.484375), x + (x_m * 8.664063), y + (y_m * 0.621094));
#line 1526 "../src/nibbles-view.vala"
			if ((self->priv->animate % 30) < ((guint64) 10)) {
#line 1526 "../src/nibbles-view.vala"
				_tmp0_ = (self->priv->animate % 30) / 10.0;
#line 11140 "nibbles-view.c"
			} else {
				gdouble _tmp1_ = 0.0;
#line 1526 "../src/nibbles-view.vala"
				if ((self->priv->animate % 30) >= ((guint64) 20)) {
#line 1526 "../src/nibbles-view.vala"
					_tmp1_ = (gdouble) 0;
#line 11147 "nibbles-view.c"
				} else {
#line 1526 "../src/nibbles-view.vala"
					_tmp1_ = (20 - (self->priv->animate % 30)) / 10.0;
#line 11151 "nibbles-view.c"
				}
#line 1526 "../src/nibbles-view.vala"
				_tmp0_ = _tmp1_;
#line 11155 "nibbles-view.c"
			}
#line 1527 "../src/nibbles-view.vala"
			if (((self->priv->animate + 10) % 30) < ((guint64) 10)) {
#line 1527 "../src/nibbles-view.vala"
				_tmp2_ = ((self->priv->animate + 10) % 30) / 10.0;
#line 11161 "nibbles-view.c"
			} else {
				gdouble _tmp3_ = 0.0;
#line 1527 "../src/nibbles-view.vala"
				if (((self->priv->animate + 10) % 30) >= ((guint64) 20)) {
#line 1527 "../src/nibbles-view.vala"
					_tmp3_ = (gdouble) 0;
#line 11168 "nibbles-view.c"
				} else {
#line 1527 "../src/nibbles-view.vala"
					_tmp3_ = (20 - ((self->priv->animate + 10) % 30)) / 10.0;
#line 11172 "nibbles-view.c"
				}
#line 1527 "../src/nibbles-view.vala"
				_tmp2_ = _tmp3_;
#line 11176 "nibbles-view.c"
			}
#line 1528 "../src/nibbles-view.vala"
			if (((self->priv->animate + 20) % 30) < ((guint64) 10)) {
#line 1528 "../src/nibbles-view.vala"
				_tmp4_ = ((self->priv->animate + 20) % 30) / 10.0;
#line 11182 "nibbles-view.c"
			} else {
				gdouble _tmp5_ = 0.0;
#line 1528 "../src/nibbles-view.vala"
				if (((self->priv->animate + 20) % 30) >= ((guint64) 20)) {
#line 1528 "../src/nibbles-view.vala"
					_tmp5_ = (gdouble) 0;
#line 11189 "nibbles-view.c"
				} else {
#line 1528 "../src/nibbles-view.vala"
					_tmp5_ = (20 - ((self->priv->animate + 20) % 30)) / 10.0;
#line 11193 "nibbles-view.c"
				}
#line 1528 "../src/nibbles-view.vala"
				_tmp4_ = _tmp5_;
#line 11197 "nibbles-view.c"
			}
#line 1526 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, _tmp0_, _tmp2_, _tmp4_, (gdouble) 1);
#line 1530 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1531 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 8.949219), y + (y_m * 12.738281));
#line 1532 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 8.113281), y + (y_m * 12.738281), x + (x_m * 7.433594), y + (y_m * 13.417969), x + (x_m * 7.433594), y + (y_m * 14.253906));
#line 1533 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 7.433594), y + (y_m * 15.089844), x + (x_m * 8.113281), y + (y_m * 15.769531), x + (x_m * 8.949219), y + (y_m * 15.769531));
#line 1534 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 9.785156), y + (y_m * 15.769531), x + (x_m * 10.464844), y + (y_m * 15.089844), x + (x_m * 10.464844), y + (y_m * 14.253906));
#line 1535 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 10.464844), y + (y_m * 13.417969), x + (x_m * 9.785156), y + (y_m * 12.738281), x + (x_m * 8.949219), y + (y_m * 12.738281));
#line 1536 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1537 "../src/nibbles-view.vala"
			break;
#line 11217 "nibbles-view.c"
		}
#line 1408 "../src/nibbles-view.vala"
		case 6:
#line 11221 "nibbles-view.c"
		{
#line 1539 "../src/nibbles-view.vala"
			x_m /= (gdouble) 16;
#line 1540 "../src/nibbles-view.vala"
			y_m /= (gdouble) 16;
#line 1541 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 8.902344), y + (y_m * 0.160156));
#line 1542 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 6.953125), y + (y_m * 1.15625), x + (x_m * 7.480469), y + (y_m * 3.089844), x + (x_m * 7.453125), y + (y_m * 5.019531));
#line 1543 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 8.257813), y + (y_m * 4.8125));
#line 1544 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 8.144531), y + (y_m * 3.507813), x + (x_m * 9.359375), y + (y_m * 1.511719), x + (x_m * 10.742188), y + (y_m * 1.675781));
#line 1546 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.305882, 0.603922, 0.0235294, (gdouble) 1);
#line 1547 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1548 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 14), y + (y_m * 9));
#line 1549 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 14), y + (y_m * 5.6875), x + (x_m * 11.3125), y + (y_m * 3), x + (x_m * 8), y + (y_m * 3));
#line 1550 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 4.6875), y + (y_m * 3), x + (x_m * 2), y + (y_m * 5.6875), x + (x_m * 2), y + (y_m * 9));
#line 1551 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 2), y + (y_m * 12.3125), x + (x_m * 4.6875), y + (y_m * 15), x + (x_m * 8), y + (y_m * 15));
#line 1552 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 11.3125), y + (y_m * 15), x + (x_m * 14), y + (y_m * 12.3125), x + (x_m * 14), y + (y_m * 9));
#line 1554 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.960784, 0.47451, (gdouble) 0, (gdouble) 1);
#line 1555 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1556 "../src/nibbles-view.vala"
			break;
#line 11255 "nibbles-view.c"
		}
#line 1408 "../src/nibbles-view.vala"
		case 7:
#line 11259 "nibbles-view.c"
		{
#line 1558 "../src/nibbles-view.vala"
			x_m /= (gdouble) 16;
#line 1559 "../src/nibbles-view.vala"
			y_m /= (gdouble) 16;
#line 1560 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 4.585938), y + (y_m * 0.96875));
#line 1561 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 3.914063), y + (y_m * 3.050781), x + (x_m * 5.65625), y + (y_m * 4.042969), x + (x_m * 7), y + (y_m * 5.429688));
#line 1562 "../src/nibbles-view.vala"
			cairo_line_to (C, x + (x_m * 7.421875), y + (y_m * 4.710938));
#line 1563 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 6.417969), y + (y_m * 3.871094), x + (x_m * 5.867188), y + (y_m * 1.597656), x + (x_m * 6.960938), y + (y_m * 0.738281));
#line 1564 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.305882, 0.603922, 0.0235294, (gdouble) 1);
#line 1565 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1566 "../src/nibbles-view.vala"
			cairo_move_to (C, x + (x_m * 12.933594), y + (y_m * 5.347656));
#line 1567 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 13.652344), y + (y_m * 7.882813), x + (x_m * 12.867188), y + (y_m * 8.753906), x + (x_m * 12.871094), y + (y_m * 10.476563));
#line 1568 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 12.875), y + (y_m * 12.890625), x + (x_m * 13.015625), y + (y_m * 14.386719), x + (x_m * 11.148438), y + (y_m * 15.089844));
#line 1569 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 9.941406), y + (y_m * 15.492188), x + (x_m * 8.785156), y + (y_m * 15.382813), x + (x_m * 6.539063), y + (y_m * 12.617188));
#line 1570 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 5.886719), y + (y_m * 11.765625), x + (x_m * 4.117188), y + (y_m * 11.683594), x + (x_m * 3.226563), y + (y_m * 10.214844));
#line 1571 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 2.117188), y + (y_m * 8.375), x + (x_m * 2.902344), y + (y_m * 5.152344), x + (x_m * 6.707031), y + (y_m * 4.464844));
#line 1572 "../src/nibbles-view.vala"
			cairo_curve_to (C, x + (x_m * 8.609375), y + (y_m * 2.308594), x + (x_m * 11.933594), y + (y_m * 3.136719), x + (x_m * 12.933594), y + (y_m * 5.347656));
#line 1573 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.937255, 0.160784, 0.160784, (gdouble) 1);
#line 1574 "../src/nibbles-view.vala"
			cairo_fill (C);
#line 1575 "../src/nibbles-view.vala"
			break;
#line 11297 "nibbles-view.c"
		}
		default:
		{
#line 1577 "../src/nibbles-view.vala"
			break;
#line 11303 "nibbles-view.c"
		}
	}
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 1593 "../src/nibbles-view.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 11313 "nibbles-view.c"
}

static void
nibbles_view_draw_text_target_width (NibblesView* self,
                                     cairo_t* C,
                                     gint x,
                                     gint y,
                                     const gchar* text,
                                     gint target_width,
                                     gint color)
{
	gint target_font_size = 0;
	guint target_width_diff = 0U;
	PangoRectangle a = {0};
	PangoRectangle _tmp0_ = {0};
	PangoRectangle _tmp20_;
	PangoRectangle _tmp21_;
	PangoLayout* layout = NULL;
	PangoLayout* _tmp22_;
	PangoFontDescription* font = NULL;
	PangoLayout* _tmp23_;
	PangoFontDescription* _tmp24_;
	PangoFontDescription* _tmp29_;
	PangoLayout* _tmp30_;
	PangoFontDescription* _tmp31_;
	PangoLayout* _tmp32_;
	PangoLayout* _tmp33_;
	PangoLayout* _tmp34_;
#line 1581 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 1581 "../src/nibbles-view.vala"
	g_return_if_fail (C != NULL);
#line 1581 "../src/nibbles-view.vala"
	g_return_if_fail (text != NULL);
#line 1584 "../src/nibbles-view.vala"
	target_font_size = 1;
#line 1585 "../src/nibbles-view.vala"
	target_width_diff = G_MAXUINT;
#line 1586 "../src/nibbles-view.vala"
	_tmp0_.x = 0;
#line 1586 "../src/nibbles-view.vala"
	_tmp0_.y = 0;
#line 1586 "../src/nibbles-view.vala"
	_tmp0_.width = 0;
#line 1586 "../src/nibbles-view.vala"
	_tmp0_.height = 0;
#line 1586 "../src/nibbles-view.vala"
	a = _tmp0_;
#line 11362 "nibbles-view.c"
	{
		gint font_size = 0;
#line 1588 "../src/nibbles-view.vala"
		font_size = 1;
#line 11367 "nibbles-view.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1588 "../src/nibbles-view.vala"
			_tmp1_ = TRUE;
#line 1588 "../src/nibbles-view.vala"
			while (TRUE) {
#line 11374 "nibbles-view.c"
				PangoLayout* layout = NULL;
				PangoLayout* _tmp3_;
				PangoFontDescription* font = NULL;
				PangoLayout* _tmp4_;
				PangoFontDescription* _tmp5_;
				PangoFontDescription* _tmp10_;
				PangoLayout* _tmp11_;
				PangoFontDescription* _tmp12_;
				PangoLayout* _tmp13_;
				PangoLayout* _tmp14_;
				PangoRectangle b = {0};
				PangoLayout* _tmp15_;
				PangoRectangle _tmp16_ = {0};
				PangoRectangle _tmp17_ = {0};
				guint width_diff = 0U;
				PangoRectangle _tmp18_;
				gboolean _tmp19_ = FALSE;
#line 1588 "../src/nibbles-view.vala"
				if (!_tmp1_) {
#line 11394 "nibbles-view.c"
					gint _tmp2_;
#line 1588 "../src/nibbles-view.vala"
					_tmp2_ = font_size;
#line 1588 "../src/nibbles-view.vala"
					font_size = _tmp2_ + 1;
#line 11400 "nibbles-view.c"
				}
#line 1588 "../src/nibbles-view.vala"
				_tmp1_ = FALSE;
#line 1588 "../src/nibbles-view.vala"
				if (!(font_size < 200)) {
#line 1588 "../src/nibbles-view.vala"
					break;
#line 11408 "nibbles-view.c"
				}
#line 1590 "../src/nibbles-view.vala"
				_tmp3_ = pango_cairo_create_layout (C);
#line 1590 "../src/nibbles-view.vala"
				layout = _tmp3_;
#line 1592 "../src/nibbles-view.vala"
				_tmp4_ = layout;
#line 1592 "../src/nibbles-view.vala"
				_tmp5_ = pango_layout_get_font_description (_tmp4_);
#line 1592 "../src/nibbles-view.vala"
				if (NULL == _tmp5_) {
#line 11420 "nibbles-view.c"
					PangoFontDescription* _tmp6_;
#line 1593 "../src/nibbles-view.vala"
					_tmp6_ = pango_font_description_from_string ("Sans Bold 1pt");
#line 1593 "../src/nibbles-view.vala"
					__vala_PangoFontDescription_free0 (font);
#line 1593 "../src/nibbles-view.vala"
					font = _tmp6_;
#line 11428 "nibbles-view.c"
				} else {
					PangoLayout* _tmp7_;
					PangoFontDescription* _tmp8_;
					PangoFontDescription* _tmp9_;
#line 1595 "../src/nibbles-view.vala"
					_tmp7_ = layout;
#line 1595 "../src/nibbles-view.vala"
					_tmp8_ = pango_layout_get_font_description (_tmp7_);
#line 1595 "../src/nibbles-view.vala"
					_tmp9_ = pango_font_description_copy (_tmp8_);
#line 1595 "../src/nibbles-view.vala"
					__vala_PangoFontDescription_free0 (font);
#line 1595 "../src/nibbles-view.vala"
					font = _tmp9_;
#line 11443 "nibbles-view.c"
				}
#line 1596 "../src/nibbles-view.vala"
				_tmp10_ = font;
#line 1596 "../src/nibbles-view.vala"
				pango_font_description_set_size (_tmp10_, PANGO_SCALE * font_size);
#line 1597 "../src/nibbles-view.vala"
				_tmp11_ = layout;
#line 1597 "../src/nibbles-view.vala"
				_tmp12_ = font;
#line 1597 "../src/nibbles-view.vala"
				pango_layout_set_font_description (_tmp11_, _tmp12_);
#line 1598 "../src/nibbles-view.vala"
				_tmp13_ = layout;
#line 1598 "../src/nibbles-view.vala"
				pango_layout_set_text (_tmp13_, text, -1);
#line 1599 "../src/nibbles-view.vala"
				_tmp14_ = layout;
#line 1599 "../src/nibbles-view.vala"
				pango_cairo_update_layout (C, _tmp14_);
#line 1601 "../src/nibbles-view.vala"
				_tmp15_ = layout;
#line 1601 "../src/nibbles-view.vala"
				pango_layout_get_extents (_tmp15_, &_tmp16_, &_tmp17_);
#line 1601 "../src/nibbles-view.vala"
				a = _tmp16_;
#line 1601 "../src/nibbles-view.vala"
				b = _tmp17_;
#line 1602 "../src/nibbles-view.vala"
				_tmp18_ = a;
#line 1602 "../src/nibbles-view.vala"
				width_diff = (guint) abs (target_width - (((gint) _tmp18_.width) / PANGO_SCALE));
#line 1603 "../src/nibbles-view.vala"
				if (width_diff > target_width_diff) {
#line 1603 "../src/nibbles-view.vala"
					_tmp19_ = (width_diff - target_width_diff) > ((guint) 2);
#line 11479 "nibbles-view.c"
				} else {
#line 1603 "../src/nibbles-view.vala"
					_tmp19_ = FALSE;
#line 11483 "nibbles-view.c"
				}
#line 1603 "../src/nibbles-view.vala"
				if (_tmp19_) {
#line 1604 "../src/nibbles-view.vala"
					__vala_PangoFontDescription_free0 (font);
#line 1604 "../src/nibbles-view.vala"
					_g_object_unref0 (layout);
#line 1604 "../src/nibbles-view.vala"
					break;
#line 11493 "nibbles-view.c"
				} else {
#line 1605 "../src/nibbles-view.vala"
					if (width_diff < target_width_diff) {
#line 1607 "../src/nibbles-view.vala"
						target_width_diff = width_diff;
#line 1608 "../src/nibbles-view.vala"
						target_font_size = font_size;
#line 11501 "nibbles-view.c"
					}
				}
#line 1588 "../src/nibbles-view.vala"
				__vala_PangoFontDescription_free0 (font);
#line 1588 "../src/nibbles-view.vala"
				_g_object_unref0 (layout);
#line 11508 "nibbles-view.c"
			}
		}
	}
#line 1611 "../src/nibbles-view.vala"
	_tmp20_ = a;
#line 1611 "../src/nibbles-view.vala"
	_tmp21_ = a;
#line 1611 "../src/nibbles-view.vala"
	cairo_move_to (C, (gdouble) (x - (_tmp20_.x / PANGO_SCALE)), (gdouble) (y - (_tmp21_.y / PANGO_SCALE)));
#line 1612 "../src/nibbles-view.vala"
	_tmp22_ = pango_cairo_create_layout (C);
#line 1612 "../src/nibbles-view.vala"
	layout = _tmp22_;
#line 1614 "../src/nibbles-view.vala"
	_tmp23_ = layout;
#line 1614 "../src/nibbles-view.vala"
	_tmp24_ = pango_layout_get_font_description (_tmp23_);
#line 1614 "../src/nibbles-view.vala"
	if (NULL == _tmp24_) {
#line 11528 "nibbles-view.c"
		PangoFontDescription* _tmp25_;
#line 1615 "../src/nibbles-view.vala"
		_tmp25_ = pango_font_description_from_string ("Sans Bold 1pt");
#line 1615 "../src/nibbles-view.vala"
		__vala_PangoFontDescription_free0 (font);
#line 1615 "../src/nibbles-view.vala"
		font = _tmp25_;
#line 11536 "nibbles-view.c"
	} else {
		PangoLayout* _tmp26_;
		PangoFontDescription* _tmp27_;
		PangoFontDescription* _tmp28_;
#line 1617 "../src/nibbles-view.vala"
		_tmp26_ = layout;
#line 1617 "../src/nibbles-view.vala"
		_tmp27_ = pango_layout_get_font_description (_tmp26_);
#line 1617 "../src/nibbles-view.vala"
		_tmp28_ = pango_font_description_copy (_tmp27_);
#line 1617 "../src/nibbles-view.vala"
		__vala_PangoFontDescription_free0 (font);
#line 1617 "../src/nibbles-view.vala"
		font = _tmp28_;
#line 11551 "nibbles-view.c"
	}
#line 1618 "../src/nibbles-view.vala"
	_tmp29_ = font;
#line 1618 "../src/nibbles-view.vala"
	pango_font_description_set_size (_tmp29_, PANGO_SCALE * target_font_size);
#line 1619 "../src/nibbles-view.vala"
	_tmp30_ = layout;
#line 1619 "../src/nibbles-view.vala"
	_tmp31_ = font;
#line 1619 "../src/nibbles-view.vala"
	pango_layout_set_font_description (_tmp30_, _tmp31_);
#line 1620 "../src/nibbles-view.vala"
	_tmp32_ = layout;
#line 1620 "../src/nibbles-view.vala"
	pango_layout_set_text (_tmp32_, text, -1);
#line 1621 "../src/nibbles-view.vala"
	_tmp33_ = layout;
#line 1621 "../src/nibbles-view.vala"
	pango_cairo_update_layout (C, _tmp33_);
#line 1622 "../src/nibbles-view.vala"
	_tmp34_ = layout;
#line 1622 "../src/nibbles-view.vala"
	pango_cairo_show_layout (C, _tmp34_);
#line 1581 "../src/nibbles-view.vala"
	__vala_PangoFontDescription_free0 (font);
#line 1581 "../src/nibbles-view.vala"
	_g_object_unref0 (layout);
#line 11579 "nibbles-view.c"
}

static void
nibbles_view_draw_text_font_size (NibblesView* self,
                                  cairo_t* C,
                                  gint x,
                                  gint y,
                                  const gchar* text,
                                  gint font_size)
{
	gint x_offset = 0;
	gint y_offset = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	PangoLayout* layout = NULL;
	PangoLayout* _tmp2_;
	PangoFontDescription* font = NULL;
	PangoLayout* _tmp3_;
	PangoFontDescription* _tmp4_;
	PangoFontDescription* _tmp9_;
	PangoLayout* _tmp10_;
	PangoFontDescription* _tmp11_;
	PangoLayout* _tmp12_;
	PangoLayout* _tmp13_;
	PangoLayout* _tmp14_;
#line 1625 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 1625 "../src/nibbles-view.vala"
	g_return_if_fail (C != NULL);
#line 1625 "../src/nibbles-view.vala"
	g_return_if_fail (text != NULL);
#line 1628 "../src/nibbles-view.vala"
	nibbles_view_get_text_offsets (self, C, text, font_size, &_tmp0_, &_tmp1_);
#line 1628 "../src/nibbles-view.vala"
	x_offset = _tmp0_;
#line 1628 "../src/nibbles-view.vala"
	y_offset = _tmp1_;
#line 1629 "../src/nibbles-view.vala"
	cairo_move_to (C, (gdouble) (x - x_offset), (gdouble) (y - y_offset));
#line 1630 "../src/nibbles-view.vala"
	cairo_set_source_rgb (C, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 1631 "../src/nibbles-view.vala"
	_tmp2_ = pango_cairo_create_layout (C);
#line 1631 "../src/nibbles-view.vala"
	layout = _tmp2_;
#line 1633 "../src/nibbles-view.vala"
	_tmp3_ = layout;
#line 1633 "../src/nibbles-view.vala"
	_tmp4_ = pango_layout_get_font_description (_tmp3_);
#line 1633 "../src/nibbles-view.vala"
	if (NULL == _tmp4_) {
#line 11631 "nibbles-view.c"
		PangoFontDescription* _tmp5_;
#line 1634 "../src/nibbles-view.vala"
		_tmp5_ = pango_font_description_from_string ("Sans Bold 1pt");
#line 1634 "../src/nibbles-view.vala"
		__vala_PangoFontDescription_free0 (font);
#line 1634 "../src/nibbles-view.vala"
		font = _tmp5_;
#line 11639 "nibbles-view.c"
	} else {
		PangoLayout* _tmp6_;
		PangoFontDescription* _tmp7_;
		PangoFontDescription* _tmp8_;
#line 1636 "../src/nibbles-view.vala"
		_tmp6_ = layout;
#line 1636 "../src/nibbles-view.vala"
		_tmp7_ = pango_layout_get_font_description (_tmp6_);
#line 1636 "../src/nibbles-view.vala"
		_tmp8_ = pango_font_description_copy (_tmp7_);
#line 1636 "../src/nibbles-view.vala"
		__vala_PangoFontDescription_free0 (font);
#line 1636 "../src/nibbles-view.vala"
		font = _tmp8_;
#line 11654 "nibbles-view.c"
	}
#line 1637 "../src/nibbles-view.vala"
	_tmp9_ = font;
#line 1637 "../src/nibbles-view.vala"
	pango_font_description_set_size (_tmp9_, PANGO_SCALE * font_size);
#line 1638 "../src/nibbles-view.vala"
	_tmp10_ = layout;
#line 1638 "../src/nibbles-view.vala"
	_tmp11_ = font;
#line 1638 "../src/nibbles-view.vala"
	pango_layout_set_font_description (_tmp10_, _tmp11_);
#line 1639 "../src/nibbles-view.vala"
	_tmp12_ = layout;
#line 1639 "../src/nibbles-view.vala"
	pango_layout_set_text (_tmp12_, text, -1);
#line 1640 "../src/nibbles-view.vala"
	_tmp13_ = layout;
#line 1640 "../src/nibbles-view.vala"
	pango_cairo_update_layout (C, _tmp13_);
#line 1641 "../src/nibbles-view.vala"
	_tmp14_ = layout;
#line 1641 "../src/nibbles-view.vala"
	pango_cairo_show_layout (C, _tmp14_);
#line 1625 "../src/nibbles-view.vala"
	__vala_PangoFontDescription_free0 (font);
#line 1625 "../src/nibbles-view.vala"
	_g_object_unref0 (layout);
#line 11682 "nibbles-view.c"
}

static void
nibbles_view_get_text_offsets (NibblesView* self,
                               cairo_t* C,
                               const gchar* text,
                               gint font_size,
                               gint* x_offset,
                               gint* y_offset)
{
	gint _vala_x_offset = 0;
	gint _vala_y_offset = 0;
	PangoLayout* layout = NULL;
	PangoLayout* _tmp0_;
	PangoFontDescription* font = NULL;
	PangoLayout* _tmp1_;
	PangoFontDescription* _tmp2_;
	PangoFontDescription* _tmp7_;
	PangoLayout* _tmp8_;
	PangoFontDescription* _tmp9_;
	PangoLayout* _tmp10_;
	PangoLayout* _tmp11_;
	PangoRectangle a = {0};
	PangoRectangle b = {0};
	PangoLayout* _tmp12_;
	PangoRectangle _tmp13_ = {0};
	PangoRectangle _tmp14_ = {0};
	PangoRectangle _tmp15_;
	PangoRectangle _tmp16_;
#line 1644 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 1644 "../src/nibbles-view.vala"
	g_return_if_fail (C != NULL);
#line 1644 "../src/nibbles-view.vala"
	g_return_if_fail (text != NULL);
#line 1646 "../src/nibbles-view.vala"
	_tmp0_ = pango_cairo_create_layout (C);
#line 1646 "../src/nibbles-view.vala"
	layout = _tmp0_;
#line 1648 "../src/nibbles-view.vala"
	_tmp1_ = layout;
#line 1648 "../src/nibbles-view.vala"
	_tmp2_ = pango_layout_get_font_description (_tmp1_);
#line 1648 "../src/nibbles-view.vala"
	if (NULL == _tmp2_) {
#line 11728 "nibbles-view.c"
		PangoFontDescription* _tmp3_;
#line 1649 "../src/nibbles-view.vala"
		_tmp3_ = pango_font_description_from_string ("Sans Bold 1pt");
#line 1649 "../src/nibbles-view.vala"
		__vala_PangoFontDescription_free0 (font);
#line 1649 "../src/nibbles-view.vala"
		font = _tmp3_;
#line 11736 "nibbles-view.c"
	} else {
		PangoLayout* _tmp4_;
		PangoFontDescription* _tmp5_;
		PangoFontDescription* _tmp6_;
#line 1651 "../src/nibbles-view.vala"
		_tmp4_ = layout;
#line 1651 "../src/nibbles-view.vala"
		_tmp5_ = pango_layout_get_font_description (_tmp4_);
#line 1651 "../src/nibbles-view.vala"
		_tmp6_ = pango_font_description_copy (_tmp5_);
#line 1651 "../src/nibbles-view.vala"
		__vala_PangoFontDescription_free0 (font);
#line 1651 "../src/nibbles-view.vala"
		font = _tmp6_;
#line 11751 "nibbles-view.c"
	}
#line 1652 "../src/nibbles-view.vala"
	_tmp7_ = font;
#line 1652 "../src/nibbles-view.vala"
	pango_font_description_set_size (_tmp7_, PANGO_SCALE * font_size);
#line 1653 "../src/nibbles-view.vala"
	_tmp8_ = layout;
#line 1653 "../src/nibbles-view.vala"
	_tmp9_ = font;
#line 1653 "../src/nibbles-view.vala"
	pango_layout_set_font_description (_tmp8_, _tmp9_);
#line 1654 "../src/nibbles-view.vala"
	_tmp10_ = layout;
#line 1654 "../src/nibbles-view.vala"
	pango_layout_set_text (_tmp10_, text, -1);
#line 1655 "../src/nibbles-view.vala"
	_tmp11_ = layout;
#line 1655 "../src/nibbles-view.vala"
	pango_cairo_update_layout (C, _tmp11_);
#line 1657 "../src/nibbles-view.vala"
	_tmp12_ = layout;
#line 1657 "../src/nibbles-view.vala"
	pango_layout_get_extents (_tmp12_, &_tmp13_, &_tmp14_);
#line 1657 "../src/nibbles-view.vala"
	a = _tmp13_;
#line 1657 "../src/nibbles-view.vala"
	b = _tmp14_;
#line 1658 "../src/nibbles-view.vala"
	_tmp15_ = a;
#line 1658 "../src/nibbles-view.vala"
	_vala_x_offset = _tmp15_.x / PANGO_SCALE;
#line 1659 "../src/nibbles-view.vala"
	_tmp16_ = a;
#line 1659 "../src/nibbles-view.vala"
	_vala_y_offset = _tmp16_.y / PANGO_SCALE;
#line 1644 "../src/nibbles-view.vala"
	__vala_PangoFontDescription_free0 (font);
#line 1644 "../src/nibbles-view.vala"
	_g_object_unref0 (layout);
#line 1644 "../src/nibbles-view.vala"
	if (x_offset) {
#line 1644 "../src/nibbles-view.vala"
		*x_offset = _vala_x_offset;
#line 11795 "nibbles-view.c"
	}
#line 1644 "../src/nibbles-view.vala"
	if (y_offset) {
#line 1644 "../src/nibbles-view.vala"
		*y_offset = _vala_y_offset;
#line 11801 "nibbles-view.c"
	}
}

static void
nibbles_view_set_color (NibblesView* self,
                        cairo_t* C,
                        gint color,
                        gboolean bright)
{
	gdouble r = 0.0;
	gdouble g = 0.0;
	gdouble b = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 1662 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 1662 "../src/nibbles-view.vala"
	g_return_if_fail (C != NULL);
#line 1667 "../src/nibbles-view.vala"
	get_worm_rgb (color, bright, &_tmp0_, &_tmp1_, &_tmp2_);
#line 1667 "../src/nibbles-view.vala"
	r = _tmp0_;
#line 1667 "../src/nibbles-view.vala"
	g = _tmp1_;
#line 1667 "../src/nibbles-view.vala"
	b = _tmp2_;
#line 1668 "../src/nibbles-view.vala"
	cairo_set_source_rgba (C, r, g, b, (gdouble) 1);
#line 11831 "nibbles-view.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 11848 "nibbles-view.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1489 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1489 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1490 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1491 "glib-2.0.vapi"
		start = string_length + start;
#line 11875 "nibbles-view.c"
	}
#line 1493 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		end = string_length + end;
#line 11881 "nibbles-view.c"
	}
#line 1496 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 11887 "nibbles-view.c"
	} else {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 11891 "nibbles-view.c"
	}
#line 1496 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1497 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 11899 "nibbles-view.c"
	} else {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 11903 "nibbles-view.c"
	}
#line 1497 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1499 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1499 "glib-2.0.vapi"
	result = _tmp4_;
#line 1499 "glib-2.0.vapi"
	return result;
#line 11915 "nibbles-view.c"
}

static void
_vala_array_add4 (gdouble* * array,
                  gint* length,
                  gint* size,
                  gdouble value)
{
#line 1717 "../src/nibbles-view.vala"
	if ((*length) == (*size)) {
#line 1717 "../src/nibbles-view.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1717 "../src/nibbles-view.vala"
		*array = g_renew (gdouble, *array, *size);
#line 11930 "nibbles-view.c"
	}
#line 1717 "../src/nibbles-view.vala"
	(*array)[(*length)++] = value;
#line 11934 "nibbles-view.c"
}

static void
_vala_array_add5 (gdouble* * array,
                  gint* length,
                  gint* size,
                  gdouble value)
{
#line 1718 "../src/nibbles-view.vala"
	if ((*length) == (*size)) {
#line 1718 "../src/nibbles-view.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1718 "../src/nibbles-view.vala"
		*array = g_renew (gdouble, *array, *size);
#line 11949 "nibbles-view.c"
	}
#line 1718 "../src/nibbles-view.vala"
	(*array)[(*length)++] = value;
#line 11953 "nibbles-view.c"
}

static void
nibbles_view_draw_dialogue (NibblesView* self,
                            cairo_t* C,
                            gdouble width,
                            gdouble height,
                            const gchar* text,
                            gdouble* b0_x,
                            gdouble* b0_y,
                            gdouble* b0_width,
                            gdouble* b0_height,
                            gdouble* b1_x,
                            gdouble* b1_y,
                            gdouble* b1_width,
                            gdouble* b1_height,
                            gboolean draw_buttons)
{
	gdouble _vala_b0_x = 0.0;
	gdouble _vala_b0_y = 0.0;
	gdouble _vala_b0_width = 0.0;
	gdouble _vala_b0_height = 0.0;
	gdouble _vala_b1_x = 0.0;
	gdouble _vala_b1_y = 0.0;
	gdouble _vala_b1_width = 0.0;
	gdouble _vala_b1_height = 0.0;
#line 1676 "../src/nibbles-view.vala"
	static const gdouble PI2 = 1.570796326794896619231321691639751442;
#line 1677 "../src/nibbles-view.vala"
	static const gdouble border_width = (gdouble) 3;
#line 11984 "nibbles-view.c"
	gint lines = 0;
	gint font_size = 0;
	gdouble* line_width = NULL;
	gdouble* _tmp27_;
	gint line_width_length1;
	gint _line_width_size_;
	gdouble* line_height = NULL;
	gdouble* _tmp28_;
	gint line_height_length1;
	gint _line_height_size_;
	gdouble text_width = 0.0;
	gdouble text_height = 0.0;
	gdouble button_height = 0.0;
	gdouble minimum_dimension = 0.0;
	gdouble background_width = 0.0;
	gdouble background_height = 0.0;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble _tmp63_ = 0.0;
	gdouble arc_radius = 0.0;
	gint line = 0;
	gdouble y_line = 0.0;
	gdouble _tmp92_ = 0.0;
	gdouble button_width = 0.0;
	gdouble _tmp93_ = 0.0;
	gdouble b0_radius = 0.0;
	gdouble b1_radius = 0.0;
#line 1671 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 1671 "../src/nibbles-view.vala"
	g_return_if_fail (C != NULL);
#line 1671 "../src/nibbles-view.vala"
	g_return_if_fail (text != NULL);
#line 1679 "../src/nibbles-view.vala"
	lines = 0;
#line 1680 "../src/nibbles-view.vala"
	font_size = G_MAXINT;
#line 12022 "nibbles-view.c"
	{
		gchar* s = NULL;
		gchar* _tmp0_;
#line 1681 "../src/nibbles-view.vala"
		_tmp0_ = g_strdup (text);
#line 1681 "../src/nibbles-view.vala"
		s = _tmp0_;
#line 12030 "nibbles-view.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1681 "../src/nibbles-view.vala"
			_tmp1_ = TRUE;
#line 1681 "../src/nibbles-view.vala"
			while (TRUE) {
#line 12037 "nibbles-view.c"
				const gchar* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				guint new_line = 0U;
				gint _tmp12_;
				const gchar* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
#line 1681 "../src/nibbles-view.vala"
				if (!_tmp1_) {
#line 12048 "nibbles-view.c"
				}
#line 1681 "../src/nibbles-view.vala"
				_tmp1_ = FALSE;
#line 1681 "../src/nibbles-view.vala"
				_tmp2_ = s;
#line 1681 "../src/nibbles-view.vala"
				_tmp3_ = strlen (_tmp2_);
#line 1681 "../src/nibbles-view.vala"
				_tmp4_ = _tmp3_;
#line 1681 "../src/nibbles-view.vala"
				if (!(_tmp4_ > 0)) {
#line 1681 "../src/nibbles-view.vala"
					break;
#line 12062 "nibbles-view.c"
				}
				{
					gboolean _tmp5_ = FALSE;
#line 1684 "../src/nibbles-view.vala"
					new_line = (guint) 0;
#line 1684 "../src/nibbles-view.vala"
					_tmp5_ = TRUE;
#line 1684 "../src/nibbles-view.vala"
					while (TRUE) {
#line 12072 "nibbles-view.c"
						gboolean _tmp7_ = FALSE;
						const gchar* _tmp8_;
						gint _tmp9_;
						gint _tmp10_;
#line 1684 "../src/nibbles-view.vala"
						if (!_tmp5_) {
#line 12079 "nibbles-view.c"
							guint _tmp6_;
#line 1684 "../src/nibbles-view.vala"
							new_line = new_line + 1;
#line 1684 "../src/nibbles-view.vala"
							_tmp6_ = new_line;
#line 12085 "nibbles-view.c"
						}
#line 1684 "../src/nibbles-view.vala"
						_tmp5_ = FALSE;
#line 1684 "../src/nibbles-view.vala"
						_tmp8_ = s;
#line 1684 "../src/nibbles-view.vala"
						_tmp9_ = strlen (_tmp8_);
#line 1684 "../src/nibbles-view.vala"
						_tmp10_ = _tmp9_;
#line 1684 "../src/nibbles-view.vala"
						if (new_line < ((guint) _tmp10_)) {
#line 12097 "nibbles-view.c"
							const gchar* _tmp11_;
#line 1684 "../src/nibbles-view.vala"
							_tmp11_ = s;
#line 1684 "../src/nibbles-view.vala"
							_tmp7_ = string_get (_tmp11_, (glong) new_line) != '\n';
#line 12103 "nibbles-view.c"
						} else {
#line 1684 "../src/nibbles-view.vala"
							_tmp7_ = FALSE;
#line 12107 "nibbles-view.c"
						}
#line 1684 "../src/nibbles-view.vala"
						if (!_tmp7_) {
#line 1684 "../src/nibbles-view.vala"
							break;
#line 12113 "nibbles-view.c"
						}
					}
				}
#line 1685 "../src/nibbles-view.vala"
				lines = lines + 1;
#line 1685 "../src/nibbles-view.vala"
				_tmp12_ = lines;
#line 1686 "../src/nibbles-view.vala"
				if (new_line > ((guint) 0)) {
#line 12123 "nibbles-view.c"
					gchar* _text = NULL;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gdouble _text_width = 0.0;
					gdouble _text_height = 0.0;
					gint size = 0;
					const gchar* _tmp15_;
					gdouble _tmp16_ = 0.0;
					gdouble _tmp17_ = 0.0;
					gint _tmp18_;
#line 1688 "../src/nibbles-view.vala"
					_tmp13_ = s;
#line 1688 "../src/nibbles-view.vala"
					_tmp14_ = string_slice (_tmp13_, (glong) 0, (glong) new_line);
#line 1688 "../src/nibbles-view.vala"
					_text = _tmp14_;
#line 1691 "../src/nibbles-view.vala"
					_tmp15_ = _text;
#line 1691 "../src/nibbles-view.vala"
					_tmp18_ = nibbles_view_calculate_font_size (self, C, _tmp15_, (gint) (width * 0.8), &_tmp16_, &_tmp17_);
#line 1691 "../src/nibbles-view.vala"
					_text_width = _tmp16_;
#line 1691 "../src/nibbles-view.vala"
					_text_height = _tmp17_;
#line 1691 "../src/nibbles-view.vala"
					size = _tmp18_;
#line 1692 "../src/nibbles-view.vala"
					if (size < font_size) {
#line 1693 "../src/nibbles-view.vala"
						font_size = size;
#line 12154 "nibbles-view.c"
					}
#line 1686 "../src/nibbles-view.vala"
					_g_free0 (_text);
#line 12158 "nibbles-view.c"
				}
#line 1695 "../src/nibbles-view.vala"
				_tmp19_ = s;
#line 1695 "../src/nibbles-view.vala"
				_tmp20_ = strlen (_tmp19_);
#line 1695 "../src/nibbles-view.vala"
				_tmp21_ = _tmp20_;
#line 1695 "../src/nibbles-view.vala"
				if (((guint) _tmp21_) > (new_line + 1)) {
#line 12168 "nibbles-view.c"
					const gchar* _tmp22_;
					const gchar* _tmp23_;
					gint _tmp24_;
					gint _tmp25_;
					gchar* _tmp26_;
#line 1696 "../src/nibbles-view.vala"
					_tmp22_ = s;
#line 1696 "../src/nibbles-view.vala"
					_tmp23_ = s;
#line 1696 "../src/nibbles-view.vala"
					_tmp24_ = strlen (_tmp23_);
#line 1696 "../src/nibbles-view.vala"
					_tmp25_ = _tmp24_;
#line 1696 "../src/nibbles-view.vala"
					_tmp26_ = string_slice (_tmp22_, (glong) (new_line + 1), (glong) _tmp25_);
#line 1696 "../src/nibbles-view.vala"
					_g_free0 (s);
#line 1696 "../src/nibbles-view.vala"
					s = _tmp26_;
#line 12188 "nibbles-view.c"
				} else {
#line 1698 "../src/nibbles-view.vala"
					break;
#line 12192 "nibbles-view.c"
				}
			}
		}
#line 1681 "../src/nibbles-view.vala"
		_g_free0 (s);
#line 12198 "nibbles-view.c"
	}
#line 1701 "../src/nibbles-view.vala"
	_tmp27_ = g_new0 (gdouble, 0);
#line 1701 "../src/nibbles-view.vala"
	line_width = _tmp27_;
#line 1701 "../src/nibbles-view.vala"
	line_width_length1 = 0;
#line 1701 "../src/nibbles-view.vala"
	_line_width_size_ = line_width_length1;
#line 1702 "../src/nibbles-view.vala"
	_tmp28_ = g_new0 (gdouble, 0);
#line 1702 "../src/nibbles-view.vala"
	line_height = _tmp28_;
#line 1702 "../src/nibbles-view.vala"
	line_height_length1 = 0;
#line 1702 "../src/nibbles-view.vala"
	_line_height_size_ = line_height_length1;
#line 1703 "../src/nibbles-view.vala"
	text_width = (gdouble) 0;
#line 1704 "../src/nibbles-view.vala"
	text_height = (gdouble) 0;
#line 12220 "nibbles-view.c"
	{
		gchar* s = NULL;
		gchar* _tmp29_;
#line 1705 "../src/nibbles-view.vala"
		_tmp29_ = g_strdup (text);
#line 1705 "../src/nibbles-view.vala"
		s = _tmp29_;
#line 12228 "nibbles-view.c"
		{
			gboolean _tmp30_ = FALSE;
#line 1705 "../src/nibbles-view.vala"
			_tmp30_ = TRUE;
#line 1705 "../src/nibbles-view.vala"
			while (TRUE) {
#line 12235 "nibbles-view.c"
				const gchar* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				guint new_line = 0U;
				const gchar* _tmp55_;
				gint _tmp56_;
				gint _tmp57_;
#line 1705 "../src/nibbles-view.vala"
				if (!_tmp30_) {
#line 12245 "nibbles-view.c"
				}
#line 1705 "../src/nibbles-view.vala"
				_tmp30_ = FALSE;
#line 1705 "../src/nibbles-view.vala"
				_tmp31_ = s;
#line 1705 "../src/nibbles-view.vala"
				_tmp32_ = strlen (_tmp31_);
#line 1705 "../src/nibbles-view.vala"
				_tmp33_ = _tmp32_;
#line 1705 "../src/nibbles-view.vala"
				if (!(_tmp33_ > 0)) {
#line 1705 "../src/nibbles-view.vala"
					break;
#line 12259 "nibbles-view.c"
				}
				{
					gboolean _tmp34_ = FALSE;
#line 1708 "../src/nibbles-view.vala"
					new_line = (guint) 0;
#line 1708 "../src/nibbles-view.vala"
					_tmp34_ = TRUE;
#line 1708 "../src/nibbles-view.vala"
					while (TRUE) {
#line 12269 "nibbles-view.c"
						gboolean _tmp36_ = FALSE;
						const gchar* _tmp37_;
						gint _tmp38_;
						gint _tmp39_;
#line 1708 "../src/nibbles-view.vala"
						if (!_tmp34_) {
#line 12276 "nibbles-view.c"
							guint _tmp35_;
#line 1708 "../src/nibbles-view.vala"
							new_line = new_line + 1;
#line 1708 "../src/nibbles-view.vala"
							_tmp35_ = new_line;
#line 12282 "nibbles-view.c"
						}
#line 1708 "../src/nibbles-view.vala"
						_tmp34_ = FALSE;
#line 1708 "../src/nibbles-view.vala"
						_tmp37_ = s;
#line 1708 "../src/nibbles-view.vala"
						_tmp38_ = strlen (_tmp37_);
#line 1708 "../src/nibbles-view.vala"
						_tmp39_ = _tmp38_;
#line 1708 "../src/nibbles-view.vala"
						if (new_line < ((guint) _tmp39_)) {
#line 12294 "nibbles-view.c"
							const gchar* _tmp40_;
#line 1708 "../src/nibbles-view.vala"
							_tmp40_ = s;
#line 1708 "../src/nibbles-view.vala"
							_tmp36_ = string_get (_tmp40_, (glong) new_line) != '\n';
#line 12300 "nibbles-view.c"
						} else {
#line 1708 "../src/nibbles-view.vala"
							_tmp36_ = FALSE;
#line 12304 "nibbles-view.c"
						}
#line 1708 "../src/nibbles-view.vala"
						if (!_tmp36_) {
#line 1708 "../src/nibbles-view.vala"
							break;
#line 12310 "nibbles-view.c"
						}
					}
				}
#line 1709 "../src/nibbles-view.vala"
				if (new_line > ((guint) 0)) {
#line 12316 "nibbles-view.c"
					gchar* _text = NULL;
					const gchar* _tmp41_;
					gchar* _tmp42_;
					cairo_t* c = NULL;
					cairo_surface_t* _tmp43_;
					cairo_t* _tmp44_;
					cairo_t* _tmp45_;
					cairo_t* _tmp46_;
					cairo_text_extents_t extents = {0};
					cairo_t* _tmp47_;
					const gchar* _tmp48_;
					cairo_text_extents_t _tmp49_ = {0};
					cairo_text_extents_t _tmp50_;
					cairo_text_extents_t _tmp51_;
					cairo_text_extents_t _tmp52_;
					cairo_text_extents_t _tmp54_;
#line 1711 "../src/nibbles-view.vala"
					_tmp41_ = s;
#line 1711 "../src/nibbles-view.vala"
					_tmp42_ = string_slice (_tmp41_, (glong) 0, (glong) new_line);
#line 1711 "../src/nibbles-view.vala"
					_text = _tmp42_;
#line 1712 "../src/nibbles-view.vala"
					_tmp43_ = cairo_get_target (C);
#line 1712 "../src/nibbles-view.vala"
					_tmp44_ = cairo_create (_tmp43_);
#line 1712 "../src/nibbles-view.vala"
					c = _tmp44_;
#line 1713 "../src/nibbles-view.vala"
					_tmp45_ = c;
#line 1713 "../src/nibbles-view.vala"
					cairo_move_to (_tmp45_, (gdouble) 0, (gdouble) 0);
#line 1714 "../src/nibbles-view.vala"
					_tmp46_ = c;
#line 1714 "../src/nibbles-view.vala"
					cairo_set_font_size (_tmp46_, (gdouble) font_size);
#line 1716 "../src/nibbles-view.vala"
					_tmp47_ = c;
#line 1716 "../src/nibbles-view.vala"
					_tmp48_ = _text;
#line 1716 "../src/nibbles-view.vala"
					cairo_text_extents (_tmp47_, _tmp48_, &_tmp49_);
#line 1716 "../src/nibbles-view.vala"
					extents = _tmp49_;
#line 1717 "../src/nibbles-view.vala"
					_tmp50_ = extents;
#line 1717 "../src/nibbles-view.vala"
					_vala_array_add4 (&line_width, &line_width_length1, &_line_width_size_, _tmp50_.width);
#line 1718 "../src/nibbles-view.vala"
					_tmp51_ = extents;
#line 1718 "../src/nibbles-view.vala"
					_vala_array_add5 (&line_height, &line_height_length1, &_line_height_size_, _tmp51_.height + 5);
#line 1719 "../src/nibbles-view.vala"
					_tmp52_ = extents;
#line 1719 "../src/nibbles-view.vala"
					if (_tmp52_.width > text_width) {
#line 12373 "nibbles-view.c"
						cairo_text_extents_t _tmp53_;
#line 1720 "../src/nibbles-view.vala"
						_tmp53_ = extents;
#line 1720 "../src/nibbles-view.vala"
						text_width = _tmp53_.width;
#line 12379 "nibbles-view.c"
					}
#line 1721 "../src/nibbles-view.vala"
					_tmp54_ = extents;
#line 1721 "../src/nibbles-view.vala"
					text_height += _tmp54_.height + 5;
#line 1709 "../src/nibbles-view.vala"
					_cairo_destroy0 (c);
#line 1709 "../src/nibbles-view.vala"
					_g_free0 (_text);
#line 12389 "nibbles-view.c"
				}
#line 1723 "../src/nibbles-view.vala"
				_tmp55_ = s;
#line 1723 "../src/nibbles-view.vala"
				_tmp56_ = strlen (_tmp55_);
#line 1723 "../src/nibbles-view.vala"
				_tmp57_ = _tmp56_;
#line 1723 "../src/nibbles-view.vala"
				if (((guint) _tmp57_) > (new_line + 1)) {
#line 12399 "nibbles-view.c"
					const gchar* _tmp58_;
					const gchar* _tmp59_;
					gint _tmp60_;
					gint _tmp61_;
					gchar* _tmp62_;
#line 1724 "../src/nibbles-view.vala"
					_tmp58_ = s;
#line 1724 "../src/nibbles-view.vala"
					_tmp59_ = s;
#line 1724 "../src/nibbles-view.vala"
					_tmp60_ = strlen (_tmp59_);
#line 1724 "../src/nibbles-view.vala"
					_tmp61_ = _tmp60_;
#line 1724 "../src/nibbles-view.vala"
					_tmp62_ = string_slice (_tmp58_, (glong) (new_line + 1), (glong) _tmp61_);
#line 1724 "../src/nibbles-view.vala"
					_g_free0 (s);
#line 1724 "../src/nibbles-view.vala"
					s = _tmp62_;
#line 12419 "nibbles-view.c"
				} else {
#line 1726 "../src/nibbles-view.vala"
					break;
#line 12423 "nibbles-view.c"
				}
			}
		}
#line 1705 "../src/nibbles-view.vala"
		_g_free0 (s);
#line 12429 "nibbles-view.c"
	}
#line 1729 "../src/nibbles-view.vala"
	button_height = (text_height / lines) * 1.5;
#line 1730 "../src/nibbles-view.vala"
	minimum_dimension = (gdouble) 10;
#line 1731 "../src/nibbles-view.vala"
	background_width = text_width + (minimum_dimension * 2);
#line 1732 "../src/nibbles-view.vala"
	background_height = (text_height + (minimum_dimension * 5)) + button_height;
#line 1734 "../src/nibbles-view.vala"
	x = (width - background_width) / 2;
#line 1735 "../src/nibbles-view.vala"
	y = (gdouble) 0;
#line 1737 "../src/nibbles-view.vala"
	if (background_width < background_height) {
#line 1737 "../src/nibbles-view.vala"
		_tmp63_ = background_width / 3;
#line 12447 "nibbles-view.c"
	} else {
#line 1737 "../src/nibbles-view.vala"
		_tmp63_ = background_height / 3;
#line 12451 "nibbles-view.c"
	}
#line 1737 "../src/nibbles-view.vala"
	arc_radius = _tmp63_;
#line 1740 "../src/nibbles-view.vala"
	cairo_move_to (C, x + background_width, y);
#line 1741 "../src/nibbles-view.vala"
	cairo_arc (C, (x + background_width) - arc_radius, y + arc_radius, arc_radius, -PI2, (gdouble) 0);
#line 1742 "../src/nibbles-view.vala"
	cairo_arc (C, (x + background_width) - arc_radius, (y + background_height) - arc_radius, arc_radius, (gdouble) 0, PI2);
#line 1743 "../src/nibbles-view.vala"
	cairo_arc (C, x + arc_radius, (y + background_height) - arc_radius, arc_radius, PI2, PI2 * 2);
#line 1744 "../src/nibbles-view.vala"
	cairo_arc (C, x + arc_radius, y + arc_radius, arc_radius, PI2 * 2, -PI2);
#line 1746 "../src/nibbles-view.vala"
	cairo_set_source_rgba (C, 0.5, 0.5, 0.5, (gdouble) 1);
#line 1747 "../src/nibbles-view.vala"
	cairo_fill (C);
#line 1750 "../src/nibbles-view.vala"
	cairo_arc (C, (x + background_width) - arc_radius, y + arc_radius, arc_radius - border_width, -PI2, (gdouble) 0);
#line 1751 "../src/nibbles-view.vala"
	cairo_arc (C, (x + background_width) - arc_radius, (y + background_height) - arc_radius, arc_radius - border_width, (gdouble) 0, PI2);
#line 1752 "../src/nibbles-view.vala"
	cairo_arc (C, x + arc_radius, (y + background_height) - arc_radius, arc_radius - border_width, PI2, PI2 * 2);
#line 1753 "../src/nibbles-view.vala"
	cairo_arc (C, x + arc_radius, y + arc_radius, arc_radius - border_width, PI2 * 2, -PI2);
#line 1755 "../src/nibbles-view.vala"
	cairo_set_source_rgba (C, 0.125, 0.125, 0.125, (gdouble) 1);
#line 1756 "../src/nibbles-view.vala"
	cairo_fill (C);
#line 1758 "../src/nibbles-view.vala"
	line = 0;
#line 1759 "../src/nibbles-view.vala"
	y_line = (gdouble) 0;
#line 12485 "nibbles-view.c"
	{
		gchar* s = NULL;
		gchar* _tmp64_;
#line 1760 "../src/nibbles-view.vala"
		_tmp64_ = g_strdup (text);
#line 1760 "../src/nibbles-view.vala"
		s = _tmp64_;
#line 12493 "nibbles-view.c"
		{
			gboolean _tmp65_ = FALSE;
#line 1760 "../src/nibbles-view.vala"
			_tmp65_ = TRUE;
#line 1760 "../src/nibbles-view.vala"
			while (TRUE) {
#line 12500 "nibbles-view.c"
				const gchar* _tmp67_;
				gint _tmp68_;
				gint _tmp69_;
				guint new_line = 0U;
				const gchar* _tmp84_;
				gint _tmp85_;
				gint _tmp86_;
#line 1760 "../src/nibbles-view.vala"
				if (!_tmp65_) {
#line 12510 "nibbles-view.c"
					gint _tmp66_;
#line 1760 "../src/nibbles-view.vala"
					line = line + 1;
#line 1760 "../src/nibbles-view.vala"
					_tmp66_ = line;
#line 12516 "nibbles-view.c"
				}
#line 1760 "../src/nibbles-view.vala"
				_tmp65_ = FALSE;
#line 1760 "../src/nibbles-view.vala"
				_tmp67_ = s;
#line 1760 "../src/nibbles-view.vala"
				_tmp68_ = strlen (_tmp67_);
#line 1760 "../src/nibbles-view.vala"
				_tmp69_ = _tmp68_;
#line 1760 "../src/nibbles-view.vala"
				if (!(_tmp69_ > 0)) {
#line 1760 "../src/nibbles-view.vala"
					break;
#line 12530 "nibbles-view.c"
				}
				{
					gboolean _tmp70_ = FALSE;
#line 1763 "../src/nibbles-view.vala"
					new_line = (guint) 0;
#line 1763 "../src/nibbles-view.vala"
					_tmp70_ = TRUE;
#line 1763 "../src/nibbles-view.vala"
					while (TRUE) {
#line 12540 "nibbles-view.c"
						gboolean _tmp72_ = FALSE;
						const gchar* _tmp73_;
						gint _tmp74_;
						gint _tmp75_;
#line 1763 "../src/nibbles-view.vala"
						if (!_tmp70_) {
#line 12547 "nibbles-view.c"
							guint _tmp71_;
#line 1763 "../src/nibbles-view.vala"
							new_line = new_line + 1;
#line 1763 "../src/nibbles-view.vala"
							_tmp71_ = new_line;
#line 12553 "nibbles-view.c"
						}
#line 1763 "../src/nibbles-view.vala"
						_tmp70_ = FALSE;
#line 1763 "../src/nibbles-view.vala"
						_tmp73_ = s;
#line 1763 "../src/nibbles-view.vala"
						_tmp74_ = strlen (_tmp73_);
#line 1763 "../src/nibbles-view.vala"
						_tmp75_ = _tmp74_;
#line 1763 "../src/nibbles-view.vala"
						if (new_line < ((guint) _tmp75_)) {
#line 12565 "nibbles-view.c"
							const gchar* _tmp76_;
#line 1763 "../src/nibbles-view.vala"
							_tmp76_ = s;
#line 1763 "../src/nibbles-view.vala"
							_tmp72_ = string_get (_tmp76_, (glong) new_line) != '\n';
#line 12571 "nibbles-view.c"
						} else {
#line 1763 "../src/nibbles-view.vala"
							_tmp72_ = FALSE;
#line 12575 "nibbles-view.c"
						}
#line 1763 "../src/nibbles-view.vala"
						if (!_tmp72_) {
#line 1763 "../src/nibbles-view.vala"
							break;
#line 12581 "nibbles-view.c"
						}
					}
				}
#line 1764 "../src/nibbles-view.vala"
				if (new_line > ((guint) 0)) {
#line 12587 "nibbles-view.c"
					gdouble* _tmp77_;
					gint _tmp77__length1;
					gdouble _tmp78_;
					gchar* _text = NULL;
					const gchar* _tmp79_;
					gchar* _tmp80_;
					gdouble* _tmp81_;
					gint _tmp81__length1;
					gdouble _tmp82_;
					const gchar* _tmp83_;
#line 1766 "../src/nibbles-view.vala"
					_tmp77_ = line_height;
#line 1766 "../src/nibbles-view.vala"
					_tmp77__length1 = line_height_length1;
#line 1766 "../src/nibbles-view.vala"
					_tmp78_ = _tmp77_[line];
#line 1766 "../src/nibbles-view.vala"
					y_line += _tmp78_;
#line 1767 "../src/nibbles-view.vala"
					_tmp79_ = s;
#line 1767 "../src/nibbles-view.vala"
					_tmp80_ = string_slice (_tmp79_, (glong) 0, (glong) new_line);
#line 1767 "../src/nibbles-view.vala"
					_text = _tmp80_;
#line 1768 "../src/nibbles-view.vala"
					_tmp81_ = line_width;
#line 1768 "../src/nibbles-view.vala"
					_tmp81__length1 = line_width_length1;
#line 1768 "../src/nibbles-view.vala"
					_tmp82_ = _tmp81_[line];
#line 1768 "../src/nibbles-view.vala"
					_tmp83_ = _text;
#line 1768 "../src/nibbles-view.vala"
					nibbles_view_draw_dialogue_text (self, C, x + ((background_width - _tmp82_) / 2), (y + minimum_dimension) + y_line, _tmp83_, font_size);
#line 1764 "../src/nibbles-view.vala"
					_g_free0 (_text);
#line 12624 "nibbles-view.c"
				}
#line 1771 "../src/nibbles-view.vala"
				_tmp84_ = s;
#line 1771 "../src/nibbles-view.vala"
				_tmp85_ = strlen (_tmp84_);
#line 1771 "../src/nibbles-view.vala"
				_tmp86_ = _tmp85_;
#line 1771 "../src/nibbles-view.vala"
				if (((guint) _tmp86_) > (new_line + 1)) {
#line 12634 "nibbles-view.c"
					const gchar* _tmp87_;
					const gchar* _tmp88_;
					gint _tmp89_;
					gint _tmp90_;
					gchar* _tmp91_;
#line 1772 "../src/nibbles-view.vala"
					_tmp87_ = s;
#line 1772 "../src/nibbles-view.vala"
					_tmp88_ = s;
#line 1772 "../src/nibbles-view.vala"
					_tmp89_ = strlen (_tmp88_);
#line 1772 "../src/nibbles-view.vala"
					_tmp90_ = _tmp89_;
#line 1772 "../src/nibbles-view.vala"
					_tmp91_ = string_slice (_tmp87_, (glong) (new_line + 1), (glong) _tmp90_);
#line 1772 "../src/nibbles-view.vala"
					_g_free0 (s);
#line 1772 "../src/nibbles-view.vala"
					s = _tmp91_;
#line 12654 "nibbles-view.c"
				} else {
#line 1774 "../src/nibbles-view.vala"
					break;
#line 12658 "nibbles-view.c"
				}
			}
		}
#line 1760 "../src/nibbles-view.vala"
		_g_free0 (s);
#line 12664 "nibbles-view.c"
	}
#line 1778 "../src/nibbles-view.vala"
	if ((background_width / 5) > ((gdouble) 100)) {
#line 1778 "../src/nibbles-view.vala"
		_tmp92_ = background_width / 5;
#line 12670 "nibbles-view.c"
	} else {
#line 1778 "../src/nibbles-view.vala"
		_tmp92_ = (gdouble) 100;
#line 12674 "nibbles-view.c"
	}
#line 1778 "../src/nibbles-view.vala"
	button_width = _tmp92_;
#line 1779 "../src/nibbles-view.vala"
	_vala_b0_x = x + ((background_width - (button_width * 2)) / 3);
#line 1780 "../src/nibbles-view.vala"
	_vala_b0_y = ((y + background_height) - minimum_dimension) - button_height;
#line 1781 "../src/nibbles-view.vala"
	if (button_width < button_height) {
#line 1781 "../src/nibbles-view.vala"
		_tmp93_ = button_width / 3;
#line 12686 "nibbles-view.c"
	} else {
#line 1781 "../src/nibbles-view.vala"
		_tmp93_ = button_height / 3;
#line 12690 "nibbles-view.c"
	}
#line 1781 "../src/nibbles-view.vala"
	b0_radius = _tmp93_;
#line 1782 "../src/nibbles-view.vala"
	if (draw_buttons) {
#line 12696 "nibbles-view.c"
		gboolean _tmp94_ = FALSE;
		gchar* No = NULL;
		gchar* _tmp95_;
		const gchar* _tmp96_;
		gdouble _tmp97_ = 0.0;
		gdouble _tmp98_ = 0.0;
		gint _tmp99_;
		const gchar* _tmp100_;
#line 1784 "../src/nibbles-view.vala"
		cairo_move_to (C, _vala_b0_x + button_width, _vala_b0_y);
#line 1785 "../src/nibbles-view.vala"
		cairo_arc (C, (_vala_b0_x + button_width) - b0_radius, _vala_b0_y + b0_radius, b0_radius, -PI2, (gdouble) 0);
#line 1786 "../src/nibbles-view.vala"
		cairo_arc (C, (_vala_b0_x + button_width) - b0_radius, (_vala_b0_y + button_height) - b0_radius, b0_radius, (gdouble) 0, PI2);
#line 1787 "../src/nibbles-view.vala"
		cairo_arc (C, _vala_b0_x + b0_radius, (_vala_b0_y + button_height) - b0_radius, b0_radius, PI2, PI2 * 2);
#line 1788 "../src/nibbles-view.vala"
		cairo_arc (C, _vala_b0_x + b0_radius, _vala_b0_y + b0_radius, b0_radius, PI2 * 2, -PI2);
#line 1789 "../src/nibbles-view.vala"
		cairo_set_source_rgba (C, 0.5, 0.5, 0.5, (gdouble) 1);
#line 1790 "../src/nibbles-view.vala"
		cairo_fill (C);
#line 1791 "../src/nibbles-view.vala"
		cairo_arc (C, (_vala_b0_x + button_width) - b0_radius, _vala_b0_y + b0_radius, b0_radius - border_width, -PI2, (gdouble) 0);
#line 1792 "../src/nibbles-view.vala"
		cairo_arc (C, (_vala_b0_x + button_width) - b0_radius, (_vala_b0_y + button_height) - b0_radius, b0_radius - border_width, (gdouble) 0, PI2);
#line 1793 "../src/nibbles-view.vala"
		cairo_arc (C, _vala_b0_x + b0_radius, (_vala_b0_y + button_height) - b0_radius, b0_radius - border_width, PI2, PI2 * 2);
#line 1794 "../src/nibbles-view.vala"
		cairo_arc (C, _vala_b0_x + b0_radius, _vala_b0_y + b0_radius, b0_radius - border_width, PI2 * 2, -PI2);
#line 1795 "../src/nibbles-view.vala"
		if (self->priv->mouse_pressed) {
#line 1795 "../src/nibbles-view.vala"
			_tmp94_ = self->priv->mouse_button == ((guint) 0);
#line 12731 "nibbles-view.c"
		} else {
#line 1795 "../src/nibbles-view.vala"
			_tmp94_ = FALSE;
#line 12735 "nibbles-view.c"
		}
#line 1795 "../src/nibbles-view.vala"
		if (_tmp94_) {
#line 1796 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.063, 0.243, 0.459, (gdouble) 1);
#line 12741 "nibbles-view.c"
		} else {
#line 1798 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.082, 0.322, 0.612, (gdouble) 1);
#line 12745 "nibbles-view.c"
		}
#line 1799 "../src/nibbles-view.vala"
		cairo_fill (C);
#line 1801 "../src/nibbles-view.vala"
		_tmp95_ = g_strdup (_ ("No"));
#line 1801 "../src/nibbles-view.vala"
		No = _tmp95_;
#line 1802 "../src/nibbles-view.vala"
		_tmp96_ = No;
#line 1802 "../src/nibbles-view.vala"
		_tmp99_ = nibbles_view_calculate_font_size_from_max (self, C, _tmp96_, (gint) (button_width - (border_width * 2)), (gint) (button_height / 3), &_tmp97_, &_tmp98_);
#line 1802 "../src/nibbles-view.vala"
		_vala_b0_width = _tmp97_;
#line 1802 "../src/nibbles-view.vala"
		_vala_b0_height = _tmp98_;
#line 1802 "../src/nibbles-view.vala"
		font_size = _tmp99_;
#line 1803 "../src/nibbles-view.vala"
		_tmp100_ = No;
#line 1803 "../src/nibbles-view.vala"
		nibbles_view_draw_dialogue_text (self, C, _vala_b0_x + ((button_width - _vala_b0_width) / 2), (_vala_b0_y + _vala_b0_height) + (button_height / 3), _tmp100_, font_size);
#line 1782 "../src/nibbles-view.vala"
		_g_free0 (No);
#line 12769 "nibbles-view.c"
	}
#line 1806 "../src/nibbles-view.vala"
	_vala_b1_x = (x + (((background_width - (button_width * 2)) / 3) * 2)) + button_width;
#line 1807 "../src/nibbles-view.vala"
	_vala_b1_y = _vala_b0_y;
#line 1808 "../src/nibbles-view.vala"
	b1_radius = b0_radius;
#line 1809 "../src/nibbles-view.vala"
	if (draw_buttons) {
#line 12779 "nibbles-view.c"
		gboolean _tmp101_ = FALSE;
		gchar* Yes = NULL;
		gchar* _tmp102_;
		const gchar* _tmp103_;
		gdouble _tmp104_ = 0.0;
		gdouble _tmp105_ = 0.0;
		gint _tmp106_;
		const gchar* _tmp107_;
#line 1811 "../src/nibbles-view.vala"
		cairo_move_to (C, _vala_b1_x + button_width, _vala_b1_y);
#line 1812 "../src/nibbles-view.vala"
		cairo_arc (C, (_vala_b1_x + button_width) - b1_radius, _vala_b1_y + b1_radius, b1_radius, -PI2, (gdouble) 0);
#line 1813 "../src/nibbles-view.vala"
		cairo_arc (C, (_vala_b1_x + button_width) - b1_radius, (_vala_b1_y + button_height) - b1_radius, b1_radius, (gdouble) 0, PI2);
#line 1814 "../src/nibbles-view.vala"
		cairo_arc (C, _vala_b1_x + b1_radius, (_vala_b1_y + button_height) - b1_radius, b1_radius, PI2, PI2 * 2);
#line 1815 "../src/nibbles-view.vala"
		cairo_arc (C, _vala_b1_x + b1_radius, _vala_b1_y + b1_radius, b1_radius, PI2 * 2, -PI2);
#line 1816 "../src/nibbles-view.vala"
		cairo_set_source_rgba (C, 0.5, 0.5, 0.5, (gdouble) 1);
#line 1817 "../src/nibbles-view.vala"
		cairo_fill (C);
#line 1818 "../src/nibbles-view.vala"
		cairo_arc (C, (_vala_b1_x + button_width) - b1_radius, _vala_b1_y + b1_radius, b1_radius - border_width, -PI2, (gdouble) 0);
#line 1819 "../src/nibbles-view.vala"
		cairo_arc (C, (_vala_b1_x + button_width) - b1_radius, (_vala_b1_y + button_height) - b1_radius, b1_radius - border_width, (gdouble) 0, PI2);
#line 1820 "../src/nibbles-view.vala"
		cairo_arc (C, _vala_b1_x + b1_radius, (_vala_b1_y + button_height) - b1_radius, b1_radius - border_width, PI2, PI2 * 2);
#line 1821 "../src/nibbles-view.vala"
		cairo_arc (C, _vala_b1_x + b1_radius, _vala_b1_y + b1_radius, b1_radius - border_width, PI2 * 2, -PI2);
#line 1822 "../src/nibbles-view.vala"
		if (self->priv->mouse_pressed) {
#line 1822 "../src/nibbles-view.vala"
			_tmp101_ = self->priv->mouse_button == ((guint) 1);
#line 12814 "nibbles-view.c"
		} else {
#line 1822 "../src/nibbles-view.vala"
			_tmp101_ = FALSE;
#line 12818 "nibbles-view.c"
		}
#line 1822 "../src/nibbles-view.vala"
		if (_tmp101_) {
#line 1823 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.063, 0.243, 0.459, (gdouble) 1);
#line 12824 "nibbles-view.c"
		} else {
#line 1825 "../src/nibbles-view.vala"
			cairo_set_source_rgba (C, 0.082, 0.322, 0.612, (gdouble) 1);
#line 12828 "nibbles-view.c"
		}
#line 1826 "../src/nibbles-view.vala"
		cairo_fill (C);
#line 1828 "../src/nibbles-view.vala"
		_tmp102_ = g_strdup (_ ("Yes"));
#line 1828 "../src/nibbles-view.vala"
		Yes = _tmp102_;
#line 1829 "../src/nibbles-view.vala"
		_tmp103_ = Yes;
#line 1829 "../src/nibbles-view.vala"
		_tmp106_ = nibbles_view_calculate_font_size_from_max (self, C, _tmp103_, (gint) (button_width - (border_width * 2)), (gint) (button_height / 3), &_tmp104_, &_tmp105_);
#line 1829 "../src/nibbles-view.vala"
		_vala_b1_width = _tmp104_;
#line 1829 "../src/nibbles-view.vala"
		_vala_b1_height = _tmp105_;
#line 1829 "../src/nibbles-view.vala"
		font_size = _tmp106_;
#line 1830 "../src/nibbles-view.vala"
		_tmp107_ = Yes;
#line 1830 "../src/nibbles-view.vala"
		nibbles_view_draw_dialogue_text (self, C, _vala_b1_x + ((button_width - _vala_b1_width) / 2), (_vala_b1_y + _vala_b1_height) + (button_height / 3), _tmp107_, font_size);
#line 1809 "../src/nibbles-view.vala"
		_g_free0 (Yes);
#line 12852 "nibbles-view.c"
	}
#line 1834 "../src/nibbles-view.vala"
	_vala_b0_width = button_width;
#line 1835 "../src/nibbles-view.vala"
	_vala_b1_width = button_width;
#line 1836 "../src/nibbles-view.vala"
	_vala_b0_height = button_height;
#line 1837 "../src/nibbles-view.vala"
	_vala_b1_height = button_height;
#line 1671 "../src/nibbles-view.vala"
	line_height = (g_free (line_height), NULL);
#line 1671 "../src/nibbles-view.vala"
	line_width = (g_free (line_width), NULL);
#line 1671 "../src/nibbles-view.vala"
	if (b0_x) {
#line 1671 "../src/nibbles-view.vala"
		*b0_x = _vala_b0_x;
#line 12870 "nibbles-view.c"
	}
#line 1671 "../src/nibbles-view.vala"
	if (b0_y) {
#line 1671 "../src/nibbles-view.vala"
		*b0_y = _vala_b0_y;
#line 12876 "nibbles-view.c"
	}
#line 1671 "../src/nibbles-view.vala"
	if (b0_width) {
#line 1671 "../src/nibbles-view.vala"
		*b0_width = _vala_b0_width;
#line 12882 "nibbles-view.c"
	}
#line 1671 "../src/nibbles-view.vala"
	if (b0_height) {
#line 1671 "../src/nibbles-view.vala"
		*b0_height = _vala_b0_height;
#line 12888 "nibbles-view.c"
	}
#line 1671 "../src/nibbles-view.vala"
	if (b1_x) {
#line 1671 "../src/nibbles-view.vala"
		*b1_x = _vala_b1_x;
#line 12894 "nibbles-view.c"
	}
#line 1671 "../src/nibbles-view.vala"
	if (b1_y) {
#line 1671 "../src/nibbles-view.vala"
		*b1_y = _vala_b1_y;
#line 12900 "nibbles-view.c"
	}
#line 1671 "../src/nibbles-view.vala"
	if (b1_width) {
#line 1671 "../src/nibbles-view.vala"
		*b1_width = _vala_b1_width;
#line 12906 "nibbles-view.c"
	}
#line 1671 "../src/nibbles-view.vala"
	if (b1_height) {
#line 1671 "../src/nibbles-view.vala"
		*b1_height = _vala_b1_height;
#line 12912 "nibbles-view.c"
	}
}

static gint
nibbles_view_calculate_font_size (NibblesView* self,
                                  cairo_t* C,
                                  const gchar* text,
                                  gint target_width,
                                  gdouble* width,
                                  gdouble* height)
{
	gdouble _vala_width = 0.0;
	gdouble _vala_height = 0.0;
	gint target_font_size = 0;
	guint target_width_diff = 0U;
	gint result;
#line 1840 "../src/nibbles-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1840 "../src/nibbles-view.vala"
	g_return_val_if_fail (C != NULL, 0);
#line 1840 "../src/nibbles-view.vala"
	g_return_val_if_fail (text != NULL, 0);
#line 1842 "../src/nibbles-view.vala"
	target_font_size = 1;
#line 1843 "../src/nibbles-view.vala"
	target_width_diff = G_MAXUINT;
#line 1844 "../src/nibbles-view.vala"
	_vala_width = (gdouble) 0;
#line 1845 "../src/nibbles-view.vala"
	_vala_height = (gdouble) 0;
#line 12943 "nibbles-view.c"
	{
		gint font_size = 0;
#line 1847 "../src/nibbles-view.vala"
		font_size = 1;
#line 12948 "nibbles-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1847 "../src/nibbles-view.vala"
			_tmp0_ = TRUE;
#line 1847 "../src/nibbles-view.vala"
			while (TRUE) {
#line 12955 "nibbles-view.c"
				PangoLayout* layout = NULL;
				PangoLayout* _tmp1_;
				PangoFontDescription* font = NULL;
				PangoLayout* _tmp2_;
				PangoFontDescription* _tmp3_;
				PangoFontDescription* _tmp8_;
				PangoLayout* _tmp9_;
				PangoFontDescription* _tmp10_;
				PangoLayout* _tmp11_;
				PangoLayout* _tmp12_;
				PangoRectangle a = {0};
				PangoRectangle b = {0};
				PangoLayout* _tmp13_;
				PangoRectangle _tmp14_ = {0};
				PangoRectangle _tmp15_ = {0};
				PangoRectangle _tmp16_;
				PangoRectangle _tmp17_;
				guint width_diff = 0U;
				PangoRectangle _tmp18_;
				gboolean _tmp19_ = FALSE;
#line 1847 "../src/nibbles-view.vala"
				if (!_tmp0_) {
#line 12978 "nibbles-view.c"
				}
#line 1847 "../src/nibbles-view.vala"
				_tmp0_ = FALSE;
#line 1847 "../src/nibbles-view.vala"
				if (!(font_size < 200)) {
#line 1847 "../src/nibbles-view.vala"
					break;
#line 12986 "nibbles-view.c"
				}
#line 1849 "../src/nibbles-view.vala"
				_tmp1_ = pango_cairo_create_layout (C);
#line 1849 "../src/nibbles-view.vala"
				layout = _tmp1_;
#line 1851 "../src/nibbles-view.vala"
				_tmp2_ = layout;
#line 1851 "../src/nibbles-view.vala"
				_tmp3_ = pango_layout_get_font_description (_tmp2_);
#line 1851 "../src/nibbles-view.vala"
				if (NULL == _tmp3_) {
#line 12998 "nibbles-view.c"
					PangoFontDescription* _tmp4_;
#line 1852 "../src/nibbles-view.vala"
					_tmp4_ = pango_font_description_from_string ("Sans Bold 1pt");
#line 1852 "../src/nibbles-view.vala"
					__vala_PangoFontDescription_free0 (font);
#line 1852 "../src/nibbles-view.vala"
					font = _tmp4_;
#line 13006 "nibbles-view.c"
				} else {
					PangoLayout* _tmp5_;
					PangoFontDescription* _tmp6_;
					PangoFontDescription* _tmp7_;
#line 1854 "../src/nibbles-view.vala"
					_tmp5_ = layout;
#line 1854 "../src/nibbles-view.vala"
					_tmp6_ = pango_layout_get_font_description (_tmp5_);
#line 1854 "../src/nibbles-view.vala"
					_tmp7_ = pango_font_description_copy (_tmp6_);
#line 1854 "../src/nibbles-view.vala"
					__vala_PangoFontDescription_free0 (font);
#line 1854 "../src/nibbles-view.vala"
					font = _tmp7_;
#line 13021 "nibbles-view.c"
				}
#line 1855 "../src/nibbles-view.vala"
				_tmp8_ = font;
#line 1855 "../src/nibbles-view.vala"
				pango_font_description_set_size (_tmp8_, PANGO_SCALE * font_size);
#line 1856 "../src/nibbles-view.vala"
				_tmp9_ = layout;
#line 1856 "../src/nibbles-view.vala"
				_tmp10_ = font;
#line 1856 "../src/nibbles-view.vala"
				pango_layout_set_font_description (_tmp9_, _tmp10_);
#line 1857 "../src/nibbles-view.vala"
				_tmp11_ = layout;
#line 1857 "../src/nibbles-view.vala"
				pango_layout_set_text (_tmp11_, text, -1);
#line 1858 "../src/nibbles-view.vala"
				_tmp12_ = layout;
#line 1858 "../src/nibbles-view.vala"
				pango_cairo_update_layout (C, _tmp12_);
#line 1860 "../src/nibbles-view.vala"
				_tmp13_ = layout;
#line 1860 "../src/nibbles-view.vala"
				pango_layout_get_extents (_tmp13_, &_tmp14_, &_tmp15_);
#line 1860 "../src/nibbles-view.vala"
				a = _tmp14_;
#line 1860 "../src/nibbles-view.vala"
				b = _tmp15_;
#line 1861 "../src/nibbles-view.vala"
				_tmp16_ = a;
#line 1861 "../src/nibbles-view.vala"
				_vala_width = (gdouble) (_tmp16_.width / PANGO_SCALE);
#line 1862 "../src/nibbles-view.vala"
				_tmp17_ = a;
#line 1862 "../src/nibbles-view.vala"
				_vala_height = (gdouble) (_tmp17_.height / PANGO_SCALE);
#line 1863 "../src/nibbles-view.vala"
				_tmp18_ = a;
#line 1863 "../src/nibbles-view.vala"
				width_diff = (guint) abs (target_width - (((gint) _tmp18_.width) / PANGO_SCALE));
#line 1864 "../src/nibbles-view.vala"
				if (width_diff > target_width_diff) {
#line 1864 "../src/nibbles-view.vala"
					_tmp19_ = (width_diff - target_width_diff) > ((guint) 2);
#line 13065 "nibbles-view.c"
				} else {
#line 1864 "../src/nibbles-view.vala"
					_tmp19_ = FALSE;
#line 13069 "nibbles-view.c"
				}
#line 1864 "../src/nibbles-view.vala"
				if (_tmp19_) {
#line 1865 "../src/nibbles-view.vala"
					__vala_PangoFontDescription_free0 (font);
#line 1865 "../src/nibbles-view.vala"
					_g_object_unref0 (layout);
#line 1865 "../src/nibbles-view.vala"
					break;
#line 13079 "nibbles-view.c"
				} else {
#line 1866 "../src/nibbles-view.vala"
					if (width_diff < target_width_diff) {
#line 1868 "../src/nibbles-view.vala"
						target_width_diff = width_diff;
#line 1869 "../src/nibbles-view.vala"
						target_font_size = font_size;
#line 13087 "nibbles-view.c"
					}
				}
#line 1871 "../src/nibbles-view.vala"
				if (font_size < 20) {
#line 13092 "nibbles-view.c"
					gint _tmp20_;
#line 1872 "../src/nibbles-view.vala"
					_tmp20_ = font_size;
#line 1872 "../src/nibbles-view.vala"
					font_size = _tmp20_ + 1;
#line 13098 "nibbles-view.c"
				} else {
#line 1873 "../src/nibbles-view.vala"
					if (font_size < 50) {
#line 1874 "../src/nibbles-view.vala"
						font_size += 5;
#line 13104 "nibbles-view.c"
					} else {
#line 1876 "../src/nibbles-view.vala"
						font_size += 10;
#line 13108 "nibbles-view.c"
					}
				}
#line 1847 "../src/nibbles-view.vala"
				__vala_PangoFontDescription_free0 (font);
#line 1847 "../src/nibbles-view.vala"
				_g_object_unref0 (layout);
#line 13115 "nibbles-view.c"
			}
		}
	}
#line 1878 "../src/nibbles-view.vala"
	result = target_font_size;
#line 1878 "../src/nibbles-view.vala"
	if (width) {
#line 1878 "../src/nibbles-view.vala"
		*width = _vala_width;
#line 13125 "nibbles-view.c"
	}
#line 1878 "../src/nibbles-view.vala"
	if (height) {
#line 1878 "../src/nibbles-view.vala"
		*height = _vala_height;
#line 13131 "nibbles-view.c"
	}
#line 1878 "../src/nibbles-view.vala"
	return result;
#line 13135 "nibbles-view.c"
}

static gint
nibbles_view_calculate_font_size_from_max (NibblesView* self,
                                           cairo_t* C,
                                           const gchar* text,
                                           gint max_width,
                                           gint max_height,
                                           gdouble* width,
                                           gdouble* height)
{
	gdouble _vala_width = 0.0;
	gdouble _vala_height = 0.0;
	gint target_font_size = 0;
	gint result;
#line 1881 "../src/nibbles-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1881 "../src/nibbles-view.vala"
	g_return_val_if_fail (C != NULL, 0);
#line 1881 "../src/nibbles-view.vala"
	g_return_val_if_fail (text != NULL, 0);
#line 1883 "../src/nibbles-view.vala"
	target_font_size = 1;
#line 1884 "../src/nibbles-view.vala"
	_vala_width = (gdouble) 0;
#line 1885 "../src/nibbles-view.vala"
	_vala_height = (gdouble) 0;
#line 13163 "nibbles-view.c"
	{
		gint font_size = 0;
#line 1886 "../src/nibbles-view.vala"
		font_size = 1;
#line 13168 "nibbles-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1886 "../src/nibbles-view.vala"
			_tmp0_ = TRUE;
#line 1886 "../src/nibbles-view.vala"
			while (TRUE) {
#line 13175 "nibbles-view.c"
				PangoLayout* layout = NULL;
				PangoLayout* _tmp1_;
				PangoFontDescription* font = NULL;
				PangoLayout* _tmp2_;
				PangoFontDescription* _tmp3_;
				PangoFontDescription* _tmp8_;
				PangoLayout* _tmp9_;
				PangoFontDescription* _tmp10_;
				PangoLayout* _tmp11_;
				PangoLayout* _tmp12_;
				PangoRectangle a = {0};
				PangoRectangle b = {0};
				PangoLayout* _tmp13_;
				PangoRectangle _tmp14_ = {0};
				PangoRectangle _tmp15_ = {0};
				gboolean _tmp16_ = FALSE;
				PangoRectangle _tmp17_;
#line 1886 "../src/nibbles-view.vala"
				if (!_tmp0_) {
#line 13195 "nibbles-view.c"
				}
#line 1886 "../src/nibbles-view.vala"
				_tmp0_ = FALSE;
#line 1886 "../src/nibbles-view.vala"
				if (!(font_size < 200)) {
#line 1886 "../src/nibbles-view.vala"
					break;
#line 13203 "nibbles-view.c"
				}
#line 1888 "../src/nibbles-view.vala"
				_tmp1_ = pango_cairo_create_layout (C);
#line 1888 "../src/nibbles-view.vala"
				layout = _tmp1_;
#line 1890 "../src/nibbles-view.vala"
				_tmp2_ = layout;
#line 1890 "../src/nibbles-view.vala"
				_tmp3_ = pango_layout_get_font_description (_tmp2_);
#line 1890 "../src/nibbles-view.vala"
				if (NULL == _tmp3_) {
#line 13215 "nibbles-view.c"
					PangoFontDescription* _tmp4_;
#line 1891 "../src/nibbles-view.vala"
					_tmp4_ = pango_font_description_from_string ("Sans Bold 1pt");
#line 1891 "../src/nibbles-view.vala"
					__vala_PangoFontDescription_free0 (font);
#line 1891 "../src/nibbles-view.vala"
					font = _tmp4_;
#line 13223 "nibbles-view.c"
				} else {
					PangoLayout* _tmp5_;
					PangoFontDescription* _tmp6_;
					PangoFontDescription* _tmp7_;
#line 1893 "../src/nibbles-view.vala"
					_tmp5_ = layout;
#line 1893 "../src/nibbles-view.vala"
					_tmp6_ = pango_layout_get_font_description (_tmp5_);
#line 1893 "../src/nibbles-view.vala"
					_tmp7_ = pango_font_description_copy (_tmp6_);
#line 1893 "../src/nibbles-view.vala"
					__vala_PangoFontDescription_free0 (font);
#line 1893 "../src/nibbles-view.vala"
					font = _tmp7_;
#line 13238 "nibbles-view.c"
				}
#line 1894 "../src/nibbles-view.vala"
				_tmp8_ = font;
#line 1894 "../src/nibbles-view.vala"
				pango_font_description_set_size (_tmp8_, PANGO_SCALE * font_size);
#line 1895 "../src/nibbles-view.vala"
				_tmp9_ = layout;
#line 1895 "../src/nibbles-view.vala"
				_tmp10_ = font;
#line 1895 "../src/nibbles-view.vala"
				pango_layout_set_font_description (_tmp9_, _tmp10_);
#line 1896 "../src/nibbles-view.vala"
				_tmp11_ = layout;
#line 1896 "../src/nibbles-view.vala"
				pango_layout_set_text (_tmp11_, text, -1);
#line 1897 "../src/nibbles-view.vala"
				_tmp12_ = layout;
#line 1897 "../src/nibbles-view.vala"
				pango_cairo_update_layout (C, _tmp12_);
#line 1899 "../src/nibbles-view.vala"
				_tmp13_ = layout;
#line 1899 "../src/nibbles-view.vala"
				pango_layout_get_extents (_tmp13_, &_tmp14_, &_tmp15_);
#line 1899 "../src/nibbles-view.vala"
				a = _tmp14_;
#line 1899 "../src/nibbles-view.vala"
				b = _tmp15_;
#line 1900 "../src/nibbles-view.vala"
				_tmp17_ = a;
#line 1900 "../src/nibbles-view.vala"
				if ((_tmp17_.width / PANGO_SCALE) < max_width) {
#line 13270 "nibbles-view.c"
					PangoRectangle _tmp18_;
#line 1900 "../src/nibbles-view.vala"
					_tmp18_ = a;
#line 1900 "../src/nibbles-view.vala"
					_tmp16_ = (_tmp18_.height / PANGO_SCALE) < max_height;
#line 13276 "nibbles-view.c"
				} else {
#line 1900 "../src/nibbles-view.vala"
					_tmp16_ = FALSE;
#line 13280 "nibbles-view.c"
				}
#line 1900 "../src/nibbles-view.vala"
				if (_tmp16_) {
#line 13284 "nibbles-view.c"
					PangoRectangle _tmp19_;
					PangoRectangle _tmp20_;
#line 1902 "../src/nibbles-view.vala"
					_tmp19_ = a;
#line 1902 "../src/nibbles-view.vala"
					_vala_width = (gdouble) (_tmp19_.width / PANGO_SCALE);
#line 1903 "../src/nibbles-view.vala"
					_tmp20_ = a;
#line 1903 "../src/nibbles-view.vala"
					_vala_height = (gdouble) (_tmp20_.height / PANGO_SCALE);
#line 1904 "../src/nibbles-view.vala"
					target_font_size = font_size;
#line 13297 "nibbles-view.c"
				} else {
#line 1907 "../src/nibbles-view.vala"
					__vala_PangoFontDescription_free0 (font);
#line 1907 "../src/nibbles-view.vala"
					_g_object_unref0 (layout);
#line 1907 "../src/nibbles-view.vala"
					break;
#line 13305 "nibbles-view.c"
				}
#line 1908 "../src/nibbles-view.vala"
				if (font_size < 20) {
#line 13309 "nibbles-view.c"
					gint _tmp21_;
#line 1909 "../src/nibbles-view.vala"
					_tmp21_ = font_size;
#line 1909 "../src/nibbles-view.vala"
					font_size = _tmp21_ + 1;
#line 13315 "nibbles-view.c"
				} else {
#line 1910 "../src/nibbles-view.vala"
					if (font_size < 50) {
#line 1911 "../src/nibbles-view.vala"
						font_size += 5;
#line 13321 "nibbles-view.c"
					} else {
#line 1913 "../src/nibbles-view.vala"
						font_size += 10;
#line 13325 "nibbles-view.c"
					}
				}
#line 1886 "../src/nibbles-view.vala"
				__vala_PangoFontDescription_free0 (font);
#line 1886 "../src/nibbles-view.vala"
				_g_object_unref0 (layout);
#line 13332 "nibbles-view.c"
			}
		}
	}
#line 1915 "../src/nibbles-view.vala"
	result = target_font_size;
#line 1915 "../src/nibbles-view.vala"
	if (width) {
#line 1915 "../src/nibbles-view.vala"
		*width = _vala_width;
#line 13342 "nibbles-view.c"
	}
#line 1915 "../src/nibbles-view.vala"
	if (height) {
#line 1915 "../src/nibbles-view.vala"
		*height = _vala_height;
#line 13348 "nibbles-view.c"
	}
#line 1915 "../src/nibbles-view.vala"
	return result;
#line 13352 "nibbles-view.c"
}

static void
nibbles_view_draw_dialogue_text (NibblesView* self,
                                 cairo_t* C,
                                 gdouble x,
                                 gdouble y,
                                 const gchar* text,
                                 gint font_size)
{
	gint x_offset = 0;
	gint y_offset = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	PangoLayout* layout = NULL;
	PangoLayout* _tmp2_;
	PangoFontDescription* font = NULL;
	PangoLayout* _tmp3_;
	PangoFontDescription* _tmp4_;
	PangoFontDescription* _tmp9_;
	PangoLayout* _tmp10_;
	PangoFontDescription* _tmp11_;
	PangoLayout* _tmp12_;
	PangoLayout* _tmp13_;
	PangoLayout* _tmp14_;
#line 1918 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 1918 "../src/nibbles-view.vala"
	g_return_if_fail (C != NULL);
#line 1918 "../src/nibbles-view.vala"
	g_return_if_fail (text != NULL);
#line 1922 "../src/nibbles-view.vala"
	nibbles_view_get_text_offsets (self, C, text, font_size, &_tmp0_, &_tmp1_);
#line 1922 "../src/nibbles-view.vala"
	x_offset = _tmp0_;
#line 1922 "../src/nibbles-view.vala"
	y_offset = _tmp1_;
#line 1923 "../src/nibbles-view.vala"
	cairo_move_to (C, x - x_offset, y - y_offset);
#line 1924 "../src/nibbles-view.vala"
	cairo_set_source_rgb (C, 0.75, 0.75, 0.75);
#line 1925 "../src/nibbles-view.vala"
	_tmp2_ = pango_cairo_create_layout (C);
#line 1925 "../src/nibbles-view.vala"
	layout = _tmp2_;
#line 1927 "../src/nibbles-view.vala"
	_tmp3_ = layout;
#line 1927 "../src/nibbles-view.vala"
	_tmp4_ = pango_layout_get_font_description (_tmp3_);
#line 1927 "../src/nibbles-view.vala"
	if (NULL == _tmp4_) {
#line 13404 "nibbles-view.c"
		PangoFontDescription* _tmp5_;
#line 1928 "../src/nibbles-view.vala"
		_tmp5_ = pango_font_description_from_string ("Sans Bold 1pt");
#line 1928 "../src/nibbles-view.vala"
		__vala_PangoFontDescription_free0 (font);
#line 1928 "../src/nibbles-view.vala"
		font = _tmp5_;
#line 13412 "nibbles-view.c"
	} else {
		PangoLayout* _tmp6_;
		PangoFontDescription* _tmp7_;
		PangoFontDescription* _tmp8_;
#line 1930 "../src/nibbles-view.vala"
		_tmp6_ = layout;
#line 1930 "../src/nibbles-view.vala"
		_tmp7_ = pango_layout_get_font_description (_tmp6_);
#line 1930 "../src/nibbles-view.vala"
		_tmp8_ = pango_font_description_copy (_tmp7_);
#line 1930 "../src/nibbles-view.vala"
		__vala_PangoFontDescription_free0 (font);
#line 1930 "../src/nibbles-view.vala"
		font = _tmp8_;
#line 13427 "nibbles-view.c"
	}
#line 1931 "../src/nibbles-view.vala"
	_tmp9_ = font;
#line 1931 "../src/nibbles-view.vala"
	pango_font_description_set_size (_tmp9_, PANGO_SCALE * font_size);
#line 1932 "../src/nibbles-view.vala"
	_tmp10_ = layout;
#line 1932 "../src/nibbles-view.vala"
	_tmp11_ = font;
#line 1932 "../src/nibbles-view.vala"
	pango_layout_set_font_description (_tmp10_, _tmp11_);
#line 1933 "../src/nibbles-view.vala"
	_tmp12_ = layout;
#line 1933 "../src/nibbles-view.vala"
	pango_layout_set_text (_tmp12_, text, -1);
#line 1934 "../src/nibbles-view.vala"
	_tmp13_ = layout;
#line 1934 "../src/nibbles-view.vala"
	pango_cairo_update_layout (C, _tmp13_);
#line 1935 "../src/nibbles-view.vala"
	_tmp14_ = layout;
#line 1935 "../src/nibbles-view.vala"
	pango_cairo_show_layout (C, _tmp14_);
#line 1918 "../src/nibbles-view.vala"
	__vala_PangoFontDescription_free0 (font);
#line 1918 "../src/nibbles-view.vala"
	_g_object_unref0 (layout);
#line 13455 "nibbles-view.c"
}

gchar*
nibbles_view_colorval_name_untranslated (gint colorval)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 1961 "../src/nibbles-view.vala"
	_tmp0_ = nibbles_view_color_lookup;
#line 1961 "../src/nibbles-view.vala"
	_tmp0__length1 = nibbles_view_color_lookup_length1;
#line 1961 "../src/nibbles-view.vala"
	_tmp0__length2 = nibbles_view_color_lookup_length2;
#line 1961 "../src/nibbles-view.vala"
	_tmp1_ = _tmp0_[(colorval * _tmp0__length2) + 0];
#line 1961 "../src/nibbles-view.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 1961 "../src/nibbles-view.vala"
	result = _tmp2_;
#line 1961 "../src/nibbles-view.vala"
	return result;
#line 13481 "nibbles-view.c"
}

GtkImage*
nibbles_view_load_image_file (const gchar* pixmap,
                              gint xsize,
                              gint ysize)
{
	gchar* filename = NULL;
	gchar* _tmp0_;
	GtkImage* image = NULL;
	GtkImage* _tmp1_;
	GtkImage* result;
#line 1968 "../src/nibbles-view.vala"
	g_return_val_if_fail (pixmap != NULL, NULL);
#line 1970 "../src/nibbles-view.vala"
	_tmp0_ = g_build_filename (PKGDATADIR, "pixmaps", pixmap, NULL, NULL);
#line 1970 "../src/nibbles-view.vala"
	filename = _tmp0_;
#line 1971 "../src/nibbles-view.vala"
	if (filename == NULL) {
#line 1972 "../src/nibbles-view.vala"
		g_error ("nibbles-view.vala:1972: Nibbles couldn't find image file: %s", filename);
#line 13504 "nibbles-view.c"
	}
#line 1974 "../src/nibbles-view.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_file (filename);
#line 1974 "../src/nibbles-view.vala"
	g_object_ref_sink (_tmp1_);
#line 1974 "../src/nibbles-view.vala"
	image = _tmp1_;
#line 1976 "../src/nibbles-view.vala"
	result = image;
#line 1976 "../src/nibbles-view.vala"
	_g_free0 (filename);
#line 1976 "../src/nibbles-view.vala"
	return result;
#line 13518 "nibbles-view.c"
}

static inline gpointer
nibbles_view_view3_d_get_instance_private (NibblesViewView3D* self)
{
	return G_STRUCT_MEMBER_P (self, NibblesViewView3D_private_offset);
}

static void
nibbles_view_view3_d_set_view_plain (NibblesViewView3D* self,
                                     gdouble y)
{
#line 152 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/nibbles-view.vala"
	self->priv->view_plain_y = y;
#line 155 "../src/nibbles-view.vala"
	self->priv->has_view_plain_been_set = TRUE;
#line 13537 "nibbles-view.c"
}

static void
nibbles_view_view3_d_set_view_point (NibblesViewView3D* self,
                                     NibblesViewPoint3D* point,
                                     gdouble max_object_height)
{
	NibblesViewPoint3D _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 169 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/nibbles-view.vala"
	g_return_if_fail (point != NULL);
#line 172 "../src/nibbles-view.vala"
	_tmp0_ = *point;
#line 172 "../src/nibbles-view.vala"
	self->priv->view_point = _tmp0_;
#line 173 "../src/nibbles-view.vala"
	if (self->priv->has_view_plain_been_set) {
#line 173 "../src/nibbles-view.vala"
		_tmp1_ = !self->priv->has_view_plain_z_height_been_set;
#line 13559 "nibbles-view.c"
	} else {
#line 173 "../src/nibbles-view.vala"
		_tmp1_ = FALSE;
#line 13563 "nibbles-view.c"
	}
#line 173 "../src/nibbles-view.vala"
	if (_tmp1_) {
#line 13567 "nibbles-view.c"
		NibblesViewPoint3D _tmp2_;
		NibblesViewPoint3D _tmp3_;
#line 176 "../src/nibbles-view.vala"
		_tmp2_ = *point;
#line 176 "../src/nibbles-view.vala"
		_tmp3_ = *point;
#line 176 "../src/nibbles-view.vala"
		self->priv->view_plain_z_height = (((_tmp2_.z - max_object_height) * self->priv->view_plain_y) / _tmp3_.y) + max_object_height;
#line 13576 "nibbles-view.c"
	}
}

static void
nibbles_view_view3_d_set_scale_x (NibblesViewView3D* self,
                                  gdouble scale)
{
#line 180 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/nibbles-view.vala"
	self->priv->x_scale = scale;
#line 13588 "nibbles-view.c"
}

static void
nibbles_view_view3_d_set_scale_y (NibblesViewView3D* self,
                                  gdouble scale)
{
#line 185 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/nibbles-view.vala"
	self->priv->y_scale = scale;
#line 13599 "nibbles-view.c"
}

static void
nibbles_view_view3_d_to_view_plain (NibblesViewView3D* self,
                                    NibblesViewPoint3D* point,
                                    gdouble* x_at_plain,
                                    gdouble* z_at_plain)
{
	gdouble _vala_x_at_plain = 0.0;
	gdouble _vala_z_at_plain = 0.0;
	gdouble base_length = 0.0;
	NibblesViewPoint3D _tmp0_;
	NibblesViewPoint3D _tmp1_;
	NibblesViewPoint3D _tmp2_;
	NibblesViewPoint3D _tmp3_;
	NibblesViewPoint3D _tmp4_;
	NibblesViewPoint3D _tmp5_;
	NibblesViewPoint3D _tmp6_;
	NibblesViewPoint3D _tmp7_;
	gdouble z_length = 0.0;
	NibblesViewPoint3D _tmp8_;
	NibblesViewPoint3D _tmp9_;
	gdouble base_length_to_view_plain = 0.0;
	NibblesViewPoint3D _tmp10_;
	NibblesViewPoint3D _tmp11_;
	NibblesViewPoint3D _tmp12_;
	NibblesViewPoint3D _tmp13_;
	gdouble x_length = 0.0;
	NibblesViewPoint3D _tmp14_;
	NibblesViewPoint3D _tmp15_;
	NibblesViewPoint3D _tmp16_;
#line 190 "../src/nibbles-view.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/nibbles-view.vala"
	g_return_if_fail (point != NULL);
#line 192 "../src/nibbles-view.vala"
	_tmp0_ = self->priv->view_point;
#line 192 "../src/nibbles-view.vala"
	_tmp1_ = *point;
#line 192 "../src/nibbles-view.vala"
	_tmp2_ = self->priv->view_point;
#line 192 "../src/nibbles-view.vala"
	_tmp3_ = *point;
#line 192 "../src/nibbles-view.vala"
	_tmp4_ = self->priv->view_point;
#line 192 "../src/nibbles-view.vala"
	_tmp5_ = *point;
#line 192 "../src/nibbles-view.vala"
	_tmp6_ = self->priv->view_point;
#line 192 "../src/nibbles-view.vala"
	_tmp7_ = *point;
#line 192 "../src/nibbles-view.vala"
	base_length = sqrt (((_tmp0_.x - _tmp1_.x) * (_tmp2_.x - _tmp3_.x)) + ((_tmp4_.y - _tmp5_.y) * (_tmp6_.y - _tmp7_.y)));
#line 193 "../src/nibbles-view.vala"
	_tmp8_ = self->priv->view_point;
#line 193 "../src/nibbles-view.vala"
	_tmp9_ = *point;
#line 193 "../src/nibbles-view.vala"
	z_length = _tmp8_.z - _tmp9_.z;
#line 194 "../src/nibbles-view.vala"
	_tmp10_ = *point;
#line 194 "../src/nibbles-view.vala"
	_tmp11_ = self->priv->view_point;
#line 194 "../src/nibbles-view.vala"
	_tmp12_ = *point;
#line 194 "../src/nibbles-view.vala"
	base_length_to_view_plain = ((self->priv->view_plain_y - _tmp10_.y) / (_tmp11_.y - _tmp12_.y)) * base_length;
#line 195 "../src/nibbles-view.vala"
	_tmp13_ = *point;
#line 195 "../src/nibbles-view.vala"
	_vala_z_at_plain = (self->priv->view_plain_z_height - (_tmp13_.z + ((base_length_to_view_plain / base_length) * z_length))) * self->priv->y_scale;
#line 196 "../src/nibbles-view.vala"
	_tmp14_ = self->priv->view_point;
#line 196 "../src/nibbles-view.vala"
	_tmp15_ = *point;
#line 196 "../src/nibbles-view.vala"
	x_length = _tmp14_.x - _tmp15_.x;
#line 197 "../src/nibbles-view.vala"
	_tmp16_ = *point;
#line 197 "../src/nibbles-view.vala"
	_vala_x_at_plain = (_tmp16_.x + ((base_length_to_view_plain / base_length) * x_length)) * self->priv->x_scale;
#line 190 "../src/nibbles-view.vala"
	if (x_at_plain) {
#line 190 "../src/nibbles-view.vala"
		*x_at_plain = _vala_x_at_plain;
#line 13685 "nibbles-view.c"
	}
#line 190 "../src/nibbles-view.vala"
	if (z_at_plain) {
#line 190 "../src/nibbles-view.vala"
		*z_at_plain = _vala_z_at_plain;
#line 13691 "nibbles-view.c"
	}
}

static gdouble
nibbles_view_view3_d_view_point_x (NibblesViewView3D* self)
{
	NibblesViewPoint3D _tmp0_;
	gdouble result;
#line 200 "../src/nibbles-view.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 202 "../src/nibbles-view.vala"
	_tmp0_ = self->priv->view_point;
#line 202 "../src/nibbles-view.vala"
	result = _tmp0_.x;
#line 202 "../src/nibbles-view.vala"
	return result;
#line 13708 "nibbles-view.c"
}

static gdouble
nibbles_view_view3_d_2D_diff (NibblesViewView3D* self,
                              NibblesViewPoint3D* a,
                              NibblesViewPoint3D* b)
{
	gdouble ax = 0.0;
	gdouble ay = 0.0;
	gdouble bx = 0.0;
	gdouble by = 0.0;
	NibblesViewPoint3D _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	NibblesViewPoint3D _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble result;
#line 205 "../src/nibbles-view.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 205 "../src/nibbles-view.vala"
	g_return_val_if_fail (a != NULL, 0.0);
#line 205 "../src/nibbles-view.vala"
	g_return_val_if_fail (b != NULL, 0.0);
#line 208 "../src/nibbles-view.vala"
	_tmp0_ = *a;
#line 208 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (self, &_tmp0_, &_tmp1_, &_tmp2_);
#line 208 "../src/nibbles-view.vala"
	ax = _tmp1_;
#line 208 "../src/nibbles-view.vala"
	ay = _tmp2_;
#line 209 "../src/nibbles-view.vala"
	_tmp3_ = *b;
#line 209 "../src/nibbles-view.vala"
	nibbles_view_view3_d_to_view_plain (self, &_tmp3_, &_tmp4_, &_tmp5_);
#line 209 "../src/nibbles-view.vala"
	bx = _tmp4_;
#line 209 "../src/nibbles-view.vala"
	by = _tmp5_;
#line 210 "../src/nibbles-view.vala"
	result = sqrt (((ax - bx) * (ax - bx)) + ((ay - by) * (ay - by)));
#line 210 "../src/nibbles-view.vala"
	return result;
#line 13753 "nibbles-view.c"
}

static NibblesViewView3D*
nibbles_view_view3_d_construct (GType object_type)
{
	NibblesViewView3D* self = NULL;
#line 102 "../src/nibbles-view.vala"
	self = (NibblesViewView3D*) g_type_create_instance (object_type);
#line 102 "../src/nibbles-view.vala"
	return self;
#line 13764 "nibbles-view.c"
}

static NibblesViewView3D*
nibbles_view_view3_d_new (void)
{
#line 102 "../src/nibbles-view.vala"
	return nibbles_view_view3_d_construct (NIBBLES_VIEW_TYPE_VIEW3_D);
#line 13772 "nibbles-view.c"
}

static void
nibbles_view_value_view3_d_init (GValue* value)
{
#line 102 "../src/nibbles-view.vala"
	value->data[0].v_pointer = NULL;
#line 13780 "nibbles-view.c"
}

static void
nibbles_view_value_view3_d_free_value (GValue* value)
{
#line 102 "../src/nibbles-view.vala"
	if (value->data[0].v_pointer) {
#line 102 "../src/nibbles-view.vala"
		nibbles_view_view3_d_unref (value->data[0].v_pointer);
#line 13790 "nibbles-view.c"
	}
}

static void
nibbles_view_value_view3_d_copy_value (const GValue* src_value,
                                       GValue* dest_value)
{
#line 102 "../src/nibbles-view.vala"
	if (src_value->data[0].v_pointer) {
#line 102 "../src/nibbles-view.vala"
		dest_value->data[0].v_pointer = nibbles_view_view3_d_ref (src_value->data[0].v_pointer);
#line 13802 "nibbles-view.c"
	} else {
#line 102 "../src/nibbles-view.vala"
		dest_value->data[0].v_pointer = NULL;
#line 13806 "nibbles-view.c"
	}
}

static gpointer
nibbles_view_value_view3_d_peek_pointer (const GValue* value)
{
#line 102 "../src/nibbles-view.vala"
	return value->data[0].v_pointer;
#line 13815 "nibbles-view.c"
}

static gchar*
nibbles_view_value_view3_d_collect_value (GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
#line 102 "../src/nibbles-view.vala"
	if (collect_values[0].v_pointer) {
#line 13826 "nibbles-view.c"
		NibblesViewView3D * object;
		object = collect_values[0].v_pointer;
#line 102 "../src/nibbles-view.vala"
		if (object->parent_instance.g_class == NULL) {
#line 102 "../src/nibbles-view.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 13833 "nibbles-view.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 102 "../src/nibbles-view.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 13837 "nibbles-view.c"
		}
#line 102 "../src/nibbles-view.vala"
		value->data[0].v_pointer = nibbles_view_view3_d_ref (object);
#line 13841 "nibbles-view.c"
	} else {
#line 102 "../src/nibbles-view.vala"
		value->data[0].v_pointer = NULL;
#line 13845 "nibbles-view.c"
	}
#line 102 "../src/nibbles-view.vala"
	return NULL;
#line 13849 "nibbles-view.c"
}

static gchar*
nibbles_view_value_view3_d_lcopy_value (const GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	NibblesViewView3D ** object_p;
	object_p = collect_values[0].v_pointer;
#line 102 "../src/nibbles-view.vala"
	if (!object_p) {
#line 102 "../src/nibbles-view.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 13864 "nibbles-view.c"
	}
#line 102 "../src/nibbles-view.vala"
	if (!value->data[0].v_pointer) {
#line 102 "../src/nibbles-view.vala"
		*object_p = NULL;
#line 13870 "nibbles-view.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 102 "../src/nibbles-view.vala"
		*object_p = value->data[0].v_pointer;
#line 13874 "nibbles-view.c"
	} else {
#line 102 "../src/nibbles-view.vala"
		*object_p = nibbles_view_view3_d_ref (value->data[0].v_pointer);
#line 13878 "nibbles-view.c"
	}
#line 102 "../src/nibbles-view.vala"
	return NULL;
#line 13882 "nibbles-view.c"
}

static GParamSpec*
nibbles_view_param_spec_view3_d (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags)
{
	NibblesViewParamSpecView3D* spec;
#line 102 "../src/nibbles-view.vala"
	g_return_val_if_fail (g_type_is_a (object_type, NIBBLES_VIEW_TYPE_VIEW3_D), NULL);
#line 102 "../src/nibbles-view.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 102 "../src/nibbles-view.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 102 "../src/nibbles-view.vala"
	return G_PARAM_SPEC (spec);
#line 13901 "nibbles-view.c"
}

static gpointer
nibbles_view_value_get_view3_d (const GValue* value)
{
#line 102 "../src/nibbles-view.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NIBBLES_VIEW_TYPE_VIEW3_D), NULL);
#line 102 "../src/nibbles-view.vala"
	return value->data[0].v_pointer;
#line 13911 "nibbles-view.c"
}

static void
nibbles_view_value_set_view3_d (GValue* value,
                                gpointer v_object)
{
	NibblesViewView3D * old;
#line 102 "../src/nibbles-view.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NIBBLES_VIEW_TYPE_VIEW3_D));
#line 102 "../src/nibbles-view.vala"
	old = value->data[0].v_pointer;
#line 102 "../src/nibbles-view.vala"
	if (v_object) {
#line 102 "../src/nibbles-view.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NIBBLES_VIEW_TYPE_VIEW3_D));
#line 102 "../src/nibbles-view.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 102 "../src/nibbles-view.vala"
		value->data[0].v_pointer = v_object;
#line 102 "../src/nibbles-view.vala"
		nibbles_view_view3_d_ref (value->data[0].v_pointer);
#line 13933 "nibbles-view.c"
	} else {
#line 102 "../src/nibbles-view.vala"
		value->data[0].v_pointer = NULL;
#line 13937 "nibbles-view.c"
	}
#line 102 "../src/nibbles-view.vala"
	if (old) {
#line 102 "../src/nibbles-view.vala"
		nibbles_view_view3_d_unref (old);
#line 13943 "nibbles-view.c"
	}
}

static void
nibbles_view_value_take_view3_d (GValue* value,
                                 gpointer v_object)
{
	NibblesViewView3D * old;
#line 102 "../src/nibbles-view.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NIBBLES_VIEW_TYPE_VIEW3_D));
#line 102 "../src/nibbles-view.vala"
	old = value->data[0].v_pointer;
#line 102 "../src/nibbles-view.vala"
	if (v_object) {
#line 102 "../src/nibbles-view.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NIBBLES_VIEW_TYPE_VIEW3_D));
#line 102 "../src/nibbles-view.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 102 "../src/nibbles-view.vala"
		value->data[0].v_pointer = v_object;
#line 13964 "nibbles-view.c"
	} else {
#line 102 "../src/nibbles-view.vala"
		value->data[0].v_pointer = NULL;
#line 13968 "nibbles-view.c"
	}
#line 102 "../src/nibbles-view.vala"
	if (old) {
#line 102 "../src/nibbles-view.vala"
		nibbles_view_view3_d_unref (old);
#line 13974 "nibbles-view.c"
	}
}

static void
nibbles_view_view3_d_class_init (NibblesViewView3DClass * klass,
                                 gpointer klass_data)
{
#line 102 "../src/nibbles-view.vala"
	nibbles_view_view3_d_parent_class = g_type_class_peek_parent (klass);
#line 102 "../src/nibbles-view.vala"
	((NibblesViewView3DClass *) klass)->finalize = nibbles_view_view3_d_finalize;
#line 102 "../src/nibbles-view.vala"
	g_type_class_adjust_private_offset (klass, &NibblesViewView3D_private_offset);
#line 13988 "nibbles-view.c"
}

static void
nibbles_view_view3_d_instance_init (NibblesViewView3D * self,
                                    gpointer klass)
{
#line 102 "../src/nibbles-view.vala"
	self->priv = nibbles_view_view3_d_get_instance_private (self);
#line 142 "../src/nibbles-view.vala"
	self->priv->has_view_plain_been_set = FALSE;
#line 145 "../src/nibbles-view.vala"
	self->priv->has_view_plain_z_height_been_set = FALSE;
#line 149 "../src/nibbles-view.vala"
	self->priv->x_scale = (gdouble) 1;
#line 150 "../src/nibbles-view.vala"
	self->priv->y_scale = (gdouble) 1;
#line 102 "../src/nibbles-view.vala"
	self->ref_count = 1;
#line 14007 "nibbles-view.c"
}

static void
nibbles_view_view3_d_finalize (NibblesViewView3D * obj)
{
	NibblesViewView3D * self;
#line 102 "../src/nibbles-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NIBBLES_VIEW_TYPE_VIEW3_D, NibblesViewView3D);
#line 102 "../src/nibbles-view.vala"
	g_signal_handlers_destroy (self);
#line 14018 "nibbles-view.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_view_view3_d_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { nibbles_view_value_view3_d_init, nibbles_view_value_view3_d_free_value, nibbles_view_value_view3_d_copy_value, nibbles_view_value_view3_d_peek_pointer, "p", nibbles_view_value_view3_d_collect_value, "p", nibbles_view_value_view3_d_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (NibblesViewView3DClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_view_view3_d_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NibblesViewView3D), 0, (GInstanceInitFunc) nibbles_view_view3_d_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType nibbles_view_view3_d_type_id;
	nibbles_view_view3_d_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NibblesViewView3D", &g_define_type_info, &g_define_type_fundamental_info, 0);
	NibblesViewView3D_private_offset = g_type_add_instance_private (nibbles_view_view3_d_type_id, sizeof (NibblesViewView3DPrivate));
	return nibbles_view_view3_d_type_id;
}

static GType
nibbles_view_view3_d_get_type (void)
{
	static gsize nibbles_view_view3_d_type_id__once = 0;
	if (g_once_init_enter (&nibbles_view_view3_d_type_id__once)) {
		GType nibbles_view_view3_d_type_id;
		nibbles_view_view3_d_type_id = nibbles_view_view3_d_get_type_once ();
		g_once_init_leave (&nibbles_view_view3_d_type_id__once, nibbles_view_view3_d_type_id);
	}
	return nibbles_view_view3_d_type_id__once;
}

static gpointer
nibbles_view_view3_d_ref (gpointer instance)
{
	NibblesViewView3D * self;
	self = instance;
#line 102 "../src/nibbles-view.vala"
	g_atomic_int_inc (&self->ref_count);
#line 102 "../src/nibbles-view.vala"
	return instance;
#line 14054 "nibbles-view.c"
}

static void
nibbles_view_view3_d_unref (gpointer instance)
{
	NibblesViewView3D * self;
	self = instance;
#line 102 "../src/nibbles-view.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 102 "../src/nibbles-view.vala"
		NIBBLES_VIEW_VIEW3_D_GET_CLASS (self)->finalize (self);
#line 102 "../src/nibbles-view.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 14068 "nibbles-view.c"
	}
}

static NibblesViewPoint3D*
nibbles_view_point3_d_dup (const NibblesViewPoint3D* self)
{
	NibblesViewPoint3D* dup;
#line 96 "../src/nibbles-view.vala"
	dup = g_new0 (NibblesViewPoint3D, 1);
#line 96 "../src/nibbles-view.vala"
	memcpy (dup, self, sizeof (NibblesViewPoint3D));
#line 96 "../src/nibbles-view.vala"
	return dup;
#line 14082 "nibbles-view.c"
}

static void
nibbles_view_point3_d_free (NibblesViewPoint3D* self)
{
#line 96 "../src/nibbles-view.vala"
	g_free (self);
#line 14090 "nibbles-view.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_view_point3_d_get_type_once (void)
{
	GType nibbles_view_point3_d_type_id;
	nibbles_view_point3_d_type_id = g_boxed_type_register_static ("NibblesViewPoint3D", (GBoxedCopyFunc) nibbles_view_point3_d_dup, (GBoxedFreeFunc) nibbles_view_point3_d_free);
	return nibbles_view_point3_d_type_id;
}

static GType
nibbles_view_point3_d_get_type (void)
{
	static gsize nibbles_view_point3_d_type_id__once = 0;
	if (g_once_init_enter (&nibbles_view_point3_d_type_id__once)) {
		GType nibbles_view_point3_d_type_id;
		nibbles_view_point3_d_type_id = nibbles_view_point3_d_get_type_once ();
		g_once_init_leave (&nibbles_view_point3_d_type_id__once, nibbles_view_point3_d_type_id);
	}
	return nibbles_view_point3_d_type_id__once;
}

static void
nibbles_view_class_init (NibblesViewClass * klass,
                         gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
#line 93 "../src/nibbles-view.vala"
	nibbles_view_parent_class = g_type_class_peek_parent (klass);
#line 93 "../src/nibbles-view.vala"
	g_type_class_adjust_private_offset (klass, &NibblesView_private_offset);
#line 93 "../src/nibbles-view.vala"
	G_OBJECT_CLASS (klass)->finalize = nibbles_view_finalize;
#line 1943 "../src/nibbles-view.vala"
	_tmp0_ = g_strdup ("red");
#line 1943 "../src/nibbles-view.vala"
	_tmp1_ = g_strdup (N_ ("red"));
#line 1943 "../src/nibbles-view.vala"
	_tmp2_ = g_strdup ("green");
#line 1943 "../src/nibbles-view.vala"
	_tmp3_ = g_strdup (N_ ("green"));
#line 1943 "../src/nibbles-view.vala"
	_tmp4_ = g_strdup ("blue");
#line 1943 "../src/nibbles-view.vala"
	_tmp5_ = g_strdup (N_ ("blue"));
#line 1943 "../src/nibbles-view.vala"
	_tmp6_ = g_strdup ("yellow");
#line 1943 "../src/nibbles-view.vala"
	_tmp7_ = g_strdup (N_ ("yellow"));
#line 1943 "../src/nibbles-view.vala"
	_tmp8_ = g_strdup ("cyan");
#line 1943 "../src/nibbles-view.vala"
	_tmp9_ = g_strdup (N_ ("cyan"));
#line 1943 "../src/nibbles-view.vala"
	_tmp10_ = g_strdup ("purple");
#line 1943 "../src/nibbles-view.vala"
	_tmp11_ = g_strdup (N_ ("purple"));
#line 1943 "../src/nibbles-view.vala"
	_tmp12_ = g_new0 (gchar*, (6 * 2) + 1);
#line 1943 "../src/nibbles-view.vala"
	_tmp12_[0] = _tmp0_;
#line 1943 "../src/nibbles-view.vala"
	_tmp12_[1] = _tmp1_;
#line 1943 "../src/nibbles-view.vala"
	_tmp12_[2] = _tmp2_;
#line 1943 "../src/nibbles-view.vala"
	_tmp12_[3] = _tmp3_;
#line 1943 "../src/nibbles-view.vala"
	_tmp12_[4] = _tmp4_;
#line 1943 "../src/nibbles-view.vala"
	_tmp12_[5] = _tmp5_;
#line 1943 "../src/nibbles-view.vala"
	_tmp12_[6] = _tmp6_;
#line 1943 "../src/nibbles-view.vala"
	_tmp12_[7] = _tmp7_;
#line 1943 "../src/nibbles-view.vala"
	_tmp12_[8] = _tmp8_;
#line 1943 "../src/nibbles-view.vala"
	_tmp12_[9] = _tmp9_;
#line 1943 "../src/nibbles-view.vala"
	_tmp12_[10] = _tmp10_;
#line 1943 "../src/nibbles-view.vala"
	_tmp12_[11] = _tmp11_;
#line 1943 "../src/nibbles-view.vala"
	nibbles_view_color_lookup = _tmp12_;
#line 1943 "../src/nibbles-view.vala"
	nibbles_view_color_lookup_length1 = 6;
#line 1943 "../src/nibbles-view.vala"
	nibbles_view_color_lookup_length2 = 2;
#line 14192 "nibbles-view.c"
}

static void
nibbles_view_instance_init (NibblesView * self,
                            gpointer klass)
{
#line 93 "../src/nibbles-view.vala"
	self->priv = nibbles_view_get_instance_private (self);
#line 240 "../src/nibbles-view.vala"
	self->priv->animate = (guint64) 0;
#line 14203 "nibbles-view.c"
}

static void
nibbles_view_finalize (GObject * obj)
{
	NibblesView * self;
#line 93 "../src/nibbles-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_VIEW, NibblesView);
#line 219 "../src/nibbles-view.vala"
	_g_object_unref0 (self->priv->game);
#line 223 "../src/nibbles-view.vala"
	(self->priv->countdown_active_target_destroy_notify == NULL) ? NULL : (self->priv->countdown_active_target_destroy_notify (self->priv->countdown_active_target), NULL);
#line 223 "../src/nibbles-view.vala"
	self->priv->countdown_active = NULL;
#line 223 "../src/nibbles-view.vala"
	self->priv->countdown_active_target = NULL;
#line 223 "../src/nibbles-view.vala"
	self->priv->countdown_active_target_destroy_notify = NULL;
#line 224 "../src/nibbles-view.vala"
	(self->priv->new_game_dialogue_active_target_destroy_notify == NULL) ? NULL : (self->priv->new_game_dialogue_active_target_destroy_notify (self->priv->new_game_dialogue_active_target), NULL);
#line 224 "../src/nibbles-view.vala"
	self->priv->new_game_dialogue_active = NULL;
#line 224 "../src/nibbles-view.vala"
	self->priv->new_game_dialogue_active_target = NULL;
#line 224 "../src/nibbles-view.vala"
	self->priv->new_game_dialogue_active_target_destroy_notify = NULL;
#line 225 "../src/nibbles-view.vala"
	(self->priv->result_function_target_destroy_notify == NULL) ? NULL : (self->priv->result_function_target_destroy_notify (self->priv->result_function_target), NULL);
#line 225 "../src/nibbles-view.vala"
	self->priv->result_function = NULL;
#line 225 "../src/nibbles-view.vala"
	self->priv->result_function_target = NULL;
#line 225 "../src/nibbles-view.vala"
	self->priv->result_function_target_destroy_notify = NULL;
#line 93 "../src/nibbles-view.vala"
	G_OBJECT_CLASS (nibbles_view_parent_class)->finalize (obj);
#line 14240 "nibbles-view.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NibblesViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NibblesView), 0, (GInstanceInitFunc) nibbles_view_instance_init, NULL };
	GType nibbles_view_type_id;
	nibbles_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "NibblesView", &g_define_type_info, 0);
	NibblesView_private_offset = g_type_add_instance_private (nibbles_view_type_id, sizeof (NibblesViewPrivate));
	return nibbles_view_type_id;
}

GType
nibbles_view_get_type (void)
{
	static gsize nibbles_view_type_id__once = 0;
	if (g_once_init_enter (&nibbles_view_type_id__once)) {
		GType nibbles_view_type_id;
		nibbles_view_type_id = nibbles_view_get_type_once ();
		g_once_init_leave (&nibbles_view_type_id__once, nibbles_view_type_id);
	}
	return nibbles_view_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

