/* nibbles-window.c generated by valac 0.56.13, the Vala compiler
 * generated from nibbles-window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 * Copyright (C) 2023 Ben Corby <bcorby@new-ms.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Coding style.
 *
 * To help you comply with the coding style in this project use the
 * following greps. Any lines returned should be adjusted so they
 * don't match. The convoluted regular expressions are so they don't 
 * match them self.
 *
 * grep -ne '[^][)(_!$ "](' *.vala
 * grep -ne '[(] ' *.vala
 * grep -ne '[ ])' *.vala
 *
 */
/* designed for Gtk 4, link with libgtk-4-dev or gtk4-devel */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib.h>
#include <libgnome-games-support.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <gobject/gvaluecollector.h>

#define NIBBLES_WINDOW_COUNTDOWN_TIME 3
#define NIBBLES_PROGRAM_NAME _ ("Nibbles")
#define NIBBLES_GAME_MAX_LEVEL 26
#define NIBBLES_GAME_MAX_WORMS 6
#define NIBBLES_VIEW_WIDTH ((guint8) 92)
#define NIBBLES_VIEW_HEIGHT ((guint8) 66)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	SETUP_SCREEN_USUAL,
	SETUP_SCREEN_SPEED,
	SETUP_SCREEN_CONTROLS,
	SETUP_SCREEN_GAME
} SetupScreen;

#define TYPE_SETUP_SCREEN (setup_screen_get_type ())

#define TYPE_NIBBLES_WINDOW (nibbles_window_get_type ())
#define NIBBLES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIBBLES_WINDOW, NibblesWindow))
#define NIBBLES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIBBLES_WINDOW, NibblesWindowClass))
#define IS_NIBBLES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIBBLES_WINDOW))
#define IS_NIBBLES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIBBLES_WINDOW))
#define NIBBLES_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIBBLES_WINDOW, NibblesWindowClass))

typedef struct _NibblesWindow NibblesWindow;
typedef struct _NibblesWindowClass NibblesWindowClass;
typedef struct _NibblesWindowPrivate NibblesWindowPrivate;

#define TYPE_PLAYERS (players_get_type ())
#define PLAYERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PLAYERS, Players))
#define PLAYERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PLAYERS, PlayersClass))
#define IS_PLAYERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PLAYERS))
#define IS_PLAYERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PLAYERS))
#define PLAYERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PLAYERS, PlayersClass))

typedef struct _Players Players;
typedef struct _PlayersClass PlayersClass;

#define TYPE_SPEED (speed_get_type ())
#define SPEED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SPEED, Speed))
#define SPEED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SPEED, SpeedClass))
#define IS_SPEED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SPEED))
#define IS_SPEED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SPEED))
#define SPEED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SPEED, SpeedClass))

typedef struct _Speed Speed;
typedef struct _SpeedClass SpeedClass;

#define TYPE_CONTROLS (controls_get_type ())
#define CONTROLS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTROLS, Controls))
#define CONTROLS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTROLS, ControlsClass))
#define IS_CONTROLS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTROLS))
#define IS_CONTROLS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTROLS))
#define CONTROLS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTROLS, ControlsClass))

typedef struct _Controls Controls;
typedef struct _ControlsClass ControlsClass;

#define TYPE_SCOREBOARD (scoreboard_get_type ())
#define SCOREBOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCOREBOARD, Scoreboard))
#define SCOREBOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCOREBOARD, ScoreboardClass))
#define IS_SCOREBOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCOREBOARD))
#define IS_SCOREBOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCOREBOARD))
#define SCOREBOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCOREBOARD, ScoreboardClass))

typedef struct _Scoreboard Scoreboard;
typedef struct _ScoreboardClass ScoreboardClass;

#define TYPE_NIBBLES_VIEW (nibbles_view_get_type ())
#define NIBBLES_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIBBLES_VIEW, NibblesView))
#define NIBBLES_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIBBLES_VIEW, NibblesViewClass))
#define IS_NIBBLES_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIBBLES_VIEW))
#define IS_NIBBLES_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIBBLES_VIEW))
#define NIBBLES_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIBBLES_VIEW, NibblesViewClass))

typedef struct _NibblesView NibblesView;
typedef struct _NibblesViewClass NibblesViewClass;

#define TYPE_SOUND (sound_get_type ())
#define SOUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOUND, Sound))
#define SOUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOUND, SoundClass))
#define IS_SOUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOUND))
#define IS_SOUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOUND))
#define SOUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOUND, SoundClass))

typedef struct _Sound Sound;
typedef struct _SoundClass SoundClass;

#define NIBBLES_WINDOW_TYPE_DELEGATE_STACK (nibbles_window_delegate_stack_get_type ())
#define NIBBLES_WINDOW_DELEGATE_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NIBBLES_WINDOW_TYPE_DELEGATE_STACK, NibblesWindowDelegateStack))
#define NIBBLES_WINDOW_DELEGATE_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NIBBLES_WINDOW_TYPE_DELEGATE_STACK, NibblesWindowDelegateStackClass))
#define NIBBLES_WINDOW_IS_DELEGATE_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NIBBLES_WINDOW_TYPE_DELEGATE_STACK))
#define NIBBLES_WINDOW_IS_DELEGATE_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NIBBLES_WINDOW_TYPE_DELEGATE_STACK))
#define NIBBLES_WINDOW_DELEGATE_STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NIBBLES_WINDOW_TYPE_DELEGATE_STACK, NibblesWindowDelegateStackClass))

typedef struct _NibblesWindowDelegateStack NibblesWindowDelegateStack;
typedef struct _NibblesWindowDelegateStackClass NibblesWindowDelegateStackClass;

#define TYPE_NIBBLES_GAME (nibbles_game_get_type ())
#define NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIBBLES_GAME, NibblesGame))
#define NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIBBLES_GAME, NibblesGameClass))
#define IS_NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIBBLES_GAME))
#define IS_NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIBBLES_GAME))
#define NIBBLES_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIBBLES_GAME, NibblesGameClass))

typedef struct _NibblesGame NibblesGame;
typedef struct _NibblesGameClass NibblesGameClass;
enum  {
	NIBBLES_WINDOW_0_PROPERTY,
	NIBBLES_WINDOW_CLI_START_LEVEL_PROPERTY,
	NIBBLES_WINDOW_START_SCREEN_PROPERTY,
	NIBBLES_WINDOW_GAME_PAUSED_PROPERTY,
	NIBBLES_WINDOW_NUM_PROPERTIES
};
static GParamSpec* nibbles_window_properties[NIBBLES_WINDOW_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _nibbles_window_delegate_stack_unref0(var) ((var == NULL) ? NULL : (var = (nibbles_window_delegate_stack_unref (var), NULL)))

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;

#define TYPE_WORM_PROPERTIES (worm_properties_get_type ())
#define WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_PROPERTIES, WormProperties))
#define WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_PROPERTIES, WormPropertiesClass))
#define IS_WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_PROPERTIES))
#define IS_WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_PROPERTIES))
#define WORM_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_PROPERTIES, WormPropertiesClass))

typedef struct _WormProperties WormProperties;
typedef struct _WormPropertiesClass WormPropertiesClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block8Data Block8Data;
typedef void (*YesNoResultFunction) (guint yes_no, gpointer user_data);
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _Block9Data Block9Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block10Data Block10Data;
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
typedef struct _NibblesWindowDelegateStackPrivate NibblesWindowDelegateStackPrivate;

#define NIBBLES_WINDOW_DELEGATE_STACK_TYPE_NODE (nibbles_window_delegate_stack_node_get_type ())
typedef struct _NibblesWindowDelegateStackNode NibblesWindowDelegateStackNode;
typedef gboolean (*KeypressHandlerFunction) (guint a, guint b, gboolean* remove_handler, gpointer user_data);
#define _nibbles_window_delegate_stack_node_free0(var) ((var == NULL) ? NULL : (var = (nibbles_window_delegate_stack_node_free (var), NULL)))

#define NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR (nibbles_window_delegate_stack_delegate_stack_iterator_get_type ())
#define NIBBLES_WINDOW_DELEGATE_STACK_DELEGATE_STACK_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR, NibblesWindowDelegateStackDelegateStackIterator))
#define NIBBLES_WINDOW_DELEGATE_STACK_DELEGATE_STACK_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR, NibblesWindowDelegateStackDelegateStackIteratorClass))
#define NIBBLES_WINDOW_DELEGATE_STACK_IS_DELEGATE_STACK_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR))
#define NIBBLES_WINDOW_DELEGATE_STACK_IS_DELEGATE_STACK_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR))
#define NIBBLES_WINDOW_DELEGATE_STACK_DELEGATE_STACK_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR, NibblesWindowDelegateStackDelegateStackIteratorClass))

typedef struct _NibblesWindowDelegateStackDelegateStackIterator NibblesWindowDelegateStackDelegateStackIterator;
typedef struct _NibblesWindowDelegateStackDelegateStackIteratorClass NibblesWindowDelegateStackDelegateStackIteratorClass;
typedef struct _NibblesWindowDelegateStackDelegateStackIteratorPrivate NibblesWindowDelegateStackDelegateStackIteratorPrivate;
typedef struct _NibblesWindowDelegateStackParamSpecDelegateStackIterator NibblesWindowDelegateStackParamSpecDelegateStackIterator;
typedef struct _NibblesWindowParamSpecDelegateStack NibblesWindowParamSpecDelegateStack;
#define _nibbles_window_delegate_stack_delegate_stack_iterator_unref0(var) ((var == NULL) ? NULL : (var = (nibbles_window_delegate_stack_delegate_stack_iterator_unref (var), NULL)))
typedef gint (*NibblesViewCountdownActiveFunction) (gpointer user_data);
typedef gboolean (*NewGameDialogueActiveFunction) (YesNoResultFunction* function, gpointer* function_target, GDestroyNotify* function_target_destroy_notify, gpointer user_data);

#define TYPE_FIRST_RUN (first_run_get_type ())
#define FIRST_RUN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FIRST_RUN, FirstRun))
#define FIRST_RUN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FIRST_RUN, FirstRunClass))
#define IS_FIRST_RUN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FIRST_RUN))
#define IS_FIRST_RUN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FIRST_RUN))
#define FIRST_RUN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FIRST_RUN, FirstRunClass))

typedef struct _FirstRun FirstRun;
typedef struct _FirstRunClass FirstRunClass;
typedef struct _FirstRunPrivate FirstRunPrivate;
enum  {
	FIRST_RUN_0_PROPERTY,
	FIRST_RUN_NUM_PROPERTIES
};
static GParamSpec* first_run_properties[FIRST_RUN_NUM_PROPERTIES];
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NibblesWindow {
	GtkApplicationWindow parent_instance;
	NibblesWindowPrivate * priv;
};

struct _NibblesWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _NibblesWindowPrivate {
	GSettings* settings;
	GeeArrayList* worm_settings;
	GtkStack* main_stack;
	GtkOverlay* overlay;
	GtkHeaderBar* headerbar;
	GtkButton* new_game_button;
	GtkButton* pause_button;
	GtkMenuButton* hamburger_menu;
	Players* players;
	Speed* speed;
	Controls* controls;
	GtkStack* statusbar_stack;
	Scoreboard* scoreboard;
	GtkImage* scoreboard_life;
	NibblesView* view;
	GtkBox* game_box;
	Sound* sound;
	NibblesWindowDelegateStack* keypress_handlers;
	NibblesGame* game;
	gint _cli_start_level;
	SetupScreen _start_screen;
	GamesScoresContext* scores_context;
	GeeLinkedList* scorecats;
	GSimpleAction* new_game_action;
	GSimpleAction* pause_action;
	GSimpleAction* back_action;
	GSimpleAction* start_game_action;
	guint countdown_id;
	gint seconds;
	gboolean show_dialogue;
	GeeArrayList* overlay_members;
	gboolean end_of_game;
};

struct _Block8Data {
	int _ref_count_;
	NibblesWindow* self;
	GtkMessageDialog* dialog;
};

struct _Block9Data {
	int _ref_count_;
	NibblesWindow* self;
	glong lowest_high_score;
	gint score;
	gint level_reached;
};

struct _Block10Data {
	int _ref_count_;
	NibblesWindow* self;
	GtkButton* button;
};

struct _NibblesWindowDelegateStack {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NibblesWindowDelegateStackPrivate * priv;
};

struct _NibblesWindowDelegateStackClass {
	GTypeClass parent_class;
	void (*finalize) (NibblesWindowDelegateStack *self);
};

struct _NibblesWindowDelegateStackNode {
	KeypressHandlerFunction keypress_handler;
	gpointer keypress_handler_target;
	GDestroyNotify keypress_handler_target_destroy_notify;
	NibblesWindowDelegateStackNode* pNext;
};

struct _NibblesWindowDelegateStackPrivate {
	NibblesWindowDelegateStackNode* pHead;
};

struct _NibblesWindowDelegateStackDelegateStackIterator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NibblesWindowDelegateStackDelegateStackIteratorPrivate * priv;
};

struct _NibblesWindowDelegateStackDelegateStackIteratorClass {
	GTypeClass parent_class;
	void (*finalize) (NibblesWindowDelegateStackDelegateStackIterator *self);
};

struct _NibblesWindowDelegateStackDelegateStackIteratorPrivate {
	NibblesWindowDelegateStackNode* pIterator;
	gboolean first_next;
};

struct _NibblesWindowDelegateStackParamSpecDelegateStackIterator {
	GParamSpec parent_instance;
};

struct _NibblesWindowParamSpecDelegateStack {
	GParamSpec parent_instance;
};

struct _FirstRun {
	GtkBox parent_instance;
	FirstRunPrivate * priv;
};

struct _FirstRunClass {
	GtkBoxClass parent_class;
};

static gint NibblesWindow_private_offset;
static gpointer nibbles_window_parent_class = NULL;
static gint NibblesWindowDelegateStack_private_offset;
static gpointer nibbles_window_delegate_stack_parent_class = NULL;
static gint NibblesWindowDelegateStackDelegateStackIterator_private_offset;
static gpointer nibbles_window_delegate_stack_delegate_stack_iterator_parent_class = NULL;
static gpointer first_run_parent_class = NULL;

VALA_EXTERN GType setup_screen_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType nibbles_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesWindow, g_object_unref)
VALA_EXTERN GType players_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Players, g_object_unref)
VALA_EXTERN GType speed_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Speed, g_object_unref)
VALA_EXTERN GType controls_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Controls, g_object_unref)
VALA_EXTERN GType scoreboard_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Scoreboard, g_object_unref)
VALA_EXTERN GType nibbles_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesView, g_object_unref)
VALA_EXTERN GType sound_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Sound, g_object_unref)
static gpointer nibbles_window_delegate_stack_ref (gpointer instance);
static void nibbles_window_delegate_stack_unref (gpointer instance);
static GParamSpec* nibbles_window_param_spec_delegate_stack (const gchar* name,
                                                      const gchar* nick,
                                                      const gchar* blurb,
                                                      GType object_type,
                                                      GParamFlags flags) G_GNUC_UNUSED ;
static void nibbles_window_value_set_delegate_stack (GValue* value,
                                              gpointer v_object) G_GNUC_UNUSED ;
static void nibbles_window_value_take_delegate_stack (GValue* value,
                                               gpointer v_object) G_GNUC_UNUSED ;
static gpointer nibbles_window_value_get_delegate_stack (const GValue* value) G_GNUC_UNUSED ;
static GType nibbles_window_delegate_stack_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesWindowDelegateStack, nibbles_window_delegate_stack_unref)
VALA_EXTERN GType nibbles_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesGame, g_object_unref)
static void nibbles_window_new_game_cb (NibblesWindow* self);
static void _nibbles_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self);
static void nibbles_window_pause_cb (NibblesWindow* self);
static void _nibbles_window_pause_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void nibbles_window_scores_cb (NibblesWindow* self);
static void _nibbles_window_scores_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self);
static inline void nibbles_window_next_screen_cb (NibblesWindow* self);
static void _nibbles_window_next_screen_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static void nibbles_window_start_game (NibblesWindow* self);
static void _nibbles_window_start_game_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void nibbles_window_back_cb (NibblesWindow* self);
static void _nibbles_window_back_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self);
static NibblesWindowDelegateStack* nibbles_window_delegate_stack_new (void);
static NibblesWindowDelegateStack* nibbles_window_delegate_stack_construct (GType object_type);
static void nibbles_window_overlay_add (NibblesWindow* self,
                                 GtkWidget* widget);
static gboolean nibbles_window_overlay_remove_all (NibblesWindow* self);
VALA_EXTERN NibblesWindow* nibbles_window_new (gint cli_start_level,
                                   SetupScreen start_screen);
VALA_EXTERN NibblesWindow* nibbles_window_construct (GType object_type,
                                         gint cli_start_level,
                                         SetupScreen start_screen);
VALA_EXTERN void nibbles_window_on_shutdown (NibblesWindow* self);
VALA_EXTERN gint nibbles_game_get_speed (NibblesGame* self);
VALA_EXTERN gboolean nibbles_game_get_fakes (NibblesGame* self);
static gboolean nibbles_window_countdown_cb (NibblesWindow* self);
VALA_EXTERN void nibbles_view_redraw (NibblesView* self,
                          gboolean AnimateStep);
VALA_EXTERN void nibbles_game_start (NibblesGame* self,
                         gboolean add_initial_bonus);
VALA_EXTERN gboolean nibbles_game_get_paused (NibblesGame* self);
static void nibbles_window_set_pause_button_label (NibblesWindow* self,
                                            gboolean paused);
VALA_EXTERN void nibbles_game_reset (NibblesGame* self,
                         gint start_level);
static gint nibbles_window_get_start_level (NibblesWindow* self);
VALA_EXTERN void nibbles_game_new_level (NibblesGame* self,
                             gint level_id);
VALA_EXTERN gint nibbles_game_get_current_level (NibblesGame* self);
VALA_EXTERN void scoreboard_clear (Scoreboard* self);
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN GeeLinkedList* nibbles_game_get_worms (NibblesGame* self);
VALA_EXTERN GType worm_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormProperties, g_object_unref)
VALA_EXTERN GeeHashMap* nibbles_game_get_worm_props (NibblesGame* self);
VALA_EXTERN gint worm_properties_get_color (WormProperties* self);
VALA_EXTERN void scoreboard_register (Scoreboard* self,
                          Worm* worm,
                          const gchar* color_name,
                          GtkImage* life);
VALA_EXTERN gchar* nibbles_view_colorval_name_untranslated (gint colorval);
VALA_EXTERN void scoreboard_update (Scoreboard* self);
static void _scoreboard_update_g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
VALA_EXTERN void nibbles_game_add_worms (NibblesGame* self);
static void nibbles_window_show_game_view (NibblesWindow* self);
static void nibbles_window_start_game_with_countdown (NibblesWindow* self);
static gboolean _nibbles_window_countdown_cb_gsource_func (gpointer self);
static void nibbles_window_restart_game (NibblesWindow* self);
static void nibbles_window_show_new_game_screen (NibblesWindow* self,
                                          gboolean after_first_run);
static void nibbles_window_show_new_game_dialog (NibblesWindow* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
VALA_EXTERN gboolean nibbles_game_get_is_running (NibblesGame* self);
VALA_EXTERN void nibbles_game_stop (NibblesGame* self);
static void __lambda41_ (Block8Data* _data8_,
                  gint response_id);
static void ___lambda41__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static gboolean nibbles_window_new_game_dialogue_active (NibblesWindow* self,
                                                  YesNoResultFunction* result_function,
                                                  gpointer* result_function_target,
                                                  GDestroyNotify* result_function_target_destroy_notify);
static void __lambda42_ (NibblesWindow* self,
                  guint yes_no);
static void ___lambda42__yes_no_result_function (guint yes_no,
                                          gpointer self);
VALA_EXTERN void nibbles_game_set_paused (NibblesGame* self,
                              gboolean value);
static void nibbles_window_settings_changed_cb (NibblesWindow* self,
                                         const gchar* key);
VALA_EXTERN void nibbles_game_set_speed (NibblesGame* self,
                             gint value);
VALA_EXTERN void sound_set_muted (Sound* self,
                      gboolean muted);
VALA_EXTERN void nibbles_game_set_fakes (NibblesGame* self,
                             gboolean value);
VALA_EXTERN void nibbles_game_set_three_dimensional_view (NibblesGame* self,
                                              gboolean value);
static void nibbles_window_worm_settings_changed_cb (NibblesWindow* self,
                                              GSettings* changed_worm_settings,
                                              const gchar* key);
VALA_EXTERN gint nibbles_game_get_numworms (NibblesGame* self);
VALA_EXTERN void worm_properties_set_color (WormProperties* self,
                                gint value);
VALA_EXTERN void worm_properties_set_up (WormProperties* self,
                             guint value);
VALA_EXTERN void worm_properties_set_down (WormProperties* self,
                               guint value);
VALA_EXTERN void worm_properties_set_left (WormProperties* self,
                               guint value);
VALA_EXTERN void worm_properties_set_right (WormProperties* self,
                                guint value);
VALA_EXTERN void worm_properties_set_raw_up (WormProperties* self,
                                 gint value);
VALA_EXTERN gint worm_properties_get_raw_up (WormProperties* self);
static gint nibbles_window_get_raw_key (NibblesWindow* self,
                                 guint keyval);
VALA_EXTERN guint worm_properties_get_up (WormProperties* self);
VALA_EXTERN void worm_properties_set_raw_down (WormProperties* self,
                                   gint value);
VALA_EXTERN gint worm_properties_get_raw_down (WormProperties* self);
VALA_EXTERN guint worm_properties_get_down (WormProperties* self);
VALA_EXTERN void worm_properties_set_raw_left (WormProperties* self,
                                   gint value);
VALA_EXTERN gint worm_properties_get_raw_left (WormProperties* self);
VALA_EXTERN guint worm_properties_get_left (WormProperties* self);
VALA_EXTERN void worm_properties_set_raw_right (WormProperties* self,
                                    gint value);
VALA_EXTERN gint worm_properties_get_raw_right (WormProperties* self);
VALA_EXTERN guint worm_properties_get_right (WormProperties* self);
VALA_EXTERN gint nibbles_game_get_numhumans (NibblesGame* self);
static void nibbles_window_update_start_game_action (NibblesWindow* self);
static void nibbles_window_show_speed_screen (NibblesWindow* self);
static void nibbles_window_leave_speed_screen (NibblesWindow* self);
static void nibbles_window_show_controls_screen (NibblesWindow* self);
static void nibbles_window_set_headerbar_title (NibblesWindow* self,
                                         const gchar* title);
VALA_EXTERN void players_get_values (Players* self,
                         gint* players_number,
                         gint* number_of_ais);
VALA_EXTERN void nibbles_game_set_numhumans (NibblesGame* self,
                                 gint value);
VALA_EXTERN void nibbles_game_set_numai (NibblesGame* self,
                             gint value);
VALA_EXTERN void speed_get_values (Speed* self,
                       gint* speed,
                       gboolean* fakes);
VALA_EXTERN void controls_clean (Controls* self);
VALA_EXTERN void nibbles_game_create_worms (NibblesGame* self,
                                GeeArrayList* worm_settings);
VALA_EXTERN void controls_prepare (Controls* self,
                       GeeLinkedList* worms,
                       GeeHashMap* worms_props,
                       GeeList* worm_settings);
static GamesScoresCategory* nibbles_window_category_request (NibblesWindow* self,
                                                      const gchar* key);
static gchar* nibbles_window_get_new_scores_key (NibblesWindow* self,
                                          const gchar* old_key);
static void nibbles_window_create_scores (NibblesWindow* self);
static GamesScoresCategory* _nibbles_window_category_request_games_scores_context_category_request_func (const gchar* category_key,
                                                                                                  gpointer self);
static gchar* _nibbles_window_get_new_scores_key_games_scores_directory_importer_category_convert_func (const gchar* old_key,
                                                                                                 gpointer self);
static GamesScoresCategory* nibbles_window_get_scores_category (NibblesWindow* self,
                                                         gint speed,
                                                         gboolean fakes);
static void nibbles_window_log_score_cb (NibblesWindow* self,
                                  gint score,
                                  gint level_reached);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void nibbles_window_game_over (NibblesWindow* self,
                               gint score,
                               glong lowest_high_score,
                               gint level_reached);
VALA_EXTERN gboolean nibbles_game_get_skip_score (NibblesGame* self);
static void __lambda43_ (Block9Data* _data9_,
                  GObject* object,
                  GAsyncResult* _result_);
static void ___lambda43__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void nibbles_window_level_completed_cb (NibblesWindow* self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda44_ (NibblesWindow* self);
static void ___lambda44__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static gboolean __lambda45_ (Block10Data* _data10_);
static gboolean ___lambda45__gsource_func (gpointer self);
static gint nibbles_window_countdown_active (NibblesWindow* self);
static gint nibbles_window_get_cli_start_level (NibblesWindow* self);
static void nibbles_window_set_cli_start_level (NibblesWindow* self,
                                         gint value);
static SetupScreen nibbles_window_get_start_screen (NibblesWindow* self);
static void nibbles_window_set_start_screen (NibblesWindow* self,
                                      SetupScreen value);
VALA_EXTERN gboolean nibbles_window_get_game_paused (NibblesWindow* self);
static void nibbles_window_set_game_paused (NibblesWindow* self,
                                     gboolean value);
static GType nibbles_window_delegate_stack_node_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static NibblesWindowDelegateStackNode* nibbles_window_delegate_stack_node_dup (const NibblesWindowDelegateStackNode* self);
static void nibbles_window_delegate_stack_node_free (NibblesWindowDelegateStackNode* self);
static void nibbles_window_delegate_stack_node_copy (const NibblesWindowDelegateStackNode* self,
                                              NibblesWindowDelegateStackNode* dest);
static void nibbles_window_delegate_stack_node_destroy (NibblesWindowDelegateStackNode* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (NibblesWindowDelegateStackNode, nibbles_window_delegate_stack_node_destroy)
static void nibbles_window_delegate_stack_push (NibblesWindowDelegateStack* self,
                                         KeypressHandlerFunction handler,
                                         gpointer handler_target);
static gboolean nibbles_window_delegate_stack_pop (NibblesWindowDelegateStack* self);
static void nibbles_window_delegate_stack_remove (NibblesWindowDelegateStack* self,
                                           KeypressHandlerFunction handler,
                                           gpointer handler_target);
static gpointer nibbles_window_delegate_stack_delegate_stack_iterator_ref (gpointer instance);
static void nibbles_window_delegate_stack_delegate_stack_iterator_unref (gpointer instance);
static GParamSpec* nibbles_window_delegate_stack_param_spec_delegate_stack_iterator (const gchar* name,
                                                                              const gchar* nick,
                                                                              const gchar* blurb,
                                                                              GType object_type,
                                                                              GParamFlags flags) G_GNUC_UNUSED ;
static void nibbles_window_delegate_stack_value_set_delegate_stack_iterator (GValue* value,
                                                                      gpointer v_object) G_GNUC_UNUSED ;
static void nibbles_window_delegate_stack_value_take_delegate_stack_iterator (GValue* value,
                                                                       gpointer v_object) G_GNUC_UNUSED ;
static gpointer nibbles_window_delegate_stack_value_get_delegate_stack_iterator (const GValue* value) G_GNUC_UNUSED ;
VALA_EXTERN GType nibbles_window_delegate_stack_delegate_stack_iterator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesWindowDelegateStackDelegateStackIterator, nibbles_window_delegate_stack_delegate_stack_iterator_unref)
static NibblesWindowDelegateStackDelegateStackIterator* nibbles_window_delegate_stack_iterator (NibblesWindowDelegateStack* self);
static NibblesWindowDelegateStackDelegateStackIterator* nibbles_window_delegate_stack_delegate_stack_iterator_new (NibblesWindowDelegateStack* p);
static NibblesWindowDelegateStackDelegateStackIterator* nibbles_window_delegate_stack_delegate_stack_iterator_construct (GType object_type,
                                                                                                                  NibblesWindowDelegateStack* p);
static gboolean nibbles_window_delegate_stack_delegate_stack_iterator_next (NibblesWindowDelegateStackDelegateStackIterator* self);
static KeypressHandlerFunction nibbles_window_delegate_stack_delegate_stack_iterator_get (NibblesWindowDelegateStackDelegateStackIterator* self,
                                                                                   gpointer* result_target,
                                                                                   GDestroyNotify* result_target_destroy_notify);
static void nibbles_window_delegate_stack_delegate_stack_iterator_finalize (NibblesWindowDelegateStackDelegateStackIterator * obj);
static GType nibbles_window_delegate_stack_delegate_stack_iterator_get_type_once (void);
static void nibbles_window_delegate_stack_finalize (NibblesWindowDelegateStack * obj);
static GType nibbles_window_delegate_stack_get_type_once (void);
static GObject * nibbles_window_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _nibbles_window_settings_changed_cb_g_settings_changed (GSettings* _sender,
                                                             const gchar* key,
                                                             gpointer self);
static void _nibbles_window_worm_settings_changed_cb_g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self);
static void _nibbles_window___lambda46_ (NibblesWindow* self);
static void __nibbles_window___lambda46__gtk_popover_closed (GtkPopover* _sender,
                                                      gpointer self);
static gboolean _nibbles_window___lambda47_ (NibblesWindow* self,
                                      GtkEventControllerKey* controller,
                                      guint keyval,
                                      guint keycode,
                                      GdkModifierType state);
static gboolean __nibbles_window___lambda47__gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                            guint keyval,
                                                                            guint keycode,
                                                                            GdkModifierType state,
                                                                            gpointer self);
static void _nibbles_window___lambda48_ (NibblesWindow* self);
static void __nibbles_window___lambda48__gtk_event_controller_key_im_update (GtkEventControllerKey* _sender,
                                                                      gpointer self);
VALA_EXTERN Sound* sound_new (gboolean is_muted);
VALA_EXTERN Sound* sound_construct (GType object_type,
                        gboolean is_muted);
VALA_EXTERN NibblesGame* nibbles_game_new (gint start_level,
                               gint speed,
                               gint gamedelay,
                               gboolean fakes,
                               gboolean three_dimensional_view,
                               guint8 width,
                               guint8 height,
                               gboolean no_random);
VALA_EXTERN NibblesGame* nibbles_game_construct (GType object_type,
                                     gint start_level,
                                     gint speed,
                                     gint gamedelay,
                                     gboolean fakes,
                                     gboolean three_dimensional_view,
                                     guint8 width,
                                     guint8 height,
                                     gboolean no_random);
static void _nibbles_window_log_score_cb_nibbles_game_log_score (NibblesGame* _sender,
                                                          gint score,
                                                          gint level_reached,
                                                          gpointer self);
static void _nibbles_window_level_completed_cb_nibbles_game_level_completed (NibblesGame* _sender,
                                                                      gpointer self);
VALA_EXTERN void sound_connect_signal (Sound* self,
                           NibblesGame* game);
static gchar* _nibbles_window___lambda49_ (NibblesWindow* self);
static gchar* __nibbles_window___lambda49__nibbles_game_get_pkgdatadir (NibblesGame* _sender,
                                                                 gpointer self);
static gboolean _nibbles_window___lambda50_ (NibblesWindow* self,
                                      KeypressHandlerFunction handler,
                                      gpointer handler_target);
static gboolean __nibbles_window___lambda50__nibbles_game_add_keypress_handler (NibblesGame* _sender,
                                                                         KeypressHandlerFunction keypress_handler,
                                                                         gpointer keypress_handler_target,
                                                                         gpointer self);
static gint _nibbles_window_countdown_active_nibbles_view_countdown_active_function (gpointer self);
static gboolean _nibbles_window_new_game_dialogue_active_new_game_dialogue_active_function (YesNoResultFunction* function,
                                                                                     gpointer* function_target,
                                                                                     GDestroyNotify* function_target_destroy_notify,
                                                                                     gpointer self);
VALA_EXTERN NibblesView* nibbles_view_new (NibblesGame* game,
                               NibblesViewCountdownActiveFunction countdown_active,
                               gpointer countdown_active_target,
                               NewGameDialogueActiveFunction new_game_dialogue_active,
                               gpointer new_game_dialogue_active_target);
VALA_EXTERN NibblesView* nibbles_view_construct (GType object_type,
                                     NibblesGame* game,
                                     NibblesViewCountdownActiveFunction countdown_active,
                                     gpointer countdown_active_target,
                                     NewGameDialogueActiveFunction new_game_dialogue_active,
                                     gpointer new_game_dialogue_active_target);
VALA_EXTERN GtkImage* nibbles_view_load_image_file (const gchar* pixmap,
                                        gint xsize,
                                        gint ysize);
VALA_EXTERN void players_set_values (Players* self,
                         gint players_number,
                         gint number_of_ais);
VALA_EXTERN void speed_set_values (Speed* self,
                       gint speed,
                       gboolean fakes);
static void _nibbles_window___lambda51_ (NibblesWindow* self,
                                  KeypressHandlerFunction handler,
                                  gpointer handler_target);
static void __nibbles_window___lambda51__controls_add_keypress_handler (Controls* _sender,
                                                                 KeypressHandlerFunction handler,
                                                                 gpointer handler_target,
                                                                 gpointer self);
VALA_EXTERN GType first_run_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FirstRun, g_object_unref)
VALA_EXTERN FirstRun* first_run_new (void);
VALA_EXTERN FirstRun* first_run_construct (GType object_type);
static void nibbles_window_finalize (GObject * obj);
static GType nibbles_window_get_type_once (void);
static void _vala_nibbles_window_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_nibbles_window_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static GType first_run_get_type_once (void);

static const GActionEntry NIBBLES_WINDOW_menu_entries[6] = {{"new-game", _nibbles_window_new_game_cb_gsimple_action_activate_callback}, {"pause", _nibbles_window_pause_cb_gsimple_action_activate_callback}, {"scores", _nibbles_window_scores_cb_gsimple_action_activate_callback}, {"next-screen", _nibbles_window_next_screen_cb_gsimple_action_activate_callback}, {"start-game", _nibbles_window_start_game_gsimple_action_activate_callback}, {"back", _nibbles_window_back_cb_gsimple_action_activate_callback}};

 G_GNUC_NO_INLINE static GType
setup_screen_get_type_once (void)
{
	static const GEnumValue values[] = {{SETUP_SCREEN_USUAL, "SETUP_SCREEN_USUAL", "usual"}, {SETUP_SCREEN_SPEED, "SETUP_SCREEN_SPEED", "speed"}, {SETUP_SCREEN_CONTROLS, "SETUP_SCREEN_CONTROLS", "controls"}, {SETUP_SCREEN_GAME, "SETUP_SCREEN_GAME", "game"}, {0, NULL, NULL}};
	GType setup_screen_type_id;
	setup_screen_type_id = g_enum_register_static ("SetupScreen", values);
	return setup_screen_type_id;
}

GType
setup_screen_get_type (void)
{
	static gsize setup_screen_type_id__once = 0;
	if (g_once_init_enter (&setup_screen_type_id__once)) {
		GType setup_screen_type_id;
		setup_screen_type_id = setup_screen_get_type_once ();
		g_once_init_leave (&setup_screen_type_id__once, setup_screen_type_id);
	}
	return setup_screen_type_id__once;
}

static inline gpointer
nibbles_window_get_instance_private (NibblesWindow* self)
{
	return G_STRUCT_MEMBER_P (self, NibblesWindow_private_offset);
}

static void
_nibbles_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                              GVariant* parameter,
                                                              gpointer self)
{
#line 202 "../src/nibbles-window.vala"
	nibbles_window_new_game_cb ((NibblesWindow*) self);
#line 800 "nibbles-window.c"
}

static void
_nibbles_window_pause_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 202 "../src/nibbles-window.vala"
	nibbles_window_pause_cb ((NibblesWindow*) self);
#line 810 "nibbles-window.c"
}

static void
_nibbles_window_scores_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self)
{
#line 202 "../src/nibbles-window.vala"
	nibbles_window_scores_cb ((NibblesWindow*) self);
#line 820 "nibbles-window.c"
}

static void
_nibbles_window_next_screen_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 202 "../src/nibbles-window.vala"
	nibbles_window_next_screen_cb ((NibblesWindow*) self);
#line 830 "nibbles-window.c"
}

static void
_nibbles_window_start_game_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 202 "../src/nibbles-window.vala"
	nibbles_window_start_game ((NibblesWindow*) self);
#line 840 "nibbles-window.c"
}

static void
_nibbles_window_back_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                          GVariant* parameter,
                                                          gpointer self)
{
#line 202 "../src/nibbles-window.vala"
	nibbles_window_back_cb ((NibblesWindow*) self);
#line 850 "nibbles-window.c"
}

static void
nibbles_window_overlay_add (NibblesWindow* self,
                            GtkWidget* widget)
{
	GeeArrayList* _tmp0_;
	GtkOverlay* _tmp1_;
#line 214 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 214 "../src/nibbles-window.vala"
	g_return_if_fail (widget != NULL);
#line 216 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->overlay_members;
#line 216 "../src/nibbles-window.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, widget);
#line 217 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->overlay;
#line 217 "../src/nibbles-window.vala"
	gtk_overlay_add_overlay (_tmp1_, widget);
#line 871 "nibbles-window.c"
}

static gboolean
nibbles_window_overlay_remove_all (NibblesWindow* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 220 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 222 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->overlay_members;
#line 222 "../src/nibbles-window.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 222 "../src/nibbles-window.vala"
	_tmp2_ = _tmp1_;
#line 222 "../src/nibbles-window.vala"
	if (_tmp2_ == 0) {
#line 223 "../src/nibbles-window.vala"
		result = FALSE;
#line 223 "../src/nibbles-window.vala"
		return result;
#line 895 "nibbles-window.c"
	} else {
		{
			gint i = 0;
			GeeArrayList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
#line 226 "../src/nibbles-window.vala"
			_tmp3_ = self->priv->overlay_members;
#line 226 "../src/nibbles-window.vala"
			_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 226 "../src/nibbles-window.vala"
			_tmp5_ = _tmp4_;
#line 226 "../src/nibbles-window.vala"
			i = _tmp5_;
#line 910 "nibbles-window.c"
			{
				gboolean _tmp6_ = FALSE;
#line 226 "../src/nibbles-window.vala"
				_tmp6_ = TRUE;
#line 226 "../src/nibbles-window.vala"
				while (TRUE) {
#line 917 "nibbles-window.c"
					GtkOverlay* _tmp8_;
					GeeArrayList* _tmp9_;
					gpointer _tmp10_;
					GtkWidget* _tmp11_;
					GeeArrayList* _tmp12_;
					gpointer _tmp13_;
					GtkWidget* _tmp14_;
#line 226 "../src/nibbles-window.vala"
					if (!_tmp6_) {
#line 927 "nibbles-window.c"
						gint _tmp7_;
#line 226 "../src/nibbles-window.vala"
						i = i - 1;
#line 226 "../src/nibbles-window.vala"
						_tmp7_ = i;
#line 933 "nibbles-window.c"
					}
#line 226 "../src/nibbles-window.vala"
					_tmp6_ = FALSE;
#line 226 "../src/nibbles-window.vala"
					if (!(i > 0)) {
#line 226 "../src/nibbles-window.vala"
						break;
#line 941 "nibbles-window.c"
					}
#line 228 "../src/nibbles-window.vala"
					_tmp8_ = self->priv->overlay;
#line 228 "../src/nibbles-window.vala"
					_tmp9_ = self->priv->overlay_members;
#line 228 "../src/nibbles-window.vala"
					_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, i - 1);
#line 228 "../src/nibbles-window.vala"
					_tmp11_ = (GtkWidget*) _tmp10_;
#line 228 "../src/nibbles-window.vala"
					gtk_overlay_remove_overlay (_tmp8_, _tmp11_);
#line 228 "../src/nibbles-window.vala"
					_g_object_unref0 (_tmp11_);
#line 229 "../src/nibbles-window.vala"
					_tmp12_ = self->priv->overlay_members;
#line 229 "../src/nibbles-window.vala"
					_tmp13_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp12_, i - 1);
#line 229 "../src/nibbles-window.vala"
					_tmp14_ = (GtkWidget*) _tmp13_;
#line 229 "../src/nibbles-window.vala"
					_g_object_unref0 (_tmp14_);
#line 963 "nibbles-window.c"
				}
			}
		}
#line 231 "../src/nibbles-window.vala"
		result = TRUE;
#line 231 "../src/nibbles-window.vala"
		return result;
#line 971 "nibbles-window.c"
	}
}

NibblesWindow*
nibbles_window_construct (GType object_type,
                          gint cli_start_level,
                          SetupScreen start_screen)
{
	NibblesWindow * self = NULL;
#line 237 "../src/nibbles-window.vala"
	self = (NibblesWindow*) g_object_new (object_type, "cli-start-level", cli_start_level, "start-screen", start_screen, NULL);
#line 235 "../src/nibbles-window.vala"
	return self;
#line 985 "nibbles-window.c"
}

NibblesWindow*
nibbles_window_new (gint cli_start_level,
                    SetupScreen start_screen)
{
#line 235 "../src/nibbles-window.vala"
	return nibbles_window_construct (TYPE_NIBBLES_WINDOW, cli_start_level, start_screen);
#line 994 "nibbles-window.c"
}

void
nibbles_window_on_shutdown (NibblesWindow* self)
{
	GSettings* _tmp0_;
	gint window_width = 0;
	gint window_height = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GSettings* _tmp8_;
	NibblesGame* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GSettings* _tmp12_;
	NibblesGame* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	GSettings* _tmp16_;
#line 434 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 436 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->settings;
#line 436 "../src/nibbles-window.vala"
	g_settings_delay (_tmp0_);
#line 440 "../src/nibbles-window.vala"
	gtk_window_get_default_size ((GtkWindow*) self, &_tmp1_, &_tmp2_);
#line 440 "../src/nibbles-window.vala"
	window_width = _tmp1_;
#line 440 "../src/nibbles-window.vala"
	window_height = _tmp2_;
#line 441 "../src/nibbles-window.vala"
	_tmp3_ = self->priv->settings;
#line 441 "../src/nibbles-window.vala"
	g_settings_set_int (_tmp3_, "window-width", window_width);
#line 442 "../src/nibbles-window.vala"
	_tmp4_ = self->priv->settings;
#line 442 "../src/nibbles-window.vala"
	g_settings_set_int (_tmp4_, "window-height", window_height);
#line 443 "../src/nibbles-window.vala"
	_tmp5_ = self->priv->settings;
#line 443 "../src/nibbles-window.vala"
	g_object_get ((GtkWindow*) self, "maximized", &_tmp6_, NULL);
#line 443 "../src/nibbles-window.vala"
	_tmp7_ = _tmp6_;
#line 443 "../src/nibbles-window.vala"
	g_settings_set_boolean (_tmp5_, "window-is-maximized", _tmp7_);
#line 446 "../src/nibbles-window.vala"
	_tmp8_ = self->priv->settings;
#line 446 "../src/nibbles-window.vala"
	_tmp9_ = self->priv->game;
#line 446 "../src/nibbles-window.vala"
	_tmp10_ = nibbles_game_get_speed (_tmp9_);
#line 446 "../src/nibbles-window.vala"
	_tmp11_ = _tmp10_;
#line 446 "../src/nibbles-window.vala"
	g_settings_set_int (_tmp8_, "speed", _tmp11_);
#line 447 "../src/nibbles-window.vala"
	_tmp12_ = self->priv->settings;
#line 447 "../src/nibbles-window.vala"
	_tmp13_ = self->priv->game;
#line 447 "../src/nibbles-window.vala"
	_tmp14_ = nibbles_game_get_fakes (_tmp13_);
#line 447 "../src/nibbles-window.vala"
	_tmp15_ = _tmp14_;
#line 447 "../src/nibbles-window.vala"
	g_settings_set_boolean (_tmp12_, "fakes", _tmp15_);
#line 448 "../src/nibbles-window.vala"
	_tmp16_ = self->priv->settings;
#line 448 "../src/nibbles-window.vala"
	g_settings_apply (_tmp16_);
#line 1071 "nibbles-window.c"
}

static gboolean
nibbles_window_countdown_cb (NibblesWindow* self)
{
	gint _tmp0_;
	NibblesView* _tmp1_;
	gboolean result;
#line 451 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 453 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->seconds;
#line 453 "../src/nibbles-window.vala"
	self->priv->seconds = _tmp0_ - 1;
#line 454 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->view;
#line 454 "../src/nibbles-window.vala"
	nibbles_view_redraw (_tmp1_, FALSE);
#line 456 "../src/nibbles-window.vala"
	if (self->priv->seconds == 0) {
#line 1092 "nibbles-window.c"
		GtkStack* _tmp2_;
		NibblesGame* _tmp3_;
		GSimpleAction* _tmp4_;
#line 458 "../src/nibbles-window.vala"
		_tmp2_ = self->priv->statusbar_stack;
#line 458 "../src/nibbles-window.vala"
		gtk_stack_set_visible_child_name (_tmp2_, "scoreboard");
#line 460 "../src/nibbles-window.vala"
		_tmp3_ = self->priv->game;
#line 460 "../src/nibbles-window.vala"
		nibbles_game_start (_tmp3_, TRUE);
#line 462 "../src/nibbles-window.vala"
		_tmp4_ = self->priv->pause_action;
#line 462 "../src/nibbles-window.vala"
		g_simple_action_set_enabled (_tmp4_, TRUE);
#line 464 "../src/nibbles-window.vala"
		self->priv->countdown_id = (guint) 0;
#line 465 "../src/nibbles-window.vala"
		result = G_SOURCE_REMOVE;
#line 465 "../src/nibbles-window.vala"
		return result;
#line 1114 "nibbles-window.c"
	}
#line 468 "../src/nibbles-window.vala"
	result = G_SOURCE_CONTINUE;
#line 468 "../src/nibbles-window.vala"
	return result;
#line 1120 "nibbles-window.c"
}

static void
_scoreboard_update_g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
#line 490 "../src/nibbles-window.vala"
	scoreboard_update ((Scoreboard*) self);
#line 1130 "nibbles-window.c"
}

static void
nibbles_window_start_game (NibblesWindow* self)
{
	GSettings* _tmp0_;
	NibblesGame* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	NibblesGame* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	NibblesGame* _tmp7_;
	NibblesGame* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	Scoreboard* _tmp11_;
	NibblesGame* _tmp40_;
#line 475 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 477 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->settings;
#line 477 "../src/nibbles-window.vala"
	g_settings_set_boolean (_tmp0_, "first-run", FALSE);
#line 479 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->game;
#line 479 "../src/nibbles-window.vala"
	_tmp2_ = nibbles_game_get_paused (_tmp1_);
#line 479 "../src/nibbles-window.vala"
	_tmp3_ = _tmp2_;
#line 479 "../src/nibbles-window.vala"
	if (_tmp3_) {
#line 480 "../src/nibbles-window.vala"
		nibbles_window_set_pause_button_label (self, FALSE);
#line 1165 "nibbles-window.c"
	}
#line 481 "../src/nibbles-window.vala"
	_tmp4_ = self->priv->game;
#line 481 "../src/nibbles-window.vala"
	_tmp5_ = nibbles_window_get_start_level (self);
#line 481 "../src/nibbles-window.vala"
	_tmp6_ = _tmp5_;
#line 481 "../src/nibbles-window.vala"
	nibbles_game_reset (_tmp4_, _tmp6_);
#line 483 "../src/nibbles-window.vala"
	_tmp7_ = self->priv->game;
#line 483 "../src/nibbles-window.vala"
	_tmp8_ = self->priv->game;
#line 483 "../src/nibbles-window.vala"
	_tmp9_ = nibbles_game_get_current_level (_tmp8_);
#line 483 "../src/nibbles-window.vala"
	_tmp10_ = _tmp9_;
#line 483 "../src/nibbles-window.vala"
	nibbles_game_new_level (_tmp7_, _tmp10_);
#line 485 "../src/nibbles-window.vala"
	_tmp11_ = self->priv->scoreboard;
#line 485 "../src/nibbles-window.vala"
	scoreboard_clear (_tmp11_);
#line 1189 "nibbles-window.c"
	{
		GeeLinkedList* _worm_list = NULL;
		NibblesGame* _tmp12_;
		GeeLinkedList* _tmp13_;
		GeeLinkedList* _tmp14_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _worm_index = 0;
#line 486 "../src/nibbles-window.vala"
		_tmp12_ = self->priv->game;
#line 486 "../src/nibbles-window.vala"
		_tmp13_ = nibbles_game_get_worms (_tmp12_);
#line 486 "../src/nibbles-window.vala"
		_tmp14_ = _tmp13_;
#line 486 "../src/nibbles-window.vala"
		_worm_list = _tmp14_;
#line 486 "../src/nibbles-window.vala"
		_tmp15_ = _worm_list;
#line 486 "../src/nibbles-window.vala"
		_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 486 "../src/nibbles-window.vala"
		_tmp17_ = _tmp16_;
#line 486 "../src/nibbles-window.vala"
		_worm_size = _tmp17_;
#line 486 "../src/nibbles-window.vala"
		_worm_index = -1;
#line 486 "../src/nibbles-window.vala"
		while (TRUE) {
#line 1220 "nibbles-window.c"
			gint _tmp18_;
			gint _tmp19_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp20_;
			gpointer _tmp21_;
			gint color = 0;
			NibblesGame* _tmp22_;
			GeeHashMap* _tmp23_;
			GeeHashMap* _tmp24_;
			Worm* _tmp25_;
			gpointer _tmp26_;
			WormProperties* _tmp27_;
			gint _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			Scoreboard* _tmp31_;
			Worm* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			GtkImage* _tmp35_;
			Worm* _tmp36_;
			Scoreboard* _tmp37_;
			Worm* _tmp38_;
			Scoreboard* _tmp39_;
#line 486 "../src/nibbles-window.vala"
			_worm_index = _worm_index + 1;
#line 486 "../src/nibbles-window.vala"
			_tmp18_ = _worm_index;
#line 486 "../src/nibbles-window.vala"
			_tmp19_ = _worm_size;
#line 486 "../src/nibbles-window.vala"
			if (!(_tmp18_ < _tmp19_)) {
#line 486 "../src/nibbles-window.vala"
				break;
#line 1255 "nibbles-window.c"
			}
#line 486 "../src/nibbles-window.vala"
			_tmp20_ = _worm_list;
#line 486 "../src/nibbles-window.vala"
			_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _worm_index);
#line 486 "../src/nibbles-window.vala"
			worm = (Worm*) _tmp21_;
#line 488 "../src/nibbles-window.vala"
			_tmp22_ = self->priv->game;
#line 488 "../src/nibbles-window.vala"
			_tmp23_ = nibbles_game_get_worm_props (_tmp22_);
#line 488 "../src/nibbles-window.vala"
			_tmp24_ = _tmp23_;
#line 488 "../src/nibbles-window.vala"
			_tmp25_ = worm;
#line 488 "../src/nibbles-window.vala"
			_tmp26_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp24_, _tmp25_);
#line 488 "../src/nibbles-window.vala"
			_tmp27_ = (WormProperties*) _tmp26_;
#line 488 "../src/nibbles-window.vala"
			_tmp28_ = worm_properties_get_color (_tmp27_);
#line 488 "../src/nibbles-window.vala"
			_tmp29_ = _tmp28_;
#line 488 "../src/nibbles-window.vala"
			_tmp30_ = _tmp29_;
#line 488 "../src/nibbles-window.vala"
			_g_object_unref0 (_tmp27_);
#line 488 "../src/nibbles-window.vala"
			color = _tmp30_;
#line 489 "../src/nibbles-window.vala"
			_tmp31_ = self->priv->scoreboard;
#line 489 "../src/nibbles-window.vala"
			_tmp32_ = worm;
#line 489 "../src/nibbles-window.vala"
			_tmp33_ = nibbles_view_colorval_name_untranslated (color);
#line 489 "../src/nibbles-window.vala"
			_tmp34_ = _tmp33_;
#line 489 "../src/nibbles-window.vala"
			_tmp35_ = self->priv->scoreboard_life;
#line 489 "../src/nibbles-window.vala"
			scoreboard_register (_tmp31_, _tmp32_, _tmp34_, _tmp35_);
#line 489 "../src/nibbles-window.vala"
			_g_free0 (_tmp34_);
#line 490 "../src/nibbles-window.vala"
			_tmp36_ = worm;
#line 490 "../src/nibbles-window.vala"
			_tmp37_ = self->priv->scoreboard;
#line 490 "../src/nibbles-window.vala"
			g_signal_connect_object ((GObject*) _tmp36_, "notify::lives", (GCallback) _scoreboard_update_g_object_notify, _tmp37_, 0);
#line 491 "../src/nibbles-window.vala"
			_tmp38_ = worm;
#line 491 "../src/nibbles-window.vala"
			_tmp39_ = self->priv->scoreboard;
#line 491 "../src/nibbles-window.vala"
			g_signal_connect_object ((GObject*) _tmp38_, "notify::score", (GCallback) _scoreboard_update_g_object_notify, _tmp39_, 0);
#line 486 "../src/nibbles-window.vala"
			_g_object_unref0 (worm);
#line 1313 "nibbles-window.c"
		}
	}
#line 493 "../src/nibbles-window.vala"
	_tmp40_ = self->priv->game;
#line 493 "../src/nibbles-window.vala"
	nibbles_game_add_worms (_tmp40_);
#line 495 "../src/nibbles-window.vala"
	nibbles_window_show_game_view (self);
#line 497 "../src/nibbles-window.vala"
	nibbles_window_start_game_with_countdown (self);
#line 1324 "nibbles-window.c"
}

static gboolean
_nibbles_window_countdown_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = nibbles_window_countdown_cb ((NibblesWindow*) self);
#line 508 "../src/nibbles-window.vala"
	return result;
#line 1334 "nibbles-window.c"
}

static void
nibbles_window_start_game_with_countdown (NibblesWindow* self)
{
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
	NibblesView* _tmp2_;
#line 500 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 502 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->new_game_action;
#line 502 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp0_, TRUE);
#line 503 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->back_action;
#line 503 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp1_, TRUE);
#line 505 "../src/nibbles-window.vala"
	self->priv->seconds = NIBBLES_WINDOW_COUNTDOWN_TIME;
#line 506 "../src/nibbles-window.vala"
	_tmp2_ = self->priv->view;
#line 506 "../src/nibbles-window.vala"
	nibbles_view_redraw (_tmp2_, FALSE);
#line 508 "../src/nibbles-window.vala"
	self->priv->countdown_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _nibbles_window_countdown_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 1361 "nibbles-window.c"
}

static void
nibbles_window_restart_game (NibblesWindow* self)
{
	NibblesGame* _tmp0_;
	NibblesGame* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	NibblesGame* _tmp4_;
#line 511 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 513 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->game;
#line 513 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->game;
#line 513 "../src/nibbles-window.vala"
	_tmp2_ = nibbles_game_get_current_level (_tmp1_);
#line 513 "../src/nibbles-window.vala"
	_tmp3_ = _tmp2_;
#line 513 "../src/nibbles-window.vala"
	nibbles_game_new_level (_tmp0_, _tmp3_);
#line 515 "../src/nibbles-window.vala"
	_tmp4_ = self->priv->game;
#line 515 "../src/nibbles-window.vala"
	nibbles_game_add_worms (_tmp4_);
#line 516 "../src/nibbles-window.vala"
	nibbles_window_start_game_with_countdown (self);
#line 1390 "nibbles-window.c"
}

static void
nibbles_window_new_game_cb (NibblesWindow* self)
{
	gchar* child_name = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GQuark _tmp6_ = 0U;
#line 522 "../src/nibbles-window.vala"
	static GQuark _tmp5_label0 = 0;
#line 522 "../src/nibbles-window.vala"
	static GQuark _tmp5_label1 = 0;
#line 522 "../src/nibbles-window.vala"
	static GQuark _tmp5_label2 = 0;
#line 522 "../src/nibbles-window.vala"
	static GQuark _tmp5_label3 = 0;
#line 522 "../src/nibbles-window.vala"
	static GQuark _tmp5_label4 = 0;
#line 519 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 521 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->main_stack;
#line 521 "../src/nibbles-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 521 "../src/nibbles-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 521 "../src/nibbles-window.vala"
	child_name = _tmp2_;
#line 522 "../src/nibbles-window.vala"
	_tmp3_ = child_name;
#line 522 "../src/nibbles-window.vala"
	_tmp4_ = _tmp3_;
#line 522 "../src/nibbles-window.vala"
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
#line 522 "../src/nibbles-window.vala"
	if (((_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("first-run")))) || (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("number_of_players"))))) || (_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string ("speed"))))) {
#line 522 "../src/nibbles-window.vala"
		switch (0) {
#line 1433 "nibbles-window.c"
			default:
			{
#line 527 "../src/nibbles-window.vala"
				nibbles_window_next_screen_cb (self);
#line 528 "../src/nibbles-window.vala"
				break;
#line 1440 "nibbles-window.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label3) ? _tmp5_label3 : (_tmp5_label3 = g_quark_from_static_string ("controls")))) {
#line 522 "../src/nibbles-window.vala"
		switch (0) {
#line 1446 "nibbles-window.c"
			default:
			{
#line 530 "../src/nibbles-window.vala"
				nibbles_window_start_game (self);
#line 531 "../src/nibbles-window.vala"
				break;
#line 1453 "nibbles-window.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label4) ? _tmp5_label4 : (_tmp5_label4 = g_quark_from_static_string ("game_box")))) {
#line 522 "../src/nibbles-window.vala"
		switch (0) {
#line 1459 "nibbles-window.c"
			default:
			{
#line 533 "../src/nibbles-window.vala"
				nibbles_window_overlay_remove_all (self);
#line 534 "../src/nibbles-window.vala"
				if (self->priv->end_of_game) {
#line 1466 "nibbles-window.c"
					NibblesView* _tmp7_;
#line 536 "../src/nibbles-window.vala"
					_tmp7_ = self->priv->view;
#line 536 "../src/nibbles-window.vala"
					gtk_widget_show ((GtkWidget*) _tmp7_);
#line 537 "../src/nibbles-window.vala"
					self->priv->end_of_game = FALSE;
#line 539 "../src/nibbles-window.vala"
					nibbles_window_show_new_game_screen (self, FALSE);
#line 1476 "nibbles-window.c"
				} else {
#line 542 "../src/nibbles-window.vala"
					nibbles_window_show_new_game_dialog (self);
#line 1480 "nibbles-window.c"
				}
#line 543 "../src/nibbles-window.vala"
				break;
#line 1484 "nibbles-window.c"
			}
		}
	}
#line 519 "../src/nibbles-window.vala"
	_g_free0 (child_name);
#line 1490 "nibbles-window.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 546 "../src/nibbles-window.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 546 "../src/nibbles-window.vala"
	return _data8_;
#line 1500 "nibbles-window.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 546 "../src/nibbles-window.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 1510 "nibbles-window.c"
		NibblesWindow* self;
#line 546 "../src/nibbles-window.vala"
		self = _data8_->self;
#line 546 "../src/nibbles-window.vala"
		_g_object_unref0 (_data8_->dialog);
#line 546 "../src/nibbles-window.vala"
		_g_object_unref0 (self);
#line 546 "../src/nibbles-window.vala"
		g_slice_free (Block8Data, _data8_);
#line 1520 "nibbles-window.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 569 "../src/nibbles-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 1529 "nibbles-window.c"
}

static void
__lambda41_ (Block8Data* _data8_,
             gint response_id)
{
	NibblesWindow* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 572 "../src/nibbles-window.vala"
	self = _data8_->self;
#line 573 "../src/nibbles-window.vala"
	if (response_id == ((gint) GTK_RESPONSE_OK)) {
#line 574 "../src/nibbles-window.vala"
		nibbles_window_show_new_game_screen (self, FALSE);
#line 1545 "nibbles-window.c"
	}
#line 575 "../src/nibbles-window.vala"
	if (response_id == ((gint) GTK_RESPONSE_CANCEL)) {
#line 575 "../src/nibbles-window.vala"
		_tmp1_ = TRUE;
#line 1551 "nibbles-window.c"
	} else {
#line 575 "../src/nibbles-window.vala"
		_tmp1_ = response_id == ((gint) GTK_RESPONSE_DELETE_EVENT);
#line 1555 "nibbles-window.c"
	}
#line 575 "../src/nibbles-window.vala"
	if (_tmp1_) {
#line 1559 "nibbles-window.c"
		NibblesGame* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 576 "../src/nibbles-window.vala"
		_tmp2_ = self->priv->game;
#line 576 "../src/nibbles-window.vala"
		_tmp3_ = nibbles_game_get_paused (_tmp2_);
#line 576 "../src/nibbles-window.vala"
		_tmp4_ = _tmp3_;
#line 576 "../src/nibbles-window.vala"
		_tmp0_ = !_tmp4_;
#line 1571 "nibbles-window.c"
	} else {
#line 575 "../src/nibbles-window.vala"
		_tmp0_ = FALSE;
#line 1575 "nibbles-window.c"
	}
#line 575 "../src/nibbles-window.vala"
	if (_tmp0_) {
#line 1579 "nibbles-window.c"
		NibblesView* _tmp6_;
#line 578 "../src/nibbles-window.vala"
		if (self->priv->seconds == 0) {
#line 1583 "nibbles-window.c"
			NibblesGame* _tmp5_;
#line 579 "../src/nibbles-window.vala"
			_tmp5_ = self->priv->game;
#line 579 "../src/nibbles-window.vala"
			nibbles_game_start (_tmp5_, FALSE);
#line 1589 "nibbles-window.c"
		} else {
#line 581 "../src/nibbles-window.vala"
			self->priv->countdown_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _nibbles_window_countdown_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 1593 "nibbles-window.c"
		}
#line 583 "../src/nibbles-window.vala"
		_tmp6_ = self->priv->view;
#line 583 "../src/nibbles-window.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 1599 "nibbles-window.c"
	}
#line 586 "../src/nibbles-window.vala"
	gtk_window_destroy ((GtkWindow*) _data8_->dialog);
#line 1603 "nibbles-window.c"
}

static void
___lambda41__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 572 "../src/nibbles-window.vala"
	__lambda41_ (self, response_id);
#line 1613 "nibbles-window.c"
}

static void
nibbles_window_show_new_game_dialog (NibblesWindow* self)
{
	Block8Data* _data8_;
	NibblesGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkMessageDialog* _tmp4_;
	GtkButton* button = NULL;
	GtkWidget* _tmp5_;
	GtkButton* _tmp6_;
#line 546 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 546 "../src/nibbles-window.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 546 "../src/nibbles-window.vala"
	_data8_->_ref_count_ = 1;
#line 546 "../src/nibbles-window.vala"
	_data8_->self = g_object_ref (self);
#line 548 "../src/nibbles-window.vala"
	if (self->priv->countdown_id != ((guint) 0)) {
#line 550 "../src/nibbles-window.vala"
		g_source_remove (self->priv->countdown_id);
#line 551 "../src/nibbles-window.vala"
		self->priv->countdown_id = (guint) 0;
#line 1641 "nibbles-window.c"
	}
#line 554 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->game;
#line 554 "../src/nibbles-window.vala"
	_tmp1_ = nibbles_game_get_is_running (_tmp0_);
#line 554 "../src/nibbles-window.vala"
	_tmp2_ = _tmp1_;
#line 554 "../src/nibbles-window.vala"
	if (_tmp2_) {
#line 1651 "nibbles-window.c"
		NibblesGame* _tmp3_;
#line 555 "../src/nibbles-window.vala"
		_tmp3_ = self->priv->game;
#line 555 "../src/nibbles-window.vala"
		nibbles_game_stop (_tmp3_);
#line 1657 "nibbles-window.c"
	}
#line 561 "../src/nibbles-window.vala"
	_tmp4_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) self, GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK_CANCEL, "%s", _ ("Are you sure you want to start a new game?"));
#line 561 "../src/nibbles-window.vala"
	g_object_ref_sink (_tmp4_);
#line 561 "../src/nibbles-window.vala"
	_data8_->dialog = _tmp4_;
#line 568 "../src/nibbles-window.vala"
	g_object_set (_data8_->dialog, "secondary-text", _ ("If you start a new game, the current one will be lost."), NULL);
#line 569 "../src/nibbles-window.vala"
	_tmp5_ = gtk_dialog_get_widget_for_response ((GtkDialog*) _data8_->dialog, (gint) GTK_RESPONSE_OK);
#line 569 "../src/nibbles-window.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_button_get_type (), GtkButton));
#line 569 "../src/nibbles-window.vala"
	button = _tmp6_;
#line 571 "../src/nibbles-window.vala"
	gtk_button_set_label (button, _ ("_New Game"));
#line 572 "../src/nibbles-window.vala"
	g_signal_connect_data ((GtkDialog*) _data8_->dialog, "response", (GCallback) ___lambda41__gtk_dialog_response, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 588 "../src/nibbles-window.vala"
	gtk_widget_show ((GtkWidget*) _data8_->dialog);
#line 546 "../src/nibbles-window.vala"
	_g_object_unref0 (button);
#line 546 "../src/nibbles-window.vala"
	block8_data_unref (_data8_);
#line 546 "../src/nibbles-window.vala"
	_data8_ = NULL;
#line 1685 "nibbles-window.c"
}

static void
__lambda42_ (NibblesWindow* self,
             guint yes_no)
{
	NibblesView* _tmp0_;
#line 595 "../src/nibbles-window.vala"
	self->priv->show_dialogue = FALSE;
#line 596 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->view;
#line 596 "../src/nibbles-window.vala"
	nibbles_view_redraw (_tmp0_, FALSE);
#line 598 "../src/nibbles-window.vala"
	if (yes_no == ((guint) 0)) {
#line 599 "../src/nibbles-window.vala"
		nibbles_window_show_new_game_screen (self, FALSE);
#line 1703 "nibbles-window.c"
	} else {
#line 602 "../src/nibbles-window.vala"
		if (self->priv->seconds == 0) {
#line 1707 "nibbles-window.c"
			NibblesGame* _tmp1_;
#line 603 "../src/nibbles-window.vala"
			_tmp1_ = self->priv->game;
#line 603 "../src/nibbles-window.vala"
			nibbles_game_start (_tmp1_, FALSE);
#line 1713 "nibbles-window.c"
		} else {
#line 605 "../src/nibbles-window.vala"
			self->priv->countdown_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _nibbles_window_countdown_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 1717 "nibbles-window.c"
		}
	}
}

static void
___lambda42__yes_no_result_function (guint yes_no,
                                     gpointer self)
{
#line 593 "../src/nibbles-window.vala"
	__lambda42_ ((NibblesWindow*) self, yes_no);
#line 1728 "nibbles-window.c"
}

static gboolean
nibbles_window_new_game_dialogue_active (NibblesWindow* self,
                                         YesNoResultFunction* result_function,
                                         gpointer* result_function_target,
                                         GDestroyNotify* result_function_target_destroy_notify)
{
	YesNoResultFunction _vala_result_function = NULL;
	gpointer _vala_result_function_target = NULL;
	GDestroyNotify _vala_result_function_target_destroy_notify = NULL;
	gboolean result;
#line 591 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 593 "../src/nibbles-window.vala"
	(_vala_result_function_target_destroy_notify == NULL) ? NULL : (_vala_result_function_target_destroy_notify (_vala_result_function_target), NULL);
#line 593 "../src/nibbles-window.vala"
	_vala_result_function = NULL;
#line 593 "../src/nibbles-window.vala"
	_vala_result_function_target = NULL;
#line 593 "../src/nibbles-window.vala"
	_vala_result_function_target_destroy_notify = NULL;
#line 593 "../src/nibbles-window.vala"
	_vala_result_function = ___lambda42__yes_no_result_function;
#line 593 "../src/nibbles-window.vala"
	_vala_result_function_target = g_object_ref (self);
#line 593 "../src/nibbles-window.vala"
	_vala_result_function_target_destroy_notify = g_object_unref;
#line 608 "../src/nibbles-window.vala"
	result = self->priv->show_dialogue;
#line 608 "../src/nibbles-window.vala"
	if (result_function) {
#line 608 "../src/nibbles-window.vala"
		*result_function = _vala_result_function;
#line 608 "../src/nibbles-window.vala"
		*result_function_target = _vala_result_function_target;
#line 608 "../src/nibbles-window.vala"
		*result_function_target_destroy_notify = _vala_result_function_target_destroy_notify;
#line 1767 "nibbles-window.c"
	} else {
#line 608 "../src/nibbles-window.vala"
		(_vala_result_function_target_destroy_notify == NULL) ? NULL : (_vala_result_function_target_destroy_notify (_vala_result_function_target), NULL);
#line 608 "../src/nibbles-window.vala"
		_vala_result_function = NULL;
#line 608 "../src/nibbles-window.vala"
		_vala_result_function_target = NULL;
#line 608 "../src/nibbles-window.vala"
		_vala_result_function_target_destroy_notify = NULL;
#line 1777 "nibbles-window.c"
	}
#line 608 "../src/nibbles-window.vala"
	return result;
#line 1781 "nibbles-window.c"
}

static void
nibbles_window_pause_cb (NibblesWindow* self)
{
	NibblesGame* _tmp0_;
#line 611 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 613 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->game;
#line 613 "../src/nibbles-window.vala"
	if (_tmp0_ != NULL) {
#line 1794 "nibbles-window.c"
		NibblesGame* _tmp1_;
		NibblesGame* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		NibblesGame* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		NibblesGame* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 615 "../src/nibbles-window.vala"
		_tmp1_ = self->priv->game;
#line 615 "../src/nibbles-window.vala"
		_tmp2_ = self->priv->game;
#line 615 "../src/nibbles-window.vala"
		_tmp3_ = nibbles_game_get_is_running (_tmp2_);
#line 615 "../src/nibbles-window.vala"
		_tmp4_ = _tmp3_;
#line 615 "../src/nibbles-window.vala"
		nibbles_game_set_paused (_tmp1_, _tmp4_);
#line 616 "../src/nibbles-window.vala"
		_tmp5_ = self->priv->game;
#line 616 "../src/nibbles-window.vala"
		_tmp6_ = nibbles_game_get_paused (_tmp5_);
#line 616 "../src/nibbles-window.vala"
		_tmp7_ = _tmp6_;
#line 616 "../src/nibbles-window.vala"
		nibbles_window_set_pause_button_label (self, _tmp7_);
#line 617 "../src/nibbles-window.vala"
		_tmp8_ = self->priv->game;
#line 617 "../src/nibbles-window.vala"
		_tmp9_ = nibbles_game_get_paused (_tmp8_);
#line 617 "../src/nibbles-window.vala"
		_tmp10_ = _tmp9_;
#line 617 "../src/nibbles-window.vala"
		if (_tmp10_) {
#line 1831 "nibbles-window.c"
			GtkStack* _tmp11_;
#line 618 "../src/nibbles-window.vala"
			_tmp11_ = self->priv->statusbar_stack;
#line 618 "../src/nibbles-window.vala"
			gtk_stack_set_visible_child_name (_tmp11_, "paused");
#line 1837 "nibbles-window.c"
		} else {
			GtkStack* _tmp12_;
			NibblesView* _tmp13_;
#line 621 "../src/nibbles-window.vala"
			_tmp12_ = self->priv->statusbar_stack;
#line 621 "../src/nibbles-window.vala"
			gtk_stack_set_visible_child_name (_tmp12_, "scoreboard");
#line 622 "../src/nibbles-window.vala"
			_tmp13_ = self->priv->view;
#line 622 "../src/nibbles-window.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
#line 1849 "nibbles-window.c"
		}
	}
}

static void
nibbles_window_set_pause_button_label (NibblesWindow* self,
                                       gboolean paused)
{
#line 627 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 629 "../src/nibbles-window.vala"
	if (paused) {
#line 1862 "nibbles-window.c"
		GtkButton* _tmp0_;
#line 632 "../src/nibbles-window.vala"
		_tmp0_ = self->priv->pause_button;
#line 632 "../src/nibbles-window.vala"
		gtk_button_set_label (_tmp0_, _ ("_Resume"));
#line 1868 "nibbles-window.c"
	} else {
		GtkButton* _tmp1_;
#line 637 "../src/nibbles-window.vala"
		_tmp1_ = self->priv->pause_button;
#line 637 "../src/nibbles-window.vala"
		gtk_button_set_label (_tmp1_, _ ("_Pause"));
#line 1875 "nibbles-window.c"
	}
}

static void
nibbles_window_settings_changed_cb (NibblesWindow* self,
                                    const gchar* key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 647 "../src/nibbles-window.vala"
	static GQuark _tmp1_label0 = 0;
#line 647 "../src/nibbles-window.vala"
	static GQuark _tmp1_label1 = 0;
#line 647 "../src/nibbles-window.vala"
	static GQuark _tmp1_label2 = 0;
#line 647 "../src/nibbles-window.vala"
	static GQuark _tmp1_label3 = 0;
#line 645 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 645 "../src/nibbles-window.vala"
	g_return_if_fail (key != NULL);
#line 647 "../src/nibbles-window.vala"
	_tmp0_ = key;
#line 647 "../src/nibbles-window.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 647 "../src/nibbles-window.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("speed")))) {
#line 647 "../src/nibbles-window.vala"
		switch (0) {
#line 1905 "nibbles-window.c"
			default:
			{
				NibblesGame* _tmp3_;
				GSettings* _tmp4_;
#line 650 "../src/nibbles-window.vala"
				_tmp3_ = self->priv->game;
#line 650 "../src/nibbles-window.vala"
				_tmp4_ = self->priv->settings;
#line 650 "../src/nibbles-window.vala"
				nibbles_game_set_speed (_tmp3_, g_settings_get_int (_tmp4_, key));
#line 651 "../src/nibbles-window.vala"
				break;
#line 1918 "nibbles-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("sound")))) {
#line 647 "../src/nibbles-window.vala"
		switch (0) {
#line 1924 "nibbles-window.c"
			default:
			{
				Sound* _tmp5_;
				GSettings* _tmp6_;
#line 653 "../src/nibbles-window.vala"
				_tmp5_ = self->priv->sound;
#line 653 "../src/nibbles-window.vala"
				_tmp6_ = self->priv->settings;
#line 653 "../src/nibbles-window.vala"
				sound_set_muted (_tmp5_, !g_settings_get_boolean (_tmp6_, key));
#line 654 "../src/nibbles-window.vala"
				break;
#line 1937 "nibbles-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("fakes")))) {
#line 647 "../src/nibbles-window.vala"
		switch (0) {
#line 1943 "nibbles-window.c"
			default:
			{
				NibblesGame* _tmp7_;
				GSettings* _tmp8_;
#line 656 "../src/nibbles-window.vala"
				_tmp7_ = self->priv->game;
#line 656 "../src/nibbles-window.vala"
				_tmp8_ = self->priv->settings;
#line 656 "../src/nibbles-window.vala"
				nibbles_game_set_fakes (_tmp7_, g_settings_get_boolean (_tmp8_, key));
#line 657 "../src/nibbles-window.vala"
				break;
#line 1956 "nibbles-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("three-dimensional-view")))) {
#line 647 "../src/nibbles-window.vala"
		switch (0) {
#line 1962 "nibbles-window.c"
			default:
			{
				NibblesGame* _tmp9_;
				GSettings* _tmp10_;
#line 659 "../src/nibbles-window.vala"
				_tmp9_ = self->priv->game;
#line 659 "../src/nibbles-window.vala"
				_tmp10_ = self->priv->settings;
#line 659 "../src/nibbles-window.vala"
				nibbles_game_set_three_dimensional_view (_tmp9_, g_settings_get_boolean (_tmp10_, key));
#line 660 "../src/nibbles-window.vala"
				break;
#line 1975 "nibbles-window.c"
			}
		}
	}
}

static void
nibbles_window_worm_settings_changed_cb (NibblesWindow* self,
                                         GSettings* changed_worm_settings,
                                         const gchar* key)
{
	NibblesGame* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GeeArrayList* _tmp5_;
	gint id = 0;
	GeeArrayList* _tmp6_;
	NibblesGame* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	Worm* worm = NULL;
	NibblesGame* _tmp10_;
	GeeLinkedList* _tmp11_;
	GeeLinkedList* _tmp12_;
	gpointer _tmp13_;
	WormProperties* properties = NULL;
	NibblesGame* _tmp14_;
	GeeHashMap* _tmp15_;
	GeeHashMap* _tmp16_;
	Worm* _tmp17_;
	gpointer _tmp18_;
	const gchar* _tmp19_;
	GQuark _tmp21_ = 0U;
#line 679 "../src/nibbles-window.vala"
	static GQuark _tmp20_label0 = 0;
#line 679 "../src/nibbles-window.vala"
	static GQuark _tmp20_label1 = 0;
#line 679 "../src/nibbles-window.vala"
	static GQuark _tmp20_label2 = 0;
#line 679 "../src/nibbles-window.vala"
	static GQuark _tmp20_label3 = 0;
#line 679 "../src/nibbles-window.vala"
	static GQuark _tmp20_label4 = 0;
#line 679 "../src/nibbles-window.vala"
	static GQuark _tmp20_label5 = 0;
#line 679 "../src/nibbles-window.vala"
	static GQuark _tmp20_label6 = 0;
#line 679 "../src/nibbles-window.vala"
	static GQuark _tmp20_label7 = 0;
#line 679 "../src/nibbles-window.vala"
	static GQuark _tmp20_label8 = 0;
#line 2028 "nibbles-window.c"
	NibblesGame* _tmp59_;
	GeeHashMap* _tmp60_;
	GeeHashMap* _tmp61_;
	Worm* _tmp62_;
	WormProperties* _tmp63_;
	NibblesGame* _tmp64_;
	gint _tmp65_;
	gint _tmp66_;
#line 664 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 664 "../src/nibbles-window.vala"
	g_return_if_fail (changed_worm_settings != NULL);
#line 664 "../src/nibbles-window.vala"
	g_return_if_fail (key != NULL);
#line 667 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->game;
#line 667 "../src/nibbles-window.vala"
	_tmp1_ = nibbles_game_get_worm_props (_tmp0_);
#line 667 "../src/nibbles-window.vala"
	_tmp2_ = _tmp1_;
#line 667 "../src/nibbles-window.vala"
	_tmp3_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp2_);
#line 667 "../src/nibbles-window.vala"
	_tmp4_ = _tmp3_;
#line 667 "../src/nibbles-window.vala"
	if (_tmp4_ == 0) {
#line 668 "../src/nibbles-window.vala"
		return;
#line 2057 "nibbles-window.c"
	}
#line 670 "../src/nibbles-window.vala"
	_tmp5_ = self->priv->worm_settings;
#line 670 "../src/nibbles-window.vala"
	_vala_assert (_tmp5_ != NULL, "worm_settings != null");
#line 671 "../src/nibbles-window.vala"
	_tmp6_ = self->priv->worm_settings;
#line 671 "../src/nibbles-window.vala"
	id = gee_abstract_list_index_of ((GeeAbstractList*) _tmp6_, changed_worm_settings);
#line 673 "../src/nibbles-window.vala"
	_tmp7_ = self->priv->game;
#line 673 "../src/nibbles-window.vala"
	_tmp8_ = nibbles_game_get_numworms (_tmp7_);
#line 673 "../src/nibbles-window.vala"
	_tmp9_ = _tmp8_;
#line 673 "../src/nibbles-window.vala"
	if (id >= _tmp9_) {
#line 674 "../src/nibbles-window.vala"
		return;
#line 2077 "nibbles-window.c"
	}
#line 676 "../src/nibbles-window.vala"
	_tmp10_ = self->priv->game;
#line 676 "../src/nibbles-window.vala"
	_tmp11_ = nibbles_game_get_worms (_tmp10_);
#line 676 "../src/nibbles-window.vala"
	_tmp12_ = _tmp11_;
#line 676 "../src/nibbles-window.vala"
	_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, id);
#line 676 "../src/nibbles-window.vala"
	worm = (Worm*) _tmp13_;
#line 677 "../src/nibbles-window.vala"
	_tmp14_ = self->priv->game;
#line 677 "../src/nibbles-window.vala"
	_tmp15_ = nibbles_game_get_worm_props (_tmp14_);
#line 677 "../src/nibbles-window.vala"
	_tmp16_ = _tmp15_;
#line 677 "../src/nibbles-window.vala"
	_tmp17_ = worm;
#line 677 "../src/nibbles-window.vala"
	_tmp18_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp16_, _tmp17_);
#line 677 "../src/nibbles-window.vala"
	properties = (WormProperties*) _tmp18_;
#line 679 "../src/nibbles-window.vala"
	_tmp19_ = key;
#line 679 "../src/nibbles-window.vala"
	_tmp21_ = (NULL == _tmp19_) ? 0 : g_quark_from_string (_tmp19_);
#line 679 "../src/nibbles-window.vala"
	if (_tmp21_ == ((0 != _tmp20_label0) ? _tmp20_label0 : (_tmp20_label0 = g_quark_from_static_string ("color")))) {
#line 679 "../src/nibbles-window.vala"
		switch (0) {
#line 2109 "nibbles-window.c"
			default:
			{
				WormProperties* _tmp22_;
#line 682 "../src/nibbles-window.vala"
				_tmp22_ = properties;
#line 682 "../src/nibbles-window.vala"
				worm_properties_set_color (_tmp22_, g_settings_get_enum (changed_worm_settings, "color"));
#line 683 "../src/nibbles-window.vala"
				break;
#line 2119 "nibbles-window.c"
			}
		}
	} else if (_tmp21_ == ((0 != _tmp20_label1) ? _tmp20_label1 : (_tmp20_label1 = g_quark_from_static_string ("key-up")))) {
#line 679 "../src/nibbles-window.vala"
		switch (0) {
#line 2125 "nibbles-window.c"
			default:
			{
				WormProperties* _tmp23_;
#line 685 "../src/nibbles-window.vala"
				_tmp23_ = properties;
#line 685 "../src/nibbles-window.vala"
				worm_properties_set_up (_tmp23_, (guint) g_settings_get_int (changed_worm_settings, "key-up"));
#line 686 "../src/nibbles-window.vala"
				break;
#line 2135 "nibbles-window.c"
			}
		}
	} else if (_tmp21_ == ((0 != _tmp20_label2) ? _tmp20_label2 : (_tmp20_label2 = g_quark_from_static_string ("key-down")))) {
#line 679 "../src/nibbles-window.vala"
		switch (0) {
#line 2141 "nibbles-window.c"
			default:
			{
				WormProperties* _tmp24_;
#line 688 "../src/nibbles-window.vala"
				_tmp24_ = properties;
#line 688 "../src/nibbles-window.vala"
				worm_properties_set_down (_tmp24_, (guint) g_settings_get_int (changed_worm_settings, "key-down"));
#line 689 "../src/nibbles-window.vala"
				break;
#line 2151 "nibbles-window.c"
			}
		}
	} else if (_tmp21_ == ((0 != _tmp20_label3) ? _tmp20_label3 : (_tmp20_label3 = g_quark_from_static_string ("key-left")))) {
#line 679 "../src/nibbles-window.vala"
		switch (0) {
#line 2157 "nibbles-window.c"
			default:
			{
				WormProperties* _tmp25_;
#line 691 "../src/nibbles-window.vala"
				_tmp25_ = properties;
#line 691 "../src/nibbles-window.vala"
				worm_properties_set_left (_tmp25_, (guint) g_settings_get_int (changed_worm_settings, "key-left"));
#line 692 "../src/nibbles-window.vala"
				break;
#line 2167 "nibbles-window.c"
			}
		}
	} else if (_tmp21_ == ((0 != _tmp20_label4) ? _tmp20_label4 : (_tmp20_label4 = g_quark_from_static_string ("key-right")))) {
#line 679 "../src/nibbles-window.vala"
		switch (0) {
#line 2173 "nibbles-window.c"
			default:
			{
				WormProperties* _tmp26_;
#line 694 "../src/nibbles-window.vala"
				_tmp26_ = properties;
#line 694 "../src/nibbles-window.vala"
				worm_properties_set_right (_tmp26_, (guint) g_settings_get_int (changed_worm_settings, "key-right"));
#line 695 "../src/nibbles-window.vala"
				break;
#line 2183 "nibbles-window.c"
			}
		}
	} else if (_tmp21_ == ((0 != _tmp20_label5) ? _tmp20_label5 : (_tmp20_label5 = g_quark_from_static_string ("key-up-raw")))) {
#line 679 "../src/nibbles-window.vala"
		switch (0) {
#line 2189 "nibbles-window.c"
			default:
			{
				WormProperties* _tmp27_;
				WormProperties* _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
#line 697 "../src/nibbles-window.vala"
				_tmp27_ = properties;
#line 697 "../src/nibbles-window.vala"
				worm_properties_set_raw_up (_tmp27_, g_settings_get_int (changed_worm_settings, "key-up-raw"));
#line 698 "../src/nibbles-window.vala"
				_tmp28_ = properties;
#line 698 "../src/nibbles-window.vala"
				_tmp29_ = worm_properties_get_raw_up (_tmp28_);
#line 698 "../src/nibbles-window.vala"
				_tmp30_ = _tmp29_;
#line 698 "../src/nibbles-window.vala"
				if (_tmp30_ < 0) {
#line 2208 "nibbles-window.c"
					WormProperties* _tmp31_;
					WormProperties* _tmp32_;
					guint _tmp33_;
					guint _tmp34_;
#line 699 "../src/nibbles-window.vala"
					_tmp31_ = properties;
#line 699 "../src/nibbles-window.vala"
					_tmp32_ = properties;
#line 699 "../src/nibbles-window.vala"
					_tmp33_ = worm_properties_get_up (_tmp32_);
#line 699 "../src/nibbles-window.vala"
					_tmp34_ = _tmp33_;
#line 699 "../src/nibbles-window.vala"
					worm_properties_set_raw_up (_tmp31_, nibbles_window_get_raw_key (self, _tmp34_));
#line 2223 "nibbles-window.c"
				}
#line 700 "../src/nibbles-window.vala"
				break;
#line 2227 "nibbles-window.c"
			}
		}
	} else if (_tmp21_ == ((0 != _tmp20_label6) ? _tmp20_label6 : (_tmp20_label6 = g_quark_from_static_string ("key-down-raw")))) {
#line 679 "../src/nibbles-window.vala"
		switch (0) {
#line 2233 "nibbles-window.c"
			default:
			{
				WormProperties* _tmp35_;
				WormProperties* _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
#line 702 "../src/nibbles-window.vala"
				_tmp35_ = properties;
#line 702 "../src/nibbles-window.vala"
				worm_properties_set_raw_down (_tmp35_, g_settings_get_int (changed_worm_settings, "key-down-raw"));
#line 703 "../src/nibbles-window.vala"
				_tmp36_ = properties;
#line 703 "../src/nibbles-window.vala"
				_tmp37_ = worm_properties_get_raw_down (_tmp36_);
#line 703 "../src/nibbles-window.vala"
				_tmp38_ = _tmp37_;
#line 703 "../src/nibbles-window.vala"
				if (_tmp38_ < 0) {
#line 2252 "nibbles-window.c"
					WormProperties* _tmp39_;
					WormProperties* _tmp40_;
					guint _tmp41_;
					guint _tmp42_;
#line 704 "../src/nibbles-window.vala"
					_tmp39_ = properties;
#line 704 "../src/nibbles-window.vala"
					_tmp40_ = properties;
#line 704 "../src/nibbles-window.vala"
					_tmp41_ = worm_properties_get_down (_tmp40_);
#line 704 "../src/nibbles-window.vala"
					_tmp42_ = _tmp41_;
#line 704 "../src/nibbles-window.vala"
					worm_properties_set_raw_down (_tmp39_, nibbles_window_get_raw_key (self, _tmp42_));
#line 2267 "nibbles-window.c"
				}
#line 705 "../src/nibbles-window.vala"
				break;
#line 2271 "nibbles-window.c"
			}
		}
	} else if (_tmp21_ == ((0 != _tmp20_label7) ? _tmp20_label7 : (_tmp20_label7 = g_quark_from_static_string ("key-left-raw")))) {
#line 679 "../src/nibbles-window.vala"
		switch (0) {
#line 2277 "nibbles-window.c"
			default:
			{
				WormProperties* _tmp43_;
				WormProperties* _tmp44_;
				gint _tmp45_;
				gint _tmp46_;
#line 707 "../src/nibbles-window.vala"
				_tmp43_ = properties;
#line 707 "../src/nibbles-window.vala"
				worm_properties_set_raw_left (_tmp43_, g_settings_get_int (changed_worm_settings, "key-left-raw"));
#line 708 "../src/nibbles-window.vala"
				_tmp44_ = properties;
#line 708 "../src/nibbles-window.vala"
				_tmp45_ = worm_properties_get_raw_left (_tmp44_);
#line 708 "../src/nibbles-window.vala"
				_tmp46_ = _tmp45_;
#line 708 "../src/nibbles-window.vala"
				if (_tmp46_ < 0) {
#line 2296 "nibbles-window.c"
					WormProperties* _tmp47_;
					WormProperties* _tmp48_;
					guint _tmp49_;
					guint _tmp50_;
#line 709 "../src/nibbles-window.vala"
					_tmp47_ = properties;
#line 709 "../src/nibbles-window.vala"
					_tmp48_ = properties;
#line 709 "../src/nibbles-window.vala"
					_tmp49_ = worm_properties_get_left (_tmp48_);
#line 709 "../src/nibbles-window.vala"
					_tmp50_ = _tmp49_;
#line 709 "../src/nibbles-window.vala"
					worm_properties_set_raw_left (_tmp47_, nibbles_window_get_raw_key (self, _tmp50_));
#line 2311 "nibbles-window.c"
				}
#line 710 "../src/nibbles-window.vala"
				break;
#line 2315 "nibbles-window.c"
			}
		}
	} else if (_tmp21_ == ((0 != _tmp20_label8) ? _tmp20_label8 : (_tmp20_label8 = g_quark_from_static_string ("key-right-raw")))) {
#line 679 "../src/nibbles-window.vala"
		switch (0) {
#line 2321 "nibbles-window.c"
			default:
			{
				WormProperties* _tmp51_;
				WormProperties* _tmp52_;
				gint _tmp53_;
				gint _tmp54_;
#line 712 "../src/nibbles-window.vala"
				_tmp51_ = properties;
#line 712 "../src/nibbles-window.vala"
				worm_properties_set_raw_right (_tmp51_, g_settings_get_int (changed_worm_settings, "key-right-raw"));
#line 713 "../src/nibbles-window.vala"
				_tmp52_ = properties;
#line 713 "../src/nibbles-window.vala"
				_tmp53_ = worm_properties_get_raw_right (_tmp52_);
#line 713 "../src/nibbles-window.vala"
				_tmp54_ = _tmp53_;
#line 713 "../src/nibbles-window.vala"
				if (_tmp54_ < 0) {
#line 2340 "nibbles-window.c"
					WormProperties* _tmp55_;
					WormProperties* _tmp56_;
					guint _tmp57_;
					guint _tmp58_;
#line 714 "../src/nibbles-window.vala"
					_tmp55_ = properties;
#line 714 "../src/nibbles-window.vala"
					_tmp56_ = properties;
#line 714 "../src/nibbles-window.vala"
					_tmp57_ = worm_properties_get_right (_tmp56_);
#line 714 "../src/nibbles-window.vala"
					_tmp58_ = _tmp57_;
#line 714 "../src/nibbles-window.vala"
					worm_properties_set_raw_right (_tmp55_, nibbles_window_get_raw_key (self, _tmp58_));
#line 2355 "nibbles-window.c"
				}
#line 715 "../src/nibbles-window.vala"
				break;
#line 2359 "nibbles-window.c"
			}
		}
	}
#line 718 "../src/nibbles-window.vala"
	_tmp59_ = self->priv->game;
#line 718 "../src/nibbles-window.vala"
	_tmp60_ = nibbles_game_get_worm_props (_tmp59_);
#line 718 "../src/nibbles-window.vala"
	_tmp61_ = _tmp60_;
#line 718 "../src/nibbles-window.vala"
	_tmp62_ = worm;
#line 718 "../src/nibbles-window.vala"
	_tmp63_ = properties;
#line 718 "../src/nibbles-window.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp61_, _tmp62_, _tmp63_);
#line 720 "../src/nibbles-window.vala"
	_tmp64_ = self->priv->game;
#line 720 "../src/nibbles-window.vala"
	_tmp65_ = nibbles_game_get_numhumans (_tmp64_);
#line 720 "../src/nibbles-window.vala"
	_tmp66_ = _tmp65_;
#line 720 "../src/nibbles-window.vala"
	if (id < _tmp66_) {
#line 721 "../src/nibbles-window.vala"
		nibbles_window_update_start_game_action (self);
#line 2385 "nibbles-window.c"
	}
#line 664 "../src/nibbles-window.vala"
	_g_object_unref0 (properties);
#line 664 "../src/nibbles-window.vala"
	_g_object_unref0 (worm);
#line 2391 "nibbles-window.c"
}

static gint
nibbles_window_get_raw_key (NibblesWindow* self,
                            guint keyval)
{
	GdkKeymapKey* keys = NULL;
	gint keys_length1 = 0;
	gint _keys_size_ = 0;
	GdkDisplay* _tmp0_;
	GdkKeymapKey* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
	gint result;
#line 724 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 727 "../src/nibbles-window.vala"
	_tmp0_ = gdk_display_get_default ();
#line 727 "../src/nibbles-window.vala"
	_tmp3_ = gdk_display_map_keyval (_tmp0_, keyval, &_tmp1_, &_tmp2_);
#line 727 "../src/nibbles-window.vala"
	keys = (g_free (keys), NULL);
#line 727 "../src/nibbles-window.vala"
	keys = _tmp1_;
#line 727 "../src/nibbles-window.vala"
	keys_length1 = _tmp2_;
#line 727 "../src/nibbles-window.vala"
	_keys_size_ = keys_length1;
#line 727 "../src/nibbles-window.vala"
	if (_tmp3_) {
#line 2422 "nibbles-window.c"
		GdkKeymapKey* _tmp4_;
		gint _tmp4__length1;
#line 729 "../src/nibbles-window.vala"
		_tmp4_ = keys;
#line 729 "../src/nibbles-window.vala"
		_tmp4__length1 = keys_length1;
#line 729 "../src/nibbles-window.vala"
		if (_tmp4__length1 > 0) {
#line 2431 "nibbles-window.c"
			GdkKeymapKey* _tmp5_;
			gint _tmp5__length1;
			GdkKeymapKey _tmp6_;
#line 730 "../src/nibbles-window.vala"
			_tmp5_ = keys;
#line 730 "../src/nibbles-window.vala"
			_tmp5__length1 = keys_length1;
#line 730 "../src/nibbles-window.vala"
			_tmp6_ = _tmp5_[0];
#line 730 "../src/nibbles-window.vala"
			result = (gint) _tmp6_.keycode;
#line 730 "../src/nibbles-window.vala"
			keys = (g_free (keys), NULL);
#line 730 "../src/nibbles-window.vala"
			return result;
#line 2447 "nibbles-window.c"
		}
	}
#line 732 "../src/nibbles-window.vala"
	result = -1;
#line 732 "../src/nibbles-window.vala"
	keys = (g_free (keys), NULL);
#line 732 "../src/nibbles-window.vala"
	return result;
#line 2456 "nibbles-window.c"
}

static inline void
nibbles_window_next_screen_cb (NibblesWindow* self)
{
	gchar* child_name = NULL;
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GQuark _tmp6_ = 0U;
#line 742 "../src/nibbles-window.vala"
	static GQuark _tmp5_label0 = 0;
#line 742 "../src/nibbles-window.vala"
	static GQuark _tmp5_label1 = 0;
#line 742 "../src/nibbles-window.vala"
	static GQuark _tmp5_label2 = 0;
#line 739 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 741 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->main_stack;
#line 741 "../src/nibbles-window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 741 "../src/nibbles-window.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 741 "../src/nibbles-window.vala"
	child_name = _tmp2_;
#line 742 "../src/nibbles-window.vala"
	_tmp3_ = child_name;
#line 742 "../src/nibbles-window.vala"
	_tmp4_ = _tmp3_;
#line 742 "../src/nibbles-window.vala"
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
#line 742 "../src/nibbles-window.vala"
	if (_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("first-run")))) {
#line 742 "../src/nibbles-window.vala"
		switch (0) {
#line 2495 "nibbles-window.c"
			default:
			{
#line 745 "../src/nibbles-window.vala"
				nibbles_window_show_new_game_screen (self, TRUE);
#line 746 "../src/nibbles-window.vala"
				break;
#line 2502 "nibbles-window.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("number_of_players")))) {
#line 742 "../src/nibbles-window.vala"
		switch (0) {
#line 2508 "nibbles-window.c"
			default:
			{
#line 748 "../src/nibbles-window.vala"
				nibbles_window_show_speed_screen (self);
#line 749 "../src/nibbles-window.vala"
				break;
#line 2515 "nibbles-window.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string ("speed")))) {
#line 742 "../src/nibbles-window.vala"
		switch (0) {
#line 2521 "nibbles-window.c"
			default:
			{
#line 751 "../src/nibbles-window.vala"
				nibbles_window_leave_speed_screen (self);
#line 752 "../src/nibbles-window.vala"
				nibbles_window_show_controls_screen (self);
#line 753 "../src/nibbles-window.vala"
				break;
#line 2530 "nibbles-window.c"
			}
		}
	} else {
#line 742 "../src/nibbles-window.vala"
		switch (0) {
#line 2536 "nibbles-window.c"
			default:
			{
#line 756 "../src/nibbles-window.vala"
				_g_free0 (child_name);
#line 756 "../src/nibbles-window.vala"
				return;
#line 2543 "nibbles-window.c"
			}
		}
	}
#line 739 "../src/nibbles-window.vala"
	_g_free0 (child_name);
#line 2549 "nibbles-window.c"
}

static void
nibbles_window_set_headerbar_title (NibblesWindow* self,
                                    const gchar* title)
{
	GtkHeaderBar* _tmp0_;
	GtkWidget* _tmp1_;
#line 760 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 760 "../src/nibbles-window.vala"
	g_return_if_fail (title != NULL);
#line 762 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->headerbar;
#line 762 "../src/nibbles-window.vala"
	_tmp1_ = gtk_header_bar_get_title_widget (_tmp0_);
#line 762 "../src/nibbles-window.vala"
	if (_tmp1_ == NULL) {
#line 2568 "nibbles-window.c"
		GtkHeaderBar* _tmp2_;
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
#line 763 "../src/nibbles-window.vala"
		_tmp2_ = self->priv->headerbar;
#line 763 "../src/nibbles-window.vala"
		_tmp3_ = (GtkLabel*) gtk_label_new (title);
#line 763 "../src/nibbles-window.vala"
		g_object_ref_sink (_tmp3_);
#line 763 "../src/nibbles-window.vala"
		_tmp4_ = _tmp3_;
#line 763 "../src/nibbles-window.vala"
		gtk_header_bar_set_title_widget (_tmp2_, (GtkWidget*) _tmp4_);
#line 763 "../src/nibbles-window.vala"
		_g_object_unref0 (_tmp4_);
#line 2584 "nibbles-window.c"
	} else {
		GtkHeaderBar* _tmp5_;
		GtkWidget* _tmp6_;
#line 765 "../src/nibbles-window.vala"
		_tmp5_ = self->priv->headerbar;
#line 765 "../src/nibbles-window.vala"
		_tmp6_ = gtk_header_bar_get_title_widget (_tmp5_);
#line 765 "../src/nibbles-window.vala"
		gtk_label_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_label_get_type (), GtkLabel), title);
#line 2594 "nibbles-window.c"
	}
}

static void
nibbles_window_show_new_game_screen (NibblesWindow* self,
                                     gboolean after_first_run)
{
	NibblesGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	GtkStack* _tmp11_;
	GtkStack* _tmp12_;
#line 768 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 770 "../src/nibbles-window.vala"
	if (self->priv->countdown_id != ((guint) 0)) {
#line 772 "../src/nibbles-window.vala"
		g_source_remove (self->priv->countdown_id);
#line 773 "../src/nibbles-window.vala"
		self->priv->countdown_id = (guint) 0;
#line 2620 "nibbles-window.c"
	}
#line 776 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->game;
#line 776 "../src/nibbles-window.vala"
	_tmp1_ = nibbles_game_get_is_running (_tmp0_);
#line 776 "../src/nibbles-window.vala"
	_tmp2_ = _tmp1_;
#line 776 "../src/nibbles-window.vala"
	if (_tmp2_) {
#line 2630 "nibbles-window.c"
		NibblesGame* _tmp3_;
#line 777 "../src/nibbles-window.vala"
		_tmp3_ = self->priv->game;
#line 777 "../src/nibbles-window.vala"
		nibbles_game_stop (_tmp3_);
#line 2636 "nibbles-window.c"
	}
#line 779 "../src/nibbles-window.vala"
	nibbles_window_set_headerbar_title (self, NIBBLES_PROGRAM_NAME);
#line 781 "../src/nibbles-window.vala"
	_tmp4_ = self->priv->new_game_action;
#line 781 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp4_, TRUE);
#line 782 "../src/nibbles-window.vala"
	_tmp5_ = self->priv->pause_action;
#line 782 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp5_, FALSE);
#line 783 "../src/nibbles-window.vala"
	_tmp6_ = self->priv->back_action;
#line 783 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp6_, TRUE);
#line 785 "../src/nibbles-window.vala"
	_tmp7_ = self->priv->new_game_button;
#line 785 "../src/nibbles-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp7_);
#line 786 "../src/nibbles-window.vala"
	_tmp8_ = self->priv->pause_button;
#line 786 "../src/nibbles-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp8_);
#line 788 "../src/nibbles-window.vala"
	if (after_first_run) {
#line 2662 "nibbles-window.c"
		GtkStack* _tmp9_;
#line 789 "../src/nibbles-window.vala"
		_tmp9_ = self->priv->main_stack;
#line 789 "../src/nibbles-window.vala"
		gtk_stack_set_transition_type (_tmp9_, GTK_STACK_TRANSITION_TYPE_SLIDE_UP);
#line 2668 "nibbles-window.c"
	} else {
		GtkStack* _tmp10_;
#line 791 "../src/nibbles-window.vala"
		_tmp10_ = self->priv->main_stack;
#line 791 "../src/nibbles-window.vala"
		gtk_stack_set_transition_type (_tmp10_, GTK_STACK_TRANSITION_TYPE_NONE);
#line 2675 "nibbles-window.c"
	}
#line 792 "../src/nibbles-window.vala"
	_tmp11_ = self->priv->main_stack;
#line 792 "../src/nibbles-window.vala"
	gtk_stack_set_visible_child_name (_tmp11_, "number_of_players");
#line 793 "../src/nibbles-window.vala"
	_tmp12_ = self->priv->main_stack;
#line 793 "../src/nibbles-window.vala"
	gtk_stack_set_transition_type (_tmp12_, GTK_STACK_TRANSITION_TYPE_SLIDE_UP);
#line 2685 "nibbles-window.c"
}

static void
nibbles_window_show_speed_screen (NibblesWindow* self)
{
	gint numhumans = 0;
	gint numai = 0;
	Players* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	NibblesGame* _tmp3_;
	NibblesGame* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GtkStack* _tmp7_;
#line 796 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 799 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->players;
#line 799 "../src/nibbles-window.vala"
	players_get_values (_tmp0_, &_tmp1_, &_tmp2_);
#line 799 "../src/nibbles-window.vala"
	numhumans = _tmp1_;
#line 799 "../src/nibbles-window.vala"
	numai = _tmp2_;
#line 800 "../src/nibbles-window.vala"
	_tmp3_ = self->priv->game;
#line 800 "../src/nibbles-window.vala"
	nibbles_game_set_numhumans (_tmp3_, numhumans);
#line 801 "../src/nibbles-window.vala"
	_tmp4_ = self->priv->game;
#line 801 "../src/nibbles-window.vala"
	nibbles_game_set_numai (_tmp4_, numai);
#line 802 "../src/nibbles-window.vala"
	_tmp5_ = self->priv->settings;
#line 802 "../src/nibbles-window.vala"
	g_settings_set_int (_tmp5_, "players", numhumans);
#line 803 "../src/nibbles-window.vala"
	_tmp6_ = self->priv->settings;
#line 803 "../src/nibbles-window.vala"
	g_settings_set_int (_tmp6_, "ai", numai);
#line 805 "../src/nibbles-window.vala"
	_tmp7_ = self->priv->main_stack;
#line 805 "../src/nibbles-window.vala"
	gtk_stack_set_visible_child_name (_tmp7_, "speed");
#line 2731 "nibbles-window.c"
}

static void
nibbles_window_leave_speed_screen (NibblesWindow* self)
{
	gint game_speed = 0;
	gboolean fakes = FALSE;
	Speed* _tmp0_;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	NibblesGame* _tmp3_;
	NibblesGame* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
#line 808 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 812 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->speed;
#line 812 "../src/nibbles-window.vala"
	speed_get_values (_tmp0_, &_tmp1_, &_tmp2_);
#line 812 "../src/nibbles-window.vala"
	game_speed = _tmp1_;
#line 812 "../src/nibbles-window.vala"
	fakes = _tmp2_;
#line 813 "../src/nibbles-window.vala"
	_tmp3_ = self->priv->game;
#line 813 "../src/nibbles-window.vala"
	nibbles_game_set_speed (_tmp3_, game_speed);
#line 814 "../src/nibbles-window.vala"
	_tmp4_ = self->priv->game;
#line 814 "../src/nibbles-window.vala"
	nibbles_game_set_fakes (_tmp4_, fakes);
#line 815 "../src/nibbles-window.vala"
	_tmp5_ = self->priv->settings;
#line 815 "../src/nibbles-window.vala"
	g_settings_set_int (_tmp5_, "speed", game_speed);
#line 816 "../src/nibbles-window.vala"
	_tmp6_ = self->priv->settings;
#line 816 "../src/nibbles-window.vala"
	g_settings_set_boolean (_tmp6_, "fakes", fakes);
#line 2772 "nibbles-window.c"
}

static void
nibbles_window_show_controls_screen (NibblesWindow* self)
{
	Controls* _tmp0_;
	NibblesGame* _tmp1_;
	GeeArrayList* _tmp2_;
	Controls* _tmp3_;
	NibblesGame* _tmp4_;
	GeeLinkedList* _tmp5_;
	GeeLinkedList* _tmp6_;
	NibblesGame* _tmp7_;
	GeeHashMap* _tmp8_;
	GeeHashMap* _tmp9_;
	GeeArrayList* _tmp10_;
	GtkStack* _tmp11_;
#line 819 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 821 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->controls;
#line 821 "../src/nibbles-window.vala"
	controls_clean (_tmp0_);
#line 822 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->game;
#line 822 "../src/nibbles-window.vala"
	_tmp2_ = self->priv->worm_settings;
#line 822 "../src/nibbles-window.vala"
	nibbles_game_create_worms (_tmp1_, _tmp2_);
#line 823 "../src/nibbles-window.vala"
	nibbles_window_update_start_game_action (self);
#line 825 "../src/nibbles-window.vala"
	_tmp3_ = self->priv->controls;
#line 825 "../src/nibbles-window.vala"
	_tmp4_ = self->priv->game;
#line 825 "../src/nibbles-window.vala"
	_tmp5_ = nibbles_game_get_worms (_tmp4_);
#line 825 "../src/nibbles-window.vala"
	_tmp6_ = _tmp5_;
#line 825 "../src/nibbles-window.vala"
	_tmp7_ = self->priv->game;
#line 825 "../src/nibbles-window.vala"
	_tmp8_ = nibbles_game_get_worm_props (_tmp7_);
#line 825 "../src/nibbles-window.vala"
	_tmp9_ = _tmp8_;
#line 825 "../src/nibbles-window.vala"
	_tmp10_ = self->priv->worm_settings;
#line 825 "../src/nibbles-window.vala"
	controls_prepare (_tmp3_, _tmp6_, _tmp9_, (GeeList*) _tmp10_);
#line 827 "../src/nibbles-window.vala"
	_tmp11_ = self->priv->main_stack;
#line 827 "../src/nibbles-window.vala"
	gtk_stack_set_visible_child_name (_tmp11_, "controls");
#line 2826 "nibbles-window.c"
}

static void
nibbles_window_update_start_game_action (NibblesWindow* self)
{
	GHashTable* keys = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GSimpleAction* _tmp112_;
#line 830 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 832 "../src/nibbles-window.vala"
	_tmp0_ = g_direct_hash;
#line 832 "../src/nibbles-window.vala"
	_tmp1_ = g_direct_equal;
#line 832 "../src/nibbles-window.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, NULL);
#line 832 "../src/nibbles-window.vala"
	keys = _tmp2_;
#line 2847 "nibbles-window.c"
	{
		gint i = 0;
#line 833 "../src/nibbles-window.vala"
		i = 0;
#line 2852 "nibbles-window.c"
		{
			gboolean _tmp3_ = FALSE;
#line 833 "../src/nibbles-window.vala"
			_tmp3_ = TRUE;
#line 833 "../src/nibbles-window.vala"
			while (TRUE) {
#line 2859 "nibbles-window.c"
				NibblesGame* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				WormProperties* worm_prop = NULL;
				NibblesGame* _tmp8_;
				GeeHashMap* _tmp9_;
				GeeHashMap* _tmp10_;
				NibblesGame* _tmp11_;
				GeeLinkedList* _tmp12_;
				GeeLinkedList* _tmp13_;
				gpointer _tmp14_;
				Worm* _tmp15_;
				gpointer _tmp16_;
				WormProperties* _tmp17_;
				gboolean _tmp18_ = FALSE;
				gboolean _tmp19_ = FALSE;
				gboolean _tmp20_ = FALSE;
				gboolean _tmp21_ = FALSE;
				gboolean _tmp22_ = FALSE;
				gboolean _tmp23_ = FALSE;
				gboolean _tmp24_ = FALSE;
				gboolean _tmp25_ = FALSE;
				gboolean _tmp26_ = FALSE;
				gboolean _tmp27_ = FALSE;
				gboolean _tmp28_ = FALSE;
				gboolean _tmp29_ = FALSE;
				gboolean _tmp30_ = FALSE;
				WormProperties* _tmp31_;
				guint _tmp32_;
				guint _tmp33_;
				GHashTable* _tmp96_;
				WormProperties* _tmp97_;
				guint _tmp98_;
				guint _tmp99_;
				GHashTable* _tmp100_;
				WormProperties* _tmp101_;
				guint _tmp102_;
				guint _tmp103_;
				GHashTable* _tmp104_;
				WormProperties* _tmp105_;
				guint _tmp106_;
				guint _tmp107_;
				GHashTable* _tmp108_;
				WormProperties* _tmp109_;
				guint _tmp110_;
				guint _tmp111_;
#line 833 "../src/nibbles-window.vala"
				if (!_tmp3_) {
#line 2908 "nibbles-window.c"
					gint _tmp4_;
#line 833 "../src/nibbles-window.vala"
					_tmp4_ = i;
#line 833 "../src/nibbles-window.vala"
					i = _tmp4_ + 1;
#line 2914 "nibbles-window.c"
				}
#line 833 "../src/nibbles-window.vala"
				_tmp3_ = FALSE;
#line 833 "../src/nibbles-window.vala"
				_tmp5_ = self->priv->game;
#line 833 "../src/nibbles-window.vala"
				_tmp6_ = nibbles_game_get_numhumans (_tmp5_);
#line 833 "../src/nibbles-window.vala"
				_tmp7_ = _tmp6_;
#line 833 "../src/nibbles-window.vala"
				if (!(i < _tmp7_)) {
#line 833 "../src/nibbles-window.vala"
					break;
#line 2928 "nibbles-window.c"
				}
#line 835 "../src/nibbles-window.vala"
				_tmp8_ = self->priv->game;
#line 835 "../src/nibbles-window.vala"
				_tmp9_ = nibbles_game_get_worm_props (_tmp8_);
#line 835 "../src/nibbles-window.vala"
				_tmp10_ = _tmp9_;
#line 835 "../src/nibbles-window.vala"
				_tmp11_ = self->priv->game;
#line 835 "../src/nibbles-window.vala"
				_tmp12_ = nibbles_game_get_worms (_tmp11_);
#line 835 "../src/nibbles-window.vala"
				_tmp13_ = _tmp12_;
#line 835 "../src/nibbles-window.vala"
				_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, i);
#line 835 "../src/nibbles-window.vala"
				_tmp15_ = (Worm*) _tmp14_;
#line 835 "../src/nibbles-window.vala"
				_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, _tmp15_);
#line 835 "../src/nibbles-window.vala"
				_tmp17_ = (WormProperties*) _tmp16_;
#line 835 "../src/nibbles-window.vala"
				_g_object_unref0 (_tmp15_);
#line 835 "../src/nibbles-window.vala"
				worm_prop = _tmp17_;
#line 836 "../src/nibbles-window.vala"
				_tmp31_ = worm_prop;
#line 836 "../src/nibbles-window.vala"
				_tmp32_ = worm_properties_get_up (_tmp31_);
#line 836 "../src/nibbles-window.vala"
				_tmp33_ = _tmp32_;
#line 836 "../src/nibbles-window.vala"
				if (_tmp33_ == ((guint) 0)) {
#line 836 "../src/nibbles-window.vala"
					_tmp30_ = TRUE;
#line 2964 "nibbles-window.c"
				} else {
					WormProperties* _tmp34_;
					guint _tmp35_;
					guint _tmp36_;
#line 837 "../src/nibbles-window.vala"
					_tmp34_ = worm_prop;
#line 837 "../src/nibbles-window.vala"
					_tmp35_ = worm_properties_get_down (_tmp34_);
#line 837 "../src/nibbles-window.vala"
					_tmp36_ = _tmp35_;
#line 837 "../src/nibbles-window.vala"
					_tmp30_ = _tmp36_ == ((guint) 0);
#line 2977 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp30_) {
#line 836 "../src/nibbles-window.vala"
					_tmp29_ = TRUE;
#line 2983 "nibbles-window.c"
				} else {
					WormProperties* _tmp37_;
					guint _tmp38_;
					guint _tmp39_;
#line 838 "../src/nibbles-window.vala"
					_tmp37_ = worm_prop;
#line 838 "../src/nibbles-window.vala"
					_tmp38_ = worm_properties_get_left (_tmp37_);
#line 838 "../src/nibbles-window.vala"
					_tmp39_ = _tmp38_;
#line 838 "../src/nibbles-window.vala"
					_tmp29_ = _tmp39_ == ((guint) 0);
#line 2996 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp29_) {
#line 836 "../src/nibbles-window.vala"
					_tmp28_ = TRUE;
#line 3002 "nibbles-window.c"
				} else {
					WormProperties* _tmp40_;
					guint _tmp41_;
					guint _tmp42_;
#line 839 "../src/nibbles-window.vala"
					_tmp40_ = worm_prop;
#line 839 "../src/nibbles-window.vala"
					_tmp41_ = worm_properties_get_right (_tmp40_);
#line 839 "../src/nibbles-window.vala"
					_tmp42_ = _tmp41_;
#line 839 "../src/nibbles-window.vala"
					_tmp28_ = _tmp42_ == ((guint) 0);
#line 3015 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp28_) {
#line 836 "../src/nibbles-window.vala"
					_tmp27_ = TRUE;
#line 3021 "nibbles-window.c"
				} else {
					WormProperties* _tmp43_;
					guint _tmp44_;
					guint _tmp45_;
					WormProperties* _tmp46_;
					guint _tmp47_;
					guint _tmp48_;
#line 841 "../src/nibbles-window.vala"
					_tmp43_ = worm_prop;
#line 841 "../src/nibbles-window.vala"
					_tmp44_ = worm_properties_get_up (_tmp43_);
#line 841 "../src/nibbles-window.vala"
					_tmp45_ = _tmp44_;
#line 841 "../src/nibbles-window.vala"
					_tmp46_ = worm_prop;
#line 841 "../src/nibbles-window.vala"
					_tmp47_ = worm_properties_get_down (_tmp46_);
#line 841 "../src/nibbles-window.vala"
					_tmp48_ = _tmp47_;
#line 841 "../src/nibbles-window.vala"
					_tmp27_ = _tmp45_ == _tmp48_;
#line 3043 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp27_) {
#line 836 "../src/nibbles-window.vala"
					_tmp26_ = TRUE;
#line 3049 "nibbles-window.c"
				} else {
					WormProperties* _tmp49_;
					guint _tmp50_;
					guint _tmp51_;
					WormProperties* _tmp52_;
					guint _tmp53_;
					guint _tmp54_;
#line 842 "../src/nibbles-window.vala"
					_tmp49_ = worm_prop;
#line 842 "../src/nibbles-window.vala"
					_tmp50_ = worm_properties_get_up (_tmp49_);
#line 842 "../src/nibbles-window.vala"
					_tmp51_ = _tmp50_;
#line 842 "../src/nibbles-window.vala"
					_tmp52_ = worm_prop;
#line 842 "../src/nibbles-window.vala"
					_tmp53_ = worm_properties_get_left (_tmp52_);
#line 842 "../src/nibbles-window.vala"
					_tmp54_ = _tmp53_;
#line 842 "../src/nibbles-window.vala"
					_tmp26_ = _tmp51_ == _tmp54_;
#line 3071 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp26_) {
#line 836 "../src/nibbles-window.vala"
					_tmp25_ = TRUE;
#line 3077 "nibbles-window.c"
				} else {
					WormProperties* _tmp55_;
					guint _tmp56_;
					guint _tmp57_;
					WormProperties* _tmp58_;
					guint _tmp59_;
					guint _tmp60_;
#line 843 "../src/nibbles-window.vala"
					_tmp55_ = worm_prop;
#line 843 "../src/nibbles-window.vala"
					_tmp56_ = worm_properties_get_up (_tmp55_);
#line 843 "../src/nibbles-window.vala"
					_tmp57_ = _tmp56_;
#line 843 "../src/nibbles-window.vala"
					_tmp58_ = worm_prop;
#line 843 "../src/nibbles-window.vala"
					_tmp59_ = worm_properties_get_right (_tmp58_);
#line 843 "../src/nibbles-window.vala"
					_tmp60_ = _tmp59_;
#line 843 "../src/nibbles-window.vala"
					_tmp25_ = _tmp57_ == _tmp60_;
#line 3099 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp25_) {
#line 836 "../src/nibbles-window.vala"
					_tmp24_ = TRUE;
#line 3105 "nibbles-window.c"
				} else {
					WormProperties* _tmp61_;
					guint _tmp62_;
					guint _tmp63_;
					WormProperties* _tmp64_;
					guint _tmp65_;
					guint _tmp66_;
#line 844 "../src/nibbles-window.vala"
					_tmp61_ = worm_prop;
#line 844 "../src/nibbles-window.vala"
					_tmp62_ = worm_properties_get_down (_tmp61_);
#line 844 "../src/nibbles-window.vala"
					_tmp63_ = _tmp62_;
#line 844 "../src/nibbles-window.vala"
					_tmp64_ = worm_prop;
#line 844 "../src/nibbles-window.vala"
					_tmp65_ = worm_properties_get_left (_tmp64_);
#line 844 "../src/nibbles-window.vala"
					_tmp66_ = _tmp65_;
#line 844 "../src/nibbles-window.vala"
					_tmp24_ = _tmp63_ == _tmp66_;
#line 3127 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp24_) {
#line 836 "../src/nibbles-window.vala"
					_tmp23_ = TRUE;
#line 3133 "nibbles-window.c"
				} else {
					WormProperties* _tmp67_;
					guint _tmp68_;
					guint _tmp69_;
					WormProperties* _tmp70_;
					guint _tmp71_;
					guint _tmp72_;
#line 845 "../src/nibbles-window.vala"
					_tmp67_ = worm_prop;
#line 845 "../src/nibbles-window.vala"
					_tmp68_ = worm_properties_get_down (_tmp67_);
#line 845 "../src/nibbles-window.vala"
					_tmp69_ = _tmp68_;
#line 845 "../src/nibbles-window.vala"
					_tmp70_ = worm_prop;
#line 845 "../src/nibbles-window.vala"
					_tmp71_ = worm_properties_get_right (_tmp70_);
#line 845 "../src/nibbles-window.vala"
					_tmp72_ = _tmp71_;
#line 845 "../src/nibbles-window.vala"
					_tmp23_ = _tmp69_ == _tmp72_;
#line 3155 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp23_) {
#line 836 "../src/nibbles-window.vala"
					_tmp22_ = TRUE;
#line 3161 "nibbles-window.c"
				} else {
					WormProperties* _tmp73_;
					guint _tmp74_;
					guint _tmp75_;
					WormProperties* _tmp76_;
					guint _tmp77_;
					guint _tmp78_;
#line 846 "../src/nibbles-window.vala"
					_tmp73_ = worm_prop;
#line 846 "../src/nibbles-window.vala"
					_tmp74_ = worm_properties_get_right (_tmp73_);
#line 846 "../src/nibbles-window.vala"
					_tmp75_ = _tmp74_;
#line 846 "../src/nibbles-window.vala"
					_tmp76_ = worm_prop;
#line 846 "../src/nibbles-window.vala"
					_tmp77_ = worm_properties_get_left (_tmp76_);
#line 846 "../src/nibbles-window.vala"
					_tmp78_ = _tmp77_;
#line 846 "../src/nibbles-window.vala"
					_tmp22_ = _tmp75_ == _tmp78_;
#line 3183 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp22_) {
#line 836 "../src/nibbles-window.vala"
					_tmp21_ = TRUE;
#line 3189 "nibbles-window.c"
				} else {
					GHashTable* _tmp79_;
					WormProperties* _tmp80_;
					guint _tmp81_;
					guint _tmp82_;
#line 848 "../src/nibbles-window.vala"
					_tmp79_ = keys;
#line 848 "../src/nibbles-window.vala"
					_tmp80_ = worm_prop;
#line 848 "../src/nibbles-window.vala"
					_tmp81_ = worm_properties_get_up (_tmp80_);
#line 848 "../src/nibbles-window.vala"
					_tmp82_ = _tmp81_;
#line 848 "../src/nibbles-window.vala"
					_tmp21_ = g_hash_table_contains (_tmp79_, (gpointer) ((guintptr) _tmp82_));
#line 3205 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp21_) {
#line 836 "../src/nibbles-window.vala"
					_tmp20_ = TRUE;
#line 3211 "nibbles-window.c"
				} else {
					GHashTable* _tmp83_;
					WormProperties* _tmp84_;
					guint _tmp85_;
					guint _tmp86_;
#line 849 "../src/nibbles-window.vala"
					_tmp83_ = keys;
#line 849 "../src/nibbles-window.vala"
					_tmp84_ = worm_prop;
#line 849 "../src/nibbles-window.vala"
					_tmp85_ = worm_properties_get_down (_tmp84_);
#line 849 "../src/nibbles-window.vala"
					_tmp86_ = _tmp85_;
#line 849 "../src/nibbles-window.vala"
					_tmp20_ = g_hash_table_contains (_tmp83_, (gpointer) ((guintptr) _tmp86_));
#line 3227 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp20_) {
#line 836 "../src/nibbles-window.vala"
					_tmp19_ = TRUE;
#line 3233 "nibbles-window.c"
				} else {
					GHashTable* _tmp87_;
					WormProperties* _tmp88_;
					guint _tmp89_;
					guint _tmp90_;
#line 850 "../src/nibbles-window.vala"
					_tmp87_ = keys;
#line 850 "../src/nibbles-window.vala"
					_tmp88_ = worm_prop;
#line 850 "../src/nibbles-window.vala"
					_tmp89_ = worm_properties_get_left (_tmp88_);
#line 850 "../src/nibbles-window.vala"
					_tmp90_ = _tmp89_;
#line 850 "../src/nibbles-window.vala"
					_tmp19_ = g_hash_table_contains (_tmp87_, (gpointer) ((guintptr) _tmp90_));
#line 3249 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp19_) {
#line 836 "../src/nibbles-window.vala"
					_tmp18_ = TRUE;
#line 3255 "nibbles-window.c"
				} else {
					GHashTable* _tmp91_;
					WormProperties* _tmp92_;
					guint _tmp93_;
					guint _tmp94_;
#line 851 "../src/nibbles-window.vala"
					_tmp91_ = keys;
#line 851 "../src/nibbles-window.vala"
					_tmp92_ = worm_prop;
#line 851 "../src/nibbles-window.vala"
					_tmp93_ = worm_properties_get_right (_tmp92_);
#line 851 "../src/nibbles-window.vala"
					_tmp94_ = _tmp93_;
#line 851 "../src/nibbles-window.vala"
					_tmp18_ = g_hash_table_contains (_tmp91_, (gpointer) ((guintptr) _tmp94_));
#line 3271 "nibbles-window.c"
				}
#line 836 "../src/nibbles-window.vala"
				if (_tmp18_) {
#line 3275 "nibbles-window.c"
					GSimpleAction* _tmp95_;
#line 853 "../src/nibbles-window.vala"
					_tmp95_ = self->priv->start_game_action;
#line 853 "../src/nibbles-window.vala"
					g_simple_action_set_enabled (_tmp95_, FALSE);
#line 854 "../src/nibbles-window.vala"
					_g_object_unref0 (worm_prop);
#line 854 "../src/nibbles-window.vala"
					_g_hash_table_unref0 (keys);
#line 854 "../src/nibbles-window.vala"
					return;
#line 3287 "nibbles-window.c"
				}
#line 856 "../src/nibbles-window.vala"
				_tmp96_ = keys;
#line 856 "../src/nibbles-window.vala"
				_tmp97_ = worm_prop;
#line 856 "../src/nibbles-window.vala"
				_tmp98_ = worm_properties_get_up (_tmp97_);
#line 856 "../src/nibbles-window.vala"
				_tmp99_ = _tmp98_;
#line 856 "../src/nibbles-window.vala"
				g_hash_table_add (_tmp96_, (gpointer) ((guintptr) _tmp99_));
#line 857 "../src/nibbles-window.vala"
				_tmp100_ = keys;
#line 857 "../src/nibbles-window.vala"
				_tmp101_ = worm_prop;
#line 857 "../src/nibbles-window.vala"
				_tmp102_ = worm_properties_get_down (_tmp101_);
#line 857 "../src/nibbles-window.vala"
				_tmp103_ = _tmp102_;
#line 857 "../src/nibbles-window.vala"
				g_hash_table_add (_tmp100_, (gpointer) ((guintptr) _tmp103_));
#line 858 "../src/nibbles-window.vala"
				_tmp104_ = keys;
#line 858 "../src/nibbles-window.vala"
				_tmp105_ = worm_prop;
#line 858 "../src/nibbles-window.vala"
				_tmp106_ = worm_properties_get_left (_tmp105_);
#line 858 "../src/nibbles-window.vala"
				_tmp107_ = _tmp106_;
#line 858 "../src/nibbles-window.vala"
				g_hash_table_add (_tmp104_, (gpointer) ((guintptr) _tmp107_));
#line 859 "../src/nibbles-window.vala"
				_tmp108_ = keys;
#line 859 "../src/nibbles-window.vala"
				_tmp109_ = worm_prop;
#line 859 "../src/nibbles-window.vala"
				_tmp110_ = worm_properties_get_right (_tmp109_);
#line 859 "../src/nibbles-window.vala"
				_tmp111_ = _tmp110_;
#line 859 "../src/nibbles-window.vala"
				g_hash_table_add (_tmp108_, (gpointer) ((guintptr) _tmp111_));
#line 833 "../src/nibbles-window.vala"
				_g_object_unref0 (worm_prop);
#line 3331 "nibbles-window.c"
			}
		}
	}
#line 861 "../src/nibbles-window.vala"
	_tmp112_ = self->priv->start_game_action;
#line 861 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp112_, TRUE);
#line 830 "../src/nibbles-window.vala"
	_g_hash_table_unref0 (keys);
#line 3341 "nibbles-window.c"
}

static void
nibbles_window_show_game_view (NibblesWindow* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	NibblesGame* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkStack* _tmp7_;
	GtkStack* _tmp8_;
#line 864 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 871 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->new_game_button;
#line 871 "../src/nibbles-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 872 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->pause_button;
#line 872 "../src/nibbles-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp1_);
#line 875 "../src/nibbles-window.vala"
	_tmp2_ = self->priv->game;
#line 875 "../src/nibbles-window.vala"
	_tmp3_ = nibbles_game_get_current_level (_tmp2_);
#line 875 "../src/nibbles-window.vala"
	_tmp4_ = _tmp3_;
#line 875 "../src/nibbles-window.vala"
	_tmp5_ = g_strdup_printf (_ ("Level %d"), _tmp4_);
#line 875 "../src/nibbles-window.vala"
	_tmp6_ = _tmp5_;
#line 875 "../src/nibbles-window.vala"
	nibbles_window_set_headerbar_title (self, _tmp6_);
#line 875 "../src/nibbles-window.vala"
	_g_free0 (_tmp6_);
#line 876 "../src/nibbles-window.vala"
	_tmp7_ = self->priv->main_stack;
#line 876 "../src/nibbles-window.vala"
	gtk_stack_set_visible_child_name (_tmp7_, "game_box");
#line 878 "../src/nibbles-window.vala"
	_tmp8_ = self->priv->main_stack;
#line 878 "../src/nibbles-window.vala"
	gtk_stack_set_transition_type (_tmp8_, GTK_STACK_TRANSITION_TYPE_SLIDE_UP);
#line 3388 "nibbles-window.c"
}

static void
nibbles_window_back_cb (NibblesWindow* self)
{
	GtkStack* _tmp0_;
	gchar* child_name = NULL;
	GtkStack* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GQuark _tmp7_ = 0U;
#line 886 "../src/nibbles-window.vala"
	static GQuark _tmp6_label0 = 0;
#line 886 "../src/nibbles-window.vala"
	static GQuark _tmp6_label1 = 0;
#line 886 "../src/nibbles-window.vala"
	static GQuark _tmp6_label2 = 0;
#line 886 "../src/nibbles-window.vala"
	static GQuark _tmp6_label3 = 0;
#line 886 "../src/nibbles-window.vala"
	static GQuark _tmp6_label4 = 0;
#line 3412 "nibbles-window.c"
	GtkStack* _tmp10_;
#line 881 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 883 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->main_stack;
#line 883 "../src/nibbles-window.vala"
	gtk_stack_set_transition_type (_tmp0_, GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN);
#line 885 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->main_stack;
#line 885 "../src/nibbles-window.vala"
	_tmp2_ = gtk_stack_get_visible_child_name (_tmp1_);
#line 885 "../src/nibbles-window.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 885 "../src/nibbles-window.vala"
	child_name = _tmp3_;
#line 886 "../src/nibbles-window.vala"
	_tmp4_ = child_name;
#line 886 "../src/nibbles-window.vala"
	_tmp5_ = _tmp4_;
#line 886 "../src/nibbles-window.vala"
	_tmp7_ = (NULL == _tmp5_) ? 0 : g_quark_from_string (_tmp5_);
#line 886 "../src/nibbles-window.vala"
	if (_tmp7_ == ((0 != _tmp6_label0) ? _tmp6_label0 : (_tmp6_label0 = g_quark_from_static_string ("first-run")))) {
#line 886 "../src/nibbles-window.vala"
		switch (0) {
#line 3438 "nibbles-window.c"
			default:
			{
#line 889 "../src/nibbles-window.vala"
				g_assert_not_reached ();
#line 3443 "nibbles-window.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label1) ? _tmp6_label1 : (_tmp6_label1 = g_quark_from_static_string ("number_of_players")))) {
#line 886 "../src/nibbles-window.vala"
		switch (0) {
#line 3449 "nibbles-window.c"
			default:
			{
#line 891 "../src/nibbles-window.vala"
				break;
#line 3454 "nibbles-window.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label2) ? _tmp6_label2 : (_tmp6_label2 = g_quark_from_static_string ("speed")))) {
#line 886 "../src/nibbles-window.vala"
		switch (0) {
#line 3460 "nibbles-window.c"
			default:
			{
				GtkStack* _tmp8_;
#line 893 "../src/nibbles-window.vala"
				_tmp8_ = self->priv->main_stack;
#line 893 "../src/nibbles-window.vala"
				gtk_stack_set_visible_child_name (_tmp8_, "number_of_players");
#line 894 "../src/nibbles-window.vala"
				break;
#line 3470 "nibbles-window.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label3) ? _tmp6_label3 : (_tmp6_label3 = g_quark_from_static_string ("controls")))) {
#line 886 "../src/nibbles-window.vala"
		switch (0) {
#line 3476 "nibbles-window.c"
			default:
			{
				GtkStack* _tmp9_;
#line 896 "../src/nibbles-window.vala"
				_tmp9_ = self->priv->main_stack;
#line 896 "../src/nibbles-window.vala"
				gtk_stack_set_visible_child_name (_tmp9_, "speed");
#line 897 "../src/nibbles-window.vala"
				break;
#line 3486 "nibbles-window.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label4) ? _tmp6_label4 : (_tmp6_label4 = g_quark_from_static_string ("game_box")))) {
#line 886 "../src/nibbles-window.vala"
		switch (0) {
#line 3492 "nibbles-window.c"
			default:
			{
#line 899 "../src/nibbles-window.vala"
				nibbles_window_new_game_cb (self);
#line 900 "../src/nibbles-window.vala"
				break;
#line 3499 "nibbles-window.c"
			}
		}
	}
#line 903 "../src/nibbles-window.vala"
	_tmp10_ = self->priv->main_stack;
#line 903 "../src/nibbles-window.vala"
	gtk_stack_set_transition_type (_tmp10_, GTK_STACK_TRANSITION_TYPE_SLIDE_UP);
#line 881 "../src/nibbles-window.vala"
	_g_free0 (child_name);
#line 3509 "nibbles-window.c"
}

static GamesScoresCategory*
nibbles_window_category_request (NibblesWindow* self,
                                 const gchar* key)
{
	GamesScoresCategory* result;
#line 910 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 910 "../src/nibbles-window.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 3521 "nibbles-window.c"
	{
		GeeLinkedList* _cat_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _cat_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _cat_index = 0;
#line 912 "../src/nibbles-window.vala"
		_tmp0_ = self->priv->scorecats;
#line 912 "../src/nibbles-window.vala"
		_cat_list = _tmp0_;
#line 912 "../src/nibbles-window.vala"
		_tmp1_ = _cat_list;
#line 912 "../src/nibbles-window.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 912 "../src/nibbles-window.vala"
		_tmp3_ = _tmp2_;
#line 912 "../src/nibbles-window.vala"
		_cat_size = _tmp3_;
#line 912 "../src/nibbles-window.vala"
		_cat_index = -1;
#line 912 "../src/nibbles-window.vala"
		while (TRUE) {
#line 3546 "nibbles-window.c"
			gint _tmp4_;
			gint _tmp5_;
			GamesScoresCategory* cat = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			GamesScoresCategory* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
#line 912 "../src/nibbles-window.vala"
			_cat_index = _cat_index + 1;
#line 912 "../src/nibbles-window.vala"
			_tmp4_ = _cat_index;
#line 912 "../src/nibbles-window.vala"
			_tmp5_ = _cat_size;
#line 912 "../src/nibbles-window.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 912 "../src/nibbles-window.vala"
				break;
#line 3565 "nibbles-window.c"
			}
#line 912 "../src/nibbles-window.vala"
			_tmp6_ = _cat_list;
#line 912 "../src/nibbles-window.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _cat_index);
#line 912 "../src/nibbles-window.vala"
			cat = (GamesScoresCategory*) _tmp7_;
#line 914 "../src/nibbles-window.vala"
			_tmp8_ = cat;
#line 914 "../src/nibbles-window.vala"
			_tmp9_ = games_scores_category_get_key (_tmp8_);
#line 914 "../src/nibbles-window.vala"
			_tmp10_ = _tmp9_;
#line 914 "../src/nibbles-window.vala"
			if (g_strcmp0 (key, _tmp10_) == 0) {
#line 915 "../src/nibbles-window.vala"
				result = cat;
#line 915 "../src/nibbles-window.vala"
				return result;
#line 3585 "nibbles-window.c"
			}
#line 912 "../src/nibbles-window.vala"
			_g_object_unref0 (cat);
#line 3589 "nibbles-window.c"
		}
	}
#line 917 "../src/nibbles-window.vala"
	result = NULL;
#line 917 "../src/nibbles-window.vala"
	return result;
#line 3596 "nibbles-window.c"
}

static gchar*
nibbles_window_get_new_scores_key (NibblesWindow* self,
                                   const gchar* old_key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 922 "../src/nibbles-window.vala"
	static GQuark _tmp1_label0 = 0;
#line 922 "../src/nibbles-window.vala"
	static GQuark _tmp1_label1 = 0;
#line 922 "../src/nibbles-window.vala"
	static GQuark _tmp1_label2 = 0;
#line 922 "../src/nibbles-window.vala"
	static GQuark _tmp1_label3 = 0;
#line 922 "../src/nibbles-window.vala"
	static GQuark _tmp1_label4 = 0;
#line 922 "../src/nibbles-window.vala"
	static GQuark _tmp1_label5 = 0;
#line 922 "../src/nibbles-window.vala"
	static GQuark _tmp1_label6 = 0;
#line 922 "../src/nibbles-window.vala"
	static GQuark _tmp1_label7 = 0;
#line 3621 "nibbles-window.c"
	gchar* result;
#line 920 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 920 "../src/nibbles-window.vala"
	g_return_val_if_fail (old_key != NULL, NULL);
#line 922 "../src/nibbles-window.vala"
	_tmp0_ = old_key;
#line 922 "../src/nibbles-window.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 922 "../src/nibbles-window.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("1.0")))) {
#line 922 "../src/nibbles-window.vala"
		switch (0) {
#line 3635 "nibbles-window.c"
			default:
			{
				gchar* _tmp3_;
#line 925 "../src/nibbles-window.vala"
				_tmp3_ = g_strdup ("fast");
#line 925 "../src/nibbles-window.vala"
				result = _tmp3_;
#line 925 "../src/nibbles-window.vala"
				return result;
#line 3645 "nibbles-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("2.0")))) {
#line 922 "../src/nibbles-window.vala"
		switch (0) {
#line 3651 "nibbles-window.c"
			default:
			{
				gchar* _tmp4_;
#line 927 "../src/nibbles-window.vala"
				_tmp4_ = g_strdup ("medium");
#line 927 "../src/nibbles-window.vala"
				result = _tmp4_;
#line 927 "../src/nibbles-window.vala"
				return result;
#line 3661 "nibbles-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("3.0")))) {
#line 922 "../src/nibbles-window.vala"
		switch (0) {
#line 3667 "nibbles-window.c"
			default:
			{
				gchar* _tmp5_;
#line 929 "../src/nibbles-window.vala"
				_tmp5_ = g_strdup ("slow");
#line 929 "../src/nibbles-window.vala"
				result = _tmp5_;
#line 929 "../src/nibbles-window.vala"
				return result;
#line 3677 "nibbles-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("4.0")))) {
#line 922 "../src/nibbles-window.vala"
		switch (0) {
#line 3683 "nibbles-window.c"
			default:
			{
				gchar* _tmp6_;
#line 931 "../src/nibbles-window.vala"
				_tmp6_ = g_strdup ("beginner");
#line 931 "../src/nibbles-window.vala"
				result = _tmp6_;
#line 931 "../src/nibbles-window.vala"
				return result;
#line 3693 "nibbles-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("1.1")))) {
#line 922 "../src/nibbles-window.vala"
		switch (0) {
#line 3699 "nibbles-window.c"
			default:
			{
				gchar* _tmp7_;
#line 933 "../src/nibbles-window.vala"
				_tmp7_ = g_strdup ("fast-fakes");
#line 933 "../src/nibbles-window.vala"
				result = _tmp7_;
#line 933 "../src/nibbles-window.vala"
				return result;
#line 3709 "nibbles-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("2.1")))) {
#line 922 "../src/nibbles-window.vala"
		switch (0) {
#line 3715 "nibbles-window.c"
			default:
			{
				gchar* _tmp8_;
#line 935 "../src/nibbles-window.vala"
				_tmp8_ = g_strdup ("medium-fakes");
#line 935 "../src/nibbles-window.vala"
				result = _tmp8_;
#line 935 "../src/nibbles-window.vala"
				return result;
#line 3725 "nibbles-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("3.1")))) {
#line 922 "../src/nibbles-window.vala"
		switch (0) {
#line 3731 "nibbles-window.c"
			default:
			{
				gchar* _tmp9_;
#line 937 "../src/nibbles-window.vala"
				_tmp9_ = g_strdup ("slow-fakes");
#line 937 "../src/nibbles-window.vala"
				result = _tmp9_;
#line 937 "../src/nibbles-window.vala"
				return result;
#line 3741 "nibbles-window.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string ("4.1")))) {
#line 922 "../src/nibbles-window.vala"
		switch (0) {
#line 3747 "nibbles-window.c"
			default:
			{
				gchar* _tmp10_;
#line 939 "../src/nibbles-window.vala"
				_tmp10_ = g_strdup ("beginner-fakes");
#line 939 "../src/nibbles-window.vala"
				result = _tmp10_;
#line 939 "../src/nibbles-window.vala"
				return result;
#line 3757 "nibbles-window.c"
			}
		}
	}
#line 941 "../src/nibbles-window.vala"
	result = NULL;
#line 941 "../src/nibbles-window.vala"
	return result;
#line 3765 "nibbles-window.c"
}

static GamesScoresCategory*
_nibbles_window_category_request_games_scores_context_category_request_func (const gchar* category_key,
                                                                             gpointer self)
{
	GamesScoresCategory* result;
	result = nibbles_window_category_request ((NibblesWindow*) self, category_key);
#line 964 "../src/nibbles-window.vala"
	return result;
#line 3776 "nibbles-window.c"
}

static gchar*
_nibbles_window_get_new_scores_key_games_scores_directory_importer_category_convert_func (const gchar* old_key,
                                                                                          gpointer self)
{
	gchar* result;
	result = nibbles_window_get_new_scores_key ((NibblesWindow*) self, old_key);
#line 964 "../src/nibbles-window.vala"
	return result;
#line 3787 "nibbles-window.c"
}

static void
nibbles_window_create_scores (NibblesWindow* self)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GamesScoresCategory* _tmp2_;
	GamesScoresCategory* _tmp3_;
	GeeLinkedList* _tmp4_;
	GamesScoresCategory* _tmp5_;
	GamesScoresCategory* _tmp6_;
	GeeLinkedList* _tmp7_;
	GamesScoresCategory* _tmp8_;
	GamesScoresCategory* _tmp9_;
	GeeLinkedList* _tmp10_;
	GamesScoresCategory* _tmp11_;
	GamesScoresCategory* _tmp12_;
	GeeLinkedList* _tmp13_;
	GamesScoresCategory* _tmp14_;
	GamesScoresCategory* _tmp15_;
	GeeLinkedList* _tmp16_;
	GamesScoresCategory* _tmp17_;
	GamesScoresCategory* _tmp18_;
	GeeLinkedList* _tmp19_;
	GamesScoresCategory* _tmp20_;
	GamesScoresCategory* _tmp21_;
	GeeLinkedList* _tmp22_;
	GamesScoresCategory* _tmp23_;
	GamesScoresCategory* _tmp24_;
	GamesScoresDirectoryImporter* _tmp25_;
	GamesScoresDirectoryImporter* _tmp26_;
	GamesScoresContext* _tmp27_;
#line 944 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 946 "../src/nibbles-window.vala"
	_tmp0_ = gee_linked_list_new (GAMES_SCORES_TYPE_CATEGORY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 946 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->scorecats);
#line 946 "../src/nibbles-window.vala"
	self->priv->scorecats = _tmp0_;
#line 948 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->scorecats;
#line 948 "../src/nibbles-window.vala"
	_tmp2_ = games_scores_category_new ("beginner", _ ("Beginner"));
#line 948 "../src/nibbles-window.vala"
	_tmp3_ = _tmp2_;
#line 948 "../src/nibbles-window.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _tmp3_);
#line 948 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp3_);
#line 950 "../src/nibbles-window.vala"
	_tmp4_ = self->priv->scorecats;
#line 950 "../src/nibbles-window.vala"
	_tmp5_ = games_scores_category_new ("slow", _ ("Slow"));
#line 950 "../src/nibbles-window.vala"
	_tmp6_ = _tmp5_;
#line 950 "../src/nibbles-window.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp6_);
#line 950 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp6_);
#line 952 "../src/nibbles-window.vala"
	_tmp7_ = self->priv->scorecats;
#line 952 "../src/nibbles-window.vala"
	_tmp8_ = games_scores_category_new ("medium", _ ("Medium"));
#line 952 "../src/nibbles-window.vala"
	_tmp9_ = _tmp8_;
#line 952 "../src/nibbles-window.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp9_);
#line 952 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp9_);
#line 954 "../src/nibbles-window.vala"
	_tmp10_ = self->priv->scorecats;
#line 954 "../src/nibbles-window.vala"
	_tmp11_ = games_scores_category_new ("fast", _ ("Fast"));
#line 954 "../src/nibbles-window.vala"
	_tmp12_ = _tmp11_;
#line 954 "../src/nibbles-window.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp12_);
#line 954 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp12_);
#line 956 "../src/nibbles-window.vala"
	_tmp13_ = self->priv->scorecats;
#line 956 "../src/nibbles-window.vala"
	_tmp14_ = games_scores_category_new ("beginner-fakes", _ ("Beginner with Fakes"));
#line 956 "../src/nibbles-window.vala"
	_tmp15_ = _tmp14_;
#line 956 "../src/nibbles-window.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp15_);
#line 956 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp15_);
#line 958 "../src/nibbles-window.vala"
	_tmp16_ = self->priv->scorecats;
#line 958 "../src/nibbles-window.vala"
	_tmp17_ = games_scores_category_new ("slow-fakes", _ ("Slow with Fakes"));
#line 958 "../src/nibbles-window.vala"
	_tmp18_ = _tmp17_;
#line 958 "../src/nibbles-window.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp18_);
#line 958 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp18_);
#line 960 "../src/nibbles-window.vala"
	_tmp19_ = self->priv->scorecats;
#line 960 "../src/nibbles-window.vala"
	_tmp20_ = games_scores_category_new ("medium-fakes", _ ("Medium with Fakes"));
#line 960 "../src/nibbles-window.vala"
	_tmp21_ = _tmp20_;
#line 960 "../src/nibbles-window.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp21_);
#line 960 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp21_);
#line 962 "../src/nibbles-window.vala"
	_tmp22_ = self->priv->scorecats;
#line 962 "../src/nibbles-window.vala"
	_tmp23_ = games_scores_category_new ("fast-fakes", _ ("Fast with Fakes"));
#line 962 "../src/nibbles-window.vala"
	_tmp24_ = _tmp23_;
#line 962 "../src/nibbles-window.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _tmp24_);
#line 962 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp24_);
#line 964 "../src/nibbles-window.vala"
	_tmp25_ = games_scores_directory_importer_new_with_convert_func (_nibbles_window_get_new_scores_key_games_scores_directory_importer_category_convert_func, self);
#line 964 "../src/nibbles-window.vala"
	_tmp26_ = _tmp25_;
#line 964 "../src/nibbles-window.vala"
	_tmp27_ = games_scores_context_new_with_importer_and_icon_name ("gnome-nibbles", _ ("Difficulty Level:"), (GtkWindow*) self, _nibbles_window_category_request_games_scores_context_category_request_func, self, GAMES_SCORES_STYLE_POINTS_GREATER_IS_BETTER, (GamesScoresImporter*) _tmp26_, "org.gnome.Nibbles");
#line 964 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->scores_context);
#line 964 "../src/nibbles-window.vala"
	self->priv->scores_context = _tmp27_;
#line 964 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp26_);
#line 3921 "nibbles-window.c"
}

static GamesScoresCategory*
nibbles_window_get_scores_category (NibblesWindow* self,
                                    gint speed,
                                    gboolean fakes)
{
	gchar* key = NULL;
	GeeLinkedList* _tmp18_;
	gpointer _tmp19_;
	GamesScoresCategory* result;
#line 975 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 977 "../src/nibbles-window.vala"
	key = NULL;
#line 978 "../src/nibbles-window.vala"
	switch (speed) {
#line 978 "../src/nibbles-window.vala"
		case 1:
#line 3941 "nibbles-window.c"
		{
			gchar* _tmp0_;
#line 981 "../src/nibbles-window.vala"
			_tmp0_ = g_strdup ("fast");
#line 981 "../src/nibbles-window.vala"
			_g_free0 (key);
#line 981 "../src/nibbles-window.vala"
			key = _tmp0_;
#line 982 "../src/nibbles-window.vala"
			break;
#line 3952 "nibbles-window.c"
		}
#line 978 "../src/nibbles-window.vala"
		case 2:
#line 3956 "nibbles-window.c"
		{
			gchar* _tmp1_;
#line 984 "../src/nibbles-window.vala"
			_tmp1_ = g_strdup ("medium");
#line 984 "../src/nibbles-window.vala"
			_g_free0 (key);
#line 984 "../src/nibbles-window.vala"
			key = _tmp1_;
#line 985 "../src/nibbles-window.vala"
			break;
#line 3967 "nibbles-window.c"
		}
#line 978 "../src/nibbles-window.vala"
		case 3:
#line 3971 "nibbles-window.c"
		{
			gchar* _tmp2_;
#line 987 "../src/nibbles-window.vala"
			_tmp2_ = g_strdup ("slow");
#line 987 "../src/nibbles-window.vala"
			_g_free0 (key);
#line 987 "../src/nibbles-window.vala"
			key = _tmp2_;
#line 988 "../src/nibbles-window.vala"
			break;
#line 3982 "nibbles-window.c"
		}
#line 978 "../src/nibbles-window.vala"
		case 4:
#line 3986 "nibbles-window.c"
		{
			gchar* _tmp3_;
#line 990 "../src/nibbles-window.vala"
			_tmp3_ = g_strdup ("beginner");
#line 990 "../src/nibbles-window.vala"
			_g_free0 (key);
#line 990 "../src/nibbles-window.vala"
			key = _tmp3_;
#line 991 "../src/nibbles-window.vala"
			break;
#line 3997 "nibbles-window.c"
		}
		default:
#line 978 "../src/nibbles-window.vala"
		break;
#line 4002 "nibbles-window.c"
	}
#line 994 "../src/nibbles-window.vala"
	if (fakes) {
#line 4006 "nibbles-window.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 995 "../src/nibbles-window.vala"
		_tmp4_ = key;
#line 995 "../src/nibbles-window.vala"
		_tmp5_ = g_strconcat (_tmp4_, "-fakes", NULL);
#line 995 "../src/nibbles-window.vala"
		_g_free0 (key);
#line 995 "../src/nibbles-window.vala"
		key = _tmp5_;
#line 4017 "nibbles-window.c"
	}
	{
		GeeLinkedList* _cat_list = NULL;
		GeeLinkedList* _tmp6_;
		gint _cat_size = 0;
		GeeLinkedList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _cat_index = 0;
#line 997 "../src/nibbles-window.vala"
		_tmp6_ = self->priv->scorecats;
#line 997 "../src/nibbles-window.vala"
		_cat_list = _tmp6_;
#line 997 "../src/nibbles-window.vala"
		_tmp7_ = _cat_list;
#line 997 "../src/nibbles-window.vala"
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 997 "../src/nibbles-window.vala"
		_tmp9_ = _tmp8_;
#line 997 "../src/nibbles-window.vala"
		_cat_size = _tmp9_;
#line 997 "../src/nibbles-window.vala"
		_cat_index = -1;
#line 997 "../src/nibbles-window.vala"
		while (TRUE) {
#line 4043 "nibbles-window.c"
			gint _tmp10_;
			gint _tmp11_;
			GamesScoresCategory* cat = NULL;
			GeeLinkedList* _tmp12_;
			gpointer _tmp13_;
			const gchar* _tmp14_;
			GamesScoresCategory* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 997 "../src/nibbles-window.vala"
			_cat_index = _cat_index + 1;
#line 997 "../src/nibbles-window.vala"
			_tmp10_ = _cat_index;
#line 997 "../src/nibbles-window.vala"
			_tmp11_ = _cat_size;
#line 997 "../src/nibbles-window.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 997 "../src/nibbles-window.vala"
				break;
#line 4063 "nibbles-window.c"
			}
#line 997 "../src/nibbles-window.vala"
			_tmp12_ = _cat_list;
#line 997 "../src/nibbles-window.vala"
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _cat_index);
#line 997 "../src/nibbles-window.vala"
			cat = (GamesScoresCategory*) _tmp13_;
#line 999 "../src/nibbles-window.vala"
			_tmp14_ = key;
#line 999 "../src/nibbles-window.vala"
			_tmp15_ = cat;
#line 999 "../src/nibbles-window.vala"
			_tmp16_ = games_scores_category_get_key (_tmp15_);
#line 999 "../src/nibbles-window.vala"
			_tmp17_ = _tmp16_;
#line 999 "../src/nibbles-window.vala"
			if (g_strcmp0 (_tmp14_, _tmp17_) == 0) {
#line 1000 "../src/nibbles-window.vala"
				result = cat;
#line 1000 "../src/nibbles-window.vala"
				_g_free0 (key);
#line 1000 "../src/nibbles-window.vala"
				return result;
#line 4087 "nibbles-window.c"
			}
#line 997 "../src/nibbles-window.vala"
			_g_object_unref0 (cat);
#line 4091 "nibbles-window.c"
		}
	}
#line 1003 "../src/nibbles-window.vala"
	_tmp18_ = self->priv->scorecats;
#line 1003 "../src/nibbles-window.vala"
	_tmp19_ = gee_linked_list_first (_tmp18_);
#line 1003 "../src/nibbles-window.vala"
	result = (GamesScoresCategory*) _tmp19_;
#line 1003 "../src/nibbles-window.vala"
	_g_free0 (key);
#line 1003 "../src/nibbles-window.vala"
	return result;
#line 4104 "nibbles-window.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 1006 "../src/nibbles-window.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 1006 "../src/nibbles-window.vala"
	return _data9_;
#line 4114 "nibbles-window.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 1006 "../src/nibbles-window.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 4124 "nibbles-window.c"
		NibblesWindow* self;
#line 1006 "../src/nibbles-window.vala"
		self = _data9_->self;
#line 1006 "../src/nibbles-window.vala"
		_g_object_unref0 (self);
#line 1006 "../src/nibbles-window.vala"
		g_slice_free (Block9Data, _data9_);
#line 4132 "nibbles-window.c"
	}
}

static void
__lambda43_ (Block9Data* _data9_,
             GObject* object,
             GAsyncResult* _result_)
{
	NibblesWindow* self;
	GError* _inner_error0_ = NULL;
#line 1031 "../src/nibbles-window.vala"
	self = _data9_->self;
#line 1031 "../src/nibbles-window.vala"
	g_return_if_fail (_result_ != NULL);
#line 4147 "nibbles-window.c"
	{
		GamesScoresContext* _tmp0_;
#line 1034 "../src/nibbles-window.vala"
		_tmp0_ = self->priv->scores_context;
#line 1034 "../src/nibbles-window.vala"
		games_scores_context_add_score_finish (_tmp0_, _result_, &_inner_error0_);
#line 1034 "../src/nibbles-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4156 "nibbles-window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 1032 "../src/nibbles-window.vala"
		e = _inner_error0_;
#line 1032 "../src/nibbles-window.vala"
		_inner_error0_ = NULL;
#line 1038 "../src/nibbles-window.vala"
		_tmp1_ = e;
#line 1038 "../src/nibbles-window.vala"
		_tmp2_ = _tmp1_->message;
#line 1038 "../src/nibbles-window.vala"
		g_warning ("nibbles-window.vala:1038: Failed to add score: %s", _tmp2_);
#line 1032 "../src/nibbles-window.vala"
		_g_error_free0 (e);
#line 4178 "nibbles-window.c"
	}
	__finally0:
#line 1032 "../src/nibbles-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1032 "../src/nibbles-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1032 "../src/nibbles-window.vala"
		g_clear_error (&_inner_error0_);
#line 1032 "../src/nibbles-window.vala"
		return;
#line 4189 "nibbles-window.c"
	}
#line 1041 "../src/nibbles-window.vala"
	nibbles_window_game_over (self, _data9_->score, _data9_->lowest_high_score, _data9_->level_reached);
#line 4193 "nibbles-window.c"
}

static void
___lambda43__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 1028 "../src/nibbles-window.vala"
	__lambda43_ (self, source_object, res);
#line 1028 "../src/nibbles-window.vala"
	block9_data_unref (self);
#line 4205 "nibbles-window.c"
}

static void
nibbles_window_log_score_cb (NibblesWindow* self,
                             gint score,
                             gint level_reached)
{
	Block9Data* _data9_;
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GeeList* scores = NULL;
	GamesScoresContext* _tmp3_;
	NibblesGame* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	NibblesGame* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GamesScoresCategory* _tmp10_;
	GamesScoresCategory* _tmp11_;
	GeeList* _tmp12_;
	GeeList* _tmp13_;
	glong _tmp14_ = 0L;
	GeeList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	NibblesGame* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	NibblesGame* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	GamesScoresContext* _tmp29_;
	NibblesGame* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	NibblesGame* _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp35_;
	GamesScoresCategory* _tmp36_;
	GamesScoresCategory* _tmp37_;
#line 1006 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 1006 "../src/nibbles-window.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 1006 "../src/nibbles-window.vala"
	_data9_->_ref_count_ = 1;
#line 1006 "../src/nibbles-window.vala"
	_data9_->self = g_object_ref (self);
#line 1006 "../src/nibbles-window.vala"
	_data9_->score = score;
#line 1006 "../src/nibbles-window.vala"
	_data9_->level_reached = level_reached;
#line 1009 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->new_game_action;
#line 1009 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp0_, FALSE);
#line 1010 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->pause_action;
#line 1010 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp1_, FALSE);
#line 1011 "../src/nibbles-window.vala"
	_tmp2_ = self->priv->back_action;
#line 1011 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp2_, FALSE);
#line 1013 "../src/nibbles-window.vala"
	_tmp3_ = self->priv->scores_context;
#line 1013 "../src/nibbles-window.vala"
	_tmp4_ = self->priv->game;
#line 1013 "../src/nibbles-window.vala"
	_tmp5_ = nibbles_game_get_speed (_tmp4_);
#line 1013 "../src/nibbles-window.vala"
	_tmp6_ = _tmp5_;
#line 1013 "../src/nibbles-window.vala"
	_tmp7_ = self->priv->game;
#line 1013 "../src/nibbles-window.vala"
	_tmp8_ = nibbles_game_get_fakes (_tmp7_);
#line 1013 "../src/nibbles-window.vala"
	_tmp9_ = _tmp8_;
#line 1013 "../src/nibbles-window.vala"
	_tmp10_ = nibbles_window_get_scores_category (self, _tmp6_, _tmp9_);
#line 1013 "../src/nibbles-window.vala"
	_tmp11_ = _tmp10_;
#line 1013 "../src/nibbles-window.vala"
	_tmp12_ = games_scores_context_get_high_scores (_tmp3_, _tmp11_, 10);
#line 1013 "../src/nibbles-window.vala"
	_tmp13_ = _tmp12_;
#line 1013 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp11_);
#line 1013 "../src/nibbles-window.vala"
	scores = _tmp13_;
#line 1014 "../src/nibbles-window.vala"
	_tmp15_ = scores;
#line 1014 "../src/nibbles-window.vala"
	_tmp16_ = gee_collection_get_size ((GeeCollection*) _tmp15_);
#line 1014 "../src/nibbles-window.vala"
	_tmp17_ = _tmp16_;
#line 1014 "../src/nibbles-window.vala"
	if (_tmp17_ == 10) {
#line 4306 "nibbles-window.c"
		GeeList* _tmp18_;
		gpointer _tmp19_;
		GamesScoresScore* _tmp20_;
		glong _tmp21_;
		glong _tmp22_;
#line 1014 "../src/nibbles-window.vala"
		_tmp18_ = scores;
#line 1014 "../src/nibbles-window.vala"
		_tmp19_ = gee_list_last (_tmp18_);
#line 1014 "../src/nibbles-window.vala"
		_tmp20_ = (GamesScoresScore*) _tmp19_;
#line 1014 "../src/nibbles-window.vala"
		_tmp21_ = games_scores_score_get_score (_tmp20_);
#line 1014 "../src/nibbles-window.vala"
		_tmp22_ = _tmp21_;
#line 1014 "../src/nibbles-window.vala"
		_tmp14_ = _tmp22_;
#line 1014 "../src/nibbles-window.vala"
		_g_object_unref0 (_tmp20_);
#line 4326 "nibbles-window.c"
	} else {
#line 1014 "../src/nibbles-window.vala"
		_tmp14_ = (glong) -1;
#line 4330 "nibbles-window.c"
	}
#line 1014 "../src/nibbles-window.vala"
	_data9_->lowest_high_score = _tmp14_;
#line 1016 "../src/nibbles-window.vala"
	_tmp23_ = self->priv->game;
#line 1016 "../src/nibbles-window.vala"
	_tmp24_ = nibbles_game_get_numhumans (_tmp23_);
#line 1016 "../src/nibbles-window.vala"
	_tmp25_ = _tmp24_;
#line 1016 "../src/nibbles-window.vala"
	if (_tmp25_ != 1) {
#line 1018 "../src/nibbles-window.vala"
		nibbles_window_game_over (self, _data9_->score, _data9_->lowest_high_score, _data9_->level_reached);
#line 1019 "../src/nibbles-window.vala"
		_g_object_unref0 (scores);
#line 1019 "../src/nibbles-window.vala"
		block9_data_unref (_data9_);
#line 1019 "../src/nibbles-window.vala"
		_data9_ = NULL;
#line 1019 "../src/nibbles-window.vala"
		return;
#line 4352 "nibbles-window.c"
	}
#line 1022 "../src/nibbles-window.vala"
	_tmp26_ = self->priv->game;
#line 1022 "../src/nibbles-window.vala"
	_tmp27_ = nibbles_game_get_skip_score (_tmp26_);
#line 1022 "../src/nibbles-window.vala"
	_tmp28_ = _tmp27_;
#line 1022 "../src/nibbles-window.vala"
	if (_tmp28_) {
#line 1024 "../src/nibbles-window.vala"
		nibbles_window_game_over (self, _data9_->score, _data9_->lowest_high_score, _data9_->level_reached);
#line 1025 "../src/nibbles-window.vala"
		_g_object_unref0 (scores);
#line 1025 "../src/nibbles-window.vala"
		block9_data_unref (_data9_);
#line 1025 "../src/nibbles-window.vala"
		_data9_ = NULL;
#line 1025 "../src/nibbles-window.vala"
		return;
#line 4372 "nibbles-window.c"
	}
#line 1028 "../src/nibbles-window.vala"
	_tmp29_ = self->priv->scores_context;
#line 1028 "../src/nibbles-window.vala"
	_tmp30_ = self->priv->game;
#line 1028 "../src/nibbles-window.vala"
	_tmp31_ = nibbles_game_get_speed (_tmp30_);
#line 1028 "../src/nibbles-window.vala"
	_tmp32_ = _tmp31_;
#line 1028 "../src/nibbles-window.vala"
	_tmp33_ = self->priv->game;
#line 1028 "../src/nibbles-window.vala"
	_tmp34_ = nibbles_game_get_fakes (_tmp33_);
#line 1028 "../src/nibbles-window.vala"
	_tmp35_ = _tmp34_;
#line 1028 "../src/nibbles-window.vala"
	_tmp36_ = nibbles_window_get_scores_category (self, _tmp32_, _tmp35_);
#line 1028 "../src/nibbles-window.vala"
	_tmp37_ = _tmp36_;
#line 1028 "../src/nibbles-window.vala"
	games_scores_context_add_score (_tmp29_, (glong) _data9_->score, _tmp37_, NULL, ___lambda43__gasync_ready_callback, block9_data_ref (_data9_));
#line 1028 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp37_);
#line 1006 "../src/nibbles-window.vala"
	_g_object_unref0 (scores);
#line 1006 "../src/nibbles-window.vala"
	block9_data_unref (_data9_);
#line 1006 "../src/nibbles-window.vala"
	_data9_ = NULL;
#line 4402 "nibbles-window.c"
}

static void
nibbles_window_scores_cb (NibblesWindow* self)
{
	gboolean should_unpause = FALSE;
	NibblesGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GamesScoresContext* _tmp4_;
#line 1045 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 1047 "../src/nibbles-window.vala"
	should_unpause = FALSE;
#line 1048 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->game;
#line 1048 "../src/nibbles-window.vala"
	_tmp1_ = nibbles_game_get_is_running (_tmp0_);
#line 1048 "../src/nibbles-window.vala"
	_tmp2_ = _tmp1_;
#line 1048 "../src/nibbles-window.vala"
	if (_tmp2_) {
#line 4425 "nibbles-window.c"
		GSimpleAction* _tmp3_;
#line 1050 "../src/nibbles-window.vala"
		_tmp3_ = self->priv->pause_action;
#line 1050 "../src/nibbles-window.vala"
		g_signal_emit_by_name (_tmp3_, "activate", NULL);
#line 1051 "../src/nibbles-window.vala"
		should_unpause = TRUE;
#line 4433 "nibbles-window.c"
	}
#line 1054 "../src/nibbles-window.vala"
	_tmp4_ = self->priv->scores_context;
#line 1054 "../src/nibbles-window.vala"
	games_scores_context_run_dialog (_tmp4_);
#line 1057 "../src/nibbles-window.vala"
	if (should_unpause) {
#line 4441 "nibbles-window.c"
		GSimpleAction* _tmp5_;
#line 1058 "../src/nibbles-window.vala"
		_tmp5_ = self->priv->pause_action;
#line 1058 "../src/nibbles-window.vala"
		g_signal_emit_by_name (_tmp5_, "activate", NULL);
#line 4447 "nibbles-window.c"
	}
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 1061 "../src/nibbles-window.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 1061 "../src/nibbles-window.vala"
	return _data10_;
#line 4458 "nibbles-window.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 1061 "../src/nibbles-window.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 4468 "nibbles-window.c"
		NibblesWindow* self;
#line 1061 "../src/nibbles-window.vala"
		self = _data10_->self;
#line 1061 "../src/nibbles-window.vala"
		_g_object_unref0 (_data10_->button);
#line 1061 "../src/nibbles-window.vala"
		_g_object_unref0 (self);
#line 1061 "../src/nibbles-window.vala"
		g_slice_free (Block10Data, _data10_);
#line 4478 "nibbles-window.c"
	}
}

static void
__lambda44_ (NibblesWindow* self)
{
	NibblesGame* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	NibblesView* _tmp5_;
#line 1091 "../src/nibbles-window.vala"
	nibbles_window_overlay_remove_all (self);
#line 1094 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->game;
#line 1094 "../src/nibbles-window.vala"
	_tmp1_ = nibbles_game_get_current_level (_tmp0_);
#line 1094 "../src/nibbles-window.vala"
	_tmp2_ = _tmp1_;
#line 1094 "../src/nibbles-window.vala"
	_tmp3_ = g_strdup_printf (_ ("Level %d"), _tmp2_);
#line 1094 "../src/nibbles-window.vala"
	_tmp4_ = _tmp3_;
#line 1094 "../src/nibbles-window.vala"
	nibbles_window_set_headerbar_title (self, _tmp4_);
#line 1094 "../src/nibbles-window.vala"
	_g_free0 (_tmp4_);
#line 1096 "../src/nibbles-window.vala"
	_tmp5_ = self->priv->view;
#line 1096 "../src/nibbles-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp5_);
#line 1098 "../src/nibbles-window.vala"
	nibbles_window_restart_game (self);
#line 4513 "nibbles-window.c"
}

static void
___lambda44__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 1089 "../src/nibbles-window.vala"
	__lambda44_ ((NibblesWindow*) self);
#line 4522 "nibbles-window.c"
}

static gboolean
__lambda45_ (Block10Data* _data10_)
{
	NibblesWindow* self;
	GtkButton* _tmp0_;
	gboolean result;
#line 1106 "../src/nibbles-window.vala"
	self = _data10_->self;
#line 1107 "../src/nibbles-window.vala"
	_tmp0_ = _data10_->button;
#line 1107 "../src/nibbles-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 1110 "../src/nibbles-window.vala"
	result = G_SOURCE_REMOVE;
#line 1110 "../src/nibbles-window.vala"
	return result;
#line 4541 "nibbles-window.c"
}

static gboolean
___lambda45__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda45_ (self);
#line 1106 "../src/nibbles-window.vala"
	return result;
#line 4551 "nibbles-window.c"
}

static void
nibbles_window_level_completed_cb (NibblesWindow* self)
{
	Block10Data* _data10_;
	NibblesGame* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	NibblesView* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
	GtkLabel* label = NULL;
	NibblesGame* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	PangoAttrList* _tmp18_;
	PangoAttrList* _tmp19_;
	GtkLabel* _tmp23_;
	PangoAttrList* _tmp24_;
	PangoAttrList* _tmp25_;
	PangoAttribute* _tmp26_;
	GtkLabel* _tmp27_;
	PangoAttrList* _tmp28_;
	PangoAttrList* _tmp29_;
	PangoAttribute* _tmp30_;
	GtkLabel* _tmp31_;
	GtkButton* _tmp32_;
	GtkButton* _tmp33_;
	GtkButton* _tmp34_;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkButton* _tmp37_;
	GtkLabel* _tmp38_;
	GtkButton* _tmp39_;
	GtkButton* _tmp40_;
#line 1061 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 1061 "../src/nibbles-window.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 1061 "../src/nibbles-window.vala"
	_data10_->_ref_count_ = 1;
#line 1061 "../src/nibbles-window.vala"
	_data10_->self = g_object_ref (self);
#line 1063 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->game;
#line 1063 "../src/nibbles-window.vala"
	_tmp1_ = nibbles_game_get_current_level (_tmp0_);
#line 1063 "../src/nibbles-window.vala"
	_tmp2_ = _tmp1_;
#line 1063 "../src/nibbles-window.vala"
	if (_tmp2_ == NIBBLES_GAME_MAX_LEVEL) {
#line 1064 "../src/nibbles-window.vala"
		block10_data_unref (_data10_);
#line 1064 "../src/nibbles-window.vala"
		_data10_ = NULL;
#line 1064 "../src/nibbles-window.vala"
		return;
#line 4619 "nibbles-window.c"
	}
#line 1066 "../src/nibbles-window.vala"
	_tmp3_ = self->priv->view;
#line 1066 "../src/nibbles-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 1068 "../src/nibbles-window.vala"
	_tmp4_ = self->priv->new_game_action;
#line 1068 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp4_, FALSE);
#line 1069 "../src/nibbles-window.vala"
	_tmp5_ = self->priv->pause_action;
#line 1069 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp5_, FALSE);
#line 1070 "../src/nibbles-window.vala"
	_tmp6_ = self->priv->back_action;
#line 1070 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp6_, FALSE);
#line 1073 "../src/nibbles-window.vala"
	_tmp7_ = self->priv->game;
#line 1073 "../src/nibbles-window.vala"
	_tmp8_ = nibbles_game_get_current_level (_tmp7_);
#line 1073 "../src/nibbles-window.vala"
	_tmp9_ = _tmp8_;
#line 1073 "../src/nibbles-window.vala"
	_tmp10_ = g_strdup_printf (_ ("Level %d Completed!"), _tmp9_);
#line 1073 "../src/nibbles-window.vala"
	_tmp11_ = _tmp10_;
#line 1073 "../src/nibbles-window.vala"
	_tmp12_ = (GtkLabel*) gtk_label_new (_tmp11_);
#line 1073 "../src/nibbles-window.vala"
	g_object_ref_sink (_tmp12_);
#line 1073 "../src/nibbles-window.vala"
	_tmp13_ = _tmp12_;
#line 1073 "../src/nibbles-window.vala"
	_g_free0 (_tmp11_);
#line 1073 "../src/nibbles-window.vala"
	label = _tmp13_;
#line 1074 "../src/nibbles-window.vala"
	_tmp14_ = label;
#line 1074 "../src/nibbles-window.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
#line 1075 "../src/nibbles-window.vala"
	_tmp15_ = label;
#line 1075 "../src/nibbles-window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp15_, GTK_ALIGN_START);
#line 1076 "../src/nibbles-window.vala"
	_tmp16_ = label;
#line 1076 "../src/nibbles-window.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp16_, 150);
#line 1077 "../src/nibbles-window.vala"
	_tmp17_ = label;
#line 1077 "../src/nibbles-window.vala"
	_tmp18_ = gtk_label_get_attributes (_tmp17_);
#line 1077 "../src/nibbles-window.vala"
	_tmp19_ = _tmp18_;
#line 1077 "../src/nibbles-window.vala"
	if (_tmp19_ == NULL) {
#line 4677 "nibbles-window.c"
		GtkLabel* _tmp20_;
		PangoAttrList* _tmp21_;
		PangoAttrList* _tmp22_;
#line 1078 "../src/nibbles-window.vala"
		_tmp20_ = label;
#line 1078 "../src/nibbles-window.vala"
		_tmp21_ = pango_attr_list_new ();
#line 1078 "../src/nibbles-window.vala"
		_tmp22_ = _tmp21_;
#line 1078 "../src/nibbles-window.vala"
		gtk_label_set_attributes (_tmp20_, _tmp22_);
#line 1078 "../src/nibbles-window.vala"
		_pango_attr_list_unref0 (_tmp22_);
#line 4691 "nibbles-window.c"
	}
#line 1079 "../src/nibbles-window.vala"
	_tmp23_ = label;
#line 1079 "../src/nibbles-window.vala"
	_tmp24_ = gtk_label_get_attributes (_tmp23_);
#line 1079 "../src/nibbles-window.vala"
	_tmp25_ = _tmp24_;
#line 1079 "../src/nibbles-window.vala"
	_tmp26_ = pango_attr_scale_new (PANGO_SCALE_X_LARGE);
#line 1079 "../src/nibbles-window.vala"
	pango_attr_list_insert (_tmp25_, _tmp26_);
#line 1080 "../src/nibbles-window.vala"
	_tmp27_ = label;
#line 1080 "../src/nibbles-window.vala"
	_tmp28_ = gtk_label_get_attributes (_tmp27_);
#line 1080 "../src/nibbles-window.vala"
	_tmp29_ = _tmp28_;
#line 1080 "../src/nibbles-window.vala"
	_tmp30_ = pango_attr_weight_new (PANGO_WEIGHT_BOLD);
#line 1080 "../src/nibbles-window.vala"
	pango_attr_list_insert (_tmp29_, _tmp30_);
#line 1081 "../src/nibbles-window.vala"
	_tmp31_ = label;
#line 1081 "../src/nibbles-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp31_);
#line 1084 "../src/nibbles-window.vala"
	_tmp32_ = (GtkButton*) gtk_button_new_with_label (_ ("_Next Level"));
#line 1084 "../src/nibbles-window.vala"
	g_object_ref_sink (_tmp32_);
#line 1084 "../src/nibbles-window.vala"
	_data10_->button = _tmp32_;
#line 1085 "../src/nibbles-window.vala"
	_tmp33_ = _data10_->button;
#line 1085 "../src/nibbles-window.vala"
	gtk_button_set_use_underline (_tmp33_, TRUE);
#line 1086 "../src/nibbles-window.vala"
	_tmp34_ = _data10_->button;
#line 1086 "../src/nibbles-window.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp34_, GTK_ALIGN_CENTER);
#line 1087 "../src/nibbles-window.vala"
	_tmp35_ = _data10_->button;
#line 1087 "../src/nibbles-window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp35_, GTK_ALIGN_END);
#line 1088 "../src/nibbles-window.vala"
	_tmp36_ = _data10_->button;
#line 1088 "../src/nibbles-window.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp36_, 100);
#line 1089 "../src/nibbles-window.vala"
	_tmp37_ = _data10_->button;
#line 1089 "../src/nibbles-window.vala"
	g_signal_connect_object (_tmp37_, "clicked", (GCallback) ___lambda44__gtk_button_clicked, self, 0);
#line 1101 "../src/nibbles-window.vala"
	_tmp38_ = label;
#line 1101 "../src/nibbles-window.vala"
	nibbles_window_overlay_add (self, (GtkWidget*) _tmp38_);
#line 1102 "../src/nibbles-window.vala"
	_tmp39_ = _data10_->button;
#line 1102 "../src/nibbles-window.vala"
	nibbles_window_overlay_add (self, (GtkWidget*) _tmp39_);
#line 1104 "../src/nibbles-window.vala"
	_tmp40_ = _data10_->button;
#line 1104 "../src/nibbles-window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp40_);
#line 1106 "../src/nibbles-window.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda45__gsource_func, block10_data_ref (_data10_), block10_data_unref);
#line 1061 "../src/nibbles-window.vala"
	_g_object_unref0 (label);
#line 1061 "../src/nibbles-window.vala"
	block10_data_unref (_data10_);
#line 1061 "../src/nibbles-window.vala"
	_data10_ = NULL;
#line 4763 "nibbles-window.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 4776 "nibbles-window.c"
}

static void
nibbles_window_game_over (NibblesWindow* self,
                          gint score,
                          glong lowest_high_score,
                          gint level_reached)
{
	gboolean is_high_score = FALSE;
	gboolean is_game_won = FALSE;
	const gchar* _tmp0_ = NULL;
	GtkLabel* game_over_label = NULL;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	PangoAttrList* _tmp6_;
	PangoAttrList* _tmp7_;
	GtkLabel* _tmp11_;
	PangoAttrList* _tmp12_;
	PangoAttrList* _tmp13_;
	PangoAttribute* _tmp14_;
	GtkLabel* _tmp15_;
	PangoAttrList* _tmp16_;
	PangoAttrList* _tmp17_;
	PangoAttribute* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* msg_label = NULL;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	PangoAttrList* _tmp25_;
	PangoAttrList* _tmp26_;
	GtkLabel* _tmp30_;
	PangoAttrList* _tmp31_;
	PangoAttrList* _tmp32_;
	PangoAttribute* _tmp33_;
	GtkLabel* _tmp34_;
	PangoAttrList* _tmp35_;
	PangoAttrList* _tmp36_;
	PangoAttribute* _tmp37_;
	GtkLabel* _tmp38_;
	gchar* score_string = NULL;
	gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	GtkLabel* score_label = NULL;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	GtkLabel* _tmp46_;
	GtkLabel* _tmp47_;
	GtkLabel* _tmp48_;
	GtkLabel* _tmp49_;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_;
	GtkLabel* _tmp52_;
	glong points_left = 0L;
	GtkLabel* points_left_label = NULL;
	gchar* _tmp53_;
	gchar* _tmp54_;
	GtkLabel* _tmp55_;
	GtkLabel* _tmp56_;
	GtkLabel* _tmp57_;
	GtkLabel* _tmp58_;
	GtkLabel* _tmp59_;
	GtkLabel* _tmp60_;
	GtkButton* play_again_button = NULL;
	GtkButton* _tmp61_;
	GtkButton* _tmp62_;
	GtkButton* _tmp63_;
	GtkButton* _tmp64_;
	GtkButton* _tmp65_;
	GtkButton* _tmp66_;
	GtkButton* _tmp67_;
	GtkLabel* _tmp68_;
	NibblesGame* _tmp70_;
	gint _tmp71_;
	gint _tmp72_;
	gboolean _tmp74_ = FALSE;
	NibblesGame* _tmp75_;
	gint _tmp76_;
	gint _tmp77_;
	GtkButton* _tmp79_;
	GtkButton* _tmp80_;
	NibblesView* _tmp81_;
	GSimpleAction* _tmp82_;
	GSimpleAction* _tmp83_;
	GSimpleAction* _tmp84_;
#line 1115 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 1117 "../src/nibbles-window.vala"
	is_high_score = ((glong) score) > lowest_high_score;
#line 1118 "../src/nibbles-window.vala"
	is_game_won = level_reached == (NIBBLES_GAME_MAX_LEVEL + 1);
#line 1121 "../src/nibbles-window.vala"
	if (is_game_won) {
#line 1121 "../src/nibbles-window.vala"
		_tmp0_ = _ ("Congratulations!");
#line 4880 "nibbles-window.c"
	} else {
#line 1125 "../src/nibbles-window.vala"
		_tmp0_ = _ ("Game Over!");
#line 4884 "nibbles-window.c"
	}
#line 1121 "../src/nibbles-window.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_tmp0_);
#line 1121 "../src/nibbles-window.vala"
	g_object_ref_sink (_tmp1_);
#line 1121 "../src/nibbles-window.vala"
	game_over_label = _tmp1_;
#line 1126 "../src/nibbles-window.vala"
	_tmp2_ = game_over_label;
#line 1126 "../src/nibbles-window.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
#line 1127 "../src/nibbles-window.vala"
	_tmp3_ = game_over_label;
#line 1127 "../src/nibbles-window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 1128 "../src/nibbles-window.vala"
	_tmp4_ = game_over_label;
#line 1128 "../src/nibbles-window.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp4_, 150);
#line 1129 "../src/nibbles-window.vala"
	_tmp5_ = game_over_label;
#line 1129 "../src/nibbles-window.vala"
	_tmp6_ = gtk_label_get_attributes (_tmp5_);
#line 1129 "../src/nibbles-window.vala"
	_tmp7_ = _tmp6_;
#line 1129 "../src/nibbles-window.vala"
	if (_tmp7_ == NULL) {
#line 4912 "nibbles-window.c"
		GtkLabel* _tmp8_;
		PangoAttrList* _tmp9_;
		PangoAttrList* _tmp10_;
#line 1130 "../src/nibbles-window.vala"
		_tmp8_ = game_over_label;
#line 1130 "../src/nibbles-window.vala"
		_tmp9_ = pango_attr_list_new ();
#line 1130 "../src/nibbles-window.vala"
		_tmp10_ = _tmp9_;
#line 1130 "../src/nibbles-window.vala"
		gtk_label_set_attributes (_tmp8_, _tmp10_);
#line 1130 "../src/nibbles-window.vala"
		_pango_attr_list_unref0 (_tmp10_);
#line 4926 "nibbles-window.c"
	}
#line 1131 "../src/nibbles-window.vala"
	_tmp11_ = game_over_label;
#line 1131 "../src/nibbles-window.vala"
	_tmp12_ = gtk_label_get_attributes (_tmp11_);
#line 1131 "../src/nibbles-window.vala"
	_tmp13_ = _tmp12_;
#line 1131 "../src/nibbles-window.vala"
	_tmp14_ = pango_attr_scale_new (PANGO_SCALE_X_LARGE);
#line 1131 "../src/nibbles-window.vala"
	pango_attr_list_insert (_tmp13_, _tmp14_);
#line 1132 "../src/nibbles-window.vala"
	_tmp15_ = game_over_label;
#line 1132 "../src/nibbles-window.vala"
	_tmp16_ = gtk_label_get_attributes (_tmp15_);
#line 1132 "../src/nibbles-window.vala"
	_tmp17_ = _tmp16_;
#line 1132 "../src/nibbles-window.vala"
	_tmp18_ = pango_attr_weight_new (PANGO_WEIGHT_BOLD);
#line 1132 "../src/nibbles-window.vala"
	pango_attr_list_insert (_tmp17_, _tmp18_);
#line 1134 "../src/nibbles-window.vala"
	_tmp19_ = game_over_label;
#line 1134 "../src/nibbles-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp19_);
#line 1137 "../src/nibbles-window.vala"
	_tmp20_ = (GtkLabel*) gtk_label_new (_ ("You have completed the game."));
#line 1137 "../src/nibbles-window.vala"
	g_object_ref_sink (_tmp20_);
#line 1137 "../src/nibbles-window.vala"
	msg_label = _tmp20_;
#line 1138 "../src/nibbles-window.vala"
	_tmp21_ = msg_label;
#line 1138 "../src/nibbles-window.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp21_, GTK_ALIGN_CENTER);
#line 1139 "../src/nibbles-window.vala"
	_tmp22_ = msg_label;
#line 1139 "../src/nibbles-window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp22_, GTK_ALIGN_START);
#line 1140 "../src/nibbles-window.vala"
	_tmp23_ = msg_label;
#line 1140 "../src/nibbles-window.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp23_, gtk_widget_get_height ((GtkWidget*) self) / 3);
#line 1141 "../src/nibbles-window.vala"
	_tmp24_ = msg_label;
#line 1141 "../src/nibbles-window.vala"
	_tmp25_ = gtk_label_get_attributes (_tmp24_);
#line 1141 "../src/nibbles-window.vala"
	_tmp26_ = _tmp25_;
#line 1141 "../src/nibbles-window.vala"
	if (_tmp26_ == NULL) {
#line 4978 "nibbles-window.c"
		GtkLabel* _tmp27_;
		PangoAttrList* _tmp28_;
		PangoAttrList* _tmp29_;
#line 1142 "../src/nibbles-window.vala"
		_tmp27_ = msg_label;
#line 1142 "../src/nibbles-window.vala"
		_tmp28_ = pango_attr_list_new ();
#line 1142 "../src/nibbles-window.vala"
		_tmp29_ = _tmp28_;
#line 1142 "../src/nibbles-window.vala"
		gtk_label_set_attributes (_tmp27_, _tmp29_);
#line 1142 "../src/nibbles-window.vala"
		_pango_attr_list_unref0 (_tmp29_);
#line 4992 "nibbles-window.c"
	}
#line 1143 "../src/nibbles-window.vala"
	_tmp30_ = msg_label;
#line 1143 "../src/nibbles-window.vala"
	_tmp31_ = gtk_label_get_attributes (_tmp30_);
#line 1143 "../src/nibbles-window.vala"
	_tmp32_ = _tmp31_;
#line 1143 "../src/nibbles-window.vala"
	_tmp33_ = pango_attr_scale_new (PANGO_SCALE_X_LARGE);
#line 1143 "../src/nibbles-window.vala"
	pango_attr_list_insert (_tmp32_, _tmp33_);
#line 1144 "../src/nibbles-window.vala"
	_tmp34_ = msg_label;
#line 1144 "../src/nibbles-window.vala"
	_tmp35_ = gtk_label_get_attributes (_tmp34_);
#line 1144 "../src/nibbles-window.vala"
	_tmp36_ = _tmp35_;
#line 1144 "../src/nibbles-window.vala"
	_tmp37_ = pango_attr_weight_new (PANGO_WEIGHT_BOLD);
#line 1144 "../src/nibbles-window.vala"
	pango_attr_list_insert (_tmp36_, _tmp37_);
#line 1145 "../src/nibbles-window.vala"
	_tmp38_ = msg_label;
#line 1145 "../src/nibbles-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp38_);
#line 1147 "../src/nibbles-window.vala"
	_tmp39_ = g_strdup (ngettext ("%d Point", "%d Points", (gulong) score));
#line 1147 "../src/nibbles-window.vala"
	score_string = _tmp39_;
#line 1148 "../src/nibbles-window.vala"
	_tmp40_ = score_string;
#line 1148 "../src/nibbles-window.vala"
	_tmp41_ = g_strdup_printf (_tmp40_, score);
#line 1148 "../src/nibbles-window.vala"
	_g_free0 (score_string);
#line 1148 "../src/nibbles-window.vala"
	score_string = _tmp41_;
#line 1149 "../src/nibbles-window.vala"
	_tmp42_ = score_string;
#line 1149 "../src/nibbles-window.vala"
	_tmp43_ = string_to_string (_tmp42_);
#line 1149 "../src/nibbles-window.vala"
	_tmp44_ = g_strconcat ("<b>", _tmp43_, "</b>", NULL);
#line 1149 "../src/nibbles-window.vala"
	_tmp45_ = _tmp44_;
#line 1149 "../src/nibbles-window.vala"
	_tmp46_ = (GtkLabel*) gtk_label_new (_tmp45_);
#line 1149 "../src/nibbles-window.vala"
	g_object_ref_sink (_tmp46_);
#line 1149 "../src/nibbles-window.vala"
	_tmp47_ = _tmp46_;
#line 1149 "../src/nibbles-window.vala"
	_g_free0 (_tmp45_);
#line 1149 "../src/nibbles-window.vala"
	score_label = _tmp47_;
#line 1150 "../src/nibbles-window.vala"
	_tmp48_ = score_label;
#line 1150 "../src/nibbles-window.vala"
	gtk_label_set_use_markup (_tmp48_, TRUE);
#line 1151 "../src/nibbles-window.vala"
	_tmp49_ = score_label;
#line 1151 "../src/nibbles-window.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp49_, GTK_ALIGN_CENTER);
#line 1152 "../src/nibbles-window.vala"
	_tmp50_ = score_label;
#line 1152 "../src/nibbles-window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp50_, GTK_ALIGN_START);
#line 1153 "../src/nibbles-window.vala"
	_tmp51_ = score_label;
#line 1153 "../src/nibbles-window.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp51_, (gtk_widget_get_height ((GtkWidget*) self) / 3) + 80);
#line 1154 "../src/nibbles-window.vala"
	_tmp52_ = score_label;
#line 1154 "../src/nibbles-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp52_);
#line 1156 "../src/nibbles-window.vala"
	points_left = lowest_high_score - score;
#line 1158 "../src/nibbles-window.vala"
	_tmp53_ = g_strdup_printf (_ ("(%ld more points to reach the leaderboard)"), points_left);
#line 1158 "../src/nibbles-window.vala"
	_tmp54_ = _tmp53_;
#line 1158 "../src/nibbles-window.vala"
	_tmp55_ = (GtkLabel*) gtk_label_new (_tmp54_);
#line 1158 "../src/nibbles-window.vala"
	g_object_ref_sink (_tmp55_);
#line 1158 "../src/nibbles-window.vala"
	_tmp56_ = _tmp55_;
#line 1158 "../src/nibbles-window.vala"
	_g_free0 (_tmp54_);
#line 1158 "../src/nibbles-window.vala"
	points_left_label = _tmp56_;
#line 1159 "../src/nibbles-window.vala"
	_tmp57_ = points_left_label;
#line 1159 "../src/nibbles-window.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp57_, GTK_ALIGN_CENTER);
#line 1160 "../src/nibbles-window.vala"
	_tmp58_ = points_left_label;
#line 1160 "../src/nibbles-window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp58_, GTK_ALIGN_START);
#line 1161 "../src/nibbles-window.vala"
	_tmp59_ = points_left_label;
#line 1161 "../src/nibbles-window.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp59_, (gtk_widget_get_height ((GtkWidget*) self) / 3) + 100);
#line 1162 "../src/nibbles-window.vala"
	_tmp60_ = points_left_label;
#line 1162 "../src/nibbles-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp60_);
#line 1165 "../src/nibbles-window.vala"
	_tmp61_ = (GtkButton*) gtk_button_new_with_label (_ ("_Play Again"));
#line 1165 "../src/nibbles-window.vala"
	g_object_ref_sink (_tmp61_);
#line 1165 "../src/nibbles-window.vala"
	play_again_button = _tmp61_;
#line 1166 "../src/nibbles-window.vala"
	_tmp62_ = play_again_button;
#line 1166 "../src/nibbles-window.vala"
	gtk_button_set_use_underline (_tmp62_, TRUE);
#line 1167 "../src/nibbles-window.vala"
	_tmp63_ = play_again_button;
#line 1167 "../src/nibbles-window.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp63_, GTK_ALIGN_CENTER);
#line 1168 "../src/nibbles-window.vala"
	_tmp64_ = play_again_button;
#line 1168 "../src/nibbles-window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp64_, GTK_ALIGN_END);
#line 1169 "../src/nibbles-window.vala"
	_tmp65_ = play_again_button;
#line 1169 "../src/nibbles-window.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp65_, 100);
#line 1170 "../src/nibbles-window.vala"
	_tmp66_ = play_again_button;
#line 1170 "../src/nibbles-window.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp66_, "win.new-game");
#line 1171 "../src/nibbles-window.vala"
	_tmp67_ = play_again_button;
#line 1171 "../src/nibbles-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp67_);
#line 1173 "../src/nibbles-window.vala"
	_tmp68_ = game_over_label;
#line 1173 "../src/nibbles-window.vala"
	nibbles_window_overlay_add (self, (GtkWidget*) _tmp68_);
#line 1174 "../src/nibbles-window.vala"
	if (is_game_won) {
#line 5136 "nibbles-window.c"
		GtkLabel* _tmp69_;
#line 1175 "../src/nibbles-window.vala"
		_tmp69_ = msg_label;
#line 1175 "../src/nibbles-window.vala"
		nibbles_window_overlay_add (self, (GtkWidget*) _tmp69_);
#line 5142 "nibbles-window.c"
	}
#line 1176 "../src/nibbles-window.vala"
	_tmp70_ = self->priv->game;
#line 1176 "../src/nibbles-window.vala"
	_tmp71_ = nibbles_game_get_numhumans (_tmp70_);
#line 1176 "../src/nibbles-window.vala"
	_tmp72_ = _tmp71_;
#line 1176 "../src/nibbles-window.vala"
	if (_tmp72_ == 1) {
#line 5152 "nibbles-window.c"
		GtkLabel* _tmp73_;
#line 1177 "../src/nibbles-window.vala"
		_tmp73_ = score_label;
#line 1177 "../src/nibbles-window.vala"
		nibbles_window_overlay_add (self, (GtkWidget*) _tmp73_);
#line 5158 "nibbles-window.c"
	}
#line 1178 "../src/nibbles-window.vala"
	_tmp75_ = self->priv->game;
#line 1178 "../src/nibbles-window.vala"
	_tmp76_ = nibbles_game_get_numhumans (_tmp75_);
#line 1178 "../src/nibbles-window.vala"
	_tmp77_ = _tmp76_;
#line 1178 "../src/nibbles-window.vala"
	if (_tmp77_ == 1) {
#line 1178 "../src/nibbles-window.vala"
		_tmp74_ = !is_high_score;
#line 5170 "nibbles-window.c"
	} else {
#line 1178 "../src/nibbles-window.vala"
		_tmp74_ = FALSE;
#line 5174 "nibbles-window.c"
	}
#line 1178 "../src/nibbles-window.vala"
	if (_tmp74_) {
#line 5178 "nibbles-window.c"
		GtkLabel* _tmp78_;
#line 1179 "../src/nibbles-window.vala"
		_tmp78_ = points_left_label;
#line 1179 "../src/nibbles-window.vala"
		nibbles_window_overlay_add (self, (GtkWidget*) _tmp78_);
#line 5184 "nibbles-window.c"
	}
#line 1180 "../src/nibbles-window.vala"
	_tmp79_ = play_again_button;
#line 1180 "../src/nibbles-window.vala"
	nibbles_window_overlay_add (self, (GtkWidget*) _tmp79_);
#line 1182 "../src/nibbles-window.vala"
	_tmp80_ = play_again_button;
#line 1182 "../src/nibbles-window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp80_);
#line 1184 "../src/nibbles-window.vala"
	_tmp81_ = self->priv->view;
#line 1184 "../src/nibbles-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp81_);
#line 1185 "../src/nibbles-window.vala"
	self->priv->end_of_game = TRUE;
#line 1186 "../src/nibbles-window.vala"
	_tmp82_ = self->priv->new_game_action;
#line 1186 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp82_, TRUE);
#line 1187 "../src/nibbles-window.vala"
	_tmp83_ = self->priv->pause_action;
#line 1187 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp83_, FALSE);
#line 1188 "../src/nibbles-window.vala"
	_tmp84_ = self->priv->back_action;
#line 1188 "../src/nibbles-window.vala"
	g_simple_action_set_enabled (_tmp84_, FALSE);
#line 1115 "../src/nibbles-window.vala"
	_g_object_unref0 (play_again_button);
#line 1115 "../src/nibbles-window.vala"
	_g_object_unref0 (points_left_label);
#line 1115 "../src/nibbles-window.vala"
	_g_object_unref0 (score_label);
#line 1115 "../src/nibbles-window.vala"
	_g_free0 (score_string);
#line 1115 "../src/nibbles-window.vala"
	_g_object_unref0 (msg_label);
#line 1115 "../src/nibbles-window.vala"
	_g_object_unref0 (game_over_label);
#line 5224 "nibbles-window.c"
}

static gint
nibbles_window_countdown_active (NibblesWindow* self)
{
	gint result;
#line 1195 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1197 "../src/nibbles-window.vala"
	result = self->priv->seconds;
#line 1197 "../src/nibbles-window.vala"
	return result;
#line 5237 "nibbles-window.c"
}

static gint
nibbles_window_get_cli_start_level (NibblesWindow* self)
{
	gint result;
#line 176 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 176 "../src/nibbles-window.vala"
	result = self->priv->_cli_start_level;
#line 176 "../src/nibbles-window.vala"
	return result;
#line 5250 "nibbles-window.c"
}

static void
nibbles_window_set_cli_start_level (NibblesWindow* self,
                                    gint value)
{
	gint old_value;
#line 176 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/nibbles-window.vala"
	old_value = nibbles_window_get_cli_start_level (self);
#line 176 "../src/nibbles-window.vala"
	if (old_value != value) {
#line 176 "../src/nibbles-window.vala"
		self->priv->_cli_start_level = value;
#line 176 "../src/nibbles-window.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_window_properties[NIBBLES_WINDOW_CLI_START_LEVEL_PROPERTY]);
#line 5268 "nibbles-window.c"
	}
}

static gint
nibbles_window_get_start_level (NibblesWindow* self)
{
	gint result;
	gint _tmp0_ = 0;
	gint _tmp1_;
#line 177 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 177 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->_cli_start_level;
#line 177 "../src/nibbles-window.vala"
	if (_tmp1_ == 0) {
#line 5284 "nibbles-window.c"
		GSettings* _tmp2_;
#line 177 "../src/nibbles-window.vala"
		_tmp2_ = self->priv->settings;
#line 177 "../src/nibbles-window.vala"
		_tmp0_ = g_settings_get_int (_tmp2_, "start-level");
#line 5290 "nibbles-window.c"
	} else {
		gint _tmp3_;
#line 177 "../src/nibbles-window.vala"
		_tmp3_ = self->priv->_cli_start_level;
#line 177 "../src/nibbles-window.vala"
		_tmp0_ = _tmp3_;
#line 5297 "nibbles-window.c"
	}
#line 177 "../src/nibbles-window.vala"
	result = _tmp0_;
#line 177 "../src/nibbles-window.vala"
	return result;
#line 5303 "nibbles-window.c"
}

static SetupScreen
nibbles_window_get_start_screen (NibblesWindow* self)
{
	SetupScreen result;
#line 178 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 178 "../src/nibbles-window.vala"
	result = self->priv->_start_screen;
#line 178 "../src/nibbles-window.vala"
	return result;
#line 5316 "nibbles-window.c"
}

static void
nibbles_window_set_start_screen (NibblesWindow* self,
                                 SetupScreen value)
{
	SetupScreen old_value;
#line 178 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/nibbles-window.vala"
	old_value = nibbles_window_get_start_screen (self);
#line 178 "../src/nibbles-window.vala"
	if (old_value != value) {
#line 178 "../src/nibbles-window.vala"
		self->priv->_start_screen = value;
#line 178 "../src/nibbles-window.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_window_properties[NIBBLES_WINDOW_START_SCREEN_PROPERTY]);
#line 5334 "nibbles-window.c"
	}
}

gboolean
nibbles_window_get_game_paused (NibblesWindow* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	NibblesGame* _tmp1_;
#line 181 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 181 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->game;
#line 181 "../src/nibbles-window.vala"
	if (_tmp1_ != NULL) {
#line 5350 "nibbles-window.c"
		NibblesGame* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 181 "../src/nibbles-window.vala"
		_tmp2_ = self->priv->game;
#line 181 "../src/nibbles-window.vala"
		_tmp3_ = nibbles_game_get_paused (_tmp2_);
#line 181 "../src/nibbles-window.vala"
		_tmp4_ = _tmp3_;
#line 181 "../src/nibbles-window.vala"
		_tmp0_ = _tmp4_;
#line 5362 "nibbles-window.c"
	} else {
#line 181 "../src/nibbles-window.vala"
		_tmp0_ = FALSE;
#line 5366 "nibbles-window.c"
	}
#line 181 "../src/nibbles-window.vala"
	result = _tmp0_;
#line 181 "../src/nibbles-window.vala"
	return result;
#line 5372 "nibbles-window.c"
}

static void
nibbles_window_set_game_paused (NibblesWindow* self,
                                gboolean value)
{
#line 182 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/nibbles-window.vala"
	g_object_notify_by_pspec ((GObject *) self, nibbles_window_properties[NIBBLES_WINDOW_GAME_PAUSED_PROPERTY]);
#line 5383 "nibbles-window.c"
}

static inline gpointer
nibbles_window_delegate_stack_get_instance_private (NibblesWindowDelegateStack* self)
{
	return G_STRUCT_MEMBER_P (self, NibblesWindowDelegateStack_private_offset);
}

static gpointer
_nibbles_window_delegate_stack_node_dup0 (gpointer self)
{
#line 128 "../src/nibbles-window.vala"
	return self ? nibbles_window_delegate_stack_node_dup (self) : NULL;
#line 5397 "nibbles-window.c"
}

static void
nibbles_window_delegate_stack_push (NibblesWindowDelegateStack* self,
                                    KeypressHandlerFunction handler,
                                    gpointer handler_target)
{
	NibblesWindowDelegateStackNode* _tmp0_;
#line 125 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->pHead;
#line 127 "../src/nibbles-window.vala"
	if (_tmp0_ == NULL) {
#line 5412 "nibbles-window.c"
		NibblesWindowDelegateStackNode _tmp1_ = {0};
		NibblesWindowDelegateStackNode _tmp2_;
		NibblesWindowDelegateStackNode* _tmp3_;
#line 128 "../src/nibbles-window.vala"
		(_tmp1_.keypress_handler_target_destroy_notify == NULL) ? NULL : (_tmp1_.keypress_handler_target_destroy_notify (_tmp1_.keypress_handler_target), NULL);
#line 128 "../src/nibbles-window.vala"
		_tmp1_.keypress_handler = NULL;
#line 128 "../src/nibbles-window.vala"
		_tmp1_.keypress_handler_target = NULL;
#line 128 "../src/nibbles-window.vala"
		_tmp1_.keypress_handler_target_destroy_notify = NULL;
#line 128 "../src/nibbles-window.vala"
		_tmp1_.keypress_handler = (KeypressHandlerFunction) handler;
#line 128 "../src/nibbles-window.vala"
		_tmp1_.keypress_handler_target = handler_target;
#line 128 "../src/nibbles-window.vala"
		_tmp1_.keypress_handler_target_destroy_notify = NULL;
#line 128 "../src/nibbles-window.vala"
		_nibbles_window_delegate_stack_node_free0 (_tmp1_.pNext);
#line 128 "../src/nibbles-window.vala"
		_tmp1_.pNext = NULL;
#line 128 "../src/nibbles-window.vala"
		_tmp2_ = _tmp1_;
#line 128 "../src/nibbles-window.vala"
		_tmp3_ = _nibbles_window_delegate_stack_node_dup0 (&_tmp2_);
#line 128 "../src/nibbles-window.vala"
		_nibbles_window_delegate_stack_node_free0 (self->priv->pHead);
#line 128 "../src/nibbles-window.vala"
		self->priv->pHead = _tmp3_;
#line 128 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_node_destroy (&_tmp2_);
#line 5444 "nibbles-window.c"
	} else {
		NibblesWindowDelegateStackNode* _tmp4_;
		NibblesWindowDelegateStackNode* _tmp5_;
		NibblesWindowDelegateStackNode _tmp6_ = {0};
		NibblesWindowDelegateStackNode _tmp7_;
		NibblesWindowDelegateStackNode* _tmp8_;
#line 130 "../src/nibbles-window.vala"
		_tmp4_ = self->priv->pHead;
#line 130 "../src/nibbles-window.vala"
		_tmp5_ = _nibbles_window_delegate_stack_node_dup0 (_tmp4_);
#line 130 "../src/nibbles-window.vala"
		(_tmp6_.keypress_handler_target_destroy_notify == NULL) ? NULL : (_tmp6_.keypress_handler_target_destroy_notify (_tmp6_.keypress_handler_target), NULL);
#line 130 "../src/nibbles-window.vala"
		_tmp6_.keypress_handler = NULL;
#line 130 "../src/nibbles-window.vala"
		_tmp6_.keypress_handler_target = NULL;
#line 130 "../src/nibbles-window.vala"
		_tmp6_.keypress_handler_target_destroy_notify = NULL;
#line 130 "../src/nibbles-window.vala"
		_tmp6_.keypress_handler = (KeypressHandlerFunction) handler;
#line 130 "../src/nibbles-window.vala"
		_tmp6_.keypress_handler_target = handler_target;
#line 130 "../src/nibbles-window.vala"
		_tmp6_.keypress_handler_target_destroy_notify = NULL;
#line 130 "../src/nibbles-window.vala"
		_nibbles_window_delegate_stack_node_free0 (_tmp6_.pNext);
#line 130 "../src/nibbles-window.vala"
		_tmp6_.pNext = _tmp5_;
#line 130 "../src/nibbles-window.vala"
		_tmp7_ = _tmp6_;
#line 130 "../src/nibbles-window.vala"
		_tmp8_ = _nibbles_window_delegate_stack_node_dup0 (&_tmp7_);
#line 130 "../src/nibbles-window.vala"
		_nibbles_window_delegate_stack_node_free0 (self->priv->pHead);
#line 130 "../src/nibbles-window.vala"
		self->priv->pHead = _tmp8_;
#line 130 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_node_destroy (&_tmp7_);
#line 5483 "nibbles-window.c"
	}
}

static gboolean
nibbles_window_delegate_stack_pop (NibblesWindowDelegateStack* self)
{
	NibblesWindowDelegateStackNode* _tmp0_;
	gboolean result;
#line 133 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 135 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->pHead;
#line 135 "../src/nibbles-window.vala"
	if (_tmp0_ == NULL) {
#line 136 "../src/nibbles-window.vala"
		result = FALSE;
#line 136 "../src/nibbles-window.vala"
		return result;
#line 5502 "nibbles-window.c"
	} else {
		NibblesWindowDelegateStackNode* _tmp1_;
		NibblesWindowDelegateStackNode* _tmp2_;
		NibblesWindowDelegateStackNode* _tmp3_;
#line 139 "../src/nibbles-window.vala"
		_tmp1_ = self->priv->pHead;
#line 139 "../src/nibbles-window.vala"
		_tmp2_ = (*_tmp1_).pNext;
#line 139 "../src/nibbles-window.vala"
		_tmp3_ = _nibbles_window_delegate_stack_node_dup0 (_tmp2_);
#line 139 "../src/nibbles-window.vala"
		_nibbles_window_delegate_stack_node_free0 (self->priv->pHead);
#line 139 "../src/nibbles-window.vala"
		self->priv->pHead = _tmp3_;
#line 140 "../src/nibbles-window.vala"
		result = TRUE;
#line 140 "../src/nibbles-window.vala"
		return result;
#line 5521 "nibbles-window.c"
	}
}

static void
nibbles_window_delegate_stack_remove (NibblesWindowDelegateStack* self,
                                      KeypressHandlerFunction handler,
                                      gpointer handler_target)
{
	gboolean _tmp0_ = FALSE;
	NibblesWindowDelegateStackNode* _tmp1_;
#line 144 "../src/nibbles-window.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/nibbles-window.vala"
	_tmp1_ = self->priv->pHead;
#line 146 "../src/nibbles-window.vala"
	if (_tmp1_ != NULL) {
#line 5538 "nibbles-window.c"
		NibblesWindowDelegateStackNode* _tmp2_;
		KeypressHandlerFunction _tmp3_;
		gpointer _tmp3__target;
#line 146 "../src/nibbles-window.vala"
		_tmp2_ = self->priv->pHead;
#line 146 "../src/nibbles-window.vala"
		_tmp3_ = (*_tmp2_).keypress_handler;
#line 146 "../src/nibbles-window.vala"
		_tmp3__target = (*_tmp2_).keypress_handler_target;
#line 146 "../src/nibbles-window.vala"
		_tmp0_ = _tmp3_ == handler;
#line 5550 "nibbles-window.c"
	} else {
#line 146 "../src/nibbles-window.vala"
		_tmp0_ = FALSE;
#line 5554 "nibbles-window.c"
	}
#line 146 "../src/nibbles-window.vala"
	if (_tmp0_) {
#line 5558 "nibbles-window.c"
		NibblesWindowDelegateStackNode* _tmp4_;
		NibblesWindowDelegateStackNode* _tmp5_;
		NibblesWindowDelegateStackNode* _tmp6_;
#line 147 "../src/nibbles-window.vala"
		_tmp4_ = self->priv->pHead;
#line 147 "../src/nibbles-window.vala"
		_tmp5_ = (*_tmp4_).pNext;
#line 147 "../src/nibbles-window.vala"
		_tmp6_ = _nibbles_window_delegate_stack_node_dup0 (_tmp5_);
#line 147 "../src/nibbles-window.vala"
		_nibbles_window_delegate_stack_node_free0 (self->priv->pHead);
#line 147 "../src/nibbles-window.vala"
		self->priv->pHead = _tmp6_;
#line 5572 "nibbles-window.c"
	} else {
		gboolean _tmp7_ = FALSE;
		NibblesWindowDelegateStackNode* _tmp8_;
#line 148 "../src/nibbles-window.vala"
		_tmp8_ = self->priv->pHead;
#line 148 "../src/nibbles-window.vala"
		if (_tmp8_ != NULL) {
#line 5580 "nibbles-window.c"
			NibblesWindowDelegateStackNode* _tmp9_;
			NibblesWindowDelegateStackNode* _tmp10_;
#line 148 "../src/nibbles-window.vala"
			_tmp9_ = self->priv->pHead;
#line 148 "../src/nibbles-window.vala"
			_tmp10_ = (*_tmp9_).pNext;
#line 148 "../src/nibbles-window.vala"
			_tmp7_ = _tmp10_ != NULL;
#line 5589 "nibbles-window.c"
		} else {
#line 148 "../src/nibbles-window.vala"
			_tmp7_ = FALSE;
#line 5593 "nibbles-window.c"
		}
#line 148 "../src/nibbles-window.vala"
		if (_tmp7_) {
#line 5597 "nibbles-window.c"
			NibblesWindowDelegateStackNode* pTrail = NULL;
			NibblesWindowDelegateStackNode* _tmp11_;
			NibblesWindowDelegateStackNode* _tmp12_;
#line 150 "../src/nibbles-window.vala"
			_tmp11_ = self->priv->pHead;
#line 150 "../src/nibbles-window.vala"
			_tmp12_ = _nibbles_window_delegate_stack_node_dup0 (_tmp11_);
#line 150 "../src/nibbles-window.vala"
			pTrail = _tmp12_;
#line 5607 "nibbles-window.c"
			{
				NibblesWindowDelegateStackNode* p = NULL;
				NibblesWindowDelegateStackNode* _tmp13_;
				NibblesWindowDelegateStackNode* _tmp14_;
				NibblesWindowDelegateStackNode* _tmp15_;
#line 151 "../src/nibbles-window.vala"
				_tmp13_ = pTrail;
#line 151 "../src/nibbles-window.vala"
				_tmp14_ = (*_tmp13_).pNext;
#line 151 "../src/nibbles-window.vala"
				_tmp15_ = _nibbles_window_delegate_stack_node_dup0 (_tmp14_);
#line 151 "../src/nibbles-window.vala"
				p = _tmp15_;
#line 5621 "nibbles-window.c"
				{
					gboolean _tmp16_ = FALSE;
#line 151 "../src/nibbles-window.vala"
					_tmp16_ = TRUE;
#line 151 "../src/nibbles-window.vala"
					while (TRUE) {
#line 5628 "nibbles-window.c"
						NibblesWindowDelegateStackNode* _tmp17_;
						NibblesWindowDelegateStackNode* _tmp18_;
						KeypressHandlerFunction _tmp19_;
						gpointer _tmp19__target;
#line 151 "../src/nibbles-window.vala"
						if (!_tmp16_) {
#line 5635 "nibbles-window.c"
						}
#line 151 "../src/nibbles-window.vala"
						_tmp16_ = FALSE;
#line 151 "../src/nibbles-window.vala"
						_tmp17_ = p;
#line 151 "../src/nibbles-window.vala"
						if (!(_tmp17_ != NULL)) {
#line 151 "../src/nibbles-window.vala"
							break;
#line 5645 "nibbles-window.c"
						}
#line 153 "../src/nibbles-window.vala"
						_tmp18_ = p;
#line 153 "../src/nibbles-window.vala"
						_tmp19_ = (*_tmp18_).keypress_handler;
#line 153 "../src/nibbles-window.vala"
						_tmp19__target = (*_tmp18_).keypress_handler_target;
#line 153 "../src/nibbles-window.vala"
						if (_tmp19_ == handler) {
#line 5655 "nibbles-window.c"
							NibblesWindowDelegateStackNode* _tmp20_;
							NibblesWindowDelegateStackNode* _tmp21_;
							NibblesWindowDelegateStackNode* _tmp22_;
							NibblesWindowDelegateStackNode* _tmp23_;
#line 155 "../src/nibbles-window.vala"
							_tmp20_ = pTrail;
#line 155 "../src/nibbles-window.vala"
							_tmp21_ = p;
#line 155 "../src/nibbles-window.vala"
							_tmp22_ = (*_tmp21_).pNext;
#line 155 "../src/nibbles-window.vala"
							_tmp23_ = _nibbles_window_delegate_stack_node_dup0 (_tmp22_);
#line 155 "../src/nibbles-window.vala"
							_nibbles_window_delegate_stack_node_free0 ((*_tmp20_).pNext);
#line 155 "../src/nibbles-window.vala"
							(*_tmp20_).pNext = _tmp23_;
#line 156 "../src/nibbles-window.vala"
							break;
#line 5674 "nibbles-window.c"
						} else {
							NibblesWindowDelegateStackNode* _tmp24_;
							NibblesWindowDelegateStackNode* _tmp25_;
							NibblesWindowDelegateStackNode* _tmp26_;
							NibblesWindowDelegateStackNode* _tmp27_;
							NibblesWindowDelegateStackNode* _tmp28_;
#line 160 "../src/nibbles-window.vala"
							_tmp24_ = p;
#line 160 "../src/nibbles-window.vala"
							_tmp25_ = _nibbles_window_delegate_stack_node_dup0 (_tmp24_);
#line 160 "../src/nibbles-window.vala"
							_nibbles_window_delegate_stack_node_free0 (pTrail);
#line 160 "../src/nibbles-window.vala"
							pTrail = _tmp25_;
#line 161 "../src/nibbles-window.vala"
							_tmp26_ = p;
#line 161 "../src/nibbles-window.vala"
							_tmp27_ = (*_tmp26_).pNext;
#line 161 "../src/nibbles-window.vala"
							_tmp28_ = _nibbles_window_delegate_stack_node_dup0 (_tmp27_);
#line 161 "../src/nibbles-window.vala"
							_nibbles_window_delegate_stack_node_free0 (p);
#line 161 "../src/nibbles-window.vala"
							p = _tmp28_;
#line 5699 "nibbles-window.c"
						}
					}
				}
#line 151 "../src/nibbles-window.vala"
				_nibbles_window_delegate_stack_node_free0 (p);
#line 5705 "nibbles-window.c"
			}
#line 148 "../src/nibbles-window.vala"
			_nibbles_window_delegate_stack_node_free0 (pTrail);
#line 5709 "nibbles-window.c"
		}
	}
}

static NibblesWindowDelegateStackDelegateStackIterator*
nibbles_window_delegate_stack_iterator (NibblesWindowDelegateStack* self)
{
	NibblesWindowDelegateStackDelegateStackIterator* _tmp0_;
	NibblesWindowDelegateStackDelegateStackIterator* result;
#line 167 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "../src/nibbles-window.vala"
	_tmp0_ = nibbles_window_delegate_stack_delegate_stack_iterator_new (self);
#line 169 "../src/nibbles-window.vala"
	result = _tmp0_;
#line 169 "../src/nibbles-window.vala"
	return result;
#line 5727 "nibbles-window.c"
}

static NibblesWindowDelegateStack*
nibbles_window_delegate_stack_construct (GType object_type)
{
	NibblesWindowDelegateStack* self = NULL;
#line 81 "../src/nibbles-window.vala"
	self = (NibblesWindowDelegateStack*) g_type_create_instance (object_type);
#line 81 "../src/nibbles-window.vala"
	return self;
#line 5738 "nibbles-window.c"
}

static NibblesWindowDelegateStack*
nibbles_window_delegate_stack_new (void)
{
#line 81 "../src/nibbles-window.vala"
	return nibbles_window_delegate_stack_construct (NIBBLES_WINDOW_TYPE_DELEGATE_STACK);
#line 5746 "nibbles-window.c"
}

static inline gpointer
nibbles_window_delegate_stack_delegate_stack_iterator_get_instance_private (NibblesWindowDelegateStackDelegateStackIterator* self)
{
	return G_STRUCT_MEMBER_P (self, NibblesWindowDelegateStackDelegateStackIterator_private_offset);
}

static NibblesWindowDelegateStackDelegateStackIterator*
nibbles_window_delegate_stack_delegate_stack_iterator_construct (GType object_type,
                                                                 NibblesWindowDelegateStack* p)
{
	NibblesWindowDelegateStackDelegateStackIterator* self = NULL;
	NibblesWindowDelegateStackNode* _tmp0_;
	NibblesWindowDelegateStackNode* _tmp1_;
#line 90 "../src/nibbles-window.vala"
	g_return_val_if_fail (p != NULL, NULL);
#line 90 "../src/nibbles-window.vala"
	self = (NibblesWindowDelegateStackDelegateStackIterator*) g_type_create_instance (object_type);
#line 92 "../src/nibbles-window.vala"
	_tmp0_ = p->priv->pHead;
#line 92 "../src/nibbles-window.vala"
	_tmp1_ = _nibbles_window_delegate_stack_node_dup0 (_tmp0_);
#line 92 "../src/nibbles-window.vala"
	_nibbles_window_delegate_stack_node_free0 (self->priv->pIterator);
#line 92 "../src/nibbles-window.vala"
	self->priv->pIterator = _tmp1_;
#line 93 "../src/nibbles-window.vala"
	self->priv->first_next = TRUE;
#line 90 "../src/nibbles-window.vala"
	return self;
#line 5778 "nibbles-window.c"
}

static NibblesWindowDelegateStackDelegateStackIterator*
nibbles_window_delegate_stack_delegate_stack_iterator_new (NibblesWindowDelegateStack* p)
{
#line 90 "../src/nibbles-window.vala"
	return nibbles_window_delegate_stack_delegate_stack_iterator_construct (NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR, p);
#line 5786 "nibbles-window.c"
}

static gboolean
nibbles_window_delegate_stack_delegate_stack_iterator_next (NibblesWindowDelegateStackDelegateStackIterator* self)
{
	NibblesWindowDelegateStackNode* _tmp0_;
	gboolean result;
#line 96 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 98 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->pIterator;
#line 98 "../src/nibbles-window.vala"
	if (_tmp0_ == NULL) {
#line 99 "../src/nibbles-window.vala"
		result = FALSE;
#line 99 "../src/nibbles-window.vala"
		return result;
#line 5804 "nibbles-window.c"
	} else {
#line 100 "../src/nibbles-window.vala"
		if (self->priv->first_next) {
#line 102 "../src/nibbles-window.vala"
			self->priv->first_next = !self->priv->first_next;
#line 103 "../src/nibbles-window.vala"
			result = TRUE;
#line 103 "../src/nibbles-window.vala"
			return result;
#line 5814 "nibbles-window.c"
		} else {
			NibblesWindowDelegateStackNode* _tmp1_;
			NibblesWindowDelegateStackNode* _tmp2_;
			NibblesWindowDelegateStackNode* _tmp3_;
			NibblesWindowDelegateStackNode* _tmp4_;
#line 107 "../src/nibbles-window.vala"
			_tmp1_ = self->priv->pIterator;
#line 107 "../src/nibbles-window.vala"
			_tmp2_ = (*_tmp1_).pNext;
#line 107 "../src/nibbles-window.vala"
			_tmp3_ = _nibbles_window_delegate_stack_node_dup0 (_tmp2_);
#line 107 "../src/nibbles-window.vala"
			_nibbles_window_delegate_stack_node_free0 (self->priv->pIterator);
#line 107 "../src/nibbles-window.vala"
			self->priv->pIterator = _tmp3_;
#line 108 "../src/nibbles-window.vala"
			_tmp4_ = self->priv->pIterator;
#line 108 "../src/nibbles-window.vala"
			result = _tmp4_ != NULL;
#line 108 "../src/nibbles-window.vala"
			return result;
#line 5836 "nibbles-window.c"
		}
	}
}

static KeypressHandlerFunction
nibbles_window_delegate_stack_delegate_stack_iterator_get (NibblesWindowDelegateStackDelegateStackIterator* self,
                                                           gpointer* result_target,
                                                           GDestroyNotify* result_target_destroy_notify)
{
	NibblesWindowDelegateStackNode* _tmp0_;
	KeypressHandlerFunction _tmp1_;
	gpointer _tmp1__target;
	KeypressHandlerFunction _tmp2_;
	gpointer _tmp2__target;
	GDestroyNotify _tmp2__target_destroy_notify;
	KeypressHandlerFunction result;
#line 112 "../src/nibbles-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 114 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->pIterator;
#line 114 "../src/nibbles-window.vala"
	_tmp1_ = (*_tmp0_).keypress_handler;
#line 114 "../src/nibbles-window.vala"
	_tmp1__target = (*_tmp0_).keypress_handler_target;
#line 114 "../src/nibbles-window.vala"
	_tmp2_ = (KeypressHandlerFunction) _tmp1_;
#line 114 "../src/nibbles-window.vala"
	_tmp2__target = _tmp1__target;
#line 114 "../src/nibbles-window.vala"
	_tmp2__target_destroy_notify = NULL;
#line 114 "../src/nibbles-window.vala"
	*result_target = _tmp2__target;
#line 114 "../src/nibbles-window.vala"
	*result_target_destroy_notify = _tmp2__target_destroy_notify;
#line 114 "../src/nibbles-window.vala"
	result = _tmp2_;
#line 114 "../src/nibbles-window.vala"
	return result;
#line 5875 "nibbles-window.c"
}

static void
nibbles_window_delegate_stack_value_delegate_stack_iterator_init (GValue* value)
{
#line 83 "../src/nibbles-window.vala"
	value->data[0].v_pointer = NULL;
#line 5883 "nibbles-window.c"
}

static void
nibbles_window_delegate_stack_value_delegate_stack_iterator_free_value (GValue* value)
{
#line 83 "../src/nibbles-window.vala"
	if (value->data[0].v_pointer) {
#line 83 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_delegate_stack_iterator_unref (value->data[0].v_pointer);
#line 5893 "nibbles-window.c"
	}
}

static void
nibbles_window_delegate_stack_value_delegate_stack_iterator_copy_value (const GValue* src_value,
                                                                        GValue* dest_value)
{
#line 83 "../src/nibbles-window.vala"
	if (src_value->data[0].v_pointer) {
#line 83 "../src/nibbles-window.vala"
		dest_value->data[0].v_pointer = nibbles_window_delegate_stack_delegate_stack_iterator_ref (src_value->data[0].v_pointer);
#line 5905 "nibbles-window.c"
	} else {
#line 83 "../src/nibbles-window.vala"
		dest_value->data[0].v_pointer = NULL;
#line 5909 "nibbles-window.c"
	}
}

static gpointer
nibbles_window_delegate_stack_value_delegate_stack_iterator_peek_pointer (const GValue* value)
{
#line 83 "../src/nibbles-window.vala"
	return value->data[0].v_pointer;
#line 5918 "nibbles-window.c"
}

static gchar*
nibbles_window_delegate_stack_value_delegate_stack_iterator_collect_value (GValue* value,
                                                                           guint n_collect_values,
                                                                           GTypeCValue* collect_values,
                                                                           guint collect_flags)
{
#line 83 "../src/nibbles-window.vala"
	if (collect_values[0].v_pointer) {
#line 5929 "nibbles-window.c"
		NibblesWindowDelegateStackDelegateStackIterator * object;
		object = collect_values[0].v_pointer;
#line 83 "../src/nibbles-window.vala"
		if (object->parent_instance.g_class == NULL) {
#line 83 "../src/nibbles-window.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5936 "nibbles-window.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 83 "../src/nibbles-window.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5940 "nibbles-window.c"
		}
#line 83 "../src/nibbles-window.vala"
		value->data[0].v_pointer = nibbles_window_delegate_stack_delegate_stack_iterator_ref (object);
#line 5944 "nibbles-window.c"
	} else {
#line 83 "../src/nibbles-window.vala"
		value->data[0].v_pointer = NULL;
#line 5948 "nibbles-window.c"
	}
#line 83 "../src/nibbles-window.vala"
	return NULL;
#line 5952 "nibbles-window.c"
}

static gchar*
nibbles_window_delegate_stack_value_delegate_stack_iterator_lcopy_value (const GValue* value,
                                                                         guint n_collect_values,
                                                                         GTypeCValue* collect_values,
                                                                         guint collect_flags)
{
	NibblesWindowDelegateStackDelegateStackIterator ** object_p;
	object_p = collect_values[0].v_pointer;
#line 83 "../src/nibbles-window.vala"
	if (!object_p) {
#line 83 "../src/nibbles-window.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 5967 "nibbles-window.c"
	}
#line 83 "../src/nibbles-window.vala"
	if (!value->data[0].v_pointer) {
#line 83 "../src/nibbles-window.vala"
		*object_p = NULL;
#line 5973 "nibbles-window.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 83 "../src/nibbles-window.vala"
		*object_p = value->data[0].v_pointer;
#line 5977 "nibbles-window.c"
	} else {
#line 83 "../src/nibbles-window.vala"
		*object_p = nibbles_window_delegate_stack_delegate_stack_iterator_ref (value->data[0].v_pointer);
#line 5981 "nibbles-window.c"
	}
#line 83 "../src/nibbles-window.vala"
	return NULL;
#line 5985 "nibbles-window.c"
}

static GParamSpec*
nibbles_window_delegate_stack_param_spec_delegate_stack_iterator (const gchar* name,
                                                                  const gchar* nick,
                                                                  const gchar* blurb,
                                                                  GType object_type,
                                                                  GParamFlags flags)
{
	NibblesWindowDelegateStackParamSpecDelegateStackIterator* spec;
#line 83 "../src/nibbles-window.vala"
	g_return_val_if_fail (g_type_is_a (object_type, NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR), NULL);
#line 83 "../src/nibbles-window.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 83 "../src/nibbles-window.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 83 "../src/nibbles-window.vala"
	return G_PARAM_SPEC (spec);
#line 6004 "nibbles-window.c"
}

static gpointer
nibbles_window_delegate_stack_value_get_delegate_stack_iterator (const GValue* value)
{
#line 83 "../src/nibbles-window.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR), NULL);
#line 83 "../src/nibbles-window.vala"
	return value->data[0].v_pointer;
#line 6014 "nibbles-window.c"
}

static void
nibbles_window_delegate_stack_value_set_delegate_stack_iterator (GValue* value,
                                                                 gpointer v_object)
{
	NibblesWindowDelegateStackDelegateStackIterator * old;
#line 83 "../src/nibbles-window.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR));
#line 83 "../src/nibbles-window.vala"
	old = value->data[0].v_pointer;
#line 83 "../src/nibbles-window.vala"
	if (v_object) {
#line 83 "../src/nibbles-window.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR));
#line 83 "../src/nibbles-window.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 83 "../src/nibbles-window.vala"
		value->data[0].v_pointer = v_object;
#line 83 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_delegate_stack_iterator_ref (value->data[0].v_pointer);
#line 6036 "nibbles-window.c"
	} else {
#line 83 "../src/nibbles-window.vala"
		value->data[0].v_pointer = NULL;
#line 6040 "nibbles-window.c"
	}
#line 83 "../src/nibbles-window.vala"
	if (old) {
#line 83 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_delegate_stack_iterator_unref (old);
#line 6046 "nibbles-window.c"
	}
}

static void
nibbles_window_delegate_stack_value_take_delegate_stack_iterator (GValue* value,
                                                                  gpointer v_object)
{
	NibblesWindowDelegateStackDelegateStackIterator * old;
#line 83 "../src/nibbles-window.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR));
#line 83 "../src/nibbles-window.vala"
	old = value->data[0].v_pointer;
#line 83 "../src/nibbles-window.vala"
	if (v_object) {
#line 83 "../src/nibbles-window.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR));
#line 83 "../src/nibbles-window.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 83 "../src/nibbles-window.vala"
		value->data[0].v_pointer = v_object;
#line 6067 "nibbles-window.c"
	} else {
#line 83 "../src/nibbles-window.vala"
		value->data[0].v_pointer = NULL;
#line 6071 "nibbles-window.c"
	}
#line 83 "../src/nibbles-window.vala"
	if (old) {
#line 83 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_delegate_stack_iterator_unref (old);
#line 6077 "nibbles-window.c"
	}
}

static void
nibbles_window_delegate_stack_delegate_stack_iterator_class_init (NibblesWindowDelegateStackDelegateStackIteratorClass * klass,
                                                                  gpointer klass_data)
{
#line 83 "../src/nibbles-window.vala"
	nibbles_window_delegate_stack_delegate_stack_iterator_parent_class = g_type_class_peek_parent (klass);
#line 83 "../src/nibbles-window.vala"
	((NibblesWindowDelegateStackDelegateStackIteratorClass *) klass)->finalize = nibbles_window_delegate_stack_delegate_stack_iterator_finalize;
#line 83 "../src/nibbles-window.vala"
	g_type_class_adjust_private_offset (klass, &NibblesWindowDelegateStackDelegateStackIterator_private_offset);
#line 6091 "nibbles-window.c"
}

static void
nibbles_window_delegate_stack_delegate_stack_iterator_instance_init (NibblesWindowDelegateStackDelegateStackIterator * self,
                                                                     gpointer klass)
{
#line 83 "../src/nibbles-window.vala"
	self->priv = nibbles_window_delegate_stack_delegate_stack_iterator_get_instance_private (self);
#line 83 "../src/nibbles-window.vala"
	self->ref_count = 1;
#line 6102 "nibbles-window.c"
}

static void
nibbles_window_delegate_stack_delegate_stack_iterator_finalize (NibblesWindowDelegateStackDelegateStackIterator * obj)
{
	NibblesWindowDelegateStackDelegateStackIterator * self;
#line 83 "../src/nibbles-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NIBBLES_WINDOW_DELEGATE_STACK_TYPE_DELEGATE_STACK_ITERATOR, NibblesWindowDelegateStackDelegateStackIterator);
#line 83 "../src/nibbles-window.vala"
	g_signal_handlers_destroy (self);
#line 86 "../src/nibbles-window.vala"
	_nibbles_window_delegate_stack_node_free0 (self->priv->pIterator);
#line 6115 "nibbles-window.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_window_delegate_stack_delegate_stack_iterator_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { nibbles_window_delegate_stack_value_delegate_stack_iterator_init, nibbles_window_delegate_stack_value_delegate_stack_iterator_free_value, nibbles_window_delegate_stack_value_delegate_stack_iterator_copy_value, nibbles_window_delegate_stack_value_delegate_stack_iterator_peek_pointer, "p", nibbles_window_delegate_stack_value_delegate_stack_iterator_collect_value, "p", nibbles_window_delegate_stack_value_delegate_stack_iterator_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (NibblesWindowDelegateStackDelegateStackIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_window_delegate_stack_delegate_stack_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NibblesWindowDelegateStackDelegateStackIterator), 0, (GInstanceInitFunc) nibbles_window_delegate_stack_delegate_stack_iterator_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType nibbles_window_delegate_stack_delegate_stack_iterator_type_id;
	nibbles_window_delegate_stack_delegate_stack_iterator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NibblesWindowDelegateStackDelegateStackIterator", &g_define_type_info, &g_define_type_fundamental_info, 0);
	NibblesWindowDelegateStackDelegateStackIterator_private_offset = g_type_add_instance_private (nibbles_window_delegate_stack_delegate_stack_iterator_type_id, sizeof (NibblesWindowDelegateStackDelegateStackIteratorPrivate));
	return nibbles_window_delegate_stack_delegate_stack_iterator_type_id;
}

GType
nibbles_window_delegate_stack_delegate_stack_iterator_get_type (void)
{
	static gsize nibbles_window_delegate_stack_delegate_stack_iterator_type_id__once = 0;
	if (g_once_init_enter (&nibbles_window_delegate_stack_delegate_stack_iterator_type_id__once)) {
		GType nibbles_window_delegate_stack_delegate_stack_iterator_type_id;
		nibbles_window_delegate_stack_delegate_stack_iterator_type_id = nibbles_window_delegate_stack_delegate_stack_iterator_get_type_once ();
		g_once_init_leave (&nibbles_window_delegate_stack_delegate_stack_iterator_type_id__once, nibbles_window_delegate_stack_delegate_stack_iterator_type_id);
	}
	return nibbles_window_delegate_stack_delegate_stack_iterator_type_id__once;
}

static gpointer
nibbles_window_delegate_stack_delegate_stack_iterator_ref (gpointer instance)
{
	NibblesWindowDelegateStackDelegateStackIterator * self;
	self = instance;
#line 83 "../src/nibbles-window.vala"
	g_atomic_int_inc (&self->ref_count);
#line 83 "../src/nibbles-window.vala"
	return instance;
#line 6151 "nibbles-window.c"
}

static void
nibbles_window_delegate_stack_delegate_stack_iterator_unref (gpointer instance)
{
	NibblesWindowDelegateStackDelegateStackIterator * self;
	self = instance;
#line 83 "../src/nibbles-window.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 83 "../src/nibbles-window.vala"
		NIBBLES_WINDOW_DELEGATE_STACK_DELEGATE_STACK_ITERATOR_GET_CLASS (self)->finalize (self);
#line 83 "../src/nibbles-window.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 6165 "nibbles-window.c"
	}
}

static void
nibbles_window_delegate_stack_node_copy (const NibblesWindowDelegateStackNode* self,
                                         NibblesWindowDelegateStackNode* dest)
{
	KeypressHandlerFunction _tmp0_;
	gpointer _tmp0__target;
	NibblesWindowDelegateStackNode* _tmp1_;
	NibblesWindowDelegateStackNode* _tmp2_;
#line 118 "../src/nibbles-window.vala"
	_tmp0_ = (*self).keypress_handler;
#line 118 "../src/nibbles-window.vala"
	_tmp0__target = (*self).keypress_handler_target;
#line 118 "../src/nibbles-window.vala"
	((*dest).keypress_handler_target_destroy_notify == NULL) ? NULL : ((*dest).keypress_handler_target_destroy_notify ((*dest).keypress_handler_target), NULL);
#line 118 "../src/nibbles-window.vala"
	(*dest).keypress_handler = NULL;
#line 118 "../src/nibbles-window.vala"
	(*dest).keypress_handler_target = NULL;
#line 118 "../src/nibbles-window.vala"
	(*dest).keypress_handler_target_destroy_notify = NULL;
#line 118 "../src/nibbles-window.vala"
	(*dest).keypress_handler = _tmp0_;
#line 118 "../src/nibbles-window.vala"
	(*dest).keypress_handler_target = _tmp0__target;
#line 118 "../src/nibbles-window.vala"
	(*dest).keypress_handler_target_destroy_notify = NULL;
#line 118 "../src/nibbles-window.vala"
	_tmp1_ = (*self).pNext;
#line 118 "../src/nibbles-window.vala"
	_tmp2_ = _nibbles_window_delegate_stack_node_dup0 (_tmp1_);
#line 118 "../src/nibbles-window.vala"
	_nibbles_window_delegate_stack_node_free0 ((*dest).pNext);
#line 118 "../src/nibbles-window.vala"
	(*dest).pNext = _tmp2_;
#line 6203 "nibbles-window.c"
}

static void
nibbles_window_delegate_stack_node_destroy (NibblesWindowDelegateStackNode* self)
{
#line 120 "../src/nibbles-window.vala"
	((*self).keypress_handler_target_destroy_notify == NULL) ? NULL : ((*self).keypress_handler_target_destroy_notify ((*self).keypress_handler_target), NULL);
#line 120 "../src/nibbles-window.vala"
	(*self).keypress_handler = NULL;
#line 120 "../src/nibbles-window.vala"
	(*self).keypress_handler_target = NULL;
#line 120 "../src/nibbles-window.vala"
	(*self).keypress_handler_target_destroy_notify = NULL;
#line 121 "../src/nibbles-window.vala"
	_nibbles_window_delegate_stack_node_free0 ((*self).pNext);
#line 6219 "nibbles-window.c"
}

static NibblesWindowDelegateStackNode*
nibbles_window_delegate_stack_node_dup (const NibblesWindowDelegateStackNode* self)
{
	NibblesWindowDelegateStackNode* dup;
#line 118 "../src/nibbles-window.vala"
	dup = g_new0 (NibblesWindowDelegateStackNode, 1);
#line 118 "../src/nibbles-window.vala"
	nibbles_window_delegate_stack_node_copy (self, dup);
#line 118 "../src/nibbles-window.vala"
	return dup;
#line 6232 "nibbles-window.c"
}

static void
nibbles_window_delegate_stack_node_free (NibblesWindowDelegateStackNode* self)
{
#line 118 "../src/nibbles-window.vala"
	nibbles_window_delegate_stack_node_destroy (self);
#line 118 "../src/nibbles-window.vala"
	g_free (self);
#line 6242 "nibbles-window.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_window_delegate_stack_node_get_type_once (void)
{
	GType nibbles_window_delegate_stack_node_type_id;
	nibbles_window_delegate_stack_node_type_id = g_boxed_type_register_static ("NibblesWindowDelegateStackNode", (GBoxedCopyFunc) nibbles_window_delegate_stack_node_dup, (GBoxedFreeFunc) nibbles_window_delegate_stack_node_free);
	return nibbles_window_delegate_stack_node_type_id;
}

static GType
nibbles_window_delegate_stack_node_get_type (void)
{
	static gsize nibbles_window_delegate_stack_node_type_id__once = 0;
	if (g_once_init_enter (&nibbles_window_delegate_stack_node_type_id__once)) {
		GType nibbles_window_delegate_stack_node_type_id;
		nibbles_window_delegate_stack_node_type_id = nibbles_window_delegate_stack_node_get_type_once ();
		g_once_init_leave (&nibbles_window_delegate_stack_node_type_id__once, nibbles_window_delegate_stack_node_type_id);
	}
	return nibbles_window_delegate_stack_node_type_id__once;
}

static void
nibbles_window_value_delegate_stack_init (GValue* value)
{
#line 81 "../src/nibbles-window.vala"
	value->data[0].v_pointer = NULL;
#line 6270 "nibbles-window.c"
}

static void
nibbles_window_value_delegate_stack_free_value (GValue* value)
{
#line 81 "../src/nibbles-window.vala"
	if (value->data[0].v_pointer) {
#line 81 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_unref (value->data[0].v_pointer);
#line 6280 "nibbles-window.c"
	}
}

static void
nibbles_window_value_delegate_stack_copy_value (const GValue* src_value,
                                                GValue* dest_value)
{
#line 81 "../src/nibbles-window.vala"
	if (src_value->data[0].v_pointer) {
#line 81 "../src/nibbles-window.vala"
		dest_value->data[0].v_pointer = nibbles_window_delegate_stack_ref (src_value->data[0].v_pointer);
#line 6292 "nibbles-window.c"
	} else {
#line 81 "../src/nibbles-window.vala"
		dest_value->data[0].v_pointer = NULL;
#line 6296 "nibbles-window.c"
	}
}

static gpointer
nibbles_window_value_delegate_stack_peek_pointer (const GValue* value)
{
#line 81 "../src/nibbles-window.vala"
	return value->data[0].v_pointer;
#line 6305 "nibbles-window.c"
}

static gchar*
nibbles_window_value_delegate_stack_collect_value (GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
#line 81 "../src/nibbles-window.vala"
	if (collect_values[0].v_pointer) {
#line 6316 "nibbles-window.c"
		NibblesWindowDelegateStack * object;
		object = collect_values[0].v_pointer;
#line 81 "../src/nibbles-window.vala"
		if (object->parent_instance.g_class == NULL) {
#line 81 "../src/nibbles-window.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6323 "nibbles-window.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 81 "../src/nibbles-window.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6327 "nibbles-window.c"
		}
#line 81 "../src/nibbles-window.vala"
		value->data[0].v_pointer = nibbles_window_delegate_stack_ref (object);
#line 6331 "nibbles-window.c"
	} else {
#line 81 "../src/nibbles-window.vala"
		value->data[0].v_pointer = NULL;
#line 6335 "nibbles-window.c"
	}
#line 81 "../src/nibbles-window.vala"
	return NULL;
#line 6339 "nibbles-window.c"
}

static gchar*
nibbles_window_value_delegate_stack_lcopy_value (const GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	NibblesWindowDelegateStack ** object_p;
	object_p = collect_values[0].v_pointer;
#line 81 "../src/nibbles-window.vala"
	if (!object_p) {
#line 81 "../src/nibbles-window.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 6354 "nibbles-window.c"
	}
#line 81 "../src/nibbles-window.vala"
	if (!value->data[0].v_pointer) {
#line 81 "../src/nibbles-window.vala"
		*object_p = NULL;
#line 6360 "nibbles-window.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 81 "../src/nibbles-window.vala"
		*object_p = value->data[0].v_pointer;
#line 6364 "nibbles-window.c"
	} else {
#line 81 "../src/nibbles-window.vala"
		*object_p = nibbles_window_delegate_stack_ref (value->data[0].v_pointer);
#line 6368 "nibbles-window.c"
	}
#line 81 "../src/nibbles-window.vala"
	return NULL;
#line 6372 "nibbles-window.c"
}

static GParamSpec*
nibbles_window_param_spec_delegate_stack (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags)
{
	NibblesWindowParamSpecDelegateStack* spec;
#line 81 "../src/nibbles-window.vala"
	g_return_val_if_fail (g_type_is_a (object_type, NIBBLES_WINDOW_TYPE_DELEGATE_STACK), NULL);
#line 81 "../src/nibbles-window.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 81 "../src/nibbles-window.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 81 "../src/nibbles-window.vala"
	return G_PARAM_SPEC (spec);
#line 6391 "nibbles-window.c"
}

static gpointer
nibbles_window_value_get_delegate_stack (const GValue* value)
{
#line 81 "../src/nibbles-window.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NIBBLES_WINDOW_TYPE_DELEGATE_STACK), NULL);
#line 81 "../src/nibbles-window.vala"
	return value->data[0].v_pointer;
#line 6401 "nibbles-window.c"
}

static void
nibbles_window_value_set_delegate_stack (GValue* value,
                                         gpointer v_object)
{
	NibblesWindowDelegateStack * old;
#line 81 "../src/nibbles-window.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NIBBLES_WINDOW_TYPE_DELEGATE_STACK));
#line 81 "../src/nibbles-window.vala"
	old = value->data[0].v_pointer;
#line 81 "../src/nibbles-window.vala"
	if (v_object) {
#line 81 "../src/nibbles-window.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NIBBLES_WINDOW_TYPE_DELEGATE_STACK));
#line 81 "../src/nibbles-window.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 81 "../src/nibbles-window.vala"
		value->data[0].v_pointer = v_object;
#line 81 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_ref (value->data[0].v_pointer);
#line 6423 "nibbles-window.c"
	} else {
#line 81 "../src/nibbles-window.vala"
		value->data[0].v_pointer = NULL;
#line 6427 "nibbles-window.c"
	}
#line 81 "../src/nibbles-window.vala"
	if (old) {
#line 81 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_unref (old);
#line 6433 "nibbles-window.c"
	}
}

static void
nibbles_window_value_take_delegate_stack (GValue* value,
                                          gpointer v_object)
{
	NibblesWindowDelegateStack * old;
#line 81 "../src/nibbles-window.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NIBBLES_WINDOW_TYPE_DELEGATE_STACK));
#line 81 "../src/nibbles-window.vala"
	old = value->data[0].v_pointer;
#line 81 "../src/nibbles-window.vala"
	if (v_object) {
#line 81 "../src/nibbles-window.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NIBBLES_WINDOW_TYPE_DELEGATE_STACK));
#line 81 "../src/nibbles-window.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 81 "../src/nibbles-window.vala"
		value->data[0].v_pointer = v_object;
#line 6454 "nibbles-window.c"
	} else {
#line 81 "../src/nibbles-window.vala"
		value->data[0].v_pointer = NULL;
#line 6458 "nibbles-window.c"
	}
#line 81 "../src/nibbles-window.vala"
	if (old) {
#line 81 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_unref (old);
#line 6464 "nibbles-window.c"
	}
}

static void
nibbles_window_delegate_stack_class_init (NibblesWindowDelegateStackClass * klass,
                                          gpointer klass_data)
{
#line 81 "../src/nibbles-window.vala"
	nibbles_window_delegate_stack_parent_class = g_type_class_peek_parent (klass);
#line 81 "../src/nibbles-window.vala"
	((NibblesWindowDelegateStackClass *) klass)->finalize = nibbles_window_delegate_stack_finalize;
#line 81 "../src/nibbles-window.vala"
	g_type_class_adjust_private_offset (klass, &NibblesWindowDelegateStack_private_offset);
#line 6478 "nibbles-window.c"
}

static void
nibbles_window_delegate_stack_instance_init (NibblesWindowDelegateStack * self,
                                             gpointer klass)
{
#line 81 "../src/nibbles-window.vala"
	self->priv = nibbles_window_delegate_stack_get_instance_private (self);
#line 123 "../src/nibbles-window.vala"
	self->priv->pHead = NULL;
#line 81 "../src/nibbles-window.vala"
	self->ref_count = 1;
#line 6491 "nibbles-window.c"
}

static void
nibbles_window_delegate_stack_finalize (NibblesWindowDelegateStack * obj)
{
	NibblesWindowDelegateStack * self;
#line 81 "../src/nibbles-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NIBBLES_WINDOW_TYPE_DELEGATE_STACK, NibblesWindowDelegateStack);
#line 81 "../src/nibbles-window.vala"
	g_signal_handlers_destroy (self);
#line 123 "../src/nibbles-window.vala"
	_nibbles_window_delegate_stack_node_free0 (self->priv->pHead);
#line 6504 "nibbles-window.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_window_delegate_stack_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { nibbles_window_value_delegate_stack_init, nibbles_window_value_delegate_stack_free_value, nibbles_window_value_delegate_stack_copy_value, nibbles_window_value_delegate_stack_peek_pointer, "p", nibbles_window_value_delegate_stack_collect_value, "p", nibbles_window_value_delegate_stack_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (NibblesWindowDelegateStackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_window_delegate_stack_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NibblesWindowDelegateStack), 0, (GInstanceInitFunc) nibbles_window_delegate_stack_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType nibbles_window_delegate_stack_type_id;
	nibbles_window_delegate_stack_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NibblesWindowDelegateStack", &g_define_type_info, &g_define_type_fundamental_info, 0);
	NibblesWindowDelegateStack_private_offset = g_type_add_instance_private (nibbles_window_delegate_stack_type_id, sizeof (NibblesWindowDelegateStackPrivate));
	return nibbles_window_delegate_stack_type_id;
}

static GType
nibbles_window_delegate_stack_get_type (void)
{
	static gsize nibbles_window_delegate_stack_type_id__once = 0;
	if (g_once_init_enter (&nibbles_window_delegate_stack_type_id__once)) {
		GType nibbles_window_delegate_stack_type_id;
		nibbles_window_delegate_stack_type_id = nibbles_window_delegate_stack_get_type_once ();
		g_once_init_leave (&nibbles_window_delegate_stack_type_id__once, nibbles_window_delegate_stack_type_id);
	}
	return nibbles_window_delegate_stack_type_id__once;
}

static gpointer
nibbles_window_delegate_stack_ref (gpointer instance)
{
	NibblesWindowDelegateStack * self;
	self = instance;
#line 81 "../src/nibbles-window.vala"
	g_atomic_int_inc (&self->ref_count);
#line 81 "../src/nibbles-window.vala"
	return instance;
#line 6540 "nibbles-window.c"
}

static void
nibbles_window_delegate_stack_unref (gpointer instance)
{
	NibblesWindowDelegateStack * self;
	self = instance;
#line 81 "../src/nibbles-window.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 81 "../src/nibbles-window.vala"
		NIBBLES_WINDOW_DELEGATE_STACK_GET_CLASS (self)->finalize (self);
#line 81 "../src/nibbles-window.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 6554 "nibbles-window.c"
	}
}

static void
_nibbles_window_settings_changed_cb_g_settings_changed (GSettings* _sender,
                                                        const gchar* key,
                                                        gpointer self)
{
#line 249 "../src/nibbles-window.vala"
	nibbles_window_settings_changed_cb ((NibblesWindow*) self, key);
#line 6565 "nibbles-window.c"
}

static void
_nibbles_window_worm_settings_changed_cb_g_settings_changed (GSettings* _sender,
                                                             const gchar* key,
                                                             gpointer self)
{
#line 258 "../src/nibbles-window.vala"
	nibbles_window_worm_settings_changed_cb ((NibblesWindow*) self, _sender, key);
#line 6575 "nibbles-window.c"
}

static void
_nibbles_window___lambda46_ (NibblesWindow* self)
{
	NibblesView* _tmp0_;
#line 263 "../src/nibbles-window.vala"
	_tmp0_ = self->priv->view;
#line 263 "../src/nibbles-window.vala"
	if (NULL != _tmp0_) {
#line 6586 "nibbles-window.c"
		NibblesView* _tmp1_;
#line 264 "../src/nibbles-window.vala"
		_tmp1_ = self->priv->view;
#line 264 "../src/nibbles-window.vala"
		gtk_root_set_focus ((GtkRoot*) self, (GtkWidget*) _tmp1_);
#line 6592 "nibbles-window.c"
	}
}

static void
__nibbles_window___lambda46__gtk_popover_closed (GtkPopover* _sender,
                                                 gpointer self)
{
#line 261 "../src/nibbles-window.vala"
	_nibbles_window___lambda46_ ((NibblesWindow*) self);
#line 6602 "nibbles-window.c"
}

static gboolean
_nibbles_window___lambda47_ (NibblesWindow* self,
                             GtkEventControllerKey* controller,
                             guint keyval,
                             guint keycode,
                             GdkModifierType state)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gboolean result;
#line 273 "../src/nibbles-window.vala"
	g_return_val_if_fail (controller != NULL, FALSE);
#line 280 "../src/nibbles-window.vala"
	_tmp1_ = gdk_keyval_name (keyval);
#line 280 "../src/nibbles-window.vala"
	_tmp0_ = _tmp1_;
#line 280 "../src/nibbles-window.vala"
	if (_tmp0_ == NULL) {
#line 280 "../src/nibbles-window.vala"
		_tmp0_ = "";
#line 6625 "nibbles-window.c"
	}
#line 280 "../src/nibbles-window.vala"
	if (g_strcmp0 ((const gchar*) _tmp0_, "F1") == 0) {
#line 282 "../src/nibbles-window.vala"
		if ((state & GDK_CONTROL_MASK) > 0) {
#line 283 "../src/nibbles-window.vala"
			g_action_group_activate_action ((GActionGroup*) self, "show-help-overlay", NULL);
#line 6633 "nibbles-window.c"
		} else {
#line 284 "../src/nibbles-window.vala"
			if ((state & GDK_SHIFT_MASK) > 0) {
#line 6637 "nibbles-window.c"
				GtkApplication* _tmp2_;
				GtkApplication* _tmp3_;
#line 285 "../src/nibbles-window.vala"
				_tmp2_ = gtk_window_get_application ((GtkWindow*) self);
#line 285 "../src/nibbles-window.vala"
				_tmp3_ = _tmp2_;
#line 285 "../src/nibbles-window.vala"
				g_action_group_activate_action ((GActionGroup*) _tmp3_, "about", NULL);
#line 6646 "nibbles-window.c"
			} else {
#line 286 "../src/nibbles-window.vala"
				if ((state & GDK_SHIFT_MASK) == 0) {
#line 6650 "nibbles-window.c"
					GtkApplication* _tmp4_;
					GtkApplication* _tmp5_;
#line 287 "../src/nibbles-window.vala"
					_tmp4_ = gtk_window_get_application ((GtkWindow*) self);
#line 287 "../src/nibbles-window.vala"
					_tmp5_ = _tmp4_;
#line 287 "../src/nibbles-window.vala"
					g_action_group_activate_action ((GActionGroup*) _tmp5_, "help", NULL);
#line 6659 "nibbles-window.c"
				} else {
#line 289 "../src/nibbles-window.vala"
					result = FALSE;
#line 289 "../src/nibbles-window.vala"
					return result;
#line 6665 "nibbles-window.c"
				}
			}
		}
#line 290 "../src/nibbles-window.vala"
		result = TRUE;
#line 290 "../src/nibbles-window.vala"
		return result;
#line 6673 "nibbles-window.c"
	} else {
		NibblesWindowDelegateStack* handlers_to_remove = NULL;
		NibblesWindowDelegateStack* _tmp6_;
#line 294 "../src/nibbles-window.vala"
		_tmp6_ = nibbles_window_delegate_stack_new ();
#line 294 "../src/nibbles-window.vala"
		handlers_to_remove = _tmp6_;
#line 6681 "nibbles-window.c"
		{
			NibblesWindowDelegateStackDelegateStackIterator* _handler_it = NULL;
			NibblesWindowDelegateStack* _tmp7_;
			NibblesWindowDelegateStackDelegateStackIterator* _tmp8_;
#line 295 "../src/nibbles-window.vala"
			_tmp7_ = self->priv->keypress_handlers;
#line 295 "../src/nibbles-window.vala"
			_tmp8_ = nibbles_window_delegate_stack_iterator (_tmp7_);
#line 295 "../src/nibbles-window.vala"
			_handler_it = _tmp8_;
#line 295 "../src/nibbles-window.vala"
			while (TRUE) {
#line 6694 "nibbles-window.c"
				NibblesWindowDelegateStackDelegateStackIterator* _tmp9_;
				KeypressHandlerFunction handler = NULL;
				NibblesWindowDelegateStackDelegateStackIterator* _tmp10_;
				gpointer _tmp11_ = NULL;
				GDestroyNotify _tmp12_ = NULL;
				KeypressHandlerFunction _tmp13_;
				gpointer handler_target;
				GDestroyNotify handler_target_destroy_notify;
				gboolean remove_handler = FALSE;
				gboolean r = FALSE;
				KeypressHandlerFunction _tmp14_;
				gpointer _tmp14__target;
				gboolean _tmp15_ = FALSE;
				gboolean _tmp16_;
#line 295 "../src/nibbles-window.vala"
				_tmp9_ = _handler_it;
#line 295 "../src/nibbles-window.vala"
				if (!nibbles_window_delegate_stack_delegate_stack_iterator_next (_tmp9_)) {
#line 295 "../src/nibbles-window.vala"
					break;
#line 6715 "nibbles-window.c"
				}
#line 295 "../src/nibbles-window.vala"
				_tmp10_ = _handler_it;
#line 295 "../src/nibbles-window.vala"
				_tmp13_ = nibbles_window_delegate_stack_delegate_stack_iterator_get (_tmp10_, &_tmp11_, &_tmp12_);
#line 295 "../src/nibbles-window.vala"
				handler = _tmp13_;
#line 295 "../src/nibbles-window.vala"
				handler_target = _tmp11_;
#line 295 "../src/nibbles-window.vala"
				handler_target_destroy_notify = _tmp12_;
#line 298 "../src/nibbles-window.vala"
				_tmp14_ = handler;
#line 298 "../src/nibbles-window.vala"
				_tmp14__target = handler_target;
#line 298 "../src/nibbles-window.vala"
				_tmp16_ = _tmp14_ (keyval, keycode, &_tmp15_, _tmp14__target);
#line 298 "../src/nibbles-window.vala"
				remove_handler = _tmp15_;
#line 298 "../src/nibbles-window.vala"
				r = _tmp16_;
#line 299 "../src/nibbles-window.vala"
				if (remove_handler) {
#line 6739 "nibbles-window.c"
					NibblesWindowDelegateStack* _tmp17_;
					KeypressHandlerFunction _tmp18_;
					gpointer _tmp18__target;
#line 300 "../src/nibbles-window.vala"
					_tmp17_ = handlers_to_remove;
#line 300 "../src/nibbles-window.vala"
					_tmp18_ = handler;
#line 300 "../src/nibbles-window.vala"
					_tmp18__target = handler_target;
#line 300 "../src/nibbles-window.vala"
					nibbles_window_delegate_stack_push (_tmp17_, _tmp18_, _tmp18__target);
#line 6751 "nibbles-window.c"
				}
#line 301 "../src/nibbles-window.vala"
				if (r) {
#line 6755 "nibbles-window.c"
					{
						NibblesWindowDelegateStackDelegateStackIterator* _h_it = NULL;
						NibblesWindowDelegateStack* _tmp19_;
						NibblesWindowDelegateStackDelegateStackIterator* _tmp20_;
#line 304 "../src/nibbles-window.vala"
						_tmp19_ = handlers_to_remove;
#line 304 "../src/nibbles-window.vala"
						_tmp20_ = nibbles_window_delegate_stack_iterator (_tmp19_);
#line 304 "../src/nibbles-window.vala"
						_h_it = _tmp20_;
#line 304 "../src/nibbles-window.vala"
						while (TRUE) {
#line 6768 "nibbles-window.c"
							NibblesWindowDelegateStackDelegateStackIterator* _tmp21_;
							KeypressHandlerFunction h = NULL;
							NibblesWindowDelegateStackDelegateStackIterator* _tmp22_;
							gpointer _tmp23_ = NULL;
							GDestroyNotify _tmp24_ = NULL;
							KeypressHandlerFunction _tmp25_;
							gpointer h_target;
							GDestroyNotify h_target_destroy_notify;
							NibblesWindowDelegateStack* _tmp26_;
							KeypressHandlerFunction _tmp27_;
							gpointer _tmp27__target;
#line 304 "../src/nibbles-window.vala"
							_tmp21_ = _h_it;
#line 304 "../src/nibbles-window.vala"
							if (!nibbles_window_delegate_stack_delegate_stack_iterator_next (_tmp21_)) {
#line 304 "../src/nibbles-window.vala"
								break;
#line 6786 "nibbles-window.c"
							}
#line 304 "../src/nibbles-window.vala"
							_tmp22_ = _h_it;
#line 304 "../src/nibbles-window.vala"
							_tmp25_ = nibbles_window_delegate_stack_delegate_stack_iterator_get (_tmp22_, &_tmp23_, &_tmp24_);
#line 304 "../src/nibbles-window.vala"
							h = _tmp25_;
#line 304 "../src/nibbles-window.vala"
							h_target = _tmp23_;
#line 304 "../src/nibbles-window.vala"
							h_target_destroy_notify = _tmp24_;
#line 305 "../src/nibbles-window.vala"
							_tmp26_ = self->priv->keypress_handlers;
#line 305 "../src/nibbles-window.vala"
							_tmp27_ = h;
#line 305 "../src/nibbles-window.vala"
							_tmp27__target = h_target;
#line 305 "../src/nibbles-window.vala"
							nibbles_window_delegate_stack_remove (_tmp26_, _tmp27_, _tmp27__target);
#line 304 "../src/nibbles-window.vala"
							(h_target_destroy_notify == NULL) ? NULL : (h_target_destroy_notify (h_target), NULL);
#line 304 "../src/nibbles-window.vala"
							h = NULL;
#line 304 "../src/nibbles-window.vala"
							h_target = NULL;
#line 304 "../src/nibbles-window.vala"
							h_target_destroy_notify = NULL;
#line 6814 "nibbles-window.c"
						}
#line 304 "../src/nibbles-window.vala"
						_nibbles_window_delegate_stack_delegate_stack_iterator_unref0 (_h_it);
#line 6818 "nibbles-window.c"
					}
#line 306 "../src/nibbles-window.vala"
					result = r;
#line 306 "../src/nibbles-window.vala"
					(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
#line 306 "../src/nibbles-window.vala"
					handler = NULL;
#line 306 "../src/nibbles-window.vala"
					handler_target = NULL;
#line 306 "../src/nibbles-window.vala"
					handler_target_destroy_notify = NULL;
#line 306 "../src/nibbles-window.vala"
					_nibbles_window_delegate_stack_delegate_stack_iterator_unref0 (_handler_it);
#line 306 "../src/nibbles-window.vala"
					_nibbles_window_delegate_stack_unref0 (handlers_to_remove);
#line 306 "../src/nibbles-window.vala"
					return result;
#line 6836 "nibbles-window.c"
				}
#line 295 "../src/nibbles-window.vala"
				(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
#line 295 "../src/nibbles-window.vala"
				handler = NULL;
#line 295 "../src/nibbles-window.vala"
				handler_target = NULL;
#line 295 "../src/nibbles-window.vala"
				handler_target_destroy_notify = NULL;
#line 6846 "nibbles-window.c"
			}
#line 295 "../src/nibbles-window.vala"
			_nibbles_window_delegate_stack_delegate_stack_iterator_unref0 (_handler_it);
#line 6850 "nibbles-window.c"
		}
		{
			NibblesWindowDelegateStackDelegateStackIterator* _handler_it = NULL;
			NibblesWindowDelegateStack* _tmp28_;
			NibblesWindowDelegateStackDelegateStackIterator* _tmp29_;
#line 310 "../src/nibbles-window.vala"
			_tmp28_ = handlers_to_remove;
#line 310 "../src/nibbles-window.vala"
			_tmp29_ = nibbles_window_delegate_stack_iterator (_tmp28_);
#line 310 "../src/nibbles-window.vala"
			_handler_it = _tmp29_;
#line 310 "../src/nibbles-window.vala"
			while (TRUE) {
#line 6864 "nibbles-window.c"
				NibblesWindowDelegateStackDelegateStackIterator* _tmp30_;
				KeypressHandlerFunction handler = NULL;
				NibblesWindowDelegateStackDelegateStackIterator* _tmp31_;
				gpointer _tmp32_ = NULL;
				GDestroyNotify _tmp33_ = NULL;
				KeypressHandlerFunction _tmp34_;
				gpointer handler_target;
				GDestroyNotify handler_target_destroy_notify;
				NibblesWindowDelegateStack* _tmp35_;
				KeypressHandlerFunction _tmp36_;
				gpointer _tmp36__target;
#line 310 "../src/nibbles-window.vala"
				_tmp30_ = _handler_it;
#line 310 "../src/nibbles-window.vala"
				if (!nibbles_window_delegate_stack_delegate_stack_iterator_next (_tmp30_)) {
#line 310 "../src/nibbles-window.vala"
					break;
#line 6882 "nibbles-window.c"
				}
#line 310 "../src/nibbles-window.vala"
				_tmp31_ = _handler_it;
#line 310 "../src/nibbles-window.vala"
				_tmp34_ = nibbles_window_delegate_stack_delegate_stack_iterator_get (_tmp31_, &_tmp32_, &_tmp33_);
#line 310 "../src/nibbles-window.vala"
				handler = _tmp34_;
#line 310 "../src/nibbles-window.vala"
				handler_target = _tmp32_;
#line 310 "../src/nibbles-window.vala"
				handler_target_destroy_notify = _tmp33_;
#line 311 "../src/nibbles-window.vala"
				_tmp35_ = self->priv->keypress_handlers;
#line 311 "../src/nibbles-window.vala"
				_tmp36_ = handler;
#line 311 "../src/nibbles-window.vala"
				_tmp36__target = handler_target;
#line 311 "../src/nibbles-window.vala"
				nibbles_window_delegate_stack_remove (_tmp35_, _tmp36_, _tmp36__target);
#line 310 "../src/nibbles-window.vala"
				(handler_target_destroy_notify == NULL) ? NULL : (handler_target_destroy_notify (handler_target), NULL);
#line 310 "../src/nibbles-window.vala"
				handler = NULL;
#line 310 "../src/nibbles-window.vala"
				handler_target = NULL;
#line 310 "../src/nibbles-window.vala"
				handler_target_destroy_notify = NULL;
#line 6910 "nibbles-window.c"
			}
#line 310 "../src/nibbles-window.vala"
			_nibbles_window_delegate_stack_delegate_stack_iterator_unref0 (_handler_it);
#line 6914 "nibbles-window.c"
		}
#line 312 "../src/nibbles-window.vala"
		result = FALSE;
#line 312 "../src/nibbles-window.vala"
		_nibbles_window_delegate_stack_unref0 (handlers_to_remove);
#line 312 "../src/nibbles-window.vala"
		return result;
#line 6922 "nibbles-window.c"
	}
}

static gboolean
__nibbles_window___lambda47__gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                   guint keyval,
                                                                   guint keycode,
                                                                   GdkModifierType state,
                                                                   gpointer self)
{
	gboolean result;
	result = _nibbles_window___lambda47_ ((NibblesWindow*) self, _sender, keyval, keycode, state);
#line 273 "../src/nibbles-window.vala"
	return result;
#line 6937 "nibbles-window.c"
}

static void
_nibbles_window___lambda48_ (NibblesWindow* self)
{
#line 317 "../src/nibbles-window.vala"
	_vala_assert (FALSE, "false");
#line 6945 "nibbles-window.c"
}

static void
__nibbles_window___lambda48__gtk_event_controller_key_im_update (GtkEventControllerKey* _sender,
                                                                 gpointer self)
{
#line 315 "../src/nibbles-window.vala"
	_nibbles_window___lambda48_ ((NibblesWindow*) self);
#line 6954 "nibbles-window.c"
}

static void
_nibbles_window_log_score_cb_nibbles_game_log_score (NibblesGame* _sender,
                                                     gint score,
                                                     gint level_reached,
                                                     gpointer self)
{
#line 335 "../src/nibbles-window.vala"
	nibbles_window_log_score_cb ((NibblesWindow*) self, score, level_reached);
#line 6965 "nibbles-window.c"
}

static void
_nibbles_window_level_completed_cb_nibbles_game_level_completed (NibblesGame* _sender,
                                                                 gpointer self)
{
#line 336 "../src/nibbles-window.vala"
	nibbles_window_level_completed_cb ((NibblesWindow*) self);
#line 6974 "nibbles-window.c"
}

static gchar*
_nibbles_window___lambda49_ (NibblesWindow* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 338 "../src/nibbles-window.vala"
	_tmp0_ = g_strdup (PKGDATADIR);
#line 338 "../src/nibbles-window.vala"
	result = _tmp0_;
#line 338 "../src/nibbles-window.vala"
	return result;
#line 6988 "nibbles-window.c"
}

static gchar*
__nibbles_window___lambda49__nibbles_game_get_pkgdatadir (NibblesGame* _sender,
                                                          gpointer self)
{
	gchar* result;
	result = _nibbles_window___lambda49_ ((NibblesWindow*) self);
#line 338 "../src/nibbles-window.vala"
	return result;
#line 6999 "nibbles-window.c"
}

static gboolean
_nibbles_window___lambda50_ (NibblesWindow* self,
                             KeypressHandlerFunction handler,
                             gpointer handler_target)
{
	gboolean result;
#line 341 "../src/nibbles-window.vala"
	if (handler != NULL) {
#line 7010 "nibbles-window.c"
		NibblesWindowDelegateStack* _tmp0_;
#line 342 "../src/nibbles-window.vala"
		_tmp0_ = self->priv->keypress_handlers;
#line 342 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_push (_tmp0_, handler, handler_target);
#line 7016 "nibbles-window.c"
	} else {
		NibblesWindowDelegateStack* _tmp1_;
#line 344 "../src/nibbles-window.vala"
		_tmp1_ = self->priv->keypress_handlers;
#line 344 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_pop (_tmp1_);
#line 7023 "nibbles-window.c"
	}
#line 345 "../src/nibbles-window.vala"
	result = TRUE;
#line 345 "../src/nibbles-window.vala"
	return result;
#line 7029 "nibbles-window.c"
}

static gboolean
__nibbles_window___lambda50__nibbles_game_add_keypress_handler (NibblesGame* _sender,
                                                                KeypressHandlerFunction keypress_handler,
                                                                gpointer keypress_handler_target,
                                                                gpointer self)
{
	gboolean result;
	result = _nibbles_window___lambda50_ ((NibblesWindow*) self, keypress_handler, keypress_handler_target);
#line 339 "../src/nibbles-window.vala"
	return result;
#line 7042 "nibbles-window.c"
}

static gint
_nibbles_window_countdown_active_nibbles_view_countdown_active_function (gpointer self)
{
	gint result;
	result = nibbles_window_countdown_active ((NibblesWindow*) self);
#line 349 "../src/nibbles-window.vala"
	return result;
#line 7052 "nibbles-window.c"
}

static gboolean
_nibbles_window_new_game_dialogue_active_new_game_dialogue_active_function (YesNoResultFunction* function,
                                                                            gpointer* function_target,
                                                                            GDestroyNotify* function_target_destroy_notify,
                                                                            gpointer self)
{
	gboolean result;
	result = nibbles_window_new_game_dialogue_active ((NibblesWindow*) self, function, function_target, function_target_destroy_notify);
#line 349 "../src/nibbles-window.vala"
	return result;
#line 7065 "nibbles-window.c"
}

static void
_nibbles_window___lambda51_ (NibblesWindow* self,
                             KeypressHandlerFunction handler,
                             gpointer handler_target)
{
#line 380 "../src/nibbles-window.vala"
	if (handler != NULL) {
#line 7075 "nibbles-window.c"
		NibblesWindowDelegateStack* _tmp0_;
#line 381 "../src/nibbles-window.vala"
		_tmp0_ = self->priv->keypress_handlers;
#line 381 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_push (_tmp0_, handler, handler_target);
#line 7081 "nibbles-window.c"
	} else {
		NibblesWindowDelegateStack* _tmp1_;
#line 383 "../src/nibbles-window.vala"
		_tmp1_ = self->priv->keypress_handlers;
#line 383 "../src/nibbles-window.vala"
		nibbles_window_delegate_stack_pop (_tmp1_);
#line 7088 "nibbles-window.c"
	}
}

static void
__nibbles_window___lambda51__controls_add_keypress_handler (Controls* _sender,
                                                            KeypressHandlerFunction handler,
                                                            gpointer handler_target,
                                                            gpointer self)
{
#line 378 "../src/nibbles-window.vala"
	_nibbles_window___lambda51_ ((NibblesWindow*) self, handler, handler_target);
#line 7100 "nibbles-window.c"
}

static GObject *
nibbles_window_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NibblesWindow * self;
	GAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GAction* _tmp11_;
	GAction* _tmp12_;
	GSettings* _tmp13_;
	GAction* _tmp14_;
	GAction* _tmp15_;
	GeeArrayList* _tmp16_;
	GtkMenuButton* _tmp27_;
	GtkPopover* _tmp28_;
	GSettings* _tmp29_;
	GSettings* _tmp30_;
	GSettings* _tmp31_;
	GtkEventControllerKey* key_controller = NULL;
	GtkEventControllerKey* _tmp32_;
	GtkEventControllerKey* _tmp33_;
	GtkEventControllerKey* _tmp34_;
	GtkEventControllerKey* _tmp35_;
	GtkEventController* _tmp36_;
	gboolean three_dimensional_view = FALSE;
	GSettings* _tmp37_;
	GSettings* _tmp38_;
	Sound* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	GSettings* _tmp42_;
	GSettings* _tmp43_;
	NibblesGame* _tmp44_;
	NibblesGame* _tmp45_;
	NibblesGame* _tmp46_;
	Sound* _tmp47_;
	NibblesGame* _tmp48_;
	NibblesGame* _tmp49_;
	NibblesGame* _tmp50_;
	NibblesGame* _tmp51_;
	NibblesView* _tmp52_;
	NibblesView* _tmp53_;
	NibblesView* _tmp54_;
	GtkBox* _tmp55_;
	NibblesView* _tmp56_;
	NibblesView* _tmp57_;
	GtkImage* _tmp58_;
	NibblesGame* _tmp59_;
	GSettings* _tmp60_;
	gint numai = 0;
	GSettings* _tmp61_;
	gboolean _tmp62_ = FALSE;
	NibblesGame* _tmp63_;
	gint _tmp64_;
	gint _tmp65_;
	NibblesGame* _tmp73_;
	Players* _tmp74_;
	NibblesGame* _tmp75_;
	gint _tmp76_;
	gint _tmp77_;
	Speed* _tmp78_;
	GSettings* _tmp79_;
	GSettings* _tmp80_;
	Controls* _tmp81_;
	SetupScreen _tmp82_;
#line 240 "../src/nibbles-window.vala"
	parent_class = G_OBJECT_CLASS (nibbles_window_parent_class);
#line 240 "../src/nibbles-window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 240 "../src/nibbles-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_WINDOW, NibblesWindow);
#line 242 "../src/nibbles-window.vala"
	g_action_map_add_action_entries ((GActionMap*) self, NIBBLES_WINDOW_menu_entries, (gint) G_N_ELEMENTS (NIBBLES_WINDOW_menu_entries), self);
#line 243 "../src/nibbles-window.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, "new-game");
#line 243 "../src/nibbles-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction));
#line 243 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->new_game_action);
#line 243 "../src/nibbles-window.vala"
	self->priv->new_game_action = _tmp1_;
#line 244 "../src/nibbles-window.vala"
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) self, "pause");
#line 244 "../src/nibbles-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, g_simple_action_get_type (), GSimpleAction));
#line 244 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->pause_action);
#line 244 "../src/nibbles-window.vala"
	self->priv->pause_action = _tmp3_;
#line 245 "../src/nibbles-window.vala"
	_tmp4_ = g_action_map_lookup_action ((GActionMap*) self, "back");
#line 245 "../src/nibbles-window.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, g_simple_action_get_type (), GSimpleAction));
#line 245 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->back_action);
#line 245 "../src/nibbles-window.vala"
	self->priv->back_action = _tmp5_;
#line 246 "../src/nibbles-window.vala"
	_tmp6_ = g_action_map_lookup_action ((GActionMap*) self, "start-game");
#line 246 "../src/nibbles-window.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, g_simple_action_get_type (), GSimpleAction));
#line 246 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->start_game_action);
#line 246 "../src/nibbles-window.vala"
	self->priv->start_game_action = _tmp7_;
#line 248 "../src/nibbles-window.vala"
	_tmp8_ = g_settings_new ("org.gnome.Nibbles");
#line 248 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->settings);
#line 248 "../src/nibbles-window.vala"
	self->priv->settings = _tmp8_;
#line 249 "../src/nibbles-window.vala"
	_tmp9_ = self->priv->settings;
#line 249 "../src/nibbles-window.vala"
	g_signal_connect_object (_tmp9_, "changed", (GCallback) _nibbles_window_settings_changed_cb_g_settings_changed, self, 0);
#line 250 "../src/nibbles-window.vala"
	_tmp10_ = self->priv->settings;
#line 250 "../src/nibbles-window.vala"
	_tmp11_ = g_settings_create_action (_tmp10_, "sound");
#line 250 "../src/nibbles-window.vala"
	_tmp12_ = _tmp11_;
#line 250 "../src/nibbles-window.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp12_);
#line 250 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp12_);
#line 251 "../src/nibbles-window.vala"
	_tmp13_ = self->priv->settings;
#line 251 "../src/nibbles-window.vala"
	_tmp14_ = g_settings_create_action (_tmp13_, "three-dimensional-view");
#line 251 "../src/nibbles-window.vala"
	_tmp15_ = _tmp14_;
#line 251 "../src/nibbles-window.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp15_);
#line 251 "../src/nibbles-window.vala"
	_g_object_unref0 (_tmp15_);
#line 253 "../src/nibbles-window.vala"
	_tmp16_ = gee_array_list_new (g_settings_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 253 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->worm_settings);
#line 253 "../src/nibbles-window.vala"
	self->priv->worm_settings = _tmp16_;
#line 7256 "nibbles-window.c"
	{
		gint i = 0;
#line 254 "../src/nibbles-window.vala"
		i = 0;
#line 7261 "nibbles-window.c"
		{
			gboolean _tmp17_ = FALSE;
#line 254 "../src/nibbles-window.vala"
			_tmp17_ = TRUE;
#line 254 "../src/nibbles-window.vala"
			while (TRUE) {
#line 7268 "nibbles-window.c"
				gchar* name = NULL;
				gchar* _tmp19_;
				GeeArrayList* _tmp20_;
				const gchar* _tmp21_;
				GSettings* _tmp22_;
				GSettings* _tmp23_;
				GeeArrayList* _tmp24_;
				gpointer _tmp25_;
				GSettings* _tmp26_;
#line 254 "../src/nibbles-window.vala"
				if (!_tmp17_) {
#line 7280 "nibbles-window.c"
					gint _tmp18_;
#line 254 "../src/nibbles-window.vala"
					_tmp18_ = i;
#line 254 "../src/nibbles-window.vala"
					i = _tmp18_ + 1;
#line 7286 "nibbles-window.c"
				}
#line 254 "../src/nibbles-window.vala"
				_tmp17_ = FALSE;
#line 254 "../src/nibbles-window.vala"
				if (!(i < NIBBLES_GAME_MAX_WORMS)) {
#line 254 "../src/nibbles-window.vala"
					break;
#line 7294 "nibbles-window.c"
				}
#line 256 "../src/nibbles-window.vala"
				_tmp19_ = g_strdup_printf ("org.gnome.Nibbles.worm%d", i);
#line 256 "../src/nibbles-window.vala"
				name = _tmp19_;
#line 257 "../src/nibbles-window.vala"
				_tmp20_ = self->priv->worm_settings;
#line 257 "../src/nibbles-window.vala"
				_tmp21_ = name;
#line 257 "../src/nibbles-window.vala"
				_tmp22_ = g_settings_new (_tmp21_);
#line 257 "../src/nibbles-window.vala"
				_tmp23_ = _tmp22_;
#line 257 "../src/nibbles-window.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp23_);
#line 257 "../src/nibbles-window.vala"
				_g_object_unref0 (_tmp23_);
#line 258 "../src/nibbles-window.vala"
				_tmp24_ = self->priv->worm_settings;
#line 258 "../src/nibbles-window.vala"
				_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, i);
#line 258 "../src/nibbles-window.vala"
				_tmp26_ = (GSettings*) _tmp25_;
#line 258 "../src/nibbles-window.vala"
				g_signal_connect_object (_tmp26_, "changed", (GCallback) _nibbles_window_worm_settings_changed_cb_g_settings_changed, self, 0);
#line 258 "../src/nibbles-window.vala"
				_g_object_unref0 (_tmp26_);
#line 254 "../src/nibbles-window.vala"
				_g_free0 (name);
#line 7324 "nibbles-window.c"
			}
		}
	}
#line 261 "../src/nibbles-window.vala"
	_tmp27_ = self->priv->hamburger_menu;
#line 261 "../src/nibbles-window.vala"
	_tmp28_ = gtk_menu_button_get_popover (_tmp27_);
#line 261 "../src/nibbles-window.vala"
	g_signal_connect_object (_tmp28_, "closed", (GCallback) __nibbles_window___lambda46__gtk_popover_closed, self, 0);
#line 267 "../src/nibbles-window.vala"
	_tmp29_ = self->priv->settings;
#line 267 "../src/nibbles-window.vala"
	_tmp30_ = self->priv->settings;
#line 267 "../src/nibbles-window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, g_settings_get_int (_tmp29_, "window-width"), g_settings_get_int (_tmp30_, "window-height"));
#line 268 "../src/nibbles-window.vala"
	_tmp31_ = self->priv->settings;
#line 268 "../src/nibbles-window.vala"
	if (g_settings_get_boolean (_tmp31_, "window-is-maximized")) {
#line 269 "../src/nibbles-window.vala"
		gtk_window_maximize ((GtkWindow*) self);
#line 7346 "nibbles-window.c"
	}
#line 272 "../src/nibbles-window.vala"
	_tmp32_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 272 "../src/nibbles-window.vala"
	key_controller = _tmp32_;
#line 273 "../src/nibbles-window.vala"
	_tmp33_ = key_controller;
#line 273 "../src/nibbles-window.vala"
	g_signal_connect_object (_tmp33_, "key-pressed", (GCallback) __nibbles_window___lambda47__gtk_event_controller_key_key_pressed, self, 0);
#line 315 "../src/nibbles-window.vala"
	_tmp34_ = key_controller;
#line 315 "../src/nibbles-window.vala"
	g_signal_connect_object (_tmp34_, "im-update", (GCallback) __nibbles_window___lambda48__gtk_event_controller_key_im_update, self, 0);
#line 319 "../src/nibbles-window.vala"
	_tmp35_ = key_controller;
#line 319 "../src/nibbles-window.vala"
	_tmp36_ = _g_object_ref0 ((GtkEventController*) _tmp35_);
#line 319 "../src/nibbles-window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp36_);
#line 322 "../src/nibbles-window.vala"
	_tmp37_ = self->priv->settings;
#line 322 "../src/nibbles-window.vala"
	three_dimensional_view = g_settings_get_boolean (_tmp37_, "three-dimensional-view");
#line 325 "../src/nibbles-window.vala"
	_tmp38_ = self->priv->settings;
#line 325 "../src/nibbles-window.vala"
	_tmp39_ = sound_new (!g_settings_get_boolean (_tmp38_, "sound"));
#line 325 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->sound);
#line 325 "../src/nibbles-window.vala"
	self->priv->sound = _tmp39_;
#line 328 "../src/nibbles-window.vala"
	_tmp40_ = nibbles_window_get_start_level (self);
#line 328 "../src/nibbles-window.vala"
	_tmp41_ = _tmp40_;
#line 328 "../src/nibbles-window.vala"
	_tmp42_ = self->priv->settings;
#line 328 "../src/nibbles-window.vala"
	_tmp43_ = self->priv->settings;
#line 328 "../src/nibbles-window.vala"
	_tmp44_ = nibbles_game_new (_tmp41_, g_settings_get_int (_tmp42_, "speed"), 35, g_settings_get_boolean (_tmp43_, "fakes"), three_dimensional_view, NIBBLES_VIEW_WIDTH, NIBBLES_VIEW_HEIGHT, FALSE);
#line 328 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->game);
#line 328 "../src/nibbles-window.vala"
	self->priv->game = _tmp44_;
#line 335 "../src/nibbles-window.vala"
	_tmp45_ = self->priv->game;
#line 335 "../src/nibbles-window.vala"
	g_signal_connect_object (_tmp45_, "log-score", (GCallback) _nibbles_window_log_score_cb_nibbles_game_log_score, self, 0);
#line 336 "../src/nibbles-window.vala"
	_tmp46_ = self->priv->game;
#line 336 "../src/nibbles-window.vala"
	g_signal_connect_object (_tmp46_, "level-completed", (GCallback) _nibbles_window_level_completed_cb_nibbles_game_level_completed, self, 0);
#line 337 "../src/nibbles-window.vala"
	_tmp47_ = self->priv->sound;
#line 337 "../src/nibbles-window.vala"
	_tmp48_ = self->priv->game;
#line 337 "../src/nibbles-window.vala"
	sound_connect_signal (_tmp47_, _tmp48_);
#line 338 "../src/nibbles-window.vala"
	_tmp49_ = self->priv->game;
#line 338 "../src/nibbles-window.vala"
	g_signal_connect_object (_tmp49_, "get-pkgdatadir", (GCallback) __nibbles_window___lambda49__nibbles_game_get_pkgdatadir, self, 0);
#line 339 "../src/nibbles-window.vala"
	_tmp50_ = self->priv->game;
#line 339 "../src/nibbles-window.vala"
	g_signal_connect_object (_tmp50_, "add-keypress-handler", (GCallback) __nibbles_window___lambda50__nibbles_game_add_keypress_handler, self, 0);
#line 349 "../src/nibbles-window.vala"
	_tmp51_ = self->priv->game;
#line 349 "../src/nibbles-window.vala"
	_tmp52_ = nibbles_view_new (_tmp51_, _nibbles_window_countdown_active_nibbles_view_countdown_active_function, self, _nibbles_window_new_game_dialogue_active_new_game_dialogue_active_function, self);
#line 349 "../src/nibbles-window.vala"
	g_object_ref_sink (_tmp52_);
#line 349 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->view);
#line 349 "../src/nibbles-window.vala"
	self->priv->view = _tmp52_;
#line 352 "../src/nibbles-window.vala"
	_tmp53_ = self->priv->view;
#line 352 "../src/nibbles-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp53_);
#line 353 "../src/nibbles-window.vala"
	_tmp54_ = self->priv->view;
#line 353 "../src/nibbles-window.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp54_, TRUE);
#line 354 "../src/nibbles-window.vala"
	_tmp55_ = self->priv->game_box;
#line 354 "../src/nibbles-window.vala"
	_tmp56_ = self->priv->view;
#line 354 "../src/nibbles-window.vala"
	gtk_box_prepend (_tmp55_, (GtkWidget*) _tmp56_);
#line 355 "../src/nibbles-window.vala"
	_tmp57_ = self->priv->view;
#line 355 "../src/nibbles-window.vala"
	gtk_root_set_focus ((GtkRoot*) self, (GtkWidget*) _tmp57_);
#line 359 "../src/nibbles-window.vala"
	_tmp58_ = nibbles_view_load_image_file ("scoreboard-life.svg", 14, 14);
#line 359 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->scoreboard_life);
#line 359 "../src/nibbles-window.vala"
	self->priv->scoreboard_life = _tmp58_;
#line 362 "../src/nibbles-window.vala"
	_tmp59_ = self->priv->game;
#line 362 "../src/nibbles-window.vala"
	_tmp60_ = self->priv->settings;
#line 362 "../src/nibbles-window.vala"
	nibbles_game_set_numhumans (_tmp59_, g_settings_get_int (_tmp60_, "players"));
#line 363 "../src/nibbles-window.vala"
	_tmp61_ = self->priv->settings;
#line 363 "../src/nibbles-window.vala"
	numai = g_settings_get_int (_tmp61_, "ai");
#line 364 "../src/nibbles-window.vala"
	_tmp63_ = self->priv->game;
#line 364 "../src/nibbles-window.vala"
	_tmp64_ = nibbles_game_get_numhumans (_tmp63_);
#line 364 "../src/nibbles-window.vala"
	_tmp65_ = _tmp64_;
#line 364 "../src/nibbles-window.vala"
	if ((numai + _tmp65_) > NIBBLES_GAME_MAX_WORMS) {
#line 364 "../src/nibbles-window.vala"
		_tmp62_ = TRUE;
#line 7468 "nibbles-window.c"
	} else {
		NibblesGame* _tmp66_;
		gint _tmp67_;
		gint _tmp68_;
#line 365 "../src/nibbles-window.vala"
		_tmp66_ = self->priv->game;
#line 365 "../src/nibbles-window.vala"
		_tmp67_ = nibbles_game_get_numhumans (_tmp66_);
#line 365 "../src/nibbles-window.vala"
		_tmp68_ = _tmp67_;
#line 365 "../src/nibbles-window.vala"
		_tmp62_ = (numai + _tmp68_) < 4;
#line 7481 "nibbles-window.c"
	}
#line 364 "../src/nibbles-window.vala"
	if (_tmp62_) {
#line 7485 "nibbles-window.c"
		NibblesGame* _tmp69_;
		gint _tmp70_;
		gint _tmp71_;
		GSettings* _tmp72_;
#line 367 "../src/nibbles-window.vala"
		_tmp69_ = self->priv->game;
#line 367 "../src/nibbles-window.vala"
		_tmp70_ = nibbles_game_get_numhumans (_tmp69_);
#line 367 "../src/nibbles-window.vala"
		_tmp71_ = _tmp70_;
#line 367 "../src/nibbles-window.vala"
		numai = 4 - _tmp71_;
#line 368 "../src/nibbles-window.vala"
		_tmp72_ = self->priv->settings;
#line 368 "../src/nibbles-window.vala"
		g_settings_set_int (_tmp72_, "ai", numai);
#line 7502 "nibbles-window.c"
	}
#line 370 "../src/nibbles-window.vala"
	_tmp73_ = self->priv->game;
#line 370 "../src/nibbles-window.vala"
	nibbles_game_set_numai (_tmp73_, numai);
#line 371 "../src/nibbles-window.vala"
	_tmp74_ = self->priv->players;
#line 371 "../src/nibbles-window.vala"
	_tmp75_ = self->priv->game;
#line 371 "../src/nibbles-window.vala"
	_tmp76_ = nibbles_game_get_numhumans (_tmp75_);
#line 371 "../src/nibbles-window.vala"
	_tmp77_ = _tmp76_;
#line 371 "../src/nibbles-window.vala"
	players_set_values (_tmp74_, _tmp77_, numai);
#line 374 "../src/nibbles-window.vala"
	_tmp78_ = self->priv->speed;
#line 374 "../src/nibbles-window.vala"
	_tmp79_ = self->priv->settings;
#line 374 "../src/nibbles-window.vala"
	_tmp80_ = self->priv->settings;
#line 374 "../src/nibbles-window.vala"
	speed_set_values (_tmp78_, g_settings_get_int (_tmp79_, "speed"), g_settings_get_boolean (_tmp80_, "fakes"));
#line 378 "../src/nibbles-window.vala"
	_tmp81_ = self->priv->controls;
#line 378 "../src/nibbles-window.vala"
	g_signal_connect_object (_tmp81_, "add-keypress-handler", (GCallback) __nibbles_window___lambda51__controls_add_keypress_handler, self, 0);
#line 387 "../src/nibbles-window.vala"
	_tmp82_ = self->priv->_start_screen;
#line 387 "../src/nibbles-window.vala"
	if (_tmp82_ == SETUP_SCREEN_GAME) {
#line 7534 "nibbles-window.c"
		NibblesGame* _tmp83_;
		GSettings* _tmp84_;
		NibblesGame* _tmp85_;
		GSettings* _tmp86_;
		NibblesGame* _tmp87_;
		GSettings* _tmp88_;
		NibblesGame* _tmp89_;
		GSettings* _tmp90_;
		NibblesGame* _tmp91_;
		GeeArrayList* _tmp92_;
#line 389 "../src/nibbles-window.vala"
		_tmp83_ = self->priv->game;
#line 389 "../src/nibbles-window.vala"
		_tmp84_ = self->priv->settings;
#line 389 "../src/nibbles-window.vala"
		nibbles_game_set_numhumans (_tmp83_, g_settings_get_int (_tmp84_, "players"));
#line 390 "../src/nibbles-window.vala"
		_tmp85_ = self->priv->game;
#line 390 "../src/nibbles-window.vala"
		_tmp86_ = self->priv->settings;
#line 390 "../src/nibbles-window.vala"
		nibbles_game_set_numai (_tmp85_, g_settings_get_int (_tmp86_, "ai"));
#line 391 "../src/nibbles-window.vala"
		_tmp87_ = self->priv->game;
#line 391 "../src/nibbles-window.vala"
		_tmp88_ = self->priv->settings;
#line 391 "../src/nibbles-window.vala"
		nibbles_game_set_speed (_tmp87_, g_settings_get_int (_tmp88_, "speed"));
#line 392 "../src/nibbles-window.vala"
		_tmp89_ = self->priv->game;
#line 392 "../src/nibbles-window.vala"
		_tmp90_ = self->priv->settings;
#line 392 "../src/nibbles-window.vala"
		nibbles_game_set_fakes (_tmp89_, g_settings_get_boolean (_tmp90_, "fakes"));
#line 393 "../src/nibbles-window.vala"
		_tmp91_ = self->priv->game;
#line 393 "../src/nibbles-window.vala"
		_tmp92_ = self->priv->worm_settings;
#line 393 "../src/nibbles-window.vala"
		nibbles_game_create_worms (_tmp91_, _tmp92_);
#line 395 "../src/nibbles-window.vala"
		nibbles_window_start_game (self);
#line 7577 "nibbles-window.c"
	} else {
		SetupScreen _tmp93_;
#line 397 "../src/nibbles-window.vala"
		_tmp93_ = self->priv->_start_screen;
#line 397 "../src/nibbles-window.vala"
		if (_tmp93_ == SETUP_SCREEN_CONTROLS) {
#line 7584 "nibbles-window.c"
			NibblesGame* _tmp94_;
			GSettings* _tmp95_;
			NibblesGame* _tmp96_;
			GSettings* _tmp97_;
			NibblesGame* _tmp98_;
			GSettings* _tmp99_;
			NibblesGame* _tmp100_;
			GSettings* _tmp101_;
#line 399 "../src/nibbles-window.vala"
			_tmp94_ = self->priv->game;
#line 399 "../src/nibbles-window.vala"
			_tmp95_ = self->priv->settings;
#line 399 "../src/nibbles-window.vala"
			nibbles_game_set_numhumans (_tmp94_, g_settings_get_int (_tmp95_, "players"));
#line 400 "../src/nibbles-window.vala"
			_tmp96_ = self->priv->game;
#line 400 "../src/nibbles-window.vala"
			_tmp97_ = self->priv->settings;
#line 400 "../src/nibbles-window.vala"
			nibbles_game_set_numai (_tmp96_, g_settings_get_int (_tmp97_, "ai"));
#line 401 "../src/nibbles-window.vala"
			_tmp98_ = self->priv->game;
#line 401 "../src/nibbles-window.vala"
			_tmp99_ = self->priv->settings;
#line 401 "../src/nibbles-window.vala"
			nibbles_game_set_speed (_tmp98_, g_settings_get_int (_tmp99_, "speed"));
#line 402 "../src/nibbles-window.vala"
			_tmp100_ = self->priv->game;
#line 402 "../src/nibbles-window.vala"
			_tmp101_ = self->priv->settings;
#line 402 "../src/nibbles-window.vala"
			nibbles_game_set_fakes (_tmp100_, g_settings_get_boolean (_tmp101_, "fakes"));
#line 404 "../src/nibbles-window.vala"
			nibbles_window_show_controls_screen (self);
#line 7619 "nibbles-window.c"
		} else {
			SetupScreen _tmp102_;
#line 406 "../src/nibbles-window.vala"
			_tmp102_ = self->priv->_start_screen;
#line 406 "../src/nibbles-window.vala"
			if (_tmp102_ == SETUP_SCREEN_SPEED) {
#line 7626 "nibbles-window.c"
				NibblesGame* _tmp103_;
				GSettings* _tmp104_;
				NibblesGame* _tmp105_;
				GSettings* _tmp106_;
				GtkStack* _tmp107_;
#line 408 "../src/nibbles-window.vala"
				_tmp103_ = self->priv->game;
#line 408 "../src/nibbles-window.vala"
				_tmp104_ = self->priv->settings;
#line 408 "../src/nibbles-window.vala"
				nibbles_game_set_numhumans (_tmp103_, g_settings_get_int (_tmp104_, "players"));
#line 409 "../src/nibbles-window.vala"
				_tmp105_ = self->priv->game;
#line 409 "../src/nibbles-window.vala"
				_tmp106_ = self->priv->settings;
#line 409 "../src/nibbles-window.vala"
				nibbles_game_set_numai (_tmp105_, g_settings_get_int (_tmp106_, "ai"));
#line 411 "../src/nibbles-window.vala"
				_tmp107_ = self->priv->main_stack;
#line 411 "../src/nibbles-window.vala"
				gtk_stack_set_visible_child_name (_tmp107_, "speed");
#line 7648 "nibbles-window.c"
			} else {
				GSettings* _tmp108_;
#line 413 "../src/nibbles-window.vala"
				_tmp108_ = self->priv->settings;
#line 413 "../src/nibbles-window.vala"
				if (g_settings_get_boolean (_tmp108_, "first-run")) {
#line 7655 "nibbles-window.c"
					FirstRun* first_run_panel = NULL;
					FirstRun* _tmp109_;
					FirstRun* _tmp110_;
					GtkStack* _tmp111_;
					FirstRun* _tmp112_;
					GSimpleAction* _tmp113_;
					GSimpleAction* _tmp114_;
					GSimpleAction* _tmp115_;
					GtkStack* _tmp116_;
					FirstRun* _tmp117_;
#line 415 "../src/nibbles-window.vala"
					_tmp109_ = first_run_new ();
#line 415 "../src/nibbles-window.vala"
					g_object_ref_sink (_tmp109_);
#line 415 "../src/nibbles-window.vala"
					first_run_panel = _tmp109_;
#line 416 "../src/nibbles-window.vala"
					_tmp110_ = first_run_panel;
#line 416 "../src/nibbles-window.vala"
					gtk_widget_show ((GtkWidget*) _tmp110_);
#line 417 "../src/nibbles-window.vala"
					_tmp111_ = self->priv->main_stack;
#line 417 "../src/nibbles-window.vala"
					_tmp112_ = first_run_panel;
#line 417 "../src/nibbles-window.vala"
					gtk_stack_add_named (_tmp111_, (GtkWidget*) _tmp112_, "first-run");
#line 419 "../src/nibbles-window.vala"
					_tmp113_ = self->priv->new_game_action;
#line 419 "../src/nibbles-window.vala"
					g_simple_action_set_enabled (_tmp113_, TRUE);
#line 420 "../src/nibbles-window.vala"
					_tmp114_ = self->priv->pause_action;
#line 420 "../src/nibbles-window.vala"
					g_simple_action_set_enabled (_tmp114_, FALSE);
#line 421 "../src/nibbles-window.vala"
					_tmp115_ = self->priv->back_action;
#line 421 "../src/nibbles-window.vala"
					g_simple_action_set_enabled (_tmp115_, FALSE);
#line 423 "../src/nibbles-window.vala"
					_tmp116_ = self->priv->main_stack;
#line 423 "../src/nibbles-window.vala"
					_tmp117_ = first_run_panel;
#line 423 "../src/nibbles-window.vala"
					gtk_stack_set_visible_child (_tmp116_, (GtkWidget*) _tmp117_);
#line 413 "../src/nibbles-window.vala"
					_g_object_unref0 (first_run_panel);
#line 7702 "nibbles-window.c"
				} else {
#line 427 "../src/nibbles-window.vala"
					nibbles_window_show_new_game_screen (self, FALSE);
#line 7706 "nibbles-window.c"
				}
			}
		}
	}
#line 431 "../src/nibbles-window.vala"
	nibbles_window_create_scores (self);
#line 240 "../src/nibbles-window.vala"
	_g_object_unref0 (key_controller);
#line 240 "../src/nibbles-window.vala"
	return obj;
#line 7717 "nibbles-window.c"
}

static void
nibbles_window_class_init (NibblesWindowClass * klass,
                           gpointer klass_data)
{
#line 46 "../src/nibbles-window.vala"
	nibbles_window_parent_class = g_type_class_peek_parent (klass);
#line 46 "../src/nibbles-window.vala"
	g_type_class_adjust_private_offset (klass, &NibblesWindow_private_offset);
#line 46 "../src/nibbles-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_nibbles_window_get_property;
#line 46 "../src/nibbles-window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_nibbles_window_set_property;
#line 46 "../src/nibbles-window.vala"
	G_OBJECT_CLASS (klass)->constructor = nibbles_window_constructor;
#line 46 "../src/nibbles-window.vala"
	G_OBJECT_CLASS (klass)->finalize = nibbles_window_finalize;
#line 46 "../src/nibbles-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_WINDOW_CLI_START_LEVEL_PROPERTY, nibbles_window_properties[NIBBLES_WINDOW_CLI_START_LEVEL_PROPERTY] = g_param_spec_int ("cli-start-level", "cli-start-level", "cli-start-level", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 46 "../src/nibbles-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_WINDOW_START_SCREEN_PROPERTY, nibbles_window_properties[NIBBLES_WINDOW_START_SCREEN_PROPERTY] = g_param_spec_enum ("start-screen", "start-screen", "start-screen", TYPE_SETUP_SCREEN, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 46 "../src/nibbles-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_WINDOW_GAME_PAUSED_PROPERTY, nibbles_window_properties[NIBBLES_WINDOW_GAME_PAUSED_PROPERTY] = g_param_spec_boolean ("game-paused", "game-paused", "game-paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Nibbles/ui/nibbles.ui");
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_stack", FALSE, NibblesWindow_private_offset + G_STRUCT_OFFSET (NibblesWindowPrivate, main_stack));
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "overlay", FALSE, NibblesWindow_private_offset + G_STRUCT_OFFSET (NibblesWindowPrivate, overlay));
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, NibblesWindow_private_offset + G_STRUCT_OFFSET (NibblesWindowPrivate, headerbar));
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "new_game_button", FALSE, NibblesWindow_private_offset + G_STRUCT_OFFSET (NibblesWindowPrivate, new_game_button));
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pause_button", FALSE, NibblesWindow_private_offset + G_STRUCT_OFFSET (NibblesWindowPrivate, pause_button));
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "hamburger_menu", FALSE, NibblesWindow_private_offset + G_STRUCT_OFFSET (NibblesWindowPrivate, hamburger_menu));
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "players", FALSE, NibblesWindow_private_offset + G_STRUCT_OFFSET (NibblesWindowPrivate, players));
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "speed", FALSE, NibblesWindow_private_offset + G_STRUCT_OFFSET (NibblesWindowPrivate, speed));
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "controls", FALSE, NibblesWindow_private_offset + G_STRUCT_OFFSET (NibblesWindowPrivate, controls));
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "statusbar_stack", FALSE, NibblesWindow_private_offset + G_STRUCT_OFFSET (NibblesWindowPrivate, statusbar_stack));
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "scoreboard", FALSE, NibblesWindow_private_offset + G_STRUCT_OFFSET (NibblesWindowPrivate, scoreboard));
#line 46 "../src/nibbles-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "game_box", FALSE, NibblesWindow_private_offset + G_STRUCT_OFFSET (NibblesWindowPrivate, game_box));
#line 7768 "nibbles-window.c"
}

static void
nibbles_window_instance_init (NibblesWindow * self,
                              gpointer klass)
{
	NibblesWindowDelegateStack* _tmp0_;
	GeeArrayList* _tmp1_;
#line 46 "../src/nibbles-window.vala"
	self->priv = nibbles_window_get_instance_private (self);
#line 172 "../src/nibbles-window.vala"
	_tmp0_ = nibbles_window_delegate_stack_new ();
#line 172 "../src/nibbles-window.vala"
	self->priv->keypress_handlers = _tmp0_;
#line 175 "../src/nibbles-window.vala"
	self->priv->game = NULL;
#line 196 "../src/nibbles-window.vala"
	self->priv->countdown_id = (guint) 0;
#line 198 "../src/nibbles-window.vala"
	self->priv->seconds = 0;
#line 200 "../src/nibbles-window.vala"
	self->priv->show_dialogue = FALSE;
#line 213 "../src/nibbles-window.vala"
	_tmp1_ = gee_array_list_new (gtk_widget_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 213 "../src/nibbles-window.vala"
	self->priv->overlay_members = _tmp1_;
#line 1114 "../src/nibbles-window.vala"
	self->priv->end_of_game = FALSE;
#line 46 "../src/nibbles-window.vala"
	g_type_ensure (TYPE_PLAYERS);
#line 46 "../src/nibbles-window.vala"
	g_type_ensure (TYPE_SPEED);
#line 46 "../src/nibbles-window.vala"
	g_type_ensure (TYPE_CONTROLS);
#line 46 "../src/nibbles-window.vala"
	g_type_ensure (TYPE_SCOREBOARD);
#line 46 "../src/nibbles-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 7807 "nibbles-window.c"
}

static void
nibbles_window_finalize (GObject * obj)
{
	NibblesWindow * self;
#line 46 "../src/nibbles-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_WINDOW, NibblesWindow);
#line 49 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->settings);
#line 50 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->worm_settings);
#line 70 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->scoreboard_life);
#line 73 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->view);
#line 78 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->sound);
#line 172 "../src/nibbles-window.vala"
	_nibbles_window_delegate_stack_unref0 (self->priv->keypress_handlers);
#line 175 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->game);
#line 186 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->scores_context);
#line 187 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->scorecats);
#line 190 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->new_game_action);
#line 191 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->pause_action);
#line 192 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->back_action);
#line 193 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->start_game_action);
#line 213 "../src/nibbles-window.vala"
	_g_object_unref0 (self->priv->overlay_members);
#line 46 "../src/nibbles-window.vala"
	G_OBJECT_CLASS (nibbles_window_parent_class)->finalize (obj);
#line 7846 "nibbles-window.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NibblesWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NibblesWindow), 0, (GInstanceInitFunc) nibbles_window_instance_init, NULL };
	GType nibbles_window_type_id;
	nibbles_window_type_id = g_type_register_static (gtk_application_window_get_type (), "NibblesWindow", &g_define_type_info, 0);
	NibblesWindow_private_offset = g_type_add_instance_private (nibbles_window_type_id, sizeof (NibblesWindowPrivate));
	return nibbles_window_type_id;
}

GType
nibbles_window_get_type (void)
{
	static gsize nibbles_window_type_id__once = 0;
	if (g_once_init_enter (&nibbles_window_type_id__once)) {
		GType nibbles_window_type_id;
		nibbles_window_type_id = nibbles_window_get_type_once ();
		g_once_init_leave (&nibbles_window_type_id__once, nibbles_window_type_id);
	}
	return nibbles_window_type_id__once;
}

static void
_vala_nibbles_window_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	NibblesWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIBBLES_WINDOW, NibblesWindow);
#line 46 "../src/nibbles-window.vala"
	switch (property_id) {
#line 46 "../src/nibbles-window.vala"
		case NIBBLES_WINDOW_CLI_START_LEVEL_PROPERTY:
#line 46 "../src/nibbles-window.vala"
		g_value_set_int (value, nibbles_window_get_cli_start_level (self));
#line 46 "../src/nibbles-window.vala"
		break;
#line 46 "../src/nibbles-window.vala"
		case NIBBLES_WINDOW_START_SCREEN_PROPERTY:
#line 46 "../src/nibbles-window.vala"
		g_value_set_enum (value, nibbles_window_get_start_screen (self));
#line 46 "../src/nibbles-window.vala"
		break;
#line 46 "../src/nibbles-window.vala"
		case NIBBLES_WINDOW_GAME_PAUSED_PROPERTY:
#line 46 "../src/nibbles-window.vala"
		g_value_set_boolean (value, nibbles_window_get_game_paused (self));
#line 46 "../src/nibbles-window.vala"
		break;
#line 7899 "nibbles-window.c"
		default:
#line 46 "../src/nibbles-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 46 "../src/nibbles-window.vala"
		break;
#line 7905 "nibbles-window.c"
	}
}

static void
_vala_nibbles_window_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	NibblesWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIBBLES_WINDOW, NibblesWindow);
#line 46 "../src/nibbles-window.vala"
	switch (property_id) {
#line 46 "../src/nibbles-window.vala"
		case NIBBLES_WINDOW_CLI_START_LEVEL_PROPERTY:
#line 46 "../src/nibbles-window.vala"
		nibbles_window_set_cli_start_level (self, g_value_get_int (value));
#line 46 "../src/nibbles-window.vala"
		break;
#line 46 "../src/nibbles-window.vala"
		case NIBBLES_WINDOW_START_SCREEN_PROPERTY:
#line 46 "../src/nibbles-window.vala"
		nibbles_window_set_start_screen (self, g_value_get_enum (value));
#line 46 "../src/nibbles-window.vala"
		break;
#line 46 "../src/nibbles-window.vala"
		case NIBBLES_WINDOW_GAME_PAUSED_PROPERTY:
#line 46 "../src/nibbles-window.vala"
		nibbles_window_set_game_paused (self, g_value_get_boolean (value));
#line 46 "../src/nibbles-window.vala"
		break;
#line 7937 "nibbles-window.c"
		default:
#line 46 "../src/nibbles-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 46 "../src/nibbles-window.vala"
		break;
#line 7943 "nibbles-window.c"
	}
}

FirstRun*
first_run_construct (GType object_type)
{
	FirstRun * self = NULL;
#line 1202 "../src/nibbles-window.vala"
	self = (FirstRun*) g_object_new (object_type, NULL);
#line 1202 "../src/nibbles-window.vala"
	return self;
#line 7955 "nibbles-window.c"
}

FirstRun*
first_run_new (void)
{
#line 1202 "../src/nibbles-window.vala"
	return first_run_construct (TYPE_FIRST_RUN);
#line 7963 "nibbles-window.c"
}

static void
first_run_class_init (FirstRunClass * klass,
                      gpointer klass_data)
{
#line 1202 "../src/nibbles-window.vala"
	first_run_parent_class = g_type_class_peek_parent (klass);
#line 1202 "../src/nibbles-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Nibbles/ui/first-run.ui");
#line 7974 "nibbles-window.c"
}

static void
first_run_instance_init (FirstRun * self,
                         gpointer klass)
{
#line 1202 "../src/nibbles-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 7983 "nibbles-window.c"
}

 G_GNUC_NO_INLINE static GType
first_run_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FirstRunClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) first_run_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FirstRun), 0, (GInstanceInitFunc) first_run_instance_init, NULL };
	GType first_run_type_id;
	first_run_type_id = g_type_register_static (gtk_box_get_type (), "FirstRun", &g_define_type_info, 0);
	return first_run_type_id;
}

GType
first_run_get_type (void)
{
	static gsize first_run_type_id__once = 0;
	if (g_once_init_enter (&first_run_type_id__once)) {
		GType first_run_type_id;
		first_run_type_id = first_run_get_type_once ();
		g_once_init_leave (&first_run_type_id__once, first_run_type_id);
	}
	return first_run_type_id__once;
}

